SystemOrganization addCategory: #'Smallchange-Web'!
SystemOrganization addCategory: #'Smallchange-Web-Admin'!
SystemOrganization addCategory: #'Smallchange-Web-User'!
SystemOrganization addCategory: #'Smallchange-Web-Components'!
SystemOrganization addCategory: #'Smallchange-Web-Application'!

Trait named: #TScwAnnouncer
	uses: {}
	category: 'Smallchange-Web'!

!TScwAnnouncer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 19:17'!
announce: anAnnouncement
	^self announcer announce: anAnnouncement! !

!TScwAnnouncer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 19:17'!
announcer
	^self session announcer! !

!TScwAnnouncer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 19:18'!
callModal: aComponent
	^(self announce: (ScwModalAnnouncement new component: aComponent))
		result
	! !

MbObject subclass: #ScwChangePasswordObject
	instanceVariableNames: 'oldPassword password1 password2 user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwChangePasswordObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:22'!
user: aUser
	^self basicNew
		initializeWithUser: aUser;
		yourself.! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 19:24'!
checkOldPassword: aPassword
	(user checkPassword: aPassword)
		ifFalse: [ MbValidationError signal: 'Password incorrect']! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 19:28'!
initializeWithUser: aUser
	<mbFields: #(oldPassword password1 password2)>
	self initialize.
	user := aUser.
	! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 19:54'!
oldPassword
	<label: 'Current Password'>
	<validateWith: #checkOldPassword:>
	<renderHint: #password>
	<required>
	^ oldPassword! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 18:34'!
oldPassword: anObject
	self set: #oldPassword to: anObject! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 19:49'!
password1
	<label: 'New Password'>
	<required>
	<password>
	^password1 ! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 19:41'!
password1: anObject
	self set: #password1 to: anObject! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 20:10'!
password2
	<label: 'Repeat New Password'>
	<password>
	<required>
	^password2! !

!ScwChangePasswordObject methodsFor: 'accessing' stamp: 'StuartHerring 5/22/2012 19:41'!
password2: anObject
	self set: #password2 to: anObject! !

SPSession subclass: #ScwSession
	instanceVariableNames: 'transactionProvider commandProcessor announcer sessionRegistry userRegistry profile predictionDate analyser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web'!

ScwSession subclass: #ScwMagmaSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web'!

!ScwMagmaSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/11/2012 16:09'!
initializeTransactionProvider 
	transactionProvider := MbMagmaTransactionProvider localAt: (self preferenceAt: #databaseName).
	transactionProvider magmaSession readStrategy: 
		((MaReadStrategy minimumDepth: 1)
			forVariableNamed: 'transaction' onAny: ScSchedule readToDepth: 2;
			forVariableNamed: 'pool' onAny: ScTransaction readToDepth: 2;
			forVariableNamed: 'account' onAny: ScTransaction readToDepth: 2
			)
! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 3/11/2012 12:11'!
acceptPendingTransactions: aCollection
	self invokeCommand: (ScAcceptTransactions profile: (self profile) transactions: aCollection)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 2/12/2012 20:34'!
addAccount: anAccount
	self invokeCommand: (ScAddAccount profile: (self profile) account: anAccount)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 3/24/2012 18:36'!
addManualTransaction: t to: schedule
	self invokeCommand: (ScAddManualTransaction new schedule: schedule; transaction: t)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 2/12/2012 20:34'!
addPool: aPool
	self invokeCommand: (ScAddPool profile: (self profile) pool: aPool)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 3/4/2012 17:14'!
addSchedule: aSchedule
	self invokeCommand: (ScAddSchedule profile: (self profile) schedule: aSchedule)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 5/20/2012 08:58'!
addUser: aUser
	"Adds a new user"
	transactionProvider commit: [
		self userRegistry addUser: aUser].
	^aUser! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:10'!
announcer
	^announcer! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 5/20/2012 17:11'!
deleteAccount
	"Very scary action - completely remove all trace of the user"
	transactionProvider commit: [
		sessionRegistry removeSessionsForUser: self platformUser.
		userRegistry removeUser: self platformUser].
	self platformLogout.! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 3/12/2012 19:36'!
deletePendingTransactions:  aCollection
	self invokeCommand: (ScDeletePendingTransactions profile: self profile transactions: aCollection)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 3/31/2012 10:08'!
deleteSchedule: aSchedule
	self invokeCommand: (ScDeleteSchedule profile: (self profile) schedule: aSchedule)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 4/13/2012 07:58'!
deleteTransaction: aTransaction
	self invokeCommand: (ScDeleteTransaction profile: (self profile) transaction: aTransaction)! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 09:00'!
handle: aRequest
	analyser ifNotNil: [ :a | a run ].
	super handle: aRequest! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 16:13'!
history
	^commandProcessor! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 14:27'!
initialize
	super initialize.
	commandProcessor := nil.
	announcer := Announcer new.
	sessionRegistry := SPInternalSessionRegistry new.! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 22:07'!
initializeTransactionProvider 
	transactionProvider := MbMemoryTransactionProvider default.
	transactionProvider root at: #users ifAbsentPut: Dictionary new.! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 18:03'!
invokeCommand: aCommand
	commandProcessor invoke: aCommand.! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 20:40'!
loggedIn
	commandProcessor := MbTransactionalCommandProcessor transactionProvider: transactionProvider.
	commandProcessor history: self platformUser history.
	profile := self platformUser profile.
	profile schemaIsCurrent ifFalse: [
		self upgradeSchema].
	transactionProvider commit: [ profile updatePending ].
	analyser := (ScAnalyserGroup profile: profile)
		add: ScAccountsSufficientForBills;
		add: ScPoolsSufficientForBills;
		add: ScPoolNotOverdrawn;
		add: ScAccountNotOverdrawn;
		yourself.
	analyser run.! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 08:59'!
notices
	^analyser notices! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:25'!
predictionDate
	^predictionDate ifNil: [predictionDate := (profile schedules detect: [:s | s transaction isIncome] ifNone: [nil]) ifNotNil: [ :s | s nextDate subtractDays: 1]]! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:22'!
predictionDate: aDate
	predictionDate := aDate.! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 12/12/2011 21:54'!
profile
	^profile! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 2/1/2012 21:22'!
recordTransaction: aTransaction
	self invokeCommand: (ScRecordTransaction profile: (self profile) transaction: aTransaction)! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 3/24/2012 18:36'!
removeManualTransaction: t from: schedule
	self invokeCommand: (ScRemoveManualTransaction new schedule: schedule; transaction: t)! !

!ScwSession methodsFor: 'accessing' stamp: 'StuartHerring 2/23/2012 17:58'!
sessionRegistry
	^ sessionRegistry! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:13'!
start
	self initializeTransactionProvider.
	userRegistry := (ScwUserRegistry withUsers: (transactionProvider root at: #users))
		transactionProvider: transactionProvider.
	super start.! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 09:28'!
transactionProvider
	^transactionProvider! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 18:00'!
unregistered
	transactionProvider ifNotNil: [ :t | t close]! !

!ScwSession methodsFor: 'commands' stamp: 'StuartHerring 2/15/2012 19:21'!
updateObject: anObject with: newObject
	self invokeCommand: (MbUpdateDefinedObjectCommand object: anObject newValues: newObject)! !

!ScwSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/8/2012 12:21'!
upgradeSchema
	Transcript show: ('Schema for profile {1} needs to be upgraded' format: profile name);cr.
	[profile schemaIsCurrent ] whileFalse: [
		Transcript show: ('Upgrading from {1}' format: profile schemaVersion printString); cr.
		transactionProvider commitForUpgrade: [
			profile upgradeSchema]]! !

!ScwSession methodsFor: 'accessing' stamp: 'StuartHerring 4/11/2012 10:53'!
userRegistry
	^userRegistry! !

WAFileLibrary subclass: #ScwRGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:27'!
RGraphbarJs
	^ '    /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */
    
    if (typeof(RGraph) == ''undefined'') RGraph = {};

    /**
    * The bar chart constructor
    * 
    * @param object canvas The canvas object
    * @param array  data   The chart data
    */
    RGraph.Bar = function (id, data)
    {
        // Get the canvas and context objects
        this.id                = id;
        this.canvas            = document.getElementById(id);
        this.context           = this.canvas.getContext ? this.canvas.getContext("2d") : null;
        this.canvas.__object__ = this;
        this.type              = ''bar'';
        this.max               = 0;
        this.stackedOrGrouped  = false;
        this.isRGraph          = true;

        /**
        * Compatibility with older browsers
        */
        RGraph.OldBrowserCompat(this.context);


        // Various config type stuff
        this.properties = {
            ''chart.background.barcolor1'':   ''rgba(0,0,0,0)'',
            ''chart.background.barcolor2'':   ''rgba(0,0,0,0)'',
            ''chart.background.grid'':        true,
            ''chart.background.grid.color'':  ''#ddd'',
            ''chart.background.grid.width'':  1,
            ''chart.background.grid.hsize'':  20,
            ''chart.background.grid.vsize'':  20,
            ''chart.background.grid.vlines'': true,
            ''chart.background.grid.hlines'': true,
            ''chart.background.grid.border'': true,
            ''chart.background.grid.autofit'':true,
            ''chart.background.grid.autofit.numhlines'': 5,
            ''chart.background.grid.autofit.numvlines'': 20,
            ''chart.background.image.stretch'': true,
            ''chart.background.image.x'':     null,
            ''chart.background.image.y'':     null,
            ''chart.background.image.align'': null,
            ''chart.ytickgap'':               20,
            ''chart.smallyticks'':            3,
            ''chart.largeyticks'':            5,
            ''chart.numyticks'':              10,
            ''chart.hmargin'':                5,
            ''chart.strokecolor'':            ''#666'',
            ''chart.axis.color'':             ''black'',
            ''chart.gutter.top'':             25,
            ''chart.gutter.bottom'':          25,
            ''chart.gutter.left'':            25,
            ''chart.gutter.right'':           25,
            ''chart.labels'':                 null,
            ''chart.labels.ingraph'':         null,
            ''chart.labels.above'':           false,
            ''chart.labels.above.decimals'':  0,
            ''chart.labels.above.size'':      null,
            ''chart.labels.above.angle'':     null,
            ''chart.ylabels'':                true,
            ''chart.ylabels.count'':          5,
            ''chart.ylabels.inside'':         false,
            ''chart.xlabels.offset'':         0,
            ''chart.xaxispos'':               ''bottom'',
            ''chart.yaxispos'':               ''left'',
            ''chart.text.color'':             ''black'',
            ''chart.text.size'':              10,
            ''chart.text.angle'':             0,
            ''chart.text.font'':              ''Arial'',
            ''chart.ymin'':                   0,
            ''chart.ymax'':                   null,
            ''chart.title'':                  '''',
            ''chart.title.font'':             null,
            ''chart.title.background'':       null,
            ''chart.title.hpos'':             null,
            ''chart.title.vpos'':             null,
            ''chart.title.bold'':             true,
            ''chart.title.xaxis'':            '''',
            ''chart.title.xaxis.bold'':       true,
            ''chart.title.xaxis.size'':       null,
            ''chart.title.xaxis.font'':       null,
            ''chart.title.yaxis'':            '''',
            ''chart.title.yaxis.bold'':       true,
            ''chart.title.yaxis.size'':       null,
            ''chart.title.yaxis.font'':       null,
            ''chart.title.xaxis.pos'':        null,
            ''chart.title.yaxis.pos'':        null,
            ''chart.colors'':                 [''rgb(0,0,255)'', ''#0f0'', ''#00f'', ''#ff0'', ''#0ff'', ''#0f0''],
            ''chart.colors.sequential'':      false,
            ''chart.colors.reverse'':         false,
            ''chart.grouping'':               ''grouped'',
            ''chart.variant'':                ''bar'',
            ''chart.shadow'':                 false,
            ''chart.shadow.color'':           ''#666'',
            ''chart.shadow.offsetx'':         3,
            ''chart.shadow.offsety'':         3,
            ''chart.shadow.blur'':            3,
            ''chart.tooltips'':               null,
            ''chart.tooltips.effect'':        ''fade'',
            ''chart.tooltips.css.class'':     ''RGraph_tooltip'',
            ''chart.tooltips.event'':         ''onclick'',
            ''chart.tooltips.highlight'':     true,
            ''chart.highlight.stroke'':       ''black'',
            ''chart.highlight.fill'':         ''rgba(255,255,255,0.5)'',
            ''chart.background.hbars'':       null,
            ''chart.key'':                    [],
            ''chart.key.background'':         ''white'',
            ''chart.key.position'':           ''graph'',
            ''chart.key.shadow'':             false,
            ''chart.key.shadow.color'':       ''#666'',
            ''chart.key.shadow.blur'':        3,
            ''chart.key.shadow.offsetx'':     2,
            ''chart.key.shadow.offsety'':     2,
            ''chart.key.position.gutter.boxed'': true,
            ''chart.key.position.x'':         null,
            ''chart.key.position.y'':         null,
            ''chart.key.halign'':             ''right'',
            ''chart.key.color.shape'':        ''square'',
            ''chart.key.rounded'':            true,
            ''chart.key.text.size'':          10,
            ''chart.key.linewidth'':          1,
            ''chart.key.colors'':             null,
            ''chart.contextmenu'':            null,
            ''chart.line'':                   null,
            ''chart.units.pre'':              '''',
            ''chart.units.post'':             '''',
            ''chart.scale.decimals'':         0,
            ''chart.scale.point'':            ''.'',
            ''chart.scale.thousand'':         '','',
            ''chart.crosshairs'':             false,
            ''chart.crosshairs.color'':       ''#333'',
            ''chart.crosshairs.hline'':       true,
            ''chart.crosshairs.vline'':       true,
            ''chart.linewidth'':              1,
            ''chart.annotatable'':            false,
            ''chart.annotate.color'':         ''black'',
            ''chart.zoom.factor'':            1.5,
            ''chart.zoom.fade.in'':           true,
            ''chart.zoom.fade.out'':          true,
            ''chart.zoom.hdir'':              ''right'',
            ''chart.zoom.vdir'':              ''down'',
            ''chart.zoom.frames'':            25,
            ''chart.zoom.delay'':             16.666,
            ''chart.zoom.shadow'':            true,
            ''chart.zoom.mode'':              ''canvas'',
            ''chart.zoom.thumbnail.width'':   75,
            ''chart.zoom.thumbnail.height'':  75,
            ''chart.zoom.thumbnail.fixed'':   false,
            ''chart.zoom.background'':        true,
            ''chart.resizable'':              false,
            ''chart.resize.handle.adjust'':   [0,0],
            ''chart.resize.handle.background'': null,
            ''chart.adjustable'':             false,
            ''chart.noaxes'':                 false,
            ''chart.noxaxis'':                false,
            ''chart.noyaxis'':                false,
            ''chart.events.click'':           null,
            ''chart.events.mousemove'':       null,
            ''chart.numxticks'':              null
        }

        // Check for support
        if (!!this.canvas) {
            alert(''[BAR] No canvas support'');
            return;
        }

        /**
        * Determine whether the chart will contain stacked or grouped bars
        */
        for (i=0; i<data.length; ++i) {
            if (typeof(data[i]) == ''object'') {
                this.stackedOrGrouped = true;
            }
        }

        // Store the data
        this.data = data;
        
        // Used to store the coords of the bars
        this.coords = [];

        /**
        * Set the .getShape commonly named method
        */
        this.getShape = this.getBar;
    }


    /**
    * A setter
    * 
    * @param name  string The name of the property to set
    * @param value mixed  The value of the property
    */
    RGraph.Bar.prototype.Set = function (name, value)
    {
        name = name.toLowerCase();

        if (name == ''chart.labels.abovebar'') {
            name = ''chart.labels.above'';
        }
        
        if (name == ''chart.strokestyle'') {
            name = ''chart.strokecolor'';
        }
        
        /**
        * Check for xaxispos
        */
        if (name == ''chart.xaxispos'' ) {
            if (value !!= ''bottom'' && value !!= ''center'' && value !!= ''top'') {
                alert(''[BAR] ('' + this.id + '') chart.xaxispos should be top, center or bottom. Tried to set it to: '' + value + '' Changing it to center'');
                value = ''center'';
            }
            
            if (value == ''top'') {
                for (var i=0; i<this.data.length; ++i) {
                    if (typeof(this.data[i]) == ''number'' && this.data[i] > 0) {
                        alert(''[BAR] The data element with index '' + i + '' should be negative'');
                    }
                }
            }
        }
        
        /**
        * lineWidth doesn''t appear to like a zero setting
        */
        if (name.toLowerCase() == ''chart.linewidth'' && value == 0) {
            value = 0.0001;
        }

        this.properties[name] = value;
    }


    /**
    * A getter
    * 
    * @param name  string The name of the property to get
    */
    RGraph.Bar.prototype.Get = function (name)
    {
        if (name == ''chart.labels.abovebar'') {
            name = ''chart.labels.above'';
        }
        
        var value = this.properties[name];

        return value;
    }


    /**
    * The function you call to draw the bar chart
    */
    RGraph.Bar.prototype.Draw = function ()
    {
        // MUST be the first thing done!!
        if (typeof(this.Get(''chart.background.image'')) == ''string'' && !!this.__background_image__) {
            RGraph.DrawBackgroundImage(this);
            return;
        }

        /**
        * Fire the onbeforedraw event
        */
        RGraph.FireCustomEvent(this, ''onbeforedraw'');

        /**
        * Clear all of this canvases event handlers (the ones installed by RGraph)
        */
        RGraph.ClearEventListeners(this.id);
        
        /**
        * This is new in May 2011 and facilitates indiviual gutter settings,
        * eg chart.gutter.left
        */
        this.gutterLeft   = this.Get(''chart.gutter.left'');
        this.gutterRight  = this.Get(''chart.gutter.right'');
        this.gutterTop    = this.Get(''chart.gutter.top'');
        this.gutterBottom = this.Get(''chart.gutter.bottom'');

        /**
        * Convert any null values to 0. Won''t make any difference to the bar (as opposed to the line chart)
        */
        for (var i=0; i<this.data.length; ++i) {
            if (this.data[i] == null) {
                this.data[i] = 0;
            }
        }


        // Cache this in a class variable as it''s used rather a lot

        /**
        * Check for tooltips and alert the user that they''re not supported with pyramid charts
        */
        if (   (this.Get(''chart.variant'') == ''pyramid'' || this.Get(''chart.variant'') == ''dot'')
            && typeof(this.Get(''chart.tooltips'')) == ''object''
            && this.Get(''chart.tooltips'')
            && this.Get(''chart.tooltips'').length > 0) {

            alert(''[BAR] ('' + this.id + '') Sorry, tooltips are not supported with dot or pyramid charts'');
        }

        /**
        * Stop the coords array from growing uncontrollably
        */
        this.coords = [];

        /**
        * Work out a few things. They need to be here because they depend on things you can change before you
        * call Draw() but after you instantiate the object
        */
        this.max            = 0;
        this.grapharea      = RGraph.GetHeight(this) - this.gutterTop - this.gutterBottom;
        this.halfgrapharea  = this.grapharea / 2;
        this.halfTextHeight = this.Get(''chart.text.size'') / 2;

        // Progressively Draw the chart
        RGraph.background.Draw(this);




        /**
        * Install the clickand mousemove event listeners
        */
        RGraph.InstallUserClickListener(this, this.Get(''chart.events.click''));
        RGraph.InstallUserMousemoveListener(this, this.Get(''chart.events.mousemove''));



        //If it''s a sketch chart variant, draw the axes first
        if (this.Get(''chart.variant'') == ''sketch'') {
            this.DrawAxes();
            this.Drawbars();
        } else {
            this.Drawbars();
            this.DrawAxes();
        }

        this.DrawLabels();


        // Draw the key if necessary
        if (this.Get(''chart.key'').length) {
            RGraph.DrawKey(this, this.Get(''chart.key''), this.Get(''chart.colors''));
        }
        
        
        /**
        * Setup the context menu if required
        */
        if (this.Get(''chart.contextmenu'')) {
            RGraph.ShowContext(this);
        }


        /**
        * Is a line is defined, draw it
        */
        var line = this.Get(''chart.line'');

        if (line) {
        
            line.__bar__ = this;
            
            // Check the X axis positions
            if (this.Get(''chart.xaxispos'') !!= line.Get(''chart.xaxispos'')) {
                alert("[BAR] Using different X axis positions when combining the Bar and Line is not advised");
            }

            line.Set(''chart.gutter.left'',   this.Get(''chart.gutter.left''));
            line.Set(''chart.gutter.right'',  this.Get(''chart.gutter.right''));
            line.Set(''chart.gutter.top'',    this.Get(''chart.gutter.top''));
            line.Set(''chart.gutter.bottom'', this.Get(''chart.gutter.bottom''));

            line.Set(''chart.hmargin'', (this.canvas.width - this.gutterLeft - this.gutterRight) / (line.original_data[0].length * 2));
            
            // If a BAR custom yMax is set, use that
            if (this.Get(''chart.ymax'') && !!line.Get(''chart.ymax'')) {
                line.Set(''chart.ymax'', this.Get(''chart.ymax''));
            
            } else if (line.Get(''chart.ymax'')) {
                line.Set(''chart.ymax'', line.Get(''chart.ymax''));
            }

            // The boolean is used to specify that the Line chart .Draw() method is being called by the Bar chart
            line.Draw(true);
        }


        /**
        * Draw "in graph" labels
        */
        if (this.Get(''chart.labels.ingraph'')) {
            RGraph.DrawInGraphLabels(this);
        }
        
        /**
        * Draw crosschairs
        */
        if (this.Get(''chart.crosshairs'')) {
            RGraph.DrawCrosshairs(this);
        }
        
        /**
        * If the canvas is annotatable, do install the event handlers
        */
        if (this.Get(''chart.annotatable'')) {
            RGraph.Annotate(this);
        }
        
        /**
        * This bit shows the mini zoom window if requested
        */
        if (this.Get(''chart.zoom.mode'') == ''thumbnail'' || this.Get(''chart.zoom.mode'') == ''area'') {
            RGraph.ShowZoomWindow(this);
        }

        
        /**
        * This function enables resizing
        */
        if (this.Get(''chart.resizable'')) {
            RGraph.AllowResizing(this);
        }


        /**
        * This function enables adjusting
        */
        if (this.Get(''chart.adjustable'')) {
            RGraph.AllowAdjusting(this);
        }


        /**
        * Fire the RGraph ondraw event
        */
        RGraph.FireCustomEvent(this, ''ondraw'');
    }

    
    /**
    * Draws the charts axes
    */
    RGraph.Bar.prototype.DrawAxes = function ()
    {
        if (this.Get(''chart.noaxes'')) {
            return;
        }

        var xaxispos = this.Get(''chart.xaxispos'');
        var yaxispos = this.Get(''chart.yaxispos'');

        this.context.beginPath();
        this.context.strokeStyle = this.Get(''chart.axis.color'');
        this.context.lineWidth   = 1;

        // Draw the Y axis
        if (this.Get(''chart.noyaxis'') == false) {
            if (yaxispos == ''right'') {
                this.context.moveTo(AA(this, this.canvas.width - this.gutterRight), this.gutterTop);
                this.context.lineTo(AA(this, this.canvas.width - this.gutterRight), this.canvas.height - this.gutterBottom);
            } else {
                this.context.moveTo(AA(this, this.gutterLeft), this.gutterTop);
                this.context.lineTo(AA(this, this.gutterLeft), this.canvas.height - this.gutterBottom);
            }
        }
        
        // Draw the X axis
        if (this.Get(''chart.noxaxis'') == false) {
            if (xaxispos == ''center'') {
                this.context.moveTo(this.gutterLeft, AA(this, ((this.canvas.height - this.gutterTop - this.gutterBottom) / 2) + this.gutterTop));
                this.context.lineTo(this.canvas.width - this.gutterRight, AA(this, ((this.canvas.height - this.gutterTop - this.gutterBottom) / 2) + this.gutterTop));
            } else if (xaxispos == ''top'') {
                this.context.moveTo(this.gutterLeft, AA(this, this.gutterTop));
                this.context.lineTo(this.canvas.width - this.gutterRight, AA(this, this.gutterTop));
            } else {
                this.context.moveTo(this.gutterLeft, AA(this, this.canvas.height - this.gutterBottom));
                this.context.lineTo(this.canvas.width - this.gutterRight, AA(this, this.canvas.height - this.gutterBottom));
            }
        }

        var numYTicks = this.Get(''chart.numyticks'');

        // Draw the Y tickmarks
        if (this.Get(''chart.noyaxis'') == false) {
            var yTickGap = (RGraph.GetHeight(this) - this.gutterTop - this.gutterBottom) / numYTicks;
            var xpos     = yaxispos == ''left'' ? this.gutterLeft : RGraph.GetWidth(this) - this.gutterRight;
    
            for (y=this.gutterTop;
                 xaxispos == ''center'' ? y <= (RGraph.GetHeight(this) - this.gutterBottom) : y < (RGraph.GetHeight(this) - this.gutterBottom + (xaxispos == ''top'' ? 1 : 0));
                 y += yTickGap) {
    
                if (xaxispos == ''center'' && y == (RGraph.GetHeight(this) / 2)) continue;
                
                // X axis at the top
                if (xaxispos == ''top'' && y == this.gutterTop) continue;
                
                this.context.moveTo(xpos, AA(this, y));
                this.context.lineTo(xpos + (yaxispos == ''left'' ? -3 : 3), AA(this, y));
            }
            
            /**
            * If the X axis is not being shown, draw an extra tick
            */
            if (this.Get(''chart.noxaxis'')) {
                if (xaxispos == ''center'') {
                    this.context.moveTo(xpos + (yaxispos == ''left'' ? -3 : 3), AA(this, this.canvas.height / 2));
                    this.context.lineTo(xpos, AA(this, RGraph.GetHeight(this) / 2));
                } else if (xaxispos == ''top'') {
                    this.context.moveTo(xpos + (yaxispos == ''left'' ? -3 : 3), AA(this, this.gutterTop));
                    this.context.lineTo(xpos, AA(this, this.gutterTop));
                } else {
                    this.context.moveTo(xpos + (yaxispos == ''left'' ? -3 : 3), AA(this, RGraph.GetHeight(this) - this.gutterBottom));
                    this.context.lineTo(xpos, AA(this, RGraph.GetHeight(this) - this.gutterBottom));
                }
            }
        }


        // Draw the X tickmarks
        if (this.Get(''chart.noxaxis'') == false) {
            
            xTickGap = (this.canvas.width - this.gutterLeft - this.gutterRight) / this.data.length;
            
            if (typeof(this.Get(''chart.numxticks'')) == ''number'') {
                xTickGap = (this.canvas.width - this.gutterLeft - this.gutterRight) / this.Get(''chart.numxticks'');
            }

            if (xaxispos == ''bottom'') {
                yStart   = this.canvas.height - this.gutterBottom;
                yEnd     = (this.canvas.height - this.gutterBottom) + 3;
            } else if (xaxispos == ''top'') {
                yStart = this.gutterTop - 3;
                yEnd   = this.gutterTop;
            } else if (xaxispos == ''center'') {
                yStart = ((this.canvas.height - this.gutterTop - this.gutterBottom) / 2) + this.gutterTop + 3;
                yEnd   = ((this.canvas.height - this.gutterTop - this.gutterBottom) / 2) + this.gutterTop - 3;
            }
            
            yStart = AA(this, yStart);
            yEnd = AA(this, yEnd);
            
            //////////////// X TICKS ////////////////
            var noEndXTick = this.Get(''chart.noendxtick'');

            for (x=this.gutterLeft + (yaxispos == ''left'' ? xTickGap : 0); x<this.canvas.width - this.gutterRight + (yaxispos == ''left'' ? 5 : 0); x+=xTickGap) {

                if (yaxispos == ''left'' && !!noEndXTick && x > this.gutterLeft) {
                    this.context.moveTo(AA(this, x), yStart);
                    this.context.lineTo(AA(this, x), yEnd);
                
                } else if (yaxispos == ''left'' && noEndXTick && x > this.gutterLeft && x < (this.canvas.width - this.gutterRight) ) {
                    this.context.moveTo(AA(this, x), yStart);
                    this.context.lineTo(AA(this, x), yEnd);
                
                } else if (yaxispos == ''right'' && x < (this.canvas.width - this.gutterRight) && !!noEndXTick) {
                    this.context.moveTo(AA(this, x), yStart);
                    this.context.lineTo(AA(this, x), yEnd);
                
                } else if (yaxispos == ''right'' && x < (this.canvas.width - this.gutterRight) && x > (this.gutterLeft) && noEndXTick) {
                    this.context.moveTo(AA(this, x), yStart);
                    this.context.lineTo(AA(this, x), yEnd);
                }
            }
            
            if (this.Get(''chart.noyaxis'') || this.Get(''chart.numxticks'') == null) {
                if (typeof(this.Get(''chart.numxticks'')) == ''number'' && this.Get(''chart.numxticks'') > 0) {
                    this.context.moveTo(AA(this, this.gutterLeft), yStart);
                    this.context.lineTo(AA(this, this.gutterLeft), yEnd);
                }
            }
    
            //////////////// X TICKS ////////////////
        }

        /**
        * If the Y axis is not being shown, draw an extra tick
        */
        if (this.Get(''chart.noyaxis'') && this.Get(''chart.noxaxis'') == false && this.Get(''chart.numxticks'') == null) {
            if (xaxispos == ''center'') {
                this.context.moveTo(AA(this, this.gutterLeft), (RGraph.GetHeight(this) / 2) - 3);
                this.context.lineTo(AA(this, this.gutterLeft), (RGraph.GetHeight(this) / 2) + 3);
            } else {
                this.context.moveTo(AA(this, this.gutterLeft), this.canvas.height - this.gutterBottom);
                this.context.lineTo(AA(this, this.gutterLeft), this.canvas.height - this.gutterBottom + 3);
            }
        }

        this.context.stroke();
    }


    /**
    * Draws the bars
    */
    RGraph.Bar.prototype.Drawbars = function ()
    {
        this.context.lineWidth   = this.Get(''chart.linewidth'');
        this.context.strokeStyle = this.Get(''chart.strokecolor'');
        this.context.fillStyle   = this.Get(''chart.colors'')[0];
        var prevX                = 0;
        var prevY                = 0;
        var decimals             = this.Get(''chart.scale.decimals'');

        /**
        * Work out the max value
        */
        if (this.Get(''chart.ymax'')) {

            this.max = this.Get(''chart.ymax'');
            this.min = this.Get(''chart.ymin'');

            this.scale = [
                          (((this.max - this.min) * (1/5)) + this.min).toFixed(decimals),
                          (((this.max - this.min) * (2/5)) + this.min).toFixed(decimals),
                          (((this.max - this.min) * (3/5)) + this.min).toFixed(decimals),
                          (((this.max - this.min) * (4/5)) + this.min).toFixed(decimals),
                          (((this.max - this.min) * (5/5) + this.min)).toFixed(decimals)
                         ];
        } else {
        
            this.min = this.Get(''chart.ymin'');
        
            for (i=0; i<this.data.length; ++i) {
                if (typeof(this.data[i]) == ''object'') {
                    var value = this.Get(''chart.grouping'') == ''grouped'' ? Number(RGraph.array_max(this.data[i], true)) : Number(RGraph.array_sum(this.data[i])) ;

                } else {
                    var value = Number(this.data[i]);
                }

                this.max = Math.max(Math.abs(this.max), Math.abs(value));
            }

            this.scale = RGraph.getScale(this.max, this);
            this.max   = this.scale[4];

            if (this.Get(''chart.ymin'')) {

                    var decimals = this.Get(''chart.scale.decimals'');
    
                    this.scale[0] = ((Number(this.scale[4] - this.min) * 0.2) + this.min).toFixed(decimals);
                    this.scale[1] = ((Number(this.scale[4] - this.min) * 0.4) + this.min).toFixed(decimals);
                    this.scale[2] = ((Number(this.scale[4] - this.min) * 0.6) + this.min).toFixed(decimals);
                    this.scale[3] = ((Number(this.scale[4] - this.min) * 0.8) + this.min).toFixed(decimals);
                    this.scale[4] = ((Number(this.scale[4] - this.min) * 1.0) + this.min).toFixed(decimals);

            } else {
                if (this.Get(''chart.scale.decimals'')) {
                    
                    var decimals = this.Get(''chart.scale.decimals'');
    
                    this.scale[0] = Number(this.scale[0]).toFixed(decimals);
                    this.scale[1] = Number(this.scale[1]).toFixed(decimals);
                    this.scale[2] = Number(this.scale[2]).toFixed(decimals);
                    this.scale[3] = Number(this.scale[3]).toFixed(decimals);
                    this.scale[4] = Number(this.scale[4]).toFixed(decimals);
                }
            }
        }

        /**
        * Draw horizontal bars here
        */
        if (this.Get(''chart.background.hbars'') && this.Get(''chart.background.hbars'').length > 0) {
            RGraph.DrawBars(this);
        }

        var variant = this.Get(''chart.variant'');
        
        /**
        * Draw the 3D axes is necessary
        */
        if (variant == ''3d'') {
            RGraph.Draw3DAxes(this);
        }

        /**
        * Get the variant once, and draw the bars, be they regular, stacked or grouped
        */
        
        // Get these variables outside of the loop
        var xaxispos      = this.Get(''chart.xaxispos'');
        var width         = (this.canvas.width - this.gutterLeft - this.gutterRight ) / this.data.length;
        var orig_height   = height;
        var hmargin       = this.Get(''chart.hmargin'');
        var shadow        = this.Get(''chart.shadow'');
        var shadowColor   = this.Get(''chart.shadow.color'');
        var shadowBlur    = this.Get(''chart.shadow.blur'');
        var shadowOffsetX = this.Get(''chart.shadow.offsetx'');
        var shadowOffsetY = this.Get(''chart.shadow.offsety'');
        var strokeStyle   = this.Get(''chart.strokecolor'');
        var colors        = this.Get(''chart.colors'');
        var sequentialColorIndex = 0;

        for (i=0; i<this.data.length; ++i) {

            // Work out the height
            //The width is up outside the loop
            var height = ((RGraph.array_sum(this.data[i]) < 0 ? RGraph.array_sum(this.data[i]) + this.min : RGraph.array_sum(this.data[i]) - this.min) / (this.max - this.min) ) * (this.canvas.height - this.gutterTop - this.gutterBottom);

            // Half the height if the Y axis is at the center
            if (xaxispos == ''center'') {
                height /= 2;
            }

            var x = (i * width) + this.gutterLeft;
            var y = xaxispos == ''center'' ? ((this.canvas.height - this.gutterTop - this.gutterBottom) / 2) + this.gutterTop - height
                                         : this.canvas.height - height - this.gutterBottom;

            // xaxispos is top
            if (xaxispos == ''top'') {
                y = this.gutterTop + Math.abs(height);
            }


            // Account for negative lengths - Some browsers (eg Chrome) don''t like a negative value
            if (height < 0) {
                y += height;
                height = Math.abs(height);
            }

            /**
            * Turn on the shadow if need be
            */
            if (shadow) {
                this.context.shadowColor   = shadowColor;
                this.context.shadowBlur    = shadowBlur;
                this.context.shadowOffsetX = shadowOffsetX;
                this.context.shadowOffsetY = shadowOffsetY;
            }

            /**
            * Draw the bar
            */
            this.context.beginPath();
                if (typeof(this.data[i]) == ''number'') {
                    
                    var barWidth = width - (2 * hmargin);

                    // Set the fill color
                    this.context.strokeStyle = strokeStyle;
                    this.context.fillStyle = colors[0];
                    
                    /**
                    * Sequential colors
                    */
                    if (this.Get(''chart.colors.sequential'')) {
                        this.context.fillStyle = colors[i];
                    }

                    if (variant == ''sketch'') {

                        this.context.lineCap = ''round'';
                        
                        var sketchOffset = 3;

                        this.context.beginPath();

                        this.context.strokeStyle = colors[0];

                        /**
                        * Sequential colors
                        */
                        if (this.Get(''chart.colors.sequential'')) {
                            this.context.strokeStyle = colors[i];
                        }

                        // Left side
                        this.context.moveTo(x + hmargin + 2, y + height - 2);
                        this.context.lineTo(x + hmargin , y - 2);

                        // The top
                        this.context.moveTo(x + hmargin - 3, y + -2 + (this.data[i] < 0 ? height : 0));
                        this.context.bezierCurveTo(x + ((hmargin + width) * 0.33),y + 5 + (this.data[i] < 0 ? height - 10: 0),x + ((hmargin + width) * 0.66),y + 5 + (this.data[i] < 0 ? height - 10 : 0),x + hmargin + width + -1, y + 0 + (this.data[i] < 0 ? height : 0));


                        // The right side
                        this.context.moveTo(x + hmargin + width - 2, y + -2);
                        this.context.lineTo(x + hmargin + width - 3, y + height - 3);

                        for (var r=0.2; r<=0.8; r+=0.2) {
                            this.context.moveTo(x + hmargin + width + (r > 0.4 ? -1 : 3) - (r * width),y - 1);
                            this.context.lineTo(x + hmargin + width - (r > 0.4 ? 1 : -1) - (r * width), y + height + (r == 0.2 ? 1 : -2));
                        }

                        this.context.stroke();

                    // Regular bar
                    } else if (variant == ''bar'' || variant == ''3d'' || variant == ''glass'' || variant == ''bevel'') {
                    
                        if (RGraph.isOld() && shadow) {
                            this.DrawIEShadow([x + hmargin, y, barWidth, height]);
                        }
                        
                        if (variant == ''glass'') {
                            RGraph.filledCurvyRect(this.context, x + hmargin, y, barWidth, height, 3, this.data[i] > 0, this.data[i] > 0, this.data[i] < 0, this.data[i] < 0);
                            RGraph.strokedCurvyRect(this.context, x + hmargin, y, barWidth, height, 3, this.data[i] > 0, this.data[i] > 0, this.data[i] < 0, this.data[i] < 0);
                        } else {
                            this.context.strokeRect(x + hmargin, y, barWidth, height);
                            this.context.fillRect(x + hmargin, y, barWidth, height);
                        }

                        // 3D effect
                        if (variant == ''3d'') {

                            var prevStrokeStyle = this.context.strokeStyle;
                            var prevFillStyle   = this.context.fillStyle;

                            // Draw the top
                            this.context.beginPath();
                                this.context.moveTo(x + hmargin, y);
                                this.context.lineTo(x + hmargin + 10, y - 5);
                                this.context.lineTo(x + hmargin + 10 + barWidth, y - 5);
                                this.context.lineTo(x + hmargin + barWidth, y);
                            this.context.closePath();

                            this.context.stroke();
                            this.context.fill();

                            // Draw the right hand side
                            this.context.beginPath();
                                this.context.moveTo(x + hmargin + barWidth, y);
                                this.context.lineTo(x + hmargin + barWidth + 10, y - 5);
                                this.context.lineTo(x + hmargin + barWidth + 10, y + height - 5);
                                this.context.lineTo(x + hmargin + barWidth, y + height);
                            this.context.closePath();
    
                            this.context.stroke();                        
                            this.context.fill();

                            // Draw the darker top section
                            this.context.beginPath();                            
                                this.context.fillStyle = ''rgba(255,255,255,0.3)'';
                                this.context.moveTo(x + hmargin, y);
                                this.context.lineTo(x + hmargin + 10, y - 5);
                                this.context.lineTo(x + hmargin + 10 + barWidth, y - 5);
                                this.context.lineTo(x + hmargin + barWidth, y);
                                this.context.lineTo(x + hmargin, y);
                            this.context.closePath();
    
                            this.context.stroke();
                            this.context.fill();

                            // Draw the darker right side section
                            this.context.beginPath();
                                this.context.fillStyle = ''rgba(0,0,0,0.4)'';
                                this.context.moveTo(x + hmargin + barWidth, y);
                                this.context.lineTo(x + hmargin + barWidth + 10, y - 5);
                                this.context.lineTo(x + hmargin + barWidth + 10, y - 5 + height);
                                this.context.lineTo(x + hmargin + barWidth, y + height);
                                this.context.lineTo(x + hmargin + barWidth, y);
                            this.context.closePath();

                            this.context.stroke();
                            this.context.fill();

                            this.context.strokeStyle = prevStrokeStyle;
                            this.context.fillStyle   = prevFillStyle;
                        
                        // Glass variant
                        } else if (variant == ''glass'') {
 
                            var grad = this.context.createLinearGradient(
                                                                         x + hmargin,
                                                                         y,
                                                                         x + hmargin + (barWidth / 2),
                                                                         y
                                                                        );
                            grad.addColorStop(0, ''rgba(255,255,255,0.9)'');
                            grad.addColorStop(1, ''rgba(255,255,255,0.5)'');

                            this.context.beginPath();
                            this.context.fillStyle = grad;
                            this.context.fillRect(x + hmargin + 2,y + (this.data[i] > 0 ? 2 : 0),(barWidth / 2) - 2,height - 2);
                            this.context.fill();
                        }

                        // This bit draws the text labels that appear above the bars if requested
                        if (this.Get(''chart.labels.above'')) {

                            // Turn off any shadow
                            if (shadow) {
                                RGraph.NoShadow(this);
                            }

                            var yPos = y - 3;

                            // Account for negative bars
                            if (this.data[i] < 0) {
                                yPos += height + 6 + (this.Get(''chart.text.size'') - 4);
                            }

                            // Account for chart.xaxispos=top
                            if (this.Get(''chart.xaxispos'') == ''top'') {
                                yPos = this.gutterTop + height + 6 + (typeof(this.Get(''chart.labels.above.size'')) == ''number'' ? this.Get(''chart.labels.above.size'') : this.Get(''chart.text.size'') - 4);
                            }

                            // Account for chart.variant=3d
                            if (this.Get(''chart.variant'') == ''3d'') {
                                yPos -= 5;
                            }

                            this.context.fillStyle = this.Get(''chart.text.color'');

                            RGraph.Text(this.context,
                                        this.Get(''chart.text.font''),
                                        typeof(this.Get(''chart.labels.above.size'')) == ''number'' ? this.Get(''chart.labels.above.size'') : this.Get(''chart.text.size'') - 3,
                                        x + hmargin + (barWidth / 2),
                                        yPos,
                                        RGraph.number_format(this, Number(this.data[i]).toFixed(this.Get(''chart.labels.above.decimals'')),this.Get(''chart.units.pre''),this.Get(''chart.units.post'')),
                                        this.Get(''chart.labels.above.angle'') ? ''bottom'' : null,
                                        this.Get(''chart.labels.above.angle'') ? (this.Get(''chart.labels.above.angle'') > 0 && (this.Get(''chart.xaxispos'') !!= ''top'') ? ''right'' : ''left'') : ''center'',
                                        null,
                                        this.Get(''chart.labels.above.angle'')
                                       );
                        }

                    // Dot chart
                    } else if (variant == ''dot'') {

                        this.context.beginPath();
                        this.context.moveTo(x + (width / 2), y);
                        this.context.lineTo(x + (width / 2), y + height);
                        this.context.stroke();
                        
                        this.context.beginPath();
                        this.context.fillStyle = this.Get(''chart.colors'')[i];
                        this.context.arc(x + (width / 2), y + (this.data[i] > 0 ? 0 : height), 2, 0, 6.28, 0);
                        
                        // Set the colour for the dots
                        this.context.fillStyle = this.Get(''chart.colors'')[0];

                        /**
                        * Sequential colors
                        */
                        if (this.Get(''chart.colors.sequential'')) {
                            this.context.fillStyle = colors[i];
                        }

                        this.context.stroke();
                        this.context.fill();
                    
                    // Pyramid chart
                    } else if (variant == ''pyramid'') {

                        this.context.beginPath();
                            var startY = (this.Get(''chart.xaxispos'') == ''center'' ? (RGraph.GetHeight(this) / 2) : (RGraph.GetHeight(this) - this.gutterBottom));
                        
                            this.context.moveTo(x + hmargin, startY);
                            this.context.lineTo(
                                                x + hmargin + (barWidth / 2),
                                                y + (this.Get(''chart.xaxispos'') == ''center'' && (this.data[i] < 0) ? height : 0)
                                               );
                            this.context.lineTo(x + hmargin + barWidth, startY);
                        
                        this.context.closePath();
                        
                        this.context.stroke();
                        this.context.fill();
                    
                    // Arrow chart
                    } else if (variant == ''arrow'') {
                        
                        var startY = (this.Get(''chart.xaxispos'') == ''center'' ? (RGraph.GetHeight(this) / 2) : (RGraph.GetHeight(this) - this.gutterBottom));

                        this.context.lineWidth = this.Get(''chart.linewidth'') ? this.Get(''chart.linewidth'') : 1;
                        this.context.lineCap = ''round'';

                        this.context.beginPath();

                            this.context.moveTo(x + hmargin + (barWidth / 2), startY);
                            this.context.lineTo(x + hmargin + (barWidth / 2), y + (this.Get(''chart.xaxispos'') == ''center'' && (this.data[i] < 0) ? height : 0));
                            this.context.arc(x + hmargin + (barWidth / 2),
                                             y + (this.Get(''chart.xaxispos'') == ''center'' && (this.data[i] < 0) ? height : 0),
                                             5,
                                             this.data[i] > 0 ? 0.78 : 5.6,
                                             this.data[i] > 0 ? 0.79 : 5.48,
                                             this.data[i] < 0);

                            this.context.moveTo(x + hmargin + (barWidth / 2), y + (this.Get(''chart.xaxispos'') == ''center'' && (this.data[i] < 0) ? height : 0));
                            this.context.arc(x + hmargin + (barWidth / 2),
                                             y + (this.Get(''chart.xaxispos'') == ''center'' && (this.data[i] < 0) ? height : 0),
                                             5,
                                             this.data[i] > 0 ? 2.355 : 4,
                                             this.data[i] > 0 ? 2.4 : 3.925,
                                             this.data[i] < 0);

                        this.context.stroke();
                        
                        this.context.lineWidth = 1;

                    // Unknown variant type
                    } else {
                        alert(''[BAR] Warning!! Unknown chart.variant: '' + variant);
                    }

                    this.coords.push([x + hmargin, y, width - (2 * hmargin), height]);


                /**
                * Stacked bar
                */
                } else if (typeof(this.data[i]) == ''object'' && this.Get(''chart.grouping'') == ''stacked'') {
                
                    if (this.min) {
                        alert("[ERROR] Stacked Bar charts with a Y min are not supported");
                    }
                    
                    var barWidth     = width - (2 * hmargin);
                    var redrawCoords = [];// Necessary to draw if the shadow is enabled
                    var startY       = 0;
                    var dataset      = this.data[i];

                    for (j=0; j<dataset.length; ++j) {

                        // Stacked bar chart and X axis pos in the middle - poitless since negative values are not permitted
                        if (xaxispos == ''center'') {
                            alert("[BAR] It''s pointless having the X axis position at the center on a stacked bar chart.");
                            return;
                        }

                        // Negative values not permitted for the stacked chart
                        if (this.data[i][j] < 0) {
                            alert(''[BAR] Negative values are not permitted with a stacked bar chart. Try a grouped one instead.'');
                            return;
                        }

                        /**
                        * Set the fill and stroke colors
                        */
                        this.context.strokeStyle = strokeStyle
                        this.context.fillStyle = colors[j];
    
                        if (this.Get(''chart.colors.reverse'')) {
                            this.context.fillStyle = colors[this.data[i].length - j - 1];
                        }
                        
                        if (this.Get(''chart.colors.sequential'') && colors[sequentialColorIndex]) {
                            this.context.fillStyle = colors[sequentialColorIndex++];
                        } else if (this.Get(''chart.colors.sequential'')) {
                            this.context.fillStyle = colors[sequentialColorIndex - 1];
                        }

                        var height = (dataset[j] / this.max) * (this.canvas.height - this.gutterTop - this.gutterBottom );

                        // If the X axis pos is in the center, we need to half the  height
                        if (xaxispos == ''center'') {
                            height /= 2;
                        }

                        var totalHeight = (RGraph.array_sum(dataset) / this.max) * (this.canvas.height - hmargin - this.gutterTop - this.gutterBottom);

                        /**
                        * Store the coords for tooltips
                        */
                        this.coords.push([x + hmargin, y, width - (2 * hmargin), height]);

                        // MSIE shadow
                        if (RGraph.isOld() && shadow) {
                            this.DrawIEShadow([x + hmargin, y, width - (2 * hmargin), height + 1]);
                        }

                        this.context.strokeRect(x + hmargin, y, width - (2 * hmargin), height);
                        this.context.fillRect(x + hmargin, y, width - (2 * hmargin), height);

                        
                        if (j == 0) {
                            var startY = y;
                            var startX = x;
                        }

                        /**
                        * Store the redraw coords if the shadow is enabled
                        */
                        if (shadow) {
                            redrawCoords.push([x + hmargin, y, width - (2 * hmargin), height, this.context.fillStyle]);
                        }

                        /**
                        * Stacked 3D effect
                        */
                        if (variant == ''3d'') {

                            var prevFillStyle = this.context.fillStyle;
                            var prevStrokeStyle = this.context.strokeStyle;

    
                            // Draw the top side
                            if (j == 0) {
                                this.context.beginPath();
                                    this.context.moveTo(startX + hmargin, y);
                                    this.context.lineTo(startX + 10 + hmargin, y - 5);
                                    this.context.lineTo(startX + 10 + barWidth + hmargin, y - 5);
                                    this.context.lineTo(startX + barWidth + hmargin, y);
                                this.context.closePath();
                                
                                this.context.fill();
                                this.context.stroke();
                            }

                            // Draw the side section
                            this.context.beginPath();
                                this.context.moveTo(startX + barWidth + hmargin, y);
                                this.context.lineTo(startX + barWidth + hmargin + 10, y - 5);
                                this.context.lineTo(startX + barWidth + + hmargin + 10, y - 5 + height);
                                this.context.lineTo(startX + barWidth + hmargin , y + height);
                            this.context.closePath();
                            
                            this.context.fill();
                            this.context.stroke();

                            // Draw the darker top side
                            if (j == 0) {
                                this.context.fillStyle = ''rgba(255,255,255,0.3)'';
                                this.context.beginPath();
                                    this.context.moveTo(startX + hmargin, y);
                                    this.context.lineTo(startX + 10 + hmargin, y - 5);
                                    this.context.lineTo(startX + 10 + barWidth + hmargin, y - 5);
                                    this.context.lineTo(startX + barWidth + hmargin, y);
                                this.context.closePath();
                                
                                this.context.fill();
                                this.context.stroke();
                            }

                            // Draw the darker side section
                            this.context.fillStyle = ''rgba(0,0,0,0.4)'';
                            this.context.beginPath();
                                this.context.moveTo(startX + barWidth + hmargin, y);
                                this.context.lineTo(startX + barWidth + hmargin + 10, y - 5);
                                this.context.lineTo(startX + barWidth + + hmargin + 10, y - 5 + height);
                                this.context.lineTo(startX + barWidth + hmargin , y + height);
                            this.context.closePath();
                            
                            this.context.fill();
                            this.context.stroke();

                            this.context.strokeStyle = prevStrokeStyle;
                            this.context.fillStyle = prevFillStyle;
                        }

                        y += height;
                    }

                    // This bit draws the text labels that appear above the bars if requested
                    if (this.Get(''chart.labels.above'')) {

                        // Turn off any shadow
                        RGraph.NoShadow(this);

                        this.context.fillStyle = this.Get(''chart.text.color'');
                        RGraph.Text(this.context,
                                    this.Get(''chart.text.font''),
                                    typeof(this.Get(''chart.labels.above.size'')) == ''number'' ? this.Get(''chart.labels.above.size'') : this.Get(''chart.text.size'') - 3,
                                    startX + (barWidth / 2) + this.Get(''chart.hmargin''),
                                    startY - (this.Get(''chart.shadow'') && this.Get(''chart.shadow.offsety'') < 0 ? 7 : 4) - (this.Get(''chart.variant'') == ''3d'' ? 5 : 0),
                                    String(this.Get(''chart.units.pre'') + RGraph.array_sum(this.data[i]).toFixed(this.Get(''chart.labels.above.decimals'')) + this.Get(''chart.units.post'')),
                                    this.Get(''chart.labels.above.angle'') ? ''bottom'' : null,
                                    this.Get(''chart.labels.above.angle'') ? (this.Get(''chart.labels.above.angle'') > 0 ? ''right'' : ''left'') : ''center'',
                                    null,
                                    this.Get(''chart.labels.above.angle''));
                      
                        // Turn any shadow back on
                        if (shadow) {
                            this.context.shadowColor   = shadowColor;
                            this.context.shadowBlur    = shadowBlur;
                            this.context.shadowOffsetX = shadowOffsetX;
                            this.context.shadowOffsetY = shadowOffsetY;
                        }
                    }
                    

                    /**
                    * Redraw the bars if the shadow is enabled due to hem being drawn from the bottom up, and the
                    * shadow spilling over to higher up bars
                    */
                    if (shadow) {

                        RGraph.NoShadow(this);

                        for (k=0; k<redrawCoords.length; ++k) {
                            this.context.strokeStyle = strokeStyle;
                            this.context.fillStyle = redrawCoords[k][4];
                            this.context.strokeRect(redrawCoords[k][0], redrawCoords[k][1], redrawCoords[k][2], redrawCoords[k][3]);
                            this.context.fillRect(redrawCoords[k][0], redrawCoords[k][1], redrawCoords[k][2], redrawCoords[k][3]);

                            this.context.stroke();
                            this.context.fill();
                        }
                        
                        // Reset the redraw coords to be empty
                        redrawCoords = [];
                    }
                /**
                * Grouped bar
                */
                } else if (typeof(this.data[i]) == ''object'' && this.Get(''chart.grouping'') == ''grouped'') {

                    var redrawCoords = [];
                    this.context.lineWidth = this.Get(''chart.linewidth'');

                    for (j=0; j<this.data[i].length; ++j) {

                        // Set the fill and stroke colors
                        this.context.strokeStyle = strokeStyle;
                        this.context.fillStyle   = colors[j];
                        
                        /**
                        * Sequential colors
                        */
                        if (this.Get(''chart.colors.sequential'') && colors[sequentialColorIndex]) {
                            this.context.fillStyle = colors[sequentialColorIndex++];
                        } else if (this.Get(''chart.colors.sequential'')) {
                            this.context.fillStyle = colors[sequentialColorIndex - 1];
                        }

                        var individualBarWidth = (width - (2 * hmargin)) / this.data[i].length;
                        var height = ((this.data[i][j] + (this.data[i][j] < 0 ? this.min : (-1 * this.min) )) / (this.max - this.min) ) * (this.canvas.height - this.gutterTop - this.gutterBottom );

                        // If the X axis pos is in the center, we need to half the  height
                        if (xaxispos == ''center'') {
                            height /= 2;
                        }

                        var startX = x + hmargin + (j * individualBarWidth);

                        /**
                        * Determine the start positioning for the bar
                        */
                        if (xaxispos == ''top'') {
                            var startY = this.Get(''chart.gutter.top'');
                            var height = Math.abs(height);

                        } else if (xaxispos == ''center'') {
                            var startY = this.gutterTop + (this.grapharea / 2) - height;
                            
                        } else {
                            var startY = this.canvas.height - this.gutterBottom - height;
                            var height = Math.abs(height);
                        }

                        /**
                        * Draw MSIE shadow
                        */
                        if (RGraph.isOld() && shadow) {
                            this.DrawIEShadow([startX, startY, individualBarWidth, height]);
                        }

                        this.context.strokeRect(startX, startY, individualBarWidth, height);
                        this.context.fillRect(startX, startY, individualBarWidth, height);
                        y += height;



                        /**
                        * Grouped 3D effect
                        */
                        if (variant == ''3d'') {
                            var prevFillStyle = this.context.fillStyle;
                            var prevStrokeStyle = this.context.strokeStyle;
                            
                            // Draw the top side
                            this.context.beginPath();
                                this.context.moveTo(startX, startY);
                                this.context.lineTo(startX + 10, startY - 5);
                                this.context.lineTo(startX + 10 + individualBarWidth, startY - 5);
                                this.context.lineTo(startX + individualBarWidth, startY);
                            this.context.closePath();
                            
                            this.context.fill();
                            this.context.stroke();
                            
                            // Draw the side section
                            this.context.beginPath();
                                this.context.moveTo(startX + individualBarWidth, startY);
                                this.context.lineTo(startX + individualBarWidth + 10, startY - 5);
                                this.context.lineTo(startX + individualBarWidth + 10, startY - 5 + height);
                                this.context.lineTo(startX + individualBarWidth , startY + height);
                            this.context.closePath();
                            
                            this.context.fill();
                            this.context.stroke();


                            // Draw the darker top side
                            this.context.fillStyle = ''rgba(255,255,255,0.3)'';
                            this.context.beginPath();
                                this.context.moveTo(startX, startY);
                                this.context.lineTo(startX + 10, startY - 5);
                                this.context.lineTo(startX + 10 + individualBarWidth, startY - 5);
                                this.context.lineTo(startX + individualBarWidth, startY);
                            this.context.closePath();
                            
                            this.context.fill();
                            this.context.stroke();
                            
                            // Draw the darker side section
                            this.context.fillStyle = ''rgba(0,0,0,0.4)'';
                            this.context.beginPath();
                                this.context.moveTo(startX + individualBarWidth, startY);
                                this.context.lineTo(startX + individualBarWidth + 10, startY - 5);
                                this.context.lineTo(startX + individualBarWidth + 10, startY - 5 + height);
                                this.context.lineTo(startX + individualBarWidth , startY + height);
                            this.context.closePath();
                            
                            this.context.fill();
                            this.context.stroke();

                            this.context.strokeStyle = prevStrokeStyle;
                            this.context.fillStyle   = prevFillStyle;
                        }

                        this.coords.push([startX, startY, individualBarWidth, height]);

                        // Facilitate shadows going to the left
                        if (this.Get(''chart.shadow'')) {
                            redrawCoords.push([startX, startY, individualBarWidth, height, this.context.fillStyle]);
                        }
// This bit draws the text labels that appear above the bars if requested
if (this.Get(''chart.labels.above'')) {

    this.context.strokeStyle = ''rgba(0,0,0,0)'';

    // Turn off any shadow
    if (shadow) {
        RGraph.NoShadow(this);
    }

    var yPos = y - 3;

    // Account for negative bars
    if (this.data[i][j] < 0) {
        yPos += height + 6 + (this.Get(''chart.text.size'') - 4);
    }

    this.context.fillStyle = this.Get(''chart.text.color'');
    RGraph.Text(this.context,
                this.Get(''chart.text.font''),
                typeof(this.Get(''chart.labels.above.size'')) == ''number'' ? this.Get(''chart.labels.above.size'') : this.Get(''chart.text.size'') - 3,startX + (individualBarWidth / 2),
                startY - 2 - (this.Get(''chart.variant'') == ''3d'' ? 5 : 0),
                RGraph.number_format(this, this.data[i][j].toFixed(this.Get(''chart.labels.above.decimals''))),
                null,
                this.Get(''chart.labels.above.angle'') ? (this.Get(''chart.labels.above.angle'') > 0 ? ''right'' : ''left'') : ''center'',
                null,
                this.Get(''chart.labels.above.angle''));
  
    // Turn any shadow back on
    if (shadow) {
        this.context.shadowColor   = shadowColor;
        this.context.shadowBlur    = shadowBlur;
        this.context.shadowOffsetX = shadowOffsetX;
        this.context.shadowOffsetY = shadowOffsetY;
    }
}
                    }
                    
                    /**
                    * Redraw the bar if shadows are going to the left
                    */
                    if (redrawCoords.length) {

                        RGraph.NoShadow(this);
                        
                        this.context.lineWidth = this.Get(''chart.linewidth'');

                        this.context.beginPath();
                            for (var j=0; j<redrawCoords.length; ++j) {

                                this.context.fillStyle   = redrawCoords[j][4];
                                this.context.strokeStyle = this.Get(''chart.strokecolor'');

                                this.context.fillRect(redrawCoords[j][0], redrawCoords[j][1], redrawCoords[j][2], redrawCoords[j][3]);
                                this.context.strokeRect(redrawCoords[j][0], redrawCoords[j][1], redrawCoords[j][2], redrawCoords[j][3]);
                            }
                        this.context.fill();
                        this.context.stroke();

                        redrawCoords = [];
                    }
                }

            this.context.closePath();
        }

        /**
        * Turn off any shadow
        */
        RGraph.NoShadow(this);


        /**
        * Install the onclick event handler
        */
        if (this.Get(''chart.tooltips'')) {
        
            // Need to register this object for redrawing
            RGraph.Register(this);
            
            RGraph.PreLoadTooltipImages(this);

            RGraph.InstallBarTooltipEventListeners(this);
        }
    }

    /**
    * Draws the labels for the graph
    */
    RGraph.Bar.prototype.DrawLabels = function ()
    {
        var context    = this.context;
        var text_angle = this.Get(''chart.text.angle'');
        var text_size  = this.Get(''chart.text.size'');
        var labels     = this.Get(''chart.labels'');


        // Draw the Y axis labels:
        if (this.Get(''chart.ylabels'')) {
            this.Drawlabels_top();
            this.Drawlabels_center();
            this.Drawlabels_bottom();
        }

        /**
        * The X axis labels
        */
        if (typeof(labels) == ''object'' && labels) {

            var yOffset = 13 + Number(this.Get(''chart.xlabels.offset''));

            /**
            * Text angle
            */
            var angle  = 0;
            var halign = ''center'';

            if (text_angle > 0) {
                angle  = -1 * text_angle;
                halign   = ''right'';
                yOffset -= 5;
                
                if (this.Get(''chart.xaxispos'') == ''top'') {
                    halign   = ''left'';
                    yOffset += 5;
                }
            }

            // Draw the X axis labels
            context.fillStyle = this.Get(''chart.text.color'');
            
            // How wide is each bar
            var barWidth = (RGraph.GetWidth(this) - this.gutterRight - this.gutterLeft) / labels.length;
            
            // Reset the xTickGap
            xTickGap = (RGraph.GetWidth(this) - this.gutterRight - this.gutterLeft) / labels.length

            // Draw the X tickmarks
            var i=0;
            var font = this.Get(''chart.text.font'');

            for (x=this.gutterLeft + (xTickGap / 2); x<=RGraph.GetWidth(this) - this.gutterRight; x+=xTickGap) {
                RGraph.Text(context, font,
                                      text_size,
                                      x + (this.Get(''chart.text.angle'') == 90 ? 0 : 0),
                                      this.Get(''chart.xaxispos'') == ''top'' ? this.gutterTop - yOffset + text_size  - 1: (RGraph.GetHeight(this) - this.gutterBottom) + yOffset,
                                      String(labels[i++]),
                                      (this.Get(''chart.text.angle'') == 90 ? ''center'' : null),
                                      halign,
                                      null,
                                      angle);
            }
        }
    }

    /**
    * Draws the X axis at the top
    */
    RGraph.Bar.prototype.Drawlabels_top = function ()
    {
        this.context.beginPath();
        this.context.fillStyle = this.Get(''chart.text.color'');
        this.context.strokeStyle = ''black'';

        if (this.Get(''chart.xaxispos'') == ''top'') {

            var context    = this.context;
            var interval   = (this.grapharea * (1/5) );
            var text_size  = this.Get(''chart.text.size'');
            var units_pre  = this.Get(''chart.units.pre'');
            var units_post = this.Get(''chart.units.post'');
            var align      = this.Get(''chart.yaxispos'') == ''left'' ? ''right'' : ''left'';
            var font       = this.Get(''chart.text.font'');
            var numYLabels = this.Get(''chart.ylabels.count'');

            if (this.Get(''chart.ylabels.inside'') == true) {
                var xpos  = this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft + 5 : RGraph.GetWidth(this) - this.gutterRight - 5;
                var align = this.Get(''chart.yaxispos'') == ''left'' ? ''left'' : ''right'';
                var boxed = true;
            } else {
                var xpos  = this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - 5 : this.canvas.width - this.gutterRight + 5;
                var boxed = false;
            }
            
            /**
            * Draw specific Y labels here so that the local variables can be reused
            */
            if (typeof(this.Get(''chart.ylabels.specific'')) == ''object'' && this.Get(''chart.ylabels.specific'')) {
                
                var labels = RGraph.array_reverse(this.Get(''chart.ylabels.specific''));
                var grapharea = RGraph.GetHeight(this) - this.gutterTop - this.gutterBottom;

                for (var i=0; i<labels.length; ++i) {
                    
                    var y = this.gutterTop + (grapharea * (i / labels.length)) + (grapharea / labels.length);
                    
                    RGraph.Text(context, font, text_size, xpos, y, labels[i], ''center'', align, boxed);
                }

                return;
            }

            // 1(ish) label
            if (numYLabels == 3 || numYLabels == 5) {
                RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + interval, ''-'' + RGraph.number_format(this, this.scale[0], units_pre, units_post), null, align, boxed);
    
                // 5 labels
                if (numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (1*interval) + this.gutterTop + this.halfTextHeight + interval, ''-'' + RGraph.number_format(this, this.scale[1], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (3*interval) + this.gutterTop + this.halfTextHeight + interval, ''-'' + RGraph.number_format(this, this.scale[3], units_pre, units_post), null, align, boxed);
                }
                
                // 3 labels
                if (numYLabels == 3 || numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (2*interval) + this.gutterTop + this.halfTextHeight + interval, ''-'' + RGraph.number_format(this, this.scale[2], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (4*interval) + this.gutterTop + this.halfTextHeight + interval, ''-'' + RGraph.number_format(this, this.scale[4], units_pre, units_post), null, align, boxed);
                }
            }
            
            // 10 Y labels
            if (numYLabels == 10) {

                interval = (this.grapharea / numYLabels );

                for (var i=10; i>0; --i) {
                    RGraph.Text(context, font, text_size, xpos,this.gutterTop + ((this.grapharea / numYLabels) * i),''-'' + RGraph.number_format(this,((this.scale[4] / numYLabels) * i).toFixed((this.Get(''chart.scale.decimals''))), units_pre, units_post), ''center'', align, boxed);
                }
            }

            /**
            * Show the minimum value if its not zero
            */
            if (this.Get(''chart.ymin'') !!= 0) {
                RGraph.Text(context,
                            font,
                            text_size,
                            xpos,
                            this.gutterTop,
                            ''-'' + RGraph.number_format(this,(this.min.toFixed((this.Get(''chart.scale.decimals'')))), units_pre, units_post),
                            ''center'',
                            align,
                            boxed);
            }

        }
        
        this.context.fill();
        this.context.stroke();
    }

    /**
    * Draws the X axis in the middle
    */
    RGraph.Bar.prototype.Drawlabels_center = function ()
    {
        var font       = this.Get(''chart.text.font'');
        var numYLabels = this.Get(''chart.ylabels.count'');

        this.context.fillStyle = this.Get(''chart.text.color'');

        if (this.Get(''chart.xaxispos'') == ''center'') {

            /**
            * Draw the top labels
            */
            var interval   = (this.grapharea * (1/10) );
            var text_size  = this.Get(''chart.text.size'');
            var units_pre  = this.Get(''chart.units.pre'');
            var units_post = this.Get(''chart.units.post'');
            var context = this.context;
            var align   = '''';
            var xpos    = 0;
            var boxed   = false;

            this.context.fillStyle = this.Get(''chart.text.color'');
            this.context.strokeStyle = ''black'';

            if (this.Get(''chart.ylabels.inside'') == true) {
                var xpos  = this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft + 5 : RGraph.GetWidth(this) - this.gutterRight - 5;
                var align = this.Get(''chart.yaxispos'') == ''left'' ? ''left'' : ''right'';
                var boxed = true;
            } else {
                var xpos  = this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - 5 : RGraph.GetWidth(this) - this.gutterRight + 5;
                var align = this.Get(''chart.yaxispos'') == ''left'' ? ''right'' : ''left'';
                var boxed = false;
            }












            /**
            * Draw specific Y labels here so that the local variables can be reused
            */
            if (typeof(this.Get(''chart.ylabels.specific'')) == ''object'' && this.Get(''chart.ylabels.specific'')) {

                var labels = this.Get(''chart.ylabels.specific'');
                var grapharea = this.canvas.height - this.gutterTop - this.gutterBottom;

                // Draw the top halves labels
                for (var i=0; i<labels.length; ++i) {

                    var y = this.gutterTop + ((grapharea / 2) / labels.length) * i;
                    
                    RGraph.Text(context, font, text_size, xpos, y, String(labels[i]), ''center'', align, boxed);
                }

                // Draw the bottom halves labels
                for (var i=labels.length-1; i>=0; --i) {
                    var y = this.gutterTop  + (grapharea * ( (i+1) / (labels.length * 2) )) + (grapharea / 2);

                    RGraph.Text(context, font, text_size, xpos, y, labels[labels.length - i - 1], ''center'', align, boxed);
                }

                return;
            }












            if (numYLabels == 3 || numYLabels == 5) {
                RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[4], units_pre, units_post), null, align, boxed);
    
                if (numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (1*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[3], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (3*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[1], units_pre, units_post), null, align, boxed);
                }
                
                if (numYLabels == 3 || numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (4*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[0], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (2*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[2], units_pre, units_post), null, align, boxed);
                }
            } else if (numYLabels == 10) {
                // 10Y labels
                interval = (this.grapharea / numYLabels) / 2;
            
                for (var i=0; i<numYLabels; ++i) {
                    RGraph.Text(context, font, text_size, xpos,this.gutterTop + ((this.grapharea / (numYLabels * 2)) * i),RGraph.number_format(this, ((this.scale[4] / numYLabels) * (numYLabels - i)).toFixed((this.Get(''chart.scale.decimals''))), units_pre, units_post), ''center'', align, boxed);
                }
            }
            ///////////////////////////////////////////////////////////////////////////////////

            /**
            * Draw the bottom (X axis) labels
            */
            var interval = (this.grapharea) / 10;

            if (numYLabels == 3 || numYLabels == 5) {
                if (numYLabels == 3 || numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (this.grapharea + this.gutterTop + this.halfTextHeight) - (4 * interval), ''-'' + RGraph.number_format(this, this.scale[0], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (this.grapharea + this.gutterTop + this.halfTextHeight) - (2 * interval), ''-'' + RGraph.number_format(this, this.scale[2], units_pre, units_post), null, align, boxed);
                }
    
                if (numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (this.grapharea + this.gutterTop + this.halfTextHeight) - (3 * interval), ''-'' + RGraph.number_format(this, this.scale[1], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (this.grapharea + this.gutterTop + this.halfTextHeight) - interval, ''-'' + RGraph.number_format(this, this.scale[3], units_pre, units_post), null, align, boxed);
                }
    
                RGraph.Text(context, font, text_size, xpos,  this.grapharea + this.gutterTop + this.halfTextHeight, ''-'' + RGraph.number_format(this, this.scale[4], units_pre, units_post), null, align, boxed);

            } else if (numYLabels == 10) {

                // Arbitrary number of Y labels
                interval = (this.grapharea / numYLabels) / 2;
            
                for (var i=0; i<numYLabels; ++i) {
                    RGraph.Text(context, font, text_size, xpos,this.gutterTop + (this.grapharea / 2) + ((this.grapharea / (numYLabels * 2)) * i) + (this.grapharea / (numYLabels * 2)),RGraph.number_format(this, ((this.scale[4] / numYLabels) * (i+1)).toFixed((this.Get(''chart.scale.decimals''))), ''-'' + units_pre, units_post),''center'', align, boxed);
                }
            }



            /**
            * Show the minimum value if its not zero
            */
            if (this.Get(''chart.ymin'') !!= 0) {
                RGraph.Text(context,
                            font,
                            text_size,
                            xpos,
                            this.gutterTop + (this.grapharea / 2),
                            RGraph.number_format(this,(this.min.toFixed((this.Get(''chart.scale.decimals'')))), units_pre, units_post),
                            ''center'',
                            align,
                            boxed);
            }
        }
    }

    /**
    * Draws the X axdis at the bottom (the default)
    */
    RGraph.Bar.prototype.Drawlabels_bottom = function ()
    {

        this.context.beginPath();
        this.context.fillStyle = this.Get(''chart.text.color'');
        this.context.strokeStyle = ''black'';

        if (this.Get(''chart.xaxispos'') !!= ''center'' && this.Get(''chart.xaxispos'') !!= ''top'') {
            
            var interval   = (this.grapharea * (1/5) );
            var text_size  = this.Get(''chart.text.size'');
            var units_pre  = this.Get(''chart.units.pre'');
            var units_post = this.Get(''chart.units.post'');
            var context    = this.context;
            var align      = this.Get(''chart.yaxispos'') == ''left'' ? ''right'' : ''left'';
            var font       = this.Get(''chart.text.font'');
            var numYLabels = this.Get(''chart.ylabels.count'');

            if (this.Get(''chart.ylabels.inside'') == true) {
                var xpos  = this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft + 5 : RGraph.GetWidth(this) - this.gutterRight - 5;
                var align = this.Get(''chart.yaxispos'') == ''left'' ? ''left'' : ''right'';
                var boxed = true;
            } else {
                var xpos  = this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - 5 : RGraph.GetWidth(this) - this.gutterRight + 5;
                var boxed = false;
            }
            
            /**
            * Draw specific Y labels here so that the local variables can be reused
            */
            if (this.Get(''chart.ylabels.specific'') && typeof(this.Get(''chart.ylabels.specific'')) == ''object'') {
                
                var labels = this.Get(''chart.ylabels.specific'');
                var grapharea = this.canvas.height - this.gutterTop - this.gutterBottom;

                for (var i=0; i<labels.length; ++i) {
                    var y = this.gutterTop + (grapharea * (i / labels.length));
                    
                    RGraph.Text(context, font, text_size, xpos, y, labels[i], ''center'', align, boxed);
                }

                return;
            }

            // 1 label
            if (numYLabels == 3 || numYLabels == 5) {

                RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[4], units_pre, units_post), null, align, boxed);

                // 5 labels
                if (numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (1*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[3], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (3*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[1], units_pre, units_post), null, align, boxed);
                }
                
                // 3 labels
                if (numYLabels == 3 || numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, (2*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[2], units_pre, units_post), null, align, boxed);
                    RGraph.Text(context, font, text_size, xpos, (4*interval) + this.gutterTop + this.halfTextHeight, RGraph.number_format(this, this.scale[0], units_pre, units_post), null, align, boxed);
                }
            }
            
            // 10 Y labels
            if (numYLabels == 10) {

                interval   = (this.grapharea / numYLabels );

                for (var i=0; i<numYLabels; ++i) {
                    RGraph.Text(context, font, text_size, xpos, this.gutterTop + ((this.grapharea / numYLabels) * i), RGraph.number_format(this,((this.scale[4] / numYLabels) * (numYLabels - i)).toFixed((this.Get(''chart.scale.decimals''))), units_pre, units_post), ''center'', align, boxed);
                }
            }
            
            /**
            * Show the minimum value if its not zero
            */
            if (this.Get(''chart.ymin'') !!= 0) {
                RGraph.Text(context,
                            font,
                            text_size,
                            xpos,
                            this.canvas.height - this.gutterBottom,
                            RGraph.number_format(this,(this.min.toFixed((this.Get(''chart.scale.decimals'')))), units_pre, units_post),
                            ''center'',
                            align,
                            boxed);
            }
        }
        
        this.context.fill();
        this.context.stroke();
    }


    /**
    * This function is used by MSIE only to manually draw the shadow
    * 
    * @param array coords The coords for the bar
    */
    RGraph.Bar.prototype.DrawIEShadow = function (coords)
    {
        var prevFillStyle = this.context.fillStyle;
        var offsetx       = this.Get(''chart.shadow.offsetx'');
        var offsety       = this.Get(''chart.shadow.offsety'');
        
        this.context.lineWidth = this.Get(''chart.linewidth'');
        this.context.fillStyle = this.Get(''chart.shadow.color'');
        this.context.beginPath();
        
        // Draw shadow here
        this.context.fillRect(coords[0] + offsetx, coords[1] + offsety, coords[2], coords[3]);

        this.context.fill();
        
        // Change the fillstyle back to what it was
        this.context.fillStyle = prevFillStyle;
    }


    /**
    * Not used by the class during creating the graph, but is used by event handlers
    * to get the coordinates (if any) of the selected bar
    * 
    * @param object e The event object
    * @param object   OPTIONAL You can pass in the bar object instead of the
    *                          function getting it from the canvas
    */
    RGraph.Bar.prototype.getBar = function (e)
    {
        var canvas = e.target;
        var obj    = e.target.__object__;
        
        if (obj.__bar__) {
            obj = obj.__bar__;
        }
        
        var mouseCoords = RGraph.getMouseXY(e);
        
        // This facilitates you being able to pass in the bar object as a parameter instead of
        // the function getting it from the object
        if (arguments[1]) {
            obj = arguments[1];
        }

        /**
        * Loop through the bars determining if the mouse is over a bar
        */
        for (var i=0; i<obj.coords.length; i++) {

            var mouseX = mouseCoords[0];
            var mouseY = mouseCoords[1];

            var left   = obj.coords[i][0];
            var top    = obj.coords[i][1];
            var width  = obj.coords[i][2];
            var height = obj.coords[i][3];

            if (   mouseX >= left
                && mouseX <= left + width
                && mouseY >= top
                && mouseY <= top + height) {
                
                return [obj, left, top, width, height, i];
            }
        }
        
        return null;
    }


    /**
    * When you click on the chart, this method can return the Y value at that point. It works for any point on the
    * chart (that is inside the gutters) - not just points within the Bars.
    * 
    * EITHER:
    * 
    * @param object arg The event object
    * 
    * OR:
    * 
    * @param object arg A two element array containing the X and Y coordinates
    */
    RGraph.Bar.prototype.getValue = function (arg)
    {
        if (arg.length == 2) {
            var mouseX = arg[0];
            var mouseY = arg[1];
        } else {
            var mouseCoords = RGraph.getMouseXY(arg);
            var mouseX      = mouseCoords[0];
            var mouseY      = mouseCoords[1];
        }

        if (   mouseY < this.Get(''chart.gutter.top'')
            || mouseY > (this.canvas.height - this.Get(''chart.gutter.bottom''))
            || mouseX < this.Get(''chart.gutter.left'')
            || mouseX > (this.canvas.width - this.Get(''chart.gutter.right''))
           ) {
            return null;
        }
        
        if (this.Get(''chart.xaxispos'') == ''center'') {
            var value = (((this.grapharea / 2) - (mouseY - this.Get(''chart.gutter.top''))) / this.grapharea) * (this.max - this.min)
            value *= 2;
            
            if (value >= 0) {
                value += this.min;
            } else {
                value -= this.min;
            }

        } else if (this.Get(''chart.xaxispos'') == ''top'') {
            var value = ((this.grapharea - (mouseY - this.Get(''chart.gutter.top''))) / this.grapharea) * (this.max - this.min)
            value = this.max - value;
            value = Math.abs(value) * -1;
        } else {
            var value = ((this.grapharea - (mouseY - this.Get(''chart.gutter.top''))) / this.grapharea) * (this.max - this.min)
            value += this.min;
        }

        return value;
    }


    /**
    * This function can be used when the canvas is clicked on (or similar - depending on the event)
    * to retrieve the relevant Y coordinate for a particular value.
    * 
    * @param int value The value to get the Y coordinate for
    */
    RGraph.Bar.prototype.getYCoord = function (value)
    {
        var yCoord;

        yCoord = ((value - this.min) / (this.max - this.min)) * this.grapharea;
        yCoord = this.canvas.height - this.gutterBottom - yCoord;
        
        return yCoord;
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:30'!
RGraphcommonannotateJs
	^ '    /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */

    if (typeof(RGraph) == ''undefined'') RGraph = {isRGraph:true,type:''common''};


    /**
    * The function which controls the annotate feature
    * 
    * @param object obj The graph object
    */
    RGraph.Annotate = function (obj)
    {
        /**
        * This installs some event handlers
        */
        if (obj.Get(''chart.annotatable'')) {

            var canvas  = obj.canvas;
            var context = obj.context;
            
            /**
            * Capture the mouse events so we can set whther the mouse is down or not
            */
            var canvas_onmousedown = function (e)
            {
                if (e.button == 0) {

                    e.target.__object__.Set(''chart.mousedown'', true);

                    // Get the context
                    var obj = e.target.__object__;
                    var context = obj.context;

                    // Don''t want any "joining" lines or colour "bleeding"
                    context.beginPath();

                    // Accommodate Chrome
                    var coords = RGraph.getMouseXY(e);
                    var x      = coords[0];
                    var y      = coords[1];
                    
                    // Clear the annotation recording
                    RGraph.Registry.Set(''annotate.actions'', [obj.Get(''chart.annotate.color'')]);

                    context.strokeStyle = obj.Get(''chart.annotate.color'');

                    context.moveTo(x, y);
                
                    // Set the lineWidth
                    context.lineWidth = 1;
                    
                    RGraph.Registry.Set(''started.annotating'', false);
                    RGraph.Registry.Set(''chart.annotating'', obj);
                    
                    /**
                    * Fire the onannotatebegin event. It also fires an event called ononnotatestart for BC purposes
                    */
                    RGraph.FireCustomEvent(obj, ''onannotatestart'');
                    RGraph.FireCustomEvent(obj, ''onannotatebegin'');
                }
                
                return false;
            }
            canvas.addEventListener(''mousedown'', canvas_onmousedown, false);
            RGraph.AddEventListener(canvas.id, ''mousedown'', canvas_onmousedown);
            
            /**
            * This cancels annotating for ALL canvases
            */
            var window_onmouseup = function (e)
            {
                var obj  = RGraph.Registry.Get(''chart.annotating'');
                var tags = document.getElementsByTagName(''canvas'');

                for (var i=0; i<tags.length; ++i) {
                    if (tags[i].__object__) {
                        tags[i].__object__.Set(''chart.mousedown'', false);
                    }
                }

                if (e.button !!= 0 || !!obj) {
                    return;
                }

                // Store the annotations in browser storage if it''s available
                if (RGraph.Registry.Get(''annotate.actions'') && RGraph.Registry.Get(''annotate.actions'').length > 0 && window.localStorage) {

                    var id = ''__rgraph_annotations_'' + e.target.id + ''__'';
                    var annotations  = window.localStorage[id] ? window.localStorage[id] + ''|'' : '''';
                        annotations += RGraph.Registry.Get(''annotate.actions'');

                    // Store the annotations information in HTML5 browser storage here
                    window.localStorage[id] = annotations;
                }
                
                // Clear the recorded annotations
                RGraph.Registry.Set(''annotate.actions'', []);
                
                /**
                * Fire the annotate event
                */

                RGraph.FireCustomEvent(obj, ''onannotateend'');
            }
            window.addEventListener(''mouseup'', window_onmouseup, false);
            RGraph.AddEventListener(canvas.id, ''window_mouseup'', window_onmouseup);
            
            /**
            * Canvas onmouseup event
            */
            var canvas_onmouseup = function (e)
            {
                var obj = e.target.__object__;
                
                RGraph.Registry.Set(''chart.mousedown'', false);
            }
            canvas.addEventListener(''mouseup'', canvas_onmouseup, false);
            RGraph.AddEventListener(canvas.id, ''mouseup'', canvas_onmouseup);

            /**
            * The canvas onmousemove function
            */
            var canvas_onmousemove = function (e)
            {
                var e      = RGraph.FixEventObject(e);
                var obj    = e.target.__object__;
                var coords = RGraph.getMouseXY(e);
                var x      = coords[0];
                var y      = coords[1];
                var width  = canvas.width;
                var height = canvas.height;

                obj.context.lineWidth = 1;

                // Don''t allow annotating in the gutter
                //
                // CHANGED 20TH DECEMBER 2010 TO ALLOW ANNOTATING IN THE GUTTER
                if (true) {
                
                    canvas.style.cursor = ''crosshair'';
                
                    if (obj.Get(''chart.mousedown'')) {
                           
                       // Special case for HBars and Gantts with their extra wide left gutter
                       if ( (obj.type !!= ''hbar'' && obj.type !!= ''gantt'') || x > obj.gutterLeft) {

                           /**
                           * This is here to stop annotating in the gutter
                           */
                            if (RGraph.Registry.Get(''started.annotating'') == false) {
                                context.moveTo(x, y);
                                RGraph.Registry.Set(''started.annotating'', true)
                            }

                            context.lineTo(x, y);

                            RGraph.Registry.Set(''annotate.actions'', RGraph.Registry.Get(''annotate.actions'') + ''|'' + x + '','' + y);

                            context.stroke();

                            /**
                            * Fire the annotate event
                            */
                            RGraph.FireCustomEvent(obj, ''onannotate'');
                        }
                    }

                } else {
                    canvas.style.cursor = ''default'';
                }
            }
            canvas.addEventListener(''mousemove'', canvas_onmousemove, false);
            RGraph.AddEventListener(canvas.id, ''mousemove'', canvas_onmousemove);

            RGraph.ReplayAnnotations(obj);
        }
    }


    /**
    * Shows the mini palette used for annotations
    * 
    * @param object e The event object
    */
    RGraph.Showpalette = function (e)
    {
        var isSafari = navigator.userAgent.indexOf(''Safari'') ? true : false;

        e = RGraph.FixEventObject(e);

        var canvas  = e.target.parentNode.__canvas__;
        var context = canvas.getContext(''2d'');
        var obj     = canvas.__object__;
        var div     = document.createElement(''DIV'');
        var coords  = RGraph.getMouseXY(e);
        
        div.__object__               = obj; // The graph object
        div.className                = ''RGraph_palette'';
        div.style.position           = ''absolute'';
        div.style.backgroundColor    = ''white'';
        div.style.border             = ''1px solid black'';
        div.style.left               = 0;
        div.style.top                = 0;
        div.style.padding            = ''3px'';
        div.style.paddingBottom      = 0;
        div.style.paddingRight       = 0;
        div.style.opacity            = 0;
        div.style.boxShadow          = ''rgba(96,96,96,0.5) 3px 3px 3px'';
        div.style.WebkitBoxShadow    = ''rgba(96,96,96,0.5) 3px 3px 3px'';
        div.style.MozBoxShadow       = ''rgba(96,96,96,0.5) 3px 3px 3px'';
        div.style.filter             = ''progid:DXImageTransform.Microsoft.Shadow(color=#666666,direction=135)'';
        
        var common_css       = ''padding: 1px; display: inline; display: inline-block; width: 15px; height: 15px; margin-right: 3px; cursor: pointer;'' + (isSafari ? ''margin-bottom: 3px'' : '''');
        var common_mouseover = '' onmouseover="this.style.border = \''1px black solid\''; this.style.padding = 0"'';
        var common_mouseout  = '' onmouseout="this.style.border = 0; this.style.padding = \''1px\''" '';

        var str = '''';

        var colors = [''red'', ''blue'', ''green'', ''black'', ''yellow'', ''magenta'', ''pink'', ''cyan'', ''purple'', ''#ddf'', ''gray'', ''#36905c''];

        for (i=0; i<colors.length; ++i) {
            str = str + ''<span '' + common_mouseover + common_mouseout + '' style="background-color: '' + colors[i] + ''; '' + common_css  + ''" onclick="this.parentNode.__object__.Set(\''chart.annotate.color\'', this.style.backgroundColor); this.parentNode.style.display = \''none\''; RGraph.FireCustomEvent(this.parentNode.__object__, \''onannotatecolor\'')">&nbsp;</span>'';
            
            // This makes the colours go across two levels
            if (i == 5) {
                str += ''<br />'';
            }
        }

        div.innerHTML = str;
        document.body.appendChild(div);
        
        /**
        * Now the div has been added to the document, move it up and left and set the width and height
        */
        div.style.width  = (div.offsetWidth) + ''px'';
        div.style.height = (div.offsetHeight - (RGraph.isIE9up() ? 5 : 5)) + ''px'';
        div.style.left   = Math.max(0, e.pageX - div.offsetWidth - 2) + ''px'';
        div.style.top    = (e.pageY - div.offsetHeight - 2) + ''px'';

        /**
        * Store the palette div in the registry
        */
        RGraph.Registry.Set(''palette'', div);
        
        setTimeout("RGraph.Registry.Get(''palette'').style.opacity = 0.2", 50);
        setTimeout("RGraph.Registry.Get(''palette'').style.opacity = 0.4", 100);
        setTimeout("RGraph.Registry.Get(''palette'').style.opacity = 0.6", 150);
        setTimeout("RGraph.Registry.Get(''palette'').style.opacity = 0.8", 200);
        setTimeout("RGraph.Registry.Get(''palette'').style.opacity = 1", 250);

        RGraph.HideContext();

        window.onclick = function ()
        {
            RGraph.HidePalette();
        }

        // Should this be here? Yes. This function is being used as an event handler.
        e.stopPropagation();
        return false;
    }
    
    
    /**
    * Clears any annotation data from global storage
    * 
    * @param string id The ID of the canvas
    */
    RGraph.ClearAnnotations = function (id)
    {
        var canvas = document.getElementById(id);
        var obj    = canvas.__object__;

        if (window.localStorage && window.localStorage[''__rgraph_annotations_'' + id + ''__''] && window.localStorage[''__rgraph_annotations_'' + id + ''__''].length) {
            window.localStorage[''__rgraph_annotations_'' + id + ''__''] = [];
            
            RGraph.FireCustomEvent(obj, ''onannotateclear'');
        }
    }


    /**
    * Replays stored annotations
    * 
    * @param object obj The graph object
    */
    RGraph.ReplayAnnotations = function (obj)
    {
        // Check for support
        if (!!window.localStorage) {
            return;
        }

        var context     = obj.context;
        var annotations = window.localStorage[''__rgraph_annotations_'' + obj.id + ''__''];
        var i, len, move, coords;

        context.beginPath();
        context.lineWidth = 2;

        if (annotations && annotations.length) {
            annotations = annotations.split(''|'');
        } else {
            return;
        }

        for (i=0, len=annotations.length; i<len; ++i) {
            if (!!annotations[i].match(/^[0-9]+,[0-9]+$/)) {
                context.stroke();
                context.beginPath();
                context.strokeStyle = annotations[i];
                move = true;
                continue;
            }
            
            coords = annotations[i].split('','');

            if (move) {
                context.moveTo(coords[0], coords[1]);
                move = false;
            } else {
                context.lineTo(coords[0], coords[1]);
            }
        }
        
        context.stroke();
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:30'!
RGraphcommoncoreJs
	^ '    /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */

    /**
    * Initialise the various objects
    */
    if (typeof(RGraph) == ''undefined'') RGraph = {isRGraph:true,type:''common''};


    RGraph.Registry       = {};
    RGraph.Registry.store = [];
    RGraph.Registry.store[''chart.event.handlers''] = [];
    RGraph.background     = {};
    RGraph.objects        = [];
    RGraph.Resizing       = {};
    RGraph.events         = [];
    


    /**
    * Returns five values which are used as a nice scale
    * 
    * @param  max int    The maximum value of the graph
    * @param  obj object The graph object
    * @return     array   An appropriate scale
    */
    RGraph.getScale = function (max, obj)
    {
        /**
        * Special case for 0
        */
        if (max == 0) {
            return [''0.2'', ''0.4'', ''0.6'', ''0.8'', ''1.0''];
        }

        var original_max = max;

        /**
        * Manually do decimals
        */
        if (max <= 1) {
            if (max > 0.5) {
                return [0.2,0.4,0.6,0.8, Number(1).toFixed(1)];

            } else if (max >= 0.1) {
                return obj.Get(''chart.scale.round'') ? [0.2,0.4,0.6,0.8,1] : [0.1,0.2,0.3,0.4,0.5];

            } else {

                var tmp = max;
                var exp = 0;

                while (tmp < 1.01) {
                    exp += 1;
                    tmp *= 10;
                }

                var ret = [''2e-'' + exp, ''4e-'' + exp, ''6e-'' + exp, ''8e-'' + exp, ''10e-'' + exp];


                if (max <= (''5e-'' + exp)) {
                    ret = [''1e-'' + exp, ''2e-'' + exp, ''3e-'' + exp, ''4e-'' + exp, ''5e-'' + exp];
                }

                return ret;
            }
        }

        // Take off any decimals
        if (String(max).indexOf(''.'') > 0) {
            max = String(max).replace(/\.\d+$/, '''');
        }

        var interval = Math.pow(10, Number(String(Number(max)).length - 1));
        var topValue = interval;

        while (topValue < max) {
            topValue += (interval / 2);
        }

        // Handles cases where the max is (for example) 50.5
        if (Number(original_max) > Number(topValue)) {
            topValue += (interval / 2);
        }

        // Custom if the max is greater than 5 and less than 10
        if (max < 10) {
            topValue = (Number(original_max) <= 5 ? 5 : 10);
        }
        
        /**
        * Added 02/11/2010 to create "nicer" scales
        */
        if (obj && typeof(obj.Get(''chart.scale.round'')) == ''boolean'' && obj.Get(''chart.scale.round'')) {
            topValue = 10 * interval;
        }

        return [topValue * 0.2, topValue * 0.4, topValue * 0.6, topValue * 0.8, topValue];
    }


    /**
    * Returns the maximum numeric value which is in an array
    * 
    * @param  array arr The array (can also be a number, in which case it''s returned as-is)
    * @param  int       Whether to ignore signs (ie negative/positive)
    * @return int       The maximum value in the array
    */
    RGraph.array_max = function (arr)
    {
        var max = null;
        
        if (typeof(arr) == ''number'') {
            return arr;
        }
        
        for (var i=0; i<arr.length; ++i) {
            if (typeof(arr[i]) == ''number'') {

                var val = arguments[1] ? Math.abs(arr[i]) : arr[i];
                
                if (typeof(max) == ''number'') {
                    max = Math.max(max, val);
                } else {
                    max = val;
                }
            }
        }
        
        return max;
    }


    /**
    * Returns the maximum value which is in an array
    * 
    * @param  array arr The array
    * @param  int   len The length to pad the array to
    * @param  mixed     The value to use to pad the array (optional)
    */
    RGraph.array_pad = function (arr, len)
    {
        if (arr.length < len) {
            var val = arguments[2] ? arguments[2] : null;
            
            for (var i=arr.length; i<len; ++i) {
                arr[i] = val;
            }
        }
        
        return arr;
    }


    /**
    * An array sum function
    * 
    * @param  array arr The  array to calculate the total of
    * @return int       The summed total of the arrays elements
    */
    RGraph.array_sum = function (arr)
    {
        // Allow integers
        if (typeof(arr) == ''number'') {
            return arr;
        }

        var i, sum;
        var len = arr.length;

        for(i=0,sum=0;i<len;sum+=arr[i++]);
        return sum;
    }



    /**
    * A simple is_array() function
    * 
    * @param  mixed obj The object you want to check
    * @return bool      Whether the object is an array or not
    */
    RGraph.is_array = function (obj)
    {
        return obj !!= null && obj.constructor.toString().indexOf(''Array'') !!= -1;
    }


    /**
    * Converts degrees to radians
    * 
    * @param  int degrees The number of degrees
    * @return float       The number of radians
    */
    RGraph.degrees2Radians = function (degrees)
    {
        return degrees * (Math.PI / 180);
    }


    /**
    * This function draws an angled line. The angle is cosidered to be clockwise
    * 
    * @param obj ctxt   The context object
    * @param int x      The X position
    * @param int y      The Y position
    * @param int angle  The angle in RADIANS
    * @param int length The length of the line
    */
    RGraph.lineByAngle = function (context, x, y, angle, length)
    {
        context.arc(x, y, length, angle, angle, false);
        context.lineTo(x, y);
        context.arc(x, y, length, angle, angle, false);
    }


    /**
    * This is a useful function which is basically a shortcut for drawing left, right, top and bottom alligned text.
    * 
    * @param object context The context
    * @param string font    The font
    * @param int    size    The size of the text
    * @param int    x       The X coordinate
    * @param int    y       The Y coordinate
    * @param string text    The text to draw
    * @parm  string         The vertical alignment. Can be null. "center" gives center aligned  text, "top" gives top aligned text.
    *                       Anything else produces bottom aligned text. Default is bottom.
    * @param  string        The horizontal alignment. Can be null. "center" gives center aligned  text, "right" gives right aligned text.
    *                       Anything else produces left aligned text. Default is left.
    * @param  bool          Whether to show a bounding box around the text. Defaults not to
    * @param int            The angle that the text should be rotate at (IN DEGREES)
    * @param string         Background color for the text
    * @param bool           Whether the text is bold or not
    * @param bool           Whether the bounding box has a placement indicator
    */
    RGraph.Text = function (context, font, size, x, y, text)
    {
        /**
        * This calls the text function recursively to accommodate multi-line text
        */
        if (typeof(text) == ''string'' && text.match(/\r\n/)) {
            
            var arr = text.split(''\r\n'');

            text = arr[0];
            arr = RGraph.array_shift(arr);

            var nextline = arr.join(''\r\n'')

            RGraph.Text(context, font, size, arguments[9] == -90 ? (x + (size * 1.5)) : x, y + (size * 1.5), nextline, arguments[6] ? arguments[6] : null, ''center'', arguments[8], arguments[9], arguments[10], arguments[11], arguments[12]);
        }


        // Accommodate MSIE
        if (RGraph.isOld()) {
            y += 2;
        }


        context.font = (arguments[11] ? ''Bold '': '''') + size + ''pt '' + font;

        var i;
        var origX = x;
        var origY = y;
        var originalFillStyle = context.fillStyle;
        var originalLineWidth = context.lineWidth;

        // Need these now the angle can be specified, ie defaults for the former two args
        if (typeof(arguments[6]) == null) arguments[6]  = ''bottom''; // Vertical alignment. Default to bottom/baseline
        if (typeof(arguments[7]) == null) arguments[7]  = ''left'';   // Horizontal alignment. Default to left
        if (typeof(arguments[8]) == null) arguments[8]  = null;     // Show a bounding box. Useful for positioning during development. Defaults to false
        if (typeof(arguments[9]) == null) arguments[9]  = 0;        // Angle (IN DEGREES) that the text should be drawn at. 0 is middle right, and it goes clockwise
        if (typeof(arguments[12]) == null) arguments[12] = true;    // Whether the bounding box has the placement indicator

        // The alignment is recorded here for purposes of Opera compatibility
        if (navigator.userAgent.indexOf(''Opera'') !!= -1) {
            context.canvas.__rgraph_valign__ = arguments[6];
            context.canvas.__rgraph_halign__ = arguments[7];
        }

        // First, translate to x/y coords
        context.save();

            context.canvas.__rgraph_originalx__ = x;
            context.canvas.__rgraph_originaly__ = y;

            context.translate(x, y);
            x = 0;
            y = 0;
            
            // Rotate the canvas if need be
            if (arguments[9]) {
                context.rotate(arguments[9] / 57.3);
            }

            // Vertical alignment - defaults to bottom
            if (arguments[6]) {
                var vAlign = arguments[6];

                if (vAlign == ''center'') {
                    context.translate(0, size / 2);
                } else if (vAlign == ''top'') {
                    context.translate(0, size);
                }
            }


            // Hoeizontal alignment - defaults to left
            if (arguments[7]) {
                var hAlign = arguments[7];
                var width  = context.measureText(text).width;
    
                if (hAlign) {
                    if (hAlign == ''center'') {
                        context.translate(-1 * (width / 2), 0)
                    } else if (hAlign == ''right'') {
                        context.translate(-1 * width, 0)
                    }
                }
            }
            
            
            context.fillStyle = originalFillStyle;

            /**
            * Draw a bounding box if requested
            */
            context.save();
                 context.fillText(text,0,0);
                 context.lineWidth = 1;
                
                if (arguments[8]) {

                    var width = context.measureText(text).width;
                    var ieOffset = RGraph.isIE8() ? 2 : 0;

                    context.translate(x, y);
                    context.strokeRect(AA(context.canvas.__object__, - 3), AA(context.canvas.__object__, 0 - 3 - size - ieOffset), width + 6, 0 + size + 6);


                    /**
                    * If requested, draw a background for the text
                    */
                    if (arguments[10]) {
        
                        var offset = 3;
                        var ieOffset = RGraph.isIE8() ? 2 : 0;
                        var width = context.measureText(text).width

                        //context.strokeStyle = ''gray'';
                        context.fillStyle = arguments[10];
                        context.fillRect(AA(context.canvas.__object__, x - offset),
                                         AA(context.canvas.__object__, y - size - offset - ieOffset),
                                         width + (2 * offset),
                                         size + (2 * offset));
                        //context.strokeRect(x - offset, y - size - offset - ieOffset, width + (2 * offset), size + (2 * offset));
                    }
                    
                    /**
                    * Do the actual drawing of the text
                    */
                    context.fillStyle = originalFillStyle;
                    context.fillText(text,0,0);

                    if (arguments[12]) {
                        context.fillRect(
                            arguments[7] == ''left'' ? 0 : (arguments[7] == ''center'' ? width / 2 : width ) - 2,
                            arguments[6] == ''bottom'' ? 0 : (arguments[6] == ''center'' ? (0 - size) / 2 : 0 - size) - 2,
                            4,
                            4
                        );
                    }
                }
            context.restore();
            
            // Reset the lineWidth
            context.lineWidth = originalLineWidth;

        context.restore();
    }


    /**
    * Clears the canvas by setting the width. You can specify a colour if you wish.
    * 
    * @param object canvas The canvas to clear
    */
    RGraph.Clear = function (canvas)
    {
        var context = canvas.getContext(''2d'');
        var color   = arguments[1];

        if (RGraph.isIE8() && !!color) {
            color = ''white'';
        }

        /**
        * Can now clear the canvas back to fully transparent
        */
        if (!!color || (color && color == ''transparent'')) {

            context.clearRect(0,0,canvas.width, canvas.height);
           // context.fillStyle = ''rgba(0,0,0,0)'';
           // context.globalCompositeOperation = ''source-in'';
           // context = canvas.getContext(''2d'');
            //context.beginPath();
            //context.fillRect(-1000,-1000,canvas.width + 2000,canvas.height + 2000);
            //context.fill();
            
            // Reset the globalCompositeOperation
            context.globalCompositeOperation = ''source-over'';

        } else {

            context.fillStyle = color;
            context = canvas.getContext(''2d'');
            context.beginPath();

            if (RGraph.isIE8()) {
                context.fillRect(0,0,canvas.width,canvas.height);
            } else {
                context.fillRect(-10,-10,canvas.width + 20,canvas.height + 20);
            }

            context.fill();
        }
        
        // Don''t do this as it also clears any translation that may have occurred
        //canvas.width = canvas.width;
        
        if (RGraph.ClearAnnotations) {
            RGraph.ClearAnnotations(canvas.id);
        }

        RGraph.FireCustomEvent(canvas.__object__, ''onclear'');
    }


    /**
    * Draws the title of the graph
    * 
    * @param object  canvas The canvas object
    * @param string  text   The title to write
    * @param integer gutter The size of the gutter
    * @param integer        The center X point (optional - if not given it will be generated from the canvas width)
    * @param integer        Size of the text. If not given it will be 14
    */
    RGraph.DrawTitle = function (canvas, text, gutterTop)
    {
        var obj          = canvas.__object__;
        var context      = canvas.getContext(''2d'');
        var gutterLeft   = obj.Get(''chart.gutter.left'');
        var gutterRight  = obj.Get(''chart.gutter.right'');
        var gutterBottom = obj.Get(''chart.gutter.bottom'');
        var size         = arguments[4] ? arguments[4] : 12;
        var bold         = obj.Get(''chart.title.bold'');
        var centerx      = (arguments[3] ? arguments[3] : ((obj.canvas.width - gutterLeft - gutterRight) / 2) + gutterLeft);
        var keypos       = obj.Get(''chart.key.position'');
        var vpos         = obj.Get(''chart.title.vpos'');
        var hpos         = obj.Get(''chart.title.hpos'');
        var bgcolor      = obj.Get(''chart.title.background'');

        // Account for 3D effect by faking the key position
        if (obj.type == ''bar'' && obj.Get(''chart.variant'') == ''3d'') {
            keypos = ''gutter'';
        }

        context.beginPath();
        context.fillStyle = obj.Get(''chart.text.color'') ? obj.Get(''chart.text.color'') : ''black'';

        /**
        * Vertically center the text if the key is not present
        */
        if (keypos && keypos !!= ''gutter'') {
            var vCenter = ''center'';

        } else if (!!keypos) {
            var vCenter = ''center'';

        } else {
            var vCenter = ''bottom'';
        }

        // if chart.title.vpos does not equal 0.5, use that
        if (typeof(obj.Get(''chart.title.vpos'')) == ''number'') {
            vpos = obj.Get(''chart.title.vpos'') * gutterTop;

            if (obj.Get(''chart.xaxispos'') == ''top'') {
                vpos = obj.Get(''chart.title.vpos'') * gutterBottom + gutterTop + (obj.canvas.height - gutterTop - gutterBottom);
            }
        } else {
            vpos = gutterTop - size - 5;

            if (obj.Get(''chart.xaxispos'') == ''top'') {
                vpos = obj.canvas.height  - gutterBottom + size + 5;
            }
        }

        // if chart.title.hpos is a number, use that. It''s multiplied with the (entire) canvas width
        if (typeof(hpos) == ''number'') {
            centerx = hpos * canvas.width;
        }
        
        // Set the colour
        if (typeof(obj.Get(''chart.title.color'') !!= null)) {
            var oldColor = context.fillStyle
            var newColor = obj.Get(''chart.title.color'')
            context.fillStyle = newColor ? newColor : ''black'';
        }
        
        /**
        * Default font is Verdana
        */
        var font = obj.Get(''chart.text.font'');
        
        /**
        * Override the default font with chart.title.font
        */
        if (typeof(obj.Get(''chart.title.font'')) == ''string'') {
            font = obj.Get(''chart.title.font'');
        }

        /**
        * Draw the title itself
        */
        RGraph.Text(context, font, size, centerx, vpos, text, vCenter, ''center'', bgcolor !!= null, null, bgcolor, bold);
        
        // Reset the fill colour
        context.fillStyle = oldColor;
    }


    /**
    * This function returns the mouse position in relation to the canvas
    * 
    * @param object e The event object.
    */
    RGraph.getMouseXY = function (e)
    {
        var obj = (RGraph.isIE8() ? event.srcElement : e.target);
        var x;
        var y;
        
        if (RGraph.isIE8()) e = event;

        // Browser with offsetX and offsetY
        if (typeof(e.offsetX) == ''number'' && typeof(e.offsetY) == ''number'') {
            x = e.offsetX;
            y = e.offsetY;

        // FF and other
        } else {
            x = 0;
            y = 0;

            while (obj !!= document.body && obj) {
                x += obj.offsetLeft;
                y += obj.offsetTop;

                obj = obj.offsetParent;
            }

            x = e.pageX - x;
            y = e.pageY - y;
        }

        return [x, y];
    }
    
    
    /**
    * This function returns a two element array of the canvas x/y position in
    * relation to the page
    * 
    * @param object canvas
    */
    RGraph.getCanvasXY = function (canvas)
    {
        var x   = 0;
        var y   = 0;
        var obj = canvas;

        do {

            x += obj.offsetLeft;
            y += obj.offsetTop;

            obj = obj.offsetParent;

        } while (obj && obj.tagName.toLowerCase() !!= ''body'');

        return [x, y];
    }


    /**
    * Registers a graph object (used when the canvas is redrawn)
    * 
    * @param object obj The object to be registered
    */
    RGraph.Register = function (obj)
    {
        var key = obj.id + ''_'' + obj.type;

        RGraph.objects[key] = obj;
    }


    /**
    * Causes all registered objects to be redrawn
    * 
    * @param string   An optional string indicating which canvas is not to be redrawn
    * @param string An optional color to use to clear the canvas
    */
    RGraph.Redraw = function ()
    {
        for (i in RGraph.objects) {
            // TODO FIXME Maybe include more intense checking for whether the object is an RGraph object, eg obj.isRGraph == true ...?
            if (
                   typeof(i) == ''string''
                && typeof(RGraph.objects[i]) == ''object''
                && typeof(RGraph.objects[i].type) == ''string''
                && RGraph.objects[i].isRGraph)  {

                if (!!arguments[0] || arguments[0] !!= RGraph.objects[i].id) {
                    RGraph.Clear(RGraph.objects[i].canvas, arguments[1] ? arguments[1] : null);
                    RGraph.objects[i].Draw();
                }
            }
        }
    }


    /**
    * Loosly mimicks the PHP function print_r();
    */
    RGraph.pr = function (obj)
    {
        var str = '''';
        var indent = (arguments[2] ? arguments[2] : '''');

        switch (typeof(obj)) {
            case ''number'':
                if (indent == '''') {
                    str+= ''Number: ''
                }
                str += String(obj);
                break;
            
            case ''string'':
                if (indent == '''') {
                    str+= ''String ('' + obj.length + ''):''
                }
                str += ''"'' + String(obj) + ''"'';
                break;

            case ''object'':
                // In case of null
                if (obj == null) {
                    str += ''null'';
                    break;
                }

                str += ''Object\n'' + indent + ''(\n'';
                for (var i in obj) {
                    if (typeof(i) == ''string'' || typeof(i) == ''number'') {
                        str += indent + '' '' + i + '' => '' + RGraph.pr(obj[i], true, indent + ''    '') + ''\n'';
                    }
                }
                
                var str = str + indent + '')'';
                break;
            
            case ''function'':
                str += obj;
                break;
            
            case ''boolean'':
                str += ''Boolean: '' + (obj ? ''true'' : ''false'');
                break;
        }

        /**
        * Finished, now either return if we''re in a recursed call, or alert()
        * if we''re not.
        */
        if (arguments[1]) {
            return str;
        } else {
            alert(str);
        }
    }


    /**
    * The RGraph registry Set() function
    * 
    * @param  string name  The name of the key
    * @param  mixed  value The value to set
    * @return mixed        Returns the same value as you pass it
    */
    RGraph.Registry.Set = function (name, value)
    {
        // Store the setting
        RGraph.Registry.store[name] = value;
        
        // Don''t really need to do this, but ho-hum
        return value;
    }


    /**
    * The RGraph registry Get() function
    * 
    * @param  string name The name of the particular setting to fetch
    * @return mixed       The value if exists, null otherwise
    */
    RGraph.Registry.Get = function (name)
    {
        //return RGraph.Registry.store[name] == null ? null : RGraph.Registry.store[name];
        return RGraph.Registry.store[name];
    }


    /**
    * This function draws the background for the bar chart, line chart and scatter chart.
    * 
    * @param  object obj The graph object
    */
    RGraph.background.Draw = function (obj)
    {
        var canvas       = obj.canvas;
        var context      = obj.context;
        var height       = 0;
        var gutterLeft   = obj.Get(''chart.gutter.left'');
        var gutterRight  = obj.Get(''chart.gutter.right'');
        var gutterTop    = obj.Get(''chart.gutter.top'');
        var gutterBottom = obj.Get(''chart.gutter.bottom'');
        var variant      = obj.Get(''chart.variant'');
        
        context.fillStyle = obj.Get(''chart.text.color'');
        
        // If it''s a bar and 3D variant, translate
        if (variant == ''3d'') {
            context.save();
            context.translate(10, -5);
        }

        // X axis title
        if (typeof(obj.Get(''chart.title.xaxis'')) == ''string'' && obj.Get(''chart.title.xaxis'').length) {
        
            var size = obj.Get(''chart.text.size'') + 2;
            var font = obj.Get(''chart.text.font'');
            var bold = obj.Get(''chart.title.xaxis.bold'');

            if (typeof(obj.Get(''chart.title.xaxis.size'')) == ''number'') {
                size = obj.Get(''chart.title.xaxis.size'');
            }

            if (typeof(obj.Get(''chart.title.xaxis.font'')) == ''string'') {
                font = obj.Get(''chart.title.xaxis.font'');
            }
            
            var hpos = ((obj.canvas.width - obj.gutterLeft - obj.gutterRight) / 2) + obj.gutterLeft;
            var vpos = obj.canvas.height - obj.Get(''chart.gutter.bottom'') + 25;
            
            if (typeof(obj.Get(''chart.title.xaxis.pos'')) == ''number'') {
                vpos = obj.canvas.height - (gutterBottom * obj.Get(''chart.title.xaxis.pos''));
            }
        
            context.beginPath();
            RGraph.Text(context,
                        font,
                        size,
                        hpos,
                        vpos,
                        obj.Get(''chart.title.xaxis''),
                        ''center'',
                        ''center'',
                        false,
                        false,
                        false,
                        bold);
            context.fill();
        }

        // Y axis title
        if (typeof(obj.Get(''chart.title.yaxis'')) == ''string'' && obj.Get(''chart.title.yaxis'').length) {

            var size            = obj.Get(''chart.text.size'') + 2;
            var font            = obj.Get(''chart.text.font'');
            var angle           = 270;
            var bold = obj.Get(''chart.title.yaxis.bold'');

            if (typeof(obj.Get(''chart.title.yaxis.pos'')) == ''number'') {
                var yaxis_title_pos = obj.Get(''chart.title.yaxis.pos'') * obj.Get(''chart.gutter.left'');
            } else {
                var yaxis_title_pos = ((obj.Get(''chart.gutter.left'') - 25) / obj.Get(''chart.gutter.left'')) * obj.Get(''chart.gutter.left'');
            }

            if (typeof(obj.Get(''chart.title.yaxis.size'')) == ''number'') {
                size = obj.Get(''chart.title.yaxis.size'');
            }

            if (typeof(obj.Get(''chart.title.yaxis.font'')) == ''string'') {
                font = obj.Get(''chart.title.yaxis.font'');
            }

            if (obj.Get(''chart.title.yaxis.align'') == ''right'' || obj.Get(''chart.title.yaxis.position'') == ''right'') {
                angle = 90;
                yaxis_title_pos = obj.Get(''chart.title.yaxis.pos'') ? obj.Get(''chart.title.yaxis.pos'') * obj.Get(''chart.gutter.right'') :
                                                                     obj.canvas.width - obj.Get(''chart.gutter.right'') + obj.Get(''chart.text.size'') + 5;
            } else {
                yaxis_title_pos = yaxis_title_pos;
            }
            

            context.beginPath();
            RGraph.Text(context,
                        font,
                        size,
                        yaxis_title_pos,
                        ((obj.canvas.height - obj.gutterTop - obj.gutterBottom) / 2) + obj.gutterTop,
                        obj.Get(''chart.title.yaxis''),
                        ''center'',
                        ''center'',
                        false,
                        angle,
                        false,
                        bold);
            context.fill();
        }

        obj.context.beginPath();

        // Draw the horizontal bars
        context.fillStyle = obj.Get(''chart.background.barcolor1'');
        height = (RGraph.GetHeight(obj) - gutterBottom);

        for (var i=gutterTop; i < height ; i+=80) {
            obj.context.fillRect(gutterLeft, i, RGraph.GetWidth(obj) - gutterLeft - gutterRight, Math.min(40, RGraph.GetHeight(obj) - gutterBottom - i) );
        }

            context.fillStyle = obj.Get(''chart.background.barcolor2'');
            height = (RGraph.GetHeight(obj) - gutterBottom);
    
            for (var i= (40 + gutterTop); i < height; i+=80) {
                obj.context.fillRect(gutterLeft, i, RGraph.GetWidth(obj) - gutterLeft - gutterRight, i + 40 > (RGraph.GetHeight(obj) - gutterBottom) ? RGraph.GetHeight(obj) - (gutterBottom + i) : 40);
            }
            
            context.stroke();
    

        // Draw the background grid
        if (obj.Get(''chart.background.grid'')) {

            // If autofit is specified, use the .numhlines and .numvlines along with the width to work
            // out the hsize and vsize
            if (obj.Get(''chart.background.grid.autofit'')) {

                /**
                * Align the grid to the tickmarks
                */
                if (obj.Get(''chart.background.grid.autofit.align'')) {
                    // Align the horizontal lines
                    obj.Set(''chart.background.grid.autofit.numhlines'', obj.Get(''chart.ylabels.count''));

                    // Align the vertical lines for the line
                    if (obj.type == ''line'') {
                        if (obj.Get(''chart.labels'') && obj.Get(''chart.labels'').length) {
                            obj.Set(''chart.background.grid.autofit.numvlines'', obj.Get(''chart.labels'').length - 1);
                        } else {
                            obj.Set(''chart.background.grid.autofit.numvlines'', obj.data[0].length - 1);
                        }

                    // Align the vertical lines for the bar
                    } else if (obj.type == ''bar'' && obj.Get(''chart.labels'') && obj.Get(''chart.labels'').length) {
                        obj.Set(''chart.background.grid.autofit.numvlines'', obj.Get(''chart.labels'').length);
                    }
                }

                var vsize = ((obj.canvas.width - gutterLeft - gutterRight)) / obj.Get(''chart.background.grid.autofit.numvlines'');
                var hsize = (obj.canvas.height - gutterTop - gutterBottom) / obj.Get(''chart.background.grid.autofit.numhlines'');

                obj.Set(''chart.background.grid.vsize'', vsize);
                obj.Set(''chart.background.grid.hsize'', hsize);
            }

            context.beginPath();
            context.lineWidth   = obj.Get(''chart.background.grid.width'') ? obj.Get(''chart.background.grid.width'') : 1;
            context.strokeStyle = obj.Get(''chart.background.grid.color'');

            // Draw the horizontal lines
            if (obj.Get(''chart.background.grid.hlines'')) {
                height = (RGraph.GetHeight(obj) - gutterBottom)
                for (y=gutterTop; y<height; y+=obj.Get(''chart.background.grid.hsize'')) {
                    context.moveTo(gutterLeft, AA(this, y));
                    context.lineTo(RGraph.GetWidth(obj) - gutterRight, AA(this, y));
                }
            }

            if (obj.Get(''chart.background.grid.vlines'')) {
                // Draw the vertical lines
                var width = (obj.canvas.width - gutterRight)
                for (x=gutterLeft; x<=width; x+=obj.Get(''chart.background.grid.vsize'')) {
                    context.moveTo(AA(this, x), gutterTop);
                    context.lineTo(AA(this, x), obj.canvas.height - gutterBottom);
                }
            }

            if (obj.Get(''chart.background.grid.border'')) {
                // Make sure a rectangle, the same colour as the grid goes around the graph
                context.strokeStyle = obj.Get(''chart.background.grid.color'');
                context.strokeRect(AA(this, gutterLeft), AA(this, gutterTop), RGraph.GetWidth(obj) - gutterLeft - gutterRight, RGraph.GetHeight(obj) - gutterTop - gutterBottom);
            }
        }

        context.stroke();

        // If it''s a bar and 3D variant, translate
        if (variant == ''3d'') {
            context.restore();
        }

        // Draw the title if one is set
        if ( typeof(obj.Get(''chart.title'')) == ''string'') {

            if (obj.type == ''gantt'') {
                gutterTop -= 10;
            }

            RGraph.DrawTitle(canvas,
                             obj.Get(''chart.title''),
                             gutterTop,
                             null,
                             obj.Get(''chart.title.size'') ? obj.Get(''chart.title.size'') : obj.Get(''chart.text.size'') + 2);
        }

        context.stroke();
    }


    /**
    * Returns the day number for a particular date. Eg 1st February would be 32
    * 
    * @param   object obj A date object
    * @return  int        The day number of the given date
    */
    RGraph.GetDays = function (obj)
    {
        var year  = obj.getFullYear();
        var days  = obj.getDate();
        var month = obj.getMonth();
        
        if (month == 0) return days;
        if (month >= 1) days += 31; 
        if (month >= 2) days += 28;

            // Leap years. Crude, but if this code is still being used
            // when it stops working, then you have my permission to shoot
            // me. Oh, you won''t be able to - I''ll be dead...
            if (year >= 2008 && year % 4 == 0) days += 1;

        if (month >= 3) days += 31;
        if (month >= 4) days += 30;
        if (month >= 5) days += 31;
        if (month >= 6) days += 30;
        if (month >= 7) days += 31;
        if (month >= 8) days += 31;
        if (month >= 9) days += 30;
        if (month >= 10) days += 31;
        if (month >= 11) days += 30;
        
        return days;
    }

    /**
    * Debug short name functions
    */
    function pd(variable) {RGraph.pr(variable);}
    function p(variable) {RGraph.pr(variable);}
    function a(variable) {alert(variable);}
    
    /**
    * A shortcut for console.log - as used by Firebug and Chromes console
    */
    function cl (variable)
    {
        return console.log(variable);
    }


    /**
    * Makes a clone of an object
    * 
    * @param obj val The object to clone
    */
    RGraph.array_clone = function (obj)
    {
        if(obj == null || typeof(obj) !!= ''object'') {
            return obj;
        }

        var temp = [];

        for (var i=0;i<obj.length; ++i) {

            if (typeof(obj[i]) == ''number'') {
                temp[i] = (function (arg) {return Number(arg);})(obj[i]);
            } else if (typeof(obj[i]) == ''string'') {
                temp[i] = (function (arg) {return String(arg);})(obj[i]);
            } else if (typeof(obj[i]) == ''function'') {
                temp[i] = obj[i];
            
            } else {
                temp[i] = RGraph.array_clone(obj[i]);
            }
        }

        return temp;
    }


    /**
    * This function reverses an array
    */
    RGraph.array_reverse = function (arr)
    {
        var newarr = [];

        for (var i=arr.length - 1; i>=0; i--) {
            newarr.push(arr[i]);
        }

        return newarr;
    }


    /**
    * Formats a number with thousand seperators so it''s easier to read
    * 
    * @param  integer num The number to format
    * @param  string      The (optional) string to prepend to the string
    * @param  string      The (optional) string to ap
    * pend to the string
    * @return string      The formatted number
    */
    RGraph.number_format = function (obj, num)
    {
        var i;
        var prepend = arguments[2] ? String(arguments[2]) : '''';
        var append  = arguments[3] ? String(arguments[3]) : '''';
        var output  = '''';
        var decimal = '''';
        var decimal_seperator  = obj.Get(''chart.scale.point'') ? obj.Get(''chart.scale.point'') : ''.'';
        var thousand_seperator = obj.Get(''chart.scale.thousand'') ? obj.Get(''chart.scale.thousand'') : '','';
        RegExp.$1   = '''';
        var i,j;

if (typeof(obj.Get(''chart.scale.formatter'')) == ''function'') {
    return obj.Get(''chart.scale.formatter'')(obj, num);
}

        // Ignore the preformatted version of "1e-2"
        if (String(num).indexOf(''e'') > 0) {
            return String(prepend + String(num) + append);
        }

        // We need then number as a string
        num = String(num);
        
        // Take off the decimal part - we re-append it later
        if (num.indexOf(''.'') > 0) {
            num     = num.replace(/\.(.*)/, '''');
            decimal = RegExp.$1;
        }

        // Thousand seperator
        //var seperator = arguments[1] ? String(arguments[1]) : '','';
        var seperator = thousand_seperator;
        
        /**
        * Work backwards adding the thousand seperators
        */
        var foundPoint;
        for (i=(num.length - 1),j=0; i>=0; j++,i--) {
            var character = num.charAt(i);
            
            if ( j % 3 == 0 && j !!= 0) {
                output += seperator;
            }
            
            /**
            * Build the output
            */
            output += character;
        }
        
        /**
        * Now need to reverse the string
        */
        var rev = output;
        output = '''';
        for (i=(rev.length - 1); i>=0; i--) {
            output += rev.charAt(i);
        }

        // Tidy up
        //output = output.replace(/^-,/, ''-'');
        if (output.indexOf(''-'' + obj.Get(''chart.scale.thousand'')) == 0) {
            output = ''-'' + output.substr((''-'' + obj.Get(''chart.scale.thousand'')).length);
        }

        // Reappend the decimal
        if (decimal.length) {
            output =  output + decimal_seperator + decimal;
            decimal = '''';
            RegExp.$1 = '''';
        }

        // Minor bugette
        if (output.charAt(0) == ''-'') {
            output = output.replace(/-/, '''');
            prepend = ''-'' + prepend;
        }

        return prepend + output + append;
    }


    /**
    * Draws horizontal coloured bars on something like the bar, line or scatter
    */
    RGraph.DrawBars = function (obj)
    {
        var hbars = obj.Get(''chart.background.hbars'');

        /**
        * Draws a horizontal bar
        */
        obj.context.beginPath();
        
        for (i=0; i<hbars.length; ++i) {
            
            // If null is specified as the "height", set it to the upper max value
            if (hbars[i][1] == null) {
                hbars[i][1] = obj.max;
            
            // If the first index plus the second index is greater than the max value, adjust accordingly
            } else if (hbars[i][0] + hbars[i][1] > obj.max) {
                hbars[i][1] = obj.max - hbars[i][0];
            }


            // If height is negative, and the abs() value is greater than .max, use a negative max instead
            if (Math.abs(hbars[i][1]) > obj.max) {
                hbars[i][1] = -1 * obj.max;
            }


            // If start point is greater than max, change it to max
            if (Math.abs(hbars[i][0]) > obj.max) {
                hbars[i][0] = obj.max;
            }
            
            // If start point plus height is less than negative max, use the negative max plus the start point
            if (hbars[i][0] + hbars[i][1] < (-1 * obj.max) ) {
                hbars[i][1] = -1 * (obj.max + hbars[i][0]);
            }

            // If the X axis is at the bottom, and a negative max is given, warn the user
            if (obj.Get(''chart.xaxispos'') == ''bottom'' && (hbars[i][0] < 0 || (hbars[i][1] + hbars[i][1] < 0)) ) {
                alert(''['' + obj.type.toUpperCase() + '' (ID: '' + obj.id + '') BACKGROUND HBARS] You have a negative value in one of your background hbars values, whilst the X axis is in the center'');
            }

            var ystart = (obj.grapharea - ((hbars[i][0] / obj.max) * obj.grapharea));
            var height = (Math.min(hbars[i][1], obj.max - hbars[i][0]) / obj.max) * obj.grapharea;

            // Account for the X axis being in the center
            if (obj.Get(''chart.xaxispos'') == ''center'') {
                ystart /= 2;
                height /= 2;
            }
            
            ystart += obj.Get(''chart.gutter.top'')

            var x = obj.Get(''chart.gutter.left'');
            var y = ystart - height;
            var w = obj.canvas.width - obj.Get(''chart.gutter.left'') - obj.Get(''chart.gutter.right'');
            var h = height;
            
            // Accommodate Opera :-/
            if (navigator.userAgent.indexOf(''Opera'') !!= -1 && obj.Get(''chart.xaxispos'') == ''center'' && h < 0) {
                h *= -1;
                y = y - h;
            }
            
            /**
            * Account for X axis at the top
            */
            if (obj.Get(''chart.xaxispos'') == ''top'') {
                y  = obj.canvas.height - y;
                h *= -1;
            }

            obj.context.fillStyle = hbars[i][2];
            obj.context.fillRect(x, y, w, h);
        }

        obj.context.fill();
    }


    /**
    * Draws in-graph labels.
    * 
    * @param object obj The graph object
    */
    RGraph.DrawInGraphLabels = function (obj)
    {
        var canvas  = obj.canvas;
        var context = obj.context;
        var labels  = obj.Get(''chart.labels.ingraph'');
        var labels_processed = [];

        // Defaults
        var fgcolor   = ''black'';
        var bgcolor   = ''white'';
        var direction = 1;

        if (!!labels) {
            return;
        }

        /**
        * Preprocess the labels array. Numbers are expanded
        */
        for (var i=0; i<labels.length; ++i) {
            if (typeof(labels[i]) == ''number'') {
                for (var j=0; j<labels[i]; ++j) {
                    labels_processed.push(null);
                }
            } else if (typeof(labels[i]) == ''string'' || typeof(labels[i]) == ''object'') {
                labels_processed.push(labels[i]);
            
            } else {
                labels_processed.push('''');
            }
        }

        /**
        * Turn off any shadow
        */
        RGraph.NoShadow(obj);

        if (labels_processed && labels_processed.length > 0) {

            for (var i=0; i<labels_processed.length; ++i) {
                if (labels_processed[i]) {
                    var coords = obj.coords[i];
                    
                    if (coords && coords.length > 0) {
                        var x      = (obj.type == ''bar'' ? coords[0] + (coords[2] / 2) : coords[0]);
                        var y      = (obj.type == ''bar'' ? coords[1] + (coords[3] / 2) : coords[1]);
                        var length = typeof(labels_processed[i][4]) == ''number'' ? labels_processed[i][4] : 25;

    
                        context.beginPath();
                        context.fillStyle   = ''black'';
                        context.strokeStyle = ''black'';
                        
    
                        if (obj.type == ''bar'') {
                        
                            /**
                            * X axis at the top
                            */
                            if (obj.Get(''chart.xaxispos'') == ''top'') {
                                length *= -1;
                            }
    
                            if (obj.Get(''chart.variant'') == ''dot'') {
                                context.moveTo(x, obj.coords[i][1] - 5);
                                context.lineTo(x, obj.coords[i][1] - 5 - length);
                                
                                var text_x = x;
                                var text_y = obj.coords[i][1] - 5 - length;
                            
                            } else if (obj.Get(''chart.variant'') == ''arrow'') {
                                context.moveTo(x, obj.coords[i][1] - 5);
                                context.lineTo(x, obj.coords[i][1] - 5 - length);
                                
                                var text_x = x;
                                var text_y = obj.coords[i][1] - 5 - length;
                            
                            } else {
    
                                context.arc(x, y, 2.5, 0, 6.28, 0);
                                context.moveTo(x, y);
                                context.lineTo(x, y - length);

                                var text_x = x;
                                var text_y = y - length;
                            }

                            context.stroke();
                            context.fill();
                            
    
                        } else if (obj.type == ''line'') {
                        
                            if (
                                typeof(labels_processed[i]) == ''object'' &&
                                typeof(labels_processed[i][3]) == ''number'' &&
                                labels_processed[i][3] == -1
                               ) {

                                context.moveTo(x, y + 5);
                                context.lineTo(x, y + 5 + length);
                                
                                context.stroke();
                                context.beginPath();                                
                                
                                // This draws the arrow
                                context.moveTo(x, y + 5);
                                context.lineTo(x - 3, y + 10);
                                context.lineTo(x + 3, y + 10);
                                context.closePath();
                                
                                var text_x = x;
                                var text_y = y + 5 + length;
                            
                            } else {
                                
                                var text_x = x;
                                var text_y = y - 5 - length;

                                context.moveTo(x, y - 5);
                                context.lineTo(x, y - 5 - length);
                                
                                context.stroke();
                                context.beginPath();
                                
                                // This draws the arrow
                                context.moveTo(x, y - 5);
                                context.lineTo(x - 3, y - 10);
                                context.lineTo(x + 3, y - 10);
                                context.closePath();
                            }
                        
                            context.fill();
                        }

                        // Taken out on the 10th Nov 2010 - unnecessary
                        //var width = context.measureText(labels[i]).width;
                        
                        context.beginPath();
                            
                            // Fore ground color
                            context.fillStyle = (typeof(labels_processed[i]) == ''object'' && typeof(labels_processed[i][1]) == ''string'') ? labels_processed[i][1] : ''black'';

                            RGraph.Text(context,
                                        obj.Get(''chart.text.font''),
                                        obj.Get(''chart.text.size''),
                                        text_x,
                                        text_y,
                                        (typeof(labels_processed[i]) == ''object'' && typeof(labels_processed[i][0]) == ''string'') ? labels_processed[i][0] : labels_processed[i],
                                        ''bottom'',
                                        ''center'',
                                        true,
                                        null,
                                        (typeof(labels_processed[i]) == ''object'' && typeof(labels_processed[i][2]) == ''string'') ? labels_processed[i][2] : ''white'');
                        context.fill();
                    }
                }
            }
        }
    }


    /**
    * This function "fills in" key missing properties that various implementations lack
    * 
    * @param object e The event object
    */
    RGraph.FixEventObject = function (e)
    {
        if (RGraph.isIE8()) {
            
            var e = event;

            e.pageX  = (event.clientX + document.body.scrollLeft);
            e.pageY  = (event.clientY + document.body.scrollTop);
            e.target = event.srcElement;
            
            if (!!document.body.scrollTop && document.documentElement.scrollTop) {
                e.pageX += parseInt(document.documentElement.scrollLeft);
                e.pageY += parseInt(document.documentElement.scrollTop);
            }
        }

        // This is mainly for FF which doesn''t provide offsetX
        if (typeof(e.offsetX) == ''undefined'' && typeof(e.offsetY) == ''undefined'') {
            var coords = RGraph.getMouseXY(e);
            e.offsetX = coords[0];
            e.offsetY = coords[1];
        }
        
        // Any browser that doesn''t implement stopPropagation() (MSIE)
        if (!!e.stopPropagation) {
            e.stopPropagation = function () {window.event.cancelBubble = true;}
        }
        
        return e;
    }


    /**
    * Draw crosshairs if enabled
    * 
    * @param object obj The graph object (from which we can get the context and canvas as required)
    */
    RGraph.DrawCrosshairs = function (obj)
    {
        if (obj.Get(''chart.crosshairs'')) {
            var canvas  = obj.canvas;
            var context = obj.context;
            
            // 5th November 2010 - removed now that tooltips are DOM2 based.
            //if (obj.Get(''chart.tooltips'') && obj.Get(''chart.tooltips'').length > 0) {
                //alert(''['' + obj.type.toUpperCase() + ''] Sorry - you cannot have crosshairs enabled with tooltips!! Turning off crosshairs...'');
                //obj.Set(''chart.crosshairs'', false);
                //return;
            //}
            
            //canvas.onmousemove = function (e)
            var crosshairs_mousemove = function (e)
            {
                var e       = RGraph.FixEventObject(e);
                var canvas  = obj.canvas;
                var context = obj.context;
                var width   = canvas.width;
                var height  = canvas.height;
                var adjustments = obj.Get(''chart.tooltips.coords.adjust'');

                
                var gutterLeft   = obj.Get(''chart.gutter.left'');
                var gutterRight  = obj.Get(''chart.gutter.right'');
                var gutterTop    = obj.Get(''chart.gutter.top'');
                var gutterBottom = obj.Get(''chart.gutter.bottom'');
    
                var mouseCoords = RGraph.getMouseXY(e);
                var x = mouseCoords[0];
                var y = mouseCoords[1];

                if (typeof(adjustments) == ''object'' && adjustments[0] && adjustments[1]) {
                    x = x - adjustments[0];
                    y = y - adjustments[1];
                }

                RGraph.Clear(canvas);
                obj.Draw();

                if (   x >= gutterLeft
                    && y >= gutterTop
                    && x <= (width - gutterRight)
                    && y <= (height - gutterBottom)
                   ) {

                    var linewidth = obj.Get(''chart.crosshairs.linewidth'');
                    context.lineWidth = linewidth ? linewidth : 1;

                    context.beginPath();
                    context.strokeStyle = obj.Get(''chart.crosshairs.color'');

                    // Draw a top vertical line
                    if (obj.Get(''chart.crosshairs.vline'')) {
                        context.moveTo(AA(this, x), AA(this, gutterTop));
                        context.lineTo(AA(this, x), AA(this, height - gutterBottom));
                    }

                    // Draw a horizontal line
                    if (obj.Get(''chart.crosshairs.hline'')) {
                        context.moveTo(AA(this, gutterLeft), AA(this, y));
                        context.lineTo(AA(this, width - gutterRight), AA(this, y));
                    }

                    context.stroke();
                    
                    
                    /**
                    * Need to show the coords?
                    */
                    if (obj.Get(''chart.crosshairs.coords'')) {
                        if (obj.type == ''scatter'') {

                            var xCoord = (((x - obj.Get(''chart.gutter.left'')) / (obj.canvas.width - gutterLeft - gutterRight)) * (obj.Get(''chart.xmax'') - obj.Get(''chart.xmin''))) + obj.Get(''chart.xmin'');
                                xCoord = xCoord.toFixed(obj.Get(''chart.scale.decimals''));
                            var yCoord = obj.max - (((y - obj.Get(''chart.gutter.top'')) / (obj.canvas.height - gutterTop - gutterBottom)) * obj.max);

                            if (obj.type == ''scatter'' && obj.Get(''chart.xaxispos'') == ''center'') {
                                yCoord = (yCoord - (obj.max / 2)) * 2;
                            }

                            yCoord = yCoord.toFixed(obj.Get(''chart.scale.decimals''));

                            var div    = RGraph.Registry.Get(''chart.coordinates.coords.div'');
                            var mouseCoords = RGraph.getMouseXY(e);
                            var canvasXY = RGraph.getCanvasXY(canvas);
                            
                            if (!!div) {

                                div = document.createElement(''DIV'');
                                div.__object__     = obj;
                                div.style.position = ''absolute'';
                                div.style.backgroundColor = ''white'';
                                div.style.border = ''1px solid black'';
                                div.style.fontFamily = ''Arial, Verdana, sans-serif'';
                                div.style.fontSize = ''10pt''
                                div.style.padding = ''2px'';
                                div.style.opacity = 1;
                                div.style.WebkitBorderRadius = ''3px'';
                                div.style.borderRadius = ''3px'';
                                div.style.MozBorderRadius = ''3px'';
                                document.body.appendChild(div);
                                
                                RGraph.Registry.Set(''chart.coordinates.coords.div'', div);
                            }
                            
                            // Convert the X/Y pixel coords to correspond to the scale
                            div.style.opacity = 1;
                            div.style.display = ''inline'';

                            if (!!obj.Get(''chart.crosshairs.coords.fixed'')) {
                                div.style.left = Math.max(2, (e.pageX - div.offsetWidth - 3)) + ''px'';
                                div.style.top = Math.max(2, (e.pageY - div.offsetHeight - 3))  + ''px'';
                            } else {
                                div.style.left = canvasXY[0] + gutterLeft + 3 + ''px'';
                                div.style.top  = canvasXY[1] + gutterTop + 3 + ''px'';
                            }

                            div.innerHTML = ''<span style="color: #666">'' + obj.Get(''chart.crosshairs.coords.labels.x'') + '':</span> '' + xCoord + ''<br><span style="color: #666">'' + obj.Get(''chart.crosshairs.coords.labels.y'') + '':</span> '' + yCoord;
                            
                            canvas.addEventListener(''mouseout'', RGraph.HideCrosshairCoords, false);

                            obj.canvas.__crosshairs_labels__ = div;
                            obj.canvas.__crosshairs_x__ = xCoord;
                            obj.canvas.__crosshairs_y__ = yCoord;

                        } else {
                            alert(''[RGRAPH] Showing crosshair coordinates is only supported on the Scatter chart'');
                        }
                    }

                    /**
                    * Fire the oncrosshairs custom event
                    */
                    RGraph.FireCustomEvent(obj, ''oncrosshairs'');

                } else {
                    RGraph.HideCrosshairCoords();
                }
            }
            canvas.addEventListener(''mousemove'', crosshairs_mousemove, false);
            RGraph.AddEventListener(obj.id, ''mousemove'', crosshairs_mousemove);
        }
    }

    /**
    * Thisz function hides the crosshairs coordinates
    */
    RGraph.HideCrosshairCoords = function ()
    {
        var div = RGraph.Registry.Get(''chart.coordinates.coords.div'');

        if (   div
            && div.style.opacity == 1
            && div.__object__.Get(''chart.crosshairs.coords.fadeout'')
           ) {
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.9;}, 50);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.8;}, 100);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.7;}, 150);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.6;}, 200);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.5;}, 250);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.4;}, 300);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.3;}, 350);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.2;}, 400);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0.1;}, 450);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.opacity = 0;}, 500);
            setTimeout(function() {RGraph.Registry.Get(''chart.coordinates.coords.div'').style.display = ''none'';}, 550);
        }
    }


    /**
    * Trims the right hand side of a string. Removes SPACE, TAB
    * CR and LF.
    * 
    * @param string str The string to trim
    */
    RGraph.rtrim = function (str)
    {
        return str.replace(/( |\n|\r|\t)+$/, '''');
    }


    /**
    * Draws the3D axes/background
    */
    RGraph.Draw3DAxes = function (obj)
    {
        var gutterLeft    = obj.Get(''chart.gutter.left'');
        var gutterRight   = obj.Get(''chart.gutter.right'');
        var gutterTop     = obj.Get(''chart.gutter.top'');
        var gutterBottom  = obj.Get(''chart.gutter.bottom'');

        var context = obj.context;
        var canvas  = obj.canvas;

        context.strokeStyle = ''#aaa'';
        context.fillStyle = ''#ddd'';

        // Draw the vertical left side
        context.beginPath();
            context.moveTo(gutterLeft, gutterTop);
            context.lineTo(gutterLeft + 10, gutterTop - 5);
            context.lineTo(gutterLeft + 10, canvas.height - gutterBottom - 5);
            context.lineTo(gutterLeft, canvas.height - gutterBottom);
        context.closePath();
        
        context.stroke();
        context.fill();

        // Draw the bottom floor
        context.beginPath();
            context.moveTo(gutterLeft, canvas.height - gutterBottom);
            context.lineTo(gutterLeft + 10, canvas.height - gutterBottom - 5);
            context.lineTo(canvas.width - gutterRight + 10,  canvas.height - gutterBottom - 5);
            context.lineTo(canvas.width - gutterRight, canvas.height - gutterBottom);
        context.closePath();
        
        context.stroke();
        context.fill();
    }

    /**
    * Turns off any shadow
    * 
    * @param object obj The graph object
    */
    RGraph.NoShadow = function (obj)
    {
        obj.context.shadowColor   = ''rgba(0,0,0,0)'';
        obj.context.shadowBlur    = 0;
        obj.context.shadowOffsetX = 0;
        obj.context.shadowOffsetY = 0;
    }
    
    
    /**
    * Sets the four shadow properties - a shortcut function
    * 
    * @param object obj     Your graph object
    * @param string color   The shadow color
    * @param number offsetx The shadows X offset
    * @param number offsety The shadows Y offset
    * @param number blur    The blurring effect applied to the shadow
    */
    RGraph.SetShadow = function (obj, color, offsetx, offsety, blur)
    {
        obj.context.shadowColor   = color;
        obj.context.shadowOffsetX = offsetx;
        obj.context.shadowOffsetY = offsety;
        obj.context.shadowBlur    = blur;
    }


    /**
    * This function attempts to "fill in" missing functions from the canvas
    * context object. Only two at the moment - measureText() nd fillText().
    * 
    * @param object context The canvas 2D context
    */
    RGraph.OldBrowserCompat = function (context)
    {
        if (!!context) {
            return;
        }

        if (!!context.measureText) {
        
            // This emulates the measureText() function
            context.measureText = function (text)
            {
                var textObj = document.createElement(''DIV'');
                textObj.innerHTML = text;
                textObj.style.backgroundColor = ''white'';
                textObj.style.position = ''absolute'';
                textObj.style.top = -100
                textObj.style.left = 0;
                document.body.appendChild(textObj);

                var width = {width: textObj.offsetWidth};
                
                textObj.style.display = ''none'';
                
                return width;
            }
        }

        if (!!context.fillText) {
            // This emulates the fillText() method
            context.fillText    = function (text, targetX, targetY)
            {
                return false;
            }
        }
        
        // If IE8, add addEventListener()
        if (!!context.canvas.addEventListener) {
            window.addEventListener = function (ev, func, bubble)
            {
                return this.attachEvent(''on'' + ev, func);
            }

            context.canvas.addEventListener = function (ev, func, bubble)
            {
                return this.attachEvent(''on'' + ev, func);
            }
        }
    }



    /**
    * This is a function that can be used to run code asynchronously, which can
    * be used to speed up the loading of you pages.
    * 
    * @param string func This is the code to run. It can also be a function pointer.
    *                    The front page graphs show this function in action. Basically
    *                   each graphs code is made in a function, and that function is
    *                   passed to this function to run asychronously.
    */
    RGraph.Async = function (func)
    {
        return setTimeout(func, arguments[1] ? arguments[1] : 1);
    }


    /**
    * A custom random number function
    * 
    * @param number min The minimum that the number should be
    * @param number max The maximum that the number should be
    * @param number    How many decimal places there should be. Default for this is 0
    */
    RGraph.random = function (min, max)
    {
        var dp = arguments[2] ? arguments[2] : 0;
        var r = Math.random();
        
        return Number((((max - min) * r) + min).toFixed(dp));
    }


    /**
    * Draws a rectangle with curvy corners
    * 
    * @param context object The context
    * @param x       number The X coordinate (top left of the square)
    * @param y       number The Y coordinate (top left of the square)
    * @param w       number The width of the rectangle
    * @param h       number The height of the rectangle
    * @param         number The radius of the curved corners
    * @param         boolean Whether the top left corner is curvy
    * @param         boolean Whether the top right corner is curvy
    * @param         boolean Whether the bottom right corner is curvy
    * @param         boolean Whether the bottom left corner is curvy
    */
    RGraph.strokedCurvyRect = function (context, x, y, w, h)
    {
        // The corner radius
        var r = arguments[5] ? arguments[5] : 3;

        // The corners
        var corner_tl = (arguments[6] || arguments[6] == null) ? true : false;
        var corner_tr = (arguments[7] || arguments[7] == null) ? true : false;
        var corner_br = (arguments[8] || arguments[8] == null) ? true : false;
        var corner_bl = (arguments[9] || arguments[9] == null) ? true : false;

        context.beginPath();

            // Top left side
            context.moveTo(x + (corner_tl ? r : 0), y);
            context.lineTo(x + w - (corner_tr ? r : 0), y);
            
            // Top right corner
            if (corner_tr) {
                context.arc(x + w - r, y + r, r, Math.PI * 1.5, Math.PI * 2, false);
            }

            // Top right side
            context.lineTo(x + w, y + h - (corner_br ? r : 0) );

            // Bottom right corner
            if (corner_br) {
                context.arc(x + w - r, y - r + h, r, Math.PI * 2, Math.PI * 0.5, false);
            }

            // Bottom right side
            context.lineTo(x + (corner_bl ? r : 0), y + h);

            // Bottom left corner
            if (corner_bl) {
                context.arc(x + r, y - r + h, r, Math.PI * 0.5, Math.PI, false);
            }

            // Bottom left side
            context.lineTo(x, y + (corner_tl ? r : 0) );

            // Top left corner
            if (corner_tl) {
                context.arc(x + r, y + r, r, Math.PI, Math.PI * 1.5, false);
            }

        context.stroke();
    }


    /**
    * Draws a filled rectangle with curvy corners
    * 
    * @param context object The context
    * @param x       number The X coordinate (top left of the square)
    * @param y       number The Y coordinate (top left of the square)
    * @param w       number The width of the rectangle
    * @param h       number The height of the rectangle
    * @param         number The radius of the curved corners
    * @param         boolean Whether the top left corner is curvy
    * @param         boolean Whether the top right corner is curvy
    * @param         boolean Whether the bottom right corner is curvy
    * @param         boolean Whether the bottom left corner is curvy
    */
    RGraph.filledCurvyRect = function (context, x, y, w, h)
    {
        // The corner radius
        var r = arguments[5] ? arguments[5] : 3;

        // The corners
        var corner_tl = (arguments[6] || arguments[6] == null) ? true : false;
        var corner_tr = (arguments[7] || arguments[7] == null) ? true : false;
        var corner_br = (arguments[8] || arguments[8] == null) ? true : false;
        var corner_bl = (arguments[9] || arguments[9] == null) ? true : false;

        context.beginPath();

            // First draw the corners

            // Top left corner
            if (corner_tl) {
                context.moveTo(x + r, y + r);
                context.arc(x + r, y + r, r, Math.PI, 1.5 * Math.PI, false);
            } else {
                context.fillRect(x, y, r, r);
            }

            // Top right corner
            if (corner_tr) {
                context.moveTo(x + w - r, y + r);
                context.arc(x + w - r, y + r, r, 1.5 * Math.PI, 0, false);
            } else {
                context.moveTo(x + w - r, y);
                context.fillRect(x + w - r, y, r, r);
            }


            // Bottom right corner
            if (corner_br) {
                context.moveTo(x + w - r, y + h - r);
                context.arc(x + w - r, y - r + h, r, 0, Math.PI / 2, false);
            } else {
                context.moveTo(x + w - r, y + h - r);
                context.fillRect(x + w - r, y + h - r, r, r);
            }

            // Bottom left corner
            if (corner_bl) {
                context.moveTo(x + r, y + h - r);
                context.arc(x + r, y - r + h, r, Math.PI / 2, Math.PI, false);
            } else {
                context.moveTo(x, y + h - r);
                context.fillRect(x, y + h - r, r, r);
            }

            // Now fill it in
            context.fillRect(x + r, y, w - r - r, h);
            context.fillRect(x, y + r, r + 1, h - r - r);
            context.fillRect(x + w - r - 1, y + r, r + 1, h - r - r);

        context.fill();
    }


    /**
    * A crude timing function
    * 
    * @param string label The label to use for the time
    */
    RGraph.Timer = function (label)
    {
        var d = new Date();

        // This uses the Firebug console
        console.log(label + '': '' + d.getSeconds() + ''.'' + d.getMilliseconds());
    }


    /**
    * Hides the palette if it''s visible
    */
    RGraph.HidePalette = function ()
    {
        var div = RGraph.Registry.Get(''palette'');

        if (typeof(div) == ''object'' && div) {
            div.style.visibility = ''hidden'';
            div.style.display    = ''none'';
            RGraph.Registry.Set(''palette'', null);
        }
    }


    /**
    * Hides the zoomed canvas
    */
    RGraph.HideZoomedCanvas = function ()
    {
        var interval = 15;
        var frames   = 10;

        if (typeof(__zoomedimage__) == ''object'') {
            obj = __zoomedimage__.obj;
        } else {
            return;
        }

        if (obj.Get(''chart.zoom.fade.out'')) {
            for (var i=frames,j=1; i>=0; --i, ++j) {
                if (typeof(__zoomedimage__) == ''object'') {
                    setTimeout("__zoomedimage__.style.opacity = " + String(i / 10), j * interval);
                }
            }

            if (typeof(__zoomedbackground__) == ''object'') {
                setTimeout("__zoomedbackground__.style.opacity = " + String(i / frames), j * interval);
            }
        }

        if (typeof(__zoomedimage__) == ''object'') {
            setTimeout("__zoomedimage__.style.display = ''none''", obj.Get(''chart.zoom.fade.out'') ? (frames * interval) + 10 : 0);
        }

        if (typeof(__zoomedbackground__) == ''object'') {
            setTimeout("__zoomedbackground__.style.display = ''none''", obj.Get(''chart.zoom.fade.out'') ? (frames * interval) + 10 : 0);
        }
    }


    /**
    * Adds an event handler
    * 
    * @param object obj   The graph object
    * @param string event The name of the event, eg ontooltip
    * @param object func  The callback function
    */
    RGraph.AddCustomEventListener = function (obj, name, func)
    {
        if (typeof(RGraph.events[obj.id]) == ''undefined'') {
            RGraph.events[obj.id] = [];
        }

        RGraph.events[obj.id].push([obj, name, func]);
        
        return RGraph.events[obj.id].length - 1;
    }


    /**
    * Used to fire one of the RGraph custom events
    * 
    * @param object obj   The graph object that fires the event
    * @param string event The name of the event to fire
    */
    RGraph.FireCustomEvent = function (obj, name)
    {
        if (obj && obj.isRGraph) {
            var id = obj.id;
    
            if (   typeof(id) == ''string''
                && typeof(RGraph.events) == ''object''
                && typeof(RGraph.events[id]) == ''object''
                && RGraph.events[id].length > 0) {
    
                for(var j=0; j<RGraph.events[id].length; ++j) {
                    if (RGraph.events[id][j] && RGraph.events[id][j][1] == name) {
                        RGraph.events[id][j][2](obj);
                    }
                }
            }
        }
    }


    /**
    * Checks the browser for traces of MSIE8
    */
    RGraph.isIE8 = function ()
    {
        return navigator.userAgent.indexOf(''MSIE 8'') > 0;
    }


    /**
    * Checks the browser for traces of MSIE7
    */
    RGraph.isIE7 = function ()
    {
        return navigator.userAgent.indexOf(''MSIE 7'') > 0;
    }


    /**
    * Checks the browser for traces of MSIE9
    */
    RGraph.isIE9 = function ()
    {
        return navigator.userAgent.indexOf(''MSIE 9'') > 0;
    }


    /**
    * Checks the browser for traces of MSIE9
    */
    RGraph.isOld = function ()
    {
        return RGraph.isIE7() || RGraph.isIE8();
    }


    /**
    * Checks the browser for traces of MSIE9
    */
    RGraph.isIE9up = function ()
    {
        navigator.userAgent.match(/MSIE (\d+)/);

        return Number(RegExp.$1) >= 9;
    }


    /**
    * This clears a canvases event handlers. Used at the start of each graphs .Draw() method.
    * 
    * @param string id The ID of the canvas whose event handlers will be cleared
    */
    RGraph.ClearEventListeners = function (id)
    {
        for (var i=0; i<RGraph.Registry.Get(''chart.event.handlers'').length; ++i) {

            var el = RGraph.Registry.Get(''chart.event.handlers'')[i];
            if (el && (el[0] == id || el[0] == (''window_'' + id))) {
                if (el[0].substring(0, 7) == ''window_'') {
                    window.removeEventListener(el[1], el[2], false);
                } else {
                    if (document.getElementById(id)) {
                        document.getElementById(id).removeEventListener(el[1], el[2], false);
                    }
                }
                
                RGraph.Registry.Get(''chart.event.handlers'')[i] = null;
            }
        }
    }


    /**
    * 
    */
    RGraph.AddEventListener = function (id, e, func)
    {
        var type = arguments[3] ? arguments[3] : ''unknown'';

        RGraph.Registry.Get(''chart.event.handlers'').push([id, e, func, type]);
    }


    /**
    * This function suggests a gutter size based on the widest left label. Given that the bottom
    * labels may be longer, this may be a little out.
    * 
    * @param object obj  The graph object
    * @param array  data An array of graph data
    * @return int        A suggested gutter setting
    */
    RGraph.getGutterSuggest = function (obj, data)
    {
        var str = RGraph.number_format(obj, RGraph.array_max(RGraph.getScale(RGraph.array_max(data), obj)), obj.Get(''chart.units.pre''), obj.Get(''chart.units.post''));

        // Take into account the HBar
        if (obj.type == ''hbar'') {

            var str = '''';
            var len = 0;

            for (var i=0; i<obj.Get(''chart.labels'').length; ++i) {
                str = (obj.Get(''chart.labels'').length > str.length ? obj.Get(''chart.labels'')[i] : str);
            }
        }

        obj.context.font = obj.Get(''chart.text.size'') + ''pt '' + obj.Get(''chart.text.font'');

        len = obj.context.measureText(str).width + 5;

        return (obj.type == ''hbar'' ? len / 3 : len);
    }


    /**
    * A basic Array shift gunction
    * 
    * @param  object The numerical array to work on
    * @return        The new array
    */
    RGraph.array_shift = function (arr)
    {
        var ret = [];
        
        for (var i=1; i<arr.length; ++i) ret.push(arr[i]);
        
        return ret;
    }


    /**
    * If you prefer, you can use the SetConfig() method to set the configuration information
    * for your chart. You may find that setting the configuration this way eases reuse.
    * 
    * @param object obj    The graph object
    * @param object config The graph configuration information
    */
    RGraph.SetConfig = function (obj, c)
    {
        for (i in c) {
            if (typeof(i) == ''string'') {
                obj.Set(i, c[i]);
            }
        }
        
        return obj;
    }


    /**
    * These are older functions that were used before the move to seperate gutter settings
    */
    RGraph.GetHeight=function(obj){return obj.canvas.height;}
    RGraph.GetWidth=function(obj){return obj.canvas.width;}


    /**
    * Clears all the custom event listeners that have been registered
    * 
    * @param    string Limits the clearing to this object ID
    */
    RGraph.RemoveAllCustomEventListeners = function ()
    {
        var id = arguments[0];

        if (id && RGraph.events[id]) {
            RGraph.events[id] = [];
        } else {
            RGraph.events = [];
        }
    }


    /**
    * Clears a particular custom event listener
    * 
    * @param object obj The graph object
    * @param number i   This is the index that is return by .AddCustomEventListener()
    */
    RGraph.RemoveCustomEventListener = function (obj, i)
    {
        if (   typeof(RGraph.events) == ''object''
            && typeof(RGraph.events[obj.id]) == ''object''
            && typeof(RGraph.events[obj.id][i]) == ''object'') {
            
            RGraph.events[obj.id][i] = null;
        }
    }


    /**
    * This draws the background
    * 
    * @param object obj The graph object
    */
    RGraph.DrawBackgroundImage = function (obj)
    {
        var img = new Image();
        img.__object__  = obj;
        img.__canvas__  = obj.canvas;
        img.__context__ = obj.context;
        img.src         = obj.Get(''chart.background.image'');
        
        obj.__background_image__ = img;

        img.onload = function ()
        {
            var obj = this.__object__;
            
            var gutterLeft   = obj.Get(''chart.gutter.left'');
            var gutterRight  = obj.Get(''chart.gutter.right'');
            var gutterTop    = obj.Get(''chart.gutter.top'');
            var gutterBottom = obj.Get(''chart.gutter.bottom'');
            var stretch      = obj.Get(''chart.background.image.stretch'');
            var align        = obj.Get(''chart.background.image.align'');
            
            // Handle chart.background.image.align
            if (typeof(align) == ''string'') {
                if (align.indexOf(''right'') !!= -1) {
                    var x = obj.canvas.width - this.width - gutterRight;
                } else {
                    var x = gutterLeft;
                }

                if (align.indexOf(''bottom'') !!= -1) {
                    var y = obj.canvas.height - this.height - gutterBottom;
                } else {
                    var y = gutterTop;
                }
            } else {
                var x = gutterLeft;
                var y = gutterTop;
            }
            
            // X/Y coords take precedence over the align
            var x = typeof(obj.Get(''chart.background.image.x'')) == ''number'' ? obj.Get(''chart.background.image.x'') : x;
            var y = typeof(obj.Get(''chart.background.image.y'')) == ''number'' ? obj.Get(''chart.background.image.y'') : y;
            var w = stretch ? obj.canvas.width - gutterLeft - gutterRight : this.width;
            var h = stretch ? obj.canvas.height - gutterTop - gutterBottom : this.height;

            RGraph.Clear(obj.canvas);

            obj.context.drawImage(this,x,y,w, h);


            // Draw the graph
            obj.Draw();
        }
        
        img.onerror = function ()
        {
            var obj = this.__canvas__.__object__;

            // Show an error alert
            alert(''[ERROR] There was an error with the background image that you specified: '' + img.src);
            
            // Draw the graph, because the onload doesn''t fire, and thus that won''t draw the chart
            obj.Draw();
        }
    }


    /**
    * This resets the canvas. Keep in mind that any translate() that has been performed will also be reset.
    * 
    * @param object canvas The canvas
    */
    RGraph.Reset=function(canvas){canvas.width = canvas.width;}

    /**
    * This function skirts the annoying canvas anti-aliasing
    * 
    * @param object obj The object
    * @param number value The number to round
    */
    function AA (obj, value)
    {            
        var value = String(value).replace(/^(\d+)\.\d+/, ''$1'');
        var newvalue = Number(value) + 0.5;
        
        return (newvalue - value) >= 0 ? newvalue : Math.floor(value);
    }

    /**
    * Facilitates easier event handling with chart.events.click
    * 
    * @param object   obj  The chart object
    * @param function func The function to attach to the click event
    */
    RGraph.InstallUserClickListener = function (obj, func)
    {
        if (typeof(func) == ''function'') {
            function UserClickListener (e)
            {
                var obj   = e.target.__object__;
                var shape = obj.getShape(e);

                if (shape) {
                    func(e, shape);
                }
            }
            obj.canvas.addEventListener(''click'', UserClickListener, false);
            RGraph.AddEventListener(obj.id, ''click'', UserClickListener);
        }
    }


    /**
    * Facilitates easier event handling with chart.events.mousemove
    * 
    * @param object   obj  The chart object
    * @param function func The function to call when the event fires
    */
    RGraph.InstallUserMousemoveListener = function (obj, func)
    {
        if (typeof(func) == ''function'') {
            function UserMousemoveHandler (e)
            {
                var obj   = e.target.__object__;
                var shape = obj.getShape(e);
                
                /**
                * This bit saves the current pointer style if there isn''t one already saved
                */
                if (shape && typeof(func) == ''function'') {
                    if (obj.Get(''chart.events.mousemove.revertto'') == null) {
                        obj.Set(''chart.events.mousemove.revertto'', e.target.style.cursor);
                    }
                    func(e, shape)

                } else if (typeof(obj.Get(''chart.events.mousemove.revertto'')) == ''string'') {

                    e.target.style.cursor = obj.Get(''chart.events.mousemove.revertto'');
                    obj.Set(''chart.events.mousemove.revertto'', null);
                }
            }
            obj.canvas.addEventListener(''mousemove'', UserMousemoveHandler, false);
            RGraph.AddEventListener(obj.id, ''mousemove'', UserMousemoveHandler);
        }
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:30'!
RGraphcommoneffectsJs
	^ '        /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */
    
    /**
    * This is a library of a few functions that make it easier to do
    * effects like fade-ins or eaxpansion.
    */

    /**
    * Initialise the various objects
    */
    if (typeof(RGraph) == ''undefined'') RGraph = {isRGraph:true,type:''common''};
    
    RGraph.Effects = {}
    RGraph.Effects.Fade           = {}; RGraph.Effects.jQuery         = {}
    RGraph.Effects.jQuery.HBlinds = {}; RGraph.Effects.jQuery.VBlinds = {}
    RGraph.Effects.jQuery.Slide   = {}; RGraph.Effects.Pie            = {}
    RGraph.Effects.Bar            = {}; RGraph.Effects.Line           = {}
    RGraph.Effects.Line.jQuery    = {}; RGraph.Effects.Fuel           = {}
    RGraph.Effects.Rose           = {}; RGraph.Effects.Odo            = {}
    RGraph.Effects.Gauge          = {}; RGraph.Effects.Meter          = {}
    RGraph.Effects.HBar           = {}; RGraph.Effects.HProgress      = {}
    RGraph.Effects.VProgress      = {}; RGraph.Effects.Radar          = {}
    RGraph.Effects.Waterfall      = {}; RGraph.Effects.Gantt          = {}

    /**
    * Fadein
    * 
    * This function simply uses the CSS opacity property - initially set to zero and
    * increasing to 1 over the period of 0.5 second
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.Fade.In = function (obj)
    {
        var canvas = obj.canvas;

        // Initially the opacity should be zero
        canvas.style.opacity = 0;
        
        // Draw the chart
        RGraph.Clear(obj.canvas);
        obj.Draw();
        
        // Now fade the chart in
        for (var i=1; i<=10; ++i) {
            setTimeout(''document.getElementById("'' + canvas.id + ''").style.opacity = '' + (i * 0.1), i * 50);
        }
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], 500);
        }
    }


    /**
    * Fadeout
    * 
    * This function is a reversal of the above function - fading out instead of in
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.Fade.Out = function (obj)
    {
        var canvas = obj.canvas;
        
        // Draw the chart
        RGraph.Clear(obj.canvas);
        obj.Draw();
        
        // Now fade the chart in
        for (var i=10; i>=0; --i) {
            setTimeout(''document.getElementById("'' + canvas.id + ''").style.opacity = '' + (i * 0.1), (10 - i) * 50);
        }
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], 500);
        }
    }


    /**
    * Expand
    * 
    * This effect is like the tooltip effect of the same name. I starts in the middle
    * and expands out to full size.
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.jQuery.Expand = function (obj)
    {
        // Check for jQuery
        if (typeof(jQuery) == ''undefined'') {
            alert(''[ERROR] Could not find jQuery object - have you included the jQuery file?'');
        }
        
        var canvas = obj.canvas;
        
        if (!!canvas.__rgraph_div_placeholder__) {
            var div    = RGraph.Effects.ReplaceCanvasWithDIV(canvas);
            canvas.__rgraph_div_placeholder__ = div;
        } else {
            div = canvas.__rgraph_div_placeholder__;
        }

        canvas.style.position = ''relative'';
        canvas.style.top = (canvas.height / 2) + ''px'';
        canvas.style.left = (canvas.width / 2) + ''px'';


        canvas.style.width = 0;
        canvas.style.height = 0;


        canvas.style.opacity = 0;

        RGraph.Clear(obj.canvas);
        obj.Draw();

        $(''#'' + obj.id).animate({
            opacity: 1,
            width: parseInt(div.style.width) + ''px'',
            height: parseInt(div.style.height) + ''px'',
            left: ''-='' + (obj.canvas.width / 2) + ''px'',
            top: ''-='' + (obj.canvas.height / 2) + ''px''
        }, 1000);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], 1000);
        }
    }


    /**
    * A function used to replace the canvas witha Div, which inturn holds the canvas. This way the page
    * layout doesn''t shift in the canvas is resized.
    * 
    * @param object canvas The canvas to replace.
    */
    RGraph.Effects.ReplaceCanvasWithDIV  = function (canvas)
    {
        if (!!canvas.replacementDIV) {
            // Create the place holder DIV
            var div    = document.createElement(''DIV'');
                div.style.width = canvas.width + ''px'';
                div.style.height = canvas.height + ''px'';
                div.style.cssFloat = canvas.style.cssFloat;
                div.style.left = canvas.style.left;
                div.style.top = canvas.style.top;
                //div.style.position = canvas.style.position;
                div.style.display = ''inline-block'';
            canvas.parentNode.insertBefore(div, canvas);
            
    
            // Remove the canvas from the document
            canvas.parentNode.removeChild(canvas);
            
            // Add it back in as a child of the place holder
            div.appendChild(canvas);
            
            // Reset the positioning information on the canvas
            canvas.style.position = ''relative'';
            canvas.style.left = (div.offsetWidth / 2) + ''px'';
            canvas.style.top = (div.offsetHeight / 2) + ''px'';
            canvas.style.cssFloat = '''';
        
            // Add a reference to the canvas to the DIV so that repeated plays of the anumation
            // don''t keep replacing the canvas with a new DIV
            canvas.replacementDIV = div;

        } else {
            var div = canvas.replacementDIV;
        }
        
        return div;
    }


    /**
    * Snap
    * 
    * Similar to the tooltip effect of the same name, this moves the canvas in from the top left corner
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.jQuery.Snap = function (obj)
    {
        var delay = 500;

        var div = RGraph.Effects.ReplaceCanvasWithDIV(obj.canvas);
        
        obj.canvas.style.position = ''absolute'';
        obj.canvas.style.top = 0;
        obj.canvas.style.left = 0;
        obj.canvas.style.width = 0;
        obj.canvas.style.height = 0;
        obj.canvas.style.opacity = 0;
        
        var targetLeft   = div.offsetLeft;
        var targetTop    = div.offsetTop;
        var targetWidth  = div.offsetWidth;
        var targetHeight = div.offsetHeight;

        RGraph.Clear(obj.canvas);
        obj.Draw();

        $(''#'' + obj.id).animate({
            opacity: 1,
            width: targetWidth + ''px'',
            height: targetHeight + ''px'',
            left: targetLeft + ''px'',
            top: targetTop + ''px''
        }, delay);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay + 50);
        }
    }


    /**
    * Reveal
    * 
    * This effect issmilat to the Expand effect - the canvas is slowly revealed from
    * the centre outwards
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.jQuery.Reveal = function (obj)
    {
        var opts   = arguments[1] ? arguments[1] : null;
        var delay  = 1000;
        var canvas = obj.canvas;
        var xy     = RGraph.getCanvasXY(obj.canvas);


        /**
        * Hide the canvas and draw it
        */
        obj.canvas.style.visibility = ''hidden'';
        RGraph.Clear(obj.canvas);
        obj.Draw();


        var divs = [
                    [''reveal_left'', xy[0], xy[1], obj.canvas.width  / 2, obj.canvas.height],
                    [''reveal_right'',(xy[0] + (obj.canvas.width  / 2)),xy[1],(obj.canvas.width  / 2),obj.canvas.height],
                    [''reveal_top'',xy[0],xy[1],obj.canvas.width,(obj.canvas.height / 2)],
                    [''reveal_bottom'',xy[0],(xy[1] + (obj.canvas.height  / 2)),obj.canvas.width,(obj.canvas.height / 2)]
                   ];
        
        for (var i=0; i<divs.length; ++i) {
            var div = document.createElement(''DIV'');
                div.id = divs[i][0];
                div.style.width =  divs[i][3]+ ''px'';
                div.style.height = divs[i][4] + ''px'';
                div.style.left   = divs[i][1] + ''px'';
                div.style.top   = divs[i][2] + ''px'';
                div.style.position = ''absolute'';
                div.style.backgroundColor = opts && typeof(opts[''color'']) == ''string'' ? opts[''color''] : ''white'';
            document.body.appendChild(div);
        }
        
        /**
        * Now the covering DIVs are in place show the canvas again
        */
        obj.canvas.style.visibility = ''visible'';


        $(''#reveal_left'').animate({width: 0}, delay);
        $(''#reveal_right'').animate({left: ''+='' + (obj.canvas.width / 2),width: 0}, delay);
        $(''#reveal_top'').animate({height: 0}, delay);
        $(''#reveal_bottom'').animate({top: ''+='' + (obj.canvas.height / 2),height: 0}, delay);
        
        // Remove the DIVs from the DOM 100ms after the animation ends
        setTimeout(
            function ()
            {
                document.body.removeChild(document.getElementById("reveal_top"))
                document.body.removeChild(document.getElementById("reveal_bottom"))
                document.body.removeChild(document.getElementById("reveal_left"))
                document.body.removeChild(document.getElementById("reveal_right"))
            }
            , delay);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Conceal
    * 
    * This effect is the reverse of the Reveal effect - instead of revealing the canvas it
    * conceals it. Combined with the reveal effect would make for a nice wipe effect.
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.jQuery.Conceal = function (obj)
    {
        var opts   = arguments[1] ? arguments[1] : null;
        var delay  = 1000;
        var canvas = obj.canvas;
        var xy     = RGraph.getCanvasXY(obj.canvas);


        var divs = [
                    [''conceal_left'', xy[0], xy[1], 0, obj.canvas.height],
                    [''conceal_right'',(xy[0] + obj.canvas.width),xy[1],0,obj.canvas.height],
                    [''conceal_top'',xy[0],xy[1],obj.canvas.width,0],
                    [''conceal_bottom'',xy[0],(xy[1] + obj.canvas.height),obj.canvas.width,0]
                   ];
        
        for (var i=0; i<divs.length; ++i) {
            var div = document.createElement(''DIV'');
                div.id = divs[i][0];
                div.style.width =  divs[i][3]+ ''px'';
                div.style.height = divs[i][4] + ''px'';
                div.style.left   = divs[i][1] + ''px'';
                div.style.top   = divs[i][2] + ''px'';
                div.style.position = ''absolute'';
                div.style.backgroundColor = opts && typeof(opts[''color'']) == ''string'' ? opts[''color''] : ''white'';
            document.body.appendChild(div);
        }


        $(''#conceal_left'').animate({width: ''+='' + (obj.canvas.width / 2)}, delay);
        $(''#conceal_right'').animate({left: ''-='' + (obj.canvas.width / 2),width: (obj.canvas.width / 2)}, delay);
        $(''#conceal_top'').animate({height: ''+='' + (obj.canvas.height / 2)}, delay);
        $(''#conceal_bottom'').animate({top: ''-='' + (obj.canvas.height / 2),height: (obj.canvas.height / 2)}, delay);
        
        // Remove the DIVs from the DOM 100ms after the animation ends
        setTimeout(
            function ()
            {
                document.body.removeChild(document.getElementById("conceal_top"))
                document.body.removeChild(document.getElementById("conceal_bottom"))
                document.body.removeChild(document.getElementById("conceal_left"))
                document.body.removeChild(document.getElementById("conceal_right"))
            }
            , delay);
            
        setTimeout(function () {RGraph.Clear(obj.canvas);}, delay);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Horizontal Blinds (open)
    * 
    * @params object obj The graph object
    */
    RGraph.Effects.jQuery.HBlinds.Open = function (obj)
    {
        var canvas  = obj.canvas;
        var opts   = arguments[1] ? arguments[1] : [];
        var delay  = 1000;
        var color  = opts[''color''] ? opts[''color''] : ''white'';
        var xy     = RGraph.getCanvasXY(canvas);
        var height = canvas.height / 5;
        
        /**
        * First draw the chart
        */
        RGraph.Clear(obj.canvas);
        obj.Draw();

        for (var i=0; i<5; ++i) {
            var div = document.createElement(''DIV'');
                div.id = ''blinds_'' + i;
                div.style.width =  canvas.width + ''px'';
                div.style.height = height + ''px'';
                div.style.left   = xy[0] + ''px'';
                div.style.top   = (xy[1] + (canvas.height * (i / 5))) + ''px'';
                div.style.position = ''absolute'';
                div.style.backgroundColor = color;
            document.body.appendChild(div);

            $(''#blinds_'' + i).animate({height: 0}, delay);
        }

        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_0''));}, delay);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_1''));}, delay);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_2''));}, delay);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_3''));}, delay);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_4''));}, delay);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Horizontal Blinds (close)
    * 
    * @params object obj The graph object
    */
    RGraph.Effects.jQuery.HBlinds.Close = function (obj)
    {
        var canvas  = obj.canvas;
        var opts   = arguments[1] ? arguments[1] : [];
        var delay  = 1000;
        var color  = opts[''color''] ? opts[''color''] : ''white'';
        var xy     = RGraph.getCanvasXY(canvas);
        var height = canvas.height / 5;

        for (var i=0; i<5; ++i) {
            var div = document.createElement(''DIV'');
                div.id = ''blinds_'' + i;
                div.style.width =  canvas.width + ''px'';
                div.style.height = 0;
                div.style.left   = xy[0] + ''px'';
                div.style.top   = (xy[1] + (canvas.height * (i / 5))) + ''px'';
                div.style.position = ''absolute'';
                div.style.backgroundColor = color;
            document.body.appendChild(div);

            $(''#blinds_'' + i).animate({height: height + ''px''}, delay);
        }
        
        setTimeout(function () {RGraph.Clear(obj.canvas);}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_0''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_1''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_2''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_3''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_4''));}, delay + 100);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Vertical Blinds (open)
    * 
    * @params object obj The graph object
    */
    RGraph.Effects.jQuery.VBlinds.Open = function (obj)
    {
        var canvas  = obj.canvas;
        var opts   = arguments[1] ? arguments[1] : [];
        var delay  = 1000;
        var color  = opts[''color''] ? opts[''color''] : ''white'';
        var xy     = RGraph.getCanvasXY(canvas);
        var width  = canvas.width / 10;
        
        /**
        * First draw the chart
        */
        RGraph.Clear(obj.canvas);
        obj.Draw();

        for (var i=0; i<10; ++i) {
            var div = document.createElement(''DIV'');
                div.id = ''blinds_'' + i;
                div.style.width =  width + ''px'';
                div.style.height = canvas.height + ''px'';
                div.style.left   = (xy[0] + (canvas.width * (i / 10))) + ''px'';
                div.style.top   = (xy[1]) + ''px'';
                div.style.position = ''absolute'';
                div.style.backgroundColor = color;
            document.body.appendChild(div);

            $(''#blinds_'' + i).animate({width: 0}, delay);
        }

        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_0''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_1''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_2''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_3''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_4''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_5''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_6''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_7''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_8''));}, delay + 100);
        setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_9''));}, delay + 100);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Vertical Blinds (close)
    * 
    * @params object obj The graph object
    */
    RGraph.Effects.jQuery.VBlinds.Close = function (obj)
    {
        var canvas  = obj.canvas;
        var opts   = arguments[1] ? arguments[1] : [];
        var delay  = 1000;
        var color  = opts[''color''] ? opts[''color''] : ''white'';
        var xy     = RGraph.getCanvasXY(canvas);
        var width  = canvas.width / 10;
        
        // Don''t draw the chart

        for (var i=0; i<10; ++i) {
            var div = document.createElement(''DIV'');
                div.id = ''blinds_'' + i;
                div.style.width =  0;
                div.style.height = canvas.height + ''px'';
                div.style.left   = (xy[0] + (canvas.width * (i / 10))) + ''px'';
                div.style.top   = (xy[1]) + ''px'';
                div.style.position = ''absolute'';
                div.style.backgroundColor = color;
            document.body.appendChild(div);

            $(''#blinds_'' + i).animate({width: width}, delay);
        }

        setTimeout(function () {RGraph.Clear(obj.canvas, color);}, delay + 100);

        if (opts[''remove'']) {
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_0''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_1''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_2''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_3''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_4''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_5''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_6''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_7''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_8''));}, delay + 100);
            setTimeout(function () {document.body.removeChild(document.getElementById(''blinds_9''));}, delay + 100);
        }
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Pie chart grow
    * 
    * Gradually increases the pie chart radius
    * 
    * @params object obj The graph object
    */
    RGraph.Effects.Pie.Grow = function (obj)
    {
        var canvas  = obj.canvas;
        var opts   = arguments[1] ? arguments[1] : [];
        var color  = opts[''color''] ? opts[''color''] : ''white'';
        var xy     = RGraph.getCanvasXY(canvas);
        
        canvas.style.visibility = ''hidden'';
        obj.Draw();
        var radius = obj.getRadius();
        RGraph.Clear(obj.canvas);
        canvas.style.visibility = ''visible'';

        obj.Set(''chart.radius'', 0);

        RGraph.Effects.Animate(obj, {''chart.radius'': radius}, arguments[2]);
    }


    /**
    * Grow
    * 
    * The Bar chart Grow effect gradually increases the values of the bars
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.Bar.Grow = function (obj)
    {
        // Save the data
        obj.original_data = RGraph.array_clone(obj.data);
        
        // Zero the data
        obj.__animation_frame__ = 0;

        // Stop the scale from changing by setting chart.ymax (if it''s not already set)
        if (obj.Get(''chart.ymax'') == null) {

            var ymax = 0;

            for (var i=0; i<obj.data.length; ++i) {
                if (RGraph.is_array(obj.data[i]) && obj.Get(''chart.grouping'') == ''stacked'') {
                    ymax = Math.max(ymax, Math.abs(RGraph.array_sum(obj.data[i])));
                } else {
                    ymax = Math.max(ymax, Math.abs(obj.data[i]));
                }
            }

            ymax = RGraph.getScale(ymax, obj)[4];
            
            obj.Set(''chart.ymax'', ymax);
        }

        function Grow ()
        {
            var numFrames = 30;

            if (!!obj.__animation_frame__) {
                obj.__animation_frame__  = 0;
                obj.__original_hmargin__ = obj.Get(''chart.hmargin'');
                obj.__hmargin__          = ((obj.canvas.width - obj.Get(''chart.gutter.left'') - obj.Get(''chart.gutter.right'')) / obj.data.length) / 2;
                obj.Set(''chart.hmargin'', obj.__hmargin__);
            }

            // Alter the Bar chart data depending on the frame
            for (var j=0; j<obj.original_data.length; ++j) {
                if (typeof(obj.data[j]) == ''object'') {
                    for (var k=0; k<obj.data[j].length; ++k) {
                        obj.data[j][k] = (obj.__animation_frame__ / numFrames) * obj.original_data[j][k];
                    }
                } else {
                    obj.data[j] = (obj.__animation_frame__ / numFrames) * obj.original_data[j];
                }
            }

            /**
            * Increment the hmargin to the target
            */
            obj.Set(''chart.hmargin'', ((1 - (obj.__animation_frame__ / numFrames)) * (obj.__hmargin__ - obj.__original_hmargin__)) + obj.__original_hmargin__);


            RGraph.Clear(obj.canvas);
            obj.Draw();

            if (obj.__animation_frame__ < numFrames) {
                obj.__animation_frame__ += 1;
                
                if (location.href.indexOf(''?settimeout'') > 0) {
                    setTimeout(Grow, 40);
                } else {
                    RGraph.Effects.UpdateCanvas(Grow);
                }
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow);
    }


    /**
    * A wrapper function that encapsulate requestAnimationFrame
    * 
    * @param function func The animation function
    */
    RGraph.Effects.UpdateCanvas = function (func)
    {
        // Standard
        if (typeof(window.requestAnimationFrame) == ''function'') {
            window.requestAnimationFrame(func);

        // IE 10+
        } else if (typeof(window.msRequestAnimationFrame) == ''function'') {
            window.msRequestAnimationFrame(func);

        // Chrome
        } else if (typeof(window.webkitRequestAnimationFrame) == ''function'') {
            window.webkitRequestAnimationFrame(func);

        // Firefox
        } else if (window.mozRequestAnimationFrame) { // Seems rather slow in FF6 - so disabled
            window.mozRequestAnimationFrame(func);

        // Default fallback to setTimeout
        } else {
            setTimeout(func, 1000 / 60);
        }
    }


    /**
    * Grow
    * 
    * The Fuel chart Grow effect gradually increases the values of the Fuel chart
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.Fuel.Grow = function (obj)
    {
        var totalFrames  = 30;
        var currentFrame = 0;
        var diff         = obj.value - obj.currentValue;
        var increment    = diff / totalFrames;
        var callback     = arguments[2] ? arguments[2] : null;

        function Grow ()
        {

            if (currentFrame < totalFrames) {
                obj.value = obj.currentValue + increment;
                RGraph.Clear(obj.canvas);
                obj.Draw();

                currentFrame++;
                RGraph.Effects.UpdateCanvas(Grow);
            } else if (callback) {
                callback(obj);
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow);
    }


    /**
    * The Animate function. Similar to the jQuery Animate() function - simply pass it a
    * map of the properties and their target values, and this function will animate
    * them to get to those values.
    * 
    * @param object obj The chart object
    * @param object map A map (an associative array) of the properties and their target values.
    * @param            An optional function which will be called when the animation is complete
    */
    RGraph.Effects.Animate = function (obj, map)
    {
        obj.Draw();

        RGraph.Effects.__total_frames__  = (map && map[''frames'']) ? map[''frames''] : 30;

        function Animate_Iterator (func)
        {
            var id = [obj.id +  ''_'' + obj.type];

            // Very first time in - initialise the arrays
            if (typeof(RGraph.Effects.__current_frame__ ) == ''undefined'') {
                RGraph.Effects.__current_frame__   = new Array();
                RGraph.Effects.__original_values__ = new Array();
                RGraph.Effects.__diffs__           = new Array();
                RGraph.Effects.__steps__           = new Array();
                RGraph.Effects.__callback__        = new Array();
            }

            // Initialise the arrays for THIS animation (not necessrily the first in the page)
            if (!!RGraph.Effects.__current_frame__[id]) {
                RGraph.Effects.__current_frame__[id] = RGraph.Effects.__total_frames__;
                RGraph.Effects.__original_values__[id] = {};
                RGraph.Effects.__diffs__[id]           = {};
                RGraph.Effects.__steps__[id]           = {};
                RGraph.Effects.__callback__[id]        = func;
            }

            for (var i in map) {
                if (typeof(map[i]) == ''string'' || typeof(map[i]) == ''number'') {

                    // If this the first frame, record the proginal value
                    if (RGraph.Effects.__current_frame__[id] == RGraph.Effects.__total_frames__) {
                        RGraph.Effects.__original_values__[id][i] = obj.Get(i);
                        RGraph.Effects.__diffs__[id][i]           = map[i] - RGraph.Effects.__original_values__[id][i];
                        RGraph.Effects.__steps__[id][i]           = RGraph.Effects.__diffs__[id][i] / RGraph.Effects.__total_frames__;
                    }

                    obj.Set(i, obj.Get(i) + RGraph.Effects.__steps__[id][i]);

                    RGraph.Clear(obj.canvas);
                    obj.Draw();
                }
            }

            // If the current frame number is above zero, run the animation iterator again
            if (--RGraph.Effects.__current_frame__[id] > 0) {
                //setTimeout(Animate_Iterator, 100)
                RGraph.Effects.UpdateCanvas(Animate_Iterator);
            
            // Optional callback
            } else {

                if (typeof(RGraph.Effects.__callback__[id]) == ''function'') {
                    (RGraph.Effects.__callback__[id])(obj);
                }
                
                // Get rid of the arrays
                RGraph.Effects.__current_frame__[id]   = null;
                RGraph.Effects.__original_values__[id] = null;
                RGraph.Effects.__diffs__[id]           = null;
                RGraph.Effects.__steps__[id]           = null;
                RGraph.Effects.__callback__[id]        = null;

            }
        }

        Animate_Iterator(arguments[2]);
    }


    /**
    * Slide in
    * 
    * This function is a wipe that can be used when switching the canvas to a new graph
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.jQuery.Slide.In = function (obj)
    {
        RGraph.Clear(obj.canvas);
        obj.Draw();

        var canvas = obj.canvas;
        var div    = RGraph.Effects.ReplaceCanvasWithDIV(obj.canvas);
        var delay = 1000;
        div.style.overflow= ''hidden'';
        var from = typeof(arguments[1]) == ''object'' && typeof(arguments[1][''from'']) == ''string'' ? arguments[1][''from''] : ''left'';
        
        canvas.style.position = ''relative'';
        
        if (from == ''left'') {
            canvas.style.left = (0 - div.offsetWidth) + ''px'';
            canvas.style.top  = 0;
        } else if (from == ''top'') {
            canvas.style.left = 0;
            canvas.style.top  = (0 - div.offsetHeight) + ''px'';
        } else if (from == ''bottom'') {
            canvas.style.left = 0;
            canvas.style.top  = div.offsetHeight + ''px'';
        } else {
            canvas.style.left = div.offsetWidth + ''px'';
            canvas.style.top  = 0;
        }
        
        $(''#'' + obj.id).animate({left:0,top:0}, delay);
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Slide out
    * 
    * This function is a wipe that can be used when switching the canvas to a new graph
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.jQuery.Slide.Out = function (obj)
    {
        var canvas = obj.canvas;
        var div    = RGraph.Effects.ReplaceCanvasWithDIV(obj.canvas);
        var delay = 1000;
        div.style.overflow= ''hidden'';
        var to = typeof(arguments[1]) == ''object'' && typeof(arguments[1][''to'']) == ''string'' ? arguments[1][''to''] : ''left'';
        
        canvas.style.position = ''relative'';
        canvas.style.left = 0;
        canvas.style.top  = 0;
        
        if (to == ''left'') {
            $(''#'' + obj.id).animate({left: (0 - canvas.width) + ''px''}, delay);
        } else if (to == ''top'') {
            $(''#'' + obj.id).animate({left: 0, top: (0 - div.offsetHeight) + ''px''}, delay);
        } else if (to == ''bottom'') {
            $(''#'' + obj.id).animate({top: (0 + div.offsetHeight) + ''px''}, delay);
        } else {
            $(''#'' + obj.id).animate({left: (0 + canvas.width) + ''px''}, delay);
        }
        
        /**
        * Callback
        */
        if (typeof(arguments[2]) == ''function'') {
            setTimeout(arguments[2], delay);
        }
    }


    /**
    * Unfold
    * 
    * This effect gradually increases the X/Y coordinatesfrom 0
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.Line.Unfold = function (obj)
    {
        obj.Set(''chart.animation.factor'', obj.Get(''chart.animation.unfold.initial''));
        RGraph.Effects.Animate(obj, {''chart.animation.factor'': 1}, arguments[2]);
    }


    /**
    * Unfold
    * 
    * This effect gradually increases the radiuss and decrease the margin of the Rose chart
    * 
    * @param object   obj The chart object
    * @param              Not used - pass null
    * @param function     An optional callback function
    */
    RGraph.Effects.Rose.Grow = function (obj)
    {
        var numFrames       = 60;
        var currentFrame    = 0;
        var original_margin = obj.Get(''chart.margin'');
        var margin          = (360 / obj.data.length) / 2;
        var callback        = arguments[2];

        obj.Set(''chart.margin'', margin);
        obj.Set(''chart.animation.grow.factor'', 0);

        //RGraph.Effects.Animate(obj, {''chart.margin'': original_margin, ''chart.animation.grow.factor'': 1, ''frames'': 45}, arguments[2]);
        function Grow_inner ()
        {
            if (currentFrame++ < numFrames) {
                obj.Set(''chart.animation.grow.factor'', currentFrame / numFrames);
                obj.Set(''chart.margin'', (currentFrame / numFrames) * original_margin);
                RGraph.Clear(obj.canvas);
                obj.Draw();
                
                RGraph.Effects.UpdateCanvas(Grow_inner);

            } else {
                obj.Set(''chart.animation.grow.factor'', 1);
                obj.Set(''chart.margin'', original_margin);
                RGraph.Clear(obj.canvas);
                obj.Draw();
                
                if (typeof(callback) == ''function'') {
                    callback(obj);
                }
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow_inner);
    }


    /**
    * UnfoldFromCenter
    * 
    * Line chart  unfold from center
    */
    RGraph.Effects.Line.UnfoldFromCenter = function (obj)
    {
        var numFrames = 30;

        var original_opacity = obj.canvas.style.opacity;
        obj.canvas.style.opacity = 0;
        obj.Draw();
        var center_value = obj.scale[4] / 2;
        obj.Set(''chart.ymax'', Number(obj.scale[4]));
        RGraph.Clear(obj.canvas);
        obj.canvas.style.opacity = original_opacity;
        var original_data = RGraph.array_clone(obj.original_data);
        var original_blur = obj.Get(''chart.shadow.blur'');
        obj.Set(''chart.shadow.blur'', 0);
        var callback = arguments[2];

        if (!!obj.__increments__) {
        
            obj.__increments__ = new Array();
        
            for (var dataset=0; dataset<original_data.length; ++dataset) {

                obj.__increments__[dataset] = new Array();

                for (var i=0; i<original_data[dataset].length; ++i) {
                    obj.__increments__[dataset][i] = (original_data[dataset][i] - center_value) / numFrames;
                    
                    obj.original_data[dataset][i] = center_value;
                }
            }
        }

        function UnfoldFromCenter ()
        {
            RGraph.Clear(obj.canvas);
            obj.Draw();
        
            for (var dataset=0; dataset<original_data.length; ++dataset) {
                for (var i=0; i<original_data[dataset].length; ++i) {
                    obj.original_data[dataset][i] += obj.__increments__[dataset][i];
                }
            }

            if (--numFrames > 0) {
                RGraph.Effects.UpdateCanvas(UnfoldFromCenter);
            } else {
                obj.original_data = RGraph.array_clone(original_data);
                obj.__increments__ = null;
                obj.Set(''chart.shadow.blur'', original_blur);
                RGraph.Clear(obj.canvas);
                obj.Draw();
                
                if (typeof(callback) == ''function'') {
                    callback(obj);
                }
            }
        }
        
        UnfoldFromCenter();
    }


    /**
    * FoldToCenter
    * 
    * Line chart  FoldTocenter
    */
    RGraph.Effects.Line.FoldToCenter = function (obj)
    {
        var totalFrames = 30;
        var numFrame    = totalFrames;
        obj.Draw();
        var center_value = obj.scale[4] / 2;
        obj.Set(''chart.ymax'', Number(obj.scale[4]));
        RGraph.Clear(obj.canvas);
        var original_data = RGraph.array_clone(obj.original_data);
        obj.Set(''chart.shadow.blur'', 0);
        var callback = arguments[2];
        
        function FoldToCenter ()
        {
            for (var i=0; i<obj.data.length; ++i) {
                if (obj.data[i].length) {
                    for (var j=0; j<obj.data[i].length; ++j) {
                        if (obj.original_data[i][j] > center_value) {
                            obj.original_data[i][j] = ((original_data[i][j] - center_value) * (numFrame/totalFrames)) + center_value;
                        } else {
                            obj.original_data[i][j] = center_value - ((center_value - original_data[i][j]) * (numFrame/totalFrames));
                        }
                    }
                }
            }
            
            RGraph.Clear(obj.canvas);
            obj.Draw();

            if (numFrame-- > 0) {
                RGraph.Effects.UpdateCanvas(FoldToCenter);
            } else if (typeof(callback) == ''function'') {
                callback(obj);
            }
        }

        RGraph.Effects.UpdateCanvas(FoldToCenter);
    }


    /**
    * Odo Grow
    * 
    * This effect gradually increases the represented value
    * 
    * @param object   obj The chart object
    * @param              Not used - pass null
    * @param function     An optional callback function
    */
    RGraph.Effects.Odo.Grow = function (obj)
    {
        var numFrames = 30;
        var origValue = Number(obj.currentValue);
        var newValue  = obj.value;
        var diff      = newValue - origValue;
        var step      = (diff / numFrames);
        var callback  = arguments[2];

        function Grow_inner ()
        {
            if (obj.currentValue !!= newValue) {
                obj.value = Number(obj.currentValue) + step;
            }


            RGraph.Clear(obj.canvas);
            obj.Draw();

            if (numFrames-- > 0) {
                RGraph.Effects.UpdateCanvas(Grow_inner);
            } else if (callback) {
                callback(obj);
            }
        }
        
        //setTimeout(Grow, 100);
        RGraph.Effects.UpdateCanvas(Grow_inner);
    }


    /**
    * Meter Grow
    * 
    * This effect gradually increases the represented value
    * 
    * @param object   obj The chart object
    * @param              Not used - pass null
    * @param function     An optional callback function
    */
    RGraph.Effects.Meter.Grow = function (obj)
    {
        if (!!obj.currentValue) {
            obj.currentValue = obj.min;
        }

        var totalFrames = 60;
        var numFrame    = 0;
        var diff        = obj.value - obj.currentValue;
        var step        = diff / totalFrames
        var callback    = arguments[2];

        function Grow_meter_inner ()
        {
            obj.value = obj.currentValue + step;

            RGraph.Clear(obj.canvas);
            obj.Draw();
        
            if (numFrame++ < totalFrames) {
                RGraph.Effects.UpdateCanvas(Grow_meter_inner);
            } else if (typeof(callback) == ''function'') {
                callback(obj);
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow_meter_inner);
    }


    /**
    * Grow
    * 
    * The HBar chart Grow effect gradually increases the values of the bars
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.HBar.Grow = function (obj)
    {
        // Save the data
        obj.original_data = RGraph.array_clone(obj.data);
        
        // Zero the data
        obj.__animation_frame__ = 0;

        // Stop the scale from changing by setting chart.ymax (if it''s not already set)
        if (obj.Get(''chart.xmax'') == 0) {

            var xmax = 0;

            for (var i=0; i<obj.data.length; ++i) {
                if (RGraph.is_array(obj.data[i]) && obj.Get(''chart.grouping'') == ''stacked'') {
                    xmax = Math.max(xmax, RGraph.array_sum(obj.data[i]));
                } else if (RGraph.is_array(obj.data[i]) && obj.Get(''chart.grouping'') == ''grouped'') {
                    xmax = Math.max(xmax, RGraph.array_max(obj.data[i]));
                } else {
                    xmax = Math.max(xmax, RGraph.array_max(obj.data[i]));
                }
            }

            xmax = RGraph.getScale(xmax)[4];
            
            obj.Set(''chart.xmax'', xmax);
        }
        
        /**
        * Turn off shadow blur for the duration of the animation
        */
        if (obj.Get(''chart.shadow.blur'') > 0) {
            var __original_shadow_blur__ = obj.Get(''chart.shadow.blur'');
            obj.Set(''chart.shadow.blur'', 0);
        }

        function Grow ()
        {
            var numFrames = 30;

            if (!!obj.__animation_frame__) {
                obj.__animation_frame__  = 0;
                obj.__original_vmargin__ = obj.Get(''chart.vmargin'');
                obj.__vmargin__          = ((obj.canvas.height - obj.Get(''chart.gutter.top'') - obj.Get(''chart.gutter.bottom'')) / obj.data.length) / 2;
                obj.Set(''chart.vmargin'', obj.__vmargin__);
            }

            // Alter the Bar chart data depending on the frame
            for (var j=0; j<obj.original_data.length; ++j) {
                
                // This stops the animatioon from being completely linear
                var easing = Math.pow(Math.sin((obj.__animation_frame__ * (90 / numFrames)) / (180 / Math.PI)), 4);

                if (typeof(obj.data[j]) == ''object'') {
                    for (var k=0; k<obj.data[j].length; ++k) {
                        obj.data[j][k] = (obj.__animation_frame__ / numFrames) * obj.original_data[j][k] * easing;
                    }
                } else {
                    obj.data[j] = (obj.__animation_frame__ / numFrames) * obj.original_data[j] * easing;
                }
            }

            /**
            * Increment the vmargin to the target
            */
            obj.Set(''chart.vmargin'', ((1 - (obj.__animation_frame__ / numFrames)) * (obj.__vmargin__ - obj.__original_vmargin__)) + obj.__original_vmargin__);


            RGraph.Clear(obj.canvas);
            obj.Draw();

            if (obj.__animation_frame__ < numFrames) {
                obj.__animation_frame__ += 1;
                
                RGraph.Effects.UpdateCanvas(Grow);
            
            // Turn any shadow blur back on
            } else {
                if (typeof(__original_shadow_blur__) == ''number'' && __original_shadow_blur__ > 0) {
                    obj.Set(''chart.shadow.blur'', __original_shadow_blur__);
                    RGraph.Clear(obj.canvas);
                    obj.Draw();
                }
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow);
    }


    /**
    * Trace
    * 
    * This effect is for the Line chart, uses the jQuery library and slowly
    * uncovers the Line , but you can see the background of the chart. This effect
    * is quite new (1/10/2011) and as such should be used with caution.
    * 
    * @param object obj The graph object
    * @param object     Not used
    * @param int        A number denoting how long (in millseconds) the animation should last for. Defauld
    *                   is 1500
    */
    RGraph.Effects.Line.jQuery.Trace = function (obj)
    {
        RGraph.Clear(obj.canvas);
        obj.Draw();

        /**
        * Create the DIV that the second canvas will sit in
        */
        var div = document.createElement(''DIV'');
        var xy = RGraph.getCanvasXY(obj.canvas);
        div.id = ''__rgraph_trace_animation_'' + RGraph.random(0, 4351623) + ''__'';
        div.style.left = xy[0] + ''px'';
        div.style.top = xy[1] + ''px'';
        div.style.width = obj.Get(''chart.gutter.left'');
        div.style.height = obj.canvas.height + ''px'';
        div.style.position = ''absolute'';
        div.style.overflow = ''hidden'';
        document.body.appendChild(div);
        
        /**
        * Make the second canvas
        */
        var id      = ''__rgraph_line_reveal_animation_'' + RGraph.random(0, 99999999) + ''__'';
        var canvas2 = document.createElement(''CANVAS'');
        canvas2.width = obj.canvas.width;
        canvas2.height = obj.canvas.height;
        canvas2.style.position = ''absolute'';
        canvas2.style.left = 0;
        canvas2.style.top  = 0;

        canvas2.id         = id;
        div.appendChild(canvas2);
        
        var reposition_canvas2 = function (e)
        {
            var xy = RGraph.getCanvasXY(obj.canvas);
            
            div.style.left = xy[0] + ''px'';
            div.style.top = xy[1] + ''px'';
        }
        window.addEventListener(''resize'', reposition_canvas2, false)
        
        /**
        * Make a copy of the original Line object
        */
        var obj2 = new RGraph.Line(id, RGraph.array_clone(obj.original_data));

        for (i in obj.properties) {
            if (typeof(i) == ''string'') {
                obj2.Set(i, obj.properties[i]);
            }
        }

        obj2.Set(''chart.labels'', []);
        obj2.Set(''chart.background.grid'', false);
        obj2.Set(''chart.ylabels'', false);
        obj2.Set(''chart.noaxes'', true);
        obj2.Set(''chart.title'', '''');
        obj2.Set(''chart.title.xaxis'', '''');
        obj2.Set(''chart.title.yaxis'', '''');
        obj2.Set(''chart.filled.accumulative'', obj.Get(''chart.filled.accumulative''));
        obj.Set(''chart.key'', []);

        obj2.Draw();

        /**
        * This effectively hides the line
        */
        obj.Set(''chart.line.visible'', false);
        obj.Set(''chart.colors'', [''rgba(0,0,0,0)'']);
        if (obj.Get(''chart.filled'')) {
            var original_fillstyle = obj.Get(''chart.fillstyle'');
            obj.Set(''chart.fillstyle'', ''rgba(0,0,0,0)'');
        }

        RGraph.Clear(obj.canvas);
        obj.Draw();

        $(''#'' + div.id).animate({
            width: obj.canvas.width + ''px''
        }, arguments[2] ? arguments[2] : 1500, RGraph.Effects.Line.Trace_callback);


        /**
        * Get rid of the second canvas and turn the line back on
        * on the original.
        */
        RGraph.Effects.Line.Trace_callback = function ()
        {
            // Remove the window resize listener
            window.removeEventListener(''resize'', reposition_canvas2, false);

            div.parentNode.removeChild(div);
            div.removeChild(canvas2);
            obj.Set(''chart.line.visible'', true);
            
            // Revert the filled status back to as it was
            obj.Set(''chart.filled'', RGraph.array_clone(obj2.Get(''chart.filled'')));
            obj.Set(''chart.fillstyle'', original_fillstyle);
            obj.Set(''chart.colors'', RGraph.array_clone(obj2.Get(''chart.colors'')));
            obj.Set(''chart.key'', RGraph.array_clone(obj2.Get(''chart.key'')));

            RGraph.Clear(obj.canvas);
            obj.Draw();
        }
    }



    /**
    * RoundRobin
    * 
    * This effect does two things:
    *  1. Gradually increases the size of each segment
    *  2. Gradually increases the size of the radius from 0
    * 
    * @param object obj The graph object
    */
    RGraph.Effects.Pie.RoundRobin = function (obj)
    {
        var callback     = arguments[2] ? arguments[2] : null;
        var opt          = arguments[1];
        var currentFrame = 0;
        var numFrames    = 90;
        var targetRadius =  typeof(obj.Get(''chart.radius'')) == ''number'' ? obj.Get(''chart.radius'') : obj.getRadius();

        function RoundRobin_inner ()
        {
            obj.Set(''chart.effect.roundrobin.multiplier'', Math.pow(Math.sin((currentFrame * (90 / numFrames)) / (180 / Math.PI)), 2) * (currentFrame / numFrames) );

            if (!!opt || opt[''radius'']) {
                obj.Set(''chart.radius'', targetRadius * obj.Get(''chart.effect.roundrobin.multiplier''));
            }
            
            RGraph.Clear(obj.canvas)
            obj.Draw();

            if (currentFrame++ < numFrames) {
                RGraph.Effects.UpdateCanvas(RoundRobin_inner);
            
            } else if (callback) {
                callback(obj);
            }
        }

        RGraph.Effects.UpdateCanvas(RoundRobin_inner);
    }


    /**
    * Implode (pie chart)
    * 
    * Here the segments are initially exploded - and gradually
    * contract inwards to create the Pie chart
    * 
    * @param object obj The Pie chart object
    */
    RGraph.Effects.Pie.Implode = function (obj)
    {
        var numFrames = 90;
        var distance = Math.min(obj.canvas.width, obj.canvas.height);
        
        function Implode_inner ()
        {
            obj.Set(''chart.exploded'', Math.sin(numFrames / 57.3) * distance);
            RGraph.Clear(obj.canvas)
            obj.Draw();

            if (numFrames > 0) {
                numFrames--;
                RGraph.Effects.UpdateCanvas(Implode_inner);
            } else {
                // Finish off the animation
                obj.Set(''chart.exploded'', 0);
                RGraph.Clear(obj.canvas);
                obj.Draw();
            }
        }
        
        RGraph.Effects.UpdateCanvas(Implode_inner);
    }


    /**
    * Gauge Grow
    * 
    * This effect gradually increases the represented value
    * 
    * @param object   obj The chart object
    * @param              Not used - pass null
    * @param function     An optional callback function
    */
    RGraph.Effects.Gauge.Grow = function (obj)
    {
        var numFrames = 30;
        var origValue = Number(obj.currentValue);
        
        if (obj.currentValue == null) {
            obj.currentValue = obj.min;
            origValue = obj.min;
        }

        var newValue  = obj.value;
        var diff      = newValue - origValue;
        var step      = (diff / numFrames);


        function Grow ()
        {
            if (obj.currentValue !!= newValue) {
                obj.value = Number(obj.currentValue) + step;
            }
    
            if (obj.value > obj.max) {
                obj.value = obj.max;
            }
    
            if (obj.value < obj.min) {
                obj.value = obj.min;
            }

            RGraph.Clear(obj.canvas);
            obj.Draw();

            if (numFrames-- > 0) {
                //setTimeout(Grow, 100);
                RGraph.Effects.UpdateCanvas(Grow);
            }
        }
        
        //setTimeout(Grow, 100);
        RGraph.Effects.UpdateCanvas(Grow);
    }


    /**
    * Radar chart grow
    * 
    * This effect gradually increases the magnitude of the points on the radar chart
    * 
    * @param object obj The chart object
    * @param null       Not used
    * @param function   An optional callback that is run when the effect is finished
    */
    RGraph.Effects.Radar.Grow = function (obj)
    {
        var totalframes   = 30;
        var framenum      = totalframes;
        var data          = RGraph.array_clone(obj.data);
        var callback      = arguments[2];
        obj.original_data = RGraph.array_clone(obj.original_data);

        function Grow_inner ()
        {
            for (var i=0; i<data.length; ++i) {
                
                if (obj.original_data[i] == null) {
                    obj.original_data[i] = [];
                }

                for (var j=0; j<data[i].length; ++j) {
                    obj.original_data[i][j] = ((totalframes - framenum)/totalframes)  * data[i][j];
                }
            }

            RGraph.Clear(obj.canvas);
            obj.Draw();

            if (framenum > 0) {
                framenum--;
                RGraph.Effects.UpdateCanvas(Grow_inner);
            } else if (typeof(callback) == ''function'') {
                callback(obj);
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow_inner);
    }


    /**
    * Waterfall Grow
    * 
    * @param object obj The chart object
    * @param null Not used
    * @param function An optional function which is called when the animation is finished
    */
    RGraph.Effects.Waterfall.Grow = function (obj)
    {
        var totalFrames = 45;
        var numFrame    = 0;
        var data = RGraph.array_clone(obj.data);
        var callback = arguments[2];
        
        //Reset The data to zeros
        for (var i=0; i<obj.data.length; ++i) {
            obj.data[i] /= totalFrames;
            
        }
        
        /**
        * Fix the scale
        */
        if (obj.Get(''chart.ymax'') == null) {
            var max = RGraph.getScale(obj.getMax(data))[4]
            obj.Set(''chart.ymax'', max);
        }
        
        obj.Set(''chart.multiplier.x'', 0);
        obj.Set(''chart.multiplier.w'', 0);

        function Grow_inner ()
        {
            for (var i=0; i<obj.data.length; ++i) {
                obj.data[i] = data[i] * (numFrame/totalFrames);
            }
            
            var multiplier = Math.pow(Math.sin(((numFrame / totalFrames) * 90) / 57.3), 20);
            obj.Set(''chart.multiplier.x'', (numFrame / totalFrames) * multiplier);
            obj.Set(''chart.multiplier.w'', (numFrame / totalFrames) * multiplier);
            
            RGraph.Clear(obj.canvas);
            obj.Draw();

            if (numFrame++ < totalFrames) {
                RGraph.Effects.UpdateCanvas(Grow_inner);
            } else if (typeof(callback) == ''function'') {
                callback(obj);
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow_inner)
    }



    /**
    * Bar chart Wave effect
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.Bar.Wave = function (obj)
    {
        var callback = arguments[2] ? arguments[2] : null;

        var max = 0;
        for (var i=0; i<obj.data.length; ++i) {
            if (typeof(obj.data[i]) == ''number'') {
                max = Math.max(max, obj.data[i])
            } else {
                if (obj.Get(''chart.grouping'') == ''stacked'') {
                    max = Math.max(max, RGraph.array_sum(obj.data[i]))
                } else {
                    max = Math.max(max, RGraph.array_max(obj.data[i]))
                }
            }
        }
        var scale = RGraph.getScale(max);
        obj.Set(''chart.ymax'', scale[4]);
        
        original_bar_data = RGraph.array_clone(obj.data);
        __rgraph_bar_wave_object__ = obj;
    
        // Zero all the bars
        for (var i=0; i<obj.data.length; ++i) {
             if (typeof(obj.data[i]) == ''number'') {
                obj.data[i] = 0;
             } else {
                obj.data[i] = new Array(obj.data[i].length);
             }
             
             var totalFrames = 25;
             var delay       = 25;
             
            setTimeout(''RGraph.Effects.Bar.Wave_inner('' + i + '', '' + totalFrames + '', '' + delay + '')'', i * 150);
        }
    
        RGraph.Effects.Bar.Wave_inner = function  (idx, totalFrames, delay)
        {
            // Touch this at your peril...!!
            for (var k=0; k<=totalFrames; ++k) {
                setTimeout(''RGraph.Effects.Bar.Wave_inner_iterator(__rgraph_bar_wave_object__, ''+idx+'', ''+(k / totalFrames)+'');'', delay * k);
            }
        }
        
        setTimeout(callback, (i * 150) + (totalFrames * delay), totalFrames, delay);
    }
    
    
    RGraph.Effects.Bar.Wave_inner_iterator = function (obj, idx, factor)
    {
        if (typeof(obj.data[idx]) == ''number'') {
            obj.data[idx] = original_bar_data[idx] * factor;
        } else {
            for (var i=0; i<obj.data[idx].length; ++i) {
                obj.data[idx][i] = factor * original_bar_data[idx][i];
            }
        }
        
        RGraph.Clear(obj.canvas);
        obj.Draw();
    }


    /**
    * HProgress Grow effect
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.HProgress.Grow = function (obj)
    {
        var canvas       = obj.canvas;
        var context      = obj.context;
        var diff         = obj.value - Number(obj.currentValue);
        var numFrames    = 30;
        var currentFrame = 0
        var increment    = diff  / numFrames;
        var callback     = arguments[2] ? arguments[2] : null;

        function Grow_hprogress_inner ()
        {
            if (currentFrame++ < 30) {
                obj.value = obj.currentValue + increment;
                RGraph.Clear(obj.canvas);
                obj.Draw();
                
                RGraph.Effects.UpdateCanvas(Grow_hprogress_inner);

            } else if (callback) {
                callback(obj);
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow_hprogress_inner);
    }


    /**
    * VProgress Grow effect
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.VProgress.Grow = function (obj)
    {
        var canvas       = obj.canvas;
        var context      = obj.context;
        var diff         = obj.value - Number(obj.currentValue);
        var numFrames    = 30;
        var currentFrame = 0
        var increment    = diff  / numFrames;
        var callback     = arguments[2] ? arguments[2] : null;

        function Grow_vprogress_inner ()
        {
            if (currentFrame++ < 30) {
                obj.value = obj.currentValue + increment;
                RGraph.Clear(obj.canvas);
                obj.Draw();
                
                RGraph.Effects.UpdateCanvas(Grow_vprogress_inner);

            } else if (callback) {
                callback(obj);
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow_vprogress_inner);
    }


    /**
    * Pie chart Wave
    * 
    * This is the Pie chart version of the Wave effect.
    * 
    * @param object obj The chart object
    */        
    RGraph.Effects.Pie.Wave = function (obj)
    {
        /**
        * Zero all the data and set the max value
        */
        var max = RGraph.array_max(obj.data);
        var scale = RGraph.getScale(max);
        obj.Set(''chart.ymax'', scale[4]);

        original_pie_data = RGraph.array_clone(obj.data);
        __rgraph_pie_wave_object__ = obj;

        // Zero all the bars
        for (var i=0; i<obj.data.length; ++i) {
            obj.data[i] = 0;
            setTimeout(''RGraph.Effects.Pie.Wave_inner('' + i + '')'', i * 100);
        }

        RGraph.Effects.Pie.Wave_inner = function  (idx)
        {
            var totalFrames = 25;

            // Touch this at your peril...!!
            for (var k=0; k<=totalFrames; ++k) {
                setTimeout(''RGraph.Effects.Pie.Wave_inner_iterator(__rgraph_pie_wave_object__, ''+idx+'', ''+(k / totalFrames)+'');'', 20 * k);
            }
        }
    }

    RGraph.Effects.Pie.Wave_inner_iterator = function (obj, idx, factor)
    {
        obj.data[idx] = original_pie_data[idx] * factor;
        
        RGraph.Clear(obj.canvas);
        obj.Draw();
    }


    /**
    * Bar chart Wave2 effect - using the requestAnimationFrame function
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.Bar.Wave2 = function (obj)
    {
        var callback = arguments[2] ? arguments[2] : null;
    
        var max = 0;
        for (var i=0; i<obj.data.length; ++i) {
            if (typeof(obj.data[i]) == ''number'') {
                max = Math.max(max, obj.data[i])
            } else {
                if (obj.Get(''chart.grouping'') == ''stacked'') {
                    max = Math.max(max, RGraph.array_sum(obj.data[i]))
                } else {
                    max = Math.max(max, RGraph.array_max(obj.data[i]))
                }
            }
        }
        var scale = RGraph.getScale(max);
        obj.Set(''chart.ymax'', scale[4]);
        
        original_bar_data = RGraph.array_clone(obj.data);
        __rgraph_bar_wave_object__ = obj;
    
        /**
        * Zero all the bars
        */
        for (var i=0; i<obj.data.length; ++i) {
             if (typeof(obj.data[i]) == ''number'') {
                obj.data[i] = 0;
             } else {
                obj.data[i] = new Array(obj.data[i].length);
             }
             
            setTimeout(''a = new RGraph.Effects.Bar.Wave2.Iterator(__rgraph_bar_wave_object__, '' + i + '', 45); a.Animate();'', i * 150);
        }
    }

    
    /**
    * The Iterator object that handles the individual animation frames
    */
    RGraph.Effects.Bar.Wave2.Iterator = function (obj, idx, frames)
    {
        this.obj    = obj;
        this.idx    = idx;
        this.frames = frames;
        this.curFrame = 0;
    }

    RGraph.Effects.Bar.Wave2.Iterator.prototype.Animate = function ()
    {
        if (typeof(this.obj.data[this.idx]) == ''number'') {
            this.obj.data[this.idx] = (this.curFrame / this.frames) * original_bar_data[this.idx];
        } else if (typeof(this.obj.data[this.idx]) == ''object'') {
            for (var j=0; j<this.obj.data[this.idx].length; ++j) {
                this.obj.data[this.idx][j] = (this.curFrame / this.frames) * original_bar_data[this.idx][j];
            }
        }
    
        RGraph.Clear(this.obj.canvas);
        this.obj.Draw();
        
        if (this.curFrame < this.frames) {
            
            this.curFrame += 1;
    
            RGraph.Effects.UpdateCanvas(this.Animate.bind(this));
        }
    }


    /**
    * Gantt chart Grow effect
    * 
    * @param object obj The chart object
    */
    RGraph.Effects.Gantt.Grow = function (obj)
    {
        var canvas       = obj.canvas;
        var context      = obj.context;
        var numFrames    = 30;
        var currentFrame = 0
        var callback     = arguments[2] ? arguments[2] : null;
        var events       = obj.Get(''chart.events'');
        
        var original_events = RGraph.array_clone(events);

        function Grow_gantt_inner ()
        {
            if (currentFrame < numFrames) {
                // Update the events
                for (var i=0; i<events.length; ++i) {
                    if (typeof(events[i][0]) == ''object'') {
                        for (var j=0; j<events[i].length; ++j) {
                            events[i][j][1] = (currentFrame / numFrames) * original_events[i][j][1];
                        }
                    } else {

                        events[i][1] = (currentFrame / numFrames) * original_events[i][1];
                    }
                }

                obj.Set(''chart.events'', events);

                RGraph.Clear(obj.canvas);
                obj.Draw();
                
                currentFrame++;
                
                RGraph.Effects.UpdateCanvas(Grow_gantt_inner);

            } else if (callback) {            
                callback(obj);
            }
        }
        
        RGraph.Effects.UpdateCanvas(Grow_gantt_inner);
    }


    /**
    * This is a compatibility hack provided for Opera and Safari which
    * don''t support ther Javascript 1.8.5 function.bind()
    */
    if (!!Function.prototype.bind) {  
      Function.prototype.bind = function (oThis) {  
        if (typeof this !!== "function") {  
          // closest thing possible to the ECMAScript 5 internal IsCallable function  
          throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");  
        }  
      
        var aArgs = Array.prototype.slice.call(arguments, 1),   
            fToBind = this,   
            fNOP = function () {},  
            fBound = function () {  
              return fToBind.apply(this instanceof fNOP  
                                     ? this  
                                     : oThis || window,  
                                   aArgs.concat(Array.prototype.slice.call(arguments)));  
            };  
      
        fNOP.prototype = this.prototype;  
        fBound.prototype = new fNOP();  
      
        return fBound;  
      };  
    }


    /**
    * Rose chart explode
    * 
    * Explodes the Rose chart - gradually incrementing the size of the chart.explode property
    * 
    * @params object obj The graph object
    */
    RGraph.Effects.Rose.Explode = function (obj)
    {
        var canvas   = obj.canvas;
        var opts     = arguments[1] ? arguments[1] : [];
        var callback = arguments[2] ? arguments[2] : null;
        var frames   = opts[''frames''] ? opts[''frames''] : 60;

        obj.Set(''chart.exploded'', 0);

        RGraph.Effects.Animate(obj, {''frames'': frames, ''chart.exploded'': Math.min(canvas.width, canvas.height)}, callback);
    }


    /**
    * Rose chart implode
    * 
    * Implodes the Rose chart - gradually decreasing the size of the chart.explode property. It starts at the largest of
    * the canvas width./height
    * 
    * @params object obj The graph object
    */
    RGraph.Effects.Rose.Implode = function (obj)
    {
        var canvas   = obj.canvas;
        var opts     = arguments[1] ? arguments[1] : [];
        var callback = arguments[2] ? arguments[2] : null;
        var frames   = opts[''frames''] ? opts[''frames''] : 60;

        obj.Set(''chart.exploded'', Math.min(canvas.width, canvas.height));

        RGraph.Effects.Animate(obj, {''frames'': frames, ''chart.exploded'': 0}, callback);
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:30'!
RGraphcommonresizingJs
	^ '    /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */

    if (typeof(RGraph) == ''undefined'') RGraph = {isRGraph:true,type:''common''};


    /**
    * This is an array of CSS properties that should be preserved when adding theplaceholder DIV
    */
    __rgraph_resizing_preserve_css_properties__ = [];

    /**
    * This function can be used to allow resizing
    * 
    * @param object obj Your graph object
    */
    RGraph.AllowResizing = function (obj)
    {
        if (obj.Get(''chart.resizable'')) {
            var canvas  = obj.canvas;
            var context = obj.context;
            var resizeHandle = 15;
            RGraph.Resizing.canvas = canvas;
            RGraph.Resizing.placeHolders = [];
            
            /**
            * Add the original width and height to the canvas
            */
            if (!!canvas.__original_width__ && !!canvas.__original_height__) {
                canvas.__original_width__  = canvas.width;
                canvas.__original_height__ = canvas.height;
            }


            var adjustX = (typeof(obj.Get(''chart.resize.handle.adjust'')) == ''object'' && typeof(obj.Get(''chart.resize.handle.adjust'')[0]) == ''number'' ? obj.Get(''chart.resize.handle.adjust'')[0] : 0);
            var adjustY = (typeof(obj.Get(''chart.resize.handle.adjust'')) == ''object'' && typeof(obj.Get(''chart.resize.handle.adjust'')[1]) == ''number'' ? obj.Get(''chart.resize.handle.adjust'')[1] : 0);


            /**
            * Draw the resize handle
            */
            var textWidth = context.measureText(''Reset'').width + 2;


            // Draw the white background for the resize handle - OPTIONAL default is rgba(0,0,0,0);
            var bgcolor = obj.Get(''chart.resize.handle.background'');
            
            if (!!bgcolor) {
                bgcolor = ''rgba(0,0,0,0)'';
            }

            context.beginPath();
                context.fillStyle = bgcolor;
                context.moveTo(canvas.width - resizeHandle - resizeHandle + adjustX, canvas.height - resizeHandle);
                context.fillRect(canvas.width - resizeHandle - resizeHandle + adjustX, canvas.height - resizeHandle + adjustY, 2 * resizeHandle, resizeHandle);
            context.fill();


            obj.context.beginPath();
                obj.context.strokeStyle = ''gray'';
                obj.context.fillStyle = ''rgba(0,0,0,0)'';
                obj.context.lineWidth = 1;
                obj.context.fillRect(obj.canvas.width - resizeHandle + adjustX, obj.canvas.height - resizeHandle - 2 + adjustY, resizeHandle, resizeHandle + 2);
                obj.context.fillRect(obj.canvas.width - resizeHandle - textWidth + adjustX, obj.canvas.height - resizeHandle + adjustY, resizeHandle + textWidth, resizeHandle + 2);


                // Draw the arrows
                
                    // Vertical line
                    obj.context.moveTo(AA(this, obj.canvas.width - (resizeHandle / 2) + adjustX), obj.canvas.height - resizeHandle + adjustY);
                    obj.context.lineTo(AA(this, obj.canvas.width - (resizeHandle / 2) + adjustX), obj.canvas.height + adjustY);


                    // Horizontal line
                    obj.context.moveTo(obj.canvas.width + adjustX, AA(this, obj.canvas.height - (resizeHandle / 2) + adjustY));
                    obj.context.lineTo(obj.canvas.width - resizeHandle + adjustX, AA(this, obj.canvas.height - (resizeHandle / 2) + adjustY));
                
            context.fill();
            context.stroke();


            // Top arrow head
            context.fillStyle = ''gray'';
            context.beginPath();
                context.moveTo(canvas.width - (resizeHandle / 2) + adjustX, canvas.height - resizeHandle + adjustY);
                context.lineTo(canvas.width - (resizeHandle / 2) + 3 + adjustX, canvas.height - resizeHandle + 3 + adjustY);
                context.lineTo(canvas.width - (resizeHandle / 2) - 3 + adjustX, canvas.height - resizeHandle + 3 + adjustY);
            context.closePath();
            context.fill();

            // Bottom arrow head
            context.beginPath();
                context.moveTo(canvas.width - (resizeHandle / 2) + adjustX, canvas.height + adjustY);
                context.lineTo(canvas.width - (resizeHandle / 2) + 3 + adjustX, canvas.height - 3 + adjustY);
                context.lineTo(canvas.width - (resizeHandle / 2) - 3 + adjustX, canvas.height - 3 + adjustY);
            context.closePath();
            context.fill();

            // Left arrow head
            context.beginPath();
                context.moveTo(canvas.width - resizeHandle + adjustX, canvas.height - (resizeHandle / 2) + adjustY);
                context.lineTo(canvas.width - resizeHandle + 3 + adjustX, canvas.height - (resizeHandle / 2) + 3 + adjustY);
                context.lineTo(canvas.width - resizeHandle + 3 + adjustX, canvas.height - (resizeHandle / 2) - 3 + adjustY);
            context.closePath();
            context.fill();

            // Right arrow head
            context.beginPath();
                context.moveTo(canvas.width + adjustX, canvas.height - (resizeHandle / 2) + adjustY);
                context.lineTo(canvas.width - 3 + adjustX, canvas.height - (resizeHandle / 2) + 3 + adjustY);
                context.lineTo(canvas.width  - 3 + adjustX, canvas.height - (resizeHandle / 2) - 3 + adjustY);
            context.closePath();
            context.fill();
            
            // Square at the centre of the arrows
            context.beginPath();
                context.fillStyle = ''white'';
                context.moveTo(canvas.width + adjustX, canvas.height - (resizeHandle / 2) + adjustY);
                context.strokeRect(canvas.width - (resizeHandle / 2) - 2 + adjustX, canvas.height - (resizeHandle / 2) - 2 + adjustY, 4, 4);
                context.fillRect(canvas.width - (resizeHandle / 2) - 2 + adjustX, canvas.height - (resizeHandle / 2) - 2 + adjustY, 4, 4);
            context.stroke();
            context.fill();


            // Draw the "Reset" button
            context.beginPath();
                context.fillStyle = ''gray'';
                context.moveTo(AA(this, canvas.width - resizeHandle - 3 + adjustX), canvas.height - resizeHandle / 2 + adjustY);
                context.lineTo(AA(this, canvas.width - resizeHandle - resizeHandle + adjustX), canvas.height - (resizeHandle / 2) + adjustY);
                context.lineTo(canvas.width - resizeHandle - resizeHandle + 2 + adjustX, canvas.height - (resizeHandle / 2) - 2 + adjustY);
                context.lineTo(canvas.width - resizeHandle - resizeHandle + 2 + adjustX, canvas.height - (resizeHandle / 2) + 2 + adjustY);
                context.lineTo(canvas.width - resizeHandle - resizeHandle + adjustX, canvas.height - (resizeHandle / 2) + adjustY);
            context.stroke();
            context.fill();

            context.beginPath();
                context.moveTo(AA(this, canvas.width - resizeHandle - resizeHandle - 1 + adjustX), canvas.height - (resizeHandle / 2) - 3 + adjustY);
                context.lineTo(AA(this, canvas.width - resizeHandle - resizeHandle - 1 + adjustX), canvas.height - (resizeHandle / 2) + 3 + adjustY);
            context.stroke();
            context.fill();
            


            var window_onmousemove = function (e)
            {
                e = RGraph.FixEventObject(e);
                
                var canvas    = RGraph.Resizing.canvas;
                var newWidth  = RGraph.Resizing.originalw - (RGraph.Resizing.originalx - e.pageX);// - 5
                var newHeight = RGraph.Resizing.originalh - (RGraph.Resizing.originaly - e.pageY);// - 5

                if (RGraph.Resizing.mousedown) {
                    if (newWidth > (canvas.__original_width__ / 2)) RGraph.Resizing.div.style.width = newWidth + ''px'';
                    if (newHeight > (canvas.__original_height__ / 2)) RGraph.Resizing.div.style.height = newHeight + ''px'';
                    
                    RGraph.FireCustomEvent(canvas.__object__, ''onresize'');
                }
            }
            window.addEventListener(''mousemove'', window_onmousemove, false);
            RGraph.AddEventListener(canvas.id, ''window_mousemove'', window_onmousemove);

            /**
            * The window onmouseup function
            */
            var MouseupFunc = function (e)
            {
                if (!!RGraph.Resizing || !!RGraph.Resizing.div || !!RGraph.Resizing.mousedown) {
                    return;
                }

                if (RGraph.Resizing.div) {

                    var div    = RGraph.Resizing.div;
                    var canvas = div.__canvas__;
                    var coords = RGraph.getCanvasXY(div.__canvas__);

                    var parentNode = canvas.parentNode;

                    if (canvas.style.position !!= ''absolute'') {
                        // Create a DIV to go in the canvases place
                        var placeHolderDIV = document.createElement(''DIV'');
                            placeHolderDIV.style.width = RGraph.Resizing.originalw + ''px'';
                            placeHolderDIV.style.height = RGraph.Resizing.originalh + ''px'';
                            //placeHolderDIV.style.backgroundColor = ''red'';
                            placeHolderDIV.style.display = ''inline-block''; // Added 5th Nov 2010
                            placeHolderDIV.style.position = canvas.style.position;
                            placeHolderDIV.style.left     = canvas.style.left;
                            placeHolderDIV.style.top      = canvas.style.top;
                            placeHolderDIV.style.cssFloat = canvas.style.cssFloat;

                        parentNode.insertBefore(placeHolderDIV, canvas);
                    }


                    // Now set the canvas to be positioned absolutely
                    canvas.style.backgroundColor = ''white'';
                    canvas.style.position        = ''absolute'';
                    canvas.style.border = ''1px dashed gray'';
                    canvas.style.left            = (RGraph.Resizing.originalCanvasX  - 1) + ''px'';
                    canvas.style.top             = (RGraph.Resizing.originalCanvasY - 1) + ''px'';

                    canvas.width = parseInt(div.style.width);
                    canvas.height = parseInt(div.style.height);
                    
                

                    /**
                    * Fire the onresize event
                    */
                    RGraph.FireCustomEvent(canvas.__object__, ''onresizebeforedraw'');

                    canvas.__object__.Draw();

                    // Get rid of transparent semi-opaque DIV
                    RGraph.Resizing.mousedown = false;
                    div.style.display = ''none'';
                    document.body.removeChild(div);
                }

                /**
                * If there is zoom enabled in thumbnail mode, lose the zoom image
                */
                if (RGraph.Registry.Get(''chart.zoomed.div'') || RGraph.Registry.Get(''chart.zoomed.img'')) {
                    RGraph.Registry.Set(''chart.zoomed.div'', null);
                    RGraph.Registry.Set(''chart.zoomed.img'', null);
                }

                /**
                * Fire the onresize event
                */
                RGraph.FireCustomEvent(canvas.__object__, ''onresizeend'');
            }


            var window_onmouseup = MouseupFunc;
            window.addEventListener(''onmouseup'', window_onmouseup, false);
            RGraph.AddEventListener(canvas.id, ''window_mouseup'', window_onmouseup);


            var canvas_onmousemove = function (e)
            {
                e = RGraph.FixEventObject(e);
                
                var coords  = RGraph.getMouseXY(e);
                var obj     = e.target.__object__;
                var canvas  = e.target;
                var context = canvas.getContext(''2d'');
                var cursor  = canvas.style.cursor;

                // Save the original cursor
                if (!!RGraph.Resizing.original_cursor) {
                    RGraph.Resizing.original_cursor = cursor;
                }
                
                if (   (coords[0] > (canvas.width - resizeHandle)
                    && coords[0] < canvas.width
                    && coords[1] > (canvas.height - resizeHandle)
                    && coords[1] < canvas.height)) {
                        
                        canvas.style.cursor = ''move'';

                } else if (   coords[0] > (canvas.width - resizeHandle - resizeHandle)
                           && coords[0] < canvas.width - resizeHandle
                           && coords[1] > (canvas.height - resizeHandle)
                           && coords[1] < canvas.height) {
                    
                    canvas.style.cursor = ''pointer'';

                } else {
                    if (RGraph.Resizing.original_cursor) {
                        canvas.style.cursor = RGraph.Resizing.original_cursor;
                        RGraph.Resizing.original_cursor = null;
                    } else {
                        canvas.style.cursor = ''default'';
                    }
                }
            }
            canvas.addEventListener(''mousemove'', canvas_onmousemove, false);
            RGraph.AddEventListener(canvas.id, ''mousemove'', canvas_onmousemove);



            var canvas_onmouseout = function (e)
            {
                e.target.style.cursor = ''default'';
                e.target.title        = '''';
            }
            canvas.addEventListener(''mouseout'', canvas_onmouseout, false);
            RGraph.AddEventListener(canvas.id, ''mouseout'', canvas_onmouseout);



            var canvas_onmousedown = function (e)
            {
                e = RGraph.FixEventObject(e);

                var coords = RGraph.getMouseXY(e);
                var canvasCoords = RGraph.getCanvasXY(e.target);
                var canvas = e.target;

                if (   coords[0] > (obj.canvas.width - resizeHandle)
                    && coords[0] < obj.canvas.width
                    && coords[1] > (obj.canvas.height - resizeHandle)
                    && coords[1] < obj.canvas.height) {
                    
                    RGraph.FireCustomEvent(obj, ''onresizebegin'');
                    
                    // Save the existing border
                    if (canvas.__original_css_border__ == null) {
                        canvas.__original_css_border__ = canvas.style.border;
                    }

                    RGraph.Resizing.mousedown = true;


                    /**
                    * Create the semi-opaque DIV
                    */

                    var div = document.createElement(''DIV'');
                    div.style.position = ''absolute'';
                    div.style.left     = canvasCoords[0] + ''px'';
                    div.style.top      = canvasCoords[1] + ''px'';
                    div.style.width    = canvas.width + ''px'';
                    div.style.height   = canvas.height + ''px'';
                    div.style.border   = ''1px dotted black'';
                    div.style.backgroundColor = ''gray'';
                    div.style.opacity  = 0.5;
                    div.__canvas__ = e.target;

                    document.body.appendChild(div);
                    RGraph.Resizing.div = div;
                    RGraph.Resizing.placeHolders.push(div);
                    
                    // Hide the previous resize indicator layers. This is only necessary it seems for the Meter chart
                    for (var i=0; i<(RGraph.Resizing.placeHolders.length - 1); ++i) {
                        RGraph.Resizing.placeHolders[i].style.display = ''none'';
                    }

                    // This is a repetition of the window.onmouseup function (No need to use DOM2 here)
                    div.onmouseup = function (e)
                    {
                        MouseupFunc(e);
                    }

                    
                    // No need to use DOM2 here
                    RGraph.Resizing.div.onmouseover = function (e)
                    {
                        e = RGraph.FixEventObject(e);
                        e.stopPropagation();
                    }
    
                    // The mouse
                    RGraph.Resizing.originalx = e.pageX;
                    RGraph.Resizing.originaly = e.pageY;
                    
                    RGraph.Resizing.originalw = obj.canvas.width;
                    RGraph.Resizing.originalh = obj.canvas.height;
                    
                    RGraph.Resizing.originalCanvasX = RGraph.getCanvasXY(obj.canvas)[0];
                    RGraph.Resizing.originalCanvasY = RGraph.getCanvasXY(obj.canvas)[1];
                }


                /**
                * This facilitates the reset button
                */
                if (   coords[0] > (canvas.width - resizeHandle - resizeHandle)
                    && coords[0] < canvas.width - resizeHandle
                    && coords[1] > (canvas.height - resizeHandle)
                    && coords[1] < canvas.height) {
                    
                    /**
                    * Fire the onresizebegin event
                    */
                    RGraph.FireCustomEvent(canvas.__object__, ''onresizebegin'');

                    // Restore the original width and height
                    canvas.width = canvas.__original_width__;
                    canvas.height = canvas.__original_height__;

                    // Lose the border
                    canvas.style.border = canvas.__original_css_border__;
                    //canvas.__original_css_border__ = null;
                    
                    // Add 1 pixel to the top/left because the border is going
                    canvas.style.left = (parseInt(canvas.style.left)) + ''px'';
                    canvas.style.top  = (parseInt(canvas.style.top)) + ''px'';


                    RGraph.FireCustomEvent(canvas.__object__, ''onresizebeforedraw'');

                    // Redraw the canvas
                    canvas.__object__.Draw();
                    
                    // Set the width and height on the DIV
                    if (RGraph.Resizing.div) {
                        RGraph.Resizing.div.style.width  = canvas.__original_width__ + ''px'';
                        RGraph.Resizing.div.style.height = canvas.__original_height__ + ''px'';
                    }

                    /**
                    * Fire the resize event
                    */
                    RGraph.FireCustomEvent(canvas.__object__, ''onresize'');
                    RGraph.FireCustomEvent(canvas.__object__, ''onresizeend'');
                }
            }
            canvas.addEventListener(''mousedown'', canvas_onmousedown, false);
            RGraph.AddEventListener(canvas.id, ''mousedown'', canvas_onmousedown);


            /**
            * This function facilitates the reset button
            * 
            * NOTE: 31st December 2010 - doesn''t appear to be being used any more
            */

            /*
            canvas.onclick = function (e)
            {
                var coords = RGraph.getMouseXY(e);
                var canvas = e.target;

                if (   coords[0] > (canvas.width - resizeHandle - resizeHandle)
                    && coords[0] < canvas.width - resizeHandle
                    && coords[1] > (canvas.height - resizeHandle)
                    && coords[1] < canvas.height) {

                    // Restore the original width and height
                    canvas.width = canvas.__original_width__;
                    canvas.height = canvas.__original_height__;

                    // Lose the border
                    canvas.style.border = '''';
                    
                    // Add 1 pixel to the top/left because the border is going
                    canvas.style.left = (parseInt(canvas.style.left) + 1) + ''px'';
                    canvas.style.top  = (parseInt(canvas.style.top) + 1) + ''px'';
                    
                    // Fire the onresizebeforedraw event
                    RGraph.FireCustomEvent(canvas.__object__, ''onresizebeforedraw'');

                    // Redraw the canvas
                    canvas.__object__.Draw();
                    
                    // Set the width and height on the DIV
                    RGraph.Resizing.div.style.width  = canvas.__original_width__ + ''px'';
                    RGraph.Resizing.div.style.height = canvas.__original_height__ + ''px'';
                    
                    // Fire the resize event
                    RGraph.FireCustomEvent(canvas.__object__, ''onresize'');
                }
            }
            */
        }
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 3/25/2012 15:11'!
RGraphcommontooltipsJs
	^ '    /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */

    if (typeof(RGraph) == ''undefined'') RGraph = {isRGraph:true,type:''common''};
    
    /**
    * This is used in two functions, hence it''s here
    */
    RGraph.tooltips = {};
    RGraph.tooltips.padding   = ''3px'';
    RGraph.tooltips.font_face = ''Tahoma'';
    RGraph.tooltips.font_size = ''10pt'';


    /**
    * Shows a tooltip next to the mouse pointer
    * 
    * @param canvas object The canvas element object
    * @param text   string The tooltip text
    * @param int     x      The X position that the tooltip should appear at. Combined with the canvases offsetLeft
    *                       gives the absolute X position
    * @param int     y      The Y position the tooltip should appear at. Combined with the canvases offsetTop
    *                       gives the absolute Y position
    * @param int     idx    The index of the tooltip in the graph objects tooltip array
    */
    RGraph.Tooltip = function (canvas, text, x, y, idx)
    {
        /**
        * chart.tooltip.override allows you to totally take control of rendering the tooltip yourself
        */
        if (typeof(canvas.__object__.Get(''chart.tooltips.override'')) == ''function'') {
            return canvas.__object__.Get(''chart.tooltips.override'')(canvas, text, x, y, idx);
        }

        /**
        * This facilitates the "id:xxx" format
        */
        text = RGraph.getTooltipTextFromDIV(text);

        /**
        * First clear any exising timers
        */
        var timers = RGraph.Registry.Get(''chart.tooltip.timers'');

        if (timers && timers.length) {
            for (i=0; i<timers.length; ++i) {
                clearTimeout(timers[i]);
            }
        }
        RGraph.Registry.Set(''chart.tooltip.timers'', []);

        /**
        * Hide the context menu if it''s currently shown
        */
        if (canvas.__object__.Get(''chart.contextmenu'')) {
            RGraph.HideContext();
        }

        // Redraw the canvas?
        if (canvas.__object__.Get(''chart.tooltips.highlight'')) {
            RGraph.Redraw(canvas.id);
        }

        var effect = canvas.__object__.Get(''chart.tooltips.effect'').toLowerCase();

        if (effect == ''snap'' && RGraph.Registry.Get(''chart.tooltip'') && RGraph.Registry.Get(''chart.tooltip'').__canvas__.id == canvas.id) {

            if (   canvas.__object__.type == ''line''
                || canvas.__object__.type == ''radar''
                || canvas.__object__.type == ''scatter''
                || canvas.__object__.type == ''rscatter''
                ) {

                var tooltipObj = RGraph.Registry.Get(''chart.tooltip'');
                
        
                tooltipObj.style.width  = null;
                tooltipObj.style.height = null;
        
                tooltipObj.innerHTML = text;
                tooltipObj.__text__  = text;
        
                /**
                * Now that the new content has been set, re-set the width & height
                */
                RGraph.Registry.Get(''chart.tooltip'').style.width  = RGraph.getTooltipWidth(text, canvas.__object__) + ''px'';
                RGraph.Registry.Get(''chart.tooltip'').style.height = RGraph.Registry.Get(''chart.tooltip'').offsetHeight + ''px'';

                /**
                * Now (25th September 2011) use jQuery if it''s available
                */
                if (typeof(jQuery) == ''function'' && typeof($) == ''function'') {
                    $(''#'' + tooltipObj.id).animate({
                        opacity: 1,
                        width: tooltipObj.offsetWidth + ''px'',
                        height: tooltipObj.offsetHeight + ''px'',
                        left: x + ''px'',
                        top: (y - tooltipObj.offsetHeight) + ''px''
                    }, 300);
                } else {
                    var currentx = parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left);
                    var currenty = parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top);
                
                    var diffx = x - currentx - ((x + RGraph.Registry.Get(''chart.tooltip'').offsetWidth) > document.body.offsetWidth ? RGraph.Registry.Get(''chart.tooltip'').offsetWidth : 0);
                    var diffy = y - currenty - RGraph.Registry.Get(''chart.tooltip'').offsetHeight;
                
                    // Position the tooltip
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.left = "'' + (currentx + (diffx * 0.2)) + ''px"'', 25);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.left = "'' + (currentx + (diffx * 0.4)) + ''px"'', 50);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.left = "'' + (currentx + (diffx * 0.6)) + ''px"'', 75);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.left = "'' + (currentx + (diffx * 0.8)) + ''px"'', 100);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.left = "'' + (currentx + (diffx * 1.0)) + ''px"'', 125);
                
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.top = "'' + (currenty + (diffy * 0.2)) + ''px"'', 25);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.top = "'' + (currenty + (diffy * 0.4)) + ''px"'', 50);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.top = "'' + (currenty + (diffy * 0.6)) + ''px"'', 75);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.top = "'' + (currenty + (diffy * 0.8)) + ''px"'', 100);
                    setTimeout(''RGraph.Registry.Get("chart.tooltip").style.top = "'' + (currenty + (diffy * 1.0)) + ''px"'', 125);
                }
            
            } else {
        
                alert(''[TOOLTIPS] The "snap" effect is only supported on the Line, Rscatter, Scatter and Radar charts (tried to use it with type: '' + canvas.__object__.type);
            }

            /**
            * Fire the tooltip event
            */
            RGraph.FireCustomEvent(canvas.__object__, ''ontooltip'');

            return;
        }

        /**
        * Hide any currently shown tooltip
        */
        RGraph.HideTooltip();


        /**
        * Show a tool tip
        */
        var tooltipObj  = document.createElement(''DIV'');
        tooltipObj.className             = canvas.__object__.Get(''chart.tooltips.css.class'');
        tooltipObj.style.display         = ''none'';
        tooltipObj.style.position        = ''absolute'';
        tooltipObj.style.left            = 0;
        tooltipObj.style.top             = 0;
        tooltipObj.style.backgroundColor = ''rgba(255,255,239,0.9)'';
        tooltipObj.style.color           = ''black'';
        if (!!document.all) tooltipObj.style.border = '''';
        tooltipObj.style.visibility      = ''visible'';
        tooltipObj.style.paddingLeft     = RGraph.tooltips.padding;
        tooltipObj.style.paddingRight    = RGraph.tooltips.padding;
        tooltipObj.style.fontFamily      = RGraph.tooltips.font_face;
        tooltipObj.style.fontSize        = RGraph.tooltips.font_size;
        tooltipObj.style.zIndex          = 3;
        tooltipObj.style.borderRadius       = ''5px'';
        tooltipObj.style.MozBorderRadius    = ''5px'';
        tooltipObj.style.WebkitBorderRadius = ''5px'';
        tooltipObj.style.WebkitBoxShadow    = ''rgba(96,96,96,0.5) 0 0 15px'';
        tooltipObj.style.MozBoxShadow       = ''rgba(96,96,96,0.5) 0 0 15px'';
        tooltipObj.style.boxShadow          = ''rgba(96,96,96,0.5) 0 0 15px'';
        tooltipObj.style.filter             = ''progid:DXImageTransform.Microsoft.Shadow(color=#666666,direction=135)'';
        tooltipObj.style.opacity            = 0;
        tooltipObj.style.overflow           = ''hidden'';
        tooltipObj.innerHTML                = text;
        tooltipObj.__text__                 = text; // This is set because the innerHTML can change when it''s set
        tooltipObj.__canvas__               = canvas;
        tooltipObj.style.display            = ''inline'';
        tooltipObj.id                       = ''__rgraph_tooltip_'' + canvas.id + ''_'' + idx;
        
        if (typeof(idx) == ''number'') {
            tooltipObj.__index__ = idx;
            
            /**
            * Just for the line chart
            */
            if (canvas.__object__.type == ''line'') {
                var index2 = idx;
                
                while (index2 >= canvas.__object__.data[0].length) {
                    index2 -= canvas.__object__.data[0].length;
                }
                
                tooltipObj.__index2__ = index2;
            }
        }

        document.body.appendChild(tooltipObj);
        
        var width  = tooltipObj.offsetWidth;
        var height = tooltipObj.offsetHeight;

        if ((y - height - 2) > 0) {
            y = y - height - 2;
        } else {
            y = y + 2;
        }

        /**
        * Set the width on the tooltip so it doesn''t resize if the window is resized
        */
        tooltipObj.style.width = width + ''px'';
        //tooltipObj.style.height = 0; // Initially set the tooltip height to nothing

        /**
        * If the mouse is towards the right of the browser window and the tooltip would go outside of the window,
        * move it left
        */
        if ( (x + width) > document.body.offsetWidth ) {
            x = x - width - 7;
            var placementLeft = true;
            
            if (canvas.__object__.Get(''chart.tooltips.effect'') == ''none'') {
                x = x - 3;
            }

            tooltipObj.style.left = x + ''px'';
            tooltipObj.style.top  = y + ''px'';

        } else {
            x += 5;

            tooltipObj.style.left = x + ''px'';
            tooltipObj.style.top = y + ''px'';
        }


        if (effect == ''expand'') {

            tooltipObj.style.left        = (x + (width / 2)) + ''px'';
            tooltipObj.style.top         = (y + (height / 2)) + ''px'';
            leftDelta                    = (width / 2) / 10;
            topDelta                     = (height / 2) / 10;

            tooltipObj.style.width              = 0;
            tooltipObj.style.height             = 0;
            //tooltipObj.style.boxShadow          = '''';
            //tooltipObj.style.MozBoxShadow       = '''';
            //tooltipObj.style.WebkitBoxShadow    = '''';
            //tooltipObj.style.borderRadius       = 0;
            //tooltipObj.style.MozBorderRadius    = 0;
            //tooltipObj.style.WebkitBorderRadius = 0;
            tooltipObj.style.opacity = 1;

            // Progressively move the tooltip to where it should be (the x position)
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) - leftDelta) + ''px'' }", 250));
            
            // Progressively move the tooltip to where it should be (the Y position)
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) - topDelta) + ''px'' }", 250));

            // Progressively grow the tooltip width
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.1) + "px''; }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.2) + "px''; }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.3) + "px''; }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.4) + "px''; }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.5) + "px''; }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.6) + "px''; }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.7) + "px''; }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.8) + "px''; }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 0.9) + "px''; }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + width + "px''; }", 250));

            // Progressively grow the tooltip height
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.1) + "px''; }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.2) + "px''; }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.3) + "px''; }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.4) + "px''; }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.5) + "px''; }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.6) + "px''; }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.7) + "px''; }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.8) + "px''; }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 0.9) + "px''; }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + height + "px''; }", 250));
            
            // When the animation is finished, set the tooltip HTML
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').innerHTML = RGraph.Registry.Get(''chart.tooltip'').__text__; }", 250));
        
        } else if (effect == ''contract'') {

            tooltipObj.style.left = (x - width) + ''px'';
            tooltipObj.style.top  = (y - (height * 2)) + ''px'';
            tooltipObj.style.cursor = ''pointer'';

            leftDelta = width / 10;
            topDelta  = height / 10;

            tooltipObj.style.width  = (width * 5) + ''px'';
            tooltipObj.style.height = (height * 5) + ''px'';

            tooltipObj.style.opacity = 0.2;

            // Progressively move the tooltip to where it should be (the x position)
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.left) + leftDelta) + ''px'' }", 250));

            // Progressively move the tooltip to where it should be (the Y position)
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = (parseInt(RGraph.Registry.Get(''chart.tooltip'').style.top) + (topDelta*2)) + ''px'' }", 250));

            // Progressively shrink the tooltip width
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 5.5) + "px''; }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 5.0) + "px''; }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 4.5) + "px''; }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 4.0) + "px''; }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 3.5) + "px''; }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 3.0) + "px''; }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 2.5) + "px''; }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 2.0) + "px''; }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + (width * 1.5) + "px''; }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.width = ''" + width + "px''; }", 250));

            // Progressively shrink the tooltip height
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 5.5) + "px''; }", 25));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 5.0) + "px''; }", 50));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 4.5) + "px''; }", 75));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 4.0) + "px''; }", 100));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 3.5) + "px''; }", 125));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 3.0) + "px''; }", 150));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 2.5) + "px''; }", 175));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 2.0) + "px''; }", 200));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + (height * 1.5) + "px''; }", 225));
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.height = ''" + height + "px''; }", 250));

            // When the animation is finished, set the tooltip HTML
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').innerHTML = RGraph.Registry.Get(''chart.tooltip'').__text__; }", 250));

            /**
            * This resets the pointer
            */
            RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.cursor = ''default''; }", 275));

        } else if (effect == ''snap'') {

            /*******************************************************
            * Move the tooltip
            *******************************************************/
            for (var i=1; i<=10; ++i) {
                RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.left = ''" + (x * 0.1 * i) + "px''; }", 15 * i));
                RGraph.Registry.Get(''chart.tooltip.timers'').push(setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.top = ''" + (y * 0.1 * i) + "px''; }", 15 * i));
            }

            tooltipObj.style.left = 0 - tooltipObj.offsetWidth + ''px'';
            tooltipObj.style.top  = 0 - tooltipObj.offsetHeight + ''px'';

        } else if (effect !!= ''fade'' && effect !!= ''expand'' && effect !!= ''none'' && effect !!= ''snap'' && effect !!= ''contract'') {
            alert(''[COMMON] Unknown tooltip effect: '' + effect);
        }

        if (effect !!= ''none'') {
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.1; }", 25);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.2; }", 50);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.3; }", 75);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.4; }", 100);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.5; }", 125);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.6; }", 150);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.7; }", 175);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.8; }", 200);
            setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 0.9; }", 225);
        }

        setTimeout("if (RGraph.Registry.Get(''chart.tooltip'')) { RGraph.Registry.Get(''chart.tooltip'').style.opacity = 1;}", effect == ''none'' ? 50 : 250);

        /**
        * If the tooltip it self is clicked, cancel it
        */
        tooltipObj.onmousedown = function (e)
        {
            e = RGraph.FixEventObject(e)
            e.stopPropagation();
        }
        
        tooltipObj.onclick = function (e)
        {
            if (e.button == 0) {
                e = RGraph.FixEventObject(e);
                e.stopPropagation();
            }
        }

        /**
        * Install the function for hiding the tooltip.
        */
        document.body.onmousedown = function (event)
        {
            var tooltip = RGraph.Registry.Get(''chart.tooltip'');

            if (tooltip) {
                RGraph.HideTooltip();

                // Redraw if highlighting is enabled
                if (tooltip.__canvas__.__object__.Get(''chart.tooltips.highlight'')) {
                    RGraph.Redraw();
                }
            }
        }

        /**
        * If the window is resized, hide the tooltip
        */
        window.onresize = function ()
        {
            var tooltip = RGraph.Registry.Get(''chart.tooltip'');

            if (tooltip) {
                tooltip.parentNode.removeChild(tooltip);
                tooltip.style.display = ''none'';                
                tooltip.style.visibility = ''hidden'';
                RGraph.Registry.Set(''chart.tooltip'', null);

                // Redraw the graph if necessary
                if (canvas.__object__.Get(''chart.tooltips.highlight'')) {
                    RGraph.Clear(canvas);
                    canvas.__object__.Draw();
                }
            }
        }

        /**
        * Keep a reference to the tooltip
        */
        RGraph.Registry.Set(''chart.tooltip'', tooltipObj);

        /**
        * Fire the tooltip event
        */
        RGraph.FireCustomEvent(canvas.__object__, ''ontooltip'');
    }
    
    
    /**
    * 
    */
    RGraph.getTooltipTextFromDIV = function (text)
    {
        // This regex is duplicated firher down on roughly line 888
        var result = /^id:(.*)/.exec(text);

        if (result && result[1] && document.getElementById(result[1])) {
            text = document.getElementById(result[1]).innerHTML;
        } else if (result && result[1]) {
            text = '''';
        }
        
        return text;
    }


    /**
    * This function handles the tooltip text being a string, function, or an array of functions.
    */
    RGraph.parseTooltipText = function (tooltips, idx)
    {
        // Get the tooltip text
        if (typeof(tooltips) == ''function'') {
            var text = tooltips(idx);

        } else if (typeof(tooltips) == ''object'' && tooltips && typeof(tooltips[idx]) == ''function'') {
            var text = tooltips[idx](idx);
        
        } else if (typeof(tooltips) == ''object'' && tooltips) {
            var text = String(tooltips[idx]);

        } else {
            var text = '''';
        }

        if (text == ''undefined'') {
            text = '''';
        } else if (text == ''null'') {
            text = '''';
        }

        return RGraph.getTooltipTextFromDIV(text);
    }


    /**
    * 
    */
    RGraph.getTooltipWidth = function (text, obj)
    {
        var div = document.createElement(''DIV'');
            div.className             = obj.Get(''chart.tooltips.css.class'');
            div.style.paddingLeft     = RGraph.tooltips.padding;
            div.style.paddingRight    = RGraph.tooltips.padding;
            div.style.fontFamily      = RGraph.tooltips.font_face;
            div.style.fontSize        = RGraph.tooltips.font_size;
            div.style.visibility      = ''hidden'';
            div.style.position        = ''absolute'';
            div.style.top            = ''300px'';
            div.style.left             = 0;
            div.style.display         = ''inline'';
            div.innerHTML             = RGraph.getTooltipTextFromDIV(text);
        document.body.appendChild(div);

        return div.offsetWidth;
    }


    /**
    * Hides the currently shown tooltip
    */
    RGraph.HideTooltip = function ()
    {
        var tooltip = RGraph.Registry.Get(''chart.tooltip'');

        if (tooltip) {
            tooltip.parentNode.removeChild(tooltip);
            tooltip.style.display = ''none'';                
            tooltip.style.visibility = ''hidden'';
            RGraph.Registry.Set(''chart.tooltip'', null);
        }
    }






    /**
    * The BAR chart onmousemove event Bar chart tooltips can now
    * be based around the onmousemove event
    */
    RGraph.InstallBarTooltipEventListeners = function (obj)
    {
        /**
        * Install the window onclick handler
        */
        var window_onclick_func = function (){RGraph.Redraw();};
        window.addEventListener(''click'', window_onclick_func, false);
        RGraph.AddEventListener(''window_'' + obj.id, ''click'', window_onclick_func);


        var canvas_onmousemove = function (e)
        {
            e = RGraph.FixEventObject(e);
    
            var canvas    = document.getElementById(e.target.id);
            var obj       = canvas.__object__;
            
            if (obj.__bar__) {
                var lineObj = obj;
                obj = obj.__bar__;
                obj.__line__ = lineObj;
            }

            var barCoords = obj.getBar(e);
    
            /**
            * If there are bar coords AND the bar has height
            */
    
            if (barCoords && barCoords[4] > 0 && RGraph.parseTooltipText(obj.Get(''chart.tooltips''), barCoords[5])) {

                /**
                * Get the tooltip text
                */
                var text = RGraph.parseTooltipText(obj.Get(''chart.tooltips''), barCoords[5]);

                if (text) {
                    canvas.style.cursor = ''pointer'';
                } else {
                    canvas.style.cursor = ''default'';
                }
                
                /**
                * Hide the currently displayed tooltip if the index is the same
                */
                if (   RGraph.Registry.Get(''chart.tooltip'')
                    && RGraph.Registry.Get(''chart.tooltip'').__canvas__.id !!= obj.id
                    && obj.Get(''chart.tooltips.event'') == ''onmousemove'') {
    
                    RGraph.Redraw();
                    RGraph.HideTooltip();
                }
    
                /**
                * This facilitates the tooltips using the onmousemove event
                */
    
                if (   obj.Get(''chart.tooltips.event'') == ''onmousemove''
                    && (
                           (RGraph.Registry.Get(''chart.tooltip'') && RGraph.Registry.Get(''chart.tooltip'').__index__ !!= barCoords[5])
                        || !!RGraph.Registry.Get(''chart.tooltip'')
                       )
                    && text) {
                    /**
                    * Show a tooltip if it''s defined
                    */
                    RGraph.Redraw(obj);

                    if (obj.Get(''chart.tooltips.highlight'')) {
                        obj.context.beginPath();
                        obj.context.strokeStyle = obj.Get(''chart.highlight.stroke'');
                        obj.context.fillStyle   = obj.Get(''chart.highlight.fill'');
                        obj.context.strokeRect(AA(this, barCoords[1]), barCoords[2], barCoords[3], barCoords[4]);
                        obj.context.fillRect(AA(this, barCoords[1]), barCoords[2], barCoords[3], barCoords[4]);
                
                        obj.context.stroke();
                        obj.context.fill();
                    }
    
                    RGraph.Tooltip(canvas, text, e.pageX, e.pageY, barCoords[5]);
                }
            } else if (obj.__line__ && obj.__line__.getPoint && obj.__line__.getPoint(e)) {
                var point       = obj.__line__.getPoint(e);
                var mouseCoords = RGraph.getMouseXY(e);
                var mouseX = mouseCoords[0];
                var mouseY = mouseCoords[1];
                
                if (   mouseX > (point[0] - 5)
                    && mouseX < (point[0] + 5)
                    && mouseY > (point[1] - 5)
                    && mouseY < (point[1] + 5) ) {
                    canvas.style.cursor = ''pointer'';
                }
            } else {
                canvas.style.cursor = ''default'';
            }
        }
        RGraph.AddEventListener(obj.id, ''mousemove'', canvas_onmousemove);
        obj.canvas.addEventListener(''mousemove'', canvas_onmousemove, false);



        /**
        * Install the onclick event handler for the tooltips
        */
        if (obj.Get(''chart.tooltips.event'') == ''onclick'') {

            var canvas_onclick = function (e)
            {
                var e = RGraph.FixEventObject(e);

                // If the button pressed isn''t the left, we''re not interested
                if (e.button !!= 0) return;

                e = RGraph.FixEventObject(e);

                var canvas    = document.getElementById(this.id);
                var obj       = canvas.__object__;

                if (obj.__bar__) {
                    obj = obj.__bar__;
                }

                var barCoords = obj.getBar(e);

                /**
                * Redraw the graph first, in effect resetting the graph to as it was when it was first drawn
                * This "deselects" any already selected bar
                */
                RGraph.Redraw();

                /**
                * Loop through the bars determining if the mouse is over a bar
                */
                if (barCoords) {

                    /**
                    * Get the tooltip text
                    */
                    var text = RGraph.parseTooltipText(obj.Get(''chart.tooltips''), barCoords[5]);

                    /**
                    * Show a tooltip if it''s defined
                    */
                    if (text && text !!= ''undefined'') {
                        if (obj.Get(''chart.tooltips.highlight'')) {

                            obj.context.beginPath();
                                obj.context.strokeStyle = obj.Get(''chart.highlight.stroke'');
                                obj.context.fillStyle   = obj.Get(''chart.highlight.fill'');
                                obj.context.strokeRect(AA(this, barCoords[1]), AA(this, barCoords[2]), barCoords[3], barCoords[4]);
                                obj.context.fillRect(AA(this, barCoords[1]), AA(this, barCoords[2]), barCoords[3], barCoords[4]);
                            obj.context.stroke();
                            obj.context.fill();
                        }

                        RGraph.Tooltip(canvas, text, e.pageX, e.pageY, barCoords[5]);
                    }
                }

                /**
                * Stop the event bubbling
                */
                e.stopPropagation();
            }
            RGraph.AddEventListener(obj.id, ''click'', canvas_onclick);
            obj.canvas.addEventListener(''click'', canvas_onclick, false);
        }
    }



    /**
    * The LINE chart tooltips event handlers
    * 
    * @param object obj The graph object
    */
    RGraph.InstallLineTooltipEventListeners = function (obj)
    {
        var canvas_onclick_func = function (e)
        {
            e = RGraph.FixEventObject(e);
    
            var canvas  = e.target;
            var context = canvas.getContext(''2d'');
            var obj     = canvas.__object__;
            var point   = obj.getPoint(e);
            
            var mouseCoords = RGraph.getMouseXY(e);
            var mouseX      = mouseCoords[0]
            var mouseY      = mouseCoords[1]
    
            if (obj.Get(''chart.tooltips.highlight'')) {
                RGraph.Register(obj);
            }

            if (   point
                && typeof(point[0]) == ''object''
                && typeof(point[1]) == ''number''
                && typeof(point[2]) == ''number''
                && typeof(point[3]) == ''number''
               ) {
    
                // point[0] is the graph object
                var xCoord = point[1];
                var yCoord = point[2];
                var idx    = point[3];
    
                if ((obj.Get(''chart.tooltips'')[idx] || typeof(obj.Get(''chart.tooltips'')) == ''function'')) {
    
                    var text = RGraph.parseTooltipText(obj.Get(''chart.tooltips''), idx);

                    // Change the pointer to a hand
                    if (   mouseX > (xCoord - 5)
                        && mouseX < (xCoord + 5)
                        && mouseY > (yCoord - 5)
                        && mouseY < (yCoord + 5)
                        && text) {

                        canvas.style.cursor = ''pointer'';
                    } else {
                        canvas.style.cursor = ''default'';
                    }

                    /**
                    * If the tooltip is the same one as is currently visible (going by the array index), don''t do squat and return.
                    */
    
                    if (   RGraph.Registry.Get(''chart.tooltip'')
                        && RGraph.Registry.Get(''chart.tooltip'').__index__ == idx
                        && RGraph.Registry.Get(''chart.tooltip'').__canvas__.id == canvas.id
                        && RGraph.Registry.Get(''chart.tooltip'').__event__
                        && RGraph.Registry.Get(''chart.tooltip'').__event__ == ''mousemove'') {
    
                        return;
                    }
    
                    /**
                    * Redraw the graph
                    */
                    if (obj.Get(''chart.tooltips.highlight'') || obj.__bar__) {
                        
                        RGraph.Redraw();
                        
                        if (obj.__bar__) {
                            RGraph.Clear(obj.canvas);
                            obj.__bar__.Draw();
                        }
                    }
    
                    // SHOW THE CORRECT TOOLTIP
                    RGraph.Tooltip(canvas, text, e.pageX, obj.Get(''chart.tooltips.hotspot.xonly'') ? (point[2] + RGraph.getCanvasXY(canvas)[1]) : e.pageY, idx);
    
                    // Store the tooltip index on the tooltip object if it exists (because of override)
                    if (typeof(obj.Get(''chart.tooltips.override'')) !!= ''function'') {
                        RGraph.Registry.Get(''chart.tooltip'').__index__ = Number(idx);
    
                        /**
                        * This converts idx into the index that is not greater than the
                        * number of items in the data array
                        */
                        while (idx >= obj.data[0].length) {
                            idx -= obj.data[0].length
                        }
    
                        RGraph.Registry.Get(''chart.tooltip'').__index2__ = idx;
                    
                        /**
                        * Set the source event
                        */
                        RGraph.Registry.Get(''chart.tooltip'').__event__ = ''mousemove'';

    
                        /**
                        * Highlight the graph
                        */
                        if (obj.Get(''chart.tooltips.highlight'')) {
                        
                            context.beginPath();
                            context.moveTo(xCoord, yCoord);
                            context.arc(xCoord, yCoord, 2, 0, 6.28, 0);
                            context.strokeStyle = obj.Get(''chart.highlight.stroke'');
                            context.fillStyle = obj.Get(''chart.highlight.fill'');
                            context.stroke();
                            context.fill();
                        }
                    }
                    
                    e.stopPropagation();
                    return;
                }
            }
            
            /**
            * Not over a hotspot?
            */
            canvas.style.cursor = ''default'';
        }
        obj.canvas.addEventListener(''click'', canvas_onclick_func, false);
        RGraph.AddEventListener(obj.id, ''click'', canvas_onclick_func);
        
        /**
        * The onmousemove by default shows the tooltips, but using the new chart.tooltips.event property
        * you can change this to the click event
        * 
        * @param obj e The event object
        */
        if (obj.Get(''chart.tooltips.event'') == ''onmousemove'') {
            var canvas_onmousemove_func = function (e)
            {
                e = RGraph.FixEventObject(e);
        
                var canvas  = e.target;
                var context = canvas.getContext(''2d'');
                var obj     = canvas.__object__;
                var point   = obj.getPoint(e);
                
                if (point && point.length > 0) {
                
                    var text = RGraph.parseTooltipText(obj.Get(''chart.tooltips''), point[3]);

                    // This regex is a duplicate of one further up on roughly line 482
                    if (text) {
                        canvas.style.cursor = ''pointer'';
                        canvas_onclick_func(e);
                    }
                } else {
                    canvas.style.cursor = ''default'';
                }
            }
            obj.canvas.addEventListener(''mousemove'', canvas_onmousemove_func, false);
            RGraph.AddEventListener(obj.id, ''mousemove'', canvas_onmousemove_func);
        
        // Just do the mouse pointer
        } else {
            var canvas_onmousemove_func = function (e)
            {
                e = RGraph.FixEventObject(e);
        
                var canvas  = e.target;
                var context = canvas.getContext(''2d'');
                var obj     = canvas.__object__;
                var point   = obj.getPoint(e);
                
                if (point && point.length > 0) {
                    
                    var text = RGraph.parseTooltipText(obj.Get(''chart.tooltips''), point[3]);

                    if (text) {
                        canvas.style.cursor = ''pointer'';
                    }
                } else {
                    canvas.style.cursor = ''default'';
                }
            }
            obj.canvas.addEventListener(''mousemove'', canvas_onmousemove_func, false);
            RGraph.AddEventListener(obj.id, ''mousemove'', canvas_onmousemove_func);
        }
    }


    /**
    * This (as the name suggests preloads any images it can find in the tooltip text
    * 
    * @param object obj The chart object
    */
    RGraph.PreLoadTooltipImages = function (obj)
    {
        var tooltips = obj.Get(''chart.tooltips'');
        
        if (obj.type == ''rscatter'') {
            tooltips = [];
            for (var i=0; i<obj.data.length; ++i) {
                tooltips.push(obj.data[3]);
            }
        }
        
        for (var i=0; i<tooltips.length; ++i) {
            // Add the text to an offscreen DIV tag
            var div = document.createElement(''DIV'');
                div.style.position = ''absolute'';
                div.style.opacity = 0;
                div.style.top = ''-100px'';
                div.style.left = ''-100px'';
                div.innerHTML  = tooltips[i];
            document.body.appendChild(div);
            
            // Now get the IMG tags and create them
            var img_tags = div.getElementsByTagName(''IMG'');

            // Create the image in an off-screen image tag
            for (var j=0; j<img_tags.length; ++j) {
                    if (img_tags && img_tags[i]) {
                    var img = document.createElement(''IMG'');
                        img.style.position = ''absolute'';
                        img.style.opacity = 0;
                        img.style.top = ''-100px'';
                        img.style.left = ''-100px'';
                        img.src = img_tags[i].src
                    document.body.appendChild(img);
                    
                    setTimeout(function () {document.body.removeChild(img);}, 250);
                }
            }

            // Now remove the div
            document.body.removeChild(div);
        }
        
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:30'!
RGraphcommonzoomJs
	^ '    /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */

    if (typeof(RGraph) == ''undefined'') RGraph = {isRGraph:true,type:''common''};


    /**
    * Installs the event handlers for zooming an area of the graph
    * 
    * @param object obj Your graph object
    */
    RGraph.ZoomArea = function (obj)
    {
        if (obj.Get(''chart.zoom.mode'') == ''area'') {

            var canvas  = obj.canvas;
            var context = obj.context;
            
            obj.canvas.style.cursor = ''crosshair'';
            
            RGraph.Register(obj);


            canvas.onmousedown = function(e)
            {
                var canvas = e.target;
                var coords = RGraph.getMouseXY(e);
                var obj    = canvas.__object__;
                    
                if (RGraph.Registry.Get(''chart.zoomed.area.div'')) {
                    RGraph.Registry.Get(''chart.zoomed.area.div'').style.display = ''none'';
                }

                if (typeof(RGraph.Registry.Get(''chart.zoomed.area.divs'')) == null) {
                    RGraph.Registry.Set(''chart.zoomed.area.divs'', []);

                } else {

                    var divs = RGraph.Registry.Get(''chart.zoomed.area.divs'');
                    
                    if (divs && divs.length) {
                        for (var i=0; i<divs.length; ++i) {
                            if (divs[i]) {
                                divs[i].style.display = ''none'';
                                divs[i] = null;
                            }
                        }
                    }
                }

                /**
                * Create the indicator DIV
                */
                var canvasXY = RGraph.getCanvasXY(canvas);
                var areaDiv  = document.createElement(''DIV'');
                    areaDiv.__canvas__     = canvas;
                    areaDiv.style.position = ''absolute'';
                    areaDiv.style.left     = canvasXY[0] + coords[0] + ''px''
                    areaDiv.style.top      = canvasXY[1] + coords[1] + ''px''
                    areaDiv.style.width    = 0;
                    areaDiv.style.height   = 0;
                    areaDiv.style.border   = ''1px solid black'';
                    areaDiv.style.backgroundColor = ''rgba(220,220,220,0.3)'';
                    areaDiv.style.display = ''none'';

                    areaDiv.onmouseover = function (e)
                    {
                        setTimeout(function () {e.target.style.opacity = 0.8;}, 50);
                        setTimeout(function () {e.target.style.opacity = 0.6;}, 100);
                        setTimeout(function () {e.target.style.opacity = 0.4;}, 150);
                        setTimeout(function () {e.target.style.opacity = 0.2;}, 200);
                        setTimeout(function () {e.target.style.opacity = 0;}, 250);
                        setTimeout(function () {e.target.style.display = ''none'';}, 300);
                        setTimeout(function () {e.target = null;}, 350);
                    }

                document.body.appendChild(areaDiv);


                RGraph.Registry.Set(''chart.zoomed.area.div'', null);
                RGraph.Registry.Set(''chart.zoomed.area.mousedown'', coords);
                RGraph.Registry.Set(''chart.zoomed.area.areadiv'', areaDiv);
            }


            var window_onmousemove = function (e)
            {
                var startCoords = RGraph.Registry.Get(''chart.zoomed.area.mousedown'');
                
                if (startCoords && startCoords.length) {

                    var coords      = RGraph.getMouseXY(e);
                    var canvasXY    = RGraph.getCanvasXY(e.target);
                    var obj = e.target.__object__;
                    var context = obj.context;
                    var canvas  = obj.canvas;
                    var startx  = startCoords[0];
                    var starty  = startCoords[1];
                    var endx    = coords[0];
                    var endy    = coords[1];
                    var width   = endx - startx;
                    var height  = endy - starty;
                    var areaDiv = RGraph.Registry.Get(''chart.zoomed.area.areadiv'');
                    
                    if (width >= 0 && height >= 0) {
                    
                        if (width > 5 && height > 5) {
                            areaDiv.style.width = (width - 15) + ''px'';
                            areaDiv.style.height = (height - 15) + ''px'';
                            areaDiv.style.display = ''inline'';
                        } else {
                            areaDiv.style.display = ''none'';
                        }

                    } else if (width < -5 || height < -5) {

                        var canvasCoords = RGraph.getCanvasXY(canvas);
                        var noticeDiv = document.createElement(''DIV'');

                        noticeDiv.style.position = ''absolute'';
                        noticeDiv.style.top  = 0;
                        noticeDiv.style.left = 0;
                        noticeDiv.style.zIndex = 99;
                        noticeDiv.style.border = ''1px dashed black'';
                        noticeDiv.style.backgroundColor = ''#ffc1c1'';
                        noticeDiv.style.MozBoxShadow = ''0 0 5px #999'';
                        noticeDiv.style.WebkitBoxShadow = ''0 0 5px #999'';
                        noticeDiv.style.boxShadow = ''0 0 5px #999'';
                        noticeDiv.style.padding = ''2px'';
                        noticeDiv.innerHTML = ''Zoom goes right and down'';
                        document.body.appendChild(noticeDiv);

                        // Reposition the warning
                        noticeDiv.style.top  = canvasCoords[1] + startCoords[1] - noticeDiv.offsetHeight + ''px'';
                        noticeDiv.style.left = canvasCoords[0] + startCoords[0] - (noticeDiv.offsetWidth / 2) + ''px'';
                        noticeDiv.style.width = noticeDiv.offsetWidth + ''px'';
                        
                        setTimeout(function () {noticeDiv.style.opacity = 0.8;}, 2100);
                        setTimeout(function () {noticeDiv.style.opacity = 0.6;}, 2200);
                        setTimeout(function () {noticeDiv.style.opacity = 0.4;}, 2300);
                        setTimeout(function () {noticeDiv.style.opacity = 0.2;}, 2400);
                        setTimeout(function () {noticeDiv.style.display = ''none'';}, 2500);
                        setTimeout(function () {noticeDiv = null;}, 2600);
                    }
                }
            }
            window.addEventListener(''mousemove'', window_onmousemove, false);
            RGraph.AddEventListener(canvas.id, ''window_mousemove'', window_onmousemove);


            canvas.onmouseup = function (e)
            {
                RGraph.FixEventObject(e);

                var startCoords = RGraph.Registry.Get(''chart.zoomed.area.mousedown'');
                var coords      = RGraph.getMouseXY(e);

                // Do the zooming here
                if (RGraph.Registry.Get(''chart.zoomed.area.mousedown'')) {

                    //RGraph.Redraw();
                    
                    RGraph.Registry.Get(''chart.zoomed.area.areadiv'').style.display = ''none'';
                    RGraph.Registry.Get(''chart.zoomed.area.areadiv'').style.left = ''-1000px'';
                    RGraph.Registry.Get(''chart.zoomed.area.areadiv'').style.top = ''-1000px'';
                    RGraph.Registry.Set(''chart.zoomed.area.areadiv'', null);

                    if (coords[0] < startCoords[0] || coords[1] < startCoords[1]) {
                        RGraph.Registry.Set(''chart.zoomed.area.mousedown'', false);
                        return;
                    }

                    var canvas       = e.target;
                    var obj          = canvas.__object__;
                    var context      = obj.context;
                    var canvasCoords = RGraph.getCanvasXY(e.target);
                    var coords       = RGraph.getMouseXY(e);
                    var startCoords  = RGraph.Registry.Get(''chart.zoomed.area.mousedown'');
                    var startx       = startCoords[0];
                    var starty       = startCoords[1];
                    var endx         = coords[0] - 15;
                    var endy         = coords[1] - 15;
                    var width        = Math.abs(endx - startx);
                    var height       = Math.abs(endy - starty);
                    var factor       = obj.Get(''chart.zoom.factor'') - 1;
                    
                    var img = document.createElement(''IMG'');
                    img.src = canvas.toDataURL();
                    img.style.position = ''relative'';
                    img.style.left     = (factor + 1) * -1 * startx + ''px'';
                    img.style.top      = (factor + 1) * -1 * starty + ''px'';
                    img.width          = (factor + 1) * canvas.width;
                    img.height         = (factor + 1) * canvas.height;

                    var div            = document.createElement(''DIV'');
                    div.__object__     = obj;
                    div.className      = ''RGraph_zoomed_area'';
                    div.style.position = ''absolute'';
                    div.style.backgroundColor = ''white'';
                    div.style.cursor = ''move'';

                    div.style.top      = e.pageY + ''px'';
                    div.style.left     = e.pageX + ''px'';
                    div.origWidth      = width;
                    div.origHeight     = height;
                    div.style.width    = width + ''px'';
                    div.style.height   = height + ''px'';
                    div.style.border   = ''1px solid black'';                    
                    div.style.boxShadow          = ''0 0 15px black'';
                    div.style.MozBoxShadow       = ''0 0 15px black'';
                    div.style.WebkitBoxShadow    = ''0 0 15px black'';
                    div.style.overflow           = ''hidden'';
                    div.style.opacity            = 0;
                    div.style.zIndex             = 99;
                    
                    document.body.appendChild(div);
                    div.appendChild(img);


                    /**
                    * This facilitates expanding the zoomed area once visible (the double click)
                    */
                    div.ondblclick = function (event)
                    {
                        var event = RGraph.FixEventObject(event);
                        var img   = event.target;
                        var div   = event.target.parentNode;
                        
                        var current_width  = div.offsetWidth
                        var current_height = div.offsetHeight
                        var target_width   = img.offsetWidth;
                        var target_height  = img.offsetHeight;
                        var diff_width     = target_width - current_width;
                        var diff_height    = target_height - current_height;
                        
                        var img_offset_left = parseInt(img.offsetLeft);
                        var img_offset_top  = parseInt(img.offsetTop);
                        
                        // Global vars on purpose so the timers can access them
                        __zoomed_div_style__ = div.style;
                        __zoomed_img_style__ = img.style;
                    
                        setTimeout("__zoomed_div_style__.left = parseInt(__zoomed_div_style__.left) - " + (diff_width * 0.1) + " + ''px''", 50);
                        setTimeout("__zoomed_div_style__.left = parseInt(__zoomed_div_style__.left) - " + (diff_width * 0.1) + " + ''px''", 100);
                        setTimeout("__zoomed_div_style__.left = parseInt(__zoomed_div_style__.left) - " + (diff_width * 0.1) + " + ''px''", 150);
                        setTimeout("__zoomed_div_style__.left = parseInt(__zoomed_div_style__.left) - " + (diff_width * 0.1) + " + ''px''", 200);
                        setTimeout("__zoomed_div_style__.left = parseInt(__zoomed_div_style__.left) - " + (diff_width * 0.1) + " + ''px''", 250);
                    
                        setTimeout("__zoomed_div_style__.top = parseInt(__zoomed_div_style__.top) - " + (diff_height * 0.1) + " + ''px''", 50);
                        setTimeout("__zoomed_div_style__.top = parseInt(__zoomed_div_style__.top) - " + (diff_height * 0.1) + " + ''px''", 100);
                        setTimeout("__zoomed_div_style__.top = parseInt(__zoomed_div_style__.top) - " + (diff_height * 0.1) + " + ''px''", 150);
                        setTimeout("__zoomed_div_style__.top = parseInt(__zoomed_div_style__.top) - " + (diff_height * 0.1) + " + ''px''", 200);
                        setTimeout("__zoomed_div_style__.top = parseInt(__zoomed_div_style__.top) - " + (diff_height * 0.1) + " + ''px''", 250);
                    
                        setTimeout("__zoomed_div_style__.width = parseInt(__zoomed_div_style__.width) + " + (diff_width * 0.2) + " + ''px''", 50);
                        setTimeout("__zoomed_div_style__.width = parseInt(__zoomed_div_style__.width) + " + (diff_width * 0.2) + " + ''px''", 100);
                        setTimeout("__zoomed_div_style__.width = parseInt(__zoomed_div_style__.width) + " + (diff_width * 0.2) + " + ''px''", 150);
                        setTimeout("__zoomed_div_style__.width = parseInt(__zoomed_div_style__.width) + " + (diff_width * 0.2) + " + ''px''", 200);
                        setTimeout("__zoomed_div_style__.width = parseInt(__zoomed_div_style__.width) + " + (diff_width * 0.2) + " + ''px''", 250);
                        
                        setTimeout("__zoomed_div_style__.height = parseInt(__zoomed_div_style__.height) + " + (diff_height * 0.2) + " + ''px''", 50);
                        setTimeout("__zoomed_div_style__.height = parseInt(__zoomed_div_style__.height) + " + (diff_height * 0.2) + " + ''px''", 100);
                        setTimeout("__zoomed_div_style__.height = parseInt(__zoomed_div_style__.height) + " + (diff_height * 0.2) + " + ''px''", 150);
                        setTimeout("__zoomed_div_style__.height = parseInt(__zoomed_div_style__.height) + " + (diff_height * 0.2) + " + ''px''", 200);
                        setTimeout("__zoomed_div_style__.height = parseInt(__zoomed_div_style__.height) + " + (diff_height * 0.2) + " + ''px''", 250);
                    
                        // Move the image within the div
                        setTimeout("__zoomed_img_style__.left = " + (img_offset_left * 0.8) + " + ''px''", 50);
                        setTimeout("__zoomed_img_style__.left = " + (img_offset_left * 0.6) + " + ''px''", 100);
                        setTimeout("__zoomed_img_style__.left = " + (img_offset_left * 0.4) + " + ''px''", 150);
                        setTimeout("__zoomed_img_style__.left = " + (img_offset_left * 0.2) + " + ''px''", 200);
                        setTimeout("__zoomed_img_style__.left = 0", 250);
                        
                        setTimeout("__zoomed_img_style__.top = " + (img_offset_top * 0.8) + " + ''px''", 50);
                        setTimeout("__zoomed_img_style__.top = " + (img_offset_top * 0.6) + " + ''px''", 100);
                        setTimeout("__zoomed_img_style__.top = " + (img_offset_top * 0.4) + " + ''px''", 150);
                        setTimeout("__zoomed_img_style__.top = " + (img_offset_top * 0.2) + " + ''px''", 200);
                        setTimeout("__zoomed_img_style__.top = 0", 250);
                        
                        div.ondblclick = null;
                    }
                    /**
                    * Make the zoomed bit draggable
                    */
                    div.onmousedown = function (e)
                    {
                        e = RGraph.FixEventObject(e);
                            
                        var div = e.target.parentNode;
                        var img = div.childNodes[0];
                        
                        if (e.button == 0 || e.button == 1  ) {
                        
                            div.__offsetx__       = e.offsetX + img.offsetLeft;
                            div.__offsety__       = e.offsetY + img.offsetTop;
                        
                            RGraph.Registry.Set(''chart.mousedown'', div);
                            RGraph.Registry.Set(''chart.button'', 0);
                        
                        } else {
                        
                            img.__startx__ = e.pageX;
                            img.__starty__ = e.pageY;
                            
                            img.__originalx__ = img.offsetLeft;
                            img.__originaly__ = img.offsetTop;

                            RGraph.Registry.Set(''chart.mousedown'', img);
                            RGraph.Registry.Set(''chart.button'', 2);
                            
                            /**
                            * Don''t show a context menu when the zoomed area is right-clicked on
                            */
                            window.oncontextmenu = function (e)
                            {
                                e = RGraph.FixEventObject(e);

                                e.stopPropagation();
                                
                                // [18th July 2010] Is this reallly necessary?
                                window.oncontextmenu = function (e)
                                {
                                    return true;
                                }
                            

                                return false;
                            }
                        }

                        e.stopPropagation();

                        return false;
                    }
                    
                    window.onmouseup = function (e)
                    {
                        RGraph.Registry.Set(''chart.mousedown'', false);
                    }
                    
                    window.onmousemove = function (e)
                    {
                        if (RGraph.Registry.Get(''chart.mousedown'') && RGraph.Registry.Get(''chart.button'') == 0) {
                            
                            var div = RGraph.Registry.Get(''chart.mousedown'');
                    
                            var x = e.pageX - div.__offsetx__;
                            var y = e.pageY - div.__offsety__;
                    
                            div.style.left = x + ''px'';
                            div.style.top = y + ''px'';

                        } else if (RGraph.Registry.Get(''chart.mousedown'') && RGraph.Registry.Get(''chart.button'') == 2) {
                            
                            var img = RGraph.Registry.Get(''chart.mousedown'');
                    
                            var x = img.__originalx__ + e.pageX - img.__startx__;
                            var y = img.__originaly__ + e.pageY - img.__starty__;
                    
                            img.style.left = x + ''px'';
                            img.style.top  = y + ''px'';
                        }
                    }
                    // End dragging code


                    var divs = RGraph.Registry.Get(''chart.zoomed.area.divs'');
                    if (typeof(divs) == ''object'') {
                        divs.push(div);
                    } else {
                        RGraph.Registry.Set(''chart.zoomed.area.divs'', [div])
                    }
                    
                    // Create the background
                    var bg = document.createElement(''DIV'');
                    bg.style.position        = ''fixed''
                    bg.style.zIndex          = 98;
                    bg.style.top             = 0;
                    bg.style.left            = 0;
                    bg.style.backgroundColor = ''#999'';
                    bg.style.opacity         = 0;
                    bg.style.width           = (screen.width + 100) + ''px'';
                    bg.style.height          = (screen.height + 100) + ''px'';
                    document.body.appendChild(bg);
                    
                    bg.onclick = function (e)
                    {
                        div.style.display = ''none'';
                        bg.style.display  = ''none'';
                        div = null;
                        bg  = null;
                    }
                    

                    setTimeout(function (){div.style.opacity = 0.2;}, 50);
                    setTimeout(function (){div.style.opacity = 0.4;}, 100);
                    setTimeout(function (){div.style.opacity = 0.6;}, 150);
                    setTimeout(function (){div.style.opacity = 0.8;}, 200);
                    setTimeout(function (){div.style.opacity = 1.0;}, 250);
                    
                    setTimeout(function () {div.style.left = canvasCoords[0] + startx - (width * factor * 0.1) + ''px''}, 50);
                    setTimeout(function () {div.style.left = canvasCoords[0] + startx - (width * factor * 0.2) + ''px''}, 100);
                    setTimeout(function () {div.style.left = canvasCoords[0] + startx - (width * factor * 0.3) + ''px''}, 150);
                    setTimeout(function () {div.style.left = canvasCoords[0] + startx - (width * factor * 0.4) + ''px''}, 200);
                    setTimeout(function () {div.style.left = canvasCoords[0] + startx - (width * factor * 0.5) + ''px''}, 250);

                    setTimeout(function () {div.style.top = canvasCoords[1] + starty - (height * factor * 0.1) + ''px''}, 50);
                    setTimeout(function () {div.style.top = canvasCoords[1] + starty - (height * factor * 0.2) + ''px''}, 100);
                    setTimeout(function () {div.style.top = canvasCoords[1] + starty - (height * factor * 0.3) + ''px''}, 150);
                    setTimeout(function () {div.style.top = canvasCoords[1] + starty - (height * factor * 0.4) + ''px''}, 200);
                    setTimeout(function () {div.style.top = canvasCoords[1] + starty - (height * factor * 0.5) + ''px''}, 250);

                    setTimeout(function () {div.style.width = width + (width * factor * 0.2) + ''px''}, 50);
                    setTimeout(function () {div.style.width = width + (width * factor * 0.4) + ''px''}, 100);
                    setTimeout(function () {div.style.width = width + (width * factor * 0.6) + ''px''}, 150);
                    setTimeout(function () {div.style.width = width + (width * factor * 0.8) + ''px''}, 200);
                    setTimeout(function () {div.style.width = width + (width * factor * 1.0) + ''px''}, 250);
                    
                    setTimeout(function () {div.style.height = height + (height * factor * 0.2) + ''px''}, 50);
                    setTimeout(function () {div.style.height = height + (height * factor * 0.4) + ''px''}, 100);
                    setTimeout(function () {div.style.height = height + (height * factor * 0.6) + ''px''}, 150);
                    setTimeout(function () {div.style.height = height + (height * factor * 0.8) + ''px''}, 200);
                    setTimeout(function () {div.style.height = height + (height * factor * 1.0) + ''px''}, 250);

                    setTimeout(function (){bg.style.opacity = 0.1;}, 50);
                    setTimeout(function (){bg.style.opacity = 0.2;}, 100);
                    setTimeout(function (){bg.style.opacity = 0.3;}, 150);
                    setTimeout(function (){bg.style.opacity = 0.4;}, 200);
                    setTimeout(function (){bg.style.opacity = 0.5;}, 250);

                    RGraph.Registry.Set(''chart.zoomed.area.bg'', bg);
                    RGraph.Registry.Set(''chart.zoomed.area.img'', img);
                    RGraph.Registry.Set(''chart.zoomed.area.div'', div);
                    RGraph.Registry.Set(''chart.zoomed.area.mousedown'', null);
                }

                /**
                * Fire the zoom event
                */
                RGraph.FireCustomEvent(obj, ''onzoom'');
            }
            
            canvas.onmouseout = function (e)
            {
                RGraph.Registry.Set(''chart.zoomed.area.areadiv'', null);
                RGraph.Registry.Set(''chart.zoomed.area.mousedown'', null);
                RGraph.Registry.Set(''chart.zoomed.area.div'', null);
            }
        }
    }


    /**
    * This function sets up the zoom window if requested
    * 
    * @param obj object The graph object
    */
    RGraph.ShowZoomWindow = function (obj)
    {
        if (obj.Get(''chart.zoom.mode'') == ''thumbnail'') {
            RGraph.ZoomWindow(obj.canvas);
        }

        if (obj.Get(''chart.zoom.mode'') == ''area'') {
            RGraph.ZoomArea(obj);
        }
    }


    /**
    * Installs the evnt handler for the zoom window/THUMBNAIL
    */
    RGraph.ZoomWindow = function (canvas)
    {
        canvas.onmousemove = function (e)
        {
            e = RGraph.FixEventObject(e);

            var obj     = e.target.__object__;
            var canvas  = obj.canvas;
            var context = obj.context;
            var coords  = RGraph.getMouseXY(e);
            
            /**
            * Create the DIV
            */
            if (!!RGraph.Registry.Get(''chart.zoomed.div'')) {

                var div = document.createElement(''div'');
                div.className    = ''RGraph_zoom_window'';
                div.style.width  = obj.Get(''chart.zoom.thumbnail.width'') + ''px'';
                div.style.height = obj.Get(''chart.zoom.thumbnail.height'') + ''px'';
                
                // Added back in on the 17th December
                div.style.border = ''2px dashed gray'';

                div.style.position = ''absolute'';
                div.style.overflow = ''hidden'';
                div.style.backgroundColor = ''white'';
                
                // Initially the zoomed layer should be off-screen
                div.style.left = ''-1000px'';
                div.style.top = ''-1000px'';

                // Should these be 0? No.
                div.style.borderRadius       = ''5px'';
                div.style.MozBorderRadius    = ''5px'';
                div.style.WebkitBorderRadius = ''5px'';

                if (obj.Get(''chart.zoom.shadow'')) {
                    div.style.boxShadow       = ''rgba(0,0,0,0.5) 3px 3px 3px'';
                    div.style.MozBoxShadow    = ''rgba(0,0,0,0.5) 3px 3px 3px'';
                    div.style.WebkitBoxShadow = ''rgba(0,0,0,0.5) 3px 3px 3px'';
                }

                //div.style.opacity = 0.2;
                div.__object__ = obj;
                document.body.appendChild(div);
        
                /**
                * Get the canvas as an image
                */
                var img = document.createElement(''img'');
                img.width  = obj.canvas.width * obj.Get(''chart.zoom.factor'');
                img.height = obj.canvas.height * obj.Get(''chart.zoom.factor'');
                img.style.position = ''relative'';
                img.style.backgroundColor = ''white'';
                img.__object__ = obj;

                div.appendChild(img);

                RGraph.Registry.Set(''chart.zoomed.div'', div);
                RGraph.Registry.Set(''chart.zoomed.img'', img);
                
                // Fade the zoom in
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').__object__.canvas.onmouseover()", 5);

            } else {

                div = RGraph.Registry.Get(''chart.zoomed.div'');
                img = RGraph.Registry.Get(''chart.zoomed.img'');
            }

            // Make sure the image is up-to-date
            img.src = canvas.toDataURL();
            
            /**
            * Ensure the div is visible
            */
            if (div && div.style.opacity < 1) {
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 1", 400);
            }

            /**
            * Get the canvas x/y coords
            */
            var c = RGraph.getCanvasXY(obj.canvas);
            var x = c[0];
            var y = c[1];

            /**
            * Position the div and img
            */
            var offset = 7;

            if (obj.Get(''chart.zoom.thumbnail.fixed'')) {
                div.style.left = (x + obj.Get(''chart.gutter.left'') + 5) + ''px'';
                div.style.top = (y + obj.Get(''chart.gutter.top'') + 5) + ''px'';

            } else {

                div.style.left = (e.pageX - obj.Get(''chart.zoom.thumbnail.width'') - offset) + ''px'';
                div.style.top = (e.pageY -  obj.Get(''chart.zoom.thumbnail.height'') - offset) + ''px'';
            }
            
            var l = (obj.Get(''chart.zoom.thumbnail.width'') / 2) - (coords[0] * obj.Get(''chart.zoom.factor''));
            var t = (obj.Get(''chart.zoom.thumbnail.height'') / 2) - (coords[1] * obj.Get(''chart.zoom.factor''));

            // More positioning
            img.style.left = (l + ((obj.Get(''chart.zoom.thumbnail.width'') / 2) * obj.Get(''chart.zoom.factor''))) + ''px'';
            img.style.top = (t + ((obj.Get(''chart.zoom.thumbnail.height'') / 2) * obj.Get(''chart.zoom.factor''))) + ''px'';
            
            if (obj.Get(''chart.zoom.thumbnail.fixed'')) {
                img.style.left = (l + (obj.Get(''chart.zoom.factor''))) + ''px'';
                img.style.top = (t + (obj.Get(''chart.zoom.factor''))) + ''px'';
            }
            
            /**
            * Fire the onzoom event
            */
            RGraph.FireCustomEvent(obj, ''onzoom'');
        }
        
        /**
        * The onmouseover event. Evidently. Fades the zoom window in
        */
        canvas.onmouseover = function (e)
        {
            var div = RGraph.Registry.Get(''chart.zoomed.div'');

            // ???
            if (!!div) return;
            
            /**
            * Allow for fixed positioning
            */
            if (div && RGraph.Registry.Get(''chart.zoomed.div'').__object__.Get(''chart.zoom.thumbnail.fixed'')) {
                return
            }

            var obj = div.__object__;

            // Used for the enlargement animation
            var targetWidth  = obj.Get(''chart.zoom.thumbnail.width'');
            var targetHeight = obj.Get(''chart.zoom.thumbnail.height'');

            div.style.width  = 0;
            div.style.height = 0;

            if (obj.Get(''chart.zoom.fade.in'')) {
                
                RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.2;
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.1", 25);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.2", 50);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.3", 75);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.4", 100);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.5", 125);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.6", 150);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.7", 175);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.8", 200);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.9", 225);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 1.0", 250);

            } else {

                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 1", 1);
            }

            // The enlargement animation frames
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (1/10) ) + "px''", 25);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (2/10) ) + "px''", 50);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (3/10) ) + "px''", 75);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (4/10) ) + "px''", 100);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (5/10) ) + "px''", 125);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (6/10) ) + "px''", 150);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (7/10) ) + "px''", 175);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (8/10) ) + "px''", 200);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (9/10) ) + "px''", 225);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.width = ''" + (targetWidth * (10/10) ) + "px''", 250);
            
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (1/10) ) + "px''", 25);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (2/10) ) + "px''", 50);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (3/10) ) + "px''", 75);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (4/10) ) + "px''", 100);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (5/10) ) + "px''", 125);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (6/10) ) + "px''", 150);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (7/10) ) + "px''", 175);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (8/10) ) + "px''", 200);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (9/10) ) + "px''", 225);
            setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.height = ''" + (targetHeight * (10/10) ) + "px''", 250);
        }
        
        canvas.onmouseout = function (e)
        {
            if (RGraph.Registry.Get(''chart.zoomed.div'') && RGraph.Registry.Get(''chart.zoomed.div'').__object__.Get(''chart.zoom.fade.out'') && !!RGraph.Registry.Get(''chart.zoomed.div'').__object__.Get(''chart.zoom.thumbnail.fixed'')) {

                RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.8;
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.6", 100);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.4", 200);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.2", 300);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0", 400);

                // Get rid of the zoom window
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.left = ''-400px''", 400);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.top = ''-400px''", 400);
            
            } else if (!!RGraph.Registry.Get(''chart.zoomed.div'').__object__.Get(''chart.zoom.thumbnail.fixed'')) {
                // Get rid of the zoom window
                if (RGraph.Registry.Get(''chart.zoomed.div'')) {
                    setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.left = ''-400px''", 1);
                    setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.top = ''-400px''", 41);
                }
            }
        }
    }


    /**
    * A zoom in function
    * 
    * @param e object The event object
    */
    RGraph.Zoom = function (e)
    {
        e = RGraph.FixEventObject(e);

        /**
        * Show the zoom window
        */
        //if ((e.target.__canvas__ && e.target.__canvas__.__object__.Get(''chart.zoom.mode'') == ''thumbnail'') || (e.target.parentNode.__canvas__ && e.target.parentNode.__canvas__.__object__.Get(''chart.zoom.mode'') == ''thumbnail'') ) {
        //    return RGraph.ZoomWindow(e);
        //}
        if (e && e.target && e.target.__canvas__) {
            var canvas  = e.target.__canvas__;
        
        /*******************************************************
        * This is here to facilitate zooming by just a single left click
        *******************************************************/
        } else if (e && e.target && e.target.__object__) {
            var canvas = e.target.__object__.canvas;
            e.stopPropagation(); // Hmmmm
        }

        // Fallback for MSIE9
        if (!!canvas) {
            var registry_canvas = RGraph.Registry.Get(''chart.contextmenu'').__canvas__;
            if (registry_canvas) {
                var canvas = registry_canvas;
            }
        }

        var context = canvas.getContext(''2d'');
        var obj     = canvas.__object__;
        var dataurl = canvas.toDataURL();
        var tmp     = canvas;
        var coords = RGraph.getCanvasXY(canvas);
        var factor = obj.Get(''chart.zoom.factor'') - 1;

        var x = coords[0];
        var y = coords[1];

        var img = document.createElement(''img'');
        img.className    = ''RGraph_zoomed_canvas'';
        img.style.border = ''3px solid gray'';
        img.style.width  = canvas.width + ''px'';
        img.style.height = canvas.height + ''px'';
        img.style.position = ''absolute'';
        img.style.left = x + ''px'';
        img.style.top = y + ''px'';
        img.style.backgroundColor = ''white'';
        img.style.opacity = obj.Get(''chart.zoom.fade.in'') ? 0 : 1;
        img.style.zIndex = 99;
        img.src = dataurl;
        document.body.appendChild(img);

        //RGraph.Registry.Set(''chart.zoomedimage'', img);
        // Store the zoomed image in a global var - NOT the registry
        __zoomedimage__ = img;
        __zoomedimage__.obj = obj;
        
        // Image onclick should not hide the image
        img.onclick = function (e)
        {
            e = RGraph.FixEventObject(e);
            e.stopPropagation();
            return false;
        }

        setTimeout(function (){window.onclick = RGraph.HideZoomedCanvas;}, 1);
        
        var width = parseInt(canvas.width);
        var height = parseInt(canvas.height);
        var frames = obj.Get(''chart.zoom.frames'');
        var delay  = obj.Get(''chart.zoom.delay'');

        // Increase the width over 10 frames - center
        if (obj.Get(''chart.zoom.hdir'') == ''center'') {

            for (var i=1; i<=frames; ++i) {
                var newWidth      = width * factor * (i/frames) + width;
                var rightHandEdge = x + canvas.width;
                var newLeft       = (x + (canvas.width / 2)) - (newWidth / 2);

                setTimeout("__zoomedimage__.style.width = ''" + String(newWidth) + "px''; __zoomedimage__.style.left = ''" + newLeft + "px''", i * delay);
            }

        // Left
        } else if (obj.Get(''chart.zoom.hdir'') == ''left'') {
            for (var i=1; i<=frames; ++i) {
                var newWidth      = width * factor * (i/frames) + width;
                var rightHandEdge = x + canvas.width;
                var newLeft       = rightHandEdge - newWidth;

                setTimeout("__zoomedimage__.style.width = ''" + String(newWidth) + "px''; __zoomedimage__.style.left = ''" + newLeft + "px''", i * delay);
            }
            
        // Right (default)
        } else {
            for (var i=1; i<=frames; ++i) {
                var newWidth      = width * factor * (i/frames) + width;
                setTimeout("__zoomedimage__.style.width = ''" + String(newWidth) + "px''", i * delay);
            }
        }

        // Increase the height over 10 frames - up
        if (obj.Get(''chart.zoom.vdir'') == ''up'') {
            for (var i=1; i<=frames; ++i) {
                var newHeight  = (height * factor * (i/frames)) + height;
                var bottomEdge = y + canvas.height;
                var newTop       = bottomEdge - newHeight;
        
                setTimeout("__zoomedimage__.style.height = ''" + String(newHeight) + "px''; __zoomedimage__.style.top = ''" + newTop + "px''", i * delay);
            }
        
        // center
        } else if (obj.Get(''chart.zoom.vdir'') == ''center'') {
            for (var i=1; i<=frames; ++i) {
                var newHeight  = (height * factor * (i/frames)) + height;
                var bottomEdge = (y + (canvas.height / 2)) + (newHeight / 2);
                var newTop       = bottomEdge - newHeight;

                setTimeout("__zoomedimage__.style.height = ''" + String(newHeight) + "px''; __zoomedimage__.style.top = ''" + newTop + "px''", i * delay);
            }
        
        // Down (default
        } else {
            for (var i=1; i<=frames; ++i) {
                setTimeout("__zoomedimage__.style.height = ''" + String(height * factor * (i/frames) + height) + "px''", i * delay);
            }
        }

        // If enabled, increase the opactity over the requested number of frames
        if (obj.Get(''chart.zoom.fade.in'')) {
            for (var i=1; i<=frames; ++i) {
                setTimeout("__zoomedimage__.style.opacity = " + Number(i / frames), i * (delay / 2));
            }
        }

        // If stipulated, produce a shadow
        if (obj.Get(''chart.zoom.shadow'')) {
            for (var i=1; i<=frames; ++i) {
                setTimeout("__zoomedimage__.style.boxShadow = ''rgba(128,128,128," + Number(i / frames) / 2 + ") 0 0 15px''", i * delay);
                setTimeout("__zoomedimage__.style.MozBoxShadow = ''rgba(128,128,128," + Number(i / frames) / 2 + ") 0 0 15px''", i * delay);
                setTimeout("__zoomedimage__.style.WebkitBoxShadow = ''rgba(128,128,128," + Number(i / frames) / 2 + ") 0 0 15px''", i * delay);
            }
        }

        /**
        * The onmouseout event. Hides the zoom window. Fades the zoom out
        *
        canvas.onmouseout = function (e)
        {
            if (RGraph.Registry.Get(''chart.zoomed.div'') && RGraph.Registry.Get(''chart.zoomed.div'').__object__.Get(''chart.zoom.fade.out'')) {

                RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.8;
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.6", 100);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.4", 200);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0.2", 300);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.opacity = 0", 400);

                // Get rid of the zoom window
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.left = ''-400px''", 400);
                setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.top = ''-400px''", 400);
            
            } else {

                // Get rid of the zoom window
                if (RGraph.Registry.Get(''chart.zoomed.div'')) {
                    setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.left = ''-400px''", 1);
                    setTimeout("RGraph.Registry.Get(''chart.zoomed.div'').style.top = ''-400px''", 1);
                }
            }
        }
        */

        // The background
        if (obj.Get(''chart.zoom.background'')) {

            var div = document.createElement(''DIV'');
            div.style.backgroundColor = ''#999'';
            div.style.opacity         = 0;
            div.style.position        = ''fixed'';
            div.style.top             = 0;
            div.style.left            = 0;
            div.style.width           = (screen.width + 100) + ''px'';
            div.style.height          = (screen.height + 100) + ''px'';
            div.style.zIndex          = 98;

            // Hides the zoomed caboodle
            div.oncontextmenu = function (e)
            {
                return RGraph.HideZoomedCanvas(e);
            }

            // 30th July 2010 - Is this necessary?
            //for (var i=1; i<=frames; ++i) {
            //  setTimeout(''__zoomedbackground__.style.opacity = '' + Number(0.04 * i), i * delay);
            //
            //    //  MSIE doesn''t support zoom
            //    //setTimeout(''__zoomedbackground__.style.filter = "progid:DXImageTransform.Microsoft.Shadow(color=#aaaaaa,direction=135); Alpha(opacity=10)"'', 50);
            //}
            
            div.origHeight = div.style.height;
            
            document.body.appendChild(div);

            __zoomedbackground__ = div;
            
            // If the window is resized, hide the zoom
            //window.onresize = RGraph.HideZoomedCanvas;

            for (var i=1; i<=frames; ++i) {
                setTimeout("__zoomedbackground__.style.opacity = " + (Number(i / frames) * 0.5), i * (delay / 2));
            }
        }
        
        /**
        * Fire the onzoom event
        */
        RGraph.FireCustomEvent(obj, ''onzoom'');
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:27'!
RGraphlineJs
	^ '/**
/**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */
    
    if (typeof(RGraph) == ''undefined'') RGraph = {};

    /**
    * The line chart constructor
    * 
    * @param object canvas The cxanvas object
    * @param array  data   The chart data
    * @param array  ...    Other lines to plot
    */
    RGraph.Line = function (id)
    {
        // Get the canvas and context objects
        this.id                = id;
        this.canvas            = document.getElementById(id);
        this.context           = this.canvas.getContext ? this.canvas.getContext("2d") : null;
        this.canvas.__object__ = this;
        this.type              = ''line'';
        this.max               = 0;
        this.coords            = [];
        this.coords2           = [];
        this.coordsKey         = [];
        this.hasnegativevalues = false;
        this.isRGraph          = true;



        /**
        * Compatibility with older browsers
        */
        RGraph.OldBrowserCompat(this.context);


        // Various config type stuff
        this.properties = {
            ''chart.background.barcolor1'':   ''rgba(0,0,0,0)'',
            ''chart.background.barcolor2'':   ''rgba(0,0,0,0)'',
            ''chart.background.grid'':        1,
            ''chart.background.grid.width'':  1,
            ''chart.background.grid.hsize'':  25,
            ''chart.background.grid.vsize'':  25,
            ''chart.background.grid.color'':  ''#ddd'',
            ''chart.background.grid.vlines'': true,
            ''chart.background.grid.hlines'': true,
            ''chart.background.grid.border'': true,
            ''chart.background.grid.autofit'':           true,
            ''chart.background.grid.autofit.align'':     false,
            ''chart.background.grid.autofit.numhlines'': 5,
            ''chart.background.grid.autofit.numvlines'': 20,
            ''chart.background.hbars'':       null,
            ''chart.background.image'':       null,
            ''chart.background.image.stretch'': true,
            ''chart.background.image.x'':     null,
            ''chart.background.image.y'':     null,
            ''chart.background.image.align'': null,
            ''chart.labels'':                 null,
            ''chart.labels.ingraph'':         null,
            ''chart.labels.above'':           false,
            ''chart.labels.above.size'':      8,
            ''chart.xtickgap'':               20,
            ''chart.smallxticks'':            3,
            ''chart.largexticks'':            5,
            ''chart.ytickgap'':               20,
            ''chart.smallyticks'':            3,
            ''chart.largeyticks'':            5,
            ''chart.numyticks'':              10,
            ''chart.linewidth'':              1.01,
            ''chart.colors'':                 [''red'', ''#0f0'', ''#00f'', ''#f0f'', ''#ff0'', ''#0ff''],
            ''chart.hmargin'':                0,
            ''chart.tickmarks.dot.color'':    ''white'',
            ''chart.tickmarks'':              null,
            ''chart.tickmarks.linewidth'':    null,
            ''chart.ticksize'':               3,
            ''chart.gutter.left'':            25,
            ''chart.gutter.right'':           25,
            ''chart.gutter.top'':             25,
            ''chart.gutter.bottom'':          25,
            ''chart.tickdirection'':          -1,
            ''chart.yaxispoints'':            5,
            ''chart.fillstyle'':              null,
            ''chart.xaxispos'':               ''bottom'',
            ''chart.yaxispos'':               ''left'',
            ''chart.xticks'':                 null,
            ''chart.text.size'':              10,
            ''chart.text.angle'':             0,
            ''chart.text.color'':             ''black'',
            ''chart.text.font'':              ''Arial'',
            ''chart.ymin'':                   null,
            ''chart.ymax'':                   null,
            ''chart.title'':                  '''',
            ''chart.title.background'':       null,
            ''chart.title.hpos'':             null,
            ''chart.title.vpos'':             0.5,
            ''chart.title.bold'':             true,
            ''chart.title.font'':             null,
            ''chart.title.xaxis'':            '''',
            ''chart.title.xaxis.bold'':       true,
            ''chart.title.xaxis.size'':       null,
            ''chart.title.xaxis.font'':       null,
            ''chart.title.yaxis'':            '''',
            ''chart.title.yaxis.bold'':       true,
            ''chart.title.yaxis.size'':       null,
            ''chart.title.yaxis.font'':       null,
            ''chart.title.xaxis.pos'':        null,
            ''chart.title.yaxis.pos'':        null,
            ''chart.shadow'':                 false,
            ''chart.shadow.offsetx'':         2,
            ''chart.shadow.offsety'':         2,
            ''chart.shadow.blur'':            3,
            ''chart.shadow.color'':           ''rgba(0,0,0,0.5)'',
            ''chart.tooltips'':               null,
            ''chart.tooltips.hotspot.xonly'': false,
            ''chart.tooltips.effect'':        ''fade'',
            ''chart.tooltips.css.class'':     ''RGraph_tooltip'',
            ''chart.tooltips.event'':         ''onmousemove'',
            ''chart.tooltips.highlight'':     true,
            ''chart.highlight.stroke'':       ''#999'',
            ''chart.highlight.fill'':         ''white'',
            ''chart.stepped'':                false,
            ''chart.key'':                    [],
            ''chart.key.background'':         ''white'',
            ''chart.key.position'':           ''graph'',
            ''chart.key.halign'':             null,
            ''chart.key.shadow'':             false,
            ''chart.key.shadow.color'':       ''#666'',
            ''chart.key.shadow.blur'':        3,
            ''chart.key.shadow.offsetx'':     2,
            ''chart.key.shadow.offsety'':     2,
            ''chart.key.position.gutter.boxed'': true,
            ''chart.key.position.x'':         null,
            ''chart.key.position.y'':         null,
            ''chart.key.color.shape'':        ''square'',
            ''chart.key.rounded'':            true,
            ''chart.key.linewidth'':          1,
            ''chart.key.colors'':             null,
            ''chart.key.interactive'':        false,
            ''chart.contextmenu'':            null,
            ''chart.ylabels'':                true,
            ''chart.ylabels.count'':          5,
            ''chart.ylabels.inside'':         false,
            ''chart.ylabels.invert'':         false,
            ''chart.xlabels.inside'':         false,
            ''chart.xlabels.inside.color'':   ''rgba(255,255,255,0.5)'',
            ''chart.noaxes'':                 false,
            ''chart.noyaxis'':                false,
            ''chart.noxaxis'':                false,
            ''chart.noendxtick'':             false,
            ''chart.units.post'':             '''',
            ''chart.units.pre'':              '''',
            ''chart.scale.decimals'':         null,
            ''chart.scale.point'':            ''.'',
            ''chart.scale.thousand'':         '','',
            ''chart.crosshairs'':             false,
            ''chart.crosshairs.color'':       ''#333'',
            ''chart.crosshairs.hline'':       true,
            ''chart.crosshairs.vline'':       true,
            ''chart.annotatable'':            false,
            ''chart.annotate.color'':         ''black'',
            ''chart.axesontop'':              false,
            ''chart.filled'':                 false,
            ''chart.filled.range'':           false,
            ''chart.filled.accumulative'':    true,
            ''chart.variant'':                null,
            ''chart.axis.color'':             ''black'',
            ''chart.zoom.factor'':            1.5,
            ''chart.zoom.fade.in'':           true,
            ''chart.zoom.fade.out'':          true,
            ''chart.zoom.hdir'':              ''right'',
            ''chart.zoom.vdir'':              ''down'',
            ''chart.zoom.frames'':            25,
            ''chart.zoom.delay'':             16.666,
            ''chart.zoom.shadow'':            true,
            ''chart.zoom.mode'':              ''canvas'',
            ''chart.zoom.thumbnail.width'':   75,
            ''chart.zoom.thumbnail.height'':  75,
            ''chart.zoom.thumbnail.fixed'':   false,
            ''chart.zoom.background'':        true,
            ''chart.zoom.action'':            ''zoom'',
            ''chart.backdrop'':               false,
            ''chart.backdrop.size'':          30,
            ''chart.backdrop.alpha'':         0.2,
            ''chart.resizable'':              false,
            ''chart.resize.handle.adjust'':   [0,0],
            ''chart.resize.handle.background'': null,
            ''chart.adjustable'':             false,
            ''chart.noredraw'':               false,
            ''chart.outofbounds'':            false,
            ''chart.chromefix'':              true,
            ''chart.animation.factor'':       1,
            ''chart.animation.unfold.x'':     false,
            ''chart.animation.unfold.y'':     true,
            ''chart.animation.unfold.initial'': 2,
            ''chart.curvy'':                    false,
            ''chart.curvy.factor'':             0.25,
            ''chart.line.visible'':             true,
            ''chart.events.click'':             null,
            ''chart.events.mousemove'':         null
        }

        /**
        * Change null arguments to empty arrays
        */
        for (var i=1; i<arguments.length; ++i) {
            if (typeof(arguments[i]) == ''null'' || !!arguments[i]) {
                arguments[i] = [];
            }
        }


        /**
        * Store the original data. Thiss also allows for giving arguments as one big array.
        */
        this.original_data = [];

        for (var i=1; i<arguments.length; ++i) {
            if (arguments[1] && typeof(arguments[1]) == ''object'' && arguments[1][0] && typeof(arguments[1][0]) == ''object'' && arguments[1][0].length) {

                var tmp = [];

                for (var i=0; i<arguments[1].length; ++i) {
                    tmp[i] = RGraph.array_clone(arguments[1][i]);
                }

                for (var j=0; j<tmp.length; ++j) {
                    this.original_data[j] = RGraph.array_clone(tmp[j]);
                }

            } else {
                this.original_data[i - 1] = RGraph.array_clone(arguments[i]);
            }
        }

        // Check for support
        if (!!this.canvas) {
            alert(''[LINE] Fatal error: no canvas support'');
            return;
        }
        
        /**
        * Store the data here as one big array
        */
        this.data_arr = [];

        for (var i=1; i<arguments.length; ++i) {
            for (var j=0; j<arguments[i].length; ++j) {
                this.data_arr.push(arguments[i][j]);
            }
        }


        /**
        * Set the .getShape commonly named method
        */
        this.getShape = this.getPoint;
    }


    /**
    * An all encompassing accessor
    * 
    * @param string name The name of the property
    * @param mixed value The value of the property
    */
    RGraph.Line.prototype.Set = function (name, value)
    {
        // Consolidate the tooltips
        if (name == ''chart.tooltips'' && typeof value == ''object'' && value) {

            var tooltips = [];

            for (var i=1; i<arguments.length; i++) {
                if (typeof(arguments[i]) == ''object'' && arguments[i][0]) {
                    for (var j=0; j<arguments[i].length; j++) {
                        tooltips.push(arguments[i][j]);
                    }

                } else if (typeof(arguments[i]) == ''function'') {
                    tooltips = arguments[i];

                } else {
                    tooltips.push(arguments[i]);
                }
            }

            // Because "value" is used further down at the end of this function, set it to the expanded array os tooltips
            value = tooltips;
        }

        /**
        * Reverse the tickmarks to make them correspond to the right line
        */
        if (name == ''chart.tickmarks'' && typeof(value) == ''object'' && value) {
            value = RGraph.array_reverse(value);
        }
        
        /**
        * Inverted Y axis should show the bottom end of the scale
        */
        if (name == ''chart.ylabels.invert'' && value && this.Get(''chart.ymin'') == null) {
            this.Set(''chart.ymin'', 0);
        }
        
        /**
        * If (buggy) Chrome and the linewidth is 1, change it to 1.01
        */
        if (name == ''chart.linewidth'' && navigator.userAgent.match(/Chrome/)) {
            if (value == 1) {
                value = 1.01;
            
            } else if (RGraph.is_array(value)) {
                for (var i=0; i<value.length; ++i) {
                    if (typeof(value[i]) == ''number'' && value[i] == 1) {
                        value[i] = 1.01;
                    }
                }
            }
        }
        
        /**
        * Check for xaxispos
        */
        if (name == ''chart.xaxispos'' ) {
            if (value !!= ''bottom'' && value !!= ''center'' && value !!= ''top'') {
                alert(''[LINE] ('' + this.id + '') chart.xaxispos should be top, center or bottom. Tried to set it to: '' + value + '' Changing it to center'');
                value = ''center'';
            }
        }
        
        /**
        * Check chart.curvy.factor - should be 0 - 0.5
        */
        if (name == ''chart.curvy.factor'' && (value < 0 || value > 0.5)) {
            alert(''[LINE] chart.curvy.factor should be between 0 and 0.5 - setting it to 0.25'');
            value = 0.25;
        }
        
        /**
        * chart.xticks is now calledchart.numxticks
        */
        if (name == ''chart.numxticks'') {
            name = ''chart.xticks'';
        }

        this.properties[name] = value;
    }


    /**
    * An all encompassing accessor
    * 
    * @param string name The name of the property
    */
    RGraph.Line.prototype.Get = function (name)
    {
        return this.properties[name];
    }


    /**
    * The function you call to draw the line chart
    * 
    * @param bool An optional bool used internally to ditinguish whether the
    *             line chart is being called by the bar chart
    */
    RGraph.Line.prototype.Draw = function ()
    {
        // MUST be the FIRST thing done - Hand over drawing to the bar chart if it''s a combo back to the Bar chart
        if (this.__bar__ && !!arguments[0]) {
            this.__bar__.Draw();
            return;
        }

        // MUST be the SECOND thing done!!
        if (typeof(this.Get(''chart.background.image'')) == ''string'' && !!this.__background_image__) {
            RGraph.DrawBackgroundImage(this);
            return;
        }
        
        if (this.__bar__ && this.Get(''chart.tooltips.highlight'')) {
            //this.Set(''chart.tooltips.highlight'', false);
        }

        /**
        * Fire the onbeforedraw event
        */
        RGraph.FireCustomEvent(this, ''onbeforedraw'');

        /**
        * Clear all of this canvases event handlers (the ones installed by RGraph)
        */
        RGraph.ClearEventListeners(this.id);
        
        /**
        * This is new in May 2011 and facilitates indiviual gutter settings,
        * eg chart.gutter.left
        */
        this.gutterLeft   = this.Get(''chart.gutter.left'');
        this.gutterRight  = this.Get(''chart.gutter.right'');
        this.gutterTop    = this.Get(''chart.gutter.top'');
        this.gutterBottom = this.Get(''chart.gutter.bottom'');


        /**
        * Check for Chrome 6 and shadow
        * 
        * TODO Remove once it''s been fixed (for a while)
        * 29/10/2011 - Looks like it''s been fixed as long the linewidth is at least 1.01
        * SEARCH TAGS: CHROME FIX SHADOW BUG
        */
        if (   this.Get(''chart.shadow'')
            && navigator.userAgent.match(/Chrome/)
            && this.Get(''chart.linewidth'') <= 1
            && this.Get(''chart.chromefix'')
            && this.Get(''chart.shadow.blur'') > 0) {
                alert(''[RGRAPH WARNING] Chrome has a shadow bug, meaning you should increase the linewidth to at least 1.01'');
        }


        // Reset the data back to that which was initially supplied
        this.data = RGraph.array_clone(this.original_data);


        // Reset the max value
        this.max = 0;

        /**
        * Reverse the datasets so that the data and the labels tally
        *  COMMENTED OUT 15TH AUGUST 2011
        */
        //this.data = RGraph.array_reverse(this.data);

        if (this.Get(''chart.filled'') && !!this.Get(''chart.filled.range'') && this.data.length > 1 && this.Get(''chart.filled.accumulative'')) {

            var accumulation = [];
        
            for (var set=0; set<this.data.length; ++set) {
                for (var point=0; point<this.data[set].length; ++point) {
                    this.data[set][point] = Number(accumulation[point] ? accumulation[point] : 0) + this.data[set][point];
                    accumulation[point] = this.data[set][point];
                }
            }
        }

        /**
        * Get the maximum Y scale value
        */
        if (this.Get(''chart.ymax'')) {
            
            this.max = this.Get(''chart.ymax'');
            this.min = this.Get(''chart.ymin'') ? this.Get(''chart.ymin'') : 0;

            this.scale = [
                          ( ((this.max - this.min) * (1/5)) + this.min).toFixed(this.Get(''chart.scale.decimals'')),
                          ( ((this.max - this.min) * (2/5)) + this.min).toFixed(this.Get(''chart.scale.decimals'')),
                          ( ((this.max - this.min) * (3/5)) + this.min).toFixed(this.Get(''chart.scale.decimals'')),
                          ( ((this.max - this.min) * (4/5)) + this.min).toFixed(this.Get(''chart.scale.decimals'')),
                          this.max.toFixed(this.Get(''chart.scale.decimals''))
                         ];

            // Check for negative values
            if (!!this.Get(''chart.outofbounds'')) {
                for (dataset=0; dataset<this.data.length; ++dataset) {
                    for (var datapoint=0; datapoint<this.data[dataset].length; datapoint++) {
            
                        // Check for negative values
                        this.hasnegativevalues = (this.data[dataset][datapoint] < 0) || this.hasnegativevalues;
                    }
                }
            }

        } else {

            this.min = this.Get(''chart.ymin'') ? this.Get(''chart.ymin'') : 0;

            // Work out the max Y value
            for (dataset=0; dataset<this.data.length; ++dataset) {
                for (var datapoint=0; datapoint<this.data[dataset].length; datapoint++) {
    
                    this.max = Math.max(this.max, this.data[dataset][datapoint] ? Math.abs(parseFloat(this.data[dataset][datapoint])) : 0);
    
                    // Check for negative values
                    if (!!this.Get(''chart.outofbounds'')) {
                        this.hasnegativevalues = (this.data[dataset][datapoint] < 0) || this.hasnegativevalues;
                    }
                }
            }

            // 20th April 2009 - moved out of the above loop
            this.scale = RGraph.getScale(Math.abs(parseFloat(this.max)), this);
            this.max   = this.scale[4] ? this.scale[4] : 0;

            if (this.Get(''chart.ymin'')) {
                this.scale[0] = ((this.max - this.Get(''chart.ymin'')) * (1/5)) + this.Get(''chart.ymin'');
                this.scale[1] = ((this.max - this.Get(''chart.ymin'')) * (2/5)) + this.Get(''chart.ymin'');
                this.scale[2] = ((this.max - this.Get(''chart.ymin'')) * (3/5)) + this.Get(''chart.ymin'');
                this.scale[3] = ((this.max - this.Get(''chart.ymin'')) * (4/5)) + this.Get(''chart.ymin'');
                this.scale[4] = ((this.max - this.Get(''chart.ymin'')) * (5/5)) + this.Get(''chart.ymin'');
            }

            if (typeof(this.Get(''chart.scale.decimals'')) == ''number'') {
                this.scale[0] = Number(this.scale[0]).toFixed(this.Get(''chart.scale.decimals''));
                this.scale[1] = Number(this.scale[1]).toFixed(this.Get(''chart.scale.decimals''));
                this.scale[2] = Number(this.scale[2]).toFixed(this.Get(''chart.scale.decimals''));
                this.scale[3] = Number(this.scale[3]).toFixed(this.Get(''chart.scale.decimals''));
                this.scale[4] = Number(this.scale[4]).toFixed(this.Get(''chart.scale.decimals''));
            }
        }

        /**
        * Setup the context menu if required
        */
        if (this.Get(''chart.contextmenu'')) {
            RGraph.ShowContext(this);
        }

        /**
        * Reset the coords array otherwise it will keep growing
        */
        this.coords = [];

        /**
        * Work out a few things. They need to be here because they depend on things you can change before you
        * call Draw() but after you instantiate the object
        */
        this.grapharea      = this.canvas.height - this.gutterTop - this.gutterBottom;
        this.halfgrapharea  = this.grapharea / 2;
        this.halfTextHeight = this.Get(''chart.text.size'') / 2;

        // Check the combination of the X axis position and if there any negative values
        //
        // 19th Dec 2010 - removed for Opera since it can be reported incorrectly whn there
        // are multiple graphs on the page
        if (this.Get(''chart.xaxispos'') == ''bottom'' && this.hasnegativevalues && navigator.userAgent.indexOf(''Opera'') == -1) {
            alert(''[LINE] You have negative values and the X axis is at the bottom. This is not good...'');
        }

        if (this.Get(''chart.variant'') == ''3d'') {
            RGraph.Draw3DAxes(this);
        }
        
        // Progressively Draw the chart
        RGraph.background.Draw(this);

        /**
        * Draw any horizontal bars that have been defined
        */
        if (this.Get(''chart.background.hbars'') && this.Get(''chart.background.hbars'').length > 0) {
            RGraph.DrawBars(this);
        }

        if (this.Get(''chart.axesontop'') == false) {
            this.DrawAxes();
        }

        /**
        * Handle the appropriate shadow color. This now facilitates an array of differing
        * shadow colors
        */
        var shadowColor = this.Get(''chart.shadow.color'');
        
        //if (typeof(shadowColor) == ''object'') {
        //    shadowColor = RGraph.array_reverse(RGraph.array_clone(this.Get(''chart.shadow.color'')));
        //}


        for (var i=0, j=0; i<this.data.length; i++, j++) {

            this.context.beginPath();

            /**
            * Turn on the shadow if required
            */
            if (this.Get(''chart.shadow'') && !!this.Get(''chart.filled'')) {

                /**
                * Accommodate an array of shadow colors as well as a single string
                */
                if (typeof(shadowColor) == ''object'' && shadowColor[i - 1]) {
                    this.context.shadowColor = shadowColor[i];
                } else if (typeof(shadowColor) == ''object'') {
                    this.context.shadowColor = shadowColor[0];
                } else if (typeof(shadowColor) == ''string'') {
                    this.context.shadowColor = shadowColor;
                }

                this.context.shadowBlur    = this.Get(''chart.shadow.blur'');
                this.context.shadowOffsetX = this.Get(''chart.shadow.offsetx'');
                this.context.shadowOffsetY = this.Get(''chart.shadow.offsety'');
            
            } else if (this.Get(''chart.filled'') && this.Get(''chart.shadow'')) {
                alert(''[LINE] Shadows are not permitted when the line is filled'');
            }

            /**
            * Draw the line
            */

            if (this.Get(''chart.fillstyle'')) {
                if (typeof(this.Get(''chart.fillstyle'')) == ''object'' && this.Get(''chart.fillstyle'')[j]) {
                   var fill = this.Get(''chart.fillstyle'')[j];
                
                } else if (typeof(this.Get(''chart.fillstyle'')) == ''string'') {
                    var fill = this.Get(''chart.fillstyle'');
    
                } else {
                    alert(''[LINE] Warning: chart.fillstyle must be either a string or an array with the same number of elements as you have sets of data'');
                }
            } else if (this.Get(''chart.filled'')) {
                var fill = this.Get(''chart.colors'')[j];

            } else {
                var fill = null;
            }

            /**
            * Figure out the tickmark to use
            */
            if (this.Get(''chart.tickmarks'') && typeof(this.Get(''chart.tickmarks'')) == ''object'') {
                var tickmarks = this.Get(''chart.tickmarks'')[i];
            } else if (this.Get(''chart.tickmarks'') && typeof(this.Get(''chart.tickmarks'')) == ''string'') {
                var tickmarks = this.Get(''chart.tickmarks'');
            } else if (this.Get(''chart.tickmarks'') && typeof(this.Get(''chart.tickmarks'')) == ''function'') {
                var tickmarks = this.Get(''chart.tickmarks'');
            } else {
                var tickmarks = null;
            }


            this.DrawLine(this.data[i],
                          this.Get(''chart.colors'')[j],
                          fill,
                          this.GetLineWidth(j),
                           tickmarks,
                           i);

            this.context.stroke();
        }

    /**
    * If the line is filled re-stroke the lines
    */
    if (this.Get(''chart.filled'') && this.Get(''chart.filled.accumulative'')) {

        for (var i=0; i<this.coords2.length; ++i) {

            this.context.beginPath();
            this.context.lineWidth = this.GetLineWidth(i);
            this.context.strokeStyle = this.Get(''chart.colors'')[i];

            for (var j=0; j<this.coords2[i].length; ++j) {

                if (j == 0 || this.coords2[i][j][1] == null || (this.coords2[i][j - 1] && this.coords2[i][j - 1][1] == null)) {
                    this.context.moveTo(this.coords2[i][j][0], this.coords2[i][j][1]);
                } else {
                    if (this.Get(''chart.stepped'')) {
                        this.context.lineTo(this.coords2[i][j][0], this.coords2[i][j - 1][1]);
                    }
                    this.context.lineTo(this.coords2[i][j][0], this.coords2[i][j][1]);
                }
            }
            
            this.context.stroke();
            // No fill!!
        }

        //Redraw the tickmarks
        if (this.Get(''chart.tickmarks'')) {

            this.context.beginPath();

            this.context.fillStyle = ''white'';
            
            for (var i=0; i<this.coords2.length; ++i) {

                this.context.beginPath();
                this.context.strokeStyle = this.Get(''chart.colors'')[i];
                for (var j=0; j<this.coords2[i].length; ++j) {
                    if (typeof(this.coords2[i][j]) == ''object'' && typeof(this.coords2[i][j][0]) == ''number'' && typeof(this.coords2[i][j][1]) == ''number'') {
                        
                        var tickmarks = typeof(this.Get(''chart.tickmarks'')) == ''object'' ? this.Get(''chart.tickmarks'')[i] : this.Get(''chart.tickmarks'');

                        this.DrawTick(  this.coords2[i][j],
                                        this.coords2[i][j][0],
                                        this.coords2[i][j][1],
                                        this.context.strokeStyle,
                                        false,
                                        j == 0 ? 0 : this.coords2[i][j - 1][0],
                                        j == 0 ? 0 : this.coords2[i][j - 1][1],
                                        tickmarks,
                                        j);
                    }
                }
            }

            this.context.stroke();
            this.context.fill();
        }
    }

    // ???
    this.context.beginPath();










        /**
        * Install the clickand mousemove event listeners
        */
        RGraph.InstallUserClickListener(this, this.Get(''chart.events.click''));
        RGraph.InstallUserMousemoveListener(this, this.Get(''chart.events.mousemove''));






        /**
        * If tooltips are defined, handle them
        */
        if (this.Get(''chart.tooltips'') && (this.Get(''chart.tooltips'').length || typeof(this.Get(''chart.tooltips'')) == ''function'')) {

            // Need to register this object for redrawing
            if (this.Get(''chart.tooltips.highlight'')) {
                RGraph.Register(this);
            }
            
            RGraph.PreLoadTooltipImages(this);

            RGraph.InstallLineTooltipEventListeners(this);
            
            /**
            * If there''s a bar, install the event listeners
            */
            if (this.__bar__) {
                RGraph.InstallBarTooltipEventListeners(this.__bar__);
            }
        }














        /**
        * If the axes have been requested to be on top, do that
        */
        if (this.Get(''chart.axesontop'')) {
            this.DrawAxes();
        }

        /**
        * Draw the labels
        */
        this.DrawLabels();
        
        /**
        * Draw the range if necessary
        */
        this.DrawRange();
        
        // Draw a key if necessary
        if (this.Get(''chart.key'').length) {
            RGraph.DrawKey(this, this.Get(''chart.key''), this.Get(''chart.colors''));
        }

        /**
        * Draw " above" labels if enabled
        */
        if (this.Get(''chart.labels.above'')) {
            this.DrawAboveLabels();
        }

        /**
        * Draw the "in graph" labels
        */
        RGraph.DrawInGraphLabels(this);

        /**
        * Draw crosschairs
        */
        RGraph.DrawCrosshairs(this);
        
        /**
        * If the canvas is annotatable, do install the event handlers
        */
        if (this.Get(''chart.annotatable'')) {
            RGraph.Annotate(this);
        }

        /**
        * Redraw the lines if a filled range is on the cards
        */
        if (this.Get(''chart.filled'') && this.Get(''chart.filled.range'') && this.data.length == 2) {

            this.context.beginPath();
            var len = this.coords.length / 2;
            this.context.lineWidth = this.Get(''chart.linewidth'');
            this.context.strokeStyle = this.Get(''chart.colors'')[0];

            for (var i=0; i<len; ++i) {
                if (i == 0) {
                    this.context.moveTo(this.coords[i][0], this.coords[i][1]);
                } else {
                    this.context.lineTo(this.coords[i][0], this.coords[i][1]);
                }
            }
            
            this.context.stroke();


            this.context.beginPath();
            
            if (this.Get(''chart.colors'')[1]) {
                this.context.strokeStyle = this.Get(''chart.colors'')[1];
            }
            
            for (var i=this.coords.length - 1; i>=len; --i) {
                if (i == (this.coords.length - 1) ) {
                    this.context.moveTo(this.coords[i][0], this.coords[i][1]);
                } else {
                    this.context.lineTo(this.coords[i][0], this.coords[i][1]);
                }
            }
            
            this.context.stroke();
        } else if (this.Get(''chart.filled'') && this.Get(''chart.filled.range'')) {
            alert(''[LINE] You must have only two sets of data for a filled range chart'');
        }

        /**
        * This bit shows the mini zoom window if requested
        */
        if (this.Get(''chart.zoom.mode'') == ''thumbnail'') {
            RGraph.ShowZoomWindow(this);
        }

        /**
        * This function enables the zoom in area mode
        */
        if (this.Get(''chart.zoom.mode'') == ''area'') {
            RGraph.ZoomArea(this);
        }
        
        /**
        * This function enables resizing
        */
        if (this.Get(''chart.resizable'')) {
            RGraph.AllowResizing(this);
        }
        
        /**
        * This function enables adjustments
        */
        if (this.Get(''chart.adjustable'')) {
            RGraph.AllowAdjusting(this);
        }


        
        /**
        * Fire the RGraph ondraw event
        */
        RGraph.FireCustomEvent(this, ''ondraw'');
    }

    
    /**
    * Draws the axes
    */
    RGraph.Line.prototype.DrawAxes = function ()
    {
        // Don''t draw the axes?
        if (this.Get(''chart.noaxes'')) {
            return;
        }

        // Turn any shadow off
        RGraph.NoShadow(this);

        this.context.lineWidth   = 1;
        this.context.lineCap = ''butt'';
        this.context.strokeStyle = this.Get(''chart.axis.color'');
        this.context.beginPath();

        // Draw the X axis
        if (this.Get(''chart.noxaxis'') == false) {
            if (this.Get(''chart.xaxispos'') == ''center'') {
                this.context.moveTo(this.gutterLeft, AA(this, (this.grapharea / 2) + this.gutterTop));
                this.context.lineTo(this.canvas.width - this.gutterRight, AA(this, (this.grapharea / 2) + this.gutterTop));
            } else if (this.Get(''chart.xaxispos'') == ''top'') {
                this.context.moveTo(this.gutterLeft, AA(this, this.gutterTop));
                this.context.lineTo(this.canvas.width - this.gutterRight, AA(this, this.gutterTop));
            } else {
                this.context.moveTo(this.gutterLeft, AA(this, this.canvas.height - this.gutterBottom));
                this.context.lineTo(this.canvas.width - this.gutterRight, AA(this, this.canvas.height - this.gutterBottom));
            }
        }

        // Draw the Y axis
        if (this.Get(''chart.noyaxis'') == false) {
            if (this.Get(''chart.yaxispos'') == ''left'') {
                this.context.moveTo(AA(this, this.gutterLeft), this.gutterTop);
                this.context.lineTo(AA(this, this.gutterLeft), this.canvas.height - this.gutterBottom );
            } else {
                this.context.moveTo(AA(this, this.canvas.width - this.gutterRight), this.gutterTop);
                this.context.lineTo(AA(this, this.canvas.width - this.gutterRight), this.canvas.height - this.gutterBottom);
            }
        }

        /**
        * Draw the X tickmarks
        */
        if (this.Get(''chart.noxaxis'') == false) {

            if (this.data[0].length > 0) {
                var xTickInterval = (this.canvas.width - this.gutterLeft - this.gutterRight) / (this.Get(''chart.xticks'') ? this.Get(''chart.xticks'') : (this.data[0].length - 1));
            }
            
            if (!!xTickInterval || xTickInterval <= 0) {
                xTickInterval = (this.canvas.width - this.gutterLeft - this.gutterRight) / (this.Get(''chart.labels'') && this.Get(''chart.labels'').length ? this.Get(''chart.labels'').length - 1 : 10);
            }

            for (x=this.gutterLeft + (this.Get(''chart.yaxispos'') == ''left'' ? xTickInterval : 0); x<=(this.canvas.width - this.gutterRight + 1 ); x+=xTickInterval) {

                if (this.Get(''chart.yaxispos'') == ''right'' && x >= (this.canvas.width - this.gutterRight - 1) ) {
                    break;
                }

                // If the last tick is not desired...
                if (this.Get(''chart.noendxtick'')) {
                    if (this.Get(''chart.yaxispos'') == ''left'' && x >= (this.canvas.width - this.gutterRight)) {
                        break;
                    } else if (this.Get(''chart.yaxispos'') == ''right'' && x == this.gutterLeft) {
                        continue;
                    }
                }

                var yStart = this.Get(''chart.xaxispos'') == ''center'' ? (this.gutterTop + (this.grapharea / 2)) - 3 : this.canvas.height - this.gutterBottom;
                var yEnd = this.Get(''chart.xaxispos'') == ''center'' ? yStart + 6 : this.canvas.height - this.gutterBottom - (x % 60 == 0 ? this.Get(''chart.largexticks'') * this.Get(''chart.tickdirection'') : this.Get(''chart.smallxticks'') * this.Get(''chart.tickdirection''));

                if (this.Get(''chart.xaxispos'') == ''center'') {
                    var yStart = AA(this, (this.gutterTop + (this.grapharea / 2))) - 3;
                    var yEnd = yStart + 6;
                
                } else if (this.Get(''chart.xaxispos'') == ''bottom'') {
                    var yStart = this.canvas.height - this.gutterBottom;
                    var yEnd  = this.canvas.height - this.gutterBottom - (x % 60 == 0 ? this.Get(''chart.largexticks'') * this.Get(''chart.tickdirection'') : this.Get(''chart.smallxticks'') * this.Get(''chart.tickdirection''));
                        yEnd += 0.5;

                
                } else if (this.Get(''chart.xaxispos'') == ''top'') {
                    yStart = this.gutterTop - 3;
                    yEnd   = this.gutterTop;
                }

                this.context.moveTo(AA(this, x), yStart);
                this.context.lineTo(AA(this, x), yEnd);
            }

        // Draw an extra tickmark if there is no X axis, but there IS a Y axis
        } else if (this.Get(''chart.noyaxis'') == false) {
            if (this.Get(''chart.yaxispos'') == ''left'') {
                this.context.moveTo(this.gutterLeft, AA(this, this.canvas.height - this.gutterBottom));
                this.context.lineTo(this.gutterLeft - this.Get(''chart.smallyticks''), AA(this, this.canvas.height - this.gutterBottom));
            } else {
                this.context.moveTo(this.canvas.width - this.gutterRight, AA(this, this.canvas.height - this.gutterBottom));
                this.context.lineTo(this.canvas.width - this.gutterRight + this.Get(''chart.smallyticks''), AA(this, this.canvas.height - this.gutterBottom));
            }
        }

        /**
        * Draw the Y tickmarks
        */
        var numyticks = this.Get(''chart.numyticks'');

        if (this.Get(''chart.noyaxis'') == false) {
            var counter    = 0;
            var adjustment = 0;
    
            if (this.Get(''chart.yaxispos'') == ''right'') {
                adjustment = (this.canvas.width - this.gutterLeft - this.gutterRight);
            }
            
            // X axis at the center
            if (this.Get(''chart.xaxispos'') == ''center'') {
                var interval = (this.grapharea / numyticks);
                var lineto = (this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft : this.canvas.width - this.gutterRight + this.Get(''chart.smallyticks''));
    
                // Draw the upper halves Y tick marks
                for (y=this.gutterTop; y < (this.grapharea / 2) + this.gutterTop; y+=interval) {
                    this.context.moveTo((this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - this.Get(''chart.smallyticks'') : this.canvas.width - this.gutterRight), AA(this, y));
                    this.context.lineTo(lineto, AA(this, y));
                }
                
                // Draw the lower halves Y tick marks
                for (y=this.gutterTop + (this.halfgrapharea) + interval; y <= this.grapharea + this.gutterTop; y+=interval) {
                    this.context.moveTo((this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - this.Get(''chart.smallyticks'') : this.canvas.width - this.gutterRight), AA(this, y));
                    this.context.lineTo(lineto, AA(this, y));
                }
            
            // X axis at the top
            } else if (this.Get(''chart.xaxispos'') == ''top'') {
                var interval = (this.grapharea / numyticks);
                var lineto = (this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft : this.canvas.width - this.gutterRight + this.Get(''chart.smallyticks''));

                // Draw the Y tick marks
                for (y=this.gutterTop + interval; y <=this.grapharea + this.gutterTop; y+=interval) {
                    this.context.moveTo((this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - this.Get(''chart.smallyticks'') : this.canvas.width - this.gutterRight), AA(this, y));
                    this.context.lineTo(lineto, AA(this, y));
                }
                
                // If there''s no X axis draw an extra tick
                if (this.Get(''chart.noxaxis'')) {
                    this.context.moveTo((this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - this.Get(''chart.smallyticks'') : this.canvas.width - this.gutterRight), this.gutterTop);
                    this.context.lineTo(lineto, this.gutterTop);
                }
            
            // X axis at the bottom
            } else {
                var lineto = (this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - this.Get(''chart.smallyticks'') : this.canvas.width - this.gutterRight + this.Get(''chart.smallyticks''));
    
                for (y=this.gutterTop; y < (this.canvas.height - this.gutterBottom) && counter < numyticks; y+=( (this.canvas.height - this.gutterTop - this.gutterBottom) / numyticks) ) {
    
                    this.context.moveTo(this.gutterLeft + adjustment, AA(this, y));
                    this.context.lineTo(lineto, AA(this, y));
                
                    var counter = counter +1;
                }
            }

        // Draw an extra X tickmark
        } else if (this.Get(''chart.noxaxis'') == false) {

            if (this.Get(''chart.yaxispos'') == ''left'') {
                this.context.moveTo(this.gutterLeft, this.Get(''chart.xaxispos'') == ''top'' ? this.gutterTop : this.canvas.height - this.gutterBottom);
                this.context.lineTo(this.gutterLeft, this.Get(''chart.xaxispos'') == ''top'' ? this.gutterTop - this.Get(''chart.smallxticks'') : this.canvas.height - this.gutterBottom + this.Get(''chart.smallxticks''));
           } else {
                this.context.moveTo(this.canvas.width - this.gutterRight, this.canvas.height - this.gutterBottom);
                this.context.lineTo(this.canvas.width - this.gutterRight, this.canvas.height - this.gutterBottom + this.Get(''chart.smallxticks''));
            }
        }

        this.context.stroke();
    }


    /**
    * Draw the text labels for the axes
    */
    RGraph.Line.prototype.DrawLabels = function ()
    {
        this.context.strokeStyle = ''black'';
        this.context.fillStyle   = this.Get(''chart.text.color'');
        this.context.lineWidth   = 1;
        
        // Turn off any shadow
        RGraph.NoShadow(this);

        // This needs to be here
        var font      = this.Get(''chart.text.font'');
        var text_size = this.Get(''chart.text.size'');
        var context   = this.context;
        var canvas    = this.canvas;

        // Draw the Y axis labels
        if (this.Get(''chart.ylabels'') && this.Get(''chart.ylabels.specific'') == null) {

            var units_pre  = this.Get(''chart.units.pre'');
            var units_post = this.Get(''chart.units.post'');
            var xpos       = this.Get(''chart.yaxispos'') == ''left'' ? this.gutterLeft - 5 : this.canvas.width - this.gutterRight + 5;
            var align      = this.Get(''chart.yaxispos'') == ''left'' ? ''right'' : ''left'';
            
            var numYLabels = this.Get(''chart.ylabels.count'');
            var bounding   = false;
            var bgcolor    = this.Get(''chart.ylabels.inside'') ? this.Get(''chart.ylabels.inside.color'') : null;

            
            /**
            * If the Y labels are inside the Y axis, invert the alignment
            */
            if (this.Get(''chart.ylabels.inside'') == true && align == ''left'') {
                xpos -= 10;
                align = ''right'';
                bounding = true;
                

            } else if (this.Get(''chart.ylabels.inside'') == true && align == ''right'') {
                xpos += 10;
                align = ''left'';
                bounding = true;
            }



            if (this.Get(''chart.xaxispos'') == ''center'') {
                var half = this.grapharea / 2;

                if (numYLabels == 1 || numYLabels == 3 || numYLabels == 5) {
                    //  Draw the upper halves labels
                    RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (0/5) * half ) + this.halfTextHeight, RGraph.number_format(this, this.scale[4], units_pre, units_post), null, align, bounding, null, bgcolor);
    
                    if (numYLabels == 5) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (1/5) * half ) + this.halfTextHeight, RGraph.number_format(this, this.scale[3], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (3/5) * half ) + this.halfTextHeight, RGraph.number_format(this, this.scale[1], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
    
                    if (numYLabels >= 3) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (2/5) * half ) + this.halfTextHeight, RGraph.number_format(this, this.scale[2], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (4/5) * half ) + this.halfTextHeight, RGraph.number_format(this, this.scale[0], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
                    
                    //  Draw the lower halves labels
                    if (numYLabels >= 3) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (6/5) * half ) + this.halfTextHeight, ''-'' + RGraph.number_format(this, this.scale[0], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (8/5) * half ) + this.halfTextHeight, ''-'' + RGraph.number_format(this, this.scale[2], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
    
                    if (numYLabels == 5) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (7/5) * half ) + this.halfTextHeight, ''-'' + RGraph.number_format(this, this.scale[1], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (9/5) * half ) + this.halfTextHeight, ''-'' + RGraph.number_format(this, this.scale[3], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
    
                    RGraph.Text(context, font, text_size, xpos, this.gutterTop + ( (10/5) * half ) + this.halfTextHeight, ''-'' + RGraph.number_format(this, (this.scale[4] == ''1.0'' ? ''1.0'' : this.scale[4]), units_pre, units_post), null, align, bounding, null, bgcolor);
                
                } else if (numYLabels == 10) {

                    // 10 Y labels
                    var interval = (this.grapharea / numYLabels) / 2;
                
                    for (var i=0; i<numYLabels; ++i) {
                        // This draws the upper halves labels
                        RGraph.Text(context,font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((i/20) * (this.grapharea) ), RGraph.number_format(this, ((this.scale[4] / numYLabels) * (numYLabels - i)).toFixed((this.Get(''chart.scale.decimals''))),units_pre, units_post), null, align, bounding, null, bgcolor);
                        
                        // And this draws the lower halves labels
                        RGraph.Text(context, font, text_size, xpos,
                        
                        this.gutterTop + this.halfTextHeight + ((i/20) * this.grapharea) + (this.grapharea / 2) + (this.grapharea / 20),
                        
                        ''-'' + RGraph.number_format(this, (this.scale[4] - ((this.scale[4] / numYLabels) * (numYLabels - i - 1))).toFixed((this.Get(''chart.scale.decimals''))),units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
                    
                } else {
                    alert(''[LINE SCALE] The number of Y labels must be 1/3/5/10'');
                }

                // Draw the lower limit if chart.ymin is specified
                if (typeof(this.Get(''chart.ymin'')) == ''number'') {
                    RGraph.Text(context, font, text_size, xpos, this.canvas.height / 2, RGraph.number_format(this, this.Get(''chart.ymin'').toFixed(this.Get(''chart.scale.decimals'')), units_pre, units_post), ''center'', align, bounding, null, bgcolor);
                }
                
                // No X axis - so draw 0
                if (this.Get(''chart.noxaxis'') == true) {
                    RGraph.Text(context,font,text_size,xpos,this.gutterTop + ( (5/5) * half ) + this.halfTextHeight,this.Get(''chart.units.pre'') + ''0'' + this.Get(''chart.units.post''),null, align, bounding, null, bgcolor);
                }

            // X axis at the top
            } else if (this.Get(''chart.xaxispos'') == ''top'') {

                var scale = RGraph.array_reverse(this.scale);

                /**
                * Accommodate reversing the Y labels
                */
                if (this.Get(''chart.ylabels.invert'')) {

                    scale = RGraph.array_reverse(scale);

                    this.context.translate(0, this.grapharea * -0.2);
                    if (typeof(this.Get(''chart.ymin'')) == null) {
                        this.Set(''chart.ymin'', 0);
                    }
                }

                if (numYLabels == 1 || numYLabels == 3 || numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((1/5) * (this.grapharea ) ), ''-'' + RGraph.number_format(this, scale[4], units_pre, units_post), null, align, bounding, null, bgcolor);
    
                    if (numYLabels == 5) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((4/5) * (this.grapharea) ), ''-'' + RGraph.number_format(this, scale[1], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((2/5) * (this.grapharea) ), ''-'' + RGraph.number_format(this, scale[3], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
    
                    if (numYLabels >= 3) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((3/5) * (this.grapharea ) ), ''-'' + RGraph.number_format(this, scale[2], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((5/5) * (this.grapharea) ), ''-'' + RGraph.number_format(this, scale[0], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
                
                } else if (numYLabels == 10) {

                    // 10 Y labels
                    var interval = (this.grapharea / numYLabels) / 2;

                    for (var i=0; i<numYLabels; ++i) {

                        RGraph.Text(context,font,text_size,xpos,(2 * interval) + this.gutterTop + this.halfTextHeight + ((i/10) * (this.grapharea) ),''-'' + RGraph.number_format(this,(scale[0] - (((scale[0] - this.min) / numYLabels) * (numYLabels - i - 1))).toFixed((this.Get(''chart.scale.decimals''))),units_pre,units_post),null,align,bounding,null,bgcolor);
                    }

                } else {
                    alert(''[LINE SCALE] The number of Y labels must be 1/3/5/10'');
                }


                /**
                * Accommodate translating back after reversing the labels
                */
                if (this.Get(''chart.ylabels.invert'')) {
                    this.context.translate(0, 0 - (this.grapharea * -0.2));
                }

                // Draw the lower limit if chart.ymin is specified
                if (typeof(this.Get(''chart.ymin'')) == ''number'') {
                    RGraph.Text(context,font,text_size,xpos,this.Get(''chart.ylabels.invert'') ? this.canvas.height - this.gutterBottom : this.gutterTop,''-'' + RGraph.number_format(this, this.Get(''chart.ymin'').toFixed(this.Get(''chart.scale.decimals'')), units_pre, units_post),''center'',align,bounding,null,bgcolor);
                }

            } else {

                /**
                * Accommodate reversing the Y labels
                */
                if (this.Get(''chart.ylabels.invert'')) {
                    this.scale = RGraph.array_reverse(this.scale);
                    this.context.translate(0, this.grapharea * 0.2);
                    if (typeof(this.Get(''chart.ymin'')) == null) {
                        this.Set(''chart.ymin'', 0);
                    }
                }

                if (numYLabels == 1 || numYLabels == 3 || numYLabels == 5) {
                    RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((0/5) * (this.grapharea ) ), RGraph.number_format(this, this.scale[4], units_pre, units_post), null, align, bounding, null, bgcolor);
    
                    if (numYLabels == 5) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((3/5) * (this.grapharea) ), RGraph.number_format(this, this.scale[1], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((1/5) * (this.grapharea) ), RGraph.number_format(this, this.scale[3], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
    
                    if (numYLabels >= 3) {
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((2/5) * (this.grapharea ) ), RGraph.number_format(this, this.scale[2], units_pre, units_post), null, align, bounding, null, bgcolor);
                        RGraph.Text(context, font, text_size, xpos, this.gutterTop + this.halfTextHeight + ((4/5) * (this.grapharea) ), RGraph.number_format(this, this.scale[0], units_pre, units_post), null, align, bounding, null, bgcolor);
                    }
                
                } else if (numYLabels == 10) {

                    // 10 Y labels
                    var interval = (this.grapharea / numYLabels) / 2;
                
                    for (var i=0; i<numYLabels; ++i) {
                        RGraph.Text(context,font,text_size,xpos,this.gutterTop + this.halfTextHeight + ((i/10) * (this.grapharea) ),RGraph.number_format(this,((((this.scale[4] - this.min) / numYLabels) * (numYLabels - i)) + this.min).toFixed((this.Get(''chart.scale.decimals''))),units_pre,units_post),null,align,bounding,null,bgcolor);
                    }

                } else {
                    alert(''[LINE SCALE] The number of Y labels must be 1/3/5/10'');
                }


                /**
                * Accommodate translating back after reversing the labels
                */
                if (this.Get(''chart.ylabels.invert'')) {
                    this.context.translate(0, 0 - (this.grapharea * 0.2));
                }

                // Draw the lower limit if chart.ymin is specified
                if (typeof(this.Get(''chart.ymin'')) == ''number'') {
                    RGraph.Text(context,font,text_size,xpos,this.Get(''chart.ylabels.invert'') ? this.gutterTop : this.canvas.height - this.gutterBottom,RGraph.number_format(this, this.Get(''chart.ymin'').toFixed(this.Get(''chart.scale.decimals'')), units_pre, units_post),''center'',align,bounding,null,bgcolor);
                }
            }

            // No X axis - so draw 0 - but not if the X axis is in the center
            if (   this.Get(''chart.noxaxis'') == true
                && this.Get(''chart.ymin'') == null
                && this.Get(''chart.xaxispos'') !!= ''center''
               ) {

                RGraph.Text(context,font,text_size,xpos,this.Get(''chart.xaxispos'') == ''top'' ? this.gutterTop + this.halfTextHeight: (this.canvas.height - this.gutterBottom + this.halfTextHeight),this.Get(''chart.units.pre'') + ''0'' + this.Get(''chart.units.post''),null, align, bounding, null, bgcolor);
            }
        
        } else if (this.Get(''chart.ylabels'') && typeof(this.Get(''chart.ylabels.specific'')) == ''object'') {
            
            // A few things
            var gap      = this.grapharea / this.Get(''chart.ylabels.specific'').length;
            var halign   = this.Get(''chart.yaxispos'') == ''left'' ? ''right'' : ''left'';
            var bounding = false;
            var bgcolor  = null;
            var ymin     = this.Get(''chart.ymin'') !!= null && this.Get(''chart.ymin'');

            // Figure out the X coord based on the position of the axis
            if (this.Get(''chart.yaxispos'') == ''left'') {
                var x = this.gutterLeft - 5;
                
                if (this.Get(''chart.ylabels.inside'')) {
                    x += 10;
                    halign   = ''left'';
                    bounding = true;
                    bgcolor  = ''rgba(255,255,255,0.5)'';
                }

            } else if (this.Get(''chart.yaxispos'') == ''right'') {
                var x = this.canvas.width - this.gutterRight + 5;
                
                if (this.Get(''chart.ylabels.inside'')) {
                    x -= 10;
                    halign = ''right'';
                    bounding = true;
                    bgcolor  = ''rgba(255,255,255,0.5)'';
                }
            }


            // Draw the labels
            if (this.Get(''chart.xaxispos'') == ''center'') {
            
                // Draw the top halfs labels
                for (var i=0; i<this.Get(''chart.ylabels.specific'').length; ++i) {
                    var y = this.gutterTop + (this.grapharea / ((this.Get(''chart.ylabels.specific'').length ) * 2) * i);
                    
                    if (ymin && ymin > 0) {
                        var y  = ((this.grapharea / 2) / (this.Get(''chart.ylabels.specific'').length - (ymin ? 1 : 0)) ) * i;
                            y += this.gutterTop;
                    }
                    
                    RGraph.Text(context, font, text_size,x,y,String(this.Get(''chart.ylabels.specific'')[i]), ''center'', halign, bounding, 0, bgcolor);
                }
                
                // Now reverse the labels and draw the bottom half
                var reversed_labels = RGraph.array_reverse(this.Get(''chart.ylabels.specific''));
            
                // Draw the bottom halfs labels
                for (var i=0; i<reversed_labels.length; ++i) {
                    var y = (this.grapharea / 2) + this.gutterTop + ((this.grapharea / (reversed_labels.length * 2) ) * (i + 1));

                    if (ymin && ymin > 0) {
                        var y  = ((this.grapharea / 2) / (reversed_labels.length - (ymin ? 1 : 0)) ) * i;
                            y += this.gutterTop;
                            y += (this.grapharea / 2);
                    }

                    RGraph.Text(context, font, text_size,x,y,String(reversed_labels[i]), ''center'', halign, bounding, 0, bgcolor);
                }
            
            } else if (this.Get(''chart.xaxispos'') == ''top'') {

                // Reverse the labels and draw
                var reversed_labels = RGraph.array_reverse(this.Get(''chart.ylabels.specific''));
            
                // Draw the bottom halfs labels
                for (var i=0; i<reversed_labels.length; ++i) {
                    
                    var y = ((this.grapharea / (reversed_labels.length - (ymin ? 1 : 0)) ) * (i + (ymin ? 0 : 1)));
                        y = y + this.gutterTop;

                    RGraph.Text(context, font, text_size,x,y,String(reversed_labels[i]), ''center'', halign, bounding, 0, bgcolor);
                }

            } else {
                for (var i=0; i<this.Get(''chart.ylabels.specific'').length; ++i) {
                    var y = this.gutterTop + ((this.grapharea / (this.Get(''chart.ylabels.specific'').length - (ymin ? 1 : 0) )) * i);
                    RGraph.Text(context, font, text_size,x,y,String(this.Get(''chart.ylabels.specific'')[i]), ''center'', halign, bounding, 0, bgcolor);
                }
            }
        }

        // Draw the X axis labels
        if (this.Get(''chart.labels'') && this.Get(''chart.labels'').length > 0) {

            var yOffset  = 5;
            var bordered = false;
            var bgcolor  = null;

            /**
            * Text angle
            */
            var angle  = 0;
            var valign = ''top'';
            var halign = ''center'';

            if (this.Get(''chart.xlabels.inside'')) {
                yOffset = -5;
                bordered = true;
                bgcolor  = this.Get(''chart.xlabels.inside.color'');
                valign = ''bottom'';
            }
            
            if (this.Get(''chart.xaxispos'') == ''top'') {
                valign = ''bottom'';
                yOffset += 2;
            }

            if (typeof(this.Get(''chart.text.angle'')) == ''number'' && this.Get(''chart.text.angle'') > 0) {
                angle   = -1 * this.Get(''chart.text.angle'');
                valign  = ''center'';
                halign  = ''right'';
                yOffset = 10;
                
                if (this.Get(''chart.xaxispos'') == ''top'') {
                    yOffset = 10;
                }
            }

            this.context.fillStyle = this.Get(''chart.text.color'');
            var numLabels = this.Get(''chart.labels'').length;

            for (i=0; i<numLabels; ++i) {

                // Changed 8th Nov 2010 to be not reliant on the coords
                //if (this.Get(''chart.labels'')[i] && this.coords && this.coords[i] && this.coords[i][0]) {
                if (this.Get(''chart.labels'')[i]) {

                    var labelX = ((this.canvas.width - this.gutterLeft - this.gutterRight - (2 * this.Get(''chart.hmargin''))) / (numLabels - 1) ) * i;
                        labelX += this.gutterLeft + this.Get(''chart.hmargin'');

                    /**
                    * Account for an unrelated number of labels
                    */
                    if (this.Get(''chart.labels'').length !!= this.data[0].length) {
                        labelX = this.gutterLeft + this.Get(''chart.hmargin'') + ((this.canvas.width - this.gutterLeft - this.gutterRight - (2 * this.Get(''chart.hmargin''))) * (i / (this.Get(''chart.labels'').length - 1)));
                    }
                    
                    // This accounts for there only being one point on the chart
                    if (!!labelX) {
                        labelX = this.gutterLeft + this.Get(''chart.hmargin'');
                    }

                    if (this.Get(''chart.xaxispos'') == ''top'' && this.Get(''chart.text.angle'') > 0) {
                        halign = ''left'';
                    }

                    RGraph.Text(context,
                                font,
                                text_size,
                                labelX,
                                (this.Get(''chart.xaxispos'') == ''top'') ? this.gutterTop - yOffset - (this.Get(''chart.xlabels.inside'') ? -22 : 0) : (this.canvas.height - this.gutterBottom) + yOffset,
                                String(this.Get(''chart.labels'')[i]),
                                valign,
                                halign,
                                bordered,
                                angle,
                                bgcolor);
                }
            }

        }

        this.context.stroke();
        this.context.fill();
    }


    /**
    * Draws the line
    */
    RGraph.Line.prototype.DrawLine = function (lineData, color, fill, linewidth, tickmarks, index)
    {
        // This facilitates the Rise animation (the Y value only)
        if (this.Get(''chart.animation.unfold.y'') && this.Get(''chart.animation.factor'') !!= 1) {
            for (var i=0; i<lineData.length; ++i) {
                lineData[i] *= this.Get(''chart.animation.factor'');
            }
        }

        var penUp = false;
        var yPos  = null;
        var xPos  = 0;
        this.context.lineWidth = 1;
        var lineCoords = [];
        
        /**
        * Get the previous line data
        */
        if (index > 0) {
            var prevLineCoords = this.coords2[index - 1];
        }

        // Work out the X interval
        var xInterval = (this.canvas.width - (2 * this.Get(''chart.hmargin'')) - this.gutterLeft - this.gutterRight) / (lineData.length - 1);

        // Loop thru each value given, plotting the line
        // (FORMERLY FIRST)
        for (i=0; i<lineData.length; i++) {

            var data_point = lineData[i];

            yPos = this.canvas.height - (((data_point - (data_point > 0 ?  this.Get(''chart.ymin'') : (-1 * this.Get(''chart.ymin'')))) / (this.max - this.min) ) * this.grapharea);
            yPos = (this.grapharea / (this.max - this.min)) * (data_point - this.min);
            yPos = this.canvas.height - yPos;

            /**
            * This skirts an annoying JS rounding error
            * SEARCH TAGS: JS ROUNDING ERROR DECIMALS
            */
            if (data_point == this.max) {
                yPos = Math.round(yPos);
            }

            if (this.Get(''chart.ylabels.invert'')) {
                yPos -= this.gutterBottom;
                yPos -= this.gutterTop;
                yPos = this.canvas.height - yPos;
            }

            // Make adjustments depending on the X axis position
            if (this.Get(''chart.xaxispos'') == ''center'') {
                yPos = (yPos - this.gutterBottom - this.gutterTop) / 2;
                yPos = yPos + this.gutterTop;

            
            // TODO Check this
            } else if (this.Get(''chart.xaxispos'') == ''top'') {

                yPos = (this.grapharea / (this.max - this.min)) * (Math.abs(data_point) - this.min);
                yPos += this.gutterTop;
                
                if (this.Get(''chart.ylabels.invert'')) {
                    yPos -= this.gutterTop;
                    yPos  = this.grapharea - yPos;
                    yPos += this.gutterTop;
                }

            } else if (this.Get(''chart.xaxispos'') == ''bottom'') {
                // TODO
                yPos -= this.gutterBottom; // Without this the line is out of place due to the gutter
            }



            // Null data points, and a special case for this bug:http://dev.rgraph.net/tests/ymin.html
            if (   lineData[i] == null
                || (this.Get(''chart.xaxispos'') == ''bottom'' && lineData[i] < this.min && !!this.Get(''chart.outofbounds''))
                ||  (this.Get(''chart.xaxispos'') == ''center'' && lineData[i] < (-1 * this.max) && !!this.Get(''chart.outofbounds''))) {

                yPos = null;
            }

            // Not always very noticeable, but it does have an effect
            // with thick lines
            this.context.lineCap  = ''round'';
            this.context.lineJoin = ''round'';

            // Plot the line if we''re at least on the second iteration
            if (i > 0) {
                xPos = xPos + xInterval;
            } else {
                xPos = this.Get(''chart.hmargin'') + this.gutterLeft;
            }
            
            if (this.Get(''chart.animation.unfold.x'')) {
                xPos *= this.Get(''chart.animation.factor'');
                
                if (xPos < this.Get(''chart.gutter.left'')) {
                    xPos = this.Get(''chart.gutter.left'');
                }
            }

            /**
            * Add the coords to an array
            */
            this.coords.push([xPos, yPos]);
            lineCoords.push([xPos, yPos]);
        }
        
        this.context.stroke();

        // Store the coords in another format, indexed by line number
        this.coords2[index] = lineCoords;

        /**
        * For IE only: Draw the shadow ourselves as ExCanvas doesn''t produce shadows
        */
        if (RGraph.isOld() && this.Get(''chart.shadow'')) {
            this.DrawIEShadow(lineCoords, this.context.shadowColor);
        }

        /**
        * Now draw the actual line [FORMERLY SECOND]
        */
        this.context.beginPath();
        // Transparent now as of 11/19/2011
        this.context.strokeStyle = ''rgba(0,0,0,0)'';
        //this.context.strokeStyle = fill;
        if (fill) {
            this.context.fillStyle   = fill;
        }

        var isStepped = this.Get(''chart.stepped'');
        var isFilled = this.Get(''chart.filled'');
        
        if (this.Get(''chart.xaxispos'') == ''top'') {
            var xAxisPos = this.gutterTop;
        } else if (this.Get(''chart.xaxispos'') == ''center'') {
            var xAxisPos = this.gutterTop + (this.grapharea / 2);
        } else if (this.Get(''chart.xaxispos'') == ''bottom'') {
            var xAxisPos = this.canvas.height - this.gutterBottom;
        }


        for (var i=0; i<lineCoords.length; ++i) {

            xPos = lineCoords[i][0];
            yPos = lineCoords[i][1];
            var set = index;

            var prevY     = (lineCoords[i - 1] ? lineCoords[i - 1][1] : null);
            var isLast    = (i + 1) == lineCoords.length;

            /**
            * This nullifys values which are out-of-range
            */
            if (prevY < this.gutterTop || prevY > (this.canvas.height - this.gutterBottom) ) {
                penUp = true;
            }

            if (i == 0 || penUp || !!yPos || !!prevY || prevY < this.gutterTop) {

                if (this.Get(''chart.filled'') && !!this.Get(''chart.filled.range'')) {

                    this.context.moveTo(xPos + 1, xAxisPos);

                    // This facilitates the X axis being at the top
                    // NOTE: Also done below
                    if (this.Get(''chart.xaxispos'') == ''top'') {
                        this.context.moveTo(xPos + 1, xAxisPos);
                    }

                    this.context.lineTo(xPos, yPos);

                } else {

                    if (RGraph.isOld() && yPos == null) {
                        // Nada
                    } else {
                        this.context.moveTo(xPos + 1, yPos);
                    }
                }

                if (yPos == null) {
                    penUp = true;

                } else {
                    penUp = false;
                }

            } else {

                // Draw the stepped part of stepped lines
                if (isStepped) {
                    this.context.lineTo(xPos, lineCoords[i - 1][1]);
                }

                if ((yPos >= this.gutterTop && yPos <= (this.canvas.height - this.gutterBottom)) || this.Get(''chart.outofbounds'') ) {

                    if (isLast && this.Get(''chart.filled'') && !!this.Get(''chart.filled.range'') && this.Get(''chart.yaxispos'') == ''right'') {
                        xPos -= 1;
                    }


                    // Added 8th September 2009
                    if (!!isStepped || !!isLast) {
                        this.context.lineTo(xPos, yPos);
                        
                        if (isFilled && lineCoords[i+1] && lineCoords[i+1][1] == null) {
                            this.context.lineTo(xPos, xAxisPos);
                        }
                    
                    // Added August 2010
                    } else if (isStepped && isLast) {
                        this.context.lineTo(xPos,yPos);
                    }


                    penUp = false;
                } else {
                    penUp = true;
                }
            }
        }

        /**
        * Draw a line to the X axis if the chart is filled
        */
        if (this.Get(''chart.filled'') && !!this.Get(''chart.filled.range'')) {

            // Is this needed ??
            var fillStyle = this.Get(''chart.fillstyle'');

            /**
            * Draw the bottom edge of the filled bit using either the X axis or the prevlinedata,
            * depending on the index of the line. The first line uses the X axis, and subsequent
            * lines use the prevLineCoords array
            */
            if (index > 0 && this.Get(''chart.filled.accumulative'')) {
                
                this.context.lineTo(xPos, prevLineCoords ? prevLineCoords[i - 1][1] : (this.canvas.height - this.gutterBottom - 1 + (this.Get(''chart.xaxispos'') == ''center'' ? (this.canvas.height - this.gutterTop - this.gutterBottom) / 2 : 0)));
            
                for (var k=(i - 1); k>=0; --k) {
                    this.context.lineTo(k == 0 ? prevLineCoords[k][0] + 1: prevLineCoords[k][0], prevLineCoords[k][1]);
                }
            } else {

                // Draw a line down to the X axis
                if (this.Get(''chart.xaxispos'') == ''top'') {
                    this.context.lineTo(xPos, this.Get(''chart.gutter.top'') +  1);
                    this.context.lineTo(lineCoords[0][0],this.Get(''chart.gutter.top'') + 1);
                } else if (typeof(lineCoords[i - 1][1]) == ''number'') {

                    var yPosition = this.Get(''chart.xaxispos'') == ''center'' ? ((this.canvas.height - this.gutterTop - this.gutterBottom) / 2) + this.gutterTop : this.canvas.height - this.gutterBottom;

                    this.context.lineTo(xPos,yPosition);
                    this.context.lineTo(lineCoords[0][0],yPosition);
                }
            }

            this.context.fillStyle = fill;

            this.context.fill();
            this.context.beginPath();

        }

        /**
        * FIXME this may need removing when Chrome is fixed
        * SEARCH TAGS: CHROME SHADOW BUG
        */
        if (navigator.userAgent.match(/Chrome/) && this.Get(''chart.shadow'') && this.Get(''chart.chromefix'') && this.Get(''chart.shadow.blur'') > 0) {

            for (var i=lineCoords.length - 1; i>=0; --i) {
                if (
                       typeof(lineCoords[i][1]) !!= ''number''
                    || (typeof(lineCoords[i+1]) == ''object'' && typeof(lineCoords[i+1][1]) !!= ''number'')
                   ) {
                    this.context.moveTo(lineCoords[i][0],lineCoords[i][1]);
                } else {
                    this.context.lineTo(lineCoords[i][0],lineCoords[i][1]);
                }
            }
        }

        this.context.stroke();


        if (this.Get(''chart.backdrop'')) {
            this.DrawBackdrop(lineCoords, color);
        }

        // Now redraw the lines with the correct line width
        this.RedrawLine(lineCoords, color, linewidth);
        
        this.context.stroke();

        // Draw the tickmarks
        for (var i=0; i<lineCoords.length; ++i) {

            i = Number(i);

            if (isStepped && i == (lineCoords.length - 1)) {
                this.context.beginPath();
                //continue;
            }

            if (
                (
                    tickmarks !!= ''endcircle''
                 && tickmarks !!= ''endsquare''
                 && tickmarks !!= ''filledendsquare''
                 && tickmarks !!= ''endtick''
                 && tickmarks !!= ''endtriangle''
                 && tickmarks !!= ''arrow''
                 && tickmarks !!= ''filledarrow''
                )
                || (i == 0 && tickmarks !!= ''arrow'' && tickmarks !!= ''filledarrow'')
                || i == (lineCoords.length - 1)
               ) {

                var prevX = (i <= 0 ? null : lineCoords[i - 1][0]);
                var prevY = (i <= 0 ? null : lineCoords[i - 1][1]);

                this.DrawTick(lineData, lineCoords[i][0], lineCoords[i][1], color, false, prevX, prevY, tickmarks, i);

                // Draws tickmarks on the stepped bits of stepped charts. Takend out 14th July 2010
                //
                //if (this.Get(''chart.stepped'') && lineCoords[i + 1] && this.Get(''chart.tickmarks'') !!= ''endsquare'' && this.Get(''chart.tickmarks'') !!= ''endcircle'' && this.Get(''chart.tickmarks'') !!= ''endtick'') {
                //    this.DrawTick(lineCoords[i + 1][0], lineCoords[i][1], color);
                //}
            }
        }

        // Draw something off canvas to skirt an annoying bug
        this.context.beginPath();
        this.context.arc(this.canvas.width + 50000, this.canvas.height + 50000, 2, 0, 6.38, 1);
    }
    
    
    /**
    * This functions draws a tick mark on the line
    * 
    * @param xPos  int  The x position of the tickmark
    * @param yPos  int  The y position of the tickmark
    * @param color str  The color of the tickmark
    * @param       bool Whether the tick is a shadow. If it is, it gets offset by the shadow offset
    */
    RGraph.Line.prototype.DrawTick = function (lineData, xPos, yPos, color, isShadow, prevX, prevY, tickmarks, index)
    {
        // If the yPos is null - no tick
        if ((yPos == null || yPos > (this.canvas.height - this.gutterBottom) || yPos < this.gutterTop) && !!this.Get(''chart.outofbounds'') || !!this.Get(''chart.line.visible'')) {
            return;
        }

        this.context.beginPath();

        var offset   = 0;

        // Reset the stroke and lineWidth back to the same as what they were when the line was drawm
        // UPDATE 28th July 2011 - the line width is now set to 1
        this.context.lineWidth   = this.Get(''chart.tickmarks.linewidth'') ? this.Get(''chart.tickmarks.linewidth'') : this.Get(''chart.linewidth'');
        this.context.strokeStyle = isShadow ? this.Get(''chart.shadow.color'') : this.context.strokeStyle;
        this.context.fillStyle   = isShadow ? this.Get(''chart.shadow.color'') : this.context.strokeStyle;

        // Cicular tick marks
        if (   tickmarks == ''circle''
            || tickmarks == ''filledcircle''
            || tickmarks == ''endcircle'') {

            if (tickmarks == ''circle''|| tickmarks == ''filledcircle'' || (tickmarks == ''endcircle'') ) {
                this.context.beginPath();
                this.context.arc(xPos + offset, yPos + offset, this.Get(''chart.ticksize''), 0, 360 / (180 / Math.PI), false);

                if (tickmarks == ''filledcircle'') {
                    this.context.fillStyle = isShadow ? this.Get(''chart.shadow.color'') : this.context.strokeStyle;
                } else {
                    this.context.fillStyle = isShadow ? this.Get(''chart.shadow.color'') : ''white'';
                }

                this.context.stroke();
                this.context.fill();
            }

        // Halfheight "Line" style tick marks
        } else if (tickmarks == ''halftick'') {
            this.context.beginPath();
            this.context.moveTo(xPos, yPos);
            this.context.lineTo(xPos, yPos + this.Get(''chart.ticksize''));

            this.context.stroke();
        
        // Tick style tickmarks
        } else if (tickmarks == ''tick'') {
            this.context.beginPath();
            this.context.moveTo(xPos, yPos -  this.Get(''chart.ticksize''));
            this.context.lineTo(xPos, yPos + this.Get(''chart.ticksize''));

            this.context.stroke();
        
        // Endtick style tickmarks
        } else if (tickmarks == ''endtick'') {
            this.context.beginPath();
            this.context.moveTo(xPos, yPos -  this.Get(''chart.ticksize''));
            this.context.lineTo(xPos, yPos + this.Get(''chart.ticksize''));

            this.context.stroke();
        
        // "Cross" style tick marks
        } else if (tickmarks == ''cross'') {
            this.context.beginPath();
            this.context.moveTo(xPos - this.Get(''chart.ticksize''), yPos - this.Get(''chart.ticksize''));
            this.context.lineTo(xPos + this.Get(''chart.ticksize''), yPos + this.Get(''chart.ticksize''));
            this.context.moveTo(xPos + this.Get(''chart.ticksize''), yPos - this.Get(''chart.ticksize''));
            this.context.lineTo(xPos - this.Get(''chart.ticksize''), yPos + this.Get(''chart.ticksize''));
            
            this.context.stroke();


        // Triangle style tick marks
        } else if (tickmarks == ''triangle'' || tickmarks == ''filledtriangle'' || tickmarks == ''endtriangle'') {
            this.context.beginPath();
                
                if (tickmarks == ''filledtriangle'') {
                    this.context.fillStyle = isShadow ? this.Get(''chart.shadow.color'') : this.context.strokeStyle;
                } else {
                    this.context.fillStyle = ''white'';
                }

                this.context.moveTo(xPos - this.Get(''chart.ticksize''), yPos + this.Get(''chart.ticksize''));
                this.context.lineTo(xPos, yPos - this.Get(''chart.ticksize''));
                this.context.lineTo(xPos + this.Get(''chart.ticksize''), yPos + this.Get(''chart.ticksize''));
            this.context.closePath();
            
            this.context.stroke();
            this.context.fill();


        // A white bordered circle
        } else if (tickmarks == ''borderedcircle'' || tickmarks == ''dot'') {
                this.context.lineWidth   = 1;
                this.context.strokeStyle = this.Get(''chart.tickmarks.dot.color'');
                this.context.fillStyle   = this.Get(''chart.tickmarks.dot.color'');

                // The outer white circle
                this.context.beginPath();
                this.context.arc(xPos, yPos, this.Get(''chart.ticksize''), 0, 360 / (180 / Math.PI), false);
                this.context.closePath();


                this.context.fill();
                this.context.stroke();
                
                // Now do the inners
                this.context.beginPath();
                this.context.fillStyle   = color;
                this.context.strokeStyle = color;
                this.context.arc(xPos, yPos, this.Get(''chart.ticksize'') - 2, 0, 360 / (180 / Math.PI), false);

                this.context.closePath();

                this.context.fill();
                this.context.stroke();
        
        } else if (   tickmarks == ''square''
                   || tickmarks == ''filledsquare''
                   || (tickmarks == ''endsquare'')
                   || (tickmarks == ''filledendsquare'') ) {

            this.context.fillStyle   = ''white'';
            this.context.strokeStyle = this.context.strokeStyle; // FIXME Is this correct?

            this.context.beginPath();
            this.context.strokeRect(xPos - this.Get(''chart.ticksize''), yPos - this.Get(''chart.ticksize''), this.Get(''chart.ticksize'') * 2, this.Get(''chart.ticksize'') * 2);

            // Fillrect
            if (tickmarks == ''filledsquare'' || tickmarks == ''filledendsquare'') {
                this.context.fillStyle = isShadow ? this.Get(''chart.shadow.color'') : this.context.strokeStyle;
                this.context.fillRect(xPos - this.Get(''chart.ticksize''), yPos - this.Get(''chart.ticksize''), this.Get(''chart.ticksize'') * 2, this.Get(''chart.ticksize'') * 2);

            } else if (tickmarks == ''square'' || tickmarks == ''endsquare'') {
                this.context.fillStyle = isShadow ? this.Get(''chart.shadow.color'') : ''white'';
                this.context.fillRect((xPos - this.Get(''chart.ticksize'')) + 1, (yPos - this.Get(''chart.ticksize'')) + 1, (this.Get(''chart.ticksize'') * 2) - 2, (this.Get(''chart.ticksize'') * 2) - 2);
            }

            this.context.stroke();
            this.context.fill();

        /**
        * FILLED arrowhead
        */
        } else if (tickmarks == ''filledarrow'') {
        
            var x = Math.abs(xPos - prevX);
            var y = Math.abs(yPos - prevY);

            if (yPos < prevY) {
                var a = Math.atan(x / y) + 1.57;
            } else {
                var a = Math.atan(y / x) + 3.14;
            }

            this.context.beginPath();
                this.context.moveTo(xPos, yPos);
                this.context.arc(xPos, yPos, 7, a - 0.5, a + 0.5, false);
            this.context.closePath();

            this.context.stroke();
            this.context.fill();

        /**
        * Arrow head, NOT filled
        */
        } else if (tickmarks == ''arrow'') {

            var x = Math.abs(xPos - prevX);
            var y = Math.abs(yPos - prevY);
            
            var orig_linewidth = this.context.lineWidth;

            if (yPos < prevY) {
                var a = Math.atan(x / y) + 1.57;
            } else {
                var a = Math.atan(y / x) + 3.14;
            }

            this.context.beginPath();
                this.context.moveTo(xPos, yPos);
                this.context.arc(xPos, yPos, 7, a - 0.5 - (document.all ? 0.1 : 0.01), a - 0.4, false);

                this.context.moveTo(xPos, yPos);
                this.context.arc(xPos, yPos, 7, a + 0.5 + (document.all ? 0.1 : 0.01), a + 0.5, true);
            this.context.stroke();
            this.context.fill();
            
            // Revert to original lineWidth
            this.context.lineWidth = orig_linewidth;
        
        /**
        * Custom tick drawing function
        */
        } else if (typeof(tickmarks) == ''function'') {
            tickmarks(this, lineData, lineData[index], index, xPos, yPos, color, prevX, prevY);
        }
    }


    /**
    * Draws a filled range if necessary
    */
    RGraph.Line.prototype.DrawRange = function ()
    {
        /**
        * Fill the range if necessary
        */
        if (this.Get(''chart.filled.range'') && this.Get(''chart.filled'')) {
            this.context.beginPath();
            this.context.fillStyle = this.Get(''chart.fillstyle'');
            this.context.strokeStyle = this.Get(''chart.fillstyle'');
            this.context.lineWidth = 1;
            var len = (this.coords.length / 2);

            for (var i=0; i<len; ++i) {
                if (i == 0) {
                    this.context.moveTo(this.coords[i][0], this.coords[i][1])
                } else {
                    this.context.lineTo(this.coords[i][0], this.coords[i][1])
                }
            }

            for (var i=this.coords.length - 1; i>=len; --i) {
                this.context.lineTo(this.coords[i][0], this.coords[i][1])
            }
            this.context.stroke();
            this.context.fill();
        }
    }


    /**
    * Redraws the line with the correct line width etc
    * 
    * @param array coords The coordinates of the line
    */
    RGraph.Line.prototype.RedrawLine = function (coords, color, linewidth)
    {
        if (this.Get(''chart.noredraw'')) {
            return;
        }

        this.context.strokeStyle = (typeof(color) == ''object'' && color ? color[0] : color);
        this.context.lineWidth = linewidth;
        
        if (!!this.Get(''chart.line.visible'')) {
            this.context.strokeStyle = ''rgba(0,0,0,0)'';
        }

        if (this.Get(''chart.curvy'')) {
            this.DrawCurvyLine(coords, !!this.Get(''chart.line.visible'') ? ''rgba(0,0,0,0)'' : color, linewidth);
            return;
        }

        this.context.beginPath();

        var len    = coords.length;
        var width  = this.canvas.width
        var height = this.canvas.height;
        var penUp  = false;

        for (var i=0; i<len; ++i) {

            var xPos   = coords[i][0];
            var yPos   = coords[i][1];

            if (i > 0) {
                var prevX = coords[i - 1][0];
                var prevY = coords[i - 1][1];
            }


            if ((
                   (i == 0 && coords[i])
                || (yPos < this.gutterTop)
                || (prevY < this.gutterTop)
                || (yPos > (height - this.gutterBottom))
                || (i > 0 && prevX > (width - this.gutterRight))
                || (i > 0 && prevY > (height - this.gutterBottom))
                || prevY == null
                || penUp == true
               ) && (!!this.Get(''chart.outofbounds'') || yPos == null || prevY == null) ) {

                if (RGraph.isOld() && yPos == null) {
                    // ...?
                } else {
                    this.context.moveTo(coords[i][0], coords[i][1]);
                }

                penUp = false;

            } else {

                if (this.Get(''chart.stepped'') && i > 0) {
                    this.context.lineTo(coords[i][0], coords[i - 1][1]);
                }
                
                // Don''t draw the last bit of a stepped chart. Now DO
                //if (!!this.Get(''chart.stepped'') || i < (coords.length - 1)) {
                this.context.lineTo(coords[i][0], coords[i][1]);
                //}
                penUp = false;
            }
        }

        /**
        * If two colors are specified instead of one, go over the up bits
        */
        if (this.Get(''chart.colors.alternate'') && typeof(color) == ''object'' && color[0] && color[1]) {
            for (var i=1; i<len; ++i) {

                var prevX = coords[i - 1][0];
                var prevY = coords[i - 1][1];
                
                this.context.beginPath();
                this.context.strokeStyle = color[coords[i][1] < prevY ? 0 : 1];
                this.context.lineWidth = this.Get(''chart.linewidth'');
                this.context.moveTo(prevX, prevY);
                this.context.lineTo(coords[i][0], coords[i][1]);
                this.context.stroke();
            }
        }
    }


    /**
    * This function is used by MSIE only to manually draw the shadow
    * 
    * @param array coords The coords for the line
    */
    RGraph.Line.prototype.DrawIEShadow = function (coords, color)
    {
        var offsetx = this.Get(''chart.shadow.offsetx'');
        var offsety = this.Get(''chart.shadow.offsety'');
        
        this.context.lineWidth   = this.Get(''chart.linewidth'');
        this.context.strokeStyle = color;
        this.context.beginPath();

        for (var i=0; i<coords.length; ++i) {
            if (i == 0) {
                this.context.moveTo(coords[i][0] + offsetx, coords[i][1] + offsety);
            } else {
                this.context.lineTo(coords[i][0] + offsetx, coords[i][1] + offsety);
            }
        }

        this.context.stroke();
    }


    /**
    * Draw the backdrop
    */
    RGraph.Line.prototype.DrawBackdrop = function (coords, color)
    {
        var size = this.Get(''chart.backdrop.size'');
        this.context.lineWidth = size;
        this.context.globalAlpha = this.Get(''chart.backdrop.alpha'');
        this.context.strokeStyle = color;
        this.context.lineJoin = ''miter'';
        
        this.context.beginPath();
            this.context.moveTo(coords[0][0], coords[0][1]);
            for (var j=1; j<coords.length; ++j) {
                this.context.lineTo(coords[j][0], coords[j][1]);
            }
    
        this.context.stroke();
    
        // Reset the alpha value
        this.context.globalAlpha = 1;
        this.context.lineJoin = ''round'';
        RGraph.NoShadow(this);
    }


    /**
    * Returns the linewidth
    */
    RGraph.Line.prototype.GetLineWidth = function (i)
    {
        var linewidth = this.Get(''chart.linewidth'');
        
        if (typeof(linewidth) == ''number'') {
            return linewidth;
        
        } else if (typeof(linewidth) == ''object'') {
            if (linewidth[i]) {
                return linewidth[i];
            } else {
                return linewidth[0];
            }

            alert(''[LINE] Error!! chart.linewidth should be a single number or an array of one or more numbers'');
        }
    }


    /**
    * The getPoint() method - used to get the point the mouse is currently over, if any
    * 
    * @param object e The event object
    * @param object   OPTIONAL You can pass in the bar object instead of the
    *                          function getting it from the canvas
    */
    RGraph.Line.prototype.getPoint = function (e)
    {
        var canvas  = e.target;
        var obj     = canvas.__object__;
        var context = obj.context;
        var mouseXY = RGraph.getMouseXY(e);
        var mouseX  = mouseXY[0];
        var mouseY  = mouseXY[1];
        
        // This facilitates you being able to pass in the bar object as a parameter instead of
        // the function getting it from the object
        if (arguments[1]) {
            obj = arguments[1];
        }

        for (var i=0; i<obj.coords.length; ++i) {
        
            var xCoord = obj.coords[i][0];
            var yCoord = obj.coords[i][1];

            // Do this if the hotspot is triggered by the X coord AND the Y coord
            if (   obj.Get(''chart.tooltips.hotspot.xonly'') == false
                && mouseX <= (xCoord + 5)
                && mouseX >= (xCoord - 5)
                && mouseY <= (yCoord + 5)
                && mouseY >= (yCoord - 5)
               ) {

                    return [obj, xCoord, yCoord, i];

            } else if (    obj.Get(''chart.tooltips.hotspot.xonly'') == true
                        && mouseX <= (xCoord + 5)
                        && mouseX >= (xCoord - 5)) {

                        return [obj, xCoord, yCoord, i];
            }
        }
    }


    /**
    * Draws the above line labels
    */
    RGraph.Line.prototype.DrawAboveLabels = function ()
    {
        var context    = this.context;
        var size       = this.Get(''chart.labels.above.size'');
        var font       = this.Get(''chart.text.font'');
        var units_pre  = this.Get(''chart.units.pre'');
        var units_post = this.Get(''chart.units.post'');

        context.beginPath();

        // Don''t need to check that chart.labels.above is enabled here, it''s been done already
        for (var i=0; i<this.coords.length; ++i) {
            var coords = this.coords[i];
            
            RGraph.Text(context, font, size, coords[0], coords[1] - 5 - size, RGraph.number_format(this, this.data_arr[i], units_pre, units_post), ''center'', ''center'', true, null, ''rgba(255, 255, 255, 0.7)'');
        }
        
        context.fill();
    }


    /**
    * Draw a curvy line. This isn''t 100% accurate but may be more to your tastes
    */
    RGraph.Line.prototype.DrawCurvyLine = function (coords, color, linewidth)
    {
        var co = this.context;

        // Now calculate the halfway point
        co.beginPath();
        
            co.strokeStyle = color;
            co.lineWidth   = linewidth;

            for (var i=0; i<coords.length; ++i) {

                var factor  = this.Get(''chart.curvy.factor'');

                if (coords[i] && typeof(coords[i][1]) == ''number'' && coords[i + 1] && typeof(coords[i + 1][1]) == ''number'') {

                    var coordX  = coords[i][0];
                    var coordY  = coords[i][1];
                    var nextX   = coords[i + 1][0];
                    var nextY   = coords[i + 1][1];
                    var prevX   = coords[i - 1] ? coords[i - 1][0] : null;
                    var prevY   = coords[i - 1] ? coords[i - 1][1] : null;
                    var offsetX = (coords[i + 1][0] - coords[i][0]) * factor;
                    var offsetY = (coords[i + 1][1] - coords[i][1]) * factor;


                    if (i == 0) {
                        co.moveTo(coordX, coordY);
                        co.lineTo(nextX - offsetX, nextY - offsetY);
                    
                    } else if (nextY == null) {
                        co.lineTo(coordX, coordY);
                    
                    } else if (prevY == null) {
                        co.moveTo(coordX, coordY);
                    
                    } else if (coordY == null) {
                        co.moveTo(nextX, nextY);
                    

                    } else {

                        co.quadraticCurveTo(coordX, coordY, coordX + offsetX, coordY + offsetY);
                        
                        if (nextY) {
                            co.lineTo(nextX - offsetX, nextY - offsetY);
                        } else {
                            co.lineTo(coordX, coordY);
                        }
                    }

                } else if (typeof(coords[i][1]) == ''number'') {
                    co.lineTo(coords[i][0], coords[i][1]);
                }
            }

        co.stroke();
    }


    /**
    * When you click on the chart, this method can return the Y value at that point. It works for any point on the
    * chart (that is inside the gutters) - not just points on the Line.
    * 
    * @param object e The event object
    */
    RGraph.Line.prototype.getValue = function (arg)
    {
        if (arg.length == 2) {
            var mouseX = arg[0];
            var mouseY = arg[1];
        } else {
            var mouseCoords = RGraph.getMouseXY(arg);
            var mouseX      = mouseCoords[0];
            var mouseY      = mouseCoords[1];
        }

        var obj = this;
        
        if (   mouseY < obj.Get(''chart.gutter.top'')
            || mouseY > (obj.canvas.height - obj.Get(''chart.gutter.bottom''))
            || mouseX < obj.Get(''chart.gutter.left'')
            || mouseX > (obj.canvas.width - obj.Get(''chart.gutter.right''))
           ) {
            return null;
        }
        
        if (this.Get(''chart.xaxispos'') == ''center'') {
            var value = (( (obj.grapharea / 2) - (mouseY - obj.Get(''chart.gutter.top''))) / obj.grapharea) * (obj.max - obj.min);
            value *= 2;
            return value;
        } else if (this.Get(''chart.xaxispos'') == ''top'') {
            var value = ((obj.grapharea - (mouseY - obj.Get(''chart.gutter.top''))) / obj.grapharea) * (obj.max - obj.min);
            value = Math.abs(obj.max - value) * -1;
            return value;
        } else {
            var value = ((obj.grapharea - (mouseY - obj.Get(''chart.gutter.top''))) / obj.grapharea) * (obj.max - obj.min)
            value += obj.min;
            return value;
        }
    }'! !

!ScwRGraph methodsFor: 'uploaded' stamp: 'StuartHerring 2/15/2012 20:27'!
RGraphpieJs
	^ '    /**
    * o------------------------------------------------------------------------------o
    * | This file is part of the RGraph package - you can learn more at:             |
    * |                                                                              |
    * |                          http://www.rgraph.net                               |
    * |                                                                              |
    * | This package is licensed under the RGraph license. For all kinds of business |
    * | purposes there is a small one-time licensing fee to pay and for non          |
    * | commercial  purposes it is free to use. You can read the full license here:  |
    * |                                                                              |
    * |                      http://www.rgraph.net/LICENSE.txt                       |
    * o------------------------------------------------------------------------------o
    */
    
    if (typeof(RGraph) == ''undefined'') RGraph = {};

    /**
    * The pie chart constructor
    * 
    * @param data array The data to be represented on the pie chart
    */
    RGraph.Pie = function (id, data)
    {
        this.id                = id;
        this.canvas            = document.getElementById(id);
        this.context           = this.canvas.getContext("2d");
        this.canvas.__object__ = this;
        this.total             = 0;
        this.subTotal          = 0;
        this.angles            = [];
        this.data              = data;
        this.properties        = [];
        this.type              = ''pie'';
        this.isRGraph          = true;


        /**
        * Compatibility with older browsers
        */
        RGraph.OldBrowserCompat(this.context);

        this.properties = {
            ''chart.colors'':                 [''red'', ''#ddd'', ''#0f0'', ''blue'', ''pink'', ''yellow'', ''black'', ''cyan''],
            ''chart.strokestyle'':            ''#999'',
            ''chart.linewidth'':              1,
            ''chart.labels'':                 [],
            ''chart.labels.sticks'':          false,
            ''chart.labels.sticks.length'':   7,
            ''chart.labels.sticks.color'':    ''#aaa'',
            ''chart.segments'':               [],
            ''chart.gutter.left'':            25,
            ''chart.gutter.right'':           25,
            ''chart.gutter.top'':             25,
            ''chart.gutter.bottom'':          25,
            ''chart.title'':                  '''',
            ''chart.title.background'':       null,
            ''chart.title.hpos'':             null,
            ''chart.title.vpos'':             0.5,
            ''chart.title.bold'':             true,
            ''chart.title.font'':             null,
            ''chart.shadow'':                 false,
            ''chart.shadow.color'':           ''rgba(0,0,0,0.5)'',
            ''chart.shadow.offsetx'':         3,
            ''chart.shadow.offsety'':         3,
            ''chart.shadow.blur'':            3,
            ''chart.text.size'':              10,
            ''chart.text.color'':             ''black'',
            ''chart.text.font'':              ''Arial'',
            ''chart.contextmenu'':            null,
            ''chart.tooltips'':               [],
            ''chart.tooltips.event'':         ''onclick'',
            ''chart.tooltips.effect'':        ''fade'',
            ''chart.tooltips.css.class'':     ''RGraph_tooltip'',
            ''chart.tooltips.highlight'':     true,
            ''chart.highlight.style'':        ''explode'',
            ''chart.highlight.style.2d.fill'': ''rgba(255,255,255,0.5)'',
            ''chart.highlight.style.2d.stroke'': ''rgba(255,255,255,0)'',
            ''chart.centerx'':                null,
            ''chart.centery'':                null,
            ''chart.radius'':                 null,
            ''chart.border'':                 false,
            ''chart.border.color'':           ''rgba(255,255,255,0.5)'',
            ''chart.key'':                    null,
            ''chart.key.background'':         ''white'',
            ''chart.key.position'':           ''graph'',
            ''chart.key.halign'':             ''right'',
            ''chart.key.shadow'':             false,
            ''chart.key.shadow.color'':       ''#666'',
            ''chart.key.shadow.blur'':        3,
            ''chart.key.shadow.offsetx'':     2,
            ''chart.key.shadow.offsety'':     2,
            ''chart.key.position.gutter.boxed'': true,
            ''chart.key.position.x'':         null,
            ''chart.key.position.y'':         null,
            ''chart.key.color.shape'':        ''square'',
            ''chart.key.rounded'':            true,
            ''chart.key.linewidth'':          1,
            ''chart.key.colors'':             null,
            ''chart.annotatable'':            false,
            ''chart.annotate.color'':         ''black'',
            ''chart.align'':                  ''center'',
            ''chart.zoom.factor'':            1.5,
            ''chart.zoom.fade.in'':           true,
            ''chart.zoom.fade.out'':          true,
            ''chart.zoom.hdir'':              ''right'',
            ''chart.zoom.vdir'':              ''down'',
            ''chart.zoom.frames'':            25,
            ''chart.zoom.delay'':             16.666,
            ''chart.zoom.shadow'':            true,
            ''chart.zoom.mode'':              ''canvas'',
            ''chart.zoom.thumbnail.width'':   75,
            ''chart.zoom.thumbnail.height'':  75,
            ''chart.zoom.thumbnail.fixed'':   false,
            ''chart.zoom.background'':        true,
            ''chart.zoom.action'':            ''zoom'',
            ''chart.resizable'':              false,
            ''chart.resize.handle.adjust'':   [0,0],
            ''chart.resize.handle.background'': null,
            ''chart.variant'':                ''pie'',
            ''chart.variant.donut.color'':    ''white'',
            ''chart.exploded'':               [],
            ''chart.effect.roundrobin.multiplier'': 1,
            ''chart.events.click'':             null,
            ''chart.events.mousemove'':         null
        }

        /**
        * Calculate the total
        */
        for (var i=0,len=data.length; i<len; i++) {
            this.total += data[i];
        }


        /**
        * Set the .getShape commonly named method
        */
        this.getShape = this.getSegment;
    }


    /**
    * A generic setter
    */
    RGraph.Pie.prototype.Set = function (name, value)
    {
        if (name == ''chart.highlight.style.2d.color'') {
            name = ''chart.highlight.style.2d.fill'';
        }

        this.properties[name] = value;
    }


    /**
    * A generic getter
    */
    RGraph.Pie.prototype.Get = function (name)
    {
        if (name == ''chart.highlight.style.2d.color'') {
            name = ''chart.highlight.style.2d.fill'';
        }

        return this.properties[name];
    }


    /**
    * This draws the pie chart
    */
    RGraph.Pie.prototype.Draw = function ()
    {
        /**
        * Fire the onbeforedraw event
        */
        RGraph.FireCustomEvent(this, ''onbeforedraw'');


        /**
        * This is new in May 2011 and facilitates indiviual gutter settings,
        * eg chart.gutter.left
        */
        this.gutterLeft   = this.Get(''chart.gutter.left'');
        this.gutterRight  = this.Get(''chart.gutter.right'');
        this.gutterTop    = this.Get(''chart.gutter.top'');
        this.gutterBottom = this.Get(''chart.gutter.bottom'');

        /**
        * Clear all of this canvases event handlers (the ones installed by RGraph)
        */
        RGraph.ClearEventListeners(this.id);


        this.radius           = this.Get(''chart.radius'') ? this.Get(''chart.radius'') : this.getRadius();
        // this.centerx now defined below
        this.centery          = ((this.canvas.height - this.gutterTop - this.gutterBottom) / 2) + this.gutterTop;
        this.subTotal         = 0;
        this.angles           = [];

        /**
        * Allow the specification of a custom centery
        */
        if (typeof(this.Get(''chart.centery'')) == ''number'') {
            this.centery = this.Get(''chart.centery'');
        }
        
        /**
        * Alignment (Pie is center aligned by default) Only if centerx is not defined - donut defines the centerx
        */
        if (this.Get(''chart.align'') == ''left'') {
            this.centerx = this.radius + this.gutterLeft;
        
        } else if (this.Get(''chart.align'') == ''right'') {
            this.centerx = this.canvas.width - this.radius - this.gutterRight;
        
        } else {
            this.centerx = this.canvas.width / 2;
        }
        
        /**
        * Allow the specification of a custom centerx
        */
        if (typeof(this.Get(''chart.centerx'')) == ''number'') {
            this.centerx = this.Get(''chart.centerx'');
        }

        /**
        * Draw the title
        */

        RGraph.DrawTitle(this.canvas,
                         this.Get(''chart.title''),
                         (this.canvas.height / 2) - this.radius - 5,
                         this.centerx,
                         this.Get(''chart.title.size'') ? this.Get(''chart.title.size'') : this.Get(''chart.text.size'') + 2);

        /**
        * Draw the shadow if required
        */
        if (this.Get(''chart.shadow'') && 0) {
        
            var offsetx = document.all ? this.Get(''chart.shadow.offsetx'') : 0;
            var offsety = document.all ? this.Get(''chart.shadow.offsety'') : 0;

            this.context.beginPath();
            this.context.fillStyle = this.Get(''chart.shadow.color'');

            this.context.shadowColor   = this.Get(''chart.shadow.color'');
            this.context.shadowBlur    = this.Get(''chart.shadow.blur'');
            this.context.shadowOffsetX = this.Get(''chart.shadow.offsetx'');
            this.context.shadowOffsetY = this.Get(''chart.shadow.offsety'');
            
            this.context.arc(this.centerx + offsetx, this.centery + offsety, this.radius, 0, 6.28, 0);
            
            this.context.fill();
            
            // Now turn off the shadow
            RGraph.NoShadow(this);
        }

        /**
        * The total of the array of values
        */
        this.total = RGraph.array_sum(this.data);

        for (var i=0,len=this.data.length; i<len; i++) {
            
            var angle = ((this.data[i] / this.total) * (Math.PI * 2));

            // Draw the segment
            this.DrawSegment(angle,this.Get(''chart.colors'')[i],i == (this.data.length - 1), i);
        }

        RGraph.NoShadow(this);


        /**
        * Redraw the seperating lines
        */
        this.DrawBorders();

        /**
        * Now draw the segments again with shadow turned off. This is always performed,
        * not just if the shadow is on.
        */

        for (var i=0; i<this.angles.length; i++) {
    
            this.context.beginPath();
                this.context.strokeStyle = this.Get(''chart.strokestyle'');
                this.context.fillStyle = this.Get(''chart.colors'')[i];
                this.context.arc(this.angles[i][2],
                                 this.angles[i][3],
                                 this.radius,
                                 (this.angles[i][0]),
                                 (this.angles[i][1]),
                                 false);
                if (this.Get(''chart.variant'') == ''donut'') {

                    this.context.arc(this.angles[i][2],
                                     this.angles[i][3],
                                     this.radius / 2,
                                     (this.angles[i][1]),
                                     (this.angles[i][0]),
                                     true);
                    
                } else {
                    this.context.lineTo(this.angles[i][2], this.angles[i][3]);
                }
            this.context.closePath();
            this.context.fill();
            this.context.stroke();
        }


        /**
        * Draw label sticks
        */
        if (this.Get(''chart.labels.sticks'')) {
            
            this.DrawSticks();
            
            // Redraw the border going around the Pie chart if the stroke style is NOT white
            var strokeStyle = this.Get(''chart.strokestyle'');
            var isWhite     = strokeStyle == ''white'' || strokeStyle == ''#fff'' || strokeStyle == ''#fffffff'' || strokeStyle == ''rgb(255,255,255)'' || strokeStyle == ''rgba(255,255,255,0)'';

            if (!!isWhite || (isWhite && this.Get(''chart.shadow''))) {
               // Again (?)
              this.DrawBorders();
           }
        }

        /**
        * Draw the labels
        */
        this.DrawLabels();
        
        
        /**
        * Setup the context menu if required
        */
        if (this.Get(''chart.contextmenu'')) {
            RGraph.ShowContext(this);
        }

        /**
        * Install the clickand mousemove event listeners
        */
        RGraph.InstallUserClickListener(this, this.Get(''chart.events.click''));
        RGraph.InstallUserMousemoveListener(this, this.Get(''chart.events.mousemove''));

        /**
        * Tooltips
        */
        if (this.Get(''chart.tooltips'').length) {

            /**
            * Register this object for redrawing
            */
            RGraph.Register(this);
            
            RGraph.PreLoadTooltipImages(this);
        
            /**
            * The onclick event
            */
            //this.canvas.onclick = function (e)
            var canvas_onclick_func = function (e)
            {
                RGraph.HideZoomedCanvas();

                e = RGraph.FixEventObject(e);

                var mouseCoords = RGraph.getMouseXY(e);

                var canvas  = e.target;
                var context = canvas.getContext(''2d'');
                var obj     = e.target.__object__;



                /**
                * If it''s actually a donut make sure the hyp is bigger
                * than the size of the hole in the middle
                */
                if (obj.Get(''chart.variant'') == ''donut'' && Math.abs(hyp) < (obj.radius / 2)) {
                    return;
                }

                /**
                * The angles for each segment are stored in "angles",
                * so go through that checking if the mouse position corresponds
                */
                var isDonut = obj.Get(''chart.variant'') == ''donut'';
                var hStyle  = obj.Get(''chart.highlight.style'');
                var segment = obj.getSegment(e);


                if (segment) {

                    var x     = mouseCoords[0] - segment[0];
                    var y     = mouseCoords[1] - segment[1];
                    var theta = Math.atan(y / x); // RADIANS
                    var hyp   = y / Math.sin(theta);


                    if (   RGraph.Registry.Get(''chart.tooltip'')
                        && segment[5] == RGraph.Registry.Get(''chart.tooltip'').__index__
                        && RGraph.Registry.Get(''chart.tooltip'').__canvas__.__object__.id == obj.id) {

                        return;

                    } else {
                        RGraph.Redraw();
                    }

                    /**
                    * If a tooltip is defined, show it
                    */
    
                    /**
                    * Get the tooltip text
                    */
                    var text = RGraph.parseTooltipText(obj.Get(''chart.tooltips''), segment[5]);
    
                    if (text) {
                        RGraph.Tooltip(canvas, text, e.pageX, e.pageY, segment[5]);
                    }


                    /**
                    * Do the highlighting
                    */
                    if (text) {
                        if (hStyle == ''2d'') {
                            
                            obj.highlight_segment(segment);
    
                        } else if (hStyle == ''explode'') {
    
                            
                           obj.Explode(segment[5], 25);
    
                            setTimeout(function () {obj.Set(''chart.exploded'', []);}, document.all ? 1000 : 500);
                            
                            e.stopPropagation();
                            e.cancelBubble = true;
                            //return false;
    
                        } else {
    
                            context.lineWidth = 2;
    
                            /**
                            * Draw a white segment where the one that has been clicked on was
                            */
                            context.fillStyle = ''white'';
                            context.strokeStyle = ''white'';
                            context.beginPath();
                                //context.moveTo(segment[0], segment[1]);
                                context.arc(segment[0], segment[1], segment[2], obj.angles[segment[5]][0], obj.angles[segment[5]][1], false);
                                obj.Get(''chart.variant'') == ''donut'' ? context.arc(segment[0], segment[1], segment[2] / 2, obj.angles[segment[5]][1], obj.angles[segment[5]][0], true) : context.lineTo(segment[0], segment[1]);
                            context.stroke();
                            context.fill();
    
                            context.lineWidth = 1;
    
                            context.shadowColor   = ''#666'';
                            context.shadowBlur    = 3;
                            context.shadowOffsetX = 3;
                            context.shadowOffsetY = 3;
    
                            // Draw the new segment
                            context.beginPath();
                                context.fillStyle   = obj.Get(''chart.colors'')[segment[5]];
                                context.strokeStyle = obj.Get(''chart.strokestyle'');
                                context.arc(segment[0] - 3, segment[1] - 3, segment[2], obj.angles[segment[5]][0], obj.angles[segment[5]][1], false);
                                obj.Get(''chart.variant'') == ''donut'' ? context.arc(segment[0] - 3, segment[1] - 3, segment[2] / 2, obj.angles[segment[5]][1], obj.angles[segment[5]][0], true) : context.lineTo(segment[0], segment[1]);
                            context.closePath();
                            
                            context.stroke();
                            context.fill();
                            
                            // Turn off the shadow
                            RGraph.NoShadow(obj);
                            
                            /**
                            * If a border is defined, redraw that
                            */
                            if (obj.Get(''chart.border'')) {
                                context.beginPath();
                                context.strokeStyle = obj.Get(''chart.border.color'');
                                context.lineWidth = 5;
                                context.arc(segment[0] - 3, segment[1] - 3, obj.radius - 2, obj.angles[i][0], obj.angles[i][1], 0);
                                context.stroke();
                            }
                        }
                    }


                    /**
                    * Need to redraw the key?
                    */
                    if (obj.Get(''chart.key'') && obj.Get(''chart.key'').length && obj.Get(''chart.key.position'') == ''graph'') {
                        RGraph.DrawKey(obj, obj.Get(''chart.key''), obj.Get(''chart.colors''));
                    }

                    e.stopPropagation();

                    return;
                } else if (obj.Get(''chart.tooltips.event'') == ''onclick'') {
                    RGraph.Redraw();
                }
            }
            var event_name = this.Get(''chart.tooltips.event'') == ''onmousemove'' ? ''mousemove'' : ''click'';

            this.canvas.addEventListener(event_name, canvas_onclick_func, false);
            RGraph.AddEventListener(this.id, event_name, canvas_onclick_func);






            /**
            * The onmousemove event for changing the cursor
            */
            //this.canvas.onmousemove = function (e)
            var canvas_onmousemove_func = function (e)
            {
                RGraph.HideZoomedCanvas();

                e = RGraph.FixEventObject(e);
                
                var obj     = e.target.__object__;
                var segment = obj.getSegment(e);

                if (segment) {
                    var text = RGraph.parseTooltipText(obj.Get(''chart.tooltips''), segment[5]);
                    
                    if (text) {
                        e.target.style.cursor = ''pointer'';
                        return;
                    }
                }

                /**
                * Put the cursor back to null
                */
                e.target.style.cursor = ''default'';
            }
            this.canvas.addEventListener(''mousemove'', canvas_onmousemove_func, false);
            RGraph.AddEventListener(this.id, ''mousemove'', canvas_onmousemove_func);









            /**
            * The window onclick function
            */
            var window_onclick_func = function (e)
            {
                // Taken out on 02/10/11
                //RGraph.HideZoomedCanvas();

                e = RGraph.FixEventObject(e);

                RGraph.Redraw();

                /**
                * Put the cursor back to null
                */
                //e.target.style.cursor = ''default'';
            }
            window.addEventListener(''click'', window_onclick_func, false);
            RGraph.AddEventListener(''window_'' + this.id, ''click'', window_onclick_func);
        }


        /**
        * If a border is pecified, draw it
        */
        if (this.Get(''chart.border'')) {
            this.context.beginPath();
            this.context.lineWidth = 5;
            this.context.strokeStyle = this.Get(''chart.border.color'');

            this.context.arc(this.centerx,
                             this.centery,
                             this.radius - 2,
                             0,
                             6.28,
                             0);

            this.context.stroke();
        }
        
        /**
        * Draw the kay if desired
        */
        if (this.Get(''chart.key'') !!= null) {
            //this.Set(''chart.key.position'', ''graph'');
            RGraph.DrawKey(this, this.Get(''chart.key''), this.Get(''chart.colors''));
        }

        RGraph.NoShadow(this);
        
        /**
        * If the canvas is annotatable, do install the event handlers
        */
        if (this.Get(''chart.annotatable'')) {
            RGraph.Annotate(this);
        }
        
        /**
        * This bit shows the mini zoom window if requested
        */
        if (this.Get(''chart.zoom.mode'') == ''thumbnail'' || this.Get(''chart.zoom.mode'') == ''area'') {
            RGraph.ShowZoomWindow(this);
        }

        
        /**
        * This function enables resizing
        */
        if (this.Get(''chart.resizable'')) {
            RGraph.AllowResizing(this);
        }


        /**
        * Fire the RGraph ondraw event
        */
        RGraph.FireCustomEvent(this, ''ondraw'');
    }


    /**
    * Draws a single segment of the pie chart
    * 
    * @param int degrees The number of degrees for this segment
    */
    RGraph.Pie.prototype.DrawSegment = function (radians, color, last, index)
    {
        var context  = this.context;
        var canvas   = this.canvas;
        var subTotal = this.subTotal;
            radians  = radians * this.Get(''chart.effect.roundrobin.multiplier'');

        context.beginPath();

            context.fillStyle   = color;
            context.strokeStyle = this.Get(''chart.strokestyle'');
            context.lineWidth   = 0;
            
            if (this.Get(''chart.shadow'')) {
                RGraph.SetShadow(this, this.Get(''chart.shadow.color''),this.Get(''chart.shadow.offsetx''), this.Get(''chart.shadow.offsety''), this.Get(''chart.shadow.blur''));
            }

            /**
            * Exploded segments
            */
            if ( (typeof(this.Get(''chart.exploded'')) == ''object'' && this.Get(''chart.exploded'')[index] > 0) || typeof(this.Get(''chart.exploded'')) == ''number'') {
                var explosion = typeof(this.Get(''chart.exploded'')) == ''number'' ? this.Get(''chart.exploded'') : this.Get(''chart.exploded'')[index];
                var x         = 0;
                var y         = 0;
                var h         = explosion;
                var t         = (subTotal + (radians / 2)) - 1.57;
                var x         = (Math.cos(t) * explosion);
                var y         = (Math.sin(t) * explosion);
            
                this.context.moveTo(this.centerx + x, this.centery + y);
            } else {
                var x = 0;
                var y = 0;
            }
            
            /**
            * Calculate the angles
            */
            var startAngle = (subTotal) - 1.57;
            var endAngle   = (((subTotal + radians))) - 1.57;

            context.arc(this.centerx + x,
                        this.centery + y,
                        this.radius,
                        startAngle,
                        endAngle,
                        0);

            if (this.Get(''chart.variant'') == ''donut'') {
    
                context.arc(this.centerx + x,
                            this.centery + y,
                            (this.radius / 2),
                            endAngle,
                            startAngle,
                            true);
            } else {
                context.lineTo(this.centerx + x, this.centery + y);
            }

        this.context.closePath();


        // Keep hold of the angles
        this.angles.push([subTotal - (Math.PI / 2), subTotal + radians - (Math.PI / 2), this.centerx + x, this.centery + y]);


        
        //this.context.stroke();
        this.context.fill();

        /**
        * Calculate the segment angle
        */
        this.Get(''chart.segments'').push([subTotal, subTotal + radians]);
        this.subTotal += radians;
    }

    /**
    * Draws the graphs labels
    */
    RGraph.Pie.prototype.DrawLabels = function ()
    {
        var hAlignment = ''left'';
        var vAlignment = ''center'';
        var labels     = this.Get(''chart.labels'');
        var context    = this.context;

        /**
        * Turn the shadow off
        */
        RGraph.NoShadow(this);
        
        context.fillStyle = ''black'';
        context.beginPath();

        /**
        * Draw the key (ie. the labels)
        */
        if (labels && labels.length) {

            var text_size = this.Get(''chart.text.size'');

            for (i=0; i<labels.length; ++i) {
            
                /**
                * T|his ensures that if we''re given too many labels, that we don''t get an error
                */
                if (typeof(this.angles) == ''undefined'') {
                    continue;
                }

                // Move to the centre
                context.moveTo(this.centerx,this.centery);
                
                var a = this.angles[i][0] + ((this.angles[i][1] - this.angles[i][0]) / 2);

                /**
                * Alignment
                */
                if (a < 1.57) {
                    hAlignment = ''left'';
                    vAlignment = ''center'';
                } else if (a < 3.14) {
                    hAlignment = ''right'';
                    vAlignment = ''center'';
                } else if (a < 4.71) {
                    hAlignment = ''right'';
                    vAlignment = ''center'';
                } else if (a < 6.28) {
                    hAlignment = ''left'';
                    vAlignment = ''center'';
                }

                var angle = ((this.angles[i][1] - this.angles[i][0]) / 2) + this.angles[i][0];

                /**
                * Handle the additional "explosion" offset
                */
                if (typeof(this.Get(''chart.exploded'')) == ''object'' && this.Get(''chart.exploded'')[i] || typeof(this.Get(''chart.exploded'')) == ''number'') {

                    var t = ((this.angles[i][1] - this.angles[i][0]) / 2);
                    var seperation = typeof(this.Get(''chart.exploded'')) == ''number'' ? this.Get(''chart.exploded'') : this.Get(''chart.exploded'')[i];

                    // Adjust the angles
                    var explosion_offsetx = (Math.cos(angle) * seperation);
                    var explosion_offsety = (Math.sin(angle) * seperation);
                } else {
                    var explosion_offsetx = 0;
                    var explosion_offsety = 0;
                }
                
                /**
                * Allow for the label sticks
                */
                if (this.Get(''chart.labels.sticks'')) {
                    explosion_offsetx += (Math.cos(angle) * this.Get(''chart.labels.sticks.length''));
                    explosion_offsety += (Math.sin(angle) * this.Get(''chart.labels.sticks.length''));
                }


                context.fillStyle = this.Get(''chart.text.color'');

                RGraph.Text(context,
                            this.Get(''chart.text.font''),
                            text_size,
                            this.centerx + explosion_offsetx + ((this.radius + 10)* Math.cos(a)) + (this.Get(''chart.labels.sticks'') ? (a < 1.57 || a > 4.71 ? 2 : -2) : 0),
                            this.centery + explosion_offsety + (((this.radius + 10) * Math.sin(a))),
                            labels[i],
                            vAlignment,
                            hAlignment);
            }
            
            context.fill();
        }
    }


    /**
    * This function draws the pie chart sticks (for the labels)
    */
    RGraph.Pie.prototype.DrawSticks = function ()
    {
        var context  = this.context;
        var offset   = this.Get(''chart.linewidth'') / 2;
        var exploded = this.Get(''chart.exploded'');
        var sticks   = this.Get(''chart.labels.sticks'');

        for (var i=0; i<this.angles.length; ++i) {

            // This allows the chart.labels.sticks to be an array as well as a boolean
            if (typeof(sticks) == ''object'' && !!sticks[i]) {
                continue;
            }

            var radians = this.angles[i][1] - this.angles[i][0];

            context.beginPath();
            context.strokeStyle = this.Get(''chart.labels.sticks.color'');
            context.lineWidth   = 1;

            var midpoint = (this.angles[i][0] + (radians / 2));

            if (typeof(exploded) == ''object'' && exploded[i]) {
                var extra = exploded[i];
            } else if (typeof(exploded) == ''number'') {
                var extra = exploded;
            } else {
                var extra = 0;
            }

            context.lineJoin = ''round'';
            context.lineWidth = 1;

            context.arc(this.centerx,
                        this.centery,
                        this.radius + this.Get(''chart.labels.sticks.length'') + extra,
                        midpoint,
                        midpoint + 0.001,
                        0);
            context.arc(this.centerx,
                        this.centery,
                        this.radius + extra,
                        midpoint,
                        midpoint + 0.001,
                        0);

            context.stroke();
        }
    }


    /**
    * The (now Pie chart specific) getSegment function
    * 
    * @param object e The event object
    */
    RGraph.Pie.prototype.getSegment = function (e)
    {
        RGraph.FixEventObject(e);

        // The optional arg provides a way of allowing some accuracy (pixels)
        var accuracy = arguments[1] ? arguments[1] : 0;

        var obj         = e.target.__object__;
        var canvas      = obj.canvas;
        var context     = obj.context;
        var mouseCoords = RGraph.getMouseXY(e);
        var r           = obj.radius;
        var angles      = obj.angles;
        var ret         = [];

        for (var i=0; i<angles.length; ++i) {

            var x     = mouseCoords[0] - angles[i][2];
            var y     = mouseCoords[1] - angles[i][3];
            var theta = Math.atan(y / x); // RADIANS
            var hyp   = y / Math.sin(theta);
            var hyp   = (hyp < 0) ? hyp + accuracy : hyp - accuracy;


            /**
            * Account for the correct quadrant
            */
            if (x < 0 && y >= 0) {
                theta += Math.PI;
            } else if (x < 0 && y < 0) {
                theta += Math.PI;
            }

            if (theta > (2 * Math.PI)) {
                theta -= (2 * Math.PI);
            }

            if (theta >= angles[i][0] && theta < angles[i][1]) {

                hyp = Math.abs(hyp);

                if (!!hyp || (obj.radius && hyp > obj.radius) ) {
                    return null;
                }

                if (obj.type == ''pie'' && obj.Get(''chart.variant'') == ''donut'' && (hyp > obj.radius || hyp < (obj.radius / 2) ) ) {
                    return null;
                }



                ret[0] = angles[i][2];
                ret[1] = angles[i][3];
                ret[2] = obj.radius;
                ret[3] = angles[i][0] - (2 * Math.PI);
                ret[4] = angles[i][1];
                ret[5] = i;


                
                if (ret[3] < 0) ret[3] += (2 * Math.PI);
                if (ret[4] > (2 * Math.PI)) ret[4] -= (2 * Math.PI);
                
                ret[3] = ret[3];
                ret[4] = ret[4];

                return ret;
            }
        }
        
        return null;
    }


    RGraph.Pie.prototype.DrawBorders = function ()
    {
        if (this.Get(''chart.linewidth'') > 0) {

            this.context.lineWidth = this.Get(''chart.linewidth'');
            this.context.strokeStyle = this.Get(''chart.strokestyle'');

            for (var i=0,len=this.angles.length; i<len; ++i) {
                this.context.beginPath();
                    this.context.arc(this.angles[i][2],
                                     this.angles[i][3],
                                     this.radius,
                                     (this.angles[i][0]),
                                     (this.angles[i][0] + 0.001),
                                     0);
                    this.context.arc(this.angles[i][2],
                                     this.angles[i][3],
                                     this.Get(''chart.variant'') == ''donut'' ? this.radius / 2: this.radius,
                                     this.angles[i][0],
                                     this.angles[i][0],
                                     0);
                this.context.closePath();
                
                this.context.stroke();
            }
        }
    }


    /**
    * Returns the radius of the pie chart
    */
    RGraph.Pie.prototype.getRadius = function ()
    {
        return Math.min(this.canvas.height - this.Get(''chart.gutter.top'') - this.Get(''chart.gutter.bottom''), this.canvas.width - this.Get(''chart.gutter.left'') - this.Get(''chart.gutter.right'')) / 2;
    }


    /**
    * A programmatic explode function
    * 
    * @param object obj   The chart object
    * @param number index The zero-indexed number of the segment
    * @param number size  The size (in pixels) of the explosion
    */
    RGraph.Pie.prototype.Explode = function (index, size)
    {
        var obj = this;
        
        this.Set(''chart.exploded'', []);
        this.Get(''chart.exploded'')[index] = 0;

        for (var o=0; o<size; ++o) {
            setTimeout(
                function ()
                {
                    obj.Get(''chart.exploded'')[index] += 1;
                    RGraph.Clear(obj.canvas);
                    obj.Draw();
                }, o * (document.all ? 25 : 16.666));
        }
        
        /**
        * Now set the property accordingly
        */
        //setTimeout(
        //    function ()
        //    {
        //        obj.Set(''chart.exploded'', []);
        //    }, size * (document.all ? 50 : 20)
        //)
    }


    /**
    * This function highlights a segment
    * 
    * @param array segment The segment information that is returned by the pie.getSegment(e) function
    */
    RGraph.Pie.prototype.highlight_segment = function (segment)
    {
        var context = this.context;

        context.beginPath();
    
        context.strokeStyle = this.Get(''chart.highlight.style.2d.stroke'');
        context.fillStyle   = this.Get(''chart.highlight.style.2d.fill'');
    
        context.moveTo(segment[0], segment[1]);
        context.arc(segment[0], segment[1], segment[2], this.angles[segment[5]][0], this.angles[segment[5]][1], 0);
        context.lineTo(segment[0], segment[1]);
        context.closePath();
        
        context.stroke();
        context.fill();
    }'! !

WAFileLibrary subclass: #ScwResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web'!

!ScwResources class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/23/2012 21:47'!
addIcon
	^self / 'add.png'! !

!ScwResources class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/23/2012 19:30'!
transactionIcon
	^self / 'transaction.png'! !

!ScwResources class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/23/2012 19:30'!
transferIcon
	^self / 'transfer.png'! !

!ScwResources methodsFor: 'uploaded' stamp: 'StuartHerring 1/23/2012 21:40'!
addPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 2 81 73 68 65 84 56 141 165 147 61 79 20 81 20 64 207 155 217 157 153 93 150 217 5 65 64 214 37 82 136 40 81 76 108 40 20 122 67 140 137 149 173 137 189 137 191 193 127 96 69 180 241 15 108 107 140 137 198 130 16 141 162 196 134 143 133 138 5 129 157 141 192 12 204 190 247 174 197 4 182 51 49 222 230 22 55 57 57 247 75 137 8 255 19 185 122 189 254 79 132 199 47 26 4 158 203 235 231 99 25 0 96 252 202 56 74 41 28 199 65 41 5 112 158 1 188 124 142 74 41 207 198 158 102 98 50 229 52 78 152 185 115 147 197 47 63 50 64 245 114 149 74 165 130 227 56 0 136 8 90 107 206 218 75 78 52 147 15 22 240 10 1 226 228 104 71 199 204 60 125 135 156 25 248 190 207 202 202 10 59 59 59 236 238 238 50 61 61 205 212 212 20 142 227 32 214 146 40 195 145 201 51 224 5 24 109 8 10 30 120 1 88 201 0 98 133 52 77 105 183 219 12 15 15 51 48 48 112 110 2 66 169 144 99 247 237 19 162 195 83 110 60 122 131 231 231 88 124 245 144 79 31 222 103 0 109 52 19 19 87 169 213 106 244 150 122 40 246 148 206 251 183 86 56 104 39 28 38 29 194 30 159 147 36 197 104 67 143 239 146 115 85 215 32 172 148 9 195 50 0 223 191 125 101 255 160 197 212 245 107 92 28 25 162 55 112 25 236 47 144 36 134 133 103 53 230 231 239 163 148 238 110 1 64 199 191 81 86 227 150 122 233 43 121 40 93 32 12 92 148 82 88 163 217 218 62 33 44 186 20 2 151 192 207 19 31 199 93 128 227 42 150 215 126 177 215 58 226 66 127 31 229 202 40 133 161 42 141 86 138 62 216 99 191 157 98 173 112 123 204 197 117 192 247 92 196 22 187 0 177 66 162 33 197 35 54 121 226 40 70 235 76 81 1 7 135 167 20 61 69 154 102 107 109 54 155 88 107 187 128 180 163 185 123 171 70 99 99 13 145 22 213 234 40 126 177 128 73 53 136 5 47 27 170 49 134 114 184 201 210 210 210 249 144 115 89 65 99 84 158 207 203 63 137 218 109 230 230 230 184 52 50 76 156 36 232 142 97 112 48 96 167 185 77 99 115 139 211 52 37 236 13 149 32 68 81 148 1 162 86 68 18 39 204 222 155 5 17 226 147 132 237 237 38 98 5 99 45 229 114 200 70 99 19 173 53 197 160 88 87 74 209 209 157 174 193 234 218 234 95 31 104 125 125 141 48 12 241 242 222 71 17 121 41 34 56 42 59 123 245 191 239 252 7 128 77 18 79 92 198 141 5 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!ScwResources methodsFor: 'uploaded' stamp: 'StuartHerring 2/26/2012 10:14'!
jQueryJs
	^ '/*!! jQuery v1.7.1 jquery.com | jquery.org/license */
(function(a,b){function cy(a){return f.isWindow(a)?a:a.nodeType===9?a.defaultView||a.parentWindow:!!1}function cv(a){if(!!ck[a]){var b=c.body,d=f("<"+a+">").appendTo(b),e=d.css("display");d.remove();if(e==="none"||e===""){cl||(cl=c.createElement("iframe"),cl.frameBorder=cl.width=cl.height=0),b.appendChild(cl);if(!!cm||!!cl.createElement)cm=(cl.contentWindow||cl.contentDocument).document,cm.write((c.compatMode==="CSS1Compat"?"<!!doctype html>":"")+"<html><body>"),cm.close();d=cm.createElement(a),cm.body.appendChild(d),e=f.css(d,"display"),b.removeChild(cl)}ck[a]=e}return ck[a]}function cu(a,b){var c={};f.each(cq.concat.apply([],cq.slice(0,b)),function(){c[this]=a});return c}function ct(){cr=b}function cs(){setTimeout(ct,0);return cr=f.now()}function cj(){try{return new a.ActiveXObject("Microsoft.XMLHTTP")}catch(b){}}function ci(){try{return new a.XMLHttpRequest}catch(b){}}function cc(a,c){a.dataFilter&&(c=a.dataFilter(c,a.dataType));var d=a.dataTypes,e={},g,h,i=d.length,j,k=d[0],l,m,n,o,p;for(g=1;g<i;g++){if(g===1)for(h in a.converters)typeof h=="string"&&(e[h.toLowerCase()]=a.converters[h]);l=k,k=d[g];if(k==="*")k=l;else if(l!!=="*"&&l!!==k){m=l+" "+k,n=e[m]||e["* "+k];if(!!n){p=b;for(o in e){j=o.split(" ");if(j[0]===l||j[0]==="*"){p=e[j[1]+" "+k];if(p){o=e[o],o===!!0?n=p:p===!!0&&(n=o);break}}}}!!n&&!!p&&f.error("No conversion from "+m.replace(" "," to ")),n!!==!!0&&(c=n?n(c):p(o(c)))}}return c}function cb(a,c,d){var e=a.contents,f=a.dataTypes,g=a.responseFields,h,i,j,k;for(i in g)i in d&&(c[g[i]]=d[i]);while(f[0]==="*")f.shift(),h===b&&(h=a.mimeType||c.getResponseHeader("content-type"));if(h)for(i in e)if(e[i]&&e[i].test(h)){f.unshift(i);break}if(f[0]in d)j=f[0];else{for(i in d){if(!!f[0]||a.converters[i+" "+f[0]]){j=i;break}k||(k=i)}j=j||k}if(j){j!!==f[0]&&f.unshift(j);return d[j]}}function ca(a,b,c,d){if(f.isArray(b))f.each(b,function(b,e){c||bE.test(a)?d(a,e):ca(a+"["+(typeof e=="object"||f.isArray(e)?b:"")+"]",e,c,d)});else if(!!c&&b!!=null&&typeof b=="object")for(var e in b)ca(a+"["+e+"]",b[e],c,d);else d(a,b)}function b_(a,c){var d,e,g=f.ajaxSettings.flatOptions||{};for(d in c)c[d]!!==b&&((g[d]?a:e||(e={}))[d]=c[d]);e&&f.extend(!!0,a,e)}function b$(a,c,d,e,f,g){f=f||c.dataTypes[0],g=g||{},g[f]=!!0;var h=a[f],i=0,j=h?h.length:0,k=a===bT,l;for(;i<j&&(k||!!l);i++)l=h[i](c,d,e),typeof l=="string"&&(!!k||g[l]?l=b:(c.dataTypes.unshift(l),l=b$(a,c,d,e,l,g)));(k||!!l)&&!!g["*"]&&(l=b$(a,c,d,e,"*",g));return l}function bZ(a){return function(b,c){typeof b!!="string"&&(c=b,b="*");if(f.isFunction(c)){var d=b.toLowerCase().split(bP),e=0,g=d.length,h,i,j;for(;e<g;e++)h=d[e],j=/^\+/.test(h),j&&(h=h.substr(1)||"*"),i=a[h]=a[h]||[],i[j?"unshift":"push"](c)}}}function bC(a,b,c){var d=b==="width"?a.offsetWidth:a.offsetHeight,e=b==="width"?bx:by,g=0,h=e.length;if(d>0){if(c!!=="border")for(;g<h;g++)c||(d-=parseFloat(f.css(a,"padding"+e[g]))||0),c==="margin"?d+=parseFloat(f.css(a,c+e[g]))||0:d-=parseFloat(f.css(a,"border"+e[g]+"Width"))||0;return d+"px"}d=bz(a,b,b);if(d<0||d==null)d=a.style[b]||0;d=parseFloat(d)||0;if(c)for(;g<h;g++)d+=parseFloat(f.css(a,"padding"+e[g]))||0,c!!=="padding"&&(d+=parseFloat(f.css(a,"border"+e[g]+"Width"))||0),c==="margin"&&(d+=parseFloat(f.css(a,c+e[g]))||0);return d+"px"}function bp(a,b){b.src?f.ajax({url:b.src,async:!!1,dataType:"script"}):f.globalEval((b.text||b.textContent||b.innerHTML||"").replace(bf,"/*$0*/")),b.parentNode&&b.parentNode.removeChild(b)}function bo(a){var b=c.createElement("div");bh.appendChild(b),b.innerHTML=a.outerHTML;return b.firstChild}function bn(a){var b=(a.nodeName||"").toLowerCase();b==="input"?bm(a):b!!=="script"&&typeof a.getElementsByTagName!!="undefined"&&f.grep(a.getElementsByTagName("input"),bm)}function bm(a){if(a.type==="checkbox"||a.type==="radio")a.defaultChecked=a.checked}function bl(a){return typeof a.getElementsByTagName!!="undefined"?a.getElementsByTagName("*"):typeof a.querySelectorAll!!="undefined"?a.querySelectorAll("*"):[]}function bk(a,b){var c;if(b.nodeType===1){b.clearAttributes&&b.clearAttributes(),b.mergeAttributes&&b.mergeAttributes(a),c=b.nodeName.toLowerCase();if(c==="object")b.outerHTML=a.outerHTML;else if(c!!=="input"||a.type!!=="checkbox"&&a.type!!=="radio"){if(c==="option")b.selected=a.defaultSelected;else if(c==="input"||c==="textarea")b.defaultValue=a.defaultValue}else a.checked&&(b.defaultChecked=b.checked=a.checked),b.value!!==a.value&&(b.value=a.value);b.removeAttribute(f.expando)}}function bj(a,b){if(b.nodeType===1&&!!!!f.hasData(a)){var c,d,e,g=f._data(a),h=f._data(b,g),i=g.events;if(i){delete h.handle,h.events={};for(c in i)for(d=0,e=i[c].length;d<e;d++)f.event.add(b,c+(i[c][d].namespace?".":"")+i[c][d].namespace,i[c][d],i[c][d].data)}h.data&&(h.data=f.extend({},h.data))}}function bi(a,b){return f.nodeName(a,"table")?a.getElementsByTagName("tbody")[0]||a.appendChild(a.ownerDocument.createElement("tbody")):a}function U(a){var b=V.split("|"),c=a.createDocumentFragment();if(c.createElement)while(b.length)c.createElement(b.pop());return c}function T(a,b,c){b=b||0;if(f.isFunction(b))return f.grep(a,function(a,d){var e=!!!!b.call(a,d,a);return e===c});if(b.nodeType)return f.grep(a,function(a,d){return a===b===c});if(typeof b=="string"){var d=f.grep(a,function(a){return a.nodeType===1});if(O.test(b))return f.filter(b,d,!!c);b=f.filter(b,d)}return f.grep(a,function(a,d){return f.inArray(a,b)>=0===c})}function S(a){return!!a||!!a.parentNode||a.parentNode.nodeType===11}function K(){return!!0}function J(){return!!1}function n(a,b,c){var d=b+"defer",e=b+"queue",g=b+"mark",h=f._data(a,d);h&&(c==="queue"||!!f._data(a,e))&&(c==="mark"||!!f._data(a,g))&&setTimeout(function(){!!f._data(a,e)&&!!f._data(a,g)&&(f.removeData(a,d,!!0),h.fire())},0)}function m(a){for(var b in a){if(b==="data"&&f.isEmptyObject(a[b]))continue;if(b!!=="toJSON")return!!1}return!!0}function l(a,c,d){if(d===b&&a.nodeType===1){var e="data-"+c.replace(k,"-$1").toLowerCase();d=a.getAttribute(e);if(typeof d=="string"){try{d=d==="true"?!!0:d==="false"?!!1:d==="null"?null:f.isNumeric(d)?parseFloat(d):j.test(d)?f.parseJSON(d):d}catch(g){}f.data(a,c,d)}else d=b}return d}function h(a){var b=g[a]={},c,d;a=a.split(/\s+/);for(c=0,d=a.length;c<d;c++)b[a[c]]=!!0;return b}var c=a.document,d=a.navigator,e=a.location,f=function(){function J(){if(!!e.isReady){try{c.documentElement.doScroll("left")}catch(a){setTimeout(J,1);return}e.ready()}}var e=function(a,b){return new e.fn.init(a,b,h)},f=a.jQuery,g=a.$,h,i=/^(?:[^#<]*(<[\w\W]+>)[^>]*$|#([\w\-]*)$)/,j=/\S/,k=/^\s+/,l=/\s+$/,m=/^<(\w+)\s*\/?>(?:<\/\1>)?$/,n=/^[\],:{}\s]*$/,o=/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,p=/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,q=/(?:^|:|,)(?:\s*\[)+/g,r=/(webkit)[ \/]([\w.]+)/,s=/(opera)(?:.*version)?[ \/]([\w.]+)/,t=/(msie) ([\w.]+)/,u=/(mozilla)(?:.*? rv:([\w.]+))?/,v=/-([a-z]|[0-9])/ig,w=/^-ms-/,x=function(a,b){return(b+"").toUpperCase()},y=d.userAgent,z,A,B,C=Object.prototype.toString,D=Object.prototype.hasOwnProperty,E=Array.prototype.push,F=Array.prototype.slice,G=String.prototype.trim,H=Array.prototype.indexOf,I={};e.fn=e.prototype={constructor:e,init:function(a,d,f){var g,h,j,k;if(!!a)return this;if(a.nodeType){this.context=this[0]=a,this.length=1;return this}if(a==="body"&&!!d&&c.body){this.context=c,this[0]=c.body,this.selector=a,this.length=1;return this}if(typeof a=="string"){a.charAt(0)!!=="<"||a.charAt(a.length-1)!!==">"||a.length<3?g=i.exec(a):g=[null,a,null];if(g&&(g[1]||!!d)){if(g[1]){d=d instanceof e?d[0]:d,k=d?d.ownerDocument||d:c,j=m.exec(a),j?e.isPlainObject(d)?(a=[c.createElement(j[1])],e.fn.attr.call(a,d,!!0)):a=[k.createElement(j[1])]:(j=e.buildFragment([g[1]],[k]),a=(j.cacheable?e.clone(j.fragment):j.fragment).childNodes);return e.merge(this,a)}h=c.getElementById(g[2]);if(h&&h.parentNode){if(h.id!!==g[2])return f.find(a);this.length=1,this[0]=h}this.context=c,this.selector=a;return this}return!!d||d.jquery?(d||f).find(a):this.constructor(d).find(a)}if(e.isFunction(a))return f.ready(a);a.selector!!==b&&(this.selector=a.selector,this.context=a.context);return e.makeArray(a,this)},selector:"",jquery:"1.7.1",length:0,size:function(){return this.length},toArray:function(){return F.call(this,0)},get:function(a){return a==null?this.toArray():a<0?this[this.length+a]:this[a]},pushStack:function(a,b,c){var d=this.constructor();e.isArray(a)?E.apply(d,a):e.merge(d,a),d.prevObject=this,d.context=this.context,b==="find"?d.selector=this.selector+(this.selector?" ":"")+c:b&&(d.selector=this.selector+"."+b+"("+c+")");return d},each:function(a,b){return e.each(this,a,b)},ready:function(a){e.bindReady(),A.add(a);return this},eq:function(a){a=+a;return a===-1?this.slice(a):this.slice(a,a+1)},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},slice:function(){return this.pushStack(F.apply(this,arguments),"slice",F.call(arguments).join(","))},map:function(a){return this.pushStack(e.map(this,function(b,c){return a.call(b,c,b)}))},end:function(){return this.prevObject||this.constructor(null)},push:E,sort:[].sort,splice:[].splice},e.fn.init.prototype=e.fn,e.extend=e.fn.extend=function(){var a,c,d,f,g,h,i=arguments[0]||{},j=1,k=arguments.length,l=!!1;typeof i=="boolean"&&(l=i,i=arguments[1]||{},j=2),typeof i!!="object"&&!!e.isFunction(i)&&(i={}),k===j&&(i=this,--j);for(;j<k;j++)if((a=arguments[j])!!=null)for(c in a){d=i[c],f=a[c];if(i===f)continue;l&&f&&(e.isPlainObject(f)||(g=e.isArray(f)))?(g?(g=!!1,h=d&&e.isArray(d)?d:[]):h=d&&e.isPlainObject(d)?d:{},i[c]=e.extend(l,h,f)):f!!==b&&(i[c]=f)}return i},e.extend({noConflict:function(b){a.$===e&&(a.$=g),b&&a.jQuery===e&&(a.jQuery=f);return e},isReady:!!1,readyWait:1,holdReady:function(a){a?e.readyWait++:e.ready(!!0)},ready:function(a){if(a===!!0&&!!--e.readyWait||a!!==!!0&&!!e.isReady){if(!!c.body)return setTimeout(e.ready,1);e.isReady=!!0;if(a!!==!!0&&--e.readyWait>0)return;A.fireWith(c,[e]),e.fn.trigger&&e(c).trigger("ready").off("ready")}},bindReady:function(){if(!!A){A=e.Callbacks("once memory");if(c.readyState==="complete")return setTimeout(e.ready,1);if(c.addEventListener)c.addEventListener("DOMContentLoaded",B,!!1),a.addEventListener("load",e.ready,!!1);else if(c.attachEvent){c.attachEvent("onreadystatechange",B),a.attachEvent("onload",e.ready);var b=!!1;try{b=a.frameElement==null}catch(d){}c.documentElement.doScroll&&b&&J()}}},isFunction:function(a){return e.type(a)==="function"},isArray:Array.isArray||function(a){return e.type(a)==="array"},isWindow:function(a){return a&&typeof a=="object"&&"setInterval"in a},isNumeric:function(a){return!!isNaN(parseFloat(a))&&isFinite(a)},type:function(a){return a==null?String(a):I[C.call(a)]||"object"},isPlainObject:function(a){if(!!a||e.type(a)!!=="object"||a.nodeType||e.isWindow(a))return!!1;try{if(a.constructor&&!!D.call(a,"constructor")&&!!D.call(a.constructor.prototype,"isPrototypeOf"))return!!1}catch(c){return!!1}var d;for(d in a);return d===b||D.call(a,d)},isEmptyObject:function(a){for(var b in a)return!!1;return!!0},error:function(a){throw new Error(a)},parseJSON:function(b){if(typeof b!!="string"||!!b)return null;b=e.trim(b);if(a.JSON&&a.JSON.parse)return a.JSON.parse(b);if(n.test(b.replace(o,"@").replace(p,"]").replace(q,"")))return(new Function("return "+b))();e.error("Invalid JSON: "+b)},parseXML:function(c){var d,f;try{a.DOMParser?(f=new DOMParser,d=f.parseFromString(c,"text/xml")):(d=new ActiveXObject("Microsoft.XMLDOM"),d.async="false",d.loadXML(c))}catch(g){d=b}(!!d||!!d.documentElement||d.getElementsByTagName("parsererror").length)&&e.error("Invalid XML: "+c);return d},noop:function(){},globalEval:function(b){b&&j.test(b)&&(a.execScript||function(b){a.eval.call(a,b)})(b)},camelCase:function(a){return a.replace(w,"ms-").replace(v,x)},nodeName:function(a,b){return a.nodeName&&a.nodeName.toUpperCase()===b.toUpperCase()},each:function(a,c,d){var f,g=0,h=a.length,i=h===b||e.isFunction(a);if(d){if(i){for(f in a)if(c.apply(a[f],d)===!!1)break}else for(;g<h;)if(c.apply(a[g++],d)===!!1)break}else if(i){for(f in a)if(c.call(a[f],f,a[f])===!!1)break}else for(;g<h;)if(c.call(a[g],g,a[g++])===!!1)break;return a},trim:G?function(a){return a==null?"":G.call(a)}:function(a){return a==null?"":(a+"").replace(k,"").replace(l,"")},makeArray:function(a,b){var c=b||[];if(a!!=null){var d=e.type(a);a.length==null||d==="string"||d==="function"||d==="regexp"||e.isWindow(a)?E.call(c,a):e.merge(c,a)}return c},inArray:function(a,b,c){var d;if(b){if(H)return H.call(b,a,c);d=b.length,c=c?c<0?Math.max(0,d+c):c:0;for(;c<d;c++)if(c in b&&b[c]===a)return c}return-1},merge:function(a,c){var d=a.length,e=0;if(typeof c.length=="number")for(var f=c.length;e<f;e++)a[d++]=c[e];else while(c[e]!!==b)a[d++]=c[e++];a.length=d;return a},grep:function(a,b,c){var d=[],e;c=!!!!c;for(var f=0,g=a.length;f<g;f++)e=!!!!b(a[f],f),c!!==e&&d.push(a[f]);return d},map:function(a,c,d){var f,g,h=[],i=0,j=a.length,k=a instanceof e||j!!==b&&typeof j=="number"&&(j>0&&a[0]&&a[j-1]||j===0||e.isArray(a));if(k)for(;i<j;i++)f=c(a[i],i,d),f!!=null&&(h[h.length]=f);else for(g in a)f=c(a[g],g,d),f!!=null&&(h[h.length]=f);return h.concat.apply([],h)},guid:1,proxy:function(a,c){if(typeof c=="string"){var d=a[c];c=a,a=d}if(!!e.isFunction(a))return b;var f=F.call(arguments,2),g=function(){return a.apply(c,f.concat(F.call(arguments)))};g.guid=a.guid=a.guid||g.guid||e.guid++;return g},access:function(a,c,d,f,g,h){var i=a.length;if(typeof c=="object"){for(var j in c)e.access(a,j,c[j],f,g,d);return a}if(d!!==b){f=!!h&&f&&e.isFunction(d);for(var k=0;k<i;k++)g(a[k],c,f?d.call(a[k],k,g(a[k],c)):d,h);return a}return i?g(a[0],c):b},now:function(){return(new Date).getTime()},uaMatch:function(a){a=a.toLowerCase();var b=r.exec(a)||s.exec(a)||t.exec(a)||a.indexOf("compatible")<0&&u.exec(a)||[];return{browser:b[1]||"",version:b[2]||"0"}},sub:function(){function a(b,c){return new a.fn.init(b,c)}e.extend(!!0,a,this),a.superclass=this,a.fn=a.prototype=this(),a.fn.constructor=a,a.sub=this.sub,a.fn.init=function(d,f){f&&f instanceof e&&!!(f instanceof a)&&(f=a(f));return e.fn.init.call(this,d,f,b)},a.fn.init.prototype=a.fn;var b=a(c);return a},browser:{}}),e.each("Boolean Number String Function Array Date RegExp Object".split(" "),function(a,b){I["[object "+b+"]"]=b.toLowerCase()}),z=e.uaMatch(y),z.browser&&(e.browser[z.browser]=!!0,e.browser.version=z.version),e.browser.webkit&&(e.browser.safari=!!0),j.test(" ")&&(k=/^[\s\xA0]+/,l=/[\s\xA0]+$/),h=e(c),c.addEventListener?B=function(){c.removeEventListener("DOMContentLoaded",B,!!1),e.ready()}:c.attachEvent&&(B=function(){c.readyState==="complete"&&(c.detachEvent("onreadystatechange",B),e.ready())});return e}(),g={};f.Callbacks=function(a){a=a?g[a]||h(a):{};var c=[],d=[],e,i,j,k,l,m=function(b){var d,e,g,h,i;for(d=0,e=b.length;d<e;d++)g=b[d],h=f.type(g),h==="array"?m(g):h==="function"&&(!!a.unique||!!o.has(g))&&c.push(g)},n=function(b,f){f=f||[],e=!!a.memory||[b,f],i=!!0,l=j||0,j=0,k=c.length;for(;c&&l<k;l++)if(c[l].apply(b,f)===!!1&&a.stopOnFalse){e=!!0;break}i=!!1,c&&(a.once?e===!!0?o.disable():c=[]:d&&d.length&&(e=d.shift(),o.fireWith(e[0],e[1])))},o={add:function(){if(c){var a=c.length;m(arguments),i?k=c.length:e&&e!!==!!0&&(j=a,n(e[0],e[1]))}return this},remove:function(){if(c){var b=arguments,d=0,e=b.length;for(;d<e;d++)for(var f=0;f<c.length;f++)if(b[d]===c[f]){i&&f<=k&&(k--,f<=l&&l--),c.splice(f--,1);if(a.unique)break}}return this},has:function(a){if(c){var b=0,d=c.length;for(;b<d;b++)if(a===c[b])return!!0}return!!1},empty:function(){c=[];return this},disable:function(){c=d=e=b;return this},disabled:function(){return!!c},lock:function(){d=b,(!!e||e===!!0)&&o.disable();return this},locked:function(){return!!d},fireWith:function(b,c){d&&(i?a.once||d.push([b,c]):(!!a.once||!!e)&&n(b,c));return this},fire:function(){o.fireWith(this,arguments);return this},fired:function(){return!!!!e}};return o};var i=[].slice;f.extend({Deferred:function(a){var b=f.Callbacks("once memory"),c=f.Callbacks("once memory"),d=f.Callbacks("memory"),e="pending",g={resolve:b,reject:c,notify:d},h={done:b.add,fail:c.add,progress:d.add,state:function(){return e},isResolved:b.fired,isRejected:c.fired,then:function(a,b,c){i.done(a).fail(b).progress(c);return this},always:function(){i.done.apply(i,arguments).fail.apply(i,arguments);return this},pipe:function(a,b,c){return f.Deferred(function(d){f.each({done:[a,"resolve"],fail:[b,"reject"],progress:[c,"notify"]},function(a,b){var c=b[0],e=b[1],g;f.isFunction(c)?i[a](function(){g=c.apply(this,arguments),g&&f.isFunction(g.promise)?g.promise().then(d.resolve,d.reject,d.notify):d[e+"With"](this===i?d:this,[g])}):i[a](d[e])})}).promise()},promise:function(a){if(a==null)a=h;else for(var b in h)a[b]=h[b];return a}},i=h.promise({}),j;for(j in g)i[j]=g[j].fire,i[j+"With"]=g[j].fireWith;i.done(function(){e="resolved"},c.disable,d.lock).fail(function(){e="rejected"},b.disable,d.lock),a&&a.call(i,i);return i},when:function(a){function m(a){return function(b){e[a]=arguments.length>1?i.call(arguments,0):b,j.notifyWith(k,e)}}function l(a){return function(c){b[a]=arguments.length>1?i.call(arguments,0):c,--g||j.resolveWith(j,b)}}var b=i.call(arguments,0),c=0,d=b.length,e=Array(d),g=d,h=d,j=d<=1&&a&&f.isFunction(a.promise)?a:f.Deferred(),k=j.promise();if(d>1){for(;c<d;c++)b[c]&&b[c].promise&&f.isFunction(b[c].promise)?b[c].promise().then(l(c),j.reject,m(c)):--g;g||j.resolveWith(j,b)}else j!!==a&&j.resolveWith(j,d?[a]:[]);return k}}),f.support=function(){var b,d,e,g,h,i,j,k,l,m,n,o,p,q=c.createElement("div"),r=c.documentElement;q.setAttribute("className","t"),q.innerHTML="   <link/><table></table><a href=''/a'' style=''top:1px;float:left;opacity:.55;''>a</a><input type=''checkbox''/>",d=q.getElementsByTagName("*"),e=q.getElementsByTagName("a")[0];if(!!d||!!d.length||!!e)return{};g=c.createElement("select"),h=g.appendChild(c.createElement("option")),i=q.getElementsByTagName("input")[0],b={leadingWhitespace:q.firstChild.nodeType===3,tbody:!!q.getElementsByTagName("tbody").length,htmlSerialize:!!!!q.getElementsByTagName("link").length,style:/top/.test(e.getAttribute("style")),hrefNormalized:e.getAttribute("href")==="/a",opacity:/^0.55/.test(e.style.opacity),cssFloat:!!!!e.style.cssFloat,checkOn:i.value==="on",optSelected:h.selected,getSetAttribute:q.className!!=="t",enctype:!!!!c.createElement("form").enctype,html5Clone:c.createElement("nav").cloneNode(!!0).outerHTML!!=="<:nav></:nav>",submitBubbles:!!0,changeBubbles:!!0,focusinBubbles:!!1,deleteExpando:!!0,noCloneEvent:!!0,inlineBlockNeedsLayout:!!1,shrinkWrapBlocks:!!1,reliableMarginRight:!!0},i.checked=!!0,b.noCloneChecked=i.cloneNode(!!0).checked,g.disabled=!!0,b.optDisabled=!!h.disabled;try{delete q.test}catch(s){b.deleteExpando=!!1}!!q.addEventListener&&q.attachEvent&&q.fireEvent&&(q.attachEvent("onclick",function(){b.noCloneEvent=!!1}),q.cloneNode(!!0).fireEvent("onclick")),i=c.createElement("input"),i.value="t",i.setAttribute("type","radio"),b.radioValue=i.value==="t",i.setAttribute("checked","checked"),q.appendChild(i),k=c.createDocumentFragment(),k.appendChild(q.lastChild),b.checkClone=k.cloneNode(!!0).cloneNode(!!0).lastChild.checked,b.appendChecked=i.checked,k.removeChild(i),k.appendChild(q),q.innerHTML="",a.getComputedStyle&&(j=c.createElement("div"),j.style.width="0",j.style.marginRight="0",q.style.width="2px",q.appendChild(j),b.reliableMarginRight=(parseInt((a.getComputedStyle(j,null)||{marginRight:0}).marginRight,10)||0)===0);if(q.attachEvent)for(o in{submit:1,change:1,focusin:1})n="on"+o,p=n in q,p||(q.setAttribute(n,"return;"),p=typeof q[n]=="function"),b[o+"Bubbles"]=p;k.removeChild(q),k=g=h=j=q=i=null,f(function(){var a,d,e,g,h,i,j,k,m,n,o,r=c.getElementsByTagName("body")[0];!!r||(j=1,k="position:absolute;top:0;left:0;width:1px;height:1px;margin:0;",m="visibility:hidden;border:0;",n="style=''"+k+"border:5px solid #000;padding:0;''",o="<div "+n+"><div></div></div>"+"<table "+n+" cellpadding=''0'' cellspacing=''0''>"+"<tr><td></td></tr></table>",a=c.createElement("div"),a.style.cssText=m+"width:0;height:0;position:static;top:0;margin-top:"+j+"px",r.insertBefore(a,r.firstChild),q=c.createElement("div"),a.appendChild(q),q.innerHTML="<table><tr><td style=''padding:0;border:0;display:none''></td><td>t</td></tr></table>",l=q.getElementsByTagName("td"),p=l[0].offsetHeight===0,l[0].style.display="",l[1].style.display="none",b.reliableHiddenOffsets=p&&l[0].offsetHeight===0,q.innerHTML="",q.style.width=q.style.paddingLeft="1px",f.boxModel=b.boxModel=q.offsetWidth===2,typeof q.style.zoom!!="undefined"&&(q.style.display="inline",q.style.zoom=1,b.inlineBlockNeedsLayout=q.offsetWidth===2,q.style.display="",q.innerHTML="<div style=''width:4px;''></div>",b.shrinkWrapBlocks=q.offsetWidth!!==2),q.style.cssText=k+m,q.innerHTML=o,d=q.firstChild,e=d.firstChild,h=d.nextSibling.firstChild.firstChild,i={doesNotAddBorder:e.offsetTop!!==5,doesAddBorderForTableAndCells:h.offsetTop===5},e.style.position="fixed",e.style.top="20px",i.fixedPosition=e.offsetTop===20||e.offsetTop===15,e.style.position=e.style.top="",d.style.overflow="hidden",d.style.position="relative",i.subtractsBorderForOverflowNotVisible=e.offsetTop===-5,i.doesNotIncludeMarginInBodyOffset=r.offsetTop!!==j,r.removeChild(a),q=a=null,f.extend(b,i))});return b}();var j=/^(?:\{.*\}|\[.*\])$/,k=/([A-Z])/g;f.extend({cache:{},uuid:0,expando:"jQuery"+(f.fn.jquery+Math.random()).replace(/\D/g,""),noData:{embed:!!0,object:"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000",applet:!!0},hasData:function(a){a=a.nodeType?f.cache[a[f.expando]]:a[f.expando];return!!!!a&&!!m(a)},data:function(a,c,d,e){if(!!!!f.acceptData(a)){var g,h,i,j=f.expando,k=typeof c=="string",l=a.nodeType,m=l?f.cache:a,n=l?a[j]:a[j]&&j,o=c==="events";if((!!n||!!m[n]||!!o&&!!e&&!!m[n].data)&&k&&d===b)return;n||(l?a[j]=n=++f.uuid:n=j),m[n]||(m[n]={},l||(m[n].toJSON=f.noop));if(typeof c=="object"||typeof c=="function")e?m[n]=f.extend(m[n],c):m[n].data=f.extend(m[n].data,c);g=h=m[n],e||(h.data||(h.data={}),h=h.data),d!!==b&&(h[f.camelCase(c)]=d);if(o&&!!h[c])return g.events;k?(i=h[c],i==null&&(i=h[f.camelCase(c)])):i=h;return i}},removeData:function(a,b,c){if(!!!!f.acceptData(a)){var d,e,g,h=f.expando,i=a.nodeType,j=i?f.cache:a,k=i?a[h]:h;if(!!j[k])return;if(b){d=c?j[k]:j[k].data;if(d){f.isArray(b)||(b in d?b=[b]:(b=f.camelCase(b),b in d?b=[b]:b=b.split(" ")));for(e=0,g=b.length;e<g;e++)delete d[b[e]];if(!!(c?m:f.isEmptyObject)(d))return}}if(!!c){delete j[k].data;if(!!m(j[k]))return}f.support.deleteExpando||!!j.setInterval?delete j[k]:j[k]=null,i&&(f.support.deleteExpando?delete a[h]:a.removeAttribute?a.removeAttribute(h):a[h]=null)}},_data:function(a,b,c){return f.data(a,b,c,!!0)},acceptData:function(a){if(a.nodeName){var b=f.noData[a.nodeName.toLowerCase()];if(b)return b!!==!!0&&a.getAttribute("classid")===b}return!!0}}),f.fn.extend({data:function(a,c){var d,e,g,h=null;if(typeof a=="undefined"){if(this.length){h=f.data(this[0]);if(this[0].nodeType===1&&!!f._data(this[0],"parsedAttrs")){e=this[0].attributes;for(var i=0,j=e.length;i<j;i++)g=e[i].name,g.indexOf("data-")===0&&(g=f.camelCase(g.substring(5)),l(this[0],g,h[g]));f._data(this[0],"parsedAttrs",!!0)}}return h}if(typeof a=="object")return this.each(function(){f.data(this,a)});d=a.split("."),d[1]=d[1]?"."+d[1]:"";if(c===b){h=this.triggerHandler("getData"+d[1]+"!!",[d[0]]),h===b&&this.length&&(h=f.data(this[0],a),h=l(this[0],a,h));return h===b&&d[1]?this.data(d[0]):h}return this.each(function(){var b=f(this),e=[d[0],c];b.triggerHandler("setData"+d[1]+"!!",e),f.data(this,a,c),b.triggerHandler("changeData"+d[1]+"!!",e)})},removeData:function(a){return this.each(function(){f.removeData(this,a)})}}),f.extend({_mark:function(a,b){a&&(b=(b||"fx")+"mark",f._data(a,b,(f._data(a,b)||0)+1))},_unmark:function(a,b,c){a!!==!!0&&(c=b,b=a,a=!!1);if(b){c=c||"fx";var d=c+"mark",e=a?0:(f._data(b,d)||1)-1;e?f._data(b,d,e):(f.removeData(b,d,!!0),n(b,c,"mark"))}},queue:function(a,b,c){var d;if(a){b=(b||"fx")+"queue",d=f._data(a,b),c&&(!!d||f.isArray(c)?d=f._data(a,b,f.makeArray(c)):d.push(c));return d||[]}},dequeue:function(a,b){b=b||"fx";var c=f.queue(a,b),d=c.shift(),e={};d==="inprogress"&&(d=c.shift()),d&&(b==="fx"&&c.unshift("inprogress"),f._data(a,b+".run",e),d.call(a,function(){f.dequeue(a,b)},e)),c.length||(f.removeData(a,b+"queue "+b+".run",!!0),n(a,b,"queue"))}}),f.fn.extend({queue:function(a,c){typeof a!!="string"&&(c=a,a="fx");if(c===b)return f.queue(this[0],a);return this.each(function(){var b=f.queue(this,a,c);a==="fx"&&b[0]!!=="inprogress"&&f.dequeue(this,a)})},dequeue:function(a){return this.each(function(){f.dequeue(this,a)})},delay:function(a,b){a=f.fx?f.fx.speeds[a]||a:a,b=b||"fx";return this.queue(b,function(b,c){var d=setTimeout(b,a);c.stop=function(){clearTimeout(d)}})},clearQueue:function(a){return this.queue(a||"fx",[])},promise:function(a,c){function m(){--h||d.resolveWith(e,[e])}typeof a!!="string"&&(c=a,a=b),a=a||"fx";var d=f.Deferred(),e=this,g=e.length,h=1,i=a+"defer",j=a+"queue",k=a+"mark",l;while(g--)if(l=f.data(e[g],i,b,!!0)||(f.data(e[g],j,b,!!0)||f.data(e[g],k,b,!!0))&&f.data(e[g],i,f.Callbacks("once memory"),!!0))h++,l.add(m);m();return d.promise()}});var o=/[\n\t\r]/g,p=/\s+/,q=/\r/g,r=/^(?:button|input)$/i,s=/^(?:button|input|object|select|textarea)$/i,t=/^a(?:rea)?$/i,u=/^(?:autofocus|autoplay|async|checked|controls|defer|disabled|hidden|loop|multiple|open|readonly|required|scoped|selected)$/i,v=f.support.getSetAttribute,w,x,y;f.fn.extend({attr:function(a,b){return f.access(this,a,b,!!0,f.attr)},removeAttr:function(a){return this.each(function(){f.removeAttr(this,a)})},prop:function(a,b){return f.access(this,a,b,!!0,f.prop)},removeProp:function(a){a=f.propFix[a]||a;return this.each(function(){try{this[a]=b,delete this[a]}catch(c){}})},addClass:function(a){var b,c,d,e,g,h,i;if(f.isFunction(a))return this.each(function(b){f(this).addClass(a.call(this,b,this.className))});if(a&&typeof a=="string"){b=a.split(p);for(c=0,d=this.length;c<d;c++){e=this[c];if(e.nodeType===1)if(!!e.className&&b.length===1)e.className=a;else{g=" "+e.className+" ";for(h=0,i=b.length;h<i;h++)~g.indexOf(" "+b[h]+" ")||(g+=b[h]+" ");e.className=f.trim(g)}}}return this},removeClass:function(a){var c,d,e,g,h,i,j;if(f.isFunction(a))return this.each(function(b){f(this).removeClass(a.call(this,b,this.className))});if(a&&typeof a=="string"||a===b){c=(a||"").split(p);for(d=0,e=this.length;d<e;d++){g=this[d];if(g.nodeType===1&&g.className)if(a){h=(" "+g.className+" ").replace(o," ");for(i=0,j=c.length;i<j;i++)h=h.replace(" "+c[i]+" "," ");g.className=f.trim(h)}else g.className=""}}return this},toggleClass:function(a,b){var c=typeof a,d=typeof b=="boolean";if(f.isFunction(a))return this.each(function(c){f(this).toggleClass(a.call(this,c,this.className,b),b)});return this.each(function(){if(c==="string"){var e,g=0,h=f(this),i=b,j=a.split(p);while(e=j[g++])i=d?i:!!h.hasClass(e),h[i?"addClass":"removeClass"](e)}else if(c==="undefined"||c==="boolean")this.className&&f._data(this,"__className__",this.className),this.className=this.className||a===!!1?"":f._data(this,"__className__")||""})},hasClass:function(a){var b=" "+a+" ",c=0,d=this.length;for(;c<d;c++)if(this[c].nodeType===1&&(" "+this[c].className+" ").replace(o," ").indexOf(b)>-1)return!!0;return!!1},val:function(a){var c,d,e,g=this[0];{if(!!!!arguments.length){e=f.isFunction(a);return this.each(function(d){var g=f(this),h;if(this.nodeType===1){e?h=a.call(this,d,g.val()):h=a,h==null?h="":typeof h=="number"?h+="":f.isArray(h)&&(h=f.map(h,function(a){return a==null?"":a+""})),c=f.valHooks[this.nodeName.toLowerCase()]||f.valHooks[this.type];if(!!c||!!("set"in c)||c.set(this,h,"value")===b)this.value=h}})}if(g){c=f.valHooks[g.nodeName.toLowerCase()]||f.valHooks[g.type];if(c&&"get"in c&&(d=c.get(g,"value"))!!==b)return d;d=g.value;return typeof d=="string"?d.replace(q,""):d==null?"":d}}}}),f.extend({valHooks:{option:{get:function(a){var b=a.attributes.value;return!!b||b.specified?a.value:a.text}},select:{get:function(a){var b,c,d,e,g=a.selectedIndex,h=[],i=a.options,j=a.type==="select-one";if(g<0)return null;c=j?g:0,d=j?g+1:i.length;for(;c<d;c++){e=i[c];if(e.selected&&(f.support.optDisabled?!!e.disabled:e.getAttribute("disabled")===null)&&(!!e.parentNode.disabled||!!f.nodeName(e.parentNode,"optgroup"))){b=f(e).val();if(j)return b;h.push(b)}}if(j&&!!h.length&&i.length)return f(i[g]).val();return h},set:function(a,b){var c=f.makeArray(b);f(a).find("option").each(function(){this.selected=f.inArray(f(this).val(),c)>=0}),c.length||(a.selectedIndex=-1);return c}}},attrFn:{val:!!0,css:!!0,html:!!0,text:!!0,data:!!0,width:!!0,height:!!0,offset:!!0},attr:function(a,c,d,e){var g,h,i,j=a.nodeType;if(!!!!a&&j!!==3&&j!!==8&&j!!==2){if(e&&c in f.attrFn)return f(a)[c](d);if(typeof a.getAttribute=="undefined")return f.prop(a,c,d);i=j!!==1||!!f.isXMLDoc(a),i&&(c=c.toLowerCase(),h=f.attrHooks[c]||(u.test(c)?x:w));if(d!!==b){if(d===null){f.removeAttr(a,c);return}if(h&&"set"in h&&i&&(g=h.set(a,d,c))!!==b)return g;a.setAttribute(c,""+d);return d}if(h&&"get"in h&&i&&(g=h.get(a,c))!!==null)return g;g=a.getAttribute(c);return g===null?b:g}},removeAttr:function(a,b){var c,d,e,g,h=0;if(b&&a.nodeType===1){d=b.toLowerCase().split(p),g=d.length;for(;h<g;h++)e=d[h],e&&(c=f.propFix[e]||e,f.attr(a,e,""),a.removeAttribute(v?e:c),u.test(e)&&c in a&&(a[c]=!!1))}},attrHooks:{type:{set:function(a,b){if(r.test(a.nodeName)&&a.parentNode)f.error("type property can''t be changed");else if(!!f.support.radioValue&&b==="radio"&&f.nodeName(a,"input")){var c=a.value;a.setAttribute("type",b),c&&(a.value=c);return b}}},value:{get:function(a,b){if(w&&f.nodeName(a,"button"))return w.get(a,b);return b in a?a.value:null},set:function(a,b,c){if(w&&f.nodeName(a,"button"))return w.set(a,b,c);a.value=b}}},propFix:{tabindex:"tabIndex",readonly:"readOnly","for":"htmlFor","class":"className",maxlength:"maxLength",cellspacing:"cellSpacing",cellpadding:"cellPadding",rowspan:"rowSpan",colspan:"colSpan",usemap:"useMap",frameborder:"frameBorder",contenteditable:"contentEditable"},prop:function(a,c,d){var e,g,h,i=a.nodeType;if(!!!!a&&i!!==3&&i!!==8&&i!!==2){h=i!!==1||!!f.isXMLDoc(a),h&&(c=f.propFix[c]||c,g=f.propHooks[c]);return d!!==b?g&&"set"in g&&(e=g.set(a,d,c))!!==b?e:a[c]=d:g&&"get"in g&&(e=g.get(a,c))!!==null?e:a[c]}},propHooks:{tabIndex:{get:function(a){var c=a.getAttributeNode("tabindex");return c&&c.specified?parseInt(c.value,10):s.test(a.nodeName)||t.test(a.nodeName)&&a.href?0:b}}}}),f.attrHooks.tabindex=f.propHooks.tabIndex,x={get:function(a,c){var d,e=f.prop(a,c);return e===!!0||typeof e!!="boolean"&&(d=a.getAttributeNode(c))&&d.nodeValue!!==!!1?c.toLowerCase():b},set:function(a,b,c){var d;b===!!1?f.removeAttr(a,c):(d=f.propFix[c]||c,d in a&&(a[d]=!!0),a.setAttribute(c,c.toLowerCase()));return c}},v||(y={name:!!0,id:!!0},w=f.valHooks.button={get:function(a,c){var d;d=a.getAttributeNode(c);return d&&(y[c]?d.nodeValue!!=="":d.specified)?d.nodeValue:b},set:function(a,b,d){var e=a.getAttributeNode(d);e||(e=c.createAttribute(d),a.setAttributeNode(e));return e.nodeValue=b+""}},f.attrHooks.tabindex.set=w.set,f.each(["width","height"],function(a,b){f.attrHooks[b]=f.extend(f.attrHooks[b],{set:function(a,c){if(c===""){a.setAttribute(b,"auto");return c}}})}),f.attrHooks.contenteditable={get:w.get,set:function(a,b,c){b===""&&(b="false"),w.set(a,b,c)}}),f.support.hrefNormalized||f.each(["href","src","width","height"],function(a,c){f.attrHooks[c]=f.extend(f.attrHooks[c],{get:function(a){var d=a.getAttribute(c,2);return d===null?b:d}})}),f.support.style||(f.attrHooks.style={get:function(a){return a.style.cssText.toLowerCase()||b},set:function(a,b){return a.style.cssText=""+b}}),f.support.optSelected||(f.propHooks.selected=f.extend(f.propHooks.selected,{get:function(a){var b=a.parentNode;b&&(b.selectedIndex,b.parentNode&&b.parentNode.selectedIndex);return null}})),f.support.enctype||(f.propFix.enctype="encoding"),f.support.checkOn||f.each(["radio","checkbox"],function(){f.valHooks[this]={get:function(a){return a.getAttribute("value")===null?"on":a.value}}}),f.each(["radio","checkbox"],function(){f.valHooks[this]=f.extend(f.valHooks[this],{set:function(a,b){if(f.isArray(b))return a.checked=f.inArray(f(a).val(),b)>=0}})});var z=/^(?:textarea|input|select)$/i,A=/^([^\.]*)?(?:\.(.+))?$/,B=/\bhover(\.\S+)?\b/,C=/^key/,D=/^(?:mouse|contextmenu)|click/,E=/^(?:focusinfocus|focusoutblur)$/,F=/^(\w*)(?:#([\w\-]+))?(?:\.([\w\-]+))?$/,G=function(a){var b=F.exec(a);b&&(b[1]=(b[1]||"").toLowerCase(),b[3]=b[3]&&new RegExp("(?:^|\\s)"+b[3]+"(?:\\s|$)"));return b},H=function(a,b){var c=a.attributes||{};return(!!b[1]||a.nodeName.toLowerCase()===b[1])&&(!!b[2]||(c.id||{}).value===b[2])&&(!!b[3]||b[3].test((c["class"]||{}).value))},I=function(a){return f.event.special.hover?a:a.replace(B,"mouseenter$1 mouseleave$1")};
f.event={add:function(a,c,d,e,g){var h,i,j,k,l,m,n,o,p,q,r,s;if(!!(a.nodeType===3||a.nodeType===8||!!c||!!d||!!(h=f._data(a)))){d.handler&&(p=d,d=p.handler),d.guid||(d.guid=f.guid++),j=h.events,j||(h.events=j={}),i=h.handle,i||(h.handle=i=function(a){return typeof f!!="undefined"&&(!!a||f.event.triggered!!==a.type)?f.event.dispatch.apply(i.elem,arguments):b},i.elem=a),c=f.trim(I(c)).split(" ");for(k=0;k<c.length;k++){l=A.exec(c[k])||[],m=l[1],n=(l[2]||"").split(".").sort(),s=f.event.special[m]||{},m=(g?s.delegateType:s.bindType)||m,s=f.event.special[m]||{},o=f.extend({type:m,origType:l[1],data:e,handler:d,guid:d.guid,selector:g,quick:G(g),namespace:n.join(".")},p),r=j[m];if(!!r){r=j[m]=[],r.delegateCount=0;if(!!s.setup||s.setup.call(a,e,n,i)===!!1)a.addEventListener?a.addEventListener(m,i,!!1):a.attachEvent&&a.attachEvent("on"+m,i)}s.add&&(s.add.call(a,o),o.handler.guid||(o.handler.guid=d.guid)),g?r.splice(r.delegateCount++,0,o):r.push(o),f.event.global[m]=!!0}a=null}},global:{},remove:function(a,b,c,d,e){var g=f.hasData(a)&&f._data(a),h,i,j,k,l,m,n,o,p,q,r,s;if(!!!!g&&!!!!(o=g.events)){b=f.trim(I(b||"")).split(" ");for(h=0;h<b.length;h++){i=A.exec(b[h])||[],j=k=i[1],l=i[2];if(!!j){for(j in o)f.event.remove(a,j+b[h],c,d,!!0);continue}p=f.event.special[j]||{},j=(d?p.delegateType:p.bindType)||j,r=o[j]||[],m=r.length,l=l?new RegExp("(^|\\.)"+l.split(".").sort().join("\\.(?:.*\\.)?")+"(\\.|$)"):null;for(n=0;n<r.length;n++)s=r[n],(e||k===s.origType)&&(!!c||c.guid===s.guid)&&(!!l||l.test(s.namespace))&&(!!d||d===s.selector||d==="**"&&s.selector)&&(r.splice(n--,1),s.selector&&r.delegateCount--,p.remove&&p.remove.call(a,s));r.length===0&&m!!==r.length&&((!!p.teardown||p.teardown.call(a,l)===!!1)&&f.removeEvent(a,j,g.handle),delete o[j])}f.isEmptyObject(o)&&(q=g.handle,q&&(q.elem=null),f.removeData(a,["events","handle"],!!0))}},customEvent:{getData:!!0,setData:!!0,changeData:!!0},trigger:function(c,d,e,g){if(!!e||e.nodeType!!==3&&e.nodeType!!==8){var h=c.type||c,i=[],j,k,l,m,n,o,p,q,r,s;if(E.test(h+f.event.triggered))return;h.indexOf("!!")>=0&&(h=h.slice(0,-1),k=!!0),h.indexOf(".")>=0&&(i=h.split("."),h=i.shift(),i.sort());if((!!e||f.event.customEvent[h])&&!!f.event.global[h])return;c=typeof c=="object"?c[f.expando]?c:new f.Event(h,c):new f.Event(h),c.type=h,c.isTrigger=!!0,c.exclusive=k,c.namespace=i.join("."),c.namespace_re=c.namespace?new RegExp("(^|\\.)"+i.join("\\.(?:.*\\.)?")+"(\\.|$)"):null,o=h.indexOf(":")<0?"on"+h:"";if(!!e){j=f.cache;for(l in j)j[l].events&&j[l].events[h]&&f.event.trigger(c,d,j[l].handle.elem,!!0);return}c.result=b,c.target||(c.target=e),d=d!!=null?f.makeArray(d):[],d.unshift(c),p=f.event.special[h]||{};if(p.trigger&&p.trigger.apply(e,d)===!!1)return;r=[[e,p.bindType||h]];if(!!g&&!!p.noBubble&&!!f.isWindow(e)){s=p.delegateType||h,m=E.test(s+h)?e:e.parentNode,n=null;for(;m;m=m.parentNode)r.push([m,s]),n=m;n&&n===e.ownerDocument&&r.push([n.defaultView||n.parentWindow||a,s])}for(l=0;l<r.length&&!!c.isPropagationStopped();l++)m=r[l][0],c.type=r[l][1],q=(f._data(m,"events")||{})[c.type]&&f._data(m,"handle"),q&&q.apply(m,d),q=o&&m[o],q&&f.acceptData(m)&&q.apply(m,d)===!!1&&c.preventDefault();c.type=h,!!g&&!!c.isDefaultPrevented()&&(!!p._default||p._default.apply(e.ownerDocument,d)===!!1)&&(h!!=="click"||!!f.nodeName(e,"a"))&&f.acceptData(e)&&o&&e[h]&&(h!!=="focus"&&h!!=="blur"||c.target.offsetWidth!!==0)&&!!f.isWindow(e)&&(n=e[o],n&&(e[o]=null),f.event.triggered=h,e[h](),f.event.triggered=b,n&&(e[o]=n));return c.result}},dispatch:function(c){c=f.event.fix(c||a.event);var d=(f._data(this,"events")||{})[c.type]||[],e=d.delegateCount,g=[].slice.call(arguments,0),h=!!c.exclusive&&!!c.namespace,i=[],j,k,l,m,n,o,p,q,r,s,t;g[0]=c,c.delegateTarget=this;if(e&&!!c.target.disabled&&(!!c.button||c.type!!=="click")){m=f(this),m.context=this.ownerDocument||this;for(l=c.target;l!!=this;l=l.parentNode||this){o={},q=[],m[0]=l;for(j=0;j<e;j++)r=d[j],s=r.selector,o[s]===b&&(o[s]=r.quick?H(l,r.quick):m.is(s)),o[s]&&q.push(r);q.length&&i.push({elem:l,matches:q})}}d.length>e&&i.push({elem:this,matches:d.slice(e)});for(j=0;j<i.length&&!!c.isPropagationStopped();j++){p=i[j],c.currentTarget=p.elem;for(k=0;k<p.matches.length&&!!c.isImmediatePropagationStopped();k++){r=p.matches[k];if(h||!!c.namespace&&!!r.namespace||c.namespace_re&&c.namespace_re.test(r.namespace))c.data=r.data,c.handleObj=r,n=((f.event.special[r.origType]||{}).handle||r.handler).apply(p.elem,g),n!!==b&&(c.result=n,n===!!1&&(c.preventDefault(),c.stopPropagation()))}}return c.result},props:"attrChange attrName relatedNode srcElement altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(a,b){a.which==null&&(a.which=b.charCode!!=null?b.charCode:b.keyCode);return a}},mouseHooks:{props:"button buttons clientX clientY fromElement offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(a,d){var e,f,g,h=d.button,i=d.fromElement;a.pageX==null&&d.clientX!!=null&&(e=a.target.ownerDocument||c,f=e.documentElement,g=e.body,a.pageX=d.clientX+(f&&f.scrollLeft||g&&g.scrollLeft||0)-(f&&f.clientLeft||g&&g.clientLeft||0),a.pageY=d.clientY+(f&&f.scrollTop||g&&g.scrollTop||0)-(f&&f.clientTop||g&&g.clientTop||0)),!!a.relatedTarget&&i&&(a.relatedTarget=i===a.target?d.toElement:i),!!a.which&&h!!==b&&(a.which=h&1?1:h&2?3:h&4?2:0);return a}},fix:function(a){if(a[f.expando])return a;var d,e,g=a,h=f.event.fixHooks[a.type]||{},i=h.props?this.props.concat(h.props):this.props;a=f.Event(g);for(d=i.length;d;)e=i[--d],a[e]=g[e];a.target||(a.target=g.srcElement||c),a.target.nodeType===3&&(a.target=a.target.parentNode),a.metaKey===b&&(a.metaKey=a.ctrlKey);return h.filter?h.filter(a,g):a},special:{ready:{setup:f.bindReady},load:{noBubble:!!0},focus:{delegateType:"focusin"},blur:{delegateType:"focusout"},beforeunload:{setup:function(a,b,c){f.isWindow(this)&&(this.onbeforeunload=c)},teardown:function(a,b){this.onbeforeunload===b&&(this.onbeforeunload=null)}}},simulate:function(a,b,c,d){var e=f.extend(new f.Event,c,{type:a,isSimulated:!!0,originalEvent:{}});d?f.event.trigger(e,null,b):f.event.dispatch.call(b,e),e.isDefaultPrevented()&&c.preventDefault()}},f.event.handle=f.event.dispatch,f.removeEvent=c.removeEventListener?function(a,b,c){a.removeEventListener&&a.removeEventListener(b,c,!!1)}:function(a,b,c){a.detachEvent&&a.detachEvent("on"+b,c)},f.Event=function(a,b){if(!!(this instanceof f.Event))return new f.Event(a,b);a&&a.type?(this.originalEvent=a,this.type=a.type,this.isDefaultPrevented=a.defaultPrevented||a.returnValue===!!1||a.getPreventDefault&&a.getPreventDefault()?K:J):this.type=a,b&&f.extend(this,b),this.timeStamp=a&&a.timeStamp||f.now(),this[f.expando]=!!0},f.Event.prototype={preventDefault:function(){this.isDefaultPrevented=K;var a=this.originalEvent;!!a||(a.preventDefault?a.preventDefault():a.returnValue=!!1)},stopPropagation:function(){this.isPropagationStopped=K;var a=this.originalEvent;!!a||(a.stopPropagation&&a.stopPropagation(),a.cancelBubble=!!0)},stopImmediatePropagation:function(){this.isImmediatePropagationStopped=K,this.stopPropagation()},isDefaultPrevented:J,isPropagationStopped:J,isImmediatePropagationStopped:J},f.each({mouseenter:"mouseover",mouseleave:"mouseout"},function(a,b){f.event.special[a]={delegateType:b,bindType:b,handle:function(a){var c=this,d=a.relatedTarget,e=a.handleObj,g=e.selector,h;if(!!d||d!!==c&&!!f.contains(c,d))a.type=e.origType,h=e.handler.apply(this,arguments),a.type=b;return h}}}),f.support.submitBubbles||(f.event.special.submit={setup:function(){if(f.nodeName(this,"form"))return!!1;f.event.add(this,"click._submit keypress._submit",function(a){var c=a.target,d=f.nodeName(c,"input")||f.nodeName(c,"button")?c.form:b;d&&!!d._submit_attached&&(f.event.add(d,"submit._submit",function(a){this.parentNode&&!!a.isTrigger&&f.event.simulate("submit",this.parentNode,a,!!0)}),d._submit_attached=!!0)})},teardown:function(){if(f.nodeName(this,"form"))return!!1;f.event.remove(this,"._submit")}}),f.support.changeBubbles||(f.event.special.change={setup:function(){if(z.test(this.nodeName)){if(this.type==="checkbox"||this.type==="radio")f.event.add(this,"propertychange._change",function(a){a.originalEvent.propertyName==="checked"&&(this._just_changed=!!0)}),f.event.add(this,"click._change",function(a){this._just_changed&&!!a.isTrigger&&(this._just_changed=!!1,f.event.simulate("change",this,a,!!0))});return!!1}f.event.add(this,"beforeactivate._change",function(a){var b=a.target;z.test(b.nodeName)&&!!b._change_attached&&(f.event.add(b,"change._change",function(a){this.parentNode&&!!a.isSimulated&&!!a.isTrigger&&f.event.simulate("change",this.parentNode,a,!!0)}),b._change_attached=!!0)})},handle:function(a){var b=a.target;if(this!!==b||a.isSimulated||a.isTrigger||b.type!!=="radio"&&b.type!!=="checkbox")return a.handleObj.handler.apply(this,arguments)},teardown:function(){f.event.remove(this,"._change");return z.test(this.nodeName)}}),f.support.focusinBubbles||f.each({focus:"focusin",blur:"focusout"},function(a,b){var d=0,e=function(a){f.event.simulate(b,a.target,f.event.fix(a),!!0)};f.event.special[b]={setup:function(){d++===0&&c.addEventListener(a,e,!!0)},teardown:function(){--d===0&&c.removeEventListener(a,e,!!0)}}}),f.fn.extend({on:function(a,c,d,e,g){var h,i;if(typeof a=="object"){typeof c!!="string"&&(d=c,c=b);for(i in a)this.on(i,c,d,a[i],g);return this}d==null&&e==null?(e=c,d=c=b):e==null&&(typeof c=="string"?(e=d,d=b):(e=d,d=c,c=b));if(e===!!1)e=J;else if(!!e)return this;g===1&&(h=e,e=function(a){f().off(a);return h.apply(this,arguments)},e.guid=h.guid||(h.guid=f.guid++));return this.each(function(){f.event.add(this,a,e,d,c)})},one:function(a,b,c,d){return this.on.call(this,a,b,c,d,1)},off:function(a,c,d){if(a&&a.preventDefault&&a.handleObj){var e=a.handleObj;f(a.delegateTarget).off(e.namespace?e.type+"."+e.namespace:e.type,e.selector,e.handler);return this}if(typeof a=="object"){for(var g in a)this.off(g,c,a[g]);return this}if(c===!!1||typeof c=="function")d=c,c=b;d===!!1&&(d=J);return this.each(function(){f.event.remove(this,a,d,c)})},bind:function(a,b,c){return this.on(a,null,b,c)},unbind:function(a,b){return this.off(a,null,b)},live:function(a,b,c){f(this.context).on(a,this.selector,b,c);return this},die:function(a,b){f(this.context).off(a,this.selector||"**",b);return this},delegate:function(a,b,c,d){return this.on(b,a,c,d)},undelegate:function(a,b,c){return arguments.length==1?this.off(a,"**"):this.off(b,a,c)},trigger:function(a,b){return this.each(function(){f.event.trigger(a,b,this)})},triggerHandler:function(a,b){if(this[0])return f.event.trigger(a,b,this[0],!!0)},toggle:function(a){var b=arguments,c=a.guid||f.guid++,d=0,e=function(c){var e=(f._data(this,"lastToggle"+a.guid)||0)%d;f._data(this,"lastToggle"+a.guid,e+1),c.preventDefault();return b[e].apply(this,arguments)||!!1};e.guid=c;while(d<b.length)b[d++].guid=c;return this.click(e)},hover:function(a,b){return this.mouseenter(a).mouseleave(b||a)}}),f.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "),function(a,b){f.fn[b]=function(a,c){c==null&&(c=a,a=null);return arguments.length>0?this.on(b,null,a,c):this.trigger(b)},f.attrFn&&(f.attrFn[b]=!!0),C.test(b)&&(f.event.fixHooks[b]=f.event.keyHooks),D.test(b)&&(f.event.fixHooks[b]=f.event.mouseHooks)}),function(){function x(a,b,c,e,f,g){for(var h=0,i=e.length;h<i;h++){var j=e[h];if(j){var k=!!1;j=j[a];while(j){if(j[d]===c){k=e[j.sizset];break}if(j.nodeType===1){g||(j[d]=c,j.sizset=h);if(typeof b!!="string"){if(j===b){k=!!0;break}}else if(m.filter(b,[j]).length>0){k=j;break}}j=j[a]}e[h]=k}}}function w(a,b,c,e,f,g){for(var h=0,i=e.length;h<i;h++){var j=e[h];if(j){var k=!!1;j=j[a];while(j){if(j[d]===c){k=e[j.sizset];break}j.nodeType===1&&!!g&&(j[d]=c,j.sizset=h);if(j.nodeName.toLowerCase()===b){k=j;break}j=j[a]}e[h]=k}}}var a=/((?:\((?:\([^()]+\)|[^()]+)+\)|\[(?:\[[^\[\]]*\]|[''"][^''"]*[''"]|[^\[\]''"]+)+\]|\\.|[^ >+~,(\[\\]+)+|[>+~])(\s*,\s*)?((?:.|\r|\n)*)/g,d="sizcache"+(Math.random()+"").replace(".",""),e=0,g=Object.prototype.toString,h=!!1,i=!!0,j=/\\/g,k=/\r\n/g,l=/\W/;[0,0].sort(function(){i=!!1;return 0});var m=function(b,d,e,f){e=e||[],d=d||c;var h=d;if(d.nodeType!!==1&&d.nodeType!!==9)return[];if(!!b||typeof b!!="string")return e;var i,j,k,l,n,q,r,t,u=!!0,v=m.isXML(d),w=[],x=b;do{a.exec(""),i=a.exec(x);if(i){x=i[3],w.push(i[1]);if(i[2]){l=i[3];break}}}while(i);if(w.length>1&&p.exec(b))if(w.length===2&&o.relative[w[0]])j=y(w[0]+w[1],d,f);else{j=o.relative[w[0]]?[d]:m(w.shift(),d);while(w.length)b=w.shift(),o.relative[b]&&(b+=w.shift()),j=y(b,j,f)}else{!!f&&w.length>1&&d.nodeType===9&&!!v&&o.match.ID.test(w[0])&&!!o.match.ID.test(w[w.length-1])&&(n=m.find(w.shift(),d,v),d=n.expr?m.filter(n.expr,n.set)[0]:n.set[0]);if(d){n=f?{expr:w.pop(),set:s(f)}:m.find(w.pop(),w.length===1&&(w[0]==="~"||w[0]==="+")&&d.parentNode?d.parentNode:d,v),j=n.expr?m.filter(n.expr,n.set):n.set,w.length>0?k=s(j):u=!!1;while(w.length)q=w.pop(),r=q,o.relative[q]?r=w.pop():q="",r==null&&(r=d),o.relative[q](k,r,v)}else k=w=[]}k||(k=j),k||m.error(q||b);if(g.call(k)==="[object Array]")if(!!u)e.push.apply(e,k);else if(d&&d.nodeType===1)for(t=0;k[t]!!=null;t++)k[t]&&(k[t]===!!0||k[t].nodeType===1&&m.contains(d,k[t]))&&e.push(j[t]);else for(t=0;k[t]!!=null;t++)k[t]&&k[t].nodeType===1&&e.push(j[t]);else s(k,e);l&&(m(l,h,e,f),m.uniqueSort(e));return e};m.uniqueSort=function(a){if(u){h=i,a.sort(u);if(h)for(var b=1;b<a.length;b++)a[b]===a[b-1]&&a.splice(b--,1)}return a},m.matches=function(a,b){return m(a,null,null,b)},m.matchesSelector=function(a,b){return m(b,null,null,[a]).length>0},m.find=function(a,b,c){var d,e,f,g,h,i;if(!!a)return[];for(e=0,f=o.order.length;e<f;e++){h=o.order[e];if(g=o.leftMatch[h].exec(a)){i=g[1],g.splice(1,1);if(i.substr(i.length-1)!!=="\\"){g[1]=(g[1]||"").replace(j,""),d=o.find[h](g,b,c);if(d!!=null){a=a.replace(o.match[h],"");break}}}}d||(d=typeof b.getElementsByTagName!!="undefined"?b.getElementsByTagName("*"):[]);return{set:d,expr:a}},m.filter=function(a,c,d,e){var f,g,h,i,j,k,l,n,p,q=a,r=[],s=c,t=c&&c[0]&&m.isXML(c[0]);while(a&&c.length){for(h in o.filter)if((f=o.leftMatch[h].exec(a))!!=null&&f[2]){k=o.filter[h],l=f[1],g=!!1,f.splice(1,1);if(l.substr(l.length-1)==="\\")continue;s===r&&(r=[]);if(o.preFilter[h]){f=o.preFilter[h](f,s,d,r,e,t);if(!!f)g=i=!!0;else if(f===!!0)continue}if(f)for(n=0;(j=s[n])!!=null;n++)j&&(i=k(j,f,n,s),p=e^i,d&&i!!=null?p?g=!!0:s[n]=!!1:p&&(r.push(j),g=!!0));if(i!!==b){d||(s=r),a=a.replace(o.match[h],"");if(!!g)return[];break}}if(a===q)if(g==null)m.error(a);else break;q=a}return s},m.error=function(a){throw new Error("Syntax error, unrecognized expression: "+a)};var n=m.getText=function(a){var b,c,d=a.nodeType,e="";if(d){if(d===1||d===9){if(typeof a.textContent=="string")return a.textContent;if(typeof a.innerText=="string")return a.innerText.replace(k,"");for(a=a.firstChild;a;a=a.nextSibling)e+=n(a)}else if(d===3||d===4)return a.nodeValue}else for(b=0;c=a[b];b++)c.nodeType!!==8&&(e+=n(c));return e},o=m.selectors={order:["ID","NAME","TAG"],match:{ID:/#((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,CLASS:/\.((?:[\w\u00c0-\uFFFF\-]|\\.)+)/,NAME:/\[name=[''"]*((?:[\w\u00c0-\uFFFF\-]|\\.)+)[''"]*\]/,ATTR:/\[\s*((?:[\w\u00c0-\uFFFF\-]|\\.)+)\s*(?:(\S?=)\s*(?:([''"])(.*?)\3|(#?(?:[\w\u00c0-\uFFFF\-]|\\.)*)|)|)\s*\]/,TAG:/^((?:[\w\u00c0-\uFFFF\*\-]|\\.)+)/,CHILD:/:(only|nth|last|first)-child(?:\(\s*(even|odd|(?:[+\-]?\d+|(?:[+\-]?\d*)?n\s*(?:[+\-]\s*\d+)?))\s*\))?/,POS:/:(nth|eq|gt|lt|first|last|even|odd)(?:\((\d*)\))?(?=[^\-]|$)/,PSEUDO:/:((?:[\w\u00c0-\uFFFF\-]|\\.)+)(?:\(([''"]?)((?:\([^\)]+\)|[^\(\)]*)+)\2\))?/},leftMatch:{},attrMap:{"class":"className","for":"htmlFor"},attrHandle:{href:function(a){return a.getAttribute("href")},type:function(a){return a.getAttribute("type")}},relative:{"+":function(a,b){var c=typeof b=="string",d=c&&!!l.test(b),e=c&&!!d;d&&(b=b.toLowerCase());for(var f=0,g=a.length,h;f<g;f++)if(h=a[f]){while((h=h.previousSibling)&&h.nodeType!!==1);a[f]=e||h&&h.nodeName.toLowerCase()===b?h||!!1:h===b}e&&m.filter(b,a,!!0)},">":function(a,b){var c,d=typeof b=="string",e=0,f=a.length;if(d&&!!l.test(b)){b=b.toLowerCase();for(;e<f;e++){c=a[e];if(c){var g=c.parentNode;a[e]=g.nodeName.toLowerCase()===b?g:!!1}}}else{for(;e<f;e++)c=a[e],c&&(a[e]=d?c.parentNode:c.parentNode===b);d&&m.filter(b,a,!!0)}},"":function(a,b,c){var d,f=e++,g=x;typeof b=="string"&&!!l.test(b)&&(b=b.toLowerCase(),d=b,g=w),g("parentNode",b,f,a,d,c)},"~":function(a,b,c){var d,f=e++,g=x;typeof b=="string"&&!!l.test(b)&&(b=b.toLowerCase(),d=b,g=w),g("previousSibling",b,f,a,d,c)}},find:{ID:function(a,b,c){if(typeof b.getElementById!!="undefined"&&!!c){var d=b.getElementById(a[1]);return d&&d.parentNode?[d]:[]}},NAME:function(a,b){if(typeof b.getElementsByName!!="undefined"){var c=[],d=b.getElementsByName(a[1]);for(var e=0,f=d.length;e<f;e++)d[e].getAttribute("name")===a[1]&&c.push(d[e]);return c.length===0?null:c}},TAG:function(a,b){if(typeof b.getElementsByTagName!!="undefined")return b.getElementsByTagName(a[1])}},preFilter:{CLASS:function(a,b,c,d,e,f){a=" "+a[1].replace(j,"")+" ";if(f)return a;for(var g=0,h;(h=b[g])!!=null;g++)h&&(e^(h.className&&(" "+h.className+" ").replace(/[\t\n\r]/g," ").indexOf(a)>=0)?c||d.push(h):c&&(b[g]=!!1));return!!1},ID:function(a){return a[1].replace(j,"")},TAG:function(a,b){return a[1].replace(j,"").toLowerCase()},CHILD:function(a){if(a[1]==="nth"){a[2]||m.error(a[0]),a[2]=a[2].replace(/^\+|\s*/g,"");var b=/(-?)(\d*)(?:n([+\-]?\d*))?/.exec(a[2]==="even"&&"2n"||a[2]==="odd"&&"2n+1"||!!/\D/.test(a[2])&&"0n+"+a[2]||a[2]);a[2]=b[1]+(b[2]||1)-0,a[3]=b[3]-0}else a[2]&&m.error(a[0]);a[0]=e++;return a},ATTR:function(a,b,c,d,e,f){var g=a[1]=a[1].replace(j,"");!!f&&o.attrMap[g]&&(a[1]=o.attrMap[g]),a[4]=(a[4]||a[5]||"").replace(j,""),a[2]==="~="&&(a[4]=" "+a[4]+" ");return a},PSEUDO:function(b,c,d,e,f){if(b[1]==="not")if((a.exec(b[3])||"").length>1||/^\w/.test(b[3]))b[3]=m(b[3],null,null,c);else{var g=m.filter(b[3],c,d,!!0^f);d||e.push.apply(e,g);return!!1}else if(o.match.POS.test(b[0])||o.match.CHILD.test(b[0]))return!!0;return b},POS:function(a){a.unshift(!!0);return a}},filters:{enabled:function(a){return a.disabled===!!1&&a.type!!=="hidden"},disabled:function(a){return a.disabled===!!0},checked:function(a){return a.checked===!!0},selected:function(a){a.parentNode&&a.parentNode.selectedIndex;return a.selected===!!0},parent:function(a){return!!!!a.firstChild},empty:function(a){return!!a.firstChild},has:function(a,b,c){return!!!!m(c[3],a).length},header:function(a){return/h\d/i.test(a.nodeName)},text:function(a){var b=a.getAttribute("type"),c=a.type;return a.nodeName.toLowerCase()==="input"&&"text"===c&&(b===c||b===null)},radio:function(a){return a.nodeName.toLowerCase()==="input"&&"radio"===a.type},checkbox:function(a){return a.nodeName.toLowerCase()==="input"&&"checkbox"===a.type},file:function(a){return a.nodeName.toLowerCase()==="input"&&"file"===a.type},password:function(a){return a.nodeName.toLowerCase()==="input"&&"password"===a.type},submit:function(a){var b=a.nodeName.toLowerCase();return(b==="input"||b==="button")&&"submit"===a.type},image:function(a){return a.nodeName.toLowerCase()==="input"&&"image"===a.type},reset:function(a){var b=a.nodeName.toLowerCase();return(b==="input"||b==="button")&&"reset"===a.type},button:function(a){var b=a.nodeName.toLowerCase();return b==="input"&&"button"===a.type||b==="button"},input:function(a){return/input|select|textarea|button/i.test(a.nodeName)},focus:function(a){return a===a.ownerDocument.activeElement}},setFilters:{first:function(a,b){return b===0},last:function(a,b,c,d){return b===d.length-1},even:function(a,b){return b%2===0},odd:function(a,b){return b%2===1},lt:function(a,b,c){return b<c[3]-0},gt:function(a,b,c){return b>c[3]-0},nth:function(a,b,c){return c[3]-0===b},eq:function(a,b,c){return c[3]-0===b}},filter:{PSEUDO:function(a,b,c,d){var e=b[1],f=o.filters[e];if(f)return f(a,c,b,d);if(e==="contains")return(a.textContent||a.innerText||n([a])||"").indexOf(b[3])>=0;if(e==="not"){var g=b[3];for(var h=0,i=g.length;h<i;h++)if(g[h]===a)return!!1;return!!0}m.error(e)},CHILD:function(a,b){var c,e,f,g,h,i,j,k=b[1],l=a;switch(k){case"only":case"first":while(l=l.previousSibling)if(l.nodeType===1)return!!1;if(k==="first")return!!0;l=a;case"last":while(l=l.nextSibling)if(l.nodeType===1)return!!1;return!!0;case"nth":c=b[2],e=b[3];if(c===1&&e===0)return!!0;f=b[0],g=a.parentNode;if(g&&(g[d]!!==f||!!a.nodeIndex)){i=0;for(l=g.firstChild;l;l=l.nextSibling)l.nodeType===1&&(l.nodeIndex=++i);g[d]=f}j=a.nodeIndex-e;return c===0?j===0:j%c===0&&j/c>=0}},ID:function(a,b){return a.nodeType===1&&a.getAttribute("id")===b},TAG:function(a,b){return b==="*"&&a.nodeType===1||!!!!a.nodeName&&a.nodeName.toLowerCase()===b},CLASS:function(a,b){return(" "+(a.className||a.getAttribute("class"))+" ").indexOf(b)>-1},ATTR:function(a,b){var c=b[1],d=m.attr?m.attr(a,c):o.attrHandle[c]?o.attrHandle[c](a):a[c]!!=null?a[c]:a.getAttribute(c),e=d+"",f=b[2],g=b[4];return d==null?f==="!!=":!!f&&m.attr?d!!=null:f==="="?e===g:f==="*="?e.indexOf(g)>=0:f==="~="?(" "+e+" ").indexOf(g)>=0:g?f==="!!="?e!!==g:f==="^="?e.indexOf(g)===0:f==="$="?e.substr(e.length-g.length)===g:f==="|="?e===g||e.substr(0,g.length+1)===g+"-":!!1:e&&d!!==!!1},POS:function(a,b,c,d){var e=b[2],f=o.setFilters[e];if(f)return f(a,c,b,d)}}},p=o.match.POS,q=function(a,b){return"\\"+(b-0+1)};for(var r in o.match)o.match[r]=new RegExp(o.match[r].source+/(?!![^\[]*\])(?!![^\(]*\))/.source),o.leftMatch[r]=new RegExp(/(^(?:.|\r|\n)*?)/.source+o.match[r].source.replace(/\\(\d+)/g,q));var s=function(a,b){a=Array.prototype.slice.call(a,0);if(b){b.push.apply(b,a);return b}return a};try{Array.prototype.slice.call(c.documentElement.childNodes,0)[0].nodeType}catch(t){s=function(a,b){var c=0,d=b||[];if(g.call(a)==="[object Array]")Array.prototype.push.apply(d,a);else if(typeof a.length=="number")for(var e=a.length;c<e;c++)d.push(a[c]);else for(;a[c];c++)d.push(a[c]);return d}}var u,v;c.documentElement.compareDocumentPosition?u=function(a,b){if(a===b){h=!!0;return 0}if(!!a.compareDocumentPosition||!!b.compareDocumentPosition)return a.compareDocumentPosition?-1:1;return a.compareDocumentPosition(b)&4?-1:1}:(u=function(a,b){if(a===b){h=!!0;return 0}if(a.sourceIndex&&b.sourceIndex)return a.sourceIndex-b.sourceIndex;var c,d,e=[],f=[],g=a.parentNode,i=b.parentNode,j=g;if(g===i)return v(a,b);if(!!g)return-1;if(!!i)return 1;while(j)e.unshift(j),j=j.parentNode;j=i;while(j)f.unshift(j),j=j.parentNode;c=e.length,d=f.length;for(var k=0;k<c&&k<d;k++)if(e[k]!!==f[k])return v(e[k],f[k]);return k===c?v(a,f[k],-1):v(e[k],b,1)},v=function(a,b,c){if(a===b)return c;var d=a.nextSibling;while(d){if(d===b)return-1;d=d.nextSibling}return 1}),function(){var a=c.createElement("div"),d="script"+(new Date).getTime(),e=c.documentElement;a.innerHTML="<a name=''"+d+"''/>",e.insertBefore(a,e.firstChild),c.getElementById(d)&&(o.find.ID=function(a,c,d){if(typeof c.getElementById!!="undefined"&&!!d){var e=c.getElementById(a[1]);return e?e.id===a[1]||typeof e.getAttributeNode!!="undefined"&&e.getAttributeNode("id").nodeValue===a[1]?[e]:b:[]}},o.filter.ID=function(a,b){var c=typeof a.getAttributeNode!!="undefined"&&a.getAttributeNode("id");return a.nodeType===1&&c&&c.nodeValue===b}),e.removeChild(a),e=a=null}(),function(){var a=c.createElement("div");a.appendChild(c.createComment("")),a.getElementsByTagName("*").length>0&&(o.find.TAG=function(a,b){var c=b.getElementsByTagName(a[1]);if(a[1]==="*"){var d=[];for(var e=0;c[e];e++)c[e].nodeType===1&&d.push(c[e]);c=d}return c}),a.innerHTML="<a href=''#''></a>",a.firstChild&&typeof a.firstChild.getAttribute!!="undefined"&&a.firstChild.getAttribute("href")!!=="#"&&(o.attrHandle.href=function(a){return a.getAttribute("href",2)}),a=null}(),c.querySelectorAll&&function(){var a=m,b=c.createElement("div"),d="__sizzle__";b.innerHTML="<p class=''TEST''></p>";if(!!b.querySelectorAll||b.querySelectorAll(".TEST").length!!==0){m=function(b,e,f,g){e=e||c;if(!!g&&!!m.isXML(e)){var h=/^(\w+$)|^\.([\w\-]+$)|^#([\w\-]+$)/.exec(b);if(h&&(e.nodeType===1||e.nodeType===9)){if(h[1])return s(e.getElementsByTagName(b),f);if(h[2]&&o.find.CLASS&&e.getElementsByClassName)return s(e.getElementsByClassName(h[2]),f)}if(e.nodeType===9){if(b==="body"&&e.body)return s([e.body],f);if(h&&h[3]){var i=e.getElementById(h[3]);if(!!i||!!i.parentNode)return s([],f);if(i.id===h[3])return s([i],f)}try{return s(e.querySelectorAll(b),f)}catch(j){}}else if(e.nodeType===1&&e.nodeName.toLowerCase()!!=="object"){var k=e,l=e.getAttribute("id"),n=l||d,p=e.parentNode,q=/^\s*[+~]/.test(b);l?n=n.replace(/''/g,"\\$&"):e.setAttribute("id",n),q&&p&&(e=e.parentNode);try{if(!!q||p)return s(e.querySelectorAll("[id=''"+n+"''] "+b),f)}catch(r){}finally{l||k.removeAttribute("id")}}}return a(b,e,f,g)};for(var e in a)m[e]=a[e];b=null}}(),function(){var a=c.documentElement,b=a.matchesSelector||a.mozMatchesSelector||a.webkitMatchesSelector||a.msMatchesSelector;if(b){var d=!!b.call(c.createElement("div"),"div"),e=!!1;try{b.call(c.documentElement,"[test!!='''']:sizzle")}catch(f){e=!!0}m.matchesSelector=function(a,c){c=c.replace(/\=\s*([^''"\]]*)\s*\]/g,"=''$1'']");if(!!m.isXML(a))try{if(e||!!o.match.PSEUDO.test(c)&&!!/!!=/.test(c)){var f=b.call(a,c);if(f||!!d||a.document&&a.document.nodeType!!==11)return f}}catch(g){}return m(c,null,null,[a]).length>0}}}(),function(){var a=c.createElement("div");a.innerHTML="<div class=''test e''></div><div class=''test''></div>";if(!!!!a.getElementsByClassName&&a.getElementsByClassName("e").length!!==0){a.lastChild.className="e";if(a.getElementsByClassName("e").length===1)return;o.order.splice(1,0,"CLASS"),o.find.CLASS=function(a,b,c){if(typeof b.getElementsByClassName!!="undefined"&&!!c)return b.getElementsByClassName(a[1])},a=null}}(),c.documentElement.contains?m.contains=function(a,b){return a!!==b&&(a.contains?a.contains(b):!!0)}:c.documentElement.compareDocumentPosition?m.contains=function(a,b){return!!!!(a.compareDocumentPosition(b)&16)}:m.contains=function(){return!!1},m.isXML=function(a){var b=(a?a.ownerDocument||a:0).documentElement;return b?b.nodeName!!=="HTML":!!1};var y=function(a,b,c){var d,e=[],f="",g=b.nodeType?[b]:b;while(d=o.match.PSEUDO.exec(a))f+=d[0],a=a.replace(o.match.PSEUDO,"");a=o.relative[a]?a+"*":a;for(var h=0,i=g.length;h<i;h++)m(a,g[h],e,c);return m.filter(f,e)};m.attr=f.attr,m.selectors.attrMap={},f.find=m,f.expr=m.selectors,f.expr[":"]=f.expr.filters,f.unique=m.uniqueSort,f.text=m.getText,f.isXMLDoc=m.isXML,f.contains=m.contains}();var L=/Until$/,M=/^(?:parents|prevUntil|prevAll)/,N=/,/,O=/^.[^:#\[\.,]*$/,P=Array.prototype.slice,Q=f.expr.match.POS,R={children:!!0,contents:!!0,next:!!0,prev:!!0};f.fn.extend({find:function(a){var b=this,c,d;if(typeof a!!="string")return f(a).filter(function(){for(c=0,d=b.length;c<d;c++)if(f.contains(b[c],this))return!!0});var e=this.pushStack("","find",a),g,h,i;for(c=0,d=this.length;c<d;c++){g=e.length,f.find(a,this[c],e);if(c>0)for(h=g;h<e.length;h++)for(i=0;i<g;i++)if(e[i]===e[h]){e.splice(h--,1);break}}return e},has:function(a){var b=f(a);return this.filter(function(){for(var a=0,c=b.length;a<c;a++)if(f.contains(this,b[a]))return!!0})},not:function(a){return this.pushStack(T(this,a,!!1),"not",a)},filter:function(a){return this.pushStack(T(this,a,!!0),"filter",a)},is:function(a){return!!!!a&&(typeof a=="string"?Q.test(a)?f(a,this.context).index(this[0])>=0:f.filter(a,this).length>0:this.filter(a).length>0)},closest:function(a,b){var c=[],d,e,g=this[0];if(f.isArray(a)){var h=1;while(g&&g.ownerDocument&&g!!==b){for(d=0;d<a.length;d++)f(g).is(a[d])&&c.push({selector:a[d],elem:g,level:h});g=g.parentNode,h++}return c}var i=Q.test(a)||typeof a!!="string"?f(a,b||this.context):0;for(d=0,e=this.length;d<e;d++){g=this[d];while(g){if(i?i.index(g)>-1:f.find.matchesSelector(g,a)){c.push(g);break}g=g.parentNode;if(!!g||!!g.ownerDocument||g===b||g.nodeType===11)break}}c=c.length>1?f.unique(c):c;return this.pushStack(c,"closest",a)},index:function(a){if(!!a)return this[0]&&this[0].parentNode?this.prevAll().length:-1;if(typeof a=="string")return f.inArray(this[0],f(a));return f.inArray(a.jquery?a[0]:a,this)},add:function(a,b){var c=typeof a=="string"?f(a,b):f.makeArray(a&&a.nodeType?[a]:a),d=f.merge(this.get(),c);return this.pushStack(S(c[0])||S(d[0])?d:f.unique(d))},andSelf:function(){return this.add(this.prevObject)}}),f.each({parent:function(a){var b=a.parentNode;return b&&b.nodeType!!==11?b:null},parents:function(a){return f.dir(a,"parentNode")},parentsUntil:function(a,b,c){return f.dir(a,"parentNode",c)},next:function(a){return f.nth(a,2,"nextSibling")},prev:function(a){return f.nth(a,2,"previousSibling")},nextAll:function(a){return f.dir(a,"nextSibling")},prevAll:function(a){return f.dir(a,"previousSibling")},nextUntil:function(a,b,c){return f.dir(a,"nextSibling",c)},prevUntil:function(a,b,c){return f.dir(a,"previousSibling",c)},siblings:function(a){return f.sibling(a.parentNode.firstChild,a)},children:function(a){return f.sibling(a.firstChild)},contents:function(a){return f.nodeName(a,"iframe")?a.contentDocument||a.contentWindow.document:f.makeArray(a.childNodes)}},function(a,b){f.fn[a]=function(c,d){var e=f.map(this,b,c);L.test(a)||(d=c),d&&typeof d=="string"&&(e=f.filter(d,e)),e=this.length>1&&!!R[a]?f.unique(e):e,(this.length>1||N.test(d))&&M.test(a)&&(e=e.reverse());return this.pushStack(e,a,P.call(arguments).join(","))}}),f.extend({filter:function(a,b,c){c&&(a=":not("+a+")");return b.length===1?f.find.matchesSelector(b[0],a)?[b[0]]:[]:f.find.matches(a,b)},dir:function(a,c,d){var e=[],g=a[c];while(g&&g.nodeType!!==9&&(d===b||g.nodeType!!==1||!!f(g).is(d)))g.nodeType===1&&e.push(g),g=g[c];return e},nth:function(a,b,c,d){b=b||1;var e=0;for(;a;a=a[c])if(a.nodeType===1&&++e===b)break;return a},sibling:function(a,b){var c=[];for(;a;a=a.nextSibling)a.nodeType===1&&a!!==b&&c.push(a);return c}});var V="abbr|article|aside|audio|canvas|datalist|details|figcaption|figure|footer|header|hgroup|mark|meter|nav|output|progress|section|summary|time|video",W=/ jQuery\d+="(?:\d+|null)"/g,X=/^\s+/,Y=/<(?!!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/ig,Z=/<([\w:]+)/,$=/<tbody/i,_=/<|&#?\w+;/,ba=/<(?:script|style)/i,bb=/<(?:script|object|embed|option|style)/i,bc=new RegExp("<(?:"+V+")","i"),bd=/checked\s*(?:[^=]|=\s*.checked.)/i,be=/\/(java|ecma)script/i,bf=/^\s*<!!(?:\[CDATA\[|\-\-)/,bg={option:[1,"<select multiple=''multiple''>","</select>"],legend:[1,"<fieldset>","</fieldset>"],thead:[1,"<table>","</table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],col:[2,"<table><tbody></tbody><colgroup>","</colgroup></table>"],area:[1,"<map>","</map>"],_default:[0,"",""]},bh=U(c);bg.optgroup=bg.option,bg.tbody=bg.tfoot=bg.colgroup=bg.caption=bg.thead,bg.th=bg.td,f.support.htmlSerialize||(bg._default=[1,"div<div>","</div>"]),f.fn.extend({text:function(a){if(f.isFunction(a))return this.each(function(b){var c=f(this);c.text(a.call(this,b,c.text()))});if(typeof a!!="object"&&a!!==b)return this.empty().append((this[0]&&this[0].ownerDocument||c).createTextNode(a));return f.text(this)},wrapAll:function(a){if(f.isFunction(a))return this.each(function(b){f(this).wrapAll(a.call(this,b))});if(this[0]){var b=f(a,this[0].ownerDocument).eq(0).clone(!!0);this[0].parentNode&&b.insertBefore(this[0]),b.map(function(){var a=this;while(a.firstChild&&a.firstChild.nodeType===1)a=a.firstChild;return a}).append(this)}return this},wrapInner:function(a){if(f.isFunction(a))return this.each(function(b){f(this).wrapInner(a.call(this,b))});return this.each(function(){var b=f(this),c=b.contents();c.length?c.wrapAll(a):b.append(a)})},wrap:function(a){var b=f.isFunction(a);return this.each(function(c){f(this).wrapAll(b?a.call(this,c):a)})},unwrap:function(){return this.parent().each(function(){f.nodeName(this,"body")||f(this).replaceWith(this.childNodes)}).end()},append:function(){return this.domManip(arguments,!!0,function(a){this.nodeType===1&&this.appendChild(a)})},prepend:function(){return this.domManip(arguments,!!0,function(a){this.nodeType===1&&this.insertBefore(a,this.firstChild)})},before:function(){if(this[0]&&this[0].parentNode)return this.domManip(arguments,!!1,function(a){this.parentNode.insertBefore(a,this)});if(arguments.length){var a=f.clean(arguments);a.push.apply(a,this.toArray());return this.pushStack(a,"before",arguments)}},after:function(){if(this[0]&&this[0].parentNode)return this.domManip(arguments,!!1,function(a){this.parentNode.insertBefore(a,this.nextSibling)});if(arguments.length){var a=this.pushStack(this,"after",arguments);a.push.apply(a,f.clean(arguments));return a}},remove:function(a,b){for(var c=0,d;(d=this[c])!!=null;c++)if(!!a||f.filter(a,[d]).length)!!b&&d.nodeType===1&&(f.cleanData(d.getElementsByTagName("*")),f.cleanData([d])),d.parentNode&&d.parentNode.removeChild(d);return this},empty:function()
{for(var a=0,b;(b=this[a])!!=null;a++){b.nodeType===1&&f.cleanData(b.getElementsByTagName("*"));while(b.firstChild)b.removeChild(b.firstChild)}return this},clone:function(a,b){a=a==null?!!1:a,b=b==null?a:b;return this.map(function(){return f.clone(this,a,b)})},html:function(a){if(a===b)return this[0]&&this[0].nodeType===1?this[0].innerHTML.replace(W,""):null;if(typeof a=="string"&&!!ba.test(a)&&(f.support.leadingWhitespace||!!X.test(a))&&!!bg[(Z.exec(a)||["",""])[1].toLowerCase()]){a=a.replace(Y,"<$1></$2>");try{for(var c=0,d=this.length;c<d;c++)this[c].nodeType===1&&(f.cleanData(this[c].getElementsByTagName("*")),this[c].innerHTML=a)}catch(e){this.empty().append(a)}}else f.isFunction(a)?this.each(function(b){var c=f(this);c.html(a.call(this,b,c.html()))}):this.empty().append(a);return this},replaceWith:function(a){if(this[0]&&this[0].parentNode){if(f.isFunction(a))return this.each(function(b){var c=f(this),d=c.html();c.replaceWith(a.call(this,b,d))});typeof a!!="string"&&(a=f(a).detach());return this.each(function(){var b=this.nextSibling,c=this.parentNode;f(this).remove(),b?f(b).before(a):f(c).append(a)})}return this.length?this.pushStack(f(f.isFunction(a)?a():a),"replaceWith",a):this},detach:function(a){return this.remove(a,!!0)},domManip:function(a,c,d){var e,g,h,i,j=a[0],k=[];if(!!f.support.checkClone&&arguments.length===3&&typeof j=="string"&&bd.test(j))return this.each(function(){f(this).domManip(a,c,d,!!0)});if(f.isFunction(j))return this.each(function(e){var g=f(this);a[0]=j.call(this,e,c?g.html():b),g.domManip(a,c,d)});if(this[0]){i=j&&j.parentNode,f.support.parentNode&&i&&i.nodeType===11&&i.childNodes.length===this.length?e={fragment:i}:e=f.buildFragment(a,this,k),h=e.fragment,h.childNodes.length===1?g=h=h.firstChild:g=h.firstChild;if(g){c=c&&f.nodeName(g,"tr");for(var l=0,m=this.length,n=m-1;l<m;l++)d.call(c?bi(this[l],g):this[l],e.cacheable||m>1&&l<n?f.clone(h,!!0,!!0):h)}k.length&&f.each(k,bp)}return this}}),f.buildFragment=function(a,b,d){var e,g,h,i,j=a[0];b&&b[0]&&(i=b[0].ownerDocument||b[0]),i.createDocumentFragment||(i=c),a.length===1&&typeof j=="string"&&j.length<512&&i===c&&j.charAt(0)==="<"&&!!bb.test(j)&&(f.support.checkClone||!!bd.test(j))&&(f.support.html5Clone||!!bc.test(j))&&(g=!!0,h=f.fragments[j],h&&h!!==1&&(e=h)),e||(e=i.createDocumentFragment(),f.clean(a,i,e,d)),g&&(f.fragments[j]=h?e:1);return{fragment:e,cacheable:g}},f.fragments={},f.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(a,b){f.fn[a]=function(c){var d=[],e=f(c),g=this.length===1&&this[0].parentNode;if(g&&g.nodeType===11&&g.childNodes.length===1&&e.length===1){e[b](this[0]);return this}for(var h=0,i=e.length;h<i;h++){var j=(h>0?this.clone(!!0):this).get();f(e[h])[b](j),d=d.concat(j)}return this.pushStack(d,a,e.selector)}}),f.extend({clone:function(a,b,c){var d,e,g,h=f.support.html5Clone||!!bc.test("<"+a.nodeName)?a.cloneNode(!!0):bo(a);if((!!f.support.noCloneEvent||!!f.support.noCloneChecked)&&(a.nodeType===1||a.nodeType===11)&&!!f.isXMLDoc(a)){bk(a,h),d=bl(a),e=bl(h);for(g=0;d[g];++g)e[g]&&bk(d[g],e[g])}if(b){bj(a,h);if(c){d=bl(a),e=bl(h);for(g=0;d[g];++g)bj(d[g],e[g])}}d=e=null;return h},clean:function(a,b,d,e){var g;b=b||c,typeof b.createElement=="undefined"&&(b=b.ownerDocument||b[0]&&b[0].ownerDocument||c);var h=[],i;for(var j=0,k;(k=a[j])!!=null;j++){typeof k=="number"&&(k+="");if(!!k)continue;if(typeof k=="string")if(!!_.test(k))k=b.createTextNode(k);else{k=k.replace(Y,"<$1></$2>");var l=(Z.exec(k)||["",""])[1].toLowerCase(),m=bg[l]||bg._default,n=m[0],o=b.createElement("div");b===c?bh.appendChild(o):U(b).appendChild(o),o.innerHTML=m[1]+k+m[2];while(n--)o=o.lastChild;if(!!f.support.tbody){var p=$.test(k),q=l==="table"&&!!p?o.firstChild&&o.firstChild.childNodes:m[1]==="<table>"&&!!p?o.childNodes:[];for(i=q.length-1;i>=0;--i)f.nodeName(q[i],"tbody")&&!!q[i].childNodes.length&&q[i].parentNode.removeChild(q[i])}!!f.support.leadingWhitespace&&X.test(k)&&o.insertBefore(b.createTextNode(X.exec(k)[0]),o.firstChild),k=o.childNodes}var r;if(!!f.support.appendChecked)if(k[0]&&typeof (r=k.length)=="number")for(i=0;i<r;i++)bn(k[i]);else bn(k);k.nodeType?h.push(k):h=f.merge(h,k)}if(d){g=function(a){return!!a.type||be.test(a.type)};for(j=0;h[j];j++)if(e&&f.nodeName(h[j],"script")&&(!!h[j].type||h[j].type.toLowerCase()==="text/javascript"))e.push(h[j].parentNode?h[j].parentNode.removeChild(h[j]):h[j]);else{if(h[j].nodeType===1){var s=f.grep(h[j].getElementsByTagName("script"),g);h.splice.apply(h,[j+1,0].concat(s))}d.appendChild(h[j])}}return h},cleanData:function(a){var b,c,d=f.cache,e=f.event.special,g=f.support.deleteExpando;for(var h=0,i;(i=a[h])!!=null;h++){if(i.nodeName&&f.noData[i.nodeName.toLowerCase()])continue;c=i[f.expando];if(c){b=d[c];if(b&&b.events){for(var j in b.events)e[j]?f.event.remove(i,j):f.removeEvent(i,j,b.handle);b.handle&&(b.handle.elem=null)}g?delete i[f.expando]:i.removeAttribute&&i.removeAttribute(f.expando),delete d[c]}}}});var bq=/alpha\([^)]*\)/i,br=/opacity=([^)]*)/,bs=/([A-Z]|^ms)/g,bt=/^-?\d+(?:px)?$/i,bu=/^-?\d/,bv=/^([\-+])=([\-+.\de]+)/,bw={position:"absolute",visibility:"hidden",display:"block"},bx=["Left","Right"],by=["Top","Bottom"],bz,bA,bB;f.fn.css=function(a,c){if(arguments.length===2&&c===b)return this;return f.access(this,a,c,!!0,function(a,c,d){return d!!==b?f.style(a,c,d):f.css(a,c)})},f.extend({cssHooks:{opacity:{get:function(a,b){if(b){var c=bz(a,"opacity","opacity");return c===""?"1":c}return a.style.opacity}}},cssNumber:{fillOpacity:!!0,fontWeight:!!0,lineHeight:!!0,opacity:!!0,orphans:!!0,widows:!!0,zIndex:!!0,zoom:!!0},cssProps:{"float":f.support.cssFloat?"cssFloat":"styleFloat"},style:function(a,c,d,e){if(!!!!a&&a.nodeType!!==3&&a.nodeType!!==8&&!!!!a.style){var g,h,i=f.camelCase(c),j=a.style,k=f.cssHooks[i];c=f.cssProps[i]||i;if(d===b){if(k&&"get"in k&&(g=k.get(a,!!1,e))!!==b)return g;return j[c]}h=typeof d,h==="string"&&(g=bv.exec(d))&&(d=+(g[1]+1)*+g[2]+parseFloat(f.css(a,c)),h="number");if(d==null||h==="number"&&isNaN(d))return;h==="number"&&!!f.cssNumber[i]&&(d+="px");if(!!k||!!("set"in k)||(d=k.set(a,d))!!==b)try{j[c]=d}catch(l){}}},css:function(a,c,d){var e,g;c=f.camelCase(c),g=f.cssHooks[c],c=f.cssProps[c]||c,c==="cssFloat"&&(c="float");if(g&&"get"in g&&(e=g.get(a,!!0,d))!!==b)return e;if(bz)return bz(a,c)},swap:function(a,b,c){var d={};for(var e in b)d[e]=a.style[e],a.style[e]=b[e];c.call(a);for(e in b)a.style[e]=d[e]}}),f.curCSS=f.css,f.each(["height","width"],function(a,b){f.cssHooks[b]={get:function(a,c,d){var e;if(c){if(a.offsetWidth!!==0)return bC(a,b,d);f.swap(a,bw,function(){e=bC(a,b,d)});return e}},set:function(a,b){if(!!bt.test(b))return b;b=parseFloat(b);if(b>=0)return b+"px"}}}),f.support.opacity||(f.cssHooks.opacity={get:function(a,b){return br.test((b&&a.currentStyle?a.currentStyle.filter:a.style.filter)||"")?parseFloat(RegExp.$1)/100+"":b?"1":""},set:function(a,b){var c=a.style,d=a.currentStyle,e=f.isNumeric(b)?"alpha(opacity="+b*100+")":"",g=d&&d.filter||c.filter||"";c.zoom=1;if(b>=1&&f.trim(g.replace(bq,""))===""){c.removeAttribute("filter");if(d&&!!d.filter)return}c.filter=bq.test(g)?g.replace(bq,e):g+" "+e}}),f(function(){f.support.reliableMarginRight||(f.cssHooks.marginRight={get:function(a,b){var c;f.swap(a,{display:"inline-block"},function(){b?c=bz(a,"margin-right","marginRight"):c=a.style.marginRight});return c}})}),c.defaultView&&c.defaultView.getComputedStyle&&(bA=function(a,b){var c,d,e;b=b.replace(bs,"-$1").toLowerCase(),(d=a.ownerDocument.defaultView)&&(e=d.getComputedStyle(a,null))&&(c=e.getPropertyValue(b),c===""&&!!f.contains(a.ownerDocument.documentElement,a)&&(c=f.style(a,b)));return c}),c.documentElement.currentStyle&&(bB=function(a,b){var c,d,e,f=a.currentStyle&&a.currentStyle[b],g=a.style;f===null&&g&&(e=g[b])&&(f=e),!!bt.test(f)&&bu.test(f)&&(c=g.left,d=a.runtimeStyle&&a.runtimeStyle.left,d&&(a.runtimeStyle.left=a.currentStyle.left),g.left=b==="fontSize"?"1em":f||0,f=g.pixelLeft+"px",g.left=c,d&&(a.runtimeStyle.left=d));return f===""?"auto":f}),bz=bA||bB,f.expr&&f.expr.filters&&(f.expr.filters.hidden=function(a){var b=a.offsetWidth,c=a.offsetHeight;return b===0&&c===0||!!f.support.reliableHiddenOffsets&&(a.style&&a.style.display||f.css(a,"display"))==="none"},f.expr.filters.visible=function(a){return!!f.expr.filters.hidden(a)});var bD=/%20/g,bE=/\[\]$/,bF=/\r?\n/g,bG=/#.*$/,bH=/^(.*?):[ \t]*([^\r\n]*)\r?$/mg,bI=/^(?:color|date|datetime|datetime-local|email|hidden|month|number|password|range|search|tel|text|time|url|week)$/i,bJ=/^(?:about|app|app\-storage|.+\-extension|file|res|widget):$/,bK=/^(?:GET|HEAD)$/,bL=/^\/\//,bM=/\?/,bN=/<script\b[^<]*(?:(?!!<\/script>)<[^<]*)*<\/script>/gi,bO=/^(?:select|textarea)/i,bP=/\s+/,bQ=/([?&])_=[^&]*/,bR=/^([\w\+\.\-]+:)(?:\/\/([^\/?#:]*)(?::(\d+))?)?/,bS=f.fn.load,bT={},bU={},bV,bW,bX=["*/"]+["*"];try{bV=e.href}catch(bY){bV=c.createElement("a"),bV.href="",bV=bV.href}bW=bR.exec(bV.toLowerCase())||[],f.fn.extend({load:function(a,c,d){if(typeof a!!="string"&&bS)return bS.apply(this,arguments);if(!!this.length)return this;var e=a.indexOf(" ");if(e>=0){var g=a.slice(e,a.length);a=a.slice(0,e)}var h="GET";c&&(f.isFunction(c)?(d=c,c=b):typeof c=="object"&&(c=f.param(c,f.ajaxSettings.traditional),h="POST"));var i=this;f.ajax({url:a,type:h,dataType:"html",data:c,complete:function(a,b,c){c=a.responseText,a.isResolved()&&(a.done(function(a){c=a}),i.html(g?f("<div>").append(c.replace(bN,"")).find(g):c)),d&&i.each(d,[c,b,a])}});return this},serialize:function(){return f.param(this.serializeArray())},serializeArray:function(){return this.map(function(){return this.elements?f.makeArray(this.elements):this}).filter(function(){return this.name&&!!this.disabled&&(this.checked||bO.test(this.nodeName)||bI.test(this.type))}).map(function(a,b){var c=f(this).val();return c==null?null:f.isArray(c)?f.map(c,function(a,c){return{name:b.name,value:a.replace(bF,"\r\n")}}):{name:b.name,value:c.replace(bF,"\r\n")}}).get()}}),f.each("ajaxStart ajaxStop ajaxComplete ajaxError ajaxSuccess ajaxSend".split(" "),function(a,b){f.fn[b]=function(a){return this.on(b,a)}}),f.each(["get","post"],function(a,c){f[c]=function(a,d,e,g){f.isFunction(d)&&(g=g||e,e=d,d=b);return f.ajax({type:c,url:a,data:d,success:e,dataType:g})}}),f.extend({getScript:function(a,c){return f.get(a,b,c,"script")},getJSON:function(a,b,c){return f.get(a,b,c,"json")},ajaxSetup:function(a,b){b?b_(a,f.ajaxSettings):(b=a,a=f.ajaxSettings),b_(a,b);return a},ajaxSettings:{url:bV,isLocal:bJ.test(bW[1]),global:!!0,type:"GET",contentType:"application/x-www-form-urlencoded",processData:!!0,async:!!0,accepts:{xml:"application/xml, text/xml",html:"text/html",text:"text/plain",json:"application/json, text/javascript","*":bX},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText"},converters:{"* text":a.String,"text html":!!0,"text json":f.parseJSON,"text xml":f.parseXML},flatOptions:{context:!!0,url:!!0}},ajaxPrefilter:bZ(bT),ajaxTransport:bZ(bU),ajax:function(a,c){function w(a,c,l,m){if(s!!==2){s=2,q&&clearTimeout(q),p=b,n=m||"",v.readyState=a>0?4:0;var o,r,u,w=c,x=l?cb(d,v,l):b,y,z;if(a>=200&&a<300||a===304){if(d.ifModified){if(y=v.getResponseHeader("Last-Modified"))f.lastModified[k]=y;if(z=v.getResponseHeader("Etag"))f.etag[k]=z}if(a===304)w="notmodified",o=!!0;else try{r=cc(d,x),w="success",o=!!0}catch(A){w="parsererror",u=A}}else{u=w;if(!!w||a)w="error",a<0&&(a=0)}v.status=a,v.statusText=""+(c||w),o?h.resolveWith(e,[r,w,v]):h.rejectWith(e,[v,w,u]),v.statusCode(j),j=b,t&&g.trigger("ajax"+(o?"Success":"Error"),[v,d,o?r:u]),i.fireWith(e,[v,w]),t&&(g.trigger("ajaxComplete",[v,d]),--f.active||f.event.trigger("ajaxStop"))}}typeof a=="object"&&(c=a,a=b),c=c||{};var d=f.ajaxSetup({},c),e=d.context||d,g=e!!==d&&(e.nodeType||e instanceof f)?f(e):f.event,h=f.Deferred(),i=f.Callbacks("once memory"),j=d.statusCode||{},k,l={},m={},n,o,p,q,r,s=0,t,u,v={readyState:0,setRequestHeader:function(a,b){if(!!s){var c=a.toLowerCase();a=m[c]=m[c]||a,l[a]=b}return this},getAllResponseHeaders:function(){return s===2?n:null},getResponseHeader:function(a){var c;if(s===2){if(!!o){o={};while(c=bH.exec(n))o[c[1].toLowerCase()]=c[2]}c=o[a.toLowerCase()]}return c===b?null:c},overrideMimeType:function(a){s||(d.mimeType=a);return this},abort:function(a){a=a||"abort",p&&p.abort(a),w(0,a);return this}};h.promise(v),v.success=v.done,v.error=v.fail,v.complete=i.add,v.statusCode=function(a){if(a){var b;if(s<2)for(b in a)j[b]=[j[b],a[b]];else b=a[v.status],v.then(b,b)}return this},d.url=((a||d.url)+"").replace(bG,"").replace(bL,bW[1]+"//"),d.dataTypes=f.trim(d.dataType||"*").toLowerCase().split(bP),d.crossDomain==null&&(r=bR.exec(d.url.toLowerCase()),d.crossDomain=!!(!!r||r[1]==bW[1]&&r[2]==bW[2]&&(r[3]||(r[1]==="http:"?80:443))==(bW[3]||(bW[1]==="http:"?80:443)))),d.data&&d.processData&&typeof d.data!!="string"&&(d.data=f.param(d.data,d.traditional)),b$(bT,d,c,v);if(s===2)return!!1;t=d.global,d.type=d.type.toUpperCase(),d.hasContent=!!bK.test(d.type),t&&f.active++===0&&f.event.trigger("ajaxStart");if(!!d.hasContent){d.data&&(d.url+=(bM.test(d.url)?"&":"?")+d.data,delete d.data),k=d.url;if(d.cache===!!1){var x=f.now(),y=d.url.replace(bQ,"$1_="+x);d.url=y+(y===d.url?(bM.test(d.url)?"&":"?")+"_="+x:"")}}(d.data&&d.hasContent&&d.contentType!!==!!1||c.contentType)&&v.setRequestHeader("Content-Type",d.contentType),d.ifModified&&(k=k||d.url,f.lastModified[k]&&v.setRequestHeader("If-Modified-Since",f.lastModified[k]),f.etag[k]&&v.setRequestHeader("If-None-Match",f.etag[k])),v.setRequestHeader("Accept",d.dataTypes[0]&&d.accepts[d.dataTypes[0]]?d.accepts[d.dataTypes[0]]+(d.dataTypes[0]!!=="*"?", "+bX+"; q=0.01":""):d.accepts["*"]);for(u in d.headers)v.setRequestHeader(u,d.headers[u]);if(d.beforeSend&&(d.beforeSend.call(e,v,d)===!!1||s===2)){v.abort();return!!1}for(u in{success:1,error:1,complete:1})v[u](d[u]);p=b$(bU,d,c,v);if(!!p)w(-1,"No Transport");else{v.readyState=1,t&&g.trigger("ajaxSend",[v,d]),d.async&&d.timeout>0&&(q=setTimeout(function(){v.abort("timeout")},d.timeout));try{s=1,p.send(l,w)}catch(z){if(s<2)w(-1,z);else throw z}}return v},param:function(a,c){var d=[],e=function(a,b){b=f.isFunction(b)?b():b,d[d.length]=encodeURIComponent(a)+"="+encodeURIComponent(b)};c===b&&(c=f.ajaxSettings.traditional);if(f.isArray(a)||a.jquery&&!!f.isPlainObject(a))f.each(a,function(){e(this.name,this.value)});else for(var g in a)ca(g,a[g],c,e);return d.join("&").replace(bD,"+")}}),f.extend({active:0,lastModified:{},etag:{}});var cd=f.now(),ce=/(\=)\?(&|$)|\?\?/i;f.ajaxSetup({jsonp:"callback",jsonpCallback:function(){return f.expando+"_"+cd++}}),f.ajaxPrefilter("json jsonp",function(b,c,d){var e=b.contentType==="application/x-www-form-urlencoded"&&typeof b.data=="string";if(b.dataTypes[0]==="jsonp"||b.jsonp!!==!!1&&(ce.test(b.url)||e&&ce.test(b.data))){var g,h=b.jsonpCallback=f.isFunction(b.jsonpCallback)?b.jsonpCallback():b.jsonpCallback,i=a[h],j=b.url,k=b.data,l="$1"+h+"$2";b.jsonp!!==!!1&&(j=j.replace(ce,l),b.url===j&&(e&&(k=k.replace(ce,l)),b.data===k&&(j+=(/\?/.test(j)?"&":"?")+b.jsonp+"="+h))),b.url=j,b.data=k,a[h]=function(a){g=[a]},d.always(function(){a[h]=i,g&&f.isFunction(i)&&a[h](g[0])}),b.converters["script json"]=function(){g||f.error(h+" was not called");return g[0]},b.dataTypes[0]="json";return"script"}}),f.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/javascript|ecmascript/},converters:{"text script":function(a){f.globalEval(a);return a}}}),f.ajaxPrefilter("script",function(a){a.cache===b&&(a.cache=!!1),a.crossDomain&&(a.type="GET",a.global=!!1)}),f.ajaxTransport("script",function(a){if(a.crossDomain){var d,e=c.head||c.getElementsByTagName("head")[0]||c.documentElement;return{send:function(f,g){d=c.createElement("script"),d.async="async",a.scriptCharset&&(d.charset=a.scriptCharset),d.src=a.url,d.onload=d.onreadystatechange=function(a,c){if(c||!!d.readyState||/loaded|complete/.test(d.readyState))d.onload=d.onreadystatechange=null,e&&d.parentNode&&e.removeChild(d),d=b,c||g(200,"success")},e.insertBefore(d,e.firstChild)},abort:function(){d&&d.onload(0,1)}}}});var cf=a.ActiveXObject?function(){for(var a in ch)ch[a](0,1)}:!!1,cg=0,ch;f.ajaxSettings.xhr=a.ActiveXObject?function(){return!!this.isLocal&&ci()||cj()}:ci,function(a){f.extend(f.support,{ajax:!!!!a,cors:!!!!a&&"withCredentials"in a})}(f.ajaxSettings.xhr()),f.support.ajax&&f.ajaxTransport(function(c){if(!!c.crossDomain||f.support.cors){var d;return{send:function(e,g){var h=c.xhr(),i,j;c.username?h.open(c.type,c.url,c.async,c.username,c.password):h.open(c.type,c.url,c.async);if(c.xhrFields)for(j in c.xhrFields)h[j]=c.xhrFields[j];c.mimeType&&h.overrideMimeType&&h.overrideMimeType(c.mimeType),!!c.crossDomain&&!!e["X-Requested-With"]&&(e["X-Requested-With"]="XMLHttpRequest");try{for(j in e)h.setRequestHeader(j,e[j])}catch(k){}h.send(c.hasContent&&c.data||null),d=function(a,e){var j,k,l,m,n;try{if(d&&(e||h.readyState===4)){d=b,i&&(h.onreadystatechange=f.noop,cf&&delete ch[i]);if(e)h.readyState!!==4&&h.abort();else{j=h.status,l=h.getAllResponseHeaders(),m={},n=h.responseXML,n&&n.documentElement&&(m.xml=n),m.text=h.responseText;try{k=h.statusText}catch(o){k=""}!!j&&c.isLocal&&!!c.crossDomain?j=m.text?200:404:j===1223&&(j=204)}}}catch(p){e||g(-1,p)}m&&g(j,k,m,l)},!!c.async||h.readyState===4?d():(i=++cg,cf&&(ch||(ch={},f(a).unload(cf)),ch[i]=d),h.onreadystatechange=d)},abort:function(){d&&d(0,1)}}}});var ck={},cl,cm,cn=/^(?:toggle|show|hide)$/,co=/^([+\-]=)?([\d+.\-]+)([a-z%]*)$/i,cp,cq=[["height","marginTop","marginBottom","paddingTop","paddingBottom"],["width","marginLeft","marginRight","paddingLeft","paddingRight"],["opacity"]],cr;f.fn.extend({show:function(a,b,c){var d,e;if(a||a===0)return this.animate(cu("show",3),a,b,c);for(var g=0,h=this.length;g<h;g++)d=this[g],d.style&&(e=d.style.display,!!f._data(d,"olddisplay")&&e==="none"&&(e=d.style.display=""),e===""&&f.css(d,"display")==="none"&&f._data(d,"olddisplay",cv(d.nodeName)));for(g=0;g<h;g++){d=this[g];if(d.style){e=d.style.display;if(e===""||e==="none")d.style.display=f._data(d,"olddisplay")||""}}return this},hide:function(a,b,c){if(a||a===0)return this.animate(cu("hide",3),a,b,c);var d,e,g=0,h=this.length;for(;g<h;g++)d=this[g],d.style&&(e=f.css(d,"display"),e!!=="none"&&!!f._data(d,"olddisplay")&&f._data(d,"olddisplay",e));for(g=0;g<h;g++)this[g].style&&(this[g].style.display="none");return this},_toggle:f.fn.toggle,toggle:function(a,b,c){var d=typeof a=="boolean";f.isFunction(a)&&f.isFunction(b)?this._toggle.apply(this,arguments):a==null||d?this.each(function(){var b=d?a:f(this).is(":hidden");f(this)[b?"show":"hide"]()}):this.animate(cu("toggle",3),a,b,c);return this},fadeTo:function(a,b,c,d){return this.filter(":hidden").css("opacity",0).show().end().animate({opacity:b},a,c,d)},animate:function(a,b,c,d){function g(){e.queue===!!1&&f._mark(this);var b=f.extend({},e),c=this.nodeType===1,d=c&&f(this).is(":hidden"),g,h,i,j,k,l,m,n,o;b.animatedProperties={};for(i in a){g=f.camelCase(i),i!!==g&&(a[g]=a[i],delete a[i]),h=a[g],f.isArray(h)?(b.animatedProperties[g]=h[1],h=a[g]=h[0]):b.animatedProperties[g]=b.specialEasing&&b.specialEasing[g]||b.easing||"swing";if(h==="hide"&&d||h==="show"&&!!d)return b.complete.call(this);c&&(g==="height"||g==="width")&&(b.overflow=[this.style.overflow,this.style.overflowX,this.style.overflowY],f.css(this,"display")==="inline"&&f.css(this,"float")==="none"&&(!!f.support.inlineBlockNeedsLayout||cv(this.nodeName)==="inline"?this.style.display="inline-block":this.style.zoom=1))}b.overflow!!=null&&(this.style.overflow="hidden");for(i in a)j=new f.fx(this,b,i),h=a[i],cn.test(h)?(o=f._data(this,"toggle"+i)||(h==="toggle"?d?"show":"hide":0),o?(f._data(this,"toggle"+i,o==="show"?"hide":"show"),j[o]()):j[h]()):(k=co.exec(h),l=j.cur(),k?(m=parseFloat(k[2]),n=k[3]||(f.cssNumber[i]?"":"px"),n!!=="px"&&(f.style(this,i,(m||1)+n),l=(m||1)/j.cur()*l,f.style(this,i,l+n)),k[1]&&(m=(k[1]==="-="?-1:1)*m+l),j.custom(l,m,n)):j.custom(l,h,""));return!!0}var e=f.speed(b,c,d);if(f.isEmptyObject(a))return this.each(e.complete,[!!1]);a=f.extend({},a);return e.queue===!!1?this.each(g):this.queue(e.queue,g)},stop:function(a,c,d){typeof a!!="string"&&(d=c,c=a,a=b),c&&a!!==!!1&&this.queue(a||"fx",[]);return this.each(function(){function h(a,b,c){var e=b[c];f.removeData(a,c,!!0),e.stop(d)}var b,c=!!1,e=f.timers,g=f._data(this);d||f._unmark(!!0,this);if(a==null)for(b in g)g[b]&&g[b].stop&&b.indexOf(".run")===b.length-4&&h(this,g,b);else g[b=a+".run"]&&g[b].stop&&h(this,g,b);for(b=e.length;b--;)e[b].elem===this&&(a==null||e[b].queue===a)&&(d?e[b](!!0):e[b].saveState(),c=!!0,e.splice(b,1));(!!d||!!c)&&f.dequeue(this,a)})}}),f.each({slideDown:cu("show",1),slideUp:cu("hide",1),slideToggle:cu("toggle",1),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(a,b){f.fn[a]=function(a,c,d){return this.animate(b,a,c,d)}}),f.extend({speed:function(a,b,c){var d=a&&typeof a=="object"?f.extend({},a):{complete:c||!!c&&b||f.isFunction(a)&&a,duration:a,easing:c&&b||b&&!!f.isFunction(b)&&b};d.duration=f.fx.off?0:typeof d.duration=="number"?d.duration:d.duration in f.fx.speeds?f.fx.speeds[d.duration]:f.fx.speeds._default;if(d.queue==null||d.queue===!!0)d.queue="fx";d.old=d.complete,d.complete=function(a){f.isFunction(d.old)&&d.old.call(this),d.queue?f.dequeue(this,d.queue):a!!==!!1&&f._unmark(this)};return d},easing:{linear:function(a,b,c,d){return c+d*a},swing:function(a,b,c,d){return(-Math.cos(a*Math.PI)/2+.5)*d+c}},timers:[],fx:function(a,b,c){this.options=b,this.elem=a,this.prop=c,b.orig=b.orig||{}}}),f.fx.prototype={update:function(){this.options.step&&this.options.step.call(this.elem,this.now,this),(f.fx.step[this.prop]||f.fx.step._default)(this)},cur:function(){if(this.elem[this.prop]!!=null&&(!!this.elem.style||this.elem.style[this.prop]==null))return this.elem[this.prop];var a,b=f.css(this.elem,this.prop);return isNaN(a=parseFloat(b))?!!b||b==="auto"?0:b:a},custom:function(a,c,d){function h(a){return e.step(a)}var e=this,g=f.fx;this.startTime=cr||cs(),this.end=c,this.now=this.start=a,this.pos=this.state=0,this.unit=d||this.unit||(f.cssNumber[this.prop]?"":"px"),h.queue=this.options.queue,h.elem=this.elem,h.saveState=function(){e.options.hide&&f._data(e.elem,"fxshow"+e.prop)===b&&f._data(e.elem,"fxshow"+e.prop,e.start)},h()&&f.timers.push(h)&&!!cp&&(cp=setInterval(g.tick,g.interval))},show:function(){var a=f._data(this.elem,"fxshow"+this.prop);this.options.orig[this.prop]=a||f.style(this.elem,this.prop),this.options.show=!!0,a!!==b?this.custom(this.cur(),a):this.custom(this.prop==="width"||this.prop==="height"?1:0,this.cur()),f(this.elem).show()},hide:function(){this.options.orig[this.prop]=f._data(this.elem,"fxshow"+this.prop)||f.style(this.elem,this.prop),this.options.hide=!!0,this.custom(this.cur(),0)},step:function(a){var b,c,d,e=cr||cs(),g=!!0,h=this.elem,i=this.options;if(a||e>=i.duration+this.startTime){this.now=this.end,this.pos=this.state=1,this.update(),i.animatedProperties[this.prop]=!!0;for(b in i.animatedProperties)i.animatedProperties[b]!!==!!0&&(g=!!1);if(g){i.overflow!!=null&&!!f.support.shrinkWrapBlocks&&f.each(["","X","Y"],function(a,b){h.style["overflow"+b]=i.overflow[a]}),i.hide&&f(h).hide();if(i.hide||i.show)for(b in i.animatedProperties)f.style(h,b,i.orig[b]),f.removeData(h,"fxshow"+b,!!0),f.removeData(h,"toggle"+b,!!0);d=i.complete,d&&(i.complete=!!1,d.call(h))}return!!1}i.duration==Infinity?this.now=e:(c=e-this.startTime,this.state=c/i.duration,this.pos=f.easing[i.animatedProperties[this.prop]](this.state,c,0,1,i.duration),this.now=this.start+(this.end-this.start)*this.pos),this.update();return!!0}},f.extend(f.fx,{tick:function(){var a,b=f.timers,c=0;for(;c<b.length;c++)a=b[c],!!a()&&b[c]===a&&b.splice(c--,1);b.length||f.fx.stop()},interval:13,stop:function(){clearInterval(cp),cp=null},speeds:{slow:600,fast:200,_default:400},step:{opacity:function(a){f.style(a.elem,"opacity",a.now)},_default:function(a){a.elem.style&&a.elem.style[a.prop]!!=null?a.elem.style[a.prop]=a.now+a.unit:a.elem[a.prop]=a.now}}}),f.each(["width","height"],function(a,b){f.fx.step[b]=function(a){f.style(a.elem,b,Math.max(0,a.now)+a.unit)}}),f.expr&&f.expr.filters&&(f.expr.filters.animated=function(a){return f.grep(f.timers,function(b){return a===b.elem}).length});var cw=/^t(?:able|d|h)$/i,cx=/^(?:body|html)$/i;"getBoundingClientRect"in c.documentElement?f.fn.offset=function(a){var b=this[0],c;if(a)return this.each(function(b){f.offset.setOffset(this,a,b)});if(!!b||!!b.ownerDocument)return null;if(b===b.ownerDocument.body)return f.offset.bodyOffset(b);try{c=b.getBoundingClientRect()}catch(d){}var e=b.ownerDocument,g=e.documentElement;if(!!c||!!f.contains(g,b))return c?{top:c.top,left:c.left}:{top:0,left:0};var h=e.body,i=cy(e),j=g.clientTop||h.clientTop||0,k=g.clientLeft||h.clientLeft||0,l=i.pageYOffset||f.support.boxModel&&g.scrollTop||h.scrollTop,m=i.pageXOffset||f.support.boxModel&&g.scrollLeft||h.scrollLeft,n=c.top+l-j,o=c.left+m-k;return{top:n,left:o}}:f.fn.offset=function(a){var b=this[0];if(a)return this.each(function(b){f.offset.setOffset(this,a,b)});if(!!b||!!b.ownerDocument)return null;if(b===b.ownerDocument.body)return f.offset.bodyOffset(b);var c,d=b.offsetParent,e=b,g=b.ownerDocument,h=g.documentElement,i=g.body,j=g.defaultView,k=j?j.getComputedStyle(b,null):b.currentStyle,l=b.offsetTop,m=b.offsetLeft;while((b=b.parentNode)&&b!!==i&&b!!==h){if(f.support.fixedPosition&&k.position==="fixed")break;c=j?j.getComputedStyle(b,null):b.currentStyle,l-=b.scrollTop,m-=b.scrollLeft,b===d&&(l+=b.offsetTop,m+=b.offsetLeft,f.support.doesNotAddBorder&&(!!f.support.doesAddBorderForTableAndCells||!!cw.test(b.nodeName))&&(l+=parseFloat(c.borderTopWidth)||0,m+=parseFloat(c.borderLeftWidth)||0),e=d,d=b.offsetParent),f.support.subtractsBorderForOverflowNotVisible&&c.overflow!!=="visible"&&(l+=parseFloat(c.borderTopWidth)||0,m+=parseFloat(c.borderLeftWidth)||0),k=c}if(k.position==="relative"||k.position==="static")l+=i.offsetTop,m+=i.offsetLeft;f.support.fixedPosition&&k.position==="fixed"&&(l+=Math.max(h.scrollTop,i.scrollTop),m+=Math.max(h.scrollLeft,i.scrollLeft));return{top:l,left:m}},f.offset={bodyOffset:function(a){var b=a.offsetTop,c=a.offsetLeft;f.support.doesNotIncludeMarginInBodyOffset&&(b+=parseFloat(f.css(a,"marginTop"))||0,c+=parseFloat(f.css(a,"marginLeft"))||0);return{top:b,left:c}},setOffset:function(a,b,c){var d=f.css(a,"position");d==="static"&&(a.style.position="relative");var e=f(a),g=e.offset(),h=f.css(a,"top"),i=f.css(a,"left"),j=(d==="absolute"||d==="fixed")&&f.inArray("auto",[h,i])>-1,k={},l={},m,n;j?(l=e.position(),m=l.top,n=l.left):(m=parseFloat(h)||0,n=parseFloat(i)||0),f.isFunction(b)&&(b=b.call(a,c,g)),b.top!!=null&&(k.top=b.top-g.top+m),b.left!!=null&&(k.left=b.left-g.left+n),"using"in b?b.using.call(a,k):e.css(k)}},f.fn.extend({position:function(){if(!!this[0])return null;var a=this[0],b=this.offsetParent(),c=this.offset(),d=cx.test(b[0].nodeName)?{top:0,left:0}:b.offset();c.top-=parseFloat(f.css(a,"marginTop"))||0,c.left-=parseFloat(f.css(a,"marginLeft"))||0,d.top+=parseFloat(f.css(b[0],"borderTopWidth"))||0,d.left+=parseFloat(f.css(b[0],"borderLeftWidth"))||0;return{top:c.top-d.top,left:c.left-d.left}},offsetParent:function(){return this.map(function(){var a=this.offsetParent||c.body;while(a&&!!cx.test(a.nodeName)&&f.css(a,"position")==="static")a=a.offsetParent;return a})}}),f.each(["Left","Top"],function(a,c){var d="scroll"+c;f.fn[d]=function(c){var e,g;if(c===b){e=this[0];if(!!e)return null;g=cy(e);return g?"pageXOffset"in g?g[a?"pageYOffset":"pageXOffset"]:f.support.boxModel&&g.document.documentElement[d]||g.document.body[d]:e[d]}return this.each(function(){g=cy(this),g?g.scrollTo(a?f(g).scrollLeft():c,a?c:f(g).scrollTop()):this[d]=c})}}),f.each(["Height","Width"],function(a,c){var d=c.toLowerCase();f.fn["inner"+c]=function(){var a=this[0];return a?a.style?parseFloat(f.css(a,d,"padding")):this[d]():null},f.fn["outer"+c]=function(a){var b=this[0];return b?b.style?parseFloat(f.css(b,d,a?"margin":"border")):this[d]():null},f.fn[d]=function(a){var e=this[0];if(!!e)return a==null?null:this;if(f.isFunction(a))return this.each(function(b){var c=f(this);c[d](a.call(this,b,c[d]()))});if(f.isWindow(e)){var g=e.document.documentElement["client"+c],h=e.document.body;return e.document.compatMode==="CSS1Compat"&&g||h&&h["client"+c]||g}if(e.nodeType===9)return Math.max(e.documentElement["client"+c],e.body["scroll"+c],e.documentElement["scroll"+c],e.body["offset"+c],e.documentElement["offset"+c]);if(a===b){var i=f.css(e,d),j=parseFloat(i);return f.isNumeric(j)?j:i}return this.css(d,typeof a=="string"?a:a+"px")}}),a.jQuery=a.$=f,typeof define=="function"&&define.amd&&define.amd.jQuery&&define("jquery",[],function(){return f})})(window);'! !

!ScwResources methodsFor: 'uploaded' stamp: 'StuartHerring 2/26/2012 10:14'!
jQueryUiJs
	^ '/*!!
 * jQuery UI 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI
 */(function(a,b){function d(b){return!!a(b).parents().andSelf().filter(function(){return a.curCSS(this,"visibility")==="hidden"||a.expr.filters.hidden(this)}).length}function c(b,c){var e=b.nodeName.toLowerCase();if("area"===e){var f=b.parentNode,g=f.name,h;if(!!b.href||!!g||f.nodeName.toLowerCase()!!=="map")return!!1;h=a("img[usemap=#"+g+"]")[0];return!!!!h&&d(h)}return(/input|select|textarea|button|object/.test(e)?!!b.disabled:"a"==e?b.href||c:c)&&d(b)}a.ui=a.ui||{};a.ui.version||(a.extend(a.ui,{version:"1.8.18",keyCode:{ALT:18,BACKSPACE:8,CAPS_LOCK:20,COMMA:188,COMMAND:91,COMMAND_LEFT:91,COMMAND_RIGHT:93,CONTROL:17,DELETE:46,DOWN:40,END:35,ENTER:13,ESCAPE:27,HOME:36,INSERT:45,LEFT:37,MENU:93,NUMPAD_ADD:107,NUMPAD_DECIMAL:110,NUMPAD_DIVIDE:111,NUMPAD_ENTER:108,NUMPAD_MULTIPLY:106,NUMPAD_SUBTRACT:109,PAGE_DOWN:34,PAGE_UP:33,PERIOD:190,RIGHT:39,SHIFT:16,SPACE:32,TAB:9,UP:38,WINDOWS:91}}),a.fn.extend({propAttr:a.fn.prop||a.fn.attr,_focus:a.fn.focus,focus:function(b,c){return typeof b=="number"?this.each(function(){var d=this;setTimeout(function(){a(d).focus(),c&&c.call(d)},b)}):this._focus.apply(this,arguments)},scrollParent:function(){var b;a.browser.msie&&/(static|relative)/.test(this.css("position"))||/absolute/.test(this.css("position"))?b=this.parents().filter(function(){return/(relative|absolute|fixed)/.test(a.curCSS(this,"position",1))&&/(auto|scroll)/.test(a.curCSS(this,"overflow",1)+a.curCSS(this,"overflow-y",1)+a.curCSS(this,"overflow-x",1))}).eq(0):b=this.parents().filter(function(){return/(auto|scroll)/.test(a.curCSS(this,"overflow",1)+a.curCSS(this,"overflow-y",1)+a.curCSS(this,"overflow-x",1))}).eq(0);return/fixed/.test(this.css("position"))||!!b.length?a(document):b},zIndex:function(c){if(c!!==b)return this.css("zIndex",c);if(this.length){var d=a(this[0]),e,f;while(d.length&&d[0]!!==document){e=d.css("position");if(e==="absolute"||e==="relative"||e==="fixed"){f=parseInt(d.css("zIndex"),10);if(!!isNaN(f)&&f!!==0)return f}d=d.parent()}}return 0},disableSelection:function(){return this.bind((a.support.selectstart?"selectstart":"mousedown")+".ui-disableSelection",function(a){a.preventDefault()})},enableSelection:function(){return this.unbind(".ui-disableSelection")}}),a.each(["Width","Height"],function(c,d){function h(b,c,d,f){a.each(e,function(){c-=parseFloat(a.curCSS(b,"padding"+this,!!0))||0,d&&(c-=parseFloat(a.curCSS(b,"border"+this+"Width",!!0))||0),f&&(c-=parseFloat(a.curCSS(b,"margin"+this,!!0))||0)});return c}var e=d==="Width"?["Left","Right"]:["Top","Bottom"],f=d.toLowerCase(),g={innerWidth:a.fn.innerWidth,innerHeight:a.fn.innerHeight,outerWidth:a.fn.outerWidth,outerHeight:a.fn.outerHeight};a.fn["inner"+d]=function(c){if(c===b)return g["inner"+d].call(this);return this.each(function(){a(this).css(f,h(this,c)+"px")})},a.fn["outer"+d]=function(b,c){if(typeof b!!="number")return g["outer"+d].call(this,b);return this.each(function(){a(this).css(f,h(this,b,!!0,c)+"px")})}}),a.extend(a.expr[":"],{data:function(b,c,d){return!!!!a.data(b,d[3])},focusable:function(b){return c(b,!!isNaN(a.attr(b,"tabindex")))},tabbable:function(b){var d=a.attr(b,"tabindex"),e=isNaN(d);return(e||d>=0)&&c(b,!!e)}}),a(function(){var b=document.body,c=b.appendChild(c=document.createElement("div"));c.offsetHeight,a.extend(c.style,{minHeight:"100px",height:"auto",padding:0,borderWidth:0}),a.support.minHeight=c.offsetHeight===100,a.support.selectstart="onselectstart"in c,b.removeChild(c).style.display="none"}),a.extend(a.ui,{plugin:{add:function(b,c,d){var e=a.ui[b].prototype;for(var f in d)e.plugins[f]=e.plugins[f]||[],e.plugins[f].push([c,d[f]])},call:function(a,b,c){var d=a.plugins[b];if(!!!!d&&!!!!a.element[0].parentNode)for(var e=0;e<d.length;e++)a.options[d[e][0]]&&d[e][1].apply(a.element,c)}},contains:function(a,b){return document.compareDocumentPosition?a.compareDocumentPosition(b)&16:a!!==b&&a.contains(b)},hasScroll:function(b,c){if(a(b).css("overflow")==="hidden")return!!1;var d=c&&c==="left"?"scrollLeft":"scrollTop",e=!!1;if(b[d]>0)return!!0;b[d]=1,e=b[d]>0,b[d]=0;return e},isOverAxis:function(a,b,c){return a>b&&a<b+c},isOver:function(b,c,d,e,f,g){return a.ui.isOverAxis(b,d,f)&&a.ui.isOverAxis(c,e,g)}}))})(jQuery);/*!!
 * jQuery UI Widget 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Widget
 */(function(a,b){if(a.cleanData){var c=a.cleanData;a.cleanData=function(b){for(var d=0,e;(e=b[d])!!=null;d++)try{a(e).triggerHandler("remove")}catch(f){}c(b)}}else{var d=a.fn.remove;a.fn.remove=function(b,c){return this.each(function(){c||(!!b||a.filter(b,[this]).length)&&a("*",this).add([this]).each(function(){try{a(this).triggerHandler("remove")}catch(b){}});return d.call(a(this),b,c)})}}a.widget=function(b,c,d){var e=b.split(".")[0],f;b=b.split(".")[1],f=e+"-"+b,d||(d=c,c=a.Widget),a.expr[":"][f]=function(c){return!!!!a.data(c,b)},a[e]=a[e]||{},a[e][b]=function(a,b){arguments.length&&this._createWidget(a,b)};var g=new c;g.options=a.extend(!!0,{},g.options),a[e][b].prototype=a.extend(!!0,g,{namespace:e,widgetName:b,widgetEventPrefix:a[e][b].prototype.widgetEventPrefix||b,widgetBaseClass:f},d),a.widget.bridge(b,a[e][b])},a.widget.bridge=function(c,d){a.fn[c]=function(e){var f=typeof e=="string",g=Array.prototype.slice.call(arguments,1),h=this;e=!!f&&g.length?a.extend.apply(null,[!!0,e].concat(g)):e;if(f&&e.charAt(0)==="_")return h;f?this.each(function(){var d=a.data(this,c),f=d&&a.isFunction(d[e])?d[e].apply(d,g):d;if(f!!==d&&f!!==b){h=f;return!!1}}):this.each(function(){var b=a.data(this,c);b?b.option(e||{})._init():a.data(this,c,new d(e,this))});return h}},a.Widget=function(a,b){arguments.length&&this._createWidget(a,b)},a.Widget.prototype={widgetName:"widget",widgetEventPrefix:"",options:{disabled:!!1},_createWidget:function(b,c){a.data(c,this.widgetName,this),this.element=a(c),this.options=a.extend(!!0,{},this.options,this._getCreateOptions(),b);var d=this;this.element.bind("remove."+this.widgetName,function(){d.destroy()}),this._create(),this._trigger("create"),this._init()},_getCreateOptions:function(){return a.metadata&&a.metadata.get(this.element[0])[this.widgetName]},_create:function(){},_init:function(){},destroy:function(){this.element.unbind("."+this.widgetName).removeData(this.widgetName),this.widget().unbind("."+this.widgetName).removeAttr("aria-disabled").removeClass(this.widgetBaseClass+"-disabled "+"ui-state-disabled")},widget:function(){return this.element},option:function(c,d){var e=c;if(arguments.length===0)return a.extend({},this.options);if(typeof c=="string"){if(d===b)return this.options[c];e={},e[c]=d}this._setOptions(e);return this},_setOptions:function(b){var c=this;a.each(b,function(a,b){c._setOption(a,b)});return this},_setOption:function(a,b){this.options[a]=b,a==="disabled"&&this.widget()[b?"addClass":"removeClass"](this.widgetBaseClass+"-disabled"+" "+"ui-state-disabled").attr("aria-disabled",b);return this},enable:function(){return this._setOption("disabled",!!1)},disable:function(){return this._setOption("disabled",!!0)},_trigger:function(b,c,d){var e,f,g=this.options[b];d=d||{},c=a.Event(c),c.type=(b===this.widgetEventPrefix?b:this.widgetEventPrefix+b).toLowerCase(),c.target=this.element[0],f=c.originalEvent;if(f)for(e in f)e in c||(c[e]=f[e]);this.element.trigger(c,d);return!!(a.isFunction(g)&&g.call(this.element[0],c,d)===!!1||c.isDefaultPrevented())}}})(jQuery);/*!!
 * jQuery UI Mouse 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Mouse
 *
 * Depends:
 *	jquery.ui.widget.js
 */(function(a,b){var c=!!1;a(document).mouseup(function(a){c=!!1}),a.widget("ui.mouse",{options:{cancel:":input,option",distance:1,delay:0},_mouseInit:function(){var b=this;this.element.bind("mousedown."+this.widgetName,function(a){return b._mouseDown(a)}).bind("click."+this.widgetName,function(c){if(!!0===a.data(c.target,b.widgetName+".preventClickEvent")){a.removeData(c.target,b.widgetName+".preventClickEvent"),c.stopImmediatePropagation();return!!1}}),this.started=!!1},_mouseDestroy:function(){this.element.unbind("."+this.widgetName)},_mouseDown:function(b){if(!!c){this._mouseStarted&&this._mouseUp(b),this._mouseDownEvent=b;var d=this,e=b.which==1,f=typeof this.options.cancel=="string"&&b.target.nodeName?a(b.target).closest(this.options.cancel).length:!!1;if(!!e||f||!!this._mouseCapture(b))return!!0;this.mouseDelayMet=!!this.options.delay,this.mouseDelayMet||(this._mouseDelayTimer=setTimeout(function(){d.mouseDelayMet=!!0},this.options.delay));if(this._mouseDistanceMet(b)&&this._mouseDelayMet(b)){this._mouseStarted=this._mouseStart(b)!!==!!1;if(!!this._mouseStarted){b.preventDefault();return!!0}}!!0===a.data(b.target,this.widgetName+".preventClickEvent")&&a.removeData(b.target,this.widgetName+".preventClickEvent"),this._mouseMoveDelegate=function(a){return d._mouseMove(a)},this._mouseUpDelegate=function(a){return d._mouseUp(a)},a(document).bind("mousemove."+this.widgetName,this._mouseMoveDelegate).bind("mouseup."+this.widgetName,this._mouseUpDelegate),b.preventDefault(),c=!!0;return!!0}},_mouseMove:function(b){if(a.browser.msie&&!!(document.documentMode>=9)&&!!b.button)return this._mouseUp(b);if(this._mouseStarted){this._mouseDrag(b);return b.preventDefault()}this._mouseDistanceMet(b)&&this._mouseDelayMet(b)&&(this._mouseStarted=this._mouseStart(this._mouseDownEvent,b)!!==!!1,this._mouseStarted?this._mouseDrag(b):this._mouseUp(b));return!!this._mouseStarted},_mouseUp:function(b){a(document).unbind("mousemove."+this.widgetName,this._mouseMoveDelegate).unbind("mouseup."+this.widgetName,this._mouseUpDelegate),this._mouseStarted&&(this._mouseStarted=!!1,b.target==this._mouseDownEvent.target&&a.data(b.target,this.widgetName+".preventClickEvent",!!0),this._mouseStop(b));return!!1},_mouseDistanceMet:function(a){return Math.max(Math.abs(this._mouseDownEvent.pageX-a.pageX),Math.abs(this._mouseDownEvent.pageY-a.pageY))>=this.options.distance},_mouseDelayMet:function(a){return this.mouseDelayMet},_mouseStart:function(a){},_mouseDrag:function(a){},_mouseStop:function(a){},_mouseCapture:function(a){return!!0}})})(jQuery);/*
 * jQuery UI Position 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Position
 */(function(a,b){a.ui=a.ui||{};var c=/left|center|right/,d=/top|center|bottom/,e="center",f={},g=a.fn.position,h=a.fn.offset;a.fn.position=function(b){if(!!b||!!b.of)return g.apply(this,arguments);b=a.extend({},b);var h=a(b.of),i=h[0],j=(b.collision||"flip").split(" "),k=b.offset?b.offset.split(" "):[0,0],l,m,n;i.nodeType===9?(l=h.width(),m=h.height(),n={top:0,left:0}):i.setTimeout?(l=h.width(),m=h.height(),n={top:h.scrollTop(),left:h.scrollLeft()}):i.preventDefault?(b.at="left top",l=m=0,n={top:b.of.pageY,left:b.of.pageX}):(l=h.outerWidth(),m=h.outerHeight(),n=h.offset()),a.each(["my","at"],function(){var a=(b[this]||"").split(" ");a.length===1&&(a=c.test(a[0])?a.concat([e]):d.test(a[0])?[e].concat(a):[e,e]),a[0]=c.test(a[0])?a[0]:e,a[1]=d.test(a[1])?a[1]:e,b[this]=a}),j.length===1&&(j[1]=j[0]),k[0]=parseInt(k[0],10)||0,k.length===1&&(k[1]=k[0]),k[1]=parseInt(k[1],10)||0,b.at[0]==="right"?n.left+=l:b.at[0]===e&&(n.left+=l/2),b.at[1]==="bottom"?n.top+=m:b.at[1]===e&&(n.top+=m/2),n.left+=k[0],n.top+=k[1];return this.each(function(){var c=a(this),d=c.outerWidth(),g=c.outerHeight(),h=parseInt(a.curCSS(this,"marginLeft",!!0))||0,i=parseInt(a.curCSS(this,"marginTop",!!0))||0,o=d+h+(parseInt(a.curCSS(this,"marginRight",!!0))||0),p=g+i+(parseInt(a.curCSS(this,"marginBottom",!!0))||0),q=a.extend({},n),r;b.my[0]==="right"?q.left-=d:b.my[0]===e&&(q.left-=d/2),b.my[1]==="bottom"?q.top-=g:b.my[1]===e&&(q.top-=g/2),f.fractions||(q.left=Math.round(q.left),q.top=Math.round(q.top)),r={left:q.left-h,top:q.top-i},a.each(["left","top"],function(c,e){a.ui.position[j[c]]&&a.ui.position[j[c]][e](q,{targetWidth:l,targetHeight:m,elemWidth:d,elemHeight:g,collisionPosition:r,collisionWidth:o,collisionHeight:p,offset:k,my:b.my,at:b.at})}),a.fn.bgiframe&&c.bgiframe(),c.offset(a.extend(q,{using:b.using}))})},a.ui.position={fit:{left:function(b,c){var d=a(window),e=c.collisionPosition.left+c.collisionWidth-d.width()-d.scrollLeft();b.left=e>0?b.left-e:Math.max(b.left-c.collisionPosition.left,b.left)},top:function(b,c){var d=a(window),e=c.collisionPosition.top+c.collisionHeight-d.height()-d.scrollTop();b.top=e>0?b.top-e:Math.max(b.top-c.collisionPosition.top,b.top)}},flip:{left:function(b,c){if(c.at[0]!!==e){var d=a(window),f=c.collisionPosition.left+c.collisionWidth-d.width()-d.scrollLeft(),g=c.my[0]==="left"?-c.elemWidth:c.my[0]==="right"?c.elemWidth:0,h=c.at[0]==="left"?c.targetWidth:-c.targetWidth,i=-2*c.offset[0];b.left+=c.collisionPosition.left<0?g+h+i:f>0?g+h+i:0}},top:function(b,c){if(c.at[1]!!==e){var d=a(window),f=c.collisionPosition.top+c.collisionHeight-d.height()-d.scrollTop(),g=c.my[1]==="top"?-c.elemHeight:c.my[1]==="bottom"?c.elemHeight:0,h=c.at[1]==="top"?c.targetHeight:-c.targetHeight,i=-2*c.offset[1];b.top+=c.collisionPosition.top<0?g+h+i:f>0?g+h+i:0}}}},a.offset.setOffset||(a.offset.setOffset=function(b,c){/static/.test(a.curCSS(b,"position"))&&(b.style.position="relative");var d=a(b),e=d.offset(),f=parseInt(a.curCSS(b,"top",!!0),10)||0,g=parseInt(a.curCSS(b,"left",!!0),10)||0,h={top:c.top-e.top+f,left:c.left-e.left+g};"using"in c?c.using.call(b,h):d.css(h)},a.fn.offset=function(b){var c=this[0];if(!!c||!!c.ownerDocument)return null;if(b)return this.each(function(){a.offset.setOffset(this,b)});return h.call(this)}),function(){var b=document.getElementsByTagName("body")[0],c=document.createElement("div"),d,e,g,h,i;d=document.createElement(b?"div":"body"),g={visibility:"hidden",width:0,height:0,border:0,margin:0,background:"none"},b&&a.extend(g,{position:"absolute",left:"-1000px",top:"-1000px"});for(var j in g)d.style[j]=g[j];d.appendChild(c),e=b||document.documentElement,e.insertBefore(d,e.firstChild),c.style.cssText="position: absolute; left: 10.7432222px; top: 10.432325px; height: 30px; width: 201px;",h=a(c).offset(function(a,b){return b}).offset(),d.innerHTML="",e.removeChild(d),i=h.top+h.left+(b?2e3:0),f.fractions=i>21&&i<22}()})(jQuery);/*
 * jQuery UI Draggable 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Draggables
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.mouse.js
 *	jquery.ui.widget.js
 */(function(a,b){a.widget("ui.draggable",a.ui.mouse,{widgetEventPrefix:"drag",options:{addClasses:!!0,appendTo:"parent",axis:!!1,connectToSortable:!!1,containment:!!1,cursor:"auto",cursorAt:!!1,grid:!!1,handle:!!1,helper:"original",iframeFix:!!1,opacity:!!1,refreshPositions:!!1,revert:!!1,revertDuration:500,scope:"default",scroll:!!0,scrollSensitivity:20,scrollSpeed:20,snap:!!1,snapMode:"both",snapTolerance:20,stack:!!1,zIndex:!!1},_create:function(){this.options.helper=="original"&&!!/^(?:r|a|f)/.test(this.element.css("position"))&&(this.element[0].style.position="relative"),this.options.addClasses&&this.element.addClass("ui-draggable"),this.options.disabled&&this.element.addClass("ui-draggable-disabled"),this._mouseInit()},destroy:function(){if(!!!!this.element.data("draggable")){this.element.removeData("draggable").unbind(".draggable").removeClass("ui-draggable ui-draggable-dragging ui-draggable-disabled"),this._mouseDestroy();return this}},_mouseCapture:function(b){var c=this.options;if(this.helper||c.disabled||a(b.target).is(".ui-resizable-handle"))return!!1;this.handle=this._getHandle(b);if(!!this.handle)return!!1;c.iframeFix&&a(c.iframeFix===!!0?"iframe":c.iframeFix).each(function(){a(''<div class="ui-draggable-iframeFix" style="background: #fff;"></div>'').css({width:this.offsetWidth+"px",height:this.offsetHeight+"px",position:"absolute",opacity:"0.001",zIndex:1e3}).css(a(this).offset()).appendTo("body")});return!!0},_mouseStart:function(b){var c=this.options;this.helper=this._createHelper(b),this._cacheHelperProportions(),a.ui.ddmanager&&(a.ui.ddmanager.current=this),this._cacheMargins(),this.cssPosition=this.helper.css("position"),this.scrollParent=this.helper.scrollParent(),this.offset=this.positionAbs=this.element.offset(),this.offset={top:this.offset.top-this.margins.top,left:this.offset.left-this.margins.left},a.extend(this.offset,{click:{left:b.pageX-this.offset.left,top:b.pageY-this.offset.top},parent:this._getParentOffset(),relative:this._getRelativeOffset()}),this.originalPosition=this.position=this._generatePosition(b),this.originalPageX=b.pageX,this.originalPageY=b.pageY,c.cursorAt&&this._adjustOffsetFromHelper(c.cursorAt),c.containment&&this._setContainment();if(this._trigger("start",b)===!!1){this._clear();return!!1}this._cacheHelperProportions(),a.ui.ddmanager&&!!c.dropBehaviour&&a.ui.ddmanager.prepareOffsets(this,b),this.helper.addClass("ui-draggable-dragging"),this._mouseDrag(b,!!0),a.ui.ddmanager&&a.ui.ddmanager.dragStart(this,b);return!!0},_mouseDrag:function(b,c){this.position=this._generatePosition(b),this.positionAbs=this._convertPositionTo("absolute");if(!!c){var d=this._uiHash();if(this._trigger("drag",b,d)===!!1){this._mouseUp({});return!!1}this.position=d.position}if(!!this.options.axis||this.options.axis!!="y")this.helper[0].style.left=this.position.left+"px";if(!!this.options.axis||this.options.axis!!="x")this.helper[0].style.top=this.position.top+"px";a.ui.ddmanager&&a.ui.ddmanager.drag(this,b);return!!1},_mouseStop:function(b){var c=!!1;a.ui.ddmanager&&!!this.options.dropBehaviour&&(c=a.ui.ddmanager.drop(this,b)),this.dropped&&(c=this.dropped,this.dropped=!!1);if((!!this.element[0]||!!this.element[0].parentNode)&&this.options.helper=="original")return!!1;if(this.options.revert=="invalid"&&!!c||this.options.revert=="valid"&&c||this.options.revert===!!0||a.isFunction(this.options.revert)&&this.options.revert.call(this.element,c)){var d=this;a(this.helper).animate(this.originalPosition,parseInt(this.options.revertDuration,10),function(){d._trigger("stop",b)!!==!!1&&d._clear()})}else this._trigger("stop",b)!!==!!1&&this._clear();return!!1},_mouseUp:function(b){this.options.iframeFix===!!0&&a("div.ui-draggable-iframeFix").each(function(){this.parentNode.removeChild(this)}),a.ui.ddmanager&&a.ui.ddmanager.dragStop(this,b);return a.ui.mouse.prototype._mouseUp.call(this,b)},cancel:function(){this.helper.is(".ui-draggable-dragging")?this._mouseUp({}):this._clear();return this},_getHandle:function(b){var c=!!this.options.handle||!!a(this.options.handle,this.element).length?!!0:!!1;a(this.options.handle,this.element).find("*").andSelf().each(function(){this==b.target&&(c=!!0)});return c},_createHelper:function(b){var c=this.options,d=a.isFunction(c.helper)?a(c.helper.apply(this.element[0],[b])):c.helper=="clone"?this.element.clone().removeAttr("id"):this.element;d.parents("body").length||d.appendTo(c.appendTo=="parent"?this.element[0].parentNode:c.appendTo),d[0]!!=this.element[0]&&!!/(fixed|absolute)/.test(d.css("position"))&&d.css("position","absolute");return d},_adjustOffsetFromHelper:function(b){typeof b=="string"&&(b=b.split(" ")),a.isArray(b)&&(b={left:+b[0],top:+b[1]||0}),"left"in b&&(this.offset.click.left=b.left+this.margins.left),"right"in b&&(this.offset.click.left=this.helperProportions.width-b.right+this.margins.left),"top"in b&&(this.offset.click.top=b.top+this.margins.top),"bottom"in b&&(this.offset.click.top=this.helperProportions.height-b.bottom+this.margins.top)},_getParentOffset:function(){this.offsetParent=this.helper.offsetParent();var b=this.offsetParent.offset();this.cssPosition=="absolute"&&this.scrollParent[0]!!=document&&a.ui.contains(this.scrollParent[0],this.offsetParent[0])&&(b.left+=this.scrollParent.scrollLeft(),b.top+=this.scrollParent.scrollTop());if(this.offsetParent[0]==document.body||this.offsetParent[0].tagName&&this.offsetParent[0].tagName.toLowerCase()=="html"&&a.browser.msie)b={top:0,left:0};return{top:b.top+(parseInt(this.offsetParent.css("borderTopWidth"),10)||0),left:b.left+(parseInt(this.offsetParent.css("borderLeftWidth"),10)||0)}},_getRelativeOffset:function(){if(this.cssPosition=="relative"){var a=this.element.position();return{top:a.top-(parseInt(this.helper.css("top"),10)||0)+this.scrollParent.scrollTop(),left:a.left-(parseInt(this.helper.css("left"),10)||0)+this.scrollParent.scrollLeft()}}return{top:0,left:0}},_cacheMargins:function(){this.margins={left:parseInt(this.element.css("marginLeft"),10)||0,top:parseInt(this.element.css("marginTop"),10)||0,right:parseInt(this.element.css("marginRight"),10)||0,bottom:parseInt(this.element.css("marginBottom"),10)||0}},_cacheHelperProportions:function(){this.helperProportions={width:this.helper.outerWidth(),height:this.helper.outerHeight()}},_setContainment:function(){var b=this.options;b.containment=="parent"&&(b.containment=this.helper[0].parentNode);if(b.containment=="document"||b.containment=="window")this.containment=[b.containment=="document"?0:a(window).scrollLeft()-this.offset.relative.left-this.offset.parent.left,b.containment=="document"?0:a(window).scrollTop()-this.offset.relative.top-this.offset.parent.top,(b.containment=="document"?0:a(window).scrollLeft())+a(b.containment=="document"?document:window).width()-this.helperProportions.width-this.margins.left,(b.containment=="document"?0:a(window).scrollTop())+(a(b.containment=="document"?document:window).height()||document.body.parentNode.scrollHeight)-this.helperProportions.height-this.margins.top];if(!!/^(document|window|parent)$/.test(b.containment)&&b.containment.constructor!!=Array){var c=a(b.containment),d=c[0];if(!!d)return;var e=c.offset(),f=a(d).css("overflow")!!="hidden";this.containment=[(parseInt(a(d).css("borderLeftWidth"),10)||0)+(parseInt(a(d).css("paddingLeft"),10)||0),(parseInt(a(d).css("borderTopWidth"),10)||0)+(parseInt(a(d).css("paddingTop"),10)||0),(f?Math.max(d.scrollWidth,d.offsetWidth):d.offsetWidth)-(parseInt(a(d).css("borderLeftWidth"),10)||0)-(parseInt(a(d).css("paddingRight"),10)||0)-this.helperProportions.width-this.margins.left-this.margins.right,(f?Math.max(d.scrollHeight,d.offsetHeight):d.offsetHeight)-(parseInt(a(d).css("borderTopWidth"),10)||0)-(parseInt(a(d).css("paddingBottom"),10)||0)-this.helperProportions.height-this.margins.top-this.margins.bottom],this.relative_container=c}else b.containment.constructor==Array&&(this.containment=b.containment)},_convertPositionTo:function(b,c){c||(c=this.position);var d=b=="absolute"?1:-1,e=this.options,f=this.cssPosition=="absolute"&&(this.scrollParent[0]==document||!!a.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,g=/(html|body)/i.test(f[0].tagName);return{top:c.top+this.offset.relative.top*d+this.offset.parent.top*d-(a.browser.safari&&a.browser.version<526&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():g?0:f.scrollTop())*d),left:c.left+this.offset.relative.left*d+this.offset.parent.left*d-(a.browser.safari&&a.browser.version<526&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():g?0:f.scrollLeft())*d)}},_generatePosition:function(b){var c=this.options,d=this.cssPosition=="absolute"&&(this.scrollParent[0]==document||!!a.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,e=/(html|body)/i.test(d[0].tagName),f=b.pageX,g=b.pageY;if(this.originalPosition){var h;if(this.containment){if(this.relative_container){var i=this.relative_container.offset();h=[this.containment[0]+i.left,this.containment[1]+i.top,this.containment[2]+i.left,this.containment[3]+i.top]}else h=this.containment;b.pageX-this.offset.click.left<h[0]&&(f=h[0]+this.offset.click.left),b.pageY-this.offset.click.top<h[1]&&(g=h[1]+this.offset.click.top),b.pageX-this.offset.click.left>h[2]&&(f=h[2]+this.offset.click.left),b.pageY-this.offset.click.top>h[3]&&(g=h[3]+this.offset.click.top)}if(c.grid){var j=c.grid[1]?this.originalPageY+Math.round((g-this.originalPageY)/c.grid[1])*c.grid[1]:this.originalPageY;g=h?j-this.offset.click.top<h[1]||j-this.offset.click.top>h[3]?j-this.offset.click.top<h[1]?j+c.grid[1]:j-c.grid[1]:j:j;var k=c.grid[0]?this.originalPageX+Math.round((f-this.originalPageX)/c.grid[0])*c.grid[0]:this.originalPageX;f=h?k-this.offset.click.left<h[0]||k-this.offset.click.left>h[2]?k-this.offset.click.left<h[0]?k+c.grid[0]:k-c.grid[0]:k:k}}return{top:g-this.offset.click.top-this.offset.relative.top-this.offset.parent.top+(a.browser.safari&&a.browser.version<526&&this.cssPosition=="fixed"?0:this.cssPosition=="fixed"?-this.scrollParent.scrollTop():e?0:d.scrollTop()),left:f-this.offset.click.left-this.offset.relative.left-this.offset.parent.left+(a.browser.safari&&a.browser.version<526&&this.cssPosition=="fixed"?0:this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():e?0:d.scrollLeft())}},_clear:function(){this.helper.removeClass("ui-draggable-dragging"),this.helper[0]!!=this.element[0]&&!!this.cancelHelperRemoval&&this.helper.remove(),this.helper=null,this.cancelHelperRemoval=!!1},_trigger:function(b,c,d){d=d||this._uiHash(),a.ui.plugin.call(this,b,[c,d]),b=="drag"&&(this.positionAbs=this._convertPositionTo("absolute"));return a.Widget.prototype._trigger.call(this,b,c,d)},plugins:{},_uiHash:function(a){return{helper:this.helper,position:this.position,originalPosition:this.originalPosition,offset:this.positionAbs}}}),a.extend(a.ui.draggable,{version:"1.8.18"}),a.ui.plugin.add("draggable","connectToSortable",{start:function(b,c){var d=a(this).data("draggable"),e=d.options,f=a.extend({},c,{item:d.element});d.sortables=[],a(e.connectToSortable).each(function(){var c=a.data(this,"sortable");c&&!!c.options.disabled&&(d.sortables.push({instance:c,shouldRevert:c.options.revert}),c.refreshPositions(),c._trigger("activate",b,f))})},stop:function(b,c){var d=a(this).data("draggable"),e=a.extend({},c,{item:d.element});a.each(d.sortables,function(){this.instance.isOver?(this.instance.isOver=0,d.cancelHelperRemoval=!!0,this.instance.cancelHelperRemoval=!!1,this.shouldRevert&&(this.instance.options.revert=!!0),this.instance._mouseStop(b),this.instance.options.helper=this.instance.options._helper,d.options.helper=="original"&&this.instance.currentItem.css({top:"auto",left:"auto"})):(this.instance.cancelHelperRemoval=!!1,this.instance._trigger("deactivate",b,e))})},drag:function(b,c){var d=a(this).data("draggable"),e=this,f=function(b){var c=this.offset.click.top,d=this.offset.click.left,e=this.positionAbs.top,f=this.positionAbs.left,g=b.height,h=b.width,i=b.top,j=b.left;return a.ui.isOver(e+c,f+d,i,j,g,h)};a.each(d.sortables,function(f){this.instance.positionAbs=d.positionAbs,this.instance.helperProportions=d.helperProportions,this.instance.offset.click=d.offset.click,this.instance._intersectsWith(this.instance.containerCache)?(this.instance.isOver||(this.instance.isOver=1,this.instance.currentItem=a(e).clone().removeAttr("id").appendTo(this.instance.element).data("sortable-item",!!0),this.instance.options._helper=this.instance.options.helper,this.instance.options.helper=function(){return c.helper[0]},b.target=this.instance.currentItem[0],this.instance._mouseCapture(b,!!0),this.instance._mouseStart(b,!!0,!!0),this.instance.offset.click.top=d.offset.click.top,this.instance.offset.click.left=d.offset.click.left,this.instance.offset.parent.left-=d.offset.parent.left-this.instance.offset.parent.left,this.instance.offset.parent.top-=d.offset.parent.top-this.instance.offset.parent.top,d._trigger("toSortable",b),d.dropped=this.instance.element,d.currentItem=d.element,this.instance.fromOutside=d),this.instance.currentItem&&this.instance._mouseDrag(b)):this.instance.isOver&&(this.instance.isOver=0,this.instance.cancelHelperRemoval=!!0,this.instance.options.revert=!!1,this.instance._trigger("out",b,this.instance._uiHash(this.instance)),this.instance._mouseStop(b,!!0),this.instance.options.helper=this.instance.options._helper,this.instance.currentItem.remove(),this.instance.placeholder&&this.instance.placeholder.remove(),d._trigger("fromSortable",b),d.dropped=!!1)})}}),a.ui.plugin.add("draggable","cursor",{start:function(b,c){var d=a("body"),e=a(this).data("draggable").options;d.css("cursor")&&(e._cursor=d.css("cursor")),d.css("cursor",e.cursor)},stop:function(b,c){var d=a(this).data("draggable").options;d._cursor&&a("body").css("cursor",d._cursor)}}),a.ui.plugin.add("draggable","opacity",{start:function(b,c){var d=a(c.helper),e=a(this).data("draggable").options;d.css("opacity")&&(e._opacity=d.css("opacity")),d.css("opacity",e.opacity)},stop:function(b,c){var d=a(this).data("draggable").options;d._opacity&&a(c.helper).css("opacity",d._opacity)}}),a.ui.plugin.add("draggable","scroll",{start:function(b,c){var d=a(this).data("draggable");d.scrollParent[0]!!=document&&d.scrollParent[0].tagName!!="HTML"&&(d.overflowOffset=d.scrollParent.offset())},drag:function(b,c){var d=a(this).data("draggable"),e=d.options,f=!!1;if(d.scrollParent[0]!!=document&&d.scrollParent[0].tagName!!="HTML"){if(!!e.axis||e.axis!!="x")d.overflowOffset.top+d.scrollParent[0].offsetHeight-b.pageY<e.scrollSensitivity?d.scrollParent[0].scrollTop=f=d.scrollParent[0].scrollTop+e.scrollSpeed:b.pageY-d.overflowOffset.top<e.scrollSensitivity&&(d.scrollParent[0].scrollTop=f=d.scrollParent[0].scrollTop-e.scrollSpeed);if(!!e.axis||e.axis!!="y")d.overflowOffset.left+d.scrollParent[0].offsetWidth-b.pageX<e.scrollSensitivity?d.scrollParent[0].scrollLeft=f=d.scrollParent[0].scrollLeft+e.scrollSpeed:b.pageX-d.overflowOffset.left<e.scrollSensitivity&&(d.scrollParent[0].scrollLeft=f=d.scrollParent[0].scrollLeft-e.scrollSpeed)}else{if(!!e.axis||e.axis!!="x")b.pageY-a(document).scrollTop()<e.scrollSensitivity?f=a(document).scrollTop(a(document).scrollTop()-e.scrollSpeed):a(window).height()-(b.pageY-a(document).scrollTop())<e.scrollSensitivity&&(f=a(document).scrollTop(a(document).scrollTop()+e.scrollSpeed));if(!!e.axis||e.axis!!="y")b.pageX-a(document).scrollLeft()<e.scrollSensitivity?f=a(document).scrollLeft(a(document).scrollLeft()-e.scrollSpeed):a(window).width()-(b.pageX-a(document).scrollLeft())<e.scrollSensitivity&&(f=a(document).scrollLeft(a(document).scrollLeft()+e.scrollSpeed))}f!!==!!1&&a.ui.ddmanager&&!!e.dropBehaviour&&a.ui.ddmanager.prepareOffsets(d,b)}}),a.ui.plugin.add("draggable","snap",{start:function(b,c){var d=a(this).data("draggable"),e=d.options;d.snapElements=[],a(e.snap.constructor!!=String?e.snap.items||":data(draggable)":e.snap).each(function(){var b=a(this),c=b.offset();this!!=d.element[0]&&d.snapElements.push({item:this,width:b.outerWidth(),height:b.outerHeight(),top:c.top,left:c.left})})},drag:function(b,c){var d=a(this).data("draggable"),e=d.options,f=e.snapTolerance,g=c.offset.left,h=g+d.helperProportions.width,i=c.offset.top,j=i+d.helperProportions.height;for(var k=d.snapElements.length-1;k>=0;k--){var l=d.snapElements[k].left,m=l+d.snapElements[k].width,n=d.snapElements[k].top,o=n+d.snapElements[k].height;if(!!(l-f<g&&g<m+f&&n-f<i&&i<o+f||l-f<g&&g<m+f&&n-f<j&&j<o+f||l-f<h&&h<m+f&&n-f<i&&i<o+f||l-f<h&&h<m+f&&n-f<j&&j<o+f)){d.snapElements[k].snapping&&d.options.snap.release&&d.options.snap.release.call(d.element,b,a.extend(d._uiHash(),{snapItem:d.snapElements[k].item})),d.snapElements[k].snapping=!!1;continue}if(e.snapMode!!="inner"){var p=Math.abs(n-j)<=f,q=Math.abs(o-i)<=f,r=Math.abs(l-h)<=f,s=Math.abs(m-g)<=f;p&&(c.position.top=d._convertPositionTo("relative",{top:n-d.helperProportions.height,left:0}).top-d.margins.top),q&&(c.position.top=d._convertPositionTo("relative",{top:o,left:0}).top-d.margins.top),r&&(c.position.left=d._convertPositionTo("relative",{top:0,left:l-d.helperProportions.width}).left-d.margins.left),s&&(c.position.left=d._convertPositionTo("relative",{top:0,left:m}).left-d.margins.left)}var t=p||q||r||s;if(e.snapMode!!="outer"){var p=Math.abs(n-i)<=f,q=Math.abs(o-j)<=f,r=Math.abs(l-g)<=f,s=Math.abs(m-h)<=f;p&&(c.position.top=d._convertPositionTo("relative",{top:n,left:0}).top-d.margins.top),q&&(c.position.top=d._convertPositionTo("relative",{top:o-d.helperProportions.height,left:0}).top-d.margins.top),r&&(c.position.left=d._convertPositionTo("relative",{top:0,left:l}).left-d.margins.left),s&&(c.position.left=d._convertPositionTo("relative",{top:0,left:m-d.helperProportions.width}).left-d.margins.left)}!!d.snapElements[k].snapping&&(p||q||r||s||t)&&d.options.snap.snap&&d.options.snap.snap.call(d.element,b,a.extend(d._uiHash(),{snapItem:d.snapElements[k].item})),d.snapElements[k].snapping=p||q||r||s||t}}}),a.ui.plugin.add("draggable","stack",{start:function(b,c){var d=a(this).data("draggable").options,e=a.makeArray(a(d.stack)).sort(function(b,c){return(parseInt(a(b).css("zIndex"),10)||0)-(parseInt(a(c).css("zIndex"),10)||0)});if(!!!!e.length){var f=parseInt(e[0].style.zIndex)||0;a(e).each(function(a){this.style.zIndex=f+a}),this[0].style.zIndex=f+e.length}}}),a.ui.plugin.add("draggable","zIndex",{start:function(b,c){var d=a(c.helper),e=a(this).data("draggable").options;d.css("zIndex")&&(e._zIndex=d.css("zIndex")),d.css("zIndex",e.zIndex)},stop:function(b,c){var d=a(this).data("draggable").options;d._zIndex&&a(c.helper).css("zIndex",d._zIndex)}})})(jQuery);/*
 * jQuery UI Droppable 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Droppables
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	jquery.ui.mouse.js
 *	jquery.ui.draggable.js
 */(function(a,b){a.widget("ui.droppable",{widgetEventPrefix:"drop",options:{accept:"*",activeClass:!!1,addClasses:!!0,greedy:!!1,hoverClass:!!1,scope:"default",tolerance:"intersect"},_create:function(){var b=this.options,c=b.accept;this.isover=0,this.isout=1,this.accept=a.isFunction(c)?c:function(a){return a.is(c)},this.proportions={width:this.element[0].offsetWidth,height:this.element[0].offsetHeight},a.ui.ddmanager.droppables[b.scope]=a.ui.ddmanager.droppables[b.scope]||[],a.ui.ddmanager.droppables[b.scope].push(this),b.addClasses&&this.element.addClass("ui-droppable")},destroy:function(){var b=a.ui.ddmanager.droppables[this.options.scope];for(var c=0;c<b.length;c++)b[c]==this&&b.splice(c,1);this.element.removeClass("ui-droppable ui-droppable-disabled").removeData("droppable").unbind(".droppable");return this},_setOption:function(b,c){b=="accept"&&(this.accept=a.isFunction(c)?c:function(a){return a.is(c)}),a.Widget.prototype._setOption.apply(this,arguments)},_activate:function(b){var c=a.ui.ddmanager.current;this.options.activeClass&&this.element.addClass(this.options.activeClass),c&&this._trigger("activate",b,this.ui(c))},_deactivate:function(b){var c=a.ui.ddmanager.current;this.options.activeClass&&this.element.removeClass(this.options.activeClass),c&&this._trigger("deactivate",b,this.ui(c))},_over:function(b){var c=a.ui.ddmanager.current;!!!!c&&(c.currentItem||c.element)[0]!!=this.element[0]&&this.accept.call(this.element[0],c.currentItem||c.element)&&(this.options.hoverClass&&this.element.addClass(this.options.hoverClass),this._trigger("over",b,this.ui(c)))},_out:function(b){var c=a.ui.ddmanager.current;!!!!c&&(c.currentItem||c.element)[0]!!=this.element[0]&&this.accept.call(this.element[0],c.currentItem||c.element)&&(this.options.hoverClass&&this.element.removeClass(this.options.hoverClass),this._trigger("out",b,this.ui(c)))},_drop:function(b,c){var d=c||a.ui.ddmanager.current;if(!!d||(d.currentItem||d.element)[0]==this.element[0])return!!1;var e=!!1;this.element.find(":data(droppable)").not(".ui-draggable-dragging").each(function(){var b=a.data(this,"droppable");if(b.options.greedy&&!!b.options.disabled&&b.options.scope==d.options.scope&&b.accept.call(b.element[0],d.currentItem||d.element)&&a.ui.intersect(d,a.extend(b,{offset:b.element.offset()}),b.options.tolerance)){e=!!0;return!!1}});if(e)return!!1;if(this.accept.call(this.element[0],d.currentItem||d.element)){this.options.activeClass&&this.element.removeClass(this.options.activeClass),this.options.hoverClass&&this.element.removeClass(this.options.hoverClass),this._trigger("drop",b,this.ui(d));return this.element}return!!1},ui:function(a){return{draggable:a.currentItem||a.element,helper:a.helper,position:a.position,offset:a.positionAbs}}}),a.extend(a.ui.droppable,{version:"1.8.18"}),a.ui.intersect=function(b,c,d){if(!!c.offset)return!!1;var e=(b.positionAbs||b.position.absolute).left,f=e+b.helperProportions.width,g=(b.positionAbs||b.position.absolute).top,h=g+b.helperProportions.height,i=c.offset.left,j=i+c.proportions.width,k=c.offset.top,l=k+c.proportions.height;switch(d){case"fit":return i<=e&&f<=j&&k<=g&&h<=l;case"intersect":return i<e+b.helperProportions.width/2&&f-b.helperProportions.width/2<j&&k<g+b.helperProportions.height/2&&h-b.helperProportions.height/2<l;case"pointer":var m=(b.positionAbs||b.position.absolute).left+(b.clickOffset||b.offset.click).left,n=(b.positionAbs||b.position.absolute).top+(b.clickOffset||b.offset.click).top,o=a.ui.isOver(n,m,k,i,c.proportions.height,c.proportions.width);return o;case"touch":return(g>=k&&g<=l||h>=k&&h<=l||g<k&&h>l)&&(e>=i&&e<=j||f>=i&&f<=j||e<i&&f>j);default:return!!1}},a.ui.ddmanager={current:null,droppables:{"default":[]},prepareOffsets:function(b,c){var d=a.ui.ddmanager.droppables[b.options.scope]||[],e=c?c.type:null,f=(b.currentItem||b.element).find(":data(droppable)").andSelf();droppablesLoop:for(var g=0;g<d.length;g++){if(d[g].options.disabled||b&&!!d[g].accept.call(d[g].element[0],b.currentItem||b.element))continue;for(var h=0;h<f.length;h++)if(f[h]==d[g].element[0]){d[g].proportions.height=0;continue droppablesLoop}d[g].visible=d[g].element.css("display")!!="none";if(!!d[g].visible)continue;e=="mousedown"&&d[g]._activate.call(d[g],c),d[g].offset=d[g].element.offset(),d[g].proportions={width:d[g].element[0].offsetWidth,height:d[g].element[0].offsetHeight}}},drop:function(b,c){var d=!!1;a.each(a.ui.ddmanager.droppables[b.options.scope]||[],function(){!!this.options||(!!this.options.disabled&&this.visible&&a.ui.intersect(b,this,this.options.tolerance)&&(d=this._drop.call(this,c)||d),!!this.options.disabled&&this.visible&&this.accept.call(this.element[0],b.currentItem||b.element)&&(this.isout=1,this.isover=0,this._deactivate.call(this,c)))});return d},dragStart:function(b,c){b.element.parents(":not(body,html)").bind("scroll.droppable",function(){b.options.refreshPositions||a.ui.ddmanager.prepareOffsets(b,c)})},drag:function(b,c){b.options.refreshPositions&&a.ui.ddmanager.prepareOffsets(b,c),a.each(a.ui.ddmanager.droppables[b.options.scope]||[],function(){if(!!(this.options.disabled||this.greedyChild||!!this.visible)){var d=a.ui.intersect(b,this,this.options.tolerance),e=!!d&&this.isover==1?"isout":d&&this.isover==0?"isover":null;if(!!e)return;var f;if(this.options.greedy){var g=this.element.parents(":data(droppable):eq(0)");g.length&&(f=a.data(g[0],"droppable"),f.greedyChild=e=="isover"?1:0)}f&&e=="isover"&&(f.isover=0,f.isout=1,f._out.call(f,c)),this[e]=1,this[e=="isout"?"isover":"isout"]=0,this[e=="isover"?"_over":"_out"].call(this,c),f&&e=="isout"&&(f.isout=0,f.isover=1,f._over.call(f,c))}})},dragStop:function(b,c){b.element.parents(":not(body,html)").unbind("scroll.droppable"),b.options.refreshPositions||a.ui.ddmanager.prepareOffsets(b,c)}}})(jQuery);/*
 * jQuery UI Resizable 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Resizables
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.mouse.js
 *	jquery.ui.widget.js
 */(function(a,b){a.widget("ui.resizable",a.ui.mouse,{widgetEventPrefix:"resize",options:{alsoResize:!!1,animate:!!1,animateDuration:"slow",animateEasing:"swing",aspectRatio:!!1,autoHide:!!1,containment:!!1,ghost:!!1,grid:!!1,handles:"e,s,se",helper:!!1,maxHeight:null,maxWidth:null,minHeight:10,minWidth:10,zIndex:1e3},_create:function(){var b=this,c=this.options;this.element.addClass("ui-resizable"),a.extend(this,{_aspectRatio:!!!!c.aspectRatio,aspectRatio:c.aspectRatio,originalElement:this.element,_proportionallyResizeElements:[],_helper:c.helper||c.ghost||c.animate?c.helper||"ui-resizable-helper":null}),this.element[0].nodeName.match(/canvas|textarea|input|select|button|img/i)&&(this.element.wrap(a(''<div class="ui-wrapper" style="overflow: hidden;"></div>'').css({position:this.element.css("position"),width:this.element.outerWidth(),height:this.element.outerHeight(),top:this.element.css("top"),left:this.element.css("left")})),this.element=this.element.parent().data("resizable",this.element.data("resizable")),this.elementIsWrapper=!!0,this.element.css({marginLeft:this.originalElement.css("marginLeft"),marginTop:this.originalElement.css("marginTop"),marginRight:this.originalElement.css("marginRight"),marginBottom:this.originalElement.css("marginBottom")}),this.originalElement.css({marginLeft:0,marginTop:0,marginRight:0,marginBottom:0}),this.originalResizeStyle=this.originalElement.css("resize"),this.originalElement.css("resize","none"),this._proportionallyResizeElements.push(this.originalElement.css({position:"static",zoom:1,display:"block"})),this.originalElement.css({margin:this.originalElement.css("margin")}),this._proportionallyResize()),this.handles=c.handles||(a(".ui-resizable-handle",this.element).length?{n:".ui-resizable-n",e:".ui-resizable-e",s:".ui-resizable-s",w:".ui-resizable-w",se:".ui-resizable-se",sw:".ui-resizable-sw",ne:".ui-resizable-ne",nw:".ui-resizable-nw"}:"e,s,se");if(this.handles.constructor==String){this.handles=="all"&&(this.handles="n,e,s,w,se,sw,ne,nw");var d=this.handles.split(",");this.handles={};for(var e=0;e<d.length;e++){var f=a.trim(d[e]),g="ui-resizable-"+f,h=a(''<div class="ui-resizable-handle ''+g+''"></div>'');/sw|se|ne|nw/.test(f)&&h.css({zIndex:++c.zIndex}),"se"==f&&h.addClass("ui-icon ui-icon-gripsmall-diagonal-se"),this.handles[f]=".ui-resizable-"+f,this.element.append(h)}}this._renderAxis=function(b){b=b||this.element;for(var c in this.handles){this.handles[c].constructor==String&&(this.handles[c]=a(this.handles[c],this.element).show());if(this.elementIsWrapper&&this.originalElement[0].nodeName.match(/textarea|input|select|button/i)){var d=a(this.handles[c],this.element),e=0;e=/sw|ne|nw|se|n|s/.test(c)?d.outerHeight():d.outerWidth();var f=["padding",/ne|nw|n/.test(c)?"Top":/se|sw|s/.test(c)?"Bottom":/^e$/.test(c)?"Right":"Left"].join("");b.css(f,e),this._proportionallyResize()}if(!!a(this.handles[c]).length)continue}},this._renderAxis(this.element),this._handles=a(".ui-resizable-handle",this.element).disableSelection(),this._handles.mouseover(function(){if(!!b.resizing){if(this.className)var a=this.className.match(/ui-resizable-(se|sw|ne|nw|n|e|s|w)/i);b.axis=a&&a[1]?a[1]:"se"}}),c.autoHide&&(this._handles.hide(),a(this.element).addClass("ui-resizable-autohide").hover(function(){c.disabled||(a(this).removeClass("ui-resizable-autohide"),b._handles.show())},function(){c.disabled||b.resizing||(a(this).addClass("ui-resizable-autohide"),b._handles.hide())})),this._mouseInit()},destroy:function(){this._mouseDestroy();var b=function(b){a(b).removeClass("ui-resizable ui-resizable-disabled ui-resizable-resizing").removeData("resizable").unbind(".resizable").find(".ui-resizable-handle").remove()};if(this.elementIsWrapper){b(this.element);var c=this.element;c.after(this.originalElement.css({position:c.css("position"),width:c.outerWidth(),height:c.outerHeight(),top:c.css("top"),left:c.css("left")})).remove()}this.originalElement.css("resize",this.originalResizeStyle),b(this.originalElement);return this},_mouseCapture:function(b){var c=!!1;for(var d in this.handles)a(this.handles[d])[0]==b.target&&(c=!!0);return!!this.options.disabled&&c},_mouseStart:function(b){var d=this.options,e=this.element.position(),f=this.element;this.resizing=!!0,this.documentScroll={top:a(document).scrollTop(),left:a(document).scrollLeft()},(f.is(".ui-draggable")||/absolute/.test(f.css("position")))&&f.css({position:"absolute",top:e.top,left:e.left}),this._renderProxy();var g=c(this.helper.css("left")),h=c(this.helper.css("top"));d.containment&&(g+=a(d.containment).scrollLeft()||0,h+=a(d.containment).scrollTop()||0),this.offset=this.helper.offset(),this.position={left:g,top:h},this.size=this._helper?{width:f.outerWidth(),height:f.outerHeight()}:{width:f.width(),height:f.height()},this.originalSize=this._helper?{width:f.outerWidth(),height:f.outerHeight()}:{width:f.width(),height:f.height()},this.originalPosition={left:g,top:h},this.sizeDiff={width:f.outerWidth()-f.width(),height:f.outerHeight()-f.height()},this.originalMousePosition={left:b.pageX,top:b.pageY},this.aspectRatio=typeof d.aspectRatio=="number"?d.aspectRatio:this.originalSize.width/this.originalSize.height||1;var i=a(".ui-resizable-"+this.axis).css("cursor");a("body").css("cursor",i=="auto"?this.axis+"-resize":i),f.addClass("ui-resizable-resizing"),this._propagate("start",b);return!!0},_mouseDrag:function(b){var c=this.helper,d=this.options,e={},f=this,g=this.originalMousePosition,h=this.axis,i=b.pageX-g.left||0,j=b.pageY-g.top||0,k=this._change[h];if(!!k)return!!1;var l=k.apply(this,[b,i,j]),m=a.browser.msie&&a.browser.version<7,n=this.sizeDiff;this._updateVirtualBoundaries(b.shiftKey);if(this._aspectRatio||b.shiftKey)l=this._updateRatio(l,b);l=this._respectSize(l,b),this._propagate("resize",b),c.css({top:this.position.top+"px",left:this.position.left+"px",width:this.size.width+"px",height:this.size.height+"px"}),!!this._helper&&this._proportionallyResizeElements.length&&this._proportionallyResize(),this._updateCache(l),this._trigger("resize",b,this.ui());return!!1},_mouseStop:function(b){this.resizing=!!1;var c=this.options,d=this;if(this._helper){var e=this._proportionallyResizeElements,f=e.length&&/textarea/i.test(e[0].nodeName),g=f&&a.ui.hasScroll(e[0],"left")?0:d.sizeDiff.height,h=f?0:d.sizeDiff.width,i={width:d.helper.width()-h,height:d.helper.height()-g},j=parseInt(d.element.css("left"),10)+(d.position.left-d.originalPosition.left)||null,k=parseInt(d.element.css("top"),10)+(d.position.top-d.originalPosition.top)||null;c.animate||this.element.css(a.extend(i,{top:k,left:j})),d.helper.height(d.size.height),d.helper.width(d.size.width),this._helper&&!!c.animate&&this._proportionallyResize()}a("body").css("cursor","auto"),this.element.removeClass("ui-resizable-resizing"),this._propagate("stop",b),this._helper&&this.helper.remove();return!!1},_updateVirtualBoundaries:function(a){var b=this.options,c,e,f,g,h;h={minWidth:d(b.minWidth)?b.minWidth:0,maxWidth:d(b.maxWidth)?b.maxWidth:Infinity,minHeight:d(b.minHeight)?b.minHeight:0,maxHeight:d(b.maxHeight)?b.maxHeight:Infinity};if(this._aspectRatio||a)c=h.minHeight*this.aspectRatio,f=h.minWidth/this.aspectRatio,e=h.maxHeight*this.aspectRatio,g=h.maxWidth/this.aspectRatio,c>h.minWidth&&(h.minWidth=c),f>h.minHeight&&(h.minHeight=f),e<h.maxWidth&&(h.maxWidth=e),g<h.maxHeight&&(h.maxHeight=g);this._vBoundaries=h},_updateCache:function(a){var b=this.options;this.offset=this.helper.offset(),d(a.left)&&(this.position.left=a.left),d(a.top)&&(this.position.top=a.top),d(a.height)&&(this.size.height=a.height),d(a.width)&&(this.size.width=a.width)},_updateRatio:function(a,b){var c=this.options,e=this.position,f=this.size,g=this.axis;d(a.height)?a.width=a.height*this.aspectRatio:d(a.width)&&(a.height=a.width/this.aspectRatio),g=="sw"&&(a.left=e.left+(f.width-a.width),a.top=null),g=="nw"&&(a.top=e.top+(f.height-a.height),a.left=e.left+(f.width-a.width));return a},_respectSize:function(a,b){var c=this.helper,e=this._vBoundaries,f=this._aspectRatio||b.shiftKey,g=this.axis,h=d(a.width)&&e.maxWidth&&e.maxWidth<a.width,i=d(a.height)&&e.maxHeight&&e.maxHeight<a.height,j=d(a.width)&&e.minWidth&&e.minWidth>a.width,k=d(a.height)&&e.minHeight&&e.minHeight>a.height;j&&(a.width=e.minWidth),k&&(a.height=e.minHeight),h&&(a.width=e.maxWidth),i&&(a.height=e.maxHeight);var l=this.originalPosition.left+this.originalSize.width,m=this.position.top+this.size.height,n=/sw|nw|w/.test(g),o=/nw|ne|n/.test(g);j&&n&&(a.left=l-e.minWidth),h&&n&&(a.left=l-e.maxWidth),k&&o&&(a.top=m-e.minHeight),i&&o&&(a.top=m-e.maxHeight);var p=!!a.width&&!!a.height;p&&!!a.left&&a.top?a.top=null:p&&!!a.top&&a.left&&(a.left=null);return a},_proportionallyResize:function(){var b=this.options;if(!!!!this._proportionallyResizeElements.length){var c=this.helper||this.element;for(var d=0;d<this._proportionallyResizeElements.length;d++){var e=this._proportionallyResizeElements[d];if(!!this.borderDif){var f=[e.css("borderTopWidth"),e.css("borderRightWidth"),e.css("borderBottomWidth"),e.css("borderLeftWidth")],g=[e.css("paddingTop"),e.css("paddingRight"),e.css("paddingBottom"),e.css("paddingLeft")];this.borderDif=a.map(f,function(a,b){var c=parseInt(a,10)||0,d=parseInt(g[b],10)||0;return c+d})}if(a.browser.msie&&(!!!!a(c).is(":hidden")||!!!!a(c).parents(":hidden").length))continue;e.css({height:c.height()-this.borderDif[0]-this.borderDif[2]||0,width:c.width()-this.borderDif[1]-this.borderDif[3]||0})}}},_renderProxy:function(){var b=this.element,c=this.options;this.elementOffset=b.offset();if(this._helper){this.helper=this.helper||a(''<div style="overflow:hidden;"></div>'');var d=a.browser.msie&&a.browser.version<7,e=d?1:0,f=d?2:-1;this.helper.addClass(this._helper).css({width:this.element.outerWidth()+f,height:this.element.outerHeight()+f,position:"absolute",left:this.elementOffset.left-e+"px",top:this.elementOffset.top-e+"px",zIndex:++c.zIndex}),this.helper.appendTo("body").disableSelection()}else this.helper=this.element},_change:{e:function(a,b,c){return{width:this.originalSize.width+b}},w:function(a,b,c){var d=this.options,e=this.originalSize,f=this.originalPosition;return{left:f.left+b,width:e.width-b}},n:function(a,b,c){var d=this.options,e=this.originalSize,f=this.originalPosition;return{top:f.top+c,height:e.height-c}},s:function(a,b,c){return{height:this.originalSize.height+c}},se:function(b,c,d){return a.extend(this._change.s.apply(this,arguments),this._change.e.apply(this,[b,c,d]))},sw:function(b,c,d){return a.extend(this._change.s.apply(this,arguments),this._change.w.apply(this,[b,c,d]))},ne:function(b,c,d){return a.extend(this._change.n.apply(this,arguments),this._change.e.apply(this,[b,c,d]))},nw:function(b,c,d){return a.extend(this._change.n.apply(this,arguments),this._change.w.apply(this,[b,c,d]))}},_propagate:function(b,c){a.ui.plugin.call(this,b,[c,this.ui()]),b!!="resize"&&this._trigger(b,c,this.ui())},plugins:{},ui:function(){return{originalElement:this.originalElement,element:this.element,helper:this.helper,position:this.position,size:this.size,originalSize:this.originalSize,originalPosition:this.originalPosition}}}),a.extend(a.ui.resizable,{version:"1.8.18"}),a.ui.plugin.add("resizable","alsoResize",{start:function(b,c){var d=a(this).data("resizable"),e=d.options,f=function(b){a(b).each(function(){var b=a(this);b.data("resizable-alsoresize",{width:parseInt(b.width(),10),height:parseInt(b.height(),10),left:parseInt(b.css("left"),10),top:parseInt(b.css("top"),10)})})};typeof e.alsoResize=="object"&&!!e.alsoResize.parentNode?e.alsoResize.length?(e.alsoResize=e.alsoResize[0],f(e.alsoResize)):a.each(e.alsoResize,function(a){f(a)}):f(e.alsoResize)},resize:function(b,c){var d=a(this).data("resizable"),e=d.options,f=d.originalSize,g=d.originalPosition,h={height:d.size.height-f.height||0,width:d.size.width-f.width||0,top:d.position.top-g.top||0,left:d.position.left-g.left||0},i=function(b,d){a(b).each(function(){var b=a(this),e=a(this).data("resizable-alsoresize"),f={},g=d&&d.length?d:b.parents(c.originalElement[0]).length?["width","height"]:["width","height","top","left"];a.each(g,function(a,b){var c=(e[b]||0)+(h[b]||0);c&&c>=0&&(f[b]=c||null)}),b.css(f)})};typeof e.alsoResize=="object"&&!!e.alsoResize.nodeType?a.each(e.alsoResize,function(a,b){i(a,b)}):i(e.alsoResize)},stop:function(b,c){a(this).removeData("resizable-alsoresize")}}),a.ui.plugin.add("resizable","animate",{stop:function(b,c){var d=a(this).data("resizable"),e=d.options,f=d._proportionallyResizeElements,g=f.length&&/textarea/i.test(f[0].nodeName),h=g&&a.ui.hasScroll(f[0],"left")?0:d.sizeDiff.height,i=g?0:d.sizeDiff.width,j={width:d.size.width-i,height:d.size.height-h},k=parseInt(d.element.css("left"),10)+(d.position.left-d.originalPosition.left)||null,l=parseInt(d.element.css("top"),10)+(d.position.top-d.originalPosition.top)||null;d.element.animate(a.extend(j,l&&k?{top:l,left:k}:{}),{duration:e.animateDuration,easing:e.animateEasing,step:function(){var c={width:parseInt(d.element.css("width"),10),height:parseInt(d.element.css("height"),10),top:parseInt(d.element.css("top"),10),left:parseInt(d.element.css("left"),10)};f&&f.length&&a(f[0]).css({width:c.width,height:c.height}),d._updateCache(c),d._propagate("resize",b)}})}}),a.ui.plugin.add("resizable","containment",{start:function(b,d){var e=a(this).data("resizable"),f=e.options,g=e.element,h=f.containment,i=h instanceof a?h.get(0):/parent/.test(h)?g.parent().get(0):h;if(!!!!i){e.containerElement=a(i);if(/document/.test(h)||h==document)e.containerOffset={left:0,top:0},e.containerPosition={left:0,top:0},e.parentData={element:a(document),left:0,top:0,width:a(document).width(),height:a(document).height()||document.body.parentNode.scrollHeight};else{var j=a(i),k=[];a(["Top","Right","Left","Bottom"]).each(function(a,b){k[a]=c(j.css("padding"+b))}),e.containerOffset=j.offset(),e.containerPosition=j.position(),e.containerSize={height:j.innerHeight()-k[3],width:j.innerWidth()-k[1]};var l=e.containerOffset,m=e.containerSize.height,n=e.containerSize.width,o=a.ui.hasScroll(i,"left")?i.scrollWidth:n,p=a.ui.hasScroll(i)?i.scrollHeight:m;e.parentData={element:i,left:l.left,top:l.top,width:o,height:p}}}},resize:function(b,c){var d=a(this).data("resizable"),e=d.options,f=d.containerSize,g=d.containerOffset,h=d.size,i=d.position,j=d._aspectRatio||b.shiftKey,k={top:0,left:0},l=d.containerElement;l[0]!!=document&&/static/.test(l.css("position"))&&(k=g),i.left<(d._helper?g.left:0)&&(d.size.width=d.size.width+(d._helper?d.position.left-g.left:d.position.left-k.left),j&&(d.size.height=d.size.width/e.aspectRatio),d.position.left=e.helper?g.left:0),i.top<(d._helper?g.top:0)&&(d.size.height=d.size.height+(d._helper?d.position.top-g.top:d.position.top),j&&(d.size.width=d.size.height*e.aspectRatio),d.position.top=d._helper?g.top:0),d.offset.left=d.parentData.left+d.position.left,d.offset.top=d.parentData.top+d.position.top;var m=Math.abs((d._helper?d.offset.left-k.left:d.offset.left-k.left)+d.sizeDiff.width),n=Math.abs((d._helper?d.offset.top-k.top:d.offset.top-g.top)+d.sizeDiff.height),o=d.containerElement.get(0)==d.element.parent().get(0),p=/relative|absolute/.test(d.containerElement.css("position"));o&&p&&(m-=d.parentData.left),m+d.size.width>=d.parentData.width&&(d.size.width=d.parentData.width-m,j&&(d.size.height=d.size.width/d.aspectRatio)),n+d.size.height>=d.parentData.height&&(d.size.height=d.parentData.height-n,j&&(d.size.width=d.size.height*d.aspectRatio))},stop:function(b,c){var d=a(this).data("resizable"),e=d.options,f=d.position,g=d.containerOffset,h=d.containerPosition,i=d.containerElement,j=a(d.helper),k=j.offset(),l=j.outerWidth()-d.sizeDiff.width,m=j.outerHeight()-d.sizeDiff.height;d._helper&&!!e.animate&&/relative/.test(i.css("position"))&&a(this).css({left:k.left-h.left-g.left,width:l,height:m}),d._helper&&!!e.animate&&/static/.test(i.css("position"))&&a(this).css({left:k.left-h.left-g.left,width:l,height:m})}}),a.ui.plugin.add("resizable","ghost",{start:function(b,c){var d=a(this).data("resizable"),e=d.options,f=d.size;d.ghost=d.originalElement.clone(),d.ghost.css({opacity:.25,display:"block",position:"relative",height:f.height,width:f.width,margin:0,left:0,top:0}).addClass("ui-resizable-ghost").addClass(typeof e.ghost=="string"?e.ghost:""),d.ghost.appendTo(d.helper)},resize:function(b,c){var d=a(this).data("resizable"),e=d.options;d.ghost&&d.ghost.css({position:"relative",height:d.size.height,width:d.size.width})},stop:function(b,c){var d=a(this).data("resizable"),e=d.options;d.ghost&&d.helper&&d.helper.get(0).removeChild(d.ghost.get(0))}}),a.ui.plugin.add("resizable","grid",{resize:function(b,c){var d=a(this).data("resizable"),e=d.options,f=d.size,g=d.originalSize,h=d.originalPosition,i=d.axis,j=e._aspectRatio||b.shiftKey;e.grid=typeof e.grid=="number"?[e.grid,e.grid]:e.grid;var k=Math.round((f.width-g.width)/(e.grid[0]||1))*(e.grid[0]||1),l=Math.round((f.height-g.height)/(e.grid[1]||1))*(e.grid[1]||1);/^(se|s|e)$/.test(i)?(d.size.width=g.width+k,d.size.height=g.height+l):/^(ne)$/.test(i)?(d.size.width=g.width+k,d.size.height=g.height+l,d.position.top=h.top-l):/^(sw)$/.test(i)?(d.size.width=g.width+k,d.size.height=g.height+l,d.position.left=h.left-k):(d.size.width=g.width+k,d.size.height=g.height+l,d.position.top=h.top-l,d.position.left=h.left-k)}});var c=function(a){return parseInt(a,10)||0},d=function(a){return!!isNaN(parseInt(a,10))}})(jQuery);/*
 * jQuery UI Selectable 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Selectables
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.mouse.js
 *	jquery.ui.widget.js
 */(function(a,b){a.widget("ui.selectable",a.ui.mouse,{options:{appendTo:"body",autoRefresh:!!0,distance:0,filter:"*",tolerance:"touch"},_create:function(){var b=this;this.element.addClass("ui-selectable"),this.dragged=!!1;var c;this.refresh=function(){c=a(b.options.filter,b.element[0]),c.addClass("ui-selectee"),c.each(function(){var b=a(this),c=b.offset();a.data(this,"selectable-item",{element:this,$element:b,left:c.left,top:c.top,right:c.left+b.outerWidth(),bottom:c.top+b.outerHeight(),startselected:!!1,selected:b.hasClass("ui-selected"),selecting:b.hasClass("ui-selecting"),unselecting:b.hasClass("ui-unselecting")})})},this.refresh(),this.selectees=c.addClass("ui-selectee"),this._mouseInit(),this.helper=a("<div class=''ui-selectable-helper''></div>")},destroy:function(){this.selectees.removeClass("ui-selectee").removeData("selectable-item"),this.element.removeClass("ui-selectable ui-selectable-disabled").removeData("selectable").unbind(".selectable"),this._mouseDestroy();return this},_mouseStart:function(b){var c=this;this.opos=[b.pageX,b.pageY];if(!!this.options.disabled){var d=this.options;this.selectees=a(d.filter,this.element[0]),this._trigger("start",b),a(d.appendTo).append(this.helper),this.helper.css({left:b.clientX,top:b.clientY,width:0,height:0}),d.autoRefresh&&this.refresh(),this.selectees.filter(".ui-selected").each(function(){var d=a.data(this,"selectable-item");d.startselected=!!0,!!b.metaKey&&!!b.ctrlKey&&(d.$element.removeClass("ui-selected"),d.selected=!!1,d.$element.addClass("ui-unselecting"),d.unselecting=!!0,c._trigger("unselecting",b,{unselecting:d.element}))}),a(b.target).parents().andSelf().each(function(){var d=a.data(this,"selectable-item");if(d){var e=!!b.metaKey&&!!b.ctrlKey||!!d.$element.hasClass("ui-selected");d.$element.removeClass(e?"ui-unselecting":"ui-selected").addClass(e?"ui-selecting":"ui-unselecting"),d.unselecting=!!e,d.selecting=e,d.selected=e,e?c._trigger("selecting",b,{selecting:d.element}):c._trigger("unselecting",b,{unselecting:d.element});return!!1}})}},_mouseDrag:function(b){var c=this;this.dragged=!!0;if(!!this.options.disabled){var d=this.options,e=this.opos[0],f=this.opos[1],g=b.pageX,h=b.pageY;if(e>g){var i=g;g=e,e=i}if(f>h){var i=h;h=f,f=i}this.helper.css({left:e,top:f,width:g-e,height:h-f}),this.selectees.each(function(){var i=a.data(this,"selectable-item");if(!!!!i&&i.element!!=c.element[0]){var j=!!1;d.tolerance=="touch"?j=!!(i.left>g||i.right<e||i.top>h||i.bottom<f):d.tolerance=="fit"&&(j=i.left>e&&i.right<g&&i.top>f&&i.bottom<h),j?(i.selected&&(i.$element.removeClass("ui-selected"),i.selected=!!1),i.unselecting&&(i.$element.removeClass("ui-unselecting"),i.unselecting=!!1),i.selecting||(i.$element.addClass("ui-selecting"),i.selecting=!!0,c._trigger("selecting",b,{selecting:i.element}))):(i.selecting&&((b.metaKey||b.ctrlKey)&&i.startselected?(i.$element.removeClass("ui-selecting"),i.selecting=!!1,i.$element.addClass("ui-selected"),i.selected=!!0):(i.$element.removeClass("ui-selecting"),i.selecting=!!1,i.startselected&&(i.$element.addClass("ui-unselecting"),i.unselecting=!!0),c._trigger("unselecting",b,{unselecting:i.element}))),i.selected&&!!b.metaKey&&!!b.ctrlKey&&!!i.startselected&&(i.$element.removeClass("ui-selected"),i.selected=!!1,i.$element.addClass("ui-unselecting"),i.unselecting=!!0,c._trigger("unselecting",b,{unselecting:i.element})))}});return!!1}},_mouseStop:function(b){var c=this;this.dragged=!!1;var d=this.options;a(".ui-unselecting",this.element[0]).each(function(){var d=a.data(this,"selectable-item");d.$element.removeClass("ui-unselecting"),d.unselecting=!!1,d.startselected=!!1,c._trigger("unselected",b,{unselected:d.element})}),a(".ui-selecting",this.element[0]).each(function(){var d=a.data(this,"selectable-item");d.$element.removeClass("ui-selecting").addClass("ui-selected"),d.selecting=!!1,d.selected=!!0,d.startselected=!!0,c._trigger("selected",b,{selected:d.element})}),this._trigger("stop",b),this.helper.remove();return!!1}}),a.extend(a.ui.selectable,{version:"1.8.18"})})(jQuery);/*
 * jQuery UI Sortable 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Sortables
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.mouse.js
 *	jquery.ui.widget.js
 */(function(a,b){a.widget("ui.sortable",a.ui.mouse,{widgetEventPrefix:"sort",ready:!!1,options:{appendTo:"parent",axis:!!1,connectWith:!!1,containment:!!1,cursor:"auto",cursorAt:!!1,dropOnEmpty:!!0,forcePlaceholderSize:!!1,forceHelperSize:!!1,grid:!!1,handle:!!1,helper:"original",items:"> *",opacity:!!1,placeholder:!!1,revert:!!1,scroll:!!0,scrollSensitivity:20,scrollSpeed:20,scope:"default",tolerance:"intersect",zIndex:1e3},_create:function(){var a=this.options;this.containerCache={},this.element.addClass("ui-sortable"),this.refresh(),this.floating=this.items.length?a.axis==="x"||/left|right/.test(this.items[0].item.css("float"))||/inline|table-cell/.test(this.items[0].item.css("display")):!!1,this.offset=this.element.offset(),this._mouseInit(),this.ready=!!0},destroy:function(){a.Widget.prototype.destroy.call(this),this.element.removeClass("ui-sortable ui-sortable-disabled"),this._mouseDestroy();for(var b=this.items.length-1;b>=0;b--)this.items[b].item.removeData(this.widgetName+"-item");return this},_setOption:function(b,c){b==="disabled"?(this.options[b]=c,this.widget()[c?"addClass":"removeClass"]("ui-sortable-disabled")):a.Widget.prototype._setOption.apply(this,arguments)},_mouseCapture:function(b,c){var d=this;if(this.reverting)return!!1;if(this.options.disabled||this.options.type=="static")return!!1;this._refreshItems(b);var e=null,f=this,g=a(b.target).parents().each(function(){if(a.data(this,d.widgetName+"-item")==f){e=a(this);return!!1}});a.data(b.target,d.widgetName+"-item")==f&&(e=a(b.target));if(!!e)return!!1;if(this.options.handle&&!!c){var h=!!1;a(this.options.handle,e).find("*").andSelf().each(function(){this==b.target&&(h=!!0)});if(!!h)return!!1}this.currentItem=e,this._removeCurrentsFromItems();return!!0},_mouseStart:function(b,c,d){var e=this.options,f=this;this.currentContainer=this,this.refreshPositions(),this.helper=this._createHelper(b),this._cacheHelperProportions(),this._cacheMargins(),this.scrollParent=this.helper.scrollParent(),this.offset=this.currentItem.offset(),this.offset={top:this.offset.top-this.margins.top,left:this.offset.left-this.margins.left},this.helper.css("position","absolute"),this.cssPosition=this.helper.css("position"),a.extend(this.offset,{click:{left:b.pageX-this.offset.left,top:b.pageY-this.offset.top},parent:this._getParentOffset(),relative:this._getRelativeOffset()}),this.originalPosition=this._generatePosition(b),this.originalPageX=b.pageX,this.originalPageY=b.pageY,e.cursorAt&&this._adjustOffsetFromHelper(e.cursorAt),this.domPosition={prev:this.currentItem.prev()[0],parent:this.currentItem.parent()[0]},this.helper[0]!!=this.currentItem[0]&&this.currentItem.hide(),this._createPlaceholder(),e.containment&&this._setContainment(),e.cursor&&(a("body").css("cursor")&&(this._storedCursor=a("body").css("cursor")),a("body").css("cursor",e.cursor)),e.opacity&&(this.helper.css("opacity")&&(this._storedOpacity=this.helper.css("opacity")),this.helper.css("opacity",e.opacity)),e.zIndex&&(this.helper.css("zIndex")&&(this._storedZIndex=this.helper.css("zIndex")),this.helper.css("zIndex",e.zIndex)),this.scrollParent[0]!!=document&&this.scrollParent[0].tagName!!="HTML"&&(this.overflowOffset=this.scrollParent.offset()),this._trigger("start",b,this._uiHash()),this._preserveHelperProportions||this._cacheHelperProportions();if(!!d)for(var g=this.containers.length-1;g>=0;g--)this.containers[g]._trigger("activate",b,f._uiHash(this));a.ui.ddmanager&&(a.ui.ddmanager.current=this),a.ui.ddmanager&&!!e.dropBehaviour&&a.ui.ddmanager.prepareOffsets(this,b),this.dragging=!!0,this.helper.addClass("ui-sortable-helper"),this._mouseDrag(b);return!!0},_mouseDrag:function(b){this.position=this._generatePosition(b),this.positionAbs=this._convertPositionTo("absolute"),this.lastPositionAbs||(this.lastPositionAbs=this.positionAbs);if(this.options.scroll){var c=this.options,d=!!1;this.scrollParent[0]!!=document&&this.scrollParent[0].tagName!!="HTML"?(this.overflowOffset.top+this.scrollParent[0].offsetHeight-b.pageY<c.scrollSensitivity?this.scrollParent[0].scrollTop=d=this.scrollParent[0].scrollTop+c.scrollSpeed:b.pageY-this.overflowOffset.top<c.scrollSensitivity&&(this.scrollParent[0].scrollTop=d=this.scrollParent[0].scrollTop-c.scrollSpeed),this.overflowOffset.left+this.scrollParent[0].offsetWidth-b.pageX<c.scrollSensitivity?this.scrollParent[0].scrollLeft=d=this.scrollParent[0].scrollLeft+c.scrollSpeed:b.pageX-this.overflowOffset.left<c.scrollSensitivity&&(this.scrollParent[0].scrollLeft=d=this.scrollParent[0].scrollLeft-c.scrollSpeed)):(b.pageY-a(document).scrollTop()<c.scrollSensitivity?d=a(document).scrollTop(a(document).scrollTop()-c.scrollSpeed):a(window).height()-(b.pageY-a(document).scrollTop())<c.scrollSensitivity&&(d=a(document).scrollTop(a(document).scrollTop()+c.scrollSpeed)),b.pageX-a(document).scrollLeft()<c.scrollSensitivity?d=a(document).scrollLeft(a(document).scrollLeft()-c.scrollSpeed):a(window).width()-(b.pageX-a(document).scrollLeft())<c.scrollSensitivity&&(d=a(document).scrollLeft(a(document).scrollLeft()+c.scrollSpeed))),d!!==!!1&&a.ui.ddmanager&&!!c.dropBehaviour&&a.ui.ddmanager.prepareOffsets(this,b)}this.positionAbs=this._convertPositionTo("absolute");if(!!this.options.axis||this.options.axis!!="y")this.helper[0].style.left=this.position.left+"px";if(!!this.options.axis||this.options.axis!!="x")this.helper[0].style.top=this.position.top+"px";for(var e=this.items.length-1;e>=0;e--){var f=this.items[e],g=f.item[0],h=this._intersectsWithPointer(f);if(!!h)continue;if(g!!=this.currentItem[0]&&this.placeholder[h==1?"next":"prev"]()[0]!!=g&&!!a.ui.contains(this.placeholder[0],g)&&(this.options.type=="semi-dynamic"?!!a.ui.contains(this.element[0],g):!!0)){this.direction=h==1?"down":"up";if(this.options.tolerance=="pointer"||this._intersectsWithSides(f))this._rearrange(b,f);else break;this._trigger("change",b,this._uiHash());break}}this._contactContainers(b),a.ui.ddmanager&&a.ui.ddmanager.drag(this,b),this._trigger("sort",b,this._uiHash()),this.lastPositionAbs=this.positionAbs;return!!1},_mouseStop:function(b,c){if(!!!!b){a.ui.ddmanager&&!!this.options.dropBehaviour&&a.ui.ddmanager.drop(this,b);if(this.options.revert){var d=this,e=d.placeholder.offset();d.reverting=!!0,a(this.helper).animate({left:e.left-this.offset.parent.left-d.margins.left+(this.offsetParent[0]==document.body?0:this.offsetParent[0].scrollLeft),top:e.top-this.offset.parent.top-d.margins.top+(this.offsetParent[0]==document.body?0:this.offsetParent[0].scrollTop)},parseInt(this.options.revert,10)||500,function(){d._clear(b)})}else this._clear(b,c);return!!1}},cancel:function(){var b=this;if(this.dragging){this._mouseUp({target:null}),this.options.helper=="original"?this.currentItem.css(this._storedCSS).removeClass("ui-sortable-helper"):this.currentItem.show();for(var c=this.containers.length-1;c>=0;c--)this.containers[c]._trigger("deactivate",null,b._uiHash(this)),this.containers[c].containerCache.over&&(this.containers[c]._trigger("out",null,b._uiHash(this)),this.containers[c].containerCache.over=0)}this.placeholder&&(this.placeholder[0].parentNode&&this.placeholder[0].parentNode.removeChild(this.placeholder[0]),this.options.helper!!="original"&&this.helper&&this.helper[0].parentNode&&this.helper.remove(),a.extend(this,{helper:null,dragging:!!1,reverting:!!1,_noFinalSort:null}),this.domPosition.prev?a(this.domPosition.prev).after(this.currentItem):a(this.domPosition.parent).prepend(this.currentItem));return this},serialize:function(b){var c=this._getItemsAsjQuery(b&&b.connected),d=[];b=b||{},a(c).each(function(){var c=(a(b.item||this).attr(b.attribute||"id")||"").match(b.expression||/(.+)[-=_](.+)/);c&&d.push((b.key||c[1]+"[]")+"="+(b.key&&b.expression?c[1]:c[2]))}),!!d.length&&b.key&&d.push(b.key+"=");return d.join("&")},toArray:function(b){var c=this._getItemsAsjQuery(b&&b.connected),d=[];b=b||{},c.each(function(){d.push(a(b.item||this).attr(b.attribute||"id")||"")});return d},_intersectsWith:function(a){var b=this.positionAbs.left,c=b+this.helperProportions.width,d=this.positionAbs.top,e=d+this.helperProportions.height,f=a.left,g=f+a.width,h=a.top,i=h+a.height,j=this.offset.click.top,k=this.offset.click.left,l=d+j>h&&d+j<i&&b+k>f&&b+k<g;return this.options.tolerance=="pointer"||this.options.forcePointerForContainers||this.options.tolerance!!="pointer"&&this.helperProportions[this.floating?"width":"height"]>a[this.floating?"width":"height"]?l:f<b+this.helperProportions.width/2&&c-this.helperProportions.width/2<g&&h<d+this.helperProportions.height/2&&e-this.helperProportions.height/2<i},_intersectsWithPointer:function(b){var c=a.ui.isOverAxis(this.positionAbs.top+this.offset.click.top,b.top,b.height),d=a.ui.isOverAxis(this.positionAbs.left+this.offset.click.left,b.left,b.width),e=c&&d,f=this._getDragVerticalDirection(),g=this._getDragHorizontalDirection();if(!!e)return!!1;return this.floating?g&&g=="right"||f=="down"?2:1:f&&(f=="down"?2:1)},_intersectsWithSides:function(b){var c=a.ui.isOverAxis(this.positionAbs.top+this.offset.click.top,b.top+b.height/2,b.height),d=a.ui.isOverAxis(this.positionAbs.left+this.offset.click.left,b.left+b.width/2,b.width),e=this._getDragVerticalDirection(),f=this._getDragHorizontalDirection();return this.floating&&f?f=="right"&&d||f=="left"&&!!d:e&&(e=="down"&&c||e=="up"&&!!c)},_getDragVerticalDirection:function(){var a=this.positionAbs.top-this.lastPositionAbs.top;return a!!=0&&(a>0?"down":"up")},_getDragHorizontalDirection:function(){var a=this.positionAbs.left-this.lastPositionAbs.left;return a!!=0&&(a>0?"right":"left")},refresh:function(a){this._refreshItems(a),this.refreshPositions();return this},_connectWith:function(){var a=this.options;return a.connectWith.constructor==String?[a.connectWith]:a.connectWith},_getItemsAsjQuery:function(b){var c=this,d=[],e=[],f=this._connectWith();if(f&&b)for(var g=f.length-1;g>=0;g--){var h=a(f[g]);for(var i=h.length-1;i>=0;i--){var j=a.data(h[i],this.widgetName);j&&j!!=this&&!!j.options.disabled&&e.push([a.isFunction(j.options.items)?j.options.items.call(j.element):a(j.options.items,j.element).not(".ui-sortable-helper").not(".ui-sortable-placeholder"),j])}}e.push([a.isFunction(this.options.items)?this.options.items.call(this.element,null,{options:this.options,item:this.currentItem}):a(this.options.items,this.element).not(".ui-sortable-helper").not(".ui-sortable-placeholder"),this]);for(var g=e.length-1;g>=0;g--)e[g][0].each(function(){d.push(this)});return a(d)},_removeCurrentsFromItems:function(){var a=this.currentItem.find(":data("+this.widgetName+"-item)");for(var b=0;b<this.items.length;b++)for(var c=0;c<a.length;c++)a[c]==this.items[b].item[0]&&this.items.splice(b,1)},_refreshItems:function(b){this.items=[],this.containers=[this];var c=this.items,d=this,e=[[a.isFunction(this.options.items)?this.options.items.call(this.element[0],b,{item:this.currentItem}):a(this.options.items,this.element),this]],f=this._connectWith();if(f&&this.ready)for(var g=f.length-1;g>=0;g--){var h=a(f[g]);for(var i=h.length-1;i>=0;i--){var j=a.data(h[i],this.widgetName);j&&j!!=this&&!!j.options.disabled&&(e.push([a.isFunction(j.options.items)?j.options.items.call(j.element[0],b,{item:this.currentItem}):a(j.options.items,j.element),j]),this.containers.push(j))}}for(var g=e.length-1;g>=0;g--){var k=e[g][1],l=e[g][0];for(var i=0,m=l.length;i<m;i++){var n=a(l[i]);n.data(this.widgetName+"-item",k),c.push({item:n,instance:k,width:0,height:0,left:0,top:0})}}},refreshPositions:function(b){this.offsetParent&&this.helper&&(this.offset.parent=this._getParentOffset());for(var c=this.items.length-1;c>=0;c--){var d=this.items[c];if(d.instance!!=this.currentContainer&&this.currentContainer&&d.item[0]!!=this.currentItem[0])continue;var e=this.options.toleranceElement?a(this.options.toleranceElement,d.item):d.item;b||(d.width=e.outerWidth(),d.height=e.outerHeight());var f=e.offset();d.left=f.left,d.top=f.top}if(this.options.custom&&this.options.custom.refreshContainers)this.options.custom.refreshContainers.call(this);else for(var c=this.containers.length-1;c>=0;c--){var f=this.containers[c].element.offset();this.containers[c].containerCache.left=f.left,this.containers[c].containerCache.top=f.top,this.containers[c].containerCache.width=this.containers[c].element.outerWidth(),this.containers[c].containerCache.height=this.containers[c].element.outerHeight()}return this},_createPlaceholder:function(b){var c=b||this,d=c.options;if(!!d.placeholder||d.placeholder.constructor==String){var e=d.placeholder;d.placeholder={element:function(){var b=a(document.createElement(c.currentItem[0].nodeName)).addClass(e||c.currentItem[0].className+" ui-sortable-placeholder").removeClass("ui-sortable-helper")[0];e||(b.style.visibility="hidden");return b},update:function(a,b){if(!!e||!!!!d.forcePlaceholderSize)b.height()||b.height(c.currentItem.innerHeight()-parseInt(c.currentItem.css("paddingTop")||0,10)-parseInt(c.currentItem.css("paddingBottom")||0,10)),b.width()||b.width(c.currentItem.innerWidth()-parseInt(c.currentItem.css("paddingLeft")||0,10)-parseInt(c.currentItem.css("paddingRight")||0,10))}}}c.placeholder=a(d.placeholder.element.call(c.element,c.currentItem)),c.currentItem.after(c.placeholder),d.placeholder.update(c,c.placeholder)},_contactContainers:function(b){var c=null,d=null;for(var e=this.containers.length-1;e>=0;e--){if(a.ui.contains(this.currentItem[0],this.containers[e].element[0]))continue;if(this._intersectsWith(this.containers[e].containerCache)){if(c&&a.ui.contains(this.containers[e].element[0],c.element[0]))continue;c=this.containers[e],d=e}else this.containers[e].containerCache.over&&(this.containers[e]._trigger("out",b,this._uiHash(this)),this.containers[e].containerCache.over=0)}if(!!!!c)if(this.containers.length===1)this.containers[d]._trigger("over",b,this._uiHash(this)),this.containers[d].containerCache.over=1;else if(this.currentContainer!!=this.containers[d]){var f=1e4,g=null,h=this.positionAbs[this.containers[d].floating?"left":"top"];for(var i=this.items.length-1;i>=0;i--){if(!!a.ui.contains(this.containers[d].element[0],this.items[i].item[0]))continue;var j=this.items[i][this.containers[d].floating?"left":"top"];Math.abs(j-h)<f&&(f=Math.abs(j-h),g=this.items[i])}if(!!g&&!!this.options.dropOnEmpty)return;this.currentContainer=this.containers[d],g?this._rearrange(b,g,null,!!0):this._rearrange(b,null,this.containers[d].element,!!0),this._trigger("change",b,this._uiHash()),this.containers[d]._trigger("change",b,this._uiHash(this)),this.options.placeholder.update(this.currentContainer,this.placeholder),this.containers[d]._trigger("over",b,this._uiHash(this)),this.containers[d].containerCache.over=1}},_createHelper:function(b){var c=this.options,d=a.isFunction(c.helper)?a(c.helper.apply(this.element[0],[b,this.currentItem])):c.helper=="clone"?this.currentItem.clone():this.currentItem;d.parents("body").length||a(c.appendTo!!="parent"?c.appendTo:this.currentItem[0].parentNode)[0].appendChild(d[0]),d[0]==this.currentItem[0]&&(this._storedCSS={width:this.currentItem[0].style.width,height:this.currentItem[0].style.height,position:this.currentItem.css("position"),top:this.currentItem.css("top"),left:this.currentItem.css("left")}),(d[0].style.width==""||c.forceHelperSize)&&d.width(this.currentItem.width()),(d[0].style.height==""||c.forceHelperSize)&&d.height(this.currentItem.height());return d},_adjustOffsetFromHelper:function(b){typeof b=="string"&&(b=b.split(" ")),a.isArray(b)&&(b={left:+b[0],top:+b[1]||0}),"left"in b&&(this.offset.click.left=b.left+this.margins.left),"right"in b&&(this.offset.click.left=this.helperProportions.width-b.right+this.margins.left),"top"in b&&(this.offset.click.top=b.top+this.margins.top),"bottom"in b&&(this.offset.click.top=this.helperProportions.height-b.bottom+this.margins.top)},_getParentOffset:function(){this.offsetParent=this.helper.offsetParent();var b=this.offsetParent.offset();this.cssPosition=="absolute"&&this.scrollParent[0]!!=document&&a.ui.contains(this.scrollParent[0],this.offsetParent[0])&&(b.left+=this.scrollParent.scrollLeft(),b.top+=this.scrollParent.scrollTop());if(this.offsetParent[0]==document.body||this.offsetParent[0].tagName&&this.offsetParent[0].tagName.toLowerCase()=="html"&&a.browser.msie)b={top:0,left:0};return{top:b.top+(parseInt(this.offsetParent.css("borderTopWidth"),10)||0),left:b.left+(parseInt(this.offsetParent.css("borderLeftWidth"),10)||0)}},_getRelativeOffset:function(){if(this.cssPosition=="relative"){var a=this.currentItem.position();return{top:a.top-(parseInt(this.helper.css("top"),10)||0)+this.scrollParent.scrollTop(),left:a.left-(parseInt(this.helper.css("left"),10)||0)+this.scrollParent.scrollLeft()}}return{top:0,left:0}},_cacheMargins:function(){this.margins={left:parseInt(this.currentItem.css("marginLeft"),10)||0,top:parseInt(this.currentItem.css("marginTop"),10)||0}},_cacheHelperProportions:function(){this.helperProportions={width:this.helper.outerWidth(),height:this.helper.outerHeight()}},_setContainment:function(){var b=this.options;b.containment=="parent"&&(b.containment=this.helper[0].parentNode);if(b.containment=="document"||b.containment=="window")this.containment=[0-this.offset.relative.left-this.offset.parent.left,0-this.offset.relative.top-this.offset.parent.top,a(b.containment=="document"?document:window).width()-this.helperProportions.width-this.margins.left,(a(b.containment=="document"?document:window).height()||document.body.parentNode.scrollHeight)-this.helperProportions.height-this.margins.top];if(!!/^(document|window|parent)$/.test(b.containment)){var c=a(b.containment)[0],d=a(b.containment).offset(),e=a(c).css("overflow")!!="hidden";this.containment=[d.left+(parseInt(a(c).css("borderLeftWidth"),10)||0)+(parseInt(a(c).css("paddingLeft"),10)||0)-this.margins.left,d.top+(parseInt(a(c).css("borderTopWidth"),10)||0)+(parseInt(a(c).css("paddingTop"),10)||0)-this.margins.top,d.left+(e?Math.max(c.scrollWidth,c.offsetWidth):c.offsetWidth)-(parseInt(a(c).css("borderLeftWidth"),10)||0)-(parseInt(a(c).css("paddingRight"),10)||0)-this.helperProportions.width-this.margins.left,d.top+(e?Math.max(c.scrollHeight,c.offsetHeight):c.offsetHeight)-(parseInt(a(c).css("borderTopWidth"),10)||0)-(parseInt(a(c).css("paddingBottom"),10)||0)-this.helperProportions.height-this.margins.top]}},_convertPositionTo:function(b,c){c||(c=this.position);var d=b=="absolute"?1:-1,e=this.options,f=this.cssPosition=="absolute"&&(this.scrollParent[0]==document||!!a.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,g=/(html|body)/i.test(f[0].tagName);return{top:c.top+this.offset.relative.top*d+this.offset.parent.top*d-(a.browser.safari&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollTop():g?0:f.scrollTop())*d),left:c.left+this.offset.relative.left*d+this.offset.parent.left*d-(a.browser.safari&&this.cssPosition=="fixed"?0:(this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():g?0:f.scrollLeft())*d)}},_generatePosition:function(b){var c=this.options,d=this.cssPosition=="absolute"&&(this.scrollParent[0]==document||!!a.ui.contains(this.scrollParent[0],this.offsetParent[0]))?this.offsetParent:this.scrollParent,e=/(html|body)/i.test(d[0].tagName);this.cssPosition=="relative"&&(this.scrollParent[0]==document||this.scrollParent[0]==this.offsetParent[0])&&(this.offset.relative=this._getRelativeOffset());var f=b.pageX,g=b.pageY;if(this.originalPosition){this.containment&&(b.pageX-this.offset.click.left<this.containment[0]&&(f=this.containment[0]+this.offset.click.left),b.pageY-this.offset.click.top<this.containment[1]&&(g=this.containment[1]+this.offset.click.top),b.pageX-this.offset.click.left>this.containment[2]&&(f=this.containment[2]+this.offset.click.left),b.pageY-this.offset.click.top>this.containment[3]&&(g=this.containment[3]+this.offset.click.top));if(c.grid){var h=this.originalPageY+Math.round((g-this.originalPageY)/c.grid[1])*c.grid[1];g=this.containment?h-this.offset.click.top<this.containment[1]||h-this.offset.click.top>this.containment[3]?h-this.offset.click.top<this.containment[1]?h+c.grid[1]:h-c.grid[1]:h:h;var i=this.originalPageX+Math.round((f-this.originalPageX)/c.grid[0])*c.grid[0];f=this.containment?i-this.offset.click.left<this.containment[0]||i-this.offset.click.left>this.containment[2]?i-this.offset.click.left<this.containment[0]?i+c.grid[0]:i-c.grid[0]:i:i}}return{top:g-this.offset.click.top-this.offset.relative.top-this.offset.parent.top+(a.browser.safari&&this.cssPosition=="fixed"?0:this.cssPosition=="fixed"?-this.scrollParent.scrollTop():e?0:d.scrollTop()),left:f-this.offset.click.left-this.offset.relative.left-this.offset.parent.left+(a.browser.safari&&this.cssPosition=="fixed"?0:this.cssPosition=="fixed"?-this.scrollParent.scrollLeft():e?0:d.scrollLeft())}},_rearrange:function(a,b,c,d){c?c[0].appendChild(this.placeholder[0]):b.item[0].parentNode.insertBefore(this.placeholder[0],this.direction=="down"?b.item[0]:b.item[0].nextSibling),this.counter=this.counter?++this.counter:1;var e=this,f=this.counter;window.setTimeout(function(){f==e.counter&&e.refreshPositions(!!d)},0)},_clear:function(b,c){this.reverting=!!1;var d=[],e=this;!!this._noFinalSort&&this.currentItem.parent().length&&this.placeholder.before(this.currentItem),this._noFinalSort=null;if(this.helper[0]==this.currentItem[0]){for(var f in this._storedCSS)if(this._storedCSS[f]=="auto"||this._storedCSS[f]=="static")this._storedCSS[f]="";this.currentItem.css(this._storedCSS).removeClass("ui-sortable-helper")}else this.currentItem.show();this.fromOutside&&!!c&&d.push(function(a){this._trigger("receive",a,this._uiHash(this.fromOutside))}),(this.fromOutside||this.domPosition.prev!!=this.currentItem.prev().not(".ui-sortable-helper")[0]||this.domPosition.parent!!=this.currentItem.parent()[0])&&!!c&&d.push(function(a){this._trigger("update",a,this._uiHash())});if(!!a.ui.contains(this.element[0],this.currentItem[0])){c||d.push(function(a){this._trigger("remove",a,this._uiHash())});for(var f=this.containers.length-1;f>=0;f--)a.ui.contains(this.containers[f].element[0],this.currentItem[0])&&!!c&&(d.push(function(a){return function(b){a._trigger("receive",b,this._uiHash(this))}}.call(this,this.containers[f])),d.push(function(a){return function(b){a._trigger("update",b,this._uiHash(this))}}.call(this,this.containers[f])))}for(var f=this.containers.length-1;f>=0;f--)c||d.push(function(a){return function(b){a._trigger("deactivate",b,this._uiHash(this))}}.call(this,this.containers[f])),this.containers[f].containerCache.over&&(d.push(function(a){return function(b){a._trigger("out",b,this._uiHash(this))}}.call(this,this.containers[f])),this.containers[f].containerCache.over=0);this._storedCursor&&a("body").css("cursor",this._storedCursor),this._storedOpacity&&this.helper.css("opacity",this._storedOpacity),this._storedZIndex&&this.helper.css("zIndex",this._storedZIndex=="auto"?"":this._storedZIndex),this.dragging=!!1;if(this.cancelHelperRemoval){if(!!c){this._trigger("beforeStop",b,this._uiHash());for(var f=0;f<d.length;f++)d[f].call(this,b);this._trigger("stop",b,this._uiHash())}return!!1}c||this._trigger("beforeStop",b,this._uiHash()),this.placeholder[0].parentNode.removeChild(this.placeholder[0]),this.helper[0]!!=this.currentItem[0]&&this.helper.remove(),this.helper=null;if(!!c){for(var f=0;f<d.length;f++)d[f].call(this,b);this._trigger("stop",b,this._uiHash())}this.fromOutside=!!1;return!!0},_trigger:function(){a.Widget.prototype._trigger.apply(this,arguments)===!!1&&this.cancel()},_uiHash:function(b){var c=b||this;return{helper:c.helper,placeholder:c.placeholder||a([]),position:c.position,originalPosition:c.originalPosition,offset:c.positionAbs,item:c.currentItem,sender:b?b.element:null}}}),a.extend(a.ui.sortable,{version:"1.8.18"})})(jQuery);/*
 * jQuery UI Accordion 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Accordion
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 */(function(a,b){a.widget("ui.accordion",{options:{active:0,animated:"slide",autoHeight:!!0,clearStyle:!!1,collapsible:!!1,event:"click",fillSpace:!!1,header:"> li > :first-child,> :not(li):even",icons:{header:"ui-icon-triangle-1-e",headerSelected:"ui-icon-triangle-1-s"},navigation:!!1,navigationFilter:function(){return this.href.toLowerCase()===location.href.toLowerCase()}},_create:function(){var b=this,c=b.options;b.running=0,b.element.addClass("ui-accordion ui-widget ui-helper-reset").children("li").addClass("ui-accordion-li-fix"),b.headers=b.element.find(c.header).addClass("ui-accordion-header ui-helper-reset ui-state-default ui-corner-all").bind("mouseenter.accordion",function(){c.disabled||a(this).addClass("ui-state-hover")}).bind("mouseleave.accordion",function(){c.disabled||a(this).removeClass("ui-state-hover")}).bind("focus.accordion",function(){c.disabled||a(this).addClass("ui-state-focus")}).bind("blur.accordion",function(){c.disabled||a(this).removeClass("ui-state-focus")}),b.headers.next().addClass("ui-accordion-content ui-helper-reset ui-widget-content ui-corner-bottom");if(c.navigation){var d=b.element.find("a").filter(c.navigationFilter).eq(0);if(d.length){var e=d.closest(".ui-accordion-header");e.length?b.active=e:b.active=d.closest(".ui-accordion-content").prev()}}b.active=b._findActive(b.active||c.active).addClass("ui-state-default ui-state-active").toggleClass("ui-corner-all").toggleClass("ui-corner-top"),b.active.next().addClass("ui-accordion-content-active"),b._createIcons(),b.resize(),b.element.attr("role","tablist"),b.headers.attr("role","tab").bind("keydown.accordion",function(a){return b._keydown(a)}).next().attr("role","tabpanel"),b.headers.not(b.active||"").attr({"aria-expanded":"false","aria-selected":"false",tabIndex:-1}).next().hide(),b.active.length?b.active.attr({"aria-expanded":"true","aria-selected":"true",tabIndex:0}):b.headers.eq(0).attr("tabIndex",0),a.browser.safari||b.headers.find("a").attr("tabIndex",-1),c.event&&b.headers.bind(c.event.split(" ").join(".accordion ")+".accordion",function(a){b._clickHandler.call(b,a,this),a.preventDefault()})},_createIcons:function(){var b=this.options;b.icons&&(a("<span></span>").addClass("ui-icon "+b.icons.header).prependTo(this.headers),this.active.children(".ui-icon").toggleClass(b.icons.header).toggleClass(b.icons.headerSelected),this.element.addClass("ui-accordion-icons"))},_destroyIcons:function(){this.headers.children(".ui-icon").remove(),this.element.removeClass("ui-accordion-icons")},destroy:function(){var b=this.options;this.element.removeClass("ui-accordion ui-widget ui-helper-reset").removeAttr("role"),this.headers.unbind(".accordion").removeClass("ui-accordion-header ui-accordion-disabled ui-helper-reset ui-state-default ui-corner-all ui-state-active ui-state-disabled ui-corner-top").removeAttr("role").removeAttr("aria-expanded").removeAttr("aria-selected").removeAttr("tabIndex"),this.headers.find("a").removeAttr("tabIndex"),this._destroyIcons();var c=this.headers.next().css("display","").removeAttr("role").removeClass("ui-helper-reset ui-widget-content ui-corner-bottom ui-accordion-content ui-accordion-content-active ui-accordion-disabled ui-state-disabled");(b.autoHeight||b.fillHeight)&&c.css("height","");return a.Widget.prototype.destroy.call(this)},_setOption:function(b,c){a.Widget.prototype._setOption.apply(this,arguments),b=="active"&&this.activate(c),b=="icons"&&(this._destroyIcons(),c&&this._createIcons()),b=="disabled"&&this.headers.add(this.headers.next())[c?"addClass":"removeClass"]("ui-accordion-disabled ui-state-disabled")},_keydown:function(b){if(!!(this.options.disabled||b.altKey||b.ctrlKey)){var c=a.ui.keyCode,d=this.headers.length,e=this.headers.index(b.target),f=!!1;switch(b.keyCode){case c.RIGHT:case c.DOWN:f=this.headers[(e+1)%d];break;case c.LEFT:case c.UP:f=this.headers[(e-1+d)%d];break;case c.SPACE:case c.ENTER:this._clickHandler({target:b.target},b.target),b.preventDefault()}if(f){a(b.target).attr("tabIndex",-1),a(f).attr("tabIndex",0),f.focus();return!!1}return!!0}},resize:function(){var b=this.options,c;if(b.fillSpace){if(a.browser.msie){var d=this.element.parent().css("overflow");this.element.parent().css("overflow","hidden")}c=this.element.parent().height(),a.browser.msie&&this.element.parent().css("overflow",d),this.headers.each(function(){c-=a(this).outerHeight(!!0)}),this.headers.next().each(function(){a(this).height(Math.max(0,c-a(this).innerHeight()+a(this).height()))}).css("overflow","auto")}else b.autoHeight&&(c=0,this.headers.next().each(function(){c=Math.max(c,a(this).height("").height())}).height(c));return this},activate:function(a){this.options.active=a;var b=this._findActive(a)[0];this._clickHandler({target:b},b);return this},_findActive:function(b){return b?typeof b=="number"?this.headers.filter(":eq("+b+")"):this.headers.not(this.headers.not(b)):b===!!1?a([]):this.headers.filter(":eq(0)")},_clickHandler:function(b,c){var d=this.options;if(!!d.disabled){if(!!b.target){if(!!d.collapsible)return;this.active.removeClass("ui-state-active ui-corner-top").addClass("ui-state-default ui-corner-all").children(".ui-icon").removeClass(d.icons.headerSelected).addClass(d.icons.header),this.active.next().addClass("ui-accordion-content-active");var e=this.active.next(),f={options:d,newHeader:a([]),oldHeader:d.active,newContent:a([]),oldContent:e},g=this.active=a([]);this._toggle(g,e,f);return}var h=a(b.currentTarget||c),i=h[0]===this.active[0];d.active=d.collapsible&&i?!!1:this.headers.index(h);if(this.running||!!d.collapsible&&i)return;var j=this.active,g=h.next(),e=this.active.next(),f={options:d,newHeader:i&&d.collapsible?a([]):h,oldHeader:this.active,newContent:i&&d.collapsible?a([]):g,oldContent:e},k=this.headers.index(this.active[0])>this.headers.index(h[0]);this.active=i?a([]):h,this._toggle(g,e,f,i,k),j.removeClass("ui-state-active ui-corner-top").addClass("ui-state-default ui-corner-all").children(".ui-icon").removeClass(d.icons.headerSelected).addClass(d.icons.header),i||(h.removeClass("ui-state-default ui-corner-all").addClass("ui-state-active ui-corner-top").children(".ui-icon").removeClass(d.icons.header).addClass(d.icons.headerSelected),h.next().addClass("ui-accordion-content-active"));return}},_toggle:function(b,c,d,e,f){var g=this,h=g.options;g.toShow=b,g.toHide=c,g.data=d;var i=function(){if(!!!!g)return g._completed.apply(g,arguments)};g._trigger("changestart",null,g.data),g.running=c.size()===0?b.size():c.size();if(h.animated){var j={};h.collapsible&&e?j={toShow:a([]),toHide:c,complete:i,down:f,autoHeight:h.autoHeight||h.fillSpace}:j={toShow:b,toHide:c,complete:i,down:f,autoHeight:h.autoHeight||h.fillSpace},h.proxied||(h.proxied=h.animated),h.proxiedDuration||(h.proxiedDuration=h.duration),h.animated=a.isFunction(h.proxied)?h.proxied(j):h.proxied,h.duration=a.isFunction(h.proxiedDuration)?h.proxiedDuration(j):h.proxiedDuration;var k=a.ui.accordion.animations,l=h.duration,m=h.animated;m&&!!k[m]&&!!a.easing[m]&&(m="slide"),k[m]||(k[m]=function(a){this.slide(a,{easing:m,duration:l||700})}),k[m](j)}else h.collapsible&&e?b.toggle():(c.hide(),b.show()),i(!!0);c.prev().attr({"aria-expanded":"false","aria-selected":"false",tabIndex:-1}).blur(),b.prev().attr({"aria-expanded":"true","aria-selected":"true",tabIndex:0}).focus()},_completed:function(a){this.running=a?0:--this.running;this.running||(this.options.clearStyle&&this.toShow.add(this.toHide).css({height:"",overflow:""}),this.toHide.removeClass("ui-accordion-content-active"),this.toHide.length&&(this.toHide.parent()[0].className=this.toHide.parent()[0].className),this._trigger("change",null,this.data))}}),a.extend(a.ui.accordion,{version:"1.8.18",animations:{slide:function(b,c){b=a.extend({easing:"swing",duration:300},b,c);if(!!b.toHide.size())b.toShow.animate({height:"show",paddingTop:"show",paddingBottom:"show"},b);else{if(!!b.toShow.size()){b.toHide.animate({height:"hide",paddingTop:"hide",paddingBottom:"hide"},b);return}var d=b.toShow.css("overflow"),e=0,f={},g={},h=["height","paddingTop","paddingBottom"],i,j=b.toShow;i=j[0].style.width,j.width(j.parent().width()-parseFloat(j.css("paddingLeft"))-parseFloat(j.css("paddingRight"))-(parseFloat(j.css("borderLeftWidth"))||0)-(parseFloat(j.css("borderRightWidth"))||0)),a.each(h,function(c,d){g[d]="hide";var e=(""+a.css(b.toShow[0],d)).match(/^([\d+-.]+)(.*)$/);f[d]={value:e[1],unit:e[2]||"px"}}),b.toShow.css({height:0,overflow:"hidden"}).show(),b.toHide.filter(":hidden").each(b.complete).end().filter(":visible").animate(g,{step:function(a,c){c.prop=="height"&&(e=c.end-c.start===0?0:(c.now-c.start)/(c.end-c.start)),b.toShow[0].style[c.prop]=e*f[c.prop].value+f[c.prop].unit},duration:b.duration,easing:b.easing,complete:function(){b.autoHeight||b.toShow.css("height",""),b.toShow.css({width:i,overflow:d}),b.complete()}})}},bounceslide:function(a){this.slide(a,{easing:a.down?"easeOutBounce":"swing",duration:a.down?1e3:200})}}})})(jQuery);/*
 * jQuery UI Autocomplete 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Autocomplete
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *	jquery.ui.position.js
 */(function(a,b){var c=0;a.widget("ui.autocomplete",{options:{appendTo:"body",autoFocus:!!1,delay:300,minLength:1,position:{my:"left top",at:"left bottom",collision:"none"},source:null},pending:0,_create:function(){var b=this,c=this.element[0].ownerDocument,d;this.element.addClass("ui-autocomplete-input").attr("autocomplete","off").attr({role:"textbox","aria-autocomplete":"list","aria-haspopup":"true"}).bind("keydown.autocomplete",function(c){if(!!b.options.disabled&&!!b.element.propAttr("readOnly")){d=!!1;var e=a.ui.keyCode;switch(c.keyCode){case e.PAGE_UP:b._move("previousPage",c);break;case e.PAGE_DOWN:b._move("nextPage",c);break;case e.UP:b._move("previous",c),c.preventDefault();break;case e.DOWN:b._move("next",c),c.preventDefault();break;case e.ENTER:case e.NUMPAD_ENTER:b.menu.active&&(d=!!0,c.preventDefault());case e.TAB:if(!!b.menu.active)return;b.menu.select(c);break;case e.ESCAPE:b.element.val(b.term),b.close(c);break;default:clearTimeout(b.searching),b.searching=setTimeout(function(){b.term!!=b.element.val()&&(b.selectedItem=null,b.search(null,c))},b.options.delay)}}}).bind("keypress.autocomplete",function(a){d&&(d=!!1,a.preventDefault())}).bind("focus.autocomplete",function(){b.options.disabled||(b.selectedItem=null,b.previous=b.element.val())}).bind("blur.autocomplete",function(a){b.options.disabled||(clearTimeout(b.searching),b.closing=setTimeout(function(){b.close(a),b._change(a)},150))}),this._initSource(),this.response=function(){return b._response.apply(b,arguments)},this.menu=a("<ul></ul>").addClass("ui-autocomplete").appendTo(a(this.options.appendTo||"body",c)[0]).mousedown(function(c){var d=b.menu.element[0];a(c.target).closest(".ui-menu-item").length||setTimeout(function(){a(document).one("mousedown",function(c){c.target!!==b.element[0]&&c.target!!==d&&!!a.ui.contains(d,c.target)&&b.close()})},1),setTimeout(function(){clearTimeout(b.closing)},13)}).menu({focus:function(a,c){var d=c.item.data("item.autocomplete");!!1!!==b._trigger("focus",a,{item:d})&&/^key/.test(a.originalEvent.type)&&b.element.val(d.value)},selected:function(a,d){var e=d.item.data("item.autocomplete"),f=b.previous;b.element[0]!!==c.activeElement&&(b.element.focus(),b.previous=f,setTimeout(function(){b.previous=f,b.selectedItem=e},1)),!!1!!==b._trigger("select",a,{item:e})&&b.element.val(e.value),b.term=b.element.val(),b.close(a),b.selectedItem=e},blur:function(a,c){b.menu.element.is(":visible")&&b.element.val()!!==b.term&&b.element.val(b.term)}}).zIndex(this.element.zIndex()+1).css({top:0,left:0}).hide().data("menu"),a.fn.bgiframe&&this.menu.element.bgiframe(),b.beforeunloadHandler=function(){b.element.removeAttr("autocomplete")},a(window).bind("beforeunload",b.beforeunloadHandler)},destroy:function(){this.element.removeClass("ui-autocomplete-input").removeAttr("autocomplete").removeAttr("role").removeAttr("aria-autocomplete").removeAttr("aria-haspopup"),this.menu.element.remove(),a(window).unbind("beforeunload",this.beforeunloadHandler),a.Widget.prototype.destroy.call(this)},_setOption:function(b,c){a.Widget.prototype._setOption.apply(this,arguments),b==="source"&&this._initSource(),b==="appendTo"&&this.menu.element.appendTo(a(c||"body",this.element[0].ownerDocument)[0]),b==="disabled"&&c&&this.xhr&&this.xhr.abort()},_initSource:function(){var b=this,d,e;a.isArray(this.options.source)?(d=this.options.source,this.source=function(b,c){c(a.ui.autocomplete.filter(d,b.term))}):typeof this.options.source=="string"?(e=this.options.source,this.source=function(d,f){b.xhr&&b.xhr.abort(),b.xhr=a.ajax({url:e,data:d,dataType:"json",context:{autocompleteRequest:++c},success:function(a,b){this.autocompleteRequest===c&&f(a)},error:function(){this.autocompleteRequest===c&&f([])}})}):this.source=this.options.source},search:function(a,b){a=a!!=null?a:this.element.val(),this.term=this.element.val();if(a.length<this.options.minLength)return this.close(b);clearTimeout(this.closing);if(this._trigger("search",b)!!==!!1)return this._search(a)},_search:function(a){this.pending++,this.element.addClass("ui-autocomplete-loading"),this.source({term:a},this.response)},_response:function(a){!!this.options.disabled&&a&&a.length?(a=this._normalize(a),this._suggest(a),this._trigger("open")):this.close(),this.pending--,this.pending||this.element.removeClass("ui-autocomplete-loading")},close:function(a){clearTimeout(this.closing),this.menu.element.is(":visible")&&(this.menu.element.hide(),this.menu.deactivate(),this._trigger("close",a))},_change:function(a){this.previous!!==this.element.val()&&this._trigger("change",a,{item:this.selectedItem})},_normalize:function(b){if(b.length&&b[0].label&&b[0].value)return b;return a.map(b,function(b){if(typeof b=="string")return{label:b,value:b};return a.extend({label:b.label||b.value,value:b.value||b.label},b)})},_suggest:function(b){var c=this.menu.element.empty().zIndex(this.element.zIndex()+1);this._renderMenu(c,b),this.menu.deactivate(),this.menu.refresh(),c.show(),this._resizeMenu(),c.position(a.extend({of:this.element},this.options.position)),this.options.autoFocus&&this.menu.next(new a.Event("mouseover"))},_resizeMenu:function(){var a=this.menu.element;a.outerWidth(Math.max(a.width("").outerWidth()+1,this.element.outerWidth()))},_renderMenu:function(b,c){var d=this;a.each(c,function(a,c){d._renderItem(b,c)})},_renderItem:function(b,c){return a("<li></li>").data("item.autocomplete",c).append(a("<a></a>").text(c.label)).appendTo(b)},_move:function(a,b){if(!!this.menu.element.is(":visible"))this.search(null,b);else{if(this.menu.first()&&/^previous/.test(a)||this.menu.last()&&/^next/.test(a)){this.element.val(this.term),this.menu.deactivate();return}this.menu[a](b)}},widget:function(){return this.menu.element}}),a.extend(a.ui.autocomplete,{escapeRegex:function(a){return a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")},filter:function(b,c){var d=new RegExp(a.ui.autocomplete.escapeRegex(c),"i");return a.grep(b,function(a){return d.test(a.label||a.value||a)})}})})(jQuery),function(a){a.widget("ui.menu",{_create:function(){var b=this;this.element.addClass("ui-menu ui-widget ui-widget-content ui-corner-all").attr({role:"listbox","aria-activedescendant":"ui-active-menuitem"}).click(function(c){!!a(c.target).closest(".ui-menu-item a").length||(c.preventDefault(),b.select(c))}),this.refresh()},refresh:function(){var b=this,c=this.element.children("li:not(.ui-menu-item):has(a)").addClass("ui-menu-item").attr("role","menuitem");c.children("a").addClass("ui-corner-all").attr("tabindex",-1).mouseenter(function(c){b.activate(c,a(this).parent())}).mouseleave(function(){b.deactivate()})},activate:function(a,b){this.deactivate();if(this.hasScroll()){var c=b.offset().top-this.element.offset().top,d=this.element.scrollTop(),e=this.element.height();c<0?this.element.scrollTop(d+c):c>=e&&this.element.scrollTop(d+c-e+b.height())}this.active=b.eq(0).children("a").addClass("ui-state-hover").attr("id","ui-active-menuitem").end(),this._trigger("focus",a,{item:b})},deactivate:function(){!!this.active||(this.active.children("a").removeClass("ui-state-hover").removeAttr("id"),this._trigger("blur"),this.active=null)},next:function(a){this.move("next",".ui-menu-item:first",a)},previous:function(a){this.move("prev",".ui-menu-item:last",a)},first:function(){return this.active&&!!this.active.prevAll(".ui-menu-item").length},last:function(){return this.active&&!!this.active.nextAll(".ui-menu-item").length},move:function(a,b,c){if(!!this.active)this.activate(c,this.element.children(b));else{var d=this.active[a+"All"](".ui-menu-item").eq(0);d.length?this.activate(c,d):this.activate(c,this.element.children(b))}},nextPage:function(b){if(this.hasScroll()){if(!!this.active||this.last()){this.activate(b,this.element.children(".ui-menu-item:first"));return}var c=this.active.offset().top,d=this.element.height(),e=this.element.children(".ui-menu-item").filter(function(){var b=a(this).offset().top-c-d+a(this).height();return b<10&&b>-10});e.length||(e=this.element.children(".ui-menu-item:last")),this.activate(b,e)}else this.activate(b,this.element.children(".ui-menu-item").filter(!!this.active||this.last()?":first":":last"))},previousPage:function(b){if(this.hasScroll()){if(!!this.active||this.first()){this.activate(b,this.element.children(".ui-menu-item:last"));return}var c=this.active.offset().top,d=this.element.height();result=this.element.children(".ui-menu-item").filter(function(){var b=a(this).offset().top-c+d-a(this).height();return b<10&&b>-10}),result.length||(result=this.element.children(".ui-menu-item:first")),this.activate(b,result)}else this.activate(b,this.element.children(".ui-menu-item").filter(!!this.active||this.first()?":last":":first"))},hasScroll:function(){return this.element.height()<this.element[a.fn.prop?"prop":"attr"]("scrollHeight")},select:function(a){this._trigger("selected",a,{item:this.active})}})}(jQuery);/*
 * jQuery UI Button 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Button
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 */(function(a,b){var c,d,e,f,g="ui-button ui-widget ui-state-default ui-corner-all",h="ui-state-hover ui-state-active ",i="ui-button-icons-only ui-button-icon-only ui-button-text-icons ui-button-text-icon-primary ui-button-text-icon-secondary ui-button-text-only",j=function(){var b=a(this).find(":ui-button");setTimeout(function(){b.button("refresh")},1)},k=function(b){var c=b.name,d=b.form,e=a([]);c&&(d?e=a(d).find("[name=''"+c+"'']"):e=a("[name=''"+c+"'']",b.ownerDocument).filter(function(){return!!this.form}));return e};a.widget("ui.button",{options:{disabled:null,text:!!0,label:null,icons:{primary:null,secondary:null}},_create:function(){this.element.closest("form").unbind("reset.button").bind("reset.button",j),typeof this.options.disabled!!="boolean"?this.options.disabled=!!!!this.element.propAttr("disabled"):this.element.propAttr("disabled",this.options.disabled),this._determineButtonType(),this.hasTitle=!!!!this.buttonElement.attr("title");var b=this,h=this.options,i=this.type==="checkbox"||this.type==="radio",l="ui-state-hover"+(i?"":" ui-state-active"),m="ui-state-focus";h.label===null&&(h.label=this.buttonElement.html()),this.buttonElement.addClass(g).attr("role","button").bind("mouseenter.button",function(){h.disabled||(a(this).addClass("ui-state-hover"),this===c&&a(this).addClass("ui-state-active"))}).bind("mouseleave.button",function(){h.disabled||a(this).removeClass(l)}).bind("click.button",function(a){h.disabled&&(a.preventDefault(),a.stopImmediatePropagation())}),this.element.bind("focus.button",function(){b.buttonElement.addClass(m)}).bind("blur.button",function(){b.buttonElement.removeClass(m)}),i&&(this.element.bind("change.button",function(){f||b.refresh()}),this.buttonElement.bind("mousedown.button",function(a){h.disabled||(f=!!1,d=a.pageX,e=a.pageY)}).bind("mouseup.button",function(a){!!h.disabled&&(d!!==a.pageX||e!!==a.pageY)&&(f=!!0)})),this.type==="checkbox"?this.buttonElement.bind("click.button",function(){if(h.disabled||f)return!!1;a(this).toggleClass("ui-state-active"),b.buttonElement.attr("aria-pressed",b.element[0].checked)}):this.type==="radio"?this.buttonElement.bind("click.button",function(){if(h.disabled||f)return!!1;a(this).addClass("ui-state-active"),b.buttonElement.attr("aria-pressed","true");var c=b.element[0];k(c).not(c).map(function(){return a(this).button("widget")[0]}).removeClass("ui-state-active").attr("aria-pressed","false")}):(this.buttonElement.bind("mousedown.button",function(){if(h.disabled)return!!1;a(this).addClass("ui-state-active"),c=this,a(document).one("mouseup",function(){c=null})}).bind("mouseup.button",function(){if(h.disabled)return!!1;a(this).removeClass("ui-state-active")}).bind("keydown.button",function(b){if(h.disabled)return!!1;(b.keyCode==a.ui.keyCode.SPACE||b.keyCode==a.ui.keyCode.ENTER)&&a(this).addClass("ui-state-active")}).bind("keyup.button",function(){a(this).removeClass("ui-state-active")}),this.buttonElement.is("a")&&this.buttonElement.keyup(function(b){b.keyCode===a.ui.keyCode.SPACE&&a(this).click()})),this._setOption("disabled",h.disabled),this._resetButton()},_determineButtonType:function(){this.element.is(":checkbox")?this.type="checkbox":this.element.is(":radio")?this.type="radio":this.element.is("input")?this.type="input":this.type="button";if(this.type==="checkbox"||this.type==="radio"){var a=this.element.parents().filter(":last"),b="label[for=''"+this.element.attr("id")+"'']";this.buttonElement=a.find(b),this.buttonElement.length||(a=a.length?a.siblings():this.element.siblings(),this.buttonElement=a.filter(b),this.buttonElement.length||(this.buttonElement=a.find(b))),this.element.addClass("ui-helper-hidden-accessible");var c=this.element.is(":checked");c&&this.buttonElement.addClass("ui-state-active"),this.buttonElement.attr("aria-pressed",c)}else this.buttonElement=this.element},widget:function(){return this.buttonElement},destroy:function(){this.element.removeClass("ui-helper-hidden-accessible"),this.buttonElement.removeClass(g+" "+h+" "+i).removeAttr("role").removeAttr("aria-pressed").html(this.buttonElement.find(".ui-button-text").html()),this.hasTitle||this.buttonElement.removeAttr("title"),a.Widget.prototype.destroy.call(this)},_setOption:function(b,c){a.Widget.prototype._setOption.apply(this,arguments);b==="disabled"?c?this.element.propAttr("disabled",!!0):this.element.propAttr("disabled",!!1):this._resetButton()},refresh:function(){var b=this.element.is(":disabled");b!!==this.options.disabled&&this._setOption("disabled",b),this.type==="radio"?k(this.element[0]).each(function(){a(this).is(":checked")?a(this).button("widget").addClass("ui-state-active").attr("aria-pressed","true"):a(this).button("widget").removeClass("ui-state-active").attr("aria-pressed","false")}):this.type==="checkbox"&&(this.element.is(":checked")?this.buttonElement.addClass("ui-state-active").attr("aria-pressed","true"):this.buttonElement.removeClass("ui-state-active").attr("aria-pressed","false"))},_resetButton:function(){if(this.type==="input")this.options.label&&this.element.val(this.options.label);else{var b=this.buttonElement.removeClass(i),c=a("<span></span>",this.element[0].ownerDocument).addClass("ui-button-text").html(this.options.label).appendTo(b.empty()).text(),d=this.options.icons,e=d.primary&&d.secondary,f=[];d.primary||d.secondary?(this.options.text&&f.push("ui-button-text-icon"+(e?"s":d.primary?"-primary":"-secondary")),d.primary&&b.prepend("<span class=''ui-button-icon-primary ui-icon "+d.primary+"''></span>"),d.secondary&&b.append("<span class=''ui-button-icon-secondary ui-icon "+d.secondary+"''></span>"),this.options.text||(f.push(e?"ui-button-icons-only":"ui-button-icon-only"),this.hasTitle||b.attr("title",c))):f.push("ui-button-text-only"),b.addClass(f.join(" "))}}}),a.widget("ui.buttonset",{options:{items:":button, :submit, :reset, :checkbox, :radio, a, :data(button)"},_create:function(){this.element.addClass("ui-buttonset")},_init:function(){this.refresh()},_setOption:function(b,c){b==="disabled"&&this.buttons.button("option",b,c),a.Widget.prototype._setOption.apply(this,arguments)},refresh:function(){var b=this.element.css("direction")==="rtl";this.buttons=this.element.find(this.options.items).filter(":ui-button").button("refresh").end().not(":ui-button").button().end().map(function(){return a(this).button("widget")[0]}).removeClass("ui-corner-all ui-corner-left ui-corner-right").filter(":first").addClass(b?"ui-corner-right":"ui-corner-left").end().filter(":last").addClass(b?"ui-corner-left":"ui-corner-right").end().end()},destroy:function(){this.element.removeClass("ui-buttonset"),this.buttons.map(function(){return a(this).button("widget")[0]}).removeClass("ui-corner-left ui-corner-right").end().button("destroy"),a.Widget.prototype.destroy.call(this)}})})(jQuery);/*
 * jQuery UI Dialog 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Dialog
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *  jquery.ui.button.js
 *	jquery.ui.draggable.js
 *	jquery.ui.mouse.js
 *	jquery.ui.position.js
 *	jquery.ui.resizable.js
 */(function(a,b){var c="ui-dialog ui-widget ui-widget-content ui-corner-all ",d={buttons:!!0,height:!!0,maxHeight:!!0,maxWidth:!!0,minHeight:!!0,minWidth:!!0,width:!!0},e={maxHeight:!!0,maxWidth:!!0,minHeight:!!0,minWidth:!!0},f=a.attrFn||{val:!!0,css:!!0,html:!!0,text:!!0,data:!!0,width:!!0,height:!!0,offset:!!0,click:!!0};a.widget("ui.dialog",{options:{autoOpen:!!0,buttons:{},closeOnEscape:!!0,closeText:"close",dialogClass:"",draggable:!!0,hide:null,height:"auto",maxHeight:!!1,maxWidth:!!1,minHeight:150,minWidth:150,modal:!!1,position:{my:"center",at:"center",collision:"fit",using:function(b){var c=a(this).css(b).offset().top;c<0&&a(this).css("top",b.top-c)}},resizable:!!0,show:null,stack:!!0,title:"",width:300,zIndex:1e3},_create:function(){this.originalTitle=this.element.attr("title"),typeof this.originalTitle!!="string"&&(this.originalTitle=""),this.options.title=this.options.title||this.originalTitle;var b=this,d=b.options,e=d.title||"&#160;",f=a.ui.dialog.getTitleId(b.element),g=(b.uiDialog=a("<div></div>")).appendTo(document.body).hide().addClass(c+d.dialogClass).css({zIndex:d.zIndex}).attr("tabIndex",-1).css("outline",0).keydown(function(c){d.closeOnEscape&&!!c.isDefaultPrevented()&&c.keyCode&&c.keyCode===a.ui.keyCode.ESCAPE&&(b.close(c),c.preventDefault())}).attr({role:"dialog","aria-labelledby":f}).mousedown(function(a){b.moveToTop(!!1,a)}),h=b.element.show().removeAttr("title").addClass("ui-dialog-content ui-widget-content").appendTo(g),i=(b.uiDialogTitlebar=a("<div></div>")).addClass("ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix").prependTo(g),j=a(''<a href="#"></a>'').addClass("ui-dialog-titlebar-close ui-corner-all").attr("role","button").hover(function(){j.addClass("ui-state-hover")},function(){j.removeClass("ui-state-hover")}).focus(function(){j.addClass("ui-state-focus")}).blur(function(){j.removeClass("ui-state-focus")}).click(function(a){b.close(a);return!!1}).appendTo(i),k=(b.uiDialogTitlebarCloseText=a("<span></span>")).addClass("ui-icon ui-icon-closethick").text(d.closeText).appendTo(j),l=a("<span></span>").addClass("ui-dialog-title").attr("id",f).html(e).prependTo(i);a.isFunction(d.beforeclose)&&!!a.isFunction(d.beforeClose)&&(d.beforeClose=d.beforeclose),i.find("*").add(i).disableSelection(),d.draggable&&a.fn.draggable&&b._makeDraggable(),d.resizable&&a.fn.resizable&&b._makeResizable(),b._createButtons(d.buttons),b._isOpen=!!1,a.fn.bgiframe&&g.bgiframe()},_init:function(){this.options.autoOpen&&this.open()},destroy:function(){var a=this;a.overlay&&a.overlay.destroy(),a.uiDialog.hide(),a.element.unbind(".dialog").removeData("dialog").removeClass("ui-dialog-content ui-widget-content").hide().appendTo("body"),a.uiDialog.remove(),a.originalTitle&&a.element.attr("title",a.originalTitle);return a},widget:function(){return this.uiDialog},close:function(b){var c=this,d,e;if(!!1!!==c._trigger("beforeClose",b)){c.overlay&&c.overlay.destroy(),c.uiDialog.unbind("keypress.ui-dialog"),c._isOpen=!!1,c.options.hide?c.uiDialog.hide(c.options.hide,function(){c._trigger("close",b)}):(c.uiDialog.hide(),c._trigger("close",b)),a.ui.dialog.overlay.resize(),c.options.modal&&(d=0,a(".ui-dialog").each(function(){this!!==c.uiDialog[0]&&(e=a(this).css("z-index"),isNaN(e)||(d=Math.max(d,e)))}),a.ui.dialog.maxZ=d);return c}},isOpen:function(){return this._isOpen},moveToTop:function(b,c){var d=this,e=d.options,f;if(e.modal&&!!b||!!e.stack&&!!e.modal)return d._trigger("focus",c);e.zIndex>a.ui.dialog.maxZ&&(a.ui.dialog.maxZ=e.zIndex),d.overlay&&(a.ui.dialog.maxZ+=1,d.overlay.$el.css("z-index",a.ui.dialog.overlay.maxZ=a.ui.dialog.maxZ)),f={scrollTop:d.element.scrollTop(),scrollLeft:d.element.scrollLeft()},a.ui.dialog.maxZ+=1,d.uiDialog.css("z-index",a.ui.dialog.maxZ),d.element.attr(f),d._trigger("focus",c);return d},open:function(){if(!!this._isOpen){var b=this,c=b.options,d=b.uiDialog;b.overlay=c.modal?new a.ui.dialog.overlay(b):null,b._size(),b._position(c.position),d.show(c.show),b.moveToTop(!!0),c.modal&&d.bind("keydown.ui-dialog",function(b){if(b.keyCode===a.ui.keyCode.TAB){var c=a(":tabbable",this),d=c.filter(":first"),e=c.filter(":last");if(b.target===e[0]&&!!b.shiftKey){d.focus(1);return!!1}if(b.target===d[0]&&b.shiftKey){e.focus(1);return!!1}}}),a(b.element.find(":tabbable").get().concat(d.find(".ui-dialog-buttonpane :tabbable").get().concat(d.get()))).eq(0).focus(),b._isOpen=!!0,b._trigger("open");return b}},_createButtons:function(b){var c=this,d=!!1,e=a("<div></div>").addClass("ui-dialog-buttonpane ui-widget-content ui-helper-clearfix"),g=a("<div></div>").addClass("ui-dialog-buttonset").appendTo(e);c.uiDialog.find(".ui-dialog-buttonpane").remove(),typeof b=="object"&&b!!==null&&a.each(b,function(){return!!(d=!!0)}),d&&(a.each(b,function(b,d){d=a.isFunction(d)?{click:d,text:b}:d;var e=a(''<button type="button"></button>'').click(function(){d.click.apply(c.element[0],arguments)}).appendTo(g);a.each(d,function(a,b){a!!=="click"&&(a in f?e[a](b):e.attr(a,b))}),a.fn.button&&e.button()}),e.appendTo(c.uiDialog))},_makeDraggable:function(){function f(a){return{position:a.position,offset:a.offset}}var b=this,c=b.options,d=a(document),e;b.uiDialog.draggable({cancel:".ui-dialog-content, .ui-dialog-titlebar-close",handle:".ui-dialog-titlebar",containment:"document",start:function(d,g){e=c.height==="auto"?"auto":a(this).height(),a(this).height(a(this).height()).addClass("ui-dialog-dragging"),b._trigger("dragStart",d,f(g))},drag:function(a,c){b._trigger("drag",a,f(c))},stop:function(g,h){c.position=[h.position.left-d.scrollLeft(),h.position.top-d.scrollTop()],a(this).removeClass("ui-dialog-dragging").height(e),b._trigger("dragStop",g,f(h)),a.ui.dialog.overlay.resize()}})},_makeResizable:function(c){function h(a){return{originalPosition:a.originalPosition,originalSize:a.originalSize,position:a.position,size:a.size}}c=c===b?this.options.resizable:c;var d=this,e=d.options,f=d.uiDialog.css("position"),g=typeof c=="string"?c:"n,e,s,w,se,sw,ne,nw";d.uiDialog.resizable({cancel:".ui-dialog-content",containment:"document",alsoResize:d.element,maxWidth:e.maxWidth,maxHeight:e.maxHeight,minWidth:e.minWidth,minHeight:d._minHeight(),handles:g,start:function(b,c){a(this).addClass("ui-dialog-resizing"),d._trigger("resizeStart",b,h(c))},resize:function(a,b){d._trigger("resize",a,h(b))},stop:function(b,c){a(this).removeClass("ui-dialog-resizing"),e.height=a(this).height(),e.width=a(this).width(),d._trigger("resizeStop",b,h(c)),a.ui.dialog.overlay.resize()}}).css("position",f).find(".ui-resizable-se").addClass("ui-icon ui-icon-grip-diagonal-se")},_minHeight:function(){var a=this.options;return a.height==="auto"?a.minHeight:Math.min(a.minHeight,a.height)},_position:function(b){var c=[],d=[0,0],e;if(b){if(typeof b=="string"||typeof b=="object"&&"0"in b)c=b.split?b.split(" "):[b[0],b[1]],c.length===1&&(c[1]=c[0]),a.each(["left","top"],function(a,b){+c[a]===c[a]&&(d[a]=c[a],c[a]=b)}),b={my:c.join(" "),at:c.join(" "),offset:d.join(" ")};b=a.extend({},a.ui.dialog.prototype.options.position,b)}else b=a.ui.dialog.prototype.options.position;e=this.uiDialog.is(":visible"),e||this.uiDialog.show(),this.uiDialog.css({top:0,left:0}).position(a.extend({of:window},b)),e||this.uiDialog.hide()},_setOptions:function(b){var c=this,f={},g=!!1;a.each(b,function(a,b){c._setOption(a,b),a in d&&(g=!!0),a in e&&(f[a]=b)}),g&&this._size(),this.uiDialog.is(":data(resizable)")&&this.uiDialog.resizable("option",f)},_setOption:function(b,d){var e=this,f=e.uiDialog;switch(b){case"beforeclose":b="beforeClose";break;case"buttons":e._createButtons(d);break;case"closeText":e.uiDialogTitlebarCloseText.text(""+d);break;case"dialogClass":f.removeClass(e.options.dialogClass).addClass(c+d);break;case"disabled":d?f.addClass("ui-dialog-disabled"):f.removeClass("ui-dialog-disabled");break;case"draggable":var g=f.is(":data(draggable)");g&&!!d&&f.draggable("destroy"),!!g&&d&&e._makeDraggable();break;case"position":e._position(d);break;case"resizable":var h=f.is(":data(resizable)");h&&!!d&&f.resizable("destroy"),h&&typeof d=="string"&&f.resizable("option","handles",d),!!h&&d!!==!!1&&e._makeResizable(d);break;case"title":a(".ui-dialog-title",e.uiDialogTitlebar).html(""+(d||"&#160;"))}a.Widget.prototype._setOption.apply(e,arguments)},_size:function(){var b=this.options,c,d,e=this.uiDialog.is(":visible");this.element.show().css({width:"auto",minHeight:0,height:0}),b.minWidth>b.width&&(b.width=b.minWidth),c=this.uiDialog.css({height:"auto",width:b.width}).height(),d=Math.max(0,b.minHeight-c);if(b.height==="auto")if(a.support.minHeight)this.element.css({minHeight:d,height:"auto"});else{this.uiDialog.show();var f=this.element.css("height","auto").height();e||this.uiDialog.hide(),this.element.height(Math.max(f,d))}else this.element.height(Math.max(b.height-c,0));this.uiDialog.is(":data(resizable)")&&this.uiDialog.resizable("option","minHeight",this._minHeight())}}),a.extend(a.ui.dialog,{version:"1.8.18",uuid:0,maxZ:0,getTitleId:function(a){var b=a.attr("id");b||(this.uuid+=1,b=this.uuid);return"ui-dialog-title-"+b},overlay:function(b){this.$el=a.ui.dialog.overlay.create(b)}}),a.extend(a.ui.dialog.overlay,{instances:[],oldInstances:[],maxZ:0,events:a.map("focus,mousedown,mouseup,keydown,keypress,click".split(","),function(a){return a+".dialog-overlay"}).join(" "),create:function(b){this.instances.length===0&&(setTimeout(function(){a.ui.dialog.overlay.instances.length&&a(document).bind(a.ui.dialog.overlay.events,function(b){if(a(b.target).zIndex()<a.ui.dialog.overlay.maxZ)return!!1})},1),a(document).bind("keydown.dialog-overlay",function(c){b.options.closeOnEscape&&!!c.isDefaultPrevented()&&c.keyCode&&c.keyCode===a.ui.keyCode.ESCAPE&&(b.close(c),c.preventDefault())}),a(window).bind("resize.dialog-overlay",a.ui.dialog.overlay.resize));var c=(this.oldInstances.pop()||a("<div></div>").addClass("ui-widget-overlay")).appendTo(document.body).css({width:this.width(),height:this.height()});a.fn.bgiframe&&c.bgiframe(),this.instances.push(c);return c},destroy:function(b){var c=a.inArray(b,this.instances);c!!=-1&&this.oldInstances.push(this.instances.splice(c,1)[0]),this.instances.length===0&&a([document,window]).unbind(".dialog-overlay"),b.remove();var d=0;a.each(this.instances,function(){d=Math.max(d,this.css("z-index"))}),this.maxZ=d},height:function(){var b,c;if(a.browser.msie&&a.browser.version<7){b=Math.max(document.documentElement.scrollHeight,document.body.scrollHeight),c=Math.max(document.documentElement.offsetHeight,document.body.offsetHeight);return b<c?a(window).height()+"px":b+"px"}return a(document).height()+"px"},width:function(){var b,c;if(a.browser.msie){b=Math.max(document.documentElement.scrollWidth,document.body.scrollWidth),c=Math.max(document.documentElement.offsetWidth,document.body.offsetWidth);return b<c?a(window).width()+"px":b+"px"}return a(document).width()+"px"},resize:function(){var b=a([]);a.each(a.ui.dialog.overlay.instances,function(){b=b.add(this)}),b.css({width:0,height:0}).css({width:a.ui.dialog.overlay.width(),height:a.ui.dialog.overlay.height()})}}),a.extend(a.ui.dialog.overlay.prototype,{destroy:function(){a.ui.dialog.overlay.destroy(this.$el)}})})(jQuery);/*
 * jQuery UI Slider 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Slider
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.mouse.js
 *	jquery.ui.widget.js
 */(function(a,b){var c=5;a.widget("ui.slider",a.ui.mouse,{widgetEventPrefix:"slide",options:{animate:!!1,distance:0,max:100,min:0,orientation:"horizontal",range:!!1,step:1,value:0,values:null},_create:function(){var b=this,d=this.options,e=this.element.find(".ui-slider-handle").addClass("ui-state-default ui-corner-all"),f="<a class=''ui-slider-handle ui-state-default ui-corner-all'' href=''#''></a>",g=d.values&&d.values.length||1,h=[];this._keySliding=!!1,this._mouseSliding=!!1,this._animateOff=!!0,this._handleIndex=null,this._detectOrientation(),this._mouseInit(),this.element.addClass("ui-slider ui-slider-"+this.orientation+" ui-widget"+" ui-widget-content"+" ui-corner-all"+(d.disabled?" ui-slider-disabled ui-disabled":"")),this.range=a([]),d.range&&(d.range===!!0&&(d.values||(d.values=[this._valueMin(),this._valueMin()]),d.values.length&&d.values.length!!==2&&(d.values=[d.values[0],d.values[0]])),this.range=a("<div></div>").appendTo(this.element).addClass("ui-slider-range ui-widget-header"+(d.range==="min"||d.range==="max"?" ui-slider-range-"+d.range:"")));for(var i=e.length;i<g;i+=1)h.push(f);this.handles=e.add(a(h.join("")).appendTo(b.element)),this.handle=this.handles.eq(0),this.handles.add(this.range).filter("a").click(function(a){a.preventDefault()}).hover(function(){d.disabled||a(this).addClass("ui-state-hover")},function(){a(this).removeClass("ui-state-hover")}).focus(function(){d.disabled?a(this).blur():(a(".ui-slider .ui-state-focus").removeClass("ui-state-focus"),a(this).addClass("ui-state-focus"))}).blur(function(){a(this).removeClass("ui-state-focus")}),this.handles.each(function(b){a(this).data("index.ui-slider-handle",b)}),this.handles.keydown(function(d){var e=a(this).data("index.ui-slider-handle"),f,g,h,i;if(!!b.options.disabled){switch(d.keyCode){case a.ui.keyCode.HOME:case a.ui.keyCode.END:case a.ui.keyCode.PAGE_UP:case a.ui.keyCode.PAGE_DOWN:case a.ui.keyCode.UP:case a.ui.keyCode.RIGHT:case a.ui.keyCode.DOWN:case a.ui.keyCode.LEFT:d.preventDefault();if(!!b._keySliding){b._keySliding=!!0,a(this).addClass("ui-state-active"),f=b._start(d,e);if(f===!!1)return}}i=b.options.step,b.options.values&&b.options.values.length?g=h=b.values(e):g=h=b.value();switch(d.keyCode){case a.ui.keyCode.HOME:h=b._valueMin();break;case a.ui.keyCode.END:h=b._valueMax();break;case a.ui.keyCode.PAGE_UP:h=b._trimAlignValue(g+(b._valueMax()-b._valueMin())/c);break;case a.ui.keyCode.PAGE_DOWN:h=b._trimAlignValue(g-(b._valueMax()-b._valueMin())/c);break;case a.ui.keyCode.UP:case a.ui.keyCode.RIGHT:if(g===b._valueMax())return;h=b._trimAlignValue(g+i);break;case a.ui.keyCode.DOWN:case a.ui.keyCode.LEFT:if(g===b._valueMin())return;h=b._trimAlignValue(g-i)}b._slide(d,e,h)}}).keyup(function(c){var d=a(this).data("index.ui-slider-handle");b._keySliding&&(b._keySliding=!!1,b._stop(c,d),b._change(c,d),a(this).removeClass("ui-state-active"))}),this._refreshValue(),this._animateOff=!!1},destroy:function(){this.handles.remove(),this.range.remove(),this.element.removeClass("ui-slider ui-slider-horizontal ui-slider-vertical ui-slider-disabled ui-widget ui-widget-content ui-corner-all").removeData("slider").unbind(".slider"),this._mouseDestroy();return this},_mouseCapture:function(b){var c=this.options,d,e,f,g,h,i,j,k,l;if(c.disabled)return!!1;this.elementSize={width:this.element.outerWidth(),height:this.element.outerHeight()},this.elementOffset=this.element.offset(),d={x:b.pageX,y:b.pageY},e=this._normValueFromMouse(d),f=this._valueMax()-this._valueMin()+1,h=this,this.handles.each(function(b){var c=Math.abs(e-h.values(b));f>c&&(f=c,g=a(this),i=b)}),c.range===!!0&&this.values(1)===c.min&&(i+=1,g=a(this.handles[i])),j=this._start(b,i);if(j===!!1)return!!1;this._mouseSliding=!!0,h._handleIndex=i,g.addClass("ui-state-active").focus(),k=g.offset(),l=!!a(b.target).parents().andSelf().is(".ui-slider-handle"),this._clickOffset=l?{left:0,top:0}:{left:b.pageX-k.left-g.width()/2,top:b.pageY-k.top-g.height()/2-(parseInt(g.css("borderTopWidth"),10)||0)-(parseInt(g.css("borderBottomWidth"),10)||0)+(parseInt(g.css("marginTop"),10)||0)},this.handles.hasClass("ui-state-hover")||this._slide(b,i,e),this._animateOff=!!0;return!!0},_mouseStart:function(a){return!!0},_mouseDrag:function(a){var b={x:a.pageX,y:a.pageY},c=this._normValueFromMouse(b);this._slide(a,this._handleIndex,c);return!!1},_mouseStop:function(a){this.handles.removeClass("ui-state-active"),this._mouseSliding=!!1,this._stop(a,this._handleIndex),this._change(a,this._handleIndex),this._handleIndex=null,this._clickOffset=null,this._animateOff=!!1;return!!1},_detectOrientation:function(){this.orientation=this.options.orientation==="vertical"?"vertical":"horizontal"},_normValueFromMouse:function(a){var b,c,d,e,f;this.orientation==="horizontal"?(b=this.elementSize.width,c=a.x-this.elementOffset.left-(this._clickOffset?this._clickOffset.left:0)):(b=this.elementSize.height,c=a.y-this.elementOffset.top-(this._clickOffset?this._clickOffset.top:0)),d=c/b,d>1&&(d=1),d<0&&(d=0),this.orientation==="vertical"&&(d=1-d),e=this._valueMax()-this._valueMin(),f=this._valueMin()+d*e;return this._trimAlignValue(f)},_start:function(a,b){var c={handle:this.handles[b],value:this.value()};this.options.values&&this.options.values.length&&(c.value=this.values(b),c.values=this.values());return this._trigger("start",a,c)},_slide:function(a,b,c){var d,e,f;this.options.values&&this.options.values.length?(d=this.values(b?0:1),this.options.values.length===2&&this.options.range===!!0&&(b===0&&c>d||b===1&&c<d)&&(c=d),c!!==this.values(b)&&(e=this.values(),e[b]=c,f=this._trigger("slide",a,{handle:this.handles[b],value:c,values:e}),d=this.values(b?0:1),f!!==!!1&&this.values(b,c,!!0))):c!!==this.value()&&(f=this._trigger("slide",a,{handle:this.handles[b],value:c}),f!!==!!1&&this.value(c))},_stop:function(a,b){var c={handle:this.handles[b],value:this.value()};this.options.values&&this.options.values.length&&(c.value=this.values(b),c.values=this.values()),this._trigger("stop",a,c)},_change:function(a,b){if(!!this._keySliding&&!!this._mouseSliding){var c={handle:this.handles[b],value:this.value()};this.options.values&&this.options.values.length&&(c.value=this.values(b),c.values=this.values()),this._trigger("change",a,c)}},value:function(a){if(arguments.length)this.options.value=this._trimAlignValue(a),this._refreshValue(),this._change(null,0);else return this._value()},values:function(b,c){var d,e,f;if(arguments.length>1)this.options.values[b]=this._trimAlignValue(c),this._refreshValue(),this._change(null,b);else{if(!!arguments.length)return this._values();if(!!a.isArray(arguments[0]))return this.options.values&&this.options.values.length?this._values(b):this.value();d=this.options.values,e=arguments[0];for(f=0;f<d.length;f+=1)d[f]=this._trimAlignValue(e[f]),this._change(null,f);this._refreshValue()}},_setOption:function(b,c){var d,e=0;a.isArray(this.options.values)&&(e=this.options.values.length),a.Widget.prototype._setOption.apply(this,arguments);switch(b){case"disabled":c?(this.handles.filter(".ui-state-focus").blur(),this.handles.removeClass("ui-state-hover"),this.handles.propAttr("disabled",!!0),this.element.addClass("ui-disabled")):(this.handles.propAttr("disabled",!!1),this.element.removeClass("ui-disabled"));break;case"orientation":this._detectOrientation(),this.element.removeClass("ui-slider-horizontal ui-slider-vertical").addClass("ui-slider-"+this.orientation),this._refreshValue();break;case"value":this._animateOff=!!0,this._refreshValue(),this._change(null,0),this._animateOff=!!1;break;case"values":this._animateOff=!!0,this._refreshValue();for(d=0;d<e;d+=1)this._change(null,d);this._animateOff=!!1}},_value:function(){var a=this.options.value;a=this._trimAlignValue(a);return a},_values:function(a){var b,c,d;if(arguments.length){b=this.options.values[a],b=this._trimAlignValue(b);return b}c=this.options.values.slice();for(d=0;d<c.length;d+=1)c[d]=this._trimAlignValue(c[d]);return c},_trimAlignValue:function(a){if(a<=this._valueMin())return this._valueMin();if(a>=this._valueMax())return this._valueMax();var b=this.options.step>0?this.options.step:1,c=(a-this._valueMin())%b,d=a-c;Math.abs(c)*2>=b&&(d+=c>0?b:-b);return parseFloat(d.toFixed(5))},_valueMin:function(){return this.options.min},_valueMax:function(){return this.options.max},_refreshValue:function(){var b=this.options.range,c=this.options,d=this,e=this._animateOff?!!1:c.animate,f,g={},h,i,j,k;this.options.values&&this.options.values.length?this.handles.each(function(b,i){f=(d.values(b)-d._valueMin())/(d._valueMax()-d._valueMin())*100,g[d.orientation==="horizontal"?"left":"bottom"]=f+"%",a(this).stop(1,1)[e?"animate":"css"](g,c.animate),d.options.range===!!0&&(d.orientation==="horizontal"?(b===0&&d.range.stop(1,1)[e?"animate":"css"]({left:f+"%"},c.animate),b===1&&d.range[e?"animate":"css"]({width:f-h+"%"},{queue:!!1,duration:c.animate})):(b===0&&d.range.stop(1,1)[e?"animate":"css"]({bottom:f+"%"},c.animate),b===1&&d.range[e?"animate":"css"]({height:f-h+"%"},{queue:!!1,duration:c.animate}))),h=f}):(i=this.value(),j=this._valueMin(),k=this._valueMax(),f=k!!==j?(i-j)/(k-j)*100:0,g[d.orientation==="horizontal"?"left":"bottom"]=f+"%",this.handle.stop(1,1)[e?"animate":"css"](g,c.animate),b==="min"&&this.orientation==="horizontal"&&this.range.stop(1,1)[e?"animate":"css"]({width:f+"%"},c.animate),b==="max"&&this.orientation==="horizontal"&&this.range[e?"animate":"css"]({width:100-f+"%"},{queue:!!1,duration:c.animate}),b==="min"&&this.orientation==="vertical"&&this.range.stop(1,1)[e?"animate":"css"]({height:f+"%"},c.animate),b==="max"&&this.orientation==="vertical"&&this.range[e?"animate":"css"]({height:100-f+"%"},{queue:!!1,duration:c.animate}))}}),a.extend(a.ui.slider,{version:"1.8.18"})})(jQuery);/*
 * jQuery UI Tabs 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Tabs
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 */(function(a,b){function f(){return++d}function e(){return++c}var c=0,d=0;a.widget("ui.tabs",{options:{add:null,ajaxOptions:null,cache:!!1,cookie:null,collapsible:!!1,disable:null,disabled:[],enable:null,event:"click",fx:null,idPrefix:"ui-tabs-",load:null,panelTemplate:"<div></div>",remove:null,select:null,show:null,spinner:"<em>Loading&#8230;</em>",tabTemplate:"<li><a href=''#{href}''><span>#{label}</span></a></li>"},_create:function(){this._tabify(!!0)},_setOption:function(a,b){if(a=="selected"){if(this.options.collapsible&&b==this.options.selected)return;this.select(b)}else this.options[a]=b,this._tabify()},_tabId:function(a){return a.title&&a.title.replace(/\s/g,"_").replace(/[^\w\u00c0-\uFFFF-]/g,"")||this.options.idPrefix+e()},_sanitizeSelector:function(a){return a.replace(/:/g,"\\:")},_cookie:function(){var b=this.cookie||(this.cookie=this.options.cookie.name||"ui-tabs-"+f());return a.cookie.apply(null,[b].concat(a.makeArray(arguments)))},_ui:function(a,b){return{tab:a,panel:b,index:this.anchors.index(a)}},_cleanup:function(){this.lis.filter(".ui-state-processing").removeClass("ui-state-processing").find("span:data(label.tabs)").each(function(){var b=a(this);b.html(b.data("label.tabs")).removeData("label.tabs")})},_tabify:function(c){function m(b,c){b.css("display",""),!!a.support.opacity&&c.opacity&&b[0].style.removeAttribute("filter")}var d=this,e=this.options,f=/^#.+/;this.list=this.element.find("ol,ul").eq(0),this.lis=a(" > li:has(a[href])",this.list),this.anchors=this.lis.map(function(){return a("a",this)[0]}),this.panels=a([]),this.anchors.each(function(b,c){var g=a(c).attr("href"),h=g.split("#")[0],i;h&&(h===location.toString().split("#")[0]||(i=a("base")[0])&&h===i.href)&&(g=c.hash,c.href=g);if(f.test(g))d.panels=d.panels.add(d.element.find(d._sanitizeSelector(g)));else if(g&&g!!=="#"){a.data(c,"href.tabs",g),a.data(c,"load.tabs",g.replace(/#.*$/,""));var j=d._tabId(c);c.href="#"+j;var k=d.element.find("#"+j);k.length||(k=a(e.panelTemplate).attr("id",j).addClass("ui-tabs-panel ui-widget-content ui-corner-bottom").insertAfter(d.panels[b-1]||d.list),k.data("destroy.tabs",!!0)),d.panels=d.panels.add(k)}else e.disabled.push(b)}),c?(this.element.addClass("ui-tabs ui-widget ui-widget-content ui-corner-all"),this.list.addClass("ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all"),this.lis.addClass("ui-state-default ui-corner-top"),this.panels.addClass("ui-tabs-panel ui-widget-content ui-corner-bottom"),e.selected===b?(location.hash&&this.anchors.each(function(a,b){if(b.hash==location.hash){e.selected=a;return!!1}}),typeof e.selected!!="number"&&e.cookie&&(e.selected=parseInt(d._cookie(),10)),typeof e.selected!!="number"&&this.lis.filter(".ui-tabs-selected").length&&(e.selected=this.lis.index(this.lis.filter(".ui-tabs-selected"))),e.selected=e.selected||(this.lis.length?0:-1)):e.selected===null&&(e.selected=-1),e.selected=e.selected>=0&&this.anchors[e.selected]||e.selected<0?e.selected:0,e.disabled=a.unique(e.disabled.concat(a.map(this.lis.filter(".ui-state-disabled"),function(a,b){return d.lis.index(a)}))).sort(),a.inArray(e.selected,e.disabled)!!=-1&&e.disabled.splice(a.inArray(e.selected,e.disabled),1),this.panels.addClass("ui-tabs-hide"),this.lis.removeClass("ui-tabs-selected ui-state-active"),e.selected>=0&&this.anchors.length&&(d.element.find(d._sanitizeSelector(d.anchors[e.selected].hash)).removeClass("ui-tabs-hide"),this.lis.eq(e.selected).addClass("ui-tabs-selected ui-state-active"),d.element.queue("tabs",function(){d._trigger("show",null,d._ui(d.anchors[e.selected],d.element.find(d._sanitizeSelector(d.anchors[e.selected].hash))[0]))}),this.load(e.selected)),a(window).bind("unload",function(){d.lis.add(d.anchors).unbind(".tabs"),d.lis=d.anchors=d.panels=null})):e.selected=this.lis.index(this.lis.filter(".ui-tabs-selected")),this.element[e.collapsible?"addClass":"removeClass"]("ui-tabs-collapsible"),e.cookie&&this._cookie(e.selected,e.cookie);for(var g=0,h;h=this.lis[g];g++)a(h)[a.inArray(g,e.disabled)!!=-1&&!!a(h).hasClass("ui-tabs-selected")?"addClass":"removeClass"]("ui-state-disabled");e.cache===!!1&&this.anchors.removeData("cache.tabs"),this.lis.add(this.anchors).unbind(".tabs");if(e.event!!=="mouseover"){var i=function(a,b){b.is(":not(.ui-state-disabled)")&&b.addClass("ui-state-"+a)},j=function(a,b){b.removeClass("ui-state-"+a)};this.lis.bind("mouseover.tabs",function(){i("hover",a(this))}),this.lis.bind("mouseout.tabs",function(){j("hover",a(this))}),this.anchors.bind("focus.tabs",function(){i("focus",a(this).closest("li"))}),this.anchors.bind("blur.tabs",function(){j("focus",a(this).closest("li"))})}var k,l;e.fx&&(a.isArray(e.fx)?(k=e.fx[0],l=e.fx[1]):k=l=e.fx);var n=l?function(b,c){a(b).closest("li").addClass("ui-tabs-selected ui-state-active"),c.hide().removeClass("ui-tabs-hide").animate(l,l.duration||"normal",function(){m(c,l),d._trigger("show",null,d._ui(b,c[0]))})}:function(b,c){a(b).closest("li").addClass("ui-tabs-selected ui-state-active"),c.removeClass("ui-tabs-hide"),d._trigger("show",null,d._ui(b,c[0]))},o=k?function(a,b){b.animate(k,k.duration||"normal",function(){d.lis.removeClass("ui-tabs-selected ui-state-active"),b.addClass("ui-tabs-hide"),m(b,k),d.element.dequeue("tabs")})}:function(a,b,c){d.lis.removeClass("ui-tabs-selected ui-state-active"),b.addClass("ui-tabs-hide"),d.element.dequeue("tabs")};this.anchors.bind(e.event+".tabs",function(){var b=this,c=a(b).closest("li"),f=d.panels.filter(":not(.ui-tabs-hide)"),g=d.element.find(d._sanitizeSelector(b.hash));if(c.hasClass("ui-tabs-selected")&&!!e.collapsible||c.hasClass("ui-state-disabled")||c.hasClass("ui-state-processing")||d.panels.filter(":animated").length||d._trigger("select",null,d._ui(this,g[0]))===!!1){this.blur();return!!1}e.selected=d.anchors.index(this),d.abort();if(e.collapsible){if(c.hasClass("ui-tabs-selected")){e.selected=-1,e.cookie&&d._cookie(e.selected,e.cookie),d.element.queue("tabs",function(){o(b,f)}).dequeue("tabs"),this.blur();return!!1}if(!!f.length){e.cookie&&d._cookie(e.selected,e.cookie),d.element.queue("tabs",function(){n(b,g)}),d.load(d.anchors.index(this)),this.blur();return!!1}}e.cookie&&d._cookie(e.selected,e.cookie);if(g.length)f.length&&d.element.queue("tabs",function(){o(b,f)}),d.element.queue("tabs",function(){n(b,g)}),d.load(d.anchors.index(this));else throw"jQuery UI Tabs: Mismatching fragment identifier.";a.browser.msie&&this.blur()}),this.anchors.bind("click.tabs",function(){return!!1})},_getIndex:function(a){typeof a=="string"&&(a=this.anchors.index(this.anchors.filter("[href$="+a+"]")));return a},destroy:function(){var b=this.options;this.abort(),this.element.unbind(".tabs").removeClass("ui-tabs ui-widget ui-widget-content ui-corner-all ui-tabs-collapsible").removeData("tabs"),this.list.removeClass("ui-tabs-nav ui-helper-reset ui-helper-clearfix ui-widget-header ui-corner-all"),this.anchors.each(function(){var b=a.data(this,"href.tabs");b&&(this.href=b);var c=a(this).unbind(".tabs");a.each(["href","load","cache"],function(a,b){c.removeData(b+".tabs")})}),this.lis.unbind(".tabs").add(this.panels).each(function(){a.data(this,"destroy.tabs")?a(this).remove():a(this).removeClass(["ui-state-default","ui-corner-top","ui-tabs-selected","ui-state-active","ui-state-hover","ui-state-focus","ui-state-disabled","ui-tabs-panel","ui-widget-content","ui-corner-bottom","ui-tabs-hide"].join(" "))}),b.cookie&&this._cookie(null,b.cookie);return this},add:function(c,d,e){e===b&&(e=this.anchors.length);var f=this,g=this.options,h=a(g.tabTemplate.replace(/#\{href\}/g,c).replace(/#\{label\}/g,d)),i=c.indexOf("#")?this._tabId(a("a",h)[0]):c.replace("#","");h.addClass("ui-state-default ui-corner-top").data("destroy.tabs",!!0);var j=f.element.find("#"+i);j.length||(j=a(g.panelTemplate).attr("id",i).data("destroy.tabs",!!0)),j.addClass("ui-tabs-panel ui-widget-content ui-corner-bottom ui-tabs-hide"),e>=this.lis.length?(h.appendTo(this.list),j.appendTo(this.list[0].parentNode)):(h.insertBefore(this.lis[e]),j.insertBefore(this.panels[e])),g.disabled=a.map(g.disabled,function(a,b){return a>=e?++a:a}),this._tabify(),this.anchors.length==1&&(g.selected=0,h.addClass("ui-tabs-selected ui-state-active"),j.removeClass("ui-tabs-hide"),this.element.queue("tabs",function(){f._trigger("show",null,f._ui(f.anchors[0],f.panels[0]))}),this.load(0)),this._trigger("add",null,this._ui(this.anchors[e],this.panels[e]));return this},remove:function(b){b=this._getIndex(b);var c=this.options,d=this.lis.eq(b).remove(),e=this.panels.eq(b).remove();d.hasClass("ui-tabs-selected")&&this.anchors.length>1&&this.select(b+(b+1<this.anchors.length?1:-1)),c.disabled=a.map(a.grep(c.disabled,function(a,c){return a!!=b}),function(a,c){return a>=b?--a:a}),this._tabify(),this._trigger("remove",null,this._ui(d.find("a")[0],e[0]));return this},enable:function(b){b=this._getIndex(b);var c=this.options;if(a.inArray(b,c.disabled)!!=-1){this.lis.eq(b).removeClass("ui-state-disabled"),c.disabled=a.grep(c.disabled,function(a,c){return a!!=b}),this._trigger("enable",null,this._ui(this.anchors[b],this.panels[b]));return this}},disable:function(a){a=this._getIndex(a);var b=this,c=this.options;a!!=c.selected&&(this.lis.eq(a).addClass("ui-state-disabled"),c.disabled.push(a),c.disabled.sort(),this._trigger("disable",null,this._ui(this.anchors[a],this.panels[a])));return this},select:function(a){a=this._getIndex(a);if(a==-1)if(this.options.collapsible&&this.options.selected!!=-1)a=this.options.selected;else return this;this.anchors.eq(a).trigger(this.options.event+".tabs");return this},load:function(b){b=this._getIndex(b);var c=this,d=this.options,e=this.anchors.eq(b)[0],f=a.data(e,"load.tabs");this.abort();if(!!f||this.element.queue("tabs").length!!==0&&a.data(e,"cache.tabs"))this.element.dequeue("tabs");else{this.lis.eq(b).addClass("ui-state-processing");if(d.spinner){var g=a("span",e);g.data("label.tabs",g.html()).html(d.spinner)}this.xhr=a.ajax(a.extend({},d.ajaxOptions,{url:f,success:function(f,g){c.element.find(c._sanitizeSelector(e.hash)).html(f),c._cleanup(),d.cache&&a.data(e,"cache.tabs",!!0),c._trigger("load",null,c._ui(c.anchors[b],c.panels[b]));try{d.ajaxOptions.success(f,g)}catch(h){}},error:function(a,f,g){c._cleanup(),c._trigger("load",null,c._ui(c.anchors[b],c.panels[b]));try{d.ajaxOptions.error(a,f,b,e)}catch(g){}}})),c.element.dequeue("tabs");return this}},abort:function(){this.element.queue([]),this.panels.stop(!!1,!!0),this.element.queue("tabs",this.element.queue("tabs").splice(-2,2)),this.xhr&&(this.xhr.abort(),delete this.xhr),this._cleanup();return this},url:function(a,b){this.anchors.eq(a).removeData("cache.tabs").data("load.tabs",b);return this},length:function(){return this.anchors.length}}),a.extend(a.ui.tabs,{version:"1.8.18"}),a.extend(a.ui.tabs.prototype,{rotation:null,rotate:function(a,b){var c=this,d=this.options,e=c._rotate||(c._rotate=function(b){clearTimeout(c.rotation),c.rotation=setTimeout(function(){var a=d.selected;c.select(++a<c.anchors.length?a:0)},a),b&&b.stopPropagation()}),f=c._unrotate||(c._unrotate=b?function(a){t=d.selected,e()}:function(a){a.clientX&&c.rotate(null)});a?(this.element.bind("tabsshow",e),this.anchors.bind(d.event+".tabs",f),e()):(clearTimeout(c.rotation),this.element.unbind("tabsshow",e),this.anchors.unbind(d.event+".tabs",f),delete this._rotate,delete this._unrotate);return this}})})(jQuery);/*
 * jQuery UI Datepicker 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Datepicker
 *
 * Depends:
 *	jquery.ui.core.js
 */(function($,undefined){function isArray(a){return a&&($.browser.safari&&typeof a=="object"&&a.length||a.constructor&&a.constructor.toString().match(/\Array\(\)/))}function extendRemove(a,b){$.extend(a,b);for(var c in b)if(b[c]==null||b[c]==undefined)a[c]=b[c];return a}function bindHover(a){var b="button, .ui-datepicker-prev, .ui-datepicker-next, .ui-datepicker-calendar td a";return a.bind("mouseout",function(a){var c=$(a.target).closest(b);!!c.length||c.removeClass("ui-state-hover ui-datepicker-prev-hover ui-datepicker-next-hover")}).bind("mouseover",function(c){var d=$(c.target).closest(b);!!$.datepicker._isDisabledDatepicker(instActive.inline?a.parent()[0]:instActive.input[0])&&!!!!d.length&&(d.parents(".ui-datepicker-calendar").find("a").removeClass("ui-state-hover"),d.addClass("ui-state-hover"),d.hasClass("ui-datepicker-prev")&&d.addClass("ui-datepicker-prev-hover"),d.hasClass("ui-datepicker-next")&&d.addClass("ui-datepicker-next-hover"))})}function Datepicker(){this.debug=!!1,this._curInst=null,this._keyEvent=!!1,this._disabledInputs=[],this._datepickerShowing=!!1,this._inDialog=!!1,this._mainDivId="ui-datepicker-div",this._inlineClass="ui-datepicker-inline",this._appendClass="ui-datepicker-append",this._triggerClass="ui-datepicker-trigger",this._dialogClass="ui-datepicker-dialog",this._disableClass="ui-datepicker-disabled",this._unselectableClass="ui-datepicker-unselectable",this._currentClass="ui-datepicker-current-day",this._dayOverClass="ui-datepicker-days-cell-over",this.regional=[],this.regional[""]={closeText:"Done",prevText:"Prev",nextText:"Next",currentText:"Today",monthNames:["January","February","March","April","May","June","July","August","September","October","November","December"],monthNamesShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dayNames:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],dayNamesShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayNamesMin:["Su","Mo","Tu","We","Th","Fr","Sa"],weekHeader:"Wk",dateFormat:"mm/dd/yy",firstDay:0,isRTL:!!1,showMonthAfterYear:!!1,yearSuffix:""},this._defaults={showOn:"focus",showAnim:"fadeIn",showOptions:{},defaultDate:null,appendText:"",buttonText:"...",buttonImage:"",buttonImageOnly:!!1,hideIfNoPrevNext:!!1,navigationAsDateFormat:!!1,gotoCurrent:!!1,changeMonth:!!1,changeYear:!!1,yearRange:"c-10:c+10",showOtherMonths:!!1,selectOtherMonths:!!1,showWeek:!!1,calculateWeek:this.iso8601Week,shortYearCutoff:"+10",minDate:null,maxDate:null,duration:"fast",beforeShowDay:null,beforeShow:null,onSelect:null,onChangeMonthYear:null,onClose:null,numberOfMonths:1,showCurrentAtPos:0,stepMonths:1,stepBigMonths:12,altField:"",altFormat:"",constrainInput:!!0,showButtonPanel:!!1,autoSize:!!1,disabled:!!1},$.extend(this._defaults,this.regional[""]),this.dpDiv=bindHover($(''<div id="''+this._mainDivId+''" class="ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all"></div>''))}$.extend($.ui,{datepicker:{version:"1.8.18"}});var PROP_NAME="datepicker",dpuuid=(new Date).getTime(),instActive;$.extend(Datepicker.prototype,{markerClassName:"hasDatepicker",maxRows:4,log:function(){this.debug&&console.log.apply("",arguments)},_widgetDatepicker:function(){return this.dpDiv},setDefaults:function(a){extendRemove(this._defaults,a||{});return this},_attachDatepicker:function(target,settings){var inlineSettings=null;for(var attrName in this._defaults){var attrValue=target.getAttribute("date:"+attrName);if(attrValue){inlineSettings=inlineSettings||{};try{inlineSettings[attrName]=eval(attrValue)}catch(err){inlineSettings[attrName]=attrValue}}}var nodeName=target.nodeName.toLowerCase(),inline=nodeName=="div"||nodeName=="span";target.id||(this.uuid+=1,target.id="dp"+this.uuid);var inst=this._newInst($(target),inline);inst.settings=$.extend({},settings||{},inlineSettings||{}),nodeName=="input"?this._connectDatepicker(target,inst):inline&&this._inlineDatepicker(target,inst)},_newInst:function(a,b){var c=a[0].id.replace(/([^A-Za-z0-9_-])/g,"\\\\$1");return{id:c,input:a,selectedDay:0,selectedMonth:0,selectedYear:0,drawMonth:0,drawYear:0,inline:b,dpDiv:b?bindHover($(''<div class="''+this._inlineClass+'' ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all"></div>'')):this.dpDiv}},_connectDatepicker:function(a,b){var c=$(a);b.append=$([]),b.trigger=$([]);c.hasClass(this.markerClassName)||(this._attachments(c,b),c.addClass(this.markerClassName).keydown(this._doKeyDown).keypress(this._doKeyPress).keyup(this._doKeyUp).bind("setData.datepicker",function(a,c,d){b.settings[c]=d}).bind("getData.datepicker",function(a,c){return this._get(b,c)}),this._autoSize(b),$.data(a,PROP_NAME,b),b.settings.disabled&&this._disableDatepicker(a))},_attachments:function(a,b){var c=this._get(b,"appendText"),d=this._get(b,"isRTL");b.append&&b.append.remove(),c&&(b.append=$(''<span class="''+this._appendClass+''">''+c+"</span>"),a[d?"before":"after"](b.append)),a.unbind("focus",this._showDatepicker),b.trigger&&b.trigger.remove();var e=this._get(b,"showOn");(e=="focus"||e=="both")&&a.focus(this._showDatepicker);if(e=="button"||e=="both"){var f=this._get(b,"buttonText"),g=this._get(b,"buttonImage");b.trigger=$(this._get(b,"buttonImageOnly")?$("<img/>").addClass(this._triggerClass).attr({src:g,alt:f,title:f}):$(''<button type="button"></button>'').addClass(this._triggerClass).html(g==""?f:$("<img/>").attr({src:g,alt:f,title:f}))),a[d?"before":"after"](b.trigger),b.trigger.click(function(){$.datepicker._datepickerShowing&&$.datepicker._lastInput==a[0]?$.datepicker._hideDatepicker():$.datepicker._datepickerShowing&&$.datepicker._lastInput!!=a[0]?($.datepicker._hideDatepicker(),$.datepicker._showDatepicker(a[0])):$.datepicker._showDatepicker(a[0]);return!!1})}},_autoSize:function(a){if(this._get(a,"autoSize")&&!!a.inline){var b=new Date(2009,11,20),c=this._get(a,"dateFormat");if(c.match(/[DM]/)){var d=function(a){var b=0,c=0;for(var d=0;d<a.length;d++)a[d].length>b&&(b=a[d].length,c=d);return c};b.setMonth(d(this._get(a,c.match(/MM/)?"monthNames":"monthNamesShort"))),b.setDate(d(this._get(a,c.match(/DD/)?"dayNames":"dayNamesShort"))+20-b.getDay())}a.input.attr("size",this._formatDate(a,b).length)}},_inlineDatepicker:function(a,b){var c=$(a);c.hasClass(this.markerClassName)||(c.addClass(this.markerClassName).append(b.dpDiv).bind("setData.datepicker",function(a,c,d){b.settings[c]=d}).bind("getData.datepicker",function(a,c){return this._get(b,c)}),$.data(a,PROP_NAME,b),this._setDate(b,this._getDefaultDate(b),!!0),this._updateDatepicker(b),this._updateAlternate(b),b.settings.disabled&&this._disableDatepicker(a),b.dpDiv.css("display","block"))},_dialogDatepicker:function(a,b,c,d,e){var f=this._dialogInst;if(!!f){this.uuid+=1;var g="dp"+this.uuid;this._dialogInput=$(''<input type="text" id="''+g+''" style="position: absolute; top: -100px; width: 0px; z-index: -10;"/>''),this._dialogInput.keydown(this._doKeyDown),$("body").append(this._dialogInput),f=this._dialogInst=this._newInst(this._dialogInput,!!1),f.settings={},$.data(this._dialogInput[0],PROP_NAME,f)}extendRemove(f.settings,d||{}),b=b&&b.constructor==Date?this._formatDate(f,b):b,this._dialogInput.val(b),this._pos=e?e.length?e:[e.pageX,e.pageY]:null;if(!!this._pos){var h=document.documentElement.clientWidth,i=document.documentElement.clientHeight,j=document.documentElement.scrollLeft||document.body.scrollLeft,k=document.documentElement.scrollTop||document.body.scrollTop;this._pos=[h/2-100+j,i/2-150+k]}this._dialogInput.css("left",this._pos[0]+20+"px").css("top",this._pos[1]+"px"),f.settings.onSelect=c,this._inDialog=!!0,this.dpDiv.addClass(this._dialogClass),this._showDatepicker(this._dialogInput[0]),$.blockUI&&$.blockUI(this.dpDiv),$.data(this._dialogInput[0],PROP_NAME,f);return this},_destroyDatepicker:function(a){var b=$(a),c=$.data(a,PROP_NAME);if(!!!!b.hasClass(this.markerClassName)){var d=a.nodeName.toLowerCase();$.removeData(a,PROP_NAME),d=="input"?(c.append.remove(),c.trigger.remove(),b.removeClass(this.markerClassName).unbind("focus",this._showDatepicker).unbind("keydown",this._doKeyDown).unbind("keypress",this._doKeyPress).unbind("keyup",this._doKeyUp)):(d=="div"||d=="span")&&b.removeClass(this.markerClassName).empty()}},_enableDatepicker:function(a){var b=$(a),c=$.data(a,PROP_NAME);if(!!!!b.hasClass(this.markerClassName)){var d=a.nodeName.toLowerCase();if(d=="input")a.disabled=!!1,c.trigger.filter("button").each(function(){this.disabled=!!1}).end().filter("img").css({opacity:"1.0",cursor:""});else if(d=="div"||d=="span"){var e=b.children("."+this._inlineClass);e.children().removeClass("ui-state-disabled"),e.find("select.ui-datepicker-month, select.ui-datepicker-year").removeAttr("disabled")}this._disabledInputs=$.map(this._disabledInputs,function(b){return b==a?null:b})}},_disableDatepicker:function(a){var b=$(a),c=$.data(a,PROP_NAME);if(!!!!b.hasClass(this.markerClassName)){var d=a.nodeName.toLowerCase();if(d=="input")a.disabled=!!0,c.trigger.filter("button").each(function(){this.disabled=!!0}).end().filter("img").css({opacity:"0.5",cursor:"default"});else if(d=="div"||d=="span"){var e=b.children("."+this._inlineClass);e.children().addClass("ui-state-disabled"),e.find("select.ui-datepicker-month, select.ui-datepicker-year").attr("disabled","disabled")}this._disabledInputs=$.map(this._disabledInputs,function(b){return b==a?null:b}),this._disabledInputs[this._disabledInputs.length]=a}},_isDisabledDatepicker:function(a){if(!!a)return!!1;for(var b=0;b<this._disabledInputs.length;b++)if(this._disabledInputs[b]==a)return!!0;return!!1},_getInst:function(a){try{return $.data(a,PROP_NAME)}catch(b){throw"Missing instance data for this datepicker"}},_optionDatepicker:function(a,b,c){var d=this._getInst(a);if(arguments.length==2&&typeof b=="string")return b=="defaults"?$.extend({},$.datepicker._defaults):d?b=="all"?$.extend({},d.settings):this._get(d,b):null;var e=b||{};typeof b=="string"&&(e={},e[b]=c);if(d){this._curInst==d&&this._hideDatepicker();var f=this._getDateDatepicker(a,!!0),g=this._getMinMaxDate(d,"min"),h=this._getMinMaxDate(d,"max");extendRemove(d.settings,e),g!!==null&&e.dateFormat!!==undefined&&e.minDate===undefined&&(d.settings.minDate=this._formatDate(d,g)),h!!==null&&e.dateFormat!!==undefined&&e.maxDate===undefined&&(d.settings.maxDate=this._formatDate(d,h)),this._attachments($(a),d),this._autoSize(d),this._setDate(d,f),this._updateAlternate(d),this._updateDatepicker(d)}},_changeDatepicker:function(a,b,c){this._optionDatepicker(a,b,c)},_refreshDatepicker:function(a){var b=this._getInst(a);b&&this._updateDatepicker(b)},_setDateDatepicker:function(a,b){var c=this._getInst(a);c&&(this._setDate(c,b),this._updateDatepicker(c),this._updateAlternate(c))},_getDateDatepicker:function(a,b){var c=this._getInst(a);c&&!!c.inline&&this._setDateFromField(c,b);return c?this._getDate(c):null},_doKeyDown:function(a){var b=$.datepicker._getInst(a.target),c=!!0,d=b.dpDiv.is(".ui-datepicker-rtl");b._keyEvent=!!0;if($.datepicker._datepickerShowing)switch(a.keyCode){case 9:$.datepicker._hideDatepicker(),c=!!1;break;case 13:var e=$("td."+$.datepicker._dayOverClass+":not(."+$.datepicker._currentClass+")",b.dpDiv);e[0]&&$.datepicker._selectDay(a.target,b.selectedMonth,b.selectedYear,e[0]);var f=$.datepicker._get(b,"onSelect");if(f){var g=$.datepicker._formatDate(b);f.apply(b.input?b.input[0]:null,[g,b])}else $.datepicker._hideDatepicker();return!!1;case 27:$.datepicker._hideDatepicker();break;case 33:$.datepicker._adjustDate(a.target,a.ctrlKey?-$.datepicker._get(b,"stepBigMonths"):-$.datepicker._get(b,"stepMonths"),"M");break;case 34:$.datepicker._adjustDate(a.target,a.ctrlKey?+$.datepicker._get(b,"stepBigMonths"):+$.datepicker._get(b,"stepMonths"),"M");break;case 35:(a.ctrlKey||a.metaKey)&&$.datepicker._clearDate(a.target),c=a.ctrlKey||a.metaKey;break;case 36:(a.ctrlKey||a.metaKey)&&$.datepicker._gotoToday(a.target),c=a.ctrlKey||a.metaKey;break;case 37:(a.ctrlKey||a.metaKey)&&$.datepicker._adjustDate(a.target,d?1:-1,"D"),c=a.ctrlKey||a.metaKey,a.originalEvent.altKey&&$.datepicker._adjustDate(a.target,a.ctrlKey?-$.datepicker._get(b,"stepBigMonths"):-$.datepicker._get(b,"stepMonths"),"M");break;case 38:(a.ctrlKey||a.metaKey)&&$.datepicker._adjustDate(a.target,-7,"D"),c=a.ctrlKey||a.metaKey;break;case 39:(a.ctrlKey||a.metaKey)&&$.datepicker._adjustDate(a.target,d?-1:1,"D"),c=a.ctrlKey||a.metaKey,a.originalEvent.altKey&&$.datepicker._adjustDate(a.target,a.ctrlKey?+$.datepicker._get(b,"stepBigMonths"):+$.datepicker._get(b,"stepMonths"),"M");break;case 40:(a.ctrlKey||a.metaKey)&&$.datepicker._adjustDate(a.target,7,"D"),c=a.ctrlKey||a.metaKey;break;default:c=!!1}else a.keyCode==36&&a.ctrlKey?$.datepicker._showDatepicker(this):c=!!1;c&&(a.preventDefault(),a.stopPropagation())},_doKeyPress:function(a){var b=$.datepicker._getInst(a.target);if($.datepicker._get(b,"constrainInput")){var c=$.datepicker._possibleChars($.datepicker._get(b,"dateFormat")),d=String.fromCharCode(a.charCode==undefined?a.keyCode:a.charCode);return a.ctrlKey||a.metaKey||d<" "||!!c||c.indexOf(d)>-1}},_doKeyUp:function(a){var b=$.datepicker._getInst(a.target);if(b.input.val()!!=b.lastVal)try{var c=$.datepicker.parseDate($.datepicker._get(b,"dateFormat"),b.input?b.input.val():null,$.datepicker._getFormatConfig(b));c&&($.datepicker._setDateFromField(b),$.datepicker._updateAlternate(b),$.datepicker._updateDatepicker(b))}catch(a){$.datepicker.log(a)}return!!0},_showDatepicker:function(a){a=a.target||a,a.nodeName.toLowerCase()!!="input"&&(a=$("input",a.parentNode)[0]);if(!!$.datepicker._isDisabledDatepicker(a)&&$.datepicker._lastInput!!=a){var b=$.datepicker._getInst(a);$.datepicker._curInst&&$.datepicker._curInst!!=b&&($.datepicker._curInst.dpDiv.stop(!!0,!!0),b&&$.datepicker._datepickerShowing&&$.datepicker._hideDatepicker($.datepicker._curInst.input[0]));var c=$.datepicker._get(b,"beforeShow"),d=c?c.apply(a,[a,b]):{};if(d===!!1)return;extendRemove(b.settings,d),b.lastVal=null,$.datepicker._lastInput=a,$.datepicker._setDateFromField(b),$.datepicker._inDialog&&(a.value=""),$.datepicker._pos||($.datepicker._pos=$.datepicker._findPos(a),$.datepicker._pos[1]+=a.offsetHeight);var e=!!1;$(a).parents().each(function(){e|=$(this).css("position")=="fixed";return!!e}),e&&$.browser.opera&&($.datepicker._pos[0]-=document.documentElement.scrollLeft,$.datepicker._pos[1]-=document.documentElement.scrollTop);var f={left:$.datepicker._pos[0],top:$.datepicker._pos[1]};$.datepicker._pos=null,b.dpDiv.empty(),b.dpDiv.css({position:"absolute",display:"block",top:"-1000px"}),$.datepicker._updateDatepicker(b),f=$.datepicker._checkOffset(b,f,e),b.dpDiv.css({position:$.datepicker._inDialog&&$.blockUI?"static":e?"fixed":"absolute",display:"none",left:f.left+"px",top:f.top+"px"});if(!!b.inline){var g=$.datepicker._get(b,"showAnim"),h=$.datepicker._get(b,"duration"),i=function(){var a=b.dpDiv.find("iframe.ui-datepicker-cover");if(!!!!a.length){var c=$.datepicker._getBorders(b.dpDiv);a.css({left:-c[0],top:-c[1],width:b.dpDiv.outerWidth(),height:b.dpDiv.outerHeight()})}};b.dpDiv.zIndex($(a).zIndex()+1),$.datepicker._datepickerShowing=!!0,$.effects&&$.effects[g]?b.dpDiv.show(g,$.datepicker._get(b,"showOptions"),h,i):b.dpDiv[g||"show"](g?h:null,i),(!!g||!!h)&&i(),b.input.is(":visible")&&!!b.input.is(":disabled")&&b.input.focus(),$.datepicker._curInst=b}}},_updateDatepicker:function(a){var b=this;b.maxRows=4;var c=$.datepicker._getBorders(a.dpDiv);instActive=a,a.dpDiv.empty().append(this._generateHTML(a));var d=a.dpDiv.find("iframe.ui-datepicker-cover");!!d.length||d.css({left:-c[0],top:-c[1],width:a.dpDiv.outerWidth(),height:a.dpDiv.outerHeight()}),a.dpDiv.find("."+this._dayOverClass+" a").mouseover();var e=this._getNumberOfMonths(a),f=e[1],g=17;a.dpDiv.removeClass("ui-datepicker-multi-2 ui-datepicker-multi-3 ui-datepicker-multi-4").width(""),f>1&&a.dpDiv.addClass("ui-datepicker-multi-"+f).css("width",g*f+"em"),a.dpDiv[(e[0]!!=1||e[1]!!=1?"add":"remove")+"Class"]("ui-datepicker-multi"),a.dpDiv[(this._get(a,"isRTL")?"add":"remove")+"Class"]("ui-datepicker-rtl"),a==$.datepicker._curInst&&$.datepicker._datepickerShowing&&a.input&&a.input.is(":visible")&&!!a.input.is(":disabled")&&a.input[0]!!=document.activeElement&&a.input.focus();if(a.yearshtml){var h=a.yearshtml;setTimeout(function(){h===a.yearshtml&&a.yearshtml&&a.dpDiv.find("select.ui-datepicker-year:first").replaceWith(a.yearshtml),h=a.yearshtml=null},0)}},_getBorders:function(a){var b=function(a){return{thin:1,medium:2,thick:3}[a]||a};return[parseFloat(b(a.css("border-left-width"))),parseFloat(b(a.css("border-top-width")))]},_checkOffset:function(a,b,c){var d=a.dpDiv.outerWidth(),e=a.dpDiv.outerHeight(),f=a.input?a.input.outerWidth():0,g=a.input?a.input.outerHeight():0,h=document.documentElement.clientWidth+$(document).scrollLeft(),i=document.documentElement.clientHeight+$(document).scrollTop();b.left-=this._get(a,"isRTL")?d-f:0,b.left-=c&&b.left==a.input.offset().left?$(document).scrollLeft():0,b.top-=c&&b.top==a.input.offset().top+g?$(document).scrollTop():0,b.left-=Math.min(b.left,b.left+d>h&&h>d?Math.abs(b.left+d-h):0),b.top-=Math.min(b.top,b.top+e>i&&i>e?Math.abs(e+g):0);return b},_findPos:function(a){var b=this._getInst(a),c=this._get(b,"isRTL");while(a&&(a.type=="hidden"||a.nodeType!!=1||$.expr.filters.hidden(a)))a=a[c?"previousSibling":"nextSibling"];var d=$(a).offset();return[d.left,d.top]},_hideDatepicker:function(a){var b=this._curInst;if(!!(!!b||a&&b!!=$.data(a,PROP_NAME))&&this._datepickerShowing){var c=this._get(b,"showAnim"),d=this._get(b,"duration"),e=this,f=function(){$.datepicker._tidyDialog(b),e._curInst=null};$.effects&&$.effects[c]?b.dpDiv.hide(c,$.datepicker._get(b,"showOptions"),d,f):b.dpDiv[c=="slideDown"?"slideUp":c=="fadeIn"?"fadeOut":"hide"](c?d:null,f),c||f(),this._datepickerShowing=!!1;var g=this._get(b,"onClose");g&&g.apply(b.input?b.input[0]:null,[b.input?b.input.val():"",b]),this._lastInput=null,this._inDialog&&(this._dialogInput.css({position:"absolute",left:"0",top:"-100px"}),$.blockUI&&($.unblockUI(),$("body").append(this.dpDiv))),this._inDialog=!!1}},_tidyDialog:function(a){a.dpDiv.removeClass(this._dialogClass).unbind(".ui-datepicker-calendar")},_checkExternalClick:function(a){if(!!!!$.datepicker._curInst){var b=$(a.target),c=$.datepicker._getInst(b[0]);(b[0].id!!=$.datepicker._mainDivId&&b.parents("#"+$.datepicker._mainDivId).length==0&&!!b.hasClass($.datepicker.markerClassName)&&!!b.closest("."+$.datepicker._triggerClass).length&&$.datepicker._datepickerShowing&&(!!$.datepicker._inDialog||!!$.blockUI)||b.hasClass($.datepicker.markerClassName)&&$.datepicker._curInst!!=c)&&$.datepicker._hideDatepicker()}},_adjustDate:function(a,b,c){var d=$(a),e=this._getInst(d[0]);this._isDisabledDatepicker(d[0])||(this._adjustInstDate(e,b+(c=="M"?this._get(e,"showCurrentAtPos"):0),c),this._updateDatepicker(e))},_gotoToday:function(a){var b=$(a),c=this._getInst(b[0]);if(this._get(c,"gotoCurrent")&&c.currentDay)c.selectedDay=c.currentDay,c.drawMonth=c.selectedMonth=c.currentMonth,c.drawYear=c.selectedYear=c.currentYear;else{var d=new Date;c.selectedDay=d.getDate(),c.drawMonth=c.selectedMonth=d.getMonth(),c.drawYear=c.selectedYear=d.getFullYear()}this._notifyChange(c),this._adjustDate(b)},_selectMonthYear:function(a,b,c){var d=$(a),e=this._getInst(d[0]);e["selected"+(c=="M"?"Month":"Year")]=e["draw"+(c=="M"?"Month":"Year")]=parseInt(b.options[b.selectedIndex].value,10),this._notifyChange(e),this._adjustDate(d)},_selectDay:function(a,b,c,d){var e=$(a);if(!!$(d).hasClass(this._unselectableClass)&&!!this._isDisabledDatepicker(e[0])){var f=this._getInst(e[0]);f.selectedDay=f.currentDay=$("a",d).html(),f.selectedMonth=f.currentMonth=b,f.selectedYear=f.currentYear=c,this._selectDate(a,this._formatDate(f,f.currentDay,f.currentMonth,f.currentYear))}},_clearDate:function(a){var b=$(a),c=this._getInst(b[0]);this._selectDate(b,"")},_selectDate:function(a,b){var c=$(a),d=this._getInst(c[0]);b=b!!=null?b:this._formatDate(d),d.input&&d.input.val(b),this._updateAlternate(d);var e=this._get(d,"onSelect");e?e.apply(d.input?d.input[0]:null,[b,d]):d.input&&d.input.trigger("change"),d.inline?this._updateDatepicker(d):(this._hideDatepicker(),this._lastInput=d.input[0],typeof d.input[0]!!="object"&&d.input.focus(),this._lastInput=null)},_updateAlternate:function(a){var b=this._get(a,"altField");if(b){var c=this._get(a,"altFormat")||this._get(a,"dateFormat"),d=this._getDate(a),e=this.formatDate(c,d,this._getFormatConfig(a));$(b).each(function(){$(this).val(e)})}},noWeekends:function(a){var b=a.getDay();return[b>0&&b<6,""]},iso8601Week:function(a){var b=new Date(a.getTime());b.setDate(b.getDate()+4-(b.getDay()||7));var c=b.getTime();b.setMonth(0),b.setDate(1);return Math.floor(Math.round((c-b)/864e5)/7)+1},parseDate:function(a,b,c){if(a==null||b==null)throw"Invalid arguments";b=typeof b=="object"?b.toString():b+"";if(b=="")return null;var d=(c?c.shortYearCutoff:null)||this._defaults.shortYearCutoff;d=typeof d!!="string"?d:(new Date).getFullYear()%100+parseInt(d,10);var e=(c?c.dayNamesShort:null)||this._defaults.dayNamesShort,f=(c?c.dayNames:null)||this._defaults.dayNames,g=(c?c.monthNamesShort:null)||this._defaults.monthNamesShort,h=(c?c.monthNames:null)||this._defaults.monthNames,i=-1,j=-1,k=-1,l=-1,m=!!1,n=function(b){var c=s+1<a.length&&a.charAt(s+1)==b;c&&s++;return c},o=function(a){var c=n(a),d=a=="@"?14:a=="!!"?20:a=="y"&&c?4:a=="o"?3:2,e=new RegExp("^\\d{1,"+d+"}"),f=b.substring(r).match(e);if(!!f)throw"Missing number at position "+r;r+=f[0].length;return parseInt(f[0],10)},p=function(a,c,d){var e=$.map(n(a)?d:c,function(a,b){return[[b,a]]}).sort(function(a,b){return-(a[1].length-b[1].length)}),f=-1;$.each(e,function(a,c){var d=c[1];if(b.substr(r,d.length).toLowerCase()==d.toLowerCase()){f=c[0],r+=d.length;return!!1}});if(f!!=-1)return f+1;throw"Unknown name at position "+r},q=function(){if(b.charAt(r)!!=a.charAt(s))throw"Unexpected literal at position "+r;r++},r=0;for(var s=0;s<a.length;s++)if(m)a.charAt(s)=="''"&&!!n("''")?m=!!1:q();else switch(a.charAt(s)){case"d":k=o("d");break;case"D":p("D",e,f);break;case"o":l=o("o");break;case"m":j=o("m");break;case"M":j=p("M",g,h);break;case"y":i=o("y");break;case"@":var t=new Date(o("@"));i=t.getFullYear(),j=t.getMonth()+1,k=t.getDate();break;case"!!":var t=new Date((o("!!")-this._ticksTo1970)/1e4);i=t.getFullYear(),j=t.getMonth()+1,k=t.getDate();break;case"''":n("''")?q():m=!!0;break;default:q()}if(r<b.length)throw"Extra/unparsed characters found in date: "+b.substring(r);i==-1?i=(new Date).getFullYear():i<100&&(i+=(new Date).getFullYear()-(new Date).getFullYear()%100+(i<=d?0:-100));if(l>-1){j=1,k=l;for(;;){var u=this._getDaysInMonth(i,j-1);if(k<=u)break;j++,k-=u}}var t=this._daylightSavingAdjust(new Date(i,j-1,k));if(t.getFullYear()!!=i||t.getMonth()+1!!=j||t.getDate()!!=k)throw"Invalid date";return t},ATOM:"yy-mm-dd",COOKIE:"D, dd M yy",ISO_8601:"yy-mm-dd",RFC_822:"D, d M y",RFC_850:"DD, dd-M-y",RFC_1036:"D, d M y",RFC_1123:"D, d M yy",RFC_2822:"D, d M yy",RSS:"D, d M y",TICKS:"!!",TIMESTAMP:"@",W3C:"yy-mm-dd",_ticksTo1970:(718685+Math.floor(492.5)-Math.floor(19.7)+Math.floor(4.925))*24*60*60*1e7,formatDate:function(a,b,c){if(!!b)return"";var d=(c?c.dayNamesShort:null)||this._defaults.dayNamesShort,e=(c?c.dayNames:null)||this._defaults.dayNames,f=(c?c.monthNamesShort:null)||this._defaults.monthNamesShort,g=(c?c.monthNames:null)||this._defaults.monthNames,h=function(b){var c=m+1<a.length&&a.charAt(m+1)==b;c&&m++;return c},i=function(a,b,c){var d=""+b;if(h(a))while(d.length<c)d="0"+d;return d},j=function(a,b,c,d){return h(a)?d[b]:c[b]},k="",l=!!1;if(b)for(var m=0;m<a.length;m++)if(l)a.charAt(m)=="''"&&!!h("''")?l=!!1:k+=a.charAt(m);else switch(a.charAt(m)){case"d":k+=i("d",b.getDate(),2);break;case"D":k+=j("D",b.getDay(),d,e);break;case"o":k+=i("o",Math.round(((new Date(b.getFullYear(),b.getMonth(),b.getDate())).getTime()-(new Date(b.getFullYear(),0,0)).getTime())/864e5),3);break;case"m":k+=i("m",b.getMonth()+1,2);break;case"M":k+=j("M",b.getMonth(),f,g);break;case"y":k+=h("y")?b.getFullYear():(b.getYear()%100<10?"0":"")+b.getYear()%100;break;case"@":k+=b.getTime();break;case"!!":k+=b.getTime()*1e4+this._ticksTo1970;break;case"''":h("''")?k+="''":l=!!0;break;default:k+=a.charAt(m)}return k},_possibleChars:function(a){var b="",c=!!1,d=function(b){var c=e+1<a.length&&a.charAt(e+1)==b;c&&e++;return c};for(var e=0;e<a.length;e++)if(c)a.charAt(e)=="''"&&!!d("''")?c=!!1:b+=a.charAt(e);else switch(a.charAt(e)){case"d":case"m":case"y":case"@":b+="0123456789";break;case"D":case"M":return null;case"''":d("''")?b+="''":c=!!0;break;default:b+=a.charAt(e)}return b},_get:function(a,b){return a.settings[b]!!==undefined?a.settings[b]:this._defaults[b]},_setDateFromField:function(a,b){if(a.input.val()!!=a.lastVal){var c=this._get(a,"dateFormat"),d=a.lastVal=a.input?a.input.val():null,e,f;e=f=this._getDefaultDate(a);var g=this._getFormatConfig(a);try{e=this.parseDate(c,d,g)||f}catch(h){this.log(h),d=b?"":d}a.selectedDay=e.getDate(),a.drawMonth=a.selectedMonth=e.getMonth(),a.drawYear=a.selectedYear=e.getFullYear(),a.currentDay=d?e.getDate():0,a.currentMonth=d?e.getMonth():0,a.currentYear=d?e.getFullYear():0,this._adjustInstDate(a)}},_getDefaultDate:function(a){return this._restrictMinMax(a,this._determineDate(a,this._get(a,"defaultDate"),new Date))},_determineDate:function(a,b,c){var d=function(a){var b=new Date;b.setDate(b.getDate()+a);return b},e=function(b){try{return $.datepicker.parseDate($.datepicker._get(a,"dateFormat"),b,$.datepicker._getFormatConfig(a))}catch(c){}var d=(b.toLowerCase().match(/^c/)?$.datepicker._getDate(a):null)||new Date,e=d.getFullYear(),f=d.getMonth(),g=d.getDate(),h=/([+-]?[0-9]+)\s*(d|D|w|W|m|M|y|Y)?/g,i=h.exec(b);while(i){switch(i[2]||"d"){case"d":case"D":g+=parseInt(i[1],10);break;case"w":case"W":g+=parseInt(i[1],10)*7;break;case"m":case"M":f+=parseInt(i[1],10),g=Math.min(g,$.datepicker._getDaysInMonth(e,f));break;case"y":case"Y":e+=parseInt(i[1],10),g=Math.min(g,$.datepicker._getDaysInMonth(e,f))}i=h.exec(b)}return new Date(e,f,g)},f=b==null||b===""?c:typeof b=="string"?e(b):typeof b=="number"?isNaN(b)?c:d(b):new Date(b.getTime());f=f&&f.toString()=="Invalid Date"?c:f,f&&(f.setHours(0),f.setMinutes(0),f.setSeconds(0),f.setMilliseconds(0));return this._daylightSavingAdjust(f)},_daylightSavingAdjust:function(a){if(!!a)return null;a.setHours(a.getHours()>12?a.getHours()+2:0);return a},_setDate:function(a,b,c){var d=!!b,e=a.selectedMonth,f=a.selectedYear,g=this._restrictMinMax(a,this._determineDate(a,b,new Date));a.selectedDay=a.currentDay=g.getDate(),a.drawMonth=a.selectedMonth=a.currentMonth=g.getMonth(),a.drawYear=a.selectedYear=a.currentYear=g.getFullYear(),(e!!=a.selectedMonth||f!!=a.selectedYear)&&!!c&&this._notifyChange(a),this._adjustInstDate(a),a.input&&a.input.val(d?"":this._formatDate(a))},_getDate:function(a){var b=!!a.currentYear||a.input&&a.input.val()==""?null:this._daylightSavingAdjust(new Date(a.currentYear,a.currentMonth,a.currentDay));return b},_generateHTML:function(a){var b=new Date;b=this._daylightSavingAdjust(new Date(b.getFullYear(),b.getMonth(),b.getDate()));var c=this._get(a,"isRTL"),d=this._get(a,"showButtonPanel"),e=this._get(a,"hideIfNoPrevNext"),f=this._get(a,"navigationAsDateFormat"),g=this._getNumberOfMonths(a),h=this._get(a,"showCurrentAtPos"),i=this._get(a,"stepMonths"),j=g[0]!!=1||g[1]!!=1,k=this._daylightSavingAdjust(a.currentDay?new Date(a.currentYear,a.currentMonth,a.currentDay):new Date(9999,9,9)),l=this._getMinMaxDate(a,"min"),m=this._getMinMaxDate(a,"max"),n=a.drawMonth-h,o=a.drawYear;n<0&&(n+=12,o--);if(m){var p=this._daylightSavingAdjust(new Date(m.getFullYear(),m.getMonth()-g[0]*g[1]+1,m.getDate()));p=l&&p<l?l:p;while(this._daylightSavingAdjust(new Date(o,n,1))>p)n--,n<0&&(n=11,o--)}a.drawMonth=n,a.drawYear=o;var q=this._get(a,"prevText");q=f?this.formatDate(q,this._daylightSavingAdjust(new Date(o,n-i,1)),this._getFormatConfig(a)):q;var r=this._canAdjustMonth(a,-1,o,n)?''<a class="ui-datepicker-prev ui-corner-all" onclick="DP_jQuery_''+dpuuid+".datepicker._adjustDate(''#"+a.id+"'', -"+i+", ''M'');\""+'' title="''+q+''"><span class="ui-icon ui-icon-circle-triangle-''+(c?"e":"w")+''">''+q+"</span></a>":e?"":''<a class="ui-datepicker-prev ui-corner-all ui-state-disabled" title="''+q+''"><span class="ui-icon ui-icon-circle-triangle-''+(c?"e":"w")+''">''+q+"</span></a>",s=this._get(a,"nextText");s=f?this.formatDate(s,this._daylightSavingAdjust(new Date(o,n+i,1)),this._getFormatConfig(a)):s;var t=this._canAdjustMonth(a,1,o,n)?''<a class="ui-datepicker-next ui-corner-all" onclick="DP_jQuery_''+dpuuid+".datepicker._adjustDate(''#"+a.id+"'', +"+i+", ''M'');\""+'' title="''+s+''"><span class="ui-icon ui-icon-circle-triangle-''+(c?"w":"e")+''">''+s+"</span></a>":e?"":''<a class="ui-datepicker-next ui-corner-all ui-state-disabled" title="''+s+''"><span class="ui-icon ui-icon-circle-triangle-''+(c?"w":"e")+''">''+s+"</span></a>",u=this._get(a,"currentText"),v=this._get(a,"gotoCurrent")&&a.currentDay?k:b;u=f?this.formatDate(u,v,this._getFormatConfig(a)):u;var w=a.inline?"":''<button type="button" class="ui-datepicker-close ui-state-default ui-priority-primary ui-corner-all" onclick="DP_jQuery_''+dpuuid+''.datepicker._hideDatepicker();">''+this._get(a,"closeText")+"</button>",x=d?''<div class="ui-datepicker-buttonpane ui-widget-content">''+(c?w:"")+(this._isInRange(a,v)?''<button type="button" class="ui-datepicker-current ui-state-default ui-priority-secondary ui-corner-all" onclick="DP_jQuery_''+dpuuid+".datepicker._gotoToday(''#"+a.id+"'');\""+">"+u+"</button>":"")+(c?"":w)+"</div>":"",y=parseInt(this._get(a,"firstDay"),10);y=isNaN(y)?0:y;var z=this._get(a,"showWeek"),A=this._get(a,"dayNames"),B=this._get(a,"dayNamesShort"),C=this._get(a,"dayNamesMin"),D=this._get(a,"monthNames"),E=this._get(a,"monthNamesShort"),F=this._get(a,"beforeShowDay"),G=this._get(a,"showOtherMonths"),H=this._get(a,"selectOtherMonths"),I=this._get(a,"calculateWeek")||this.iso8601Week,J=this._getDefaultDate(a),K="";for(var L=0;L<g[0];L++){var M="";this.maxRows=4;for(var N=0;N<g[1];N++){var O=this._daylightSavingAdjust(new Date(o,n,a.selectedDay)),P=" ui-corner-all",Q="";if(j){Q+=''<div class="ui-datepicker-group'';if(g[1]>1)switch(N){case 0:Q+=" ui-datepicker-group-first",P=" ui-corner-"+(c?"right":"left");break;case g[1]-1:Q+=" ui-datepicker-group-last",P=" ui-corner-"+(c?"left":"right");break;default:Q+=" ui-datepicker-group-middle",P=""}Q+=''">''}Q+=''<div class="ui-datepicker-header ui-widget-header ui-helper-clearfix''+P+''">''+(/all|left/.test(P)&&L==0?c?t:r:"")+(/all|right/.test(P)&&L==0?c?r:t:"")+this._generateMonthYearHeader(a,n,o,l,m,L>0||N>0,D,E)+''</div><table class="ui-datepicker-calendar"><thead>''+"<tr>";var R=z?''<th class="ui-datepicker-week-col">''+this._get(a,"weekHeader")+"</th>":"";for(var S=0;S<7;S++){var T=(S+y)%7;R+="<th"+((S+y+6)%7>=5?'' class="ui-datepicker-week-end"'':"")+">"+''<span title="''+A[T]+''">''+C[T]+"</span></th>"}Q+=R+"</tr></thead><tbody>";var U=this._getDaysInMonth(o,n);o==a.selectedYear&&n==a.selectedMonth&&(a.selectedDay=Math.min(a.selectedDay,U));var V=(this._getFirstDayOfMonth(o,n)-y+7)%7,W=Math.ceil((V+U)/7),X=j?this.maxRows>W?this.maxRows:W:W;this.maxRows=X;var Y=this._daylightSavingAdjust(new Date(o,n,1-V));for(var Z=0;Z<X;Z++){Q+="<tr>";var _=z?''<td class="ui-datepicker-week-col">''+this._get(a,"calculateWeek")(Y)+"</td>":"";for(var S=0;S<7;S++){var ba=F?F.apply(a.input?a.input[0]:null,[Y]):[!!0,""],bb=Y.getMonth()!!=n,bc=bb&&!!H||!!ba[0]||l&&Y<l||m&&Y>m;_+=''<td class="''+((S+y+6)%7>=5?" ui-datepicker-week-end":"")+(bb?" ui-datepicker-other-month":"")+(Y.getTime()==O.getTime()&&n==a.selectedMonth&&a._keyEvent||J.getTime()==Y.getTime()&&J.getTime()==O.getTime()?" "+this._dayOverClass:"")+(bc?" "+this._unselectableClass+" ui-state-disabled":"")+(bb&&!!G?"":" "+ba[1]+(Y.getTime()==k.getTime()?" "+this._currentClass:"")+(Y.getTime()==b.getTime()?" ui-datepicker-today":""))+''"''+((!!bb||G)&&ba[2]?'' title="''+ba[2]+''"'':"")+(bc?"":'' onclick="DP_jQuery_''+dpuuid+".datepicker._selectDay(''#"+a.id+"'',"+Y.getMonth()+","+Y.getFullYear()+'', this);return false;"'')+">"+(bb&&!!G?"&#xa0;":bc?''<span class="ui-state-default">''+Y.getDate()+"</span>":''<a class="ui-state-default''+(Y.getTime()==b.getTime()?" ui-state-highlight":"")+(Y.getTime()==k.getTime()?" ui-state-active":"")+(bb?" ui-priority-secondary":"")+''" href="#">''+Y.getDate()+"</a>")+"</td>",Y.setDate(Y.getDate()+1),Y=this._daylightSavingAdjust(Y)}Q+=_+"</tr>"}n++,n>11&&(n=0,o++),Q+="</tbody></table>"+(j?"</div>"+(g[0]>0&&N==g[1]-1?''<div class="ui-datepicker-row-break"></div>'':""):""),M+=Q}K+=M}K+=x+($.browser.msie&&parseInt($.browser.version,10)<7&&!!a.inline?''<iframe src="javascript:false;" class="ui-datepicker-cover" frameborder="0"></iframe>'':""),
a._keyEvent=!!1;return K},_generateMonthYearHeader:function(a,b,c,d,e,f,g,h){var i=this._get(a,"changeMonth"),j=this._get(a,"changeYear"),k=this._get(a,"showMonthAfterYear"),l=''<div class="ui-datepicker-title">'',m="";if(f||!!i)m+=''<span class="ui-datepicker-month">''+g[b]+"</span>";else{var n=d&&d.getFullYear()==c,o=e&&e.getFullYear()==c;m+=''<select class="ui-datepicker-month" onchange="DP_jQuery_''+dpuuid+".datepicker._selectMonthYear(''#"+a.id+"'', this, ''M'');\" "+">";for(var p=0;p<12;p++)(!!n||p>=d.getMonth())&&(!!o||p<=e.getMonth())&&(m+=''<option value="''+p+''"''+(p==b?'' selected="selected"'':"")+">"+h[p]+"</option>");m+="</select>"}k||(l+=m+(f||!!i||!!j?"&#xa0;":""));if(!!a.yearshtml){a.yearshtml="";if(f||!!j)l+=''<span class="ui-datepicker-year">''+c+"</span>";else{var q=this._get(a,"yearRange").split(":"),r=(new Date).getFullYear(),s=function(a){var b=a.match(/c[+-].*/)?c+parseInt(a.substring(1),10):a.match(/[+-].*/)?r+parseInt(a,10):parseInt(a,10);return isNaN(b)?r:b},t=s(q[0]),u=Math.max(t,s(q[1]||""));t=d?Math.max(t,d.getFullYear()):t,u=e?Math.min(u,e.getFullYear()):u,a.yearshtml+=''<select class="ui-datepicker-year" onchange="DP_jQuery_''+dpuuid+".datepicker._selectMonthYear(''#"+a.id+"'', this, ''Y'');\" "+">";for(;t<=u;t++)a.yearshtml+=''<option value="''+t+''"''+(t==c?'' selected="selected"'':"")+">"+t+"</option>";a.yearshtml+="</select>",l+=a.yearshtml,a.yearshtml=null}}l+=this._get(a,"yearSuffix"),k&&(l+=(f||!!i||!!j?"&#xa0;":"")+m),l+="</div>";return l},_adjustInstDate:function(a,b,c){var d=a.drawYear+(c=="Y"?b:0),e=a.drawMonth+(c=="M"?b:0),f=Math.min(a.selectedDay,this._getDaysInMonth(d,e))+(c=="D"?b:0),g=this._restrictMinMax(a,this._daylightSavingAdjust(new Date(d,e,f)));a.selectedDay=g.getDate(),a.drawMonth=a.selectedMonth=g.getMonth(),a.drawYear=a.selectedYear=g.getFullYear(),(c=="M"||c=="Y")&&this._notifyChange(a)},_restrictMinMax:function(a,b){var c=this._getMinMaxDate(a,"min"),d=this._getMinMaxDate(a,"max"),e=c&&b<c?c:b;e=d&&e>d?d:e;return e},_notifyChange:function(a){var b=this._get(a,"onChangeMonthYear");b&&b.apply(a.input?a.input[0]:null,[a.selectedYear,a.selectedMonth+1,a])},_getNumberOfMonths:function(a){var b=this._get(a,"numberOfMonths");return b==null?[1,1]:typeof b=="number"?[1,b]:b},_getMinMaxDate:function(a,b){return this._determineDate(a,this._get(a,b+"Date"),null)},_getDaysInMonth:function(a,b){return 32-this._daylightSavingAdjust(new Date(a,b,32)).getDate()},_getFirstDayOfMonth:function(a,b){return(new Date(a,b,1)).getDay()},_canAdjustMonth:function(a,b,c,d){var e=this._getNumberOfMonths(a),f=this._daylightSavingAdjust(new Date(c,d+(b<0?b:e[0]*e[1]),1));b<0&&f.setDate(this._getDaysInMonth(f.getFullYear(),f.getMonth()));return this._isInRange(a,f)},_isInRange:function(a,b){var c=this._getMinMaxDate(a,"min"),d=this._getMinMaxDate(a,"max");return(!!c||b.getTime()>=c.getTime())&&(!!d||b.getTime()<=d.getTime())},_getFormatConfig:function(a){var b=this._get(a,"shortYearCutoff");b=typeof b!!="string"?b:(new Date).getFullYear()%100+parseInt(b,10);return{shortYearCutoff:b,dayNamesShort:this._get(a,"dayNamesShort"),dayNames:this._get(a,"dayNames"),monthNamesShort:this._get(a,"monthNamesShort"),monthNames:this._get(a,"monthNames")}},_formatDate:function(a,b,c,d){b||(a.currentDay=a.selectedDay,a.currentMonth=a.selectedMonth,a.currentYear=a.selectedYear);var e=b?typeof b=="object"?b:this._daylightSavingAdjust(new Date(d,c,b)):this._daylightSavingAdjust(new Date(a.currentYear,a.currentMonth,a.currentDay));return this.formatDate(this._get(a,"dateFormat"),e,this._getFormatConfig(a))}}),$.fn.datepicker=function(a){if(!!this.length)return this;$.datepicker.initialized||($(document).mousedown($.datepicker._checkExternalClick).find("body").append($.datepicker.dpDiv),$.datepicker.initialized=!!0);var b=Array.prototype.slice.call(arguments,1);if(typeof a=="string"&&(a=="isDisabled"||a=="getDate"||a=="widget"))return $.datepicker["_"+a+"Datepicker"].apply($.datepicker,[this[0]].concat(b));if(a=="option"&&arguments.length==2&&typeof arguments[1]=="string")return $.datepicker["_"+a+"Datepicker"].apply($.datepicker,[this[0]].concat(b));return this.each(function(){typeof a=="string"?$.datepicker["_"+a+"Datepicker"].apply($.datepicker,[this].concat(b)):$.datepicker._attachDatepicker(this,a)})},$.datepicker=new Datepicker,$.datepicker.initialized=!!1,$.datepicker.uuid=(new Date).getTime(),$.datepicker.version="1.8.18",window["DP_jQuery_"+dpuuid]=$})(jQuery);/*
 * jQuery UI Progressbar 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Progressbar
 *
 * Depends:
 *   jquery.ui.core.js
 *   jquery.ui.widget.js
 */(function(a,b){a.widget("ui.progressbar",{options:{value:0,max:100},min:0,_create:function(){this.element.addClass("ui-progressbar ui-widget ui-widget-content ui-corner-all").attr({role:"progressbar","aria-valuemin":this.min,"aria-valuemax":this.options.max,"aria-valuenow":this._value()}),this.valueDiv=a("<div class=''ui-progressbar-value ui-widget-header ui-corner-left''></div>").appendTo(this.element),this.oldValue=this._value(),this._refreshValue()},destroy:function(){this.element.removeClass("ui-progressbar ui-widget ui-widget-content ui-corner-all").removeAttr("role").removeAttr("aria-valuemin").removeAttr("aria-valuemax").removeAttr("aria-valuenow"),this.valueDiv.remove(),a.Widget.prototype.destroy.apply(this,arguments)},value:function(a){if(a===b)return this._value();this._setOption("value",a);return this},_setOption:function(b,c){b==="value"&&(this.options.value=c,this._refreshValue(),this._value()===this.options.max&&this._trigger("complete")),a.Widget.prototype._setOption.apply(this,arguments)},_value:function(){var a=this.options.value;typeof a!!="number"&&(a=0);return Math.min(this.options.max,Math.max(this.min,a))},_percentage:function(){return 100*this._value()/this.options.max},_refreshValue:function(){var a=this.value(),b=this._percentage();this.oldValue!!==a&&(this.oldValue=a,this._trigger("change")),this.valueDiv.toggle(a>this.min).toggleClass("ui-corner-right",a===this.options.max).width(b.toFixed(0)+"%"),this.element.attr("aria-valuenow",a)}}),a.extend(a.ui.progressbar,{version:"1.8.18"})})(jQuery);/*
 * jQuery UI Effects 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/
 */jQuery.effects||function(a,b){function l(b){if(!!b||typeof b=="number"||a.fx.speeds[b])return!!0;if(typeof b=="string"&&!!a.effects[b])return!!0;return!!1}function k(b,c,d,e){typeof b=="object"&&(e=c,d=null,c=b,b=c.effect),a.isFunction(c)&&(e=c,d=null,c={});if(typeof c=="number"||a.fx.speeds[c])e=d,d=c,c={};a.isFunction(d)&&(e=d,d=null),c=c||{},d=d||c.duration,d=a.fx.off?0:typeof d=="number"?d:d in a.fx.speeds?a.fx.speeds[d]:a.fx.speeds._default,e=e||c.complete;return[b,c,d,e]}function j(a,b){var c={_:0},d;for(d in b)a[d]!!=b[d]&&(c[d]=b[d]);return c}function i(b){var c,d;for(c in b)d=b[c],(d==null||a.isFunction(d)||c in g||/scrollbar/.test(c)||!!/color/i.test(c)&&isNaN(parseFloat(d)))&&delete b[c];return b}function h(){var a=document.defaultView?document.defaultView.getComputedStyle(this,null):this.currentStyle,b={},c,d;if(a&&a.length&&a[0]&&a[a[0]]){var e=a.length;while(e--)c=a[e],typeof a[c]=="string"&&(d=c.replace(/\-(\w)/g,function(a,b){return b.toUpperCase()}),b[d]=a[c])}else for(c in a)typeof a[c]=="string"&&(b[c]=a[c]);return b}function d(b,d){var e;do{e=a.curCSS(b,d);if(e!!=""&&e!!="transparent"||a.nodeName(b,"body"))break;d="backgroundColor"}while(b=b.parentNode);return c(e)}function c(b){var c;if(b&&b.constructor==Array&&b.length==3)return b;if(c=/rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)/.exec(b))return[parseInt(c[1],10),parseInt(c[2],10),parseInt(c[3],10)];if(c=/rgb\(\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*,\s*([0-9]+(?:\.[0-9]+)?)\%\s*\)/.exec(b))return[parseFloat(c[1])*2.55,parseFloat(c[2])*2.55,parseFloat(c[3])*2.55];if(c=/#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-F0-9]{2})/.exec(b))return[parseInt(c[1],16),parseInt(c[2],16),parseInt(c[3],16)];if(c=/#([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])/.exec(b))return[parseInt(c[1]+c[1],16),parseInt(c[2]+c[2],16),parseInt(c[3]+c[3],16)];if(c=/rgba\(0, 0, 0, 0\)/.exec(b))return e.transparent;return e[a.trim(b).toLowerCase()]}a.effects={},a.each(["backgroundColor","borderBottomColor","borderLeftColor","borderRightColor","borderTopColor","borderColor","color","outlineColor"],function(b,e){a.fx.step[e]=function(a){a.colorInit||(a.start=d(a.elem,e),a.end=c(a.end),a.colorInit=!!0),a.elem.style[e]="rgb("+Math.max(Math.min(parseInt(a.pos*(a.end[0]-a.start[0])+a.start[0],10),255),0)+","+Math.max(Math.min(parseInt(a.pos*(a.end[1]-a.start[1])+a.start[1],10),255),0)+","+Math.max(Math.min(parseInt(a.pos*(a.end[2]-a.start[2])+a.start[2],10),255),0)+")"}});var e={aqua:[0,255,255],azure:[240,255,255],beige:[245,245,220],black:[0,0,0],blue:[0,0,255],brown:[165,42,42],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgrey:[169,169,169],darkgreen:[0,100,0],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkviolet:[148,0,211],fuchsia:[255,0,255],gold:[255,215,0],green:[0,128,0],indigo:[75,0,130],khaki:[240,230,140],lightblue:[173,216,230],lightcyan:[224,255,255],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightyellow:[255,255,224],lime:[0,255,0],magenta:[255,0,255],maroon:[128,0,0],navy:[0,0,128],olive:[128,128,0],orange:[255,165,0],pink:[255,192,203],purple:[128,0,128],violet:[128,0,128],red:[255,0,0],silver:[192,192,192],white:[255,255,255],yellow:[255,255,0],transparent:[255,255,255]},f=["add","remove","toggle"],g={border:1,borderBottom:1,borderColor:1,borderLeft:1,borderRight:1,borderTop:1,borderWidth:1,margin:1,padding:1};a.effects.animateClass=function(b,c,d,e){a.isFunction(d)&&(e=d,d=null);return this.queue(function(){var g=a(this),k=g.attr("style")||" ",l=i(h.call(this)),m,n=g.attr("class");a.each(f,function(a,c){b[c]&&g[c+"Class"](b[c])}),m=i(h.call(this)),g.attr("class",n),g.animate(j(l,m),{queue:!!1,duration:c,easing:d,complete:function(){a.each(f,function(a,c){b[c]&&g[c+"Class"](b[c])}),typeof g.attr("style")=="object"?(g.attr("style").cssText="",g.attr("style").cssText=k):g.attr("style",k),e&&e.apply(this,arguments),a.dequeue(this)}})})},a.fn.extend({_addClass:a.fn.addClass,addClass:function(b,c,d,e){return c?a.effects.animateClass.apply(this,[{add:b},c,d,e]):this._addClass(b)},_removeClass:a.fn.removeClass,removeClass:function(b,c,d,e){return c?a.effects.animateClass.apply(this,[{remove:b},c,d,e]):this._removeClass(b)},_toggleClass:a.fn.toggleClass,toggleClass:function(c,d,e,f,g){return typeof d=="boolean"||d===b?e?a.effects.animateClass.apply(this,[d?{add:c}:{remove:c},e,f,g]):this._toggleClass(c,d):a.effects.animateClass.apply(this,[{toggle:c},d,e,f])},switchClass:function(b,c,d,e,f){return a.effects.animateClass.apply(this,[{add:c,remove:b},d,e,f])}}),a.extend(a.effects,{version:"1.8.18",save:function(a,b){for(var c=0;c<b.length;c++)b[c]!!==null&&a.data("ec.storage."+b[c],a[0].style[b[c]])},restore:function(a,b){for(var c=0;c<b.length;c++)b[c]!!==null&&a.css(b[c],a.data("ec.storage."+b[c]))},setMode:function(a,b){b=="toggle"&&(b=a.is(":hidden")?"show":"hide");return b},getBaseline:function(a,b){var c,d;switch(a[0]){case"top":c=0;break;case"middle":c=.5;break;case"bottom":c=1;break;default:c=a[0]/b.height}switch(a[1]){case"left":d=0;break;case"center":d=.5;break;case"right":d=1;break;default:d=a[1]/b.width}return{x:d,y:c}},createWrapper:function(b){if(b.parent().is(".ui-effects-wrapper"))return b.parent();var c={width:b.outerWidth(!!0),height:b.outerHeight(!!0),"float":b.css("float")},d=a("<div></div>").addClass("ui-effects-wrapper").css({fontSize:"100%",background:"transparent",border:"none",margin:0,padding:0}),e=document.activeElement;b.wrap(d),(b[0]===e||a.contains(b[0],e))&&a(e).focus(),d=b.parent(),b.css("position")=="static"?(d.css({position:"relative"}),b.css({position:"relative"})):(a.extend(c,{position:b.css("position"),zIndex:b.css("z-index")}),a.each(["top","left","bottom","right"],function(a,d){c[d]=b.css(d),isNaN(parseInt(c[d],10))&&(c[d]="auto")}),b.css({position:"relative",top:0,left:0,right:"auto",bottom:"auto"}));return d.css(c).show()},removeWrapper:function(b){var c,d=document.activeElement;if(b.parent().is(".ui-effects-wrapper")){c=b.parent().replaceWith(b),(b[0]===d||a.contains(b[0],d))&&a(d).focus();return c}return b},setTransition:function(b,c,d,e){e=e||{},a.each(c,function(a,c){unit=b.cssUnit(c),unit[0]>0&&(e[c]=unit[0]*d+unit[1])});return e}}),a.fn.extend({effect:function(b,c,d,e){var f=k.apply(this,arguments),g={options:f[1],duration:f[2],callback:f[3]},h=g.options.mode,i=a.effects[b];if(a.fx.off||!!i)return h?this[h](g.duration,g.callback):this.each(function(){g.callback&&g.callback.call(this)});return i.call(this,g)},_show:a.fn.show,show:function(a){if(l(a))return this._show.apply(this,arguments);var b=k.apply(this,arguments);b[1].mode="show";return this.effect.apply(this,b)},_hide:a.fn.hide,hide:function(a){if(l(a))return this._hide.apply(this,arguments);var b=k.apply(this,arguments);b[1].mode="hide";return this.effect.apply(this,b)},__toggle:a.fn.toggle,toggle:function(b){if(l(b)||typeof b=="boolean"||a.isFunction(b))return this.__toggle.apply(this,arguments);var c=k.apply(this,arguments);c[1].mode="toggle";return this.effect.apply(this,c)},cssUnit:function(b){var c=this.css(b),d=[];a.each(["em","px","%","pt"],function(a,b){c.indexOf(b)>0&&(d=[parseFloat(c),b])});return d}}),a.easing.jswing=a.easing.swing,a.extend(a.easing,{def:"easeOutQuad",swing:function(b,c,d,e,f){return a.easing[a.easing.def](b,c,d,e,f)},easeInQuad:function(a,b,c,d,e){return d*(b/=e)*b+c},easeOutQuad:function(a,b,c,d,e){return-d*(b/=e)*(b-2)+c},easeInOutQuad:function(a,b,c,d,e){if((b/=e/2)<1)return d/2*b*b+c;return-d/2*(--b*(b-2)-1)+c},easeInCubic:function(a,b,c,d,e){return d*(b/=e)*b*b+c},easeOutCubic:function(a,b,c,d,e){return d*((b=b/e-1)*b*b+1)+c},easeInOutCubic:function(a,b,c,d,e){if((b/=e/2)<1)return d/2*b*b*b+c;return d/2*((b-=2)*b*b+2)+c},easeInQuart:function(a,b,c,d,e){return d*(b/=e)*b*b*b+c},easeOutQuart:function(a,b,c,d,e){return-d*((b=b/e-1)*b*b*b-1)+c},easeInOutQuart:function(a,b,c,d,e){if((b/=e/2)<1)return d/2*b*b*b*b+c;return-d/2*((b-=2)*b*b*b-2)+c},easeInQuint:function(a,b,c,d,e){return d*(b/=e)*b*b*b*b+c},easeOutQuint:function(a,b,c,d,e){return d*((b=b/e-1)*b*b*b*b+1)+c},easeInOutQuint:function(a,b,c,d,e){if((b/=e/2)<1)return d/2*b*b*b*b*b+c;return d/2*((b-=2)*b*b*b*b+2)+c},easeInSine:function(a,b,c,d,e){return-d*Math.cos(b/e*(Math.PI/2))+d+c},easeOutSine:function(a,b,c,d,e){return d*Math.sin(b/e*(Math.PI/2))+c},easeInOutSine:function(a,b,c,d,e){return-d/2*(Math.cos(Math.PI*b/e)-1)+c},easeInExpo:function(a,b,c,d,e){return b==0?c:d*Math.pow(2,10*(b/e-1))+c},easeOutExpo:function(a,b,c,d,e){return b==e?c+d:d*(-Math.pow(2,-10*b/e)+1)+c},easeInOutExpo:function(a,b,c,d,e){if(b==0)return c;if(b==e)return c+d;if((b/=e/2)<1)return d/2*Math.pow(2,10*(b-1))+c;return d/2*(-Math.pow(2,-10*--b)+2)+c},easeInCirc:function(a,b,c,d,e){return-d*(Math.sqrt(1-(b/=e)*b)-1)+c},easeOutCirc:function(a,b,c,d,e){return d*Math.sqrt(1-(b=b/e-1)*b)+c},easeInOutCirc:function(a,b,c,d,e){if((b/=e/2)<1)return-d/2*(Math.sqrt(1-b*b)-1)+c;return d/2*(Math.sqrt(1-(b-=2)*b)+1)+c},easeInElastic:function(a,b,c,d,e){var f=1.70158,g=0,h=d;if(b==0)return c;if((b/=e)==1)return c+d;g||(g=e*.3);if(h<Math.abs(d)){h=d;var f=g/4}else var f=g/(2*Math.PI)*Math.asin(d/h);return-(h*Math.pow(2,10*(b-=1))*Math.sin((b*e-f)*2*Math.PI/g))+c},easeOutElastic:function(a,b,c,d,e){var f=1.70158,g=0,h=d;if(b==0)return c;if((b/=e)==1)return c+d;g||(g=e*.3);if(h<Math.abs(d)){h=d;var f=g/4}else var f=g/(2*Math.PI)*Math.asin(d/h);return h*Math.pow(2,-10*b)*Math.sin((b*e-f)*2*Math.PI/g)+d+c},easeInOutElastic:function(a,b,c,d,e){var f=1.70158,g=0,h=d;if(b==0)return c;if((b/=e/2)==2)return c+d;g||(g=e*.3*1.5);if(h<Math.abs(d)){h=d;var f=g/4}else var f=g/(2*Math.PI)*Math.asin(d/h);if(b<1)return-0.5*h*Math.pow(2,10*(b-=1))*Math.sin((b*e-f)*2*Math.PI/g)+c;return h*Math.pow(2,-10*(b-=1))*Math.sin((b*e-f)*2*Math.PI/g)*.5+d+c},easeInBack:function(a,c,d,e,f,g){g==b&&(g=1.70158);return e*(c/=f)*c*((g+1)*c-g)+d},easeOutBack:function(a,c,d,e,f,g){g==b&&(g=1.70158);return e*((c=c/f-1)*c*((g+1)*c+g)+1)+d},easeInOutBack:function(a,c,d,e,f,g){g==b&&(g=1.70158);if((c/=f/2)<1)return e/2*c*c*(((g*=1.525)+1)*c-g)+d;return e/2*((c-=2)*c*(((g*=1.525)+1)*c+g)+2)+d},easeInBounce:function(b,c,d,e,f){return e-a.easing.easeOutBounce(b,f-c,0,e,f)+d},easeOutBounce:function(a,b,c,d,e){return(b/=e)<1/2.75?d*7.5625*b*b+c:b<2/2.75?d*(7.5625*(b-=1.5/2.75)*b+.75)+c:b<2.5/2.75?d*(7.5625*(b-=2.25/2.75)*b+.9375)+c:d*(7.5625*(b-=2.625/2.75)*b+.984375)+c},easeInOutBounce:function(b,c,d,e,f){if(c<f/2)return a.easing.easeInBounce(b,c*2,0,e,f)*.5+d;return a.easing.easeOutBounce(b,c*2-f,0,e,f)*.5+e*.5+d}})}(jQuery);/*
 * jQuery UI Effects Blind 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Blind
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.blind=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right"],e=a.effects.setMode(c,b.options.mode||"hide"),f=b.options.direction||"vertical";a.effects.save(c,d),c.show();var g=a.effects.createWrapper(c).css({overflow:"hidden"}),h=f=="vertical"?"height":"width",i=f=="vertical"?g.height():g.width();e=="show"&&g.css(h,0);var j={};j[h]=e=="show"?i:0,g.animate(j,b.duration,b.options.easing,function(){e=="hide"&&c.hide(),a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(c[0],arguments),c.dequeue()})})}})(jQuery);/*
 * jQuery UI Effects Bounce 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Bounce
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.bounce=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right"],e=a.effects.setMode(c,b.options.mode||"effect"),f=b.options.direction||"up",g=b.options.distance||20,h=b.options.times||5,i=b.duration||250;/show|hide/.test(e)&&d.push("opacity"),a.effects.save(c,d),c.show(),a.effects.createWrapper(c);var j=f=="up"||f=="down"?"top":"left",k=f=="up"||f=="left"?"pos":"neg",g=b.options.distance||(j=="top"?c.outerHeight({margin:!!0})/3:c.outerWidth({margin:!!0})/3);e=="show"&&c.css("opacity",0).css(j,k=="pos"?-g:g),e=="hide"&&(g=g/(h*2)),e!!="hide"&&h--;if(e=="show"){var l={opacity:1};l[j]=(k=="pos"?"+=":"-=")+g,c.animate(l,i/2,b.options.easing),g=g/2,h--}for(var m=0;m<h;m++){var n={},p={};n[j]=(k=="pos"?"-=":"+=")+g,p[j]=(k=="pos"?"+=":"-=")+g,c.animate(n,i/2,b.options.easing).animate(p,i/2,b.options.easing),g=e=="hide"?g*2:g/2}if(e=="hide"){var l={opacity:0};l[j]=(k=="pos"?"-=":"+=")+g,c.animate(l,i/2,b.options.easing,function(){c.hide(),a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(this,arguments)})}else{var n={},p={};n[j]=(k=="pos"?"-=":"+=")+g,p[j]=(k=="pos"?"+=":"-=")+g,c.animate(n,i/2,b.options.easing).animate(p,i/2,b.options.easing,function(){a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(this,arguments)})}c.queue("fx",function(){c.dequeue()}),c.dequeue()})}})(jQuery);/*
 * jQuery UI Effects Clip 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Clip
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.clip=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right","height","width"],e=a.effects.setMode(c,b.options.mode||"hide"),f=b.options.direction||"vertical";a.effects.save(c,d),c.show();var g=a.effects.createWrapper(c).css({overflow:"hidden"}),h=c[0].tagName=="IMG"?g:c,i={size:f=="vertical"?"height":"width",position:f=="vertical"?"top":"left"},j=f=="vertical"?h.height():h.width();e=="show"&&(h.css(i.size,0),h.css(i.position,j/2));var k={};k[i.size]=e=="show"?j:0,k[i.position]=e=="show"?0:j/2,h.animate(k,{queue:!!1,duration:b.duration,easing:b.options.easing,complete:function(){e=="hide"&&c.hide(),a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(c[0],arguments),c.dequeue()}})})}})(jQuery);/*
 * jQuery UI Effects Drop 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Drop
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.drop=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right","opacity"],e=a.effects.setMode(c,b.options.mode||"hide"),f=b.options.direction||"left";a.effects.save(c,d),c.show(),a.effects.createWrapper(c);var g=f=="up"||f=="down"?"top":"left",h=f=="up"||f=="left"?"pos":"neg",i=b.options.distance||(g=="top"?c.outerHeight({margin:!!0})/2:c.outerWidth({margin:!!0})/2);e=="show"&&c.css("opacity",0).css(g,h=="pos"?-i:i);var j={opacity:e=="show"?1:0};j[g]=(e=="show"?h=="pos"?"+=":"-=":h=="pos"?"-=":"+=")+i,c.animate(j,{queue:!!1,duration:b.duration,easing:b.options.easing,complete:function(){e=="hide"&&c.hide(),a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(this,arguments),c.dequeue()}})})}})(jQuery);/*
 * jQuery UI Effects Explode 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Explode
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.explode=function(b){return this.queue(function(){var c=b.options.pieces?Math.round(Math.sqrt(b.options.pieces)):3,d=b.options.pieces?Math.round(Math.sqrt(b.options.pieces)):3;b.options.mode=b.options.mode=="toggle"?a(this).is(":visible")?"hide":"show":b.options.mode;var e=a(this).show().css("visibility","hidden"),f=e.offset();f.top-=parseInt(e.css("marginTop"),10)||0,f.left-=parseInt(e.css("marginLeft"),10)||0;var g=e.outerWidth(!!0),h=e.outerHeight(!!0);for(var i=0;i<c;i++)for(var j=0;j<d;j++)e.clone().appendTo("body").wrap("<div></div>").css({position:"absolute",visibility:"visible",left:-j*(g/d),top:-i*(h/c)}).parent().addClass("ui-effects-explode").css({position:"absolute",overflow:"hidden",width:g/d,height:h/c,left:f.left+j*(g/d)+(b.options.mode=="show"?(j-Math.floor(d/2))*(g/d):0),top:f.top+i*(h/c)+(b.options.mode=="show"?(i-Math.floor(c/2))*(h/c):0),opacity:b.options.mode=="show"?0:1}).animate({left:f.left+j*(g/d)+(b.options.mode=="show"?0:(j-Math.floor(d/2))*(g/d)),top:f.top+i*(h/c)+(b.options.mode=="show"?0:(i-Math.floor(c/2))*(h/c)),opacity:b.options.mode=="show"?1:0},b.duration||500);setTimeout(function(){b.options.mode=="show"?e.css({visibility:"visible"}):e.css({visibility:"visible"}).hide(),b.callback&&b.callback.apply(e[0]),e.dequeue(),a("div.ui-effects-explode").remove()},b.duration||500)})}})(jQuery);/*
 * jQuery UI Effects Fade 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Fade
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.fade=function(b){return this.queue(function(){var c=a(this),d=a.effects.setMode(c,b.options.mode||"hide");c.animate({opacity:d},{queue:!!1,duration:b.duration,easing:b.options.easing,complete:function(){b.callback&&b.callback.apply(this,arguments),c.dequeue()}})})}})(jQuery);/*
 * jQuery UI Effects Fold 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Fold
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.fold=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right"],e=a.effects.setMode(c,b.options.mode||"hide"),f=b.options.size||15,g=!!!!b.options.horizFirst,h=b.duration?b.duration/2:a.fx.speeds._default/2;a.effects.save(c,d),c.show();var i=a.effects.createWrapper(c).css({overflow:"hidden"}),j=e=="show"!!=g,k=j?["width","height"]:["height","width"],l=j?[i.width(),i.height()]:[i.height(),i.width()],m=/([0-9]+)%/.exec(f);m&&(f=parseInt(m[1],10)/100*l[e=="hide"?0:1]),e=="show"&&i.css(g?{height:0,width:f}:{height:f,width:0});var n={},p={};n[k[0]]=e=="show"?l[0]:f,p[k[1]]=e=="show"?l[1]:0,i.animate(n,h,b.options.easing).animate(p,h,b.options.easing,function(){e=="hide"&&c.hide(),a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(c[0],arguments),c.dequeue()})})}})(jQuery);/*
 * jQuery UI Effects Highlight 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Highlight
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.highlight=function(b){return this.queue(function(){var c=a(this),d=["backgroundImage","backgroundColor","opacity"],e=a.effects.setMode(c,b.options.mode||"show"),f={backgroundColor:c.css("backgroundColor")};e=="hide"&&(f.opacity=0),a.effects.save(c,d),c.show().css({backgroundImage:"none",backgroundColor:b.options.color||"#ffff99"}).animate(f,{queue:!!1,duration:b.duration,easing:b.options.easing,complete:function(){e=="hide"&&c.hide(),a.effects.restore(c,d),e=="show"&&!!a.support.opacity&&this.style.removeAttribute("filter"),b.callback&&b.callback.apply(this,arguments),c.dequeue()}})})}})(jQuery);/*
 * jQuery UI Effects Pulsate 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Pulsate
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.pulsate=function(b){return this.queue(function(){var c=a(this),d=a.effects.setMode(c,b.options.mode||"show");times=(b.options.times||5)*2-1,duration=b.duration?b.duration/2:a.fx.speeds._default/2,isVisible=c.is(":visible"),animateTo=0,isVisible||(c.css("opacity",0).show(),animateTo=1),(d=="hide"&&isVisible||d=="show"&&!!isVisible)&&times--;for(var e=0;e<times;e++)c.animate({opacity:animateTo},duration,b.options.easing),animateTo=(animateTo+1)%2;c.animate({opacity:animateTo},duration,b.options.easing,function(){animateTo==0&&c.hide(),b.callback&&b.callback.apply(this,arguments)}),c.queue("fx",function(){c.dequeue()}).dequeue()})}})(jQuery);/*
 * jQuery UI Effects Scale 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Scale
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.puff=function(b){return this.queue(function(){var c=a(this),d=a.effects.setMode(c,b.options.mode||"hide"),e=parseInt(b.options.percent,10)||150,f=e/100,g={height:c.height(),width:c.width()};a.extend(b.options,{fade:!!0,mode:d,percent:d=="hide"?e:100,from:d=="hide"?g:{height:g.height*f,width:g.width*f}}),c.effect("scale",b.options,b.duration,b.callback),c.dequeue()})},a.effects.scale=function(b){return this.queue(function(){var c=a(this),d=a.extend(!!0,{},b.options),e=a.effects.setMode(c,b.options.mode||"effect"),f=parseInt(b.options.percent,10)||(parseInt(b.options.percent,10)==0?0:e=="hide"?0:100),g=b.options.direction||"both",h=b.options.origin;e!!="effect"&&(d.origin=h||["middle","center"],d.restore=!!0);var i={height:c.height(),width:c.width()};c.from=b.options.from||(e=="show"?{height:0,width:0}:i);var j={y:g!!="horizontal"?f/100:1,x:g!!="vertical"?f/100:1};c.to={height:i.height*j.y,width:i.width*j.x},b.options.fade&&(e=="show"&&(c.from.opacity=0,c.to.opacity=1),e=="hide"&&(c.from.opacity=1,c.to.opacity=0)),d.from=c.from,d.to=c.to,d.mode=e,c.effect("size",d,b.duration,b.callback),c.dequeue()})},a.effects.size=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right","width","height","overflow","opacity"],e=["position","top","bottom","left","right","overflow","opacity"],f=["width","height","overflow"],g=["fontSize"],h=["borderTopWidth","borderBottomWidth","paddingTop","paddingBottom"],i=["borderLeftWidth","borderRightWidth","paddingLeft","paddingRight"],j=a.effects.setMode(c,b.options.mode||"effect"),k=b.options.restore||!!1,l=b.options.scale||"both",m=b.options.origin,n={height:c.height(),width:c.width()};c.from=b.options.from||n,c.to=b.options.to||n;if(m){var p=a.effects.getBaseline(m,n);c.from.top=(n.height-c.from.height)*p.y,c.from.left=(n.width-c.from.width)*p.x,c.to.top=(n.height-c.to.height)*p.y,c.to.left=(n.width-c.to.width)*p.x}var q={from:{y:c.from.height/n.height,x:c.from.width/n.width},to:{y:c.to.height/n.height,x:c.to.width/n.width}};if(l=="box"||l=="both")q.from.y!!=q.to.y&&(d=d.concat(h),c.from=a.effects.setTransition(c,h,q.from.y,c.from),c.to=a.effects.setTransition(c,h,q.to.y,c.to)),q.from.x!!=q.to.x&&(d=d.concat(i),c.from=a.effects.setTransition(c,i,q.from.x,c.from),c.to=a.effects.setTransition(c,i,q.to.x,c.to));(l=="content"||l=="both")&&q.from.y!!=q.to.y&&(d=d.concat(g),c.from=a.effects.setTransition(c,g,q.from.y,c.from),c.to=a.effects.setTransition(c,g,q.to.y,c.to)),a.effects.save(c,k?d:e),c.show(),a.effects.createWrapper(c),c.css("overflow","hidden").css(c.from);if(l=="content"||l=="both")h=h.concat(["marginTop","marginBottom"]).concat(g),i=i.concat(["marginLeft","marginRight"]),f=d.concat(h).concat(i),c.find("*[width]").each(function(){child=a(this),k&&a.effects.save(child,f);var c={height:child.height(),width:child.width()};child.from={height:c.height*q.from.y,width:c.width*q.from.x},child.to={height:c.height*q.to.y,width:c.width*q.to.x},q.from.y!!=q.to.y&&(child.from=a.effects.setTransition(child,h,q.from.y,child.from),child.to=a.effects.setTransition(child,h,q.to.y,child.to)),q.from.x!!=q.to.x&&(child.from=a.effects.setTransition(child,i,q.from.x,child.from),child.to=a.effects.setTransition(child,i,q.to.x,child.to)),child.css(child.from),child.animate(child.to,b.duration,b.options.easing,function(){k&&a.effects.restore(child,f)})});c.animate(c.to,{queue:!!1,duration:b.duration,easing:b.options.easing,complete:function(){c.to.opacity===0&&c.css("opacity",c.from.opacity),j=="hide"&&c.hide(),a.effects.restore(c,k?d:e),a.effects.removeWrapper(c),b.callback&&b.callback.apply(this,arguments),c.dequeue()}})})}})(jQuery);/*
 * jQuery UI Effects Shake 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Shake
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.shake=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right"],e=a.effects.setMode(c,b.options.mode||"effect"),f=b.options.direction||"left",g=b.options.distance||20,h=b.options.times||3,i=b.duration||b.options.duration||140;a.effects.save(c,d),c.show(),a.effects.createWrapper(c);var j=f=="up"||f=="down"?"top":"left",k=f=="up"||f=="left"?"pos":"neg",l={},m={},n={};l[j]=(k=="pos"?"-=":"+=")+g,m[j]=(k=="pos"?"+=":"-=")+g*2,n[j]=(k=="pos"?"-=":"+=")+g*2,c.animate(l,i,b.options.easing);for(var p=1;p<h;p++)c.animate(m,i,b.options.easing).animate(n,i,b.options.easing);c.animate(m,i,b.options.easing).animate(l,i/2,b.options.easing,function(){a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(this,arguments)}),c.queue("fx",function(){c.dequeue()}),c.dequeue()})}})(jQuery);/*
 * jQuery UI Effects Slide 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Slide
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.slide=function(b){return this.queue(function(){var c=a(this),d=["position","top","bottom","left","right"],e=a.effects.setMode(c,b.options.mode||"show"),f=b.options.direction||"left";a.effects.save(c,d),c.show(),a.effects.createWrapper(c).css({overflow:"hidden"});var g=f=="up"||f=="down"?"top":"left",h=f=="up"||f=="left"?"pos":"neg",i=b.options.distance||(g=="top"?c.outerHeight({margin:!!0}):c.outerWidth({margin:!!0}));e=="show"&&c.css(g,h=="pos"?isNaN(i)?"-"+i:-i:i);var j={};j[g]=(e=="show"?h=="pos"?"+=":"-=":h=="pos"?"-=":"+=")+i,c.animate(j,{queue:!!1,duration:b.duration,easing:b.options.easing,complete:function(){e=="hide"&&c.hide(),a.effects.restore(c,d),a.effects.removeWrapper(c),b.callback&&b.callback.apply(this,arguments),c.dequeue()}})})}})(jQuery);/*
 * jQuery UI Effects Transfer 1.8.18
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/Effects/Transfer
 *
 * Depends:
 *	jquery.effects.core.js
 */(function(a,b){a.effects.transfer=function(b){return this.queue(function(){var c=a(this),d=a(b.options.to),e=d.offset(),f={top:e.top,left:e.left,height:d.innerHeight(),width:d.innerWidth()},g=c.offset(),h=a(''<div class="ui-effects-transfer"></div>'').appendTo(document.body).addClass(b.options.className).css({top:g.top,left:g.left,height:c.innerHeight(),width:c.innerWidth(),position:"absolute"}).animate(f,b.duration,b.options.easing,function(){h.remove(),b.callback&&b.callback.apply(c[0],arguments),c.dequeue()})})}})(jQuery);'! !

!ScwResources methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 10:15'!
selectorsToInclude
	^#(styleCss jQueryJs jQueryUiJs)! !

!ScwResources methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:13'!
styleCss
	^'
#actions {
    list-style: none;
    margin: 0;
    padding: 0;
}

#actions li {
    display: inline-block;
    margin-left: 0.2em;
    margin-right: 0.2em;
}

#undoHistory {
    border-width: 0;
}

#undoHistory h2 {
    margin-top: 0;
    font-size: 1em;
}

#actions li {
    text-align: center;
}

#actions a {
    text-decoration: none;
}

#actions span {
    display: block;
}

tr.expense {
color: darkred;
}

tr.income {
color: darkgreen;
}

tr.transfer {
color: blue;
}
'
! !

!ScwResources methodsFor: 'uploaded' stamp: 'StuartHerring 1/23/2012 20:01'!
transactionPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 8 84 73 68 65 84 104 129 197 88 251 111 84 199 21 254 102 238 99 189 107 99 95 30 6 19 104 178 198 105 12 148 135 169 19 90 90 36 214 169 72 66 149 192 70 73 72 3 52 24 165 47 245 135 6 126 142 42 154 63 32 42 72 149 170 150 80 67 165 182 73 67 195 58 64 32 169 132 173 148 38 72 45 101 13 166 198 188 108 140 13 54 96 123 177 247 225 189 119 239 156 254 176 119 215 119 239 238 154 93 63 232 145 70 51 119 238 157 51 223 55 231 220 115 102 134 17 17 0 128 49 134 233 144 117 111 183 248 22 104 37 45 85 154 11 140 1 32 128 0 92 235 143 32 60 150 104 56 187 191 161 117 170 115 164 48 3 128 60 85 101 185 148 215 215 104 216 188 182 10 220 90 20 147 8 239 5 174 226 234 109 99 186 167 155 25 2 95 94 13 225 242 253 56 200 214 127 123 112 12 36 40 239 184 201 202 180 19 128 32 8 34 152 14 176 36 40 195 244 211 37 51 98 1 18 2 194 73 128 8 152 1 2 108 186 126 226 103 126 246 121 29 0 31 128 13 21 154 219 175 105 30 155 11 17 42 85 134 184 158 0 1 136 197 205 208 141 59 225 32 64 221 68 104 3 208 250 239 223 61 31 44 116 46 187 37 167 68 224 233 159 126 166 1 104 44 115 203 111 63 253 212 28 239 10 175 134 85 222 10 140 196 77 236 63 121 19 176 81 216 189 201 11 65 128 41 128 170 217 46 168 50 199 141 254 48 186 250 35 232 184 249 0 109 215 134 186 35 99 137 0 17 222 61 119 224 133 208 140 19 168 255 241 41 255 252 217 37 77 155 191 251 53 205 183 122 62 46 247 134 113 99 32 138 235 3 17 244 13 141 57 102 204 168 44 16 192 146 5 30 44 208 92 120 188 210 131 39 31 43 195 47 15 156 195 208 72 188 250 220 129 77 221 51 74 160 254 71 39 155 158 173 95 216 248 220 218 69 184 216 51 138 243 55 66 8 69 242 135 200 124 174 63 222 79 16 130 48 208 55 28 252 207 193 239 175 121 216 252 83 202 3 223 124 235 211 166 109 207 215 52 46 89 84 129 166 211 61 120 144 1 60 223 34 80 102 139 178 223 198 162 58 64 212 92 44 158 162 8 172 217 117 98 247 250 186 170 70 181 68 197 239 79 117 141 191 72 227 166 116 83 8 130 161 39 178 116 72 50 135 36 241 52 240 84 99 44 26 7 17 5 138 66 143 34 8 212 53 30 211 230 148 171 123 87 62 85 137 35 103 122 157 184 211 98 24 9 132 71 98 136 199 244 32 128 236 21 37 172 6 224 85 93 114 157 234 86 225 114 171 224 18 135 30 211 67 231 155 94 44 56 18 21 77 0 68 141 107 87 85 105 45 23 238 38 51 42 203 242 4 36 116 19 161 251 35 65 18 98 215 249 67 47 77 8 166 110 231 49 45 62 102 248 70 135 195 91 36 73 106 20 166 40 122 245 139 34 64 130 54 36 192 113 119 216 138 48 4 176 148 13 172 42 252 32 2 97 154 123 130 135 55 63 116 37 131 135 95 10 1 8 0 8 172 126 179 121 15 0 173 72 236 0 138 178 0 52 67 100 70 20 114 196 71 97 10 4 15 111 110 45 22 68 219 31 183 132 0 76 24 251 243 9 47 244 67 34 66 239 189 40 132 72 134 60 162 236 34 201 18 86 109 15 236 158 12 144 201 74 81 4 238 14 197 210 96 83 68 4 17 4 1 130 128 146 89 110 200 170 252 235 149 219 142 254 106 6 49 103 72 193 137 108 229 27 31 55 149 205 45 111 84 220 42 108 222 159 67 35 48 54 26 67 108 36 210 77 166 216 15 224 208 197 15 94 153 148 123 228 147 73 101 226 21 63 248 155 79 245 184 90 74 103 151 231 204 87 206 46 34 130 208 13 68 31 68 97 196 141 67 0 53 183 127 248 234 164 34 141 83 38 189 149 248 198 214 35 45 101 149 154 79 118 41 227 128 179 134 101 118 200 50 131 196 0 61 28 67 248 65 52 164 199 141 0 8 205 151 62 122 109 210 100 38 79 224 181 143 188 140 179 243 165 149 154 38 41 74 110 216 89 166 176 186 57 131 199 45 67 229 192 88 56 134 123 119 66 221 134 97 238 7 112 232 191 71 182 22 229 98 83 218 204 45 127 245 175 117 140 177 22 207 188 10 77 118 169 197 204 155 22 69 225 88 56 191 12 34 30 199 149 246 190 144 174 155 187 58 62 126 189 96 139 76 121 55 186 252 149 15 53 34 52 169 165 37 126 87 121 41 184 36 229 223 199 1 217 41 219 234 40 245 40 88 242 132 134 254 158 65 92 187 220 31 0 104 87 199 209 55 30 106 141 105 59 208 44 123 249 3 31 128 189 106 105 137 79 45 117 131 171 74 158 47 41 103 51 37 43 150 85 194 28 211 113 246 31 87 131 32 106 184 220 188 109 230 15 52 118 89 234 255 139 15 192 78 73 145 253 114 137 170 49 206 193 184 67 31 101 54 156 219 234 117 235 188 136 142 68 113 246 204 181 125 157 159 108 223 243 72 9 164 100 233 150 63 107 0 252 0 54 128 49 63 151 37 77 82 101 48 150 202 151 217 150 72 18 33 168 170 132 215 183 174 193 103 39 46 162 247 214 112 117 231 177 29 221 143 156 128 83 106 55 255 201 15 194 78 38 113 191 236 82 192 184 45 241 19 101 122 19 1 235 191 227 133 91 225 56 241 105 251 190 43 199 127 152 215 10 118 2 5 111 37 38 35 157 159 108 15 116 30 219 254 178 72 152 107 244 200 88 171 169 27 32 33 172 66 86 17 233 210 213 53 136 229 181 243 65 130 124 133 206 49 163 4 82 114 229 248 142 224 149 227 59 26 140 88 60 96 234 9 235 146 43 155 200 173 91 195 112 187 21 128 168 174 80 221 143 132 64 90 8 123 198 173 224 180 0 165 175 30 171 159 152 83 176 202 71 74 224 234 201 55 187 133 105 102 184 77 22 17 2 174 119 221 47 88 103 81 135 250 154 231 154 26 1 120 1 28 186 254 249 174 238 98 198 90 227 125 96 44 189 210 228 136 165 139 23 107 136 36 111 39 90 11 213 89 220 181 10 137 45 92 150 253 36 104 111 205 198 63 4 0 106 6 208 122 253 239 111 117 63 20 252 198 131 62 128 142 114 73 2 9 97 35 144 86 14 111 245 60 92 234 184 3 34 81 240 225 190 40 2 4 242 39 147 20 64 196 253 36 132 159 72 96 201 198 247 187 65 20 4 208 102 125 218 106 213 62 0 21 96 204 7 206 235 36 89 78 134 79 178 231 181 100 75 85 101 212 212 86 225 84 224 95 0 137 253 133 98 42 56 15 84 127 239 183 126 206 229 163 92 78 30 104 146 131 236 236 82 215 231 201 227 25 1 86 54 102 227 241 223 230 50 142 196 140 134 77 43 17 25 25 197 87 45 151 246 117 157 254 121 193 153 184 112 11 8 115 3 184 98 249 111 106 143 156 235 67 14 112 128 217 111 227 44 151 201 78 196 73 83 124 203 183 20 9 67 199 151 167 47 4 1 188 91 48 166 2 9 112 0 140 68 194 15 48 16 9 39 10 75 88 174 206 28 207 169 110 130 172 202 168 95 95 139 216 232 40 254 121 230 194 197 216 80 199 11 119 219 223 143 0 144 0 136 252 131 31 78 128 91 74 36 0 210 130 149 63 169 6 200 75 194 0 152 61 242 50 71 51 199 105 198 185 95 0 32 43 18 230 47 154 135 170 197 26 58 131 29 24 232 233 57 216 251 213 222 119 0 152 0 74 173 58 85 18 19 145 113 254 3 204 34 37 89 117 186 84 213 253 226 69 217 61 119 171 36 123 54 50 174 0 92 2 99 82 190 133 201 18 213 237 66 249 220 114 184 61 46 112 36 112 175 175 31 161 254 222 227 163 183 207 252 102 164 239 139 155 0 12 11 108 170 216 159 237 132 40 223 102 206 9 94 201 81 43 37 218 215 231 148 45 252 246 58 197 93 249 12 151 221 181 146 58 171 14 96 182 29 39 192 184 2 100 4 5 130 103 150 138 104 104 232 110 60 50 120 193 136 221 11 142 244 182 182 234 163 189 195 54 160 70 142 146 139 72 34 31 1 158 99 245 149 66 138 103 238 138 69 74 233 194 199 64 66 118 207 89 246 172 58 107 113 67 166 117 8 122 116 224 210 157 115 239 189 227 0 155 0 160 219 234 124 36 156 4 210 12 236 255 128 176 62 96 182 154 35 247 49 157 172 239 5 0 51 58 216 126 19 131 237 189 0 36 181 252 241 90 50 117 16 115 236 82 132 48 1 68 144 233 219 206 85 206 231 54 166 13 95 198 191 224 252 137 83 31 8 219 128 148 53 82 171 148 122 150 108 181 100 145 149 24 88 76 152 241 12 151 74 222 162 154 6 128 97 155 94 59 145 84 157 200 241 156 225 255 14 188 57 163 80 10 124 194 2 149 17 145 28 207 220 86 39 45 198 120 52 105 1 135 86 18 6 128 65 155 126 251 34 57 87 217 254 108 75 60 217 50 81 30 32 155 34 195 2 104 119 43 238 104 91 105 87 138 9 51 110 75 11 86 202 18 34 97 17 176 187 96 174 122 66 192 197 16 200 69 40 53 145 83 236 247 90 157 36 226 173 233 17 227 195 219 0 132 29 250 166 44 140 104 90 244 252 223 228 209 158 200 102 64 254 7 149 152 154 25 42 129 42 210 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!ScwResources methodsFor: 'uploaded' stamp: 'StuartHerring 1/23/2012 20:02'!
transferPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 48 0 0 0 48 8 6 0 0 0 87 2 249 135 0 0 10 58 73 68 65 84 104 129 173 89 107 140 93 85 21 254 246 57 247 49 143 206 116 166 233 20 43 88 6 19 69 160 213 219 2 9 106 162 20 197 196 31 132 18 49 26 208 240 170 255 80 104 140 49 196 152 182 49 134 248 11 208 152 240 3 172 137 196 72 162 64 2 213 196 24 169 68 19 18 21 70 121 148 71 98 75 16 42 133 129 153 222 59 247 158 253 88 107 249 99 239 243 188 247 204 116 218 238 228 204 217 231 158 253 88 223 250 214 107 159 129 136 64 68 112 174 218 85 215 207 30 184 236 154 70 231 156 45 88 211 82 185 163 115 189 240 246 206 101 159 250 204 231 175 58 116 174 215 173 107 42 213 190 82 234 140 22 184 242 134 214 158 75 183 239 232 196 113 140 40 138 65 98 111 233 235 229 249 166 76 28 124 228 222 127 29 56 157 53 118 220 244 120 71 41 181 167 44 131 64 4 16 97 8 75 184 24 194 252 196 209 199 190 190 144 201 125 166 0 174 221 187 101 207 220 121 155 239 35 216 249 126 210 69 98 250 80 10 152 156 152 66 63 233 225 194 173 23 227 181 215 95 218 121 228 161 149 133 213 214 185 244 43 143 206 168 56 62 166 148 154 129 2 20 20 4 193 164 131 153 148 0 16 47 48 209 238 215 14 127 115 9 0 26 235 146 58 180 235 239 218 118 104 114 102 226 214 247 62 248 47 162 56 66 20 43 180 39 154 80 145 130 149 4 205 118 3 239 158 122 19 151 239 250 244 161 35 248 211 206 213 214 154 156 155 237 0 200 132 71 153 132 244 79 222 21 233 0 232 0 56 114 70 0 190 118 207 199 15 68 45 185 245 253 238 255 208 158 104 161 209 138 17 199 49 226 184 129 40 138 160 148 119 43 38 66 223 45 119 190 243 179 207 29 248 233 183 159 57 80 183 94 220 106 2 0 126 254 173 29 167 181 255 157 15 191 88 122 94 23 128 221 123 55 204 183 39 155 251 223 91 62 129 177 201 22 154 173 22 90 205 54 154 141 38 26 113 19 81 20 67 69 30 128 48 3 138 177 113 227 236 254 235 238 217 124 255 147 247 190 183 52 106 77 17 6 0 124 226 130 41 156 236 89 104 39 200 137 200 233 104 199 10 115 27 26 16 46 71 204 117 1 184 96 219 182 187 250 230 20 218 227 45 140 141 141 99 172 61 134 217 233 45 216 52 189 5 137 233 163 217 108 163 219 255 0 0 48 217 158 198 120 107 122 225 217 23 254 120 91 157 240 30 168 64 1 232 106 198 239 143 46 225 237 83 22 145 82 80 10 128 82 80 0 4 130 15 79 183 176 231 178 217 12 240 25 1 152 218 56 213 233 190 187 136 201 13 27 176 121 246 67 152 28 155 62 190 212 93 124 224 249 87 254 186 208 104 52 231 175 188 100 247 161 70 220 192 220 212 71 150 142 157 56 122 240 224 205 191 186 127 205 69 197 187 108 207 16 180 101 88 199 136 148 15 42 105 92 17 1 180 37 244 12 157 29 3 173 86 235 234 177 241 49 76 79 206 98 122 98 211 194 203 255 249 199 238 223 237 63 177 4 0 123 239 219 177 231 226 243 175 192 187 203 111 29 249 219 75 79 221 246 240 190 23 143 159 206 154 169 64 61 195 48 150 225 44 67 69 1 64 58 6 128 177 140 158 97 143 230 76 1 76 111 216 132 229 254 34 46 218 122 9 158 123 245 153 27 82 225 1 224 188 77 219 230 95 121 243 159 251 190 119 227 47 215 214 122 9 0 3 80 232 106 134 118 12 235 40 211 126 26 218 5 128 182 140 174 230 179 99 32 146 120 161 221 26 235 56 71 11 191 249 193 27 199 139 239 126 124 203 225 117 9 158 1 16 1 32 232 25 130 177 4 235 56 7 0 0 74 1 34 208 54 14 38 84 246 129 117 149 18 243 91 46 61 50 183 241 124 92 241 209 47 214 58 229 186 1 132 36 213 53 236 125 192 50 156 35 184 224 15 54 128 210 150 208 53 140 106 237 182 46 6 254 242 210 99 15 92 243 201 175 222 125 106 176 56 244 238 242 189 127 120 94 197 81 39 138 35 168 40 242 244 151 28 49 148 6 204 75 66 188 251 239 15 126 105 33 188 0 0 244 180 7 224 28 151 204 39 132 33 239 3 35 76 104 93 12 28 250 238 203 199 35 52 14 126 236 188 203 75 213 230 174 219 15 223 13 72 7 226 211 61 19 229 151 35 144 35 48 49 132 8 194 60 3 145 167 211 185 57 3 4 147 106 61 248 130 103 192 247 181 101 116 13 157 29 3 0 112 243 181 63 60 240 147 223 126 99 227 254 95 95 215 57 120 211 147 11 0 208 154 154 152 217 58 59 134 173 179 99 88 171 162 234 38 14 175 159 88 153 201 0 132 184 190 98 130 19 219 220 137 211 132 150 134 209 21 195 0 159 69 30 72 219 247 111 124 100 95 241 89 152 241 229 206 28 238 248 194 133 107 206 125 254 216 50 238 124 232 133 194 92 175 77 99 40 179 247 98 14 8 22 4 235 24 230 108 243 64 93 19 22 104 203 120 245 228 0 135 95 88 68 28 169 161 68 196 34 216 121 193 6 52 184 28 73 50 0 150 224 92 238 3 64 62 31 0 172 101 24 75 67 135 175 115 3 128 24 137 101 156 236 26 28 125 171 135 40 82 136 2 8 15 64 192 44 216 60 217 192 220 120 92 6 32 41 0 134 35 6 17 135 18 162 44 168 35 159 232 106 25 216 121 251 19 51 42 82 135 0 204 164 27 87 143 8 18 106 90 17 44 60 247 208 245 153 25 9 51 18 71 232 106 66 162 9 113 6 32 159 199 44 88 209 132 241 24 229 88 30 250 214 18 200 9 136 4 80 2 85 241 38 10 254 81 91 11 49 209 211 74 84 71 41 5 201 138 168 66 125 158 10 239 37 186 122 215 237 143 227 185 95 220 176 207 3 16 36 150 209 75 24 90 187 90 6 86 18 194 120 172 192 148 107 113 152 1 9 123 74 72 100 126 239 53 25 152 154 153 236 248 2 48 247 158 81 17 165 112 198 200 66 169 176 55 161 83 154 160 13 101 194 23 25 144 192 192 88 83 141 244 1 107 9 142 24 142 57 203 192 69 221 57 39 176 150 128 58 0 68 140 31 221 177 11 219 47 154 29 33 118 185 61 250 231 99 120 244 233 99 5 33 60 128 158 38 216 180 24 171 176 39 34 232 27 194 152 137 70 251 128 241 78 76 148 106 126 132 15 152 85 156 152 137 209 29 56 60 251 250 50 94 121 123 165 86 248 207 94 60 131 129 118 96 42 107 49 177 228 1 20 138 177 98 19 1 250 134 209 214 229 80 152 130 49 150 97 6 6 38 177 225 77 121 1 197 12 99 199 135 106 161 28 0 123 7 90 78 12 142 189 51 168 5 208 185 112 10 142 197 71 139 108 110 96 192 240 112 49 134 244 40 11 12 12 161 181 138 9 153 196 192 244 205 200 125 99 164 78 92 199 0 123 7 101 14 182 86 211 210 84 206 21 45 58 199 208 198 193 133 76 154 29 210 17 92 63 100 83 109 203 38 132 130 19 51 241 144 134 211 70 107 57 177 136 132 170 207 47 86 215 180 101 56 42 215 35 66 2 231 8 198 16 200 186 80 196 149 77 64 68 96 13 193 182 162 138 9 249 190 115 1 0 241 200 232 33 228 149 84 203 128 136 143 18 125 141 85 25 232 37 190 176 42 1 8 12 24 67 32 83 0 144 217 144 175 68 157 113 176 54 242 66 102 175 124 159 130 246 115 6 202 54 200 169 217 214 249 128 48 99 37 33 12 18 159 182 235 1 56 36 102 216 17 157 37 24 109 161 7 9 210 74 76 21 3 185 0 90 91 152 118 12 30 225 3 142 60 3 169 105 86 51 49 147 207 19 245 38 196 130 158 118 232 27 192 186 213 24 112 72 236 112 61 227 28 67 107 15 34 59 73 21 239 0 140 113 176 21 59 78 153 116 228 253 42 93 183 250 185 153 121 216 116 43 0 60 3 125 163 224 92 253 215 234 94 66 129 129 34 128 96 66 150 32 196 144 210 87 182 220 20 178 49 165 82 194 239 69 167 225 3 228 86 97 128 137 177 162 29 150 187 14 31 44 118 195 175 170 116 3 128 229 222 84 13 0 95 14 103 26 76 51 105 129 1 103 203 99 128 162 15 80 217 7 42 65 128 153 253 152 186 90 72 152 176 146 16 86 250 22 122 96 170 114 103 173 219 183 72 12 149 18 25 7 19 178 214 159 194 178 26 40 45 10 131 64 206 17 236 16 120 111 174 156 158 218 50 13 15 251 0 59 170 119 98 38 198 74 98 161 181 3 91 151 143 168 104 162 159 88 104 227 202 66 132 16 151 106 87 10 57 0 42 43 203 252 24 71 144 82 49 231 0 40 176 11 230 87 147 7 132 61 0 145 178 127 230 12 16 35 25 24 232 196 122 164 53 109 208 55 48 218 129 41 31 227 207 193 222 70 193 4 64 65 50 220 185 2 216 17 156 147 10 3 46 123 39 204 89 132 170 178 47 129 129 116 252 16 0 38 66 50 176 48 218 130 172 43 40 190 188 84 146 248 49 165 90 72 8 68 148 133 66 85 113 222 148 15 162 97 59 22 182 25 128 162 19 75 101 95 181 38 0 102 31 167 181 27 205 64 144 71 39 6 198 84 24 32 11 34 202 24 144 161 8 228 163 58 133 19 151 144 45 205 5 0 10 194 137 16 144 30 9 10 153 76 88 133 49 249 220 50 0 34 104 109 97 141 3 59 135 209 46 12 232 196 193 26 87 206 166 108 192 100 225 136 106 25 128 242 123 184 138 16 194 6 222 7 28 152 108 0 20 210 88 33 19 171 8 96 231 194 248 145 0 24 214 120 225 184 88 74 84 112 24 99 225 108 149 1 13 118 54 80 236 25 200 179 112 126 243 223 137 28 152 116 97 174 245 224 28 65 200 66 200 228 236 21 26 147 100 99 70 2 128 248 40 66 214 130 92 82 152 94 214 164 179 206 155 65 193 142 153 52 200 89 196 174 144 7 80 61 19 168 240 145 203 66 138 0 130 70 217 17 216 105 112 1 64 233 52 171 60 0 102 83 138 176 165 60 64 196 104 76 182 49 213 90 229 84 22 71 222 217 138 0 92 2 118 6 81 28 99 246 252 173 21 229 229 15 81 179 1 54 3 48 37 5 240 57 128 184 53 133 184 89 9 163 233 135 33 21 5 6 106 76 8 66 112 73 2 9 255 179 170 110 158 109 152 36 112 86 135 112 153 10 49 128 235 159 130 105 143 87 70 87 204 192 2 46 89 1 187 28 128 103 67 193 246 151 202 51 70 153 145 29 212 3 16 182 88 89 60 89 222 184 180 90 250 175 207 108 70 190 176 75 208 95 124 3 253 247 223 8 99 135 11 185 82 43 20 100 169 201 12 22 95 28 49 111 173 15 149 56 251 127 116 3 192 150 237 123 231 1 53 159 127 73 80 35 53 88 108 239 252 251 193 35 103 188 33 242 42 182 14 64 250 16 133 126 4 32 14 247 168 242 92 252 61 29 155 174 81 58 22 135 62 135 62 135 139 42 247 106 63 29 11 20 249 15 114 87 63 45 198 225 106 84 174 102 184 138 253 234 111 141 194 220 34 168 84 232 84 48 87 184 219 194 189 120 185 74 63 125 78 231 101 158 94 5 80 212 134 173 0 90 237 158 94 69 38 70 49 32 24 214 122 10 168 10 174 248 123 149 145 172 157 137 15 168 17 253 81 94 55 84 143 141 232 215 221 215 108 169 220 255 7 241 236 90 253 247 238 150 183 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

MbForm subclass: #ScwNewTransactionForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwNewTransactionForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:19'!
initializeWithObject: anObject
	super initializeWithObject: anObject.
 	fields first onChange: [ :v | self poolChanged: v]! !

!ScwNewTransactionForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:22'!
poolChanged: v
	v ifNotNil: [ v defaultAccount ifNotNil: [ :a | fields last value: a ]]! !

!ScwNewTransactionForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:20'!
renderFieldsOn: html
	fields do: [ :field | html render: field].
	html script: (((html jQuery: 'select') first) onChange:  ((((html jQuery: 'select') last parentsUntil: '.control-group') parent load
			serialize: (html jQuery: 'select') first) html: [ :h | h render: fields last]))! !

WATask subclass: #ScwAdminSetupTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Admin'!

!ScwAdminSetupTask class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/14/2012 14:52'!
canBeRoot
	^true! !

SPInternalUserRegistry subclass: #ScwUserRegistry
	instanceVariableNames: 'transactionProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Application'!

!ScwUserRegistry class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 17:55'!
withUsers: aCollection
	^self basicNew
		initializeWithUsers: aCollection;
		yourself! !

!ScwUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 17:57'!
addUser: aUser
	transactionProvider commit: [
		super addUser: aUser]! !

!ScwUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 15:30'!
findUserByEmailAddress: anAddress
	^users detect: [ :user | user email = anAddress ] ifNone: [nil]! !

!ScwUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 17:54'!
initializeWithUsers: aCollection
	self initialize.
	users := aCollection! !

!ScwUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 20:03'!
removeUser: aUser
	transactionProvider commit: [
		super removeUser: aUser]! !

!ScwUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 17:56'!
transactionProvider: aTransactionProvider
	transactionProvider := aTransactionProvider.! !

!ScwUserRegistry methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 14:07'!
users
	^users! !

!ScInsufficientFundsNotice methodsFor: '*smallchange-web' stamp: 'StuartHerring 3/18/2012 10:17'!
renderOn: html
	html render: self message.! !

Announcement subclass: #ScwModalAnnouncement
	instanceVariableNames: 'component result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web'!

!ScwModalAnnouncement methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 17:56'!
component
	^component! !

!ScwModalAnnouncement methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 17:56'!
component: aComponent
	component := aComponent.! !

!ScwModalAnnouncement methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:02'!
result
	^result! !

!ScwModalAnnouncement methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:06'!
result: aValue
	result := aValue! !

MbTransactionProvider subclass: #ScwXmlTransactionProvider
	instanceVariableNames: 'filename model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Application'!

!ScwXmlTransactionProvider class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:25'!
directory
	^(FileDirectory default / 'profiles') assureExistence! !

!ScwXmlTransactionProvider class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:26'!
list
	^self directory fileNames! !

!ScwXmlTransactionProvider class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:32'!
load: aFilename
	^self model: (Object readSixxFrom: (self directory fileNamed: aFilename)) filename: aFilename! !

!ScwXmlTransactionProvider class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:33'!
model: anObject filename: aFilename
	^self basicNew
		initializeWithModel: anObject filename: aFilename;
		yourself.! !

!ScwXmlTransactionProvider methodsFor: 'saving' stamp: 'StuartHerring 2/5/2012 17:31'!
commit
	self save.! !

!ScwXmlTransactionProvider methodsFor: 'saving' stamp: 'StuartHerring 2/5/2012 17:33'!
filename
	^filename! !

!ScwXmlTransactionProvider methodsFor: 'saving' stamp: 'StuartHerring 2/5/2012 17:33'!
initializeWithModel: anObject filename: aFilename
	self initialize.
	model := anObject.
	filename := aFilename.! !

!ScwXmlTransactionProvider methodsFor: 'saving' stamp: 'StuartHerring 2/5/2012 17:34'!
model
	^model! !

!ScwXmlTransactionProvider methodsFor: 'saving' stamp: 'StuartHerring 2/5/2012 17:31'!
save
	(self class directory forceNewFileNamed: filename) nextPutAll: model sixxString.! !

ScTransactionHolder subclass: #ScwGlobalTransactionHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwGlobalTransactionHolder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/16/2012 12:08'!
accumulate: aTransaction
	^aTransaction isExpense ifTrue: [aTransaction amount negated] 
		ifFalse: [aTransaction isIncome ifTrue: [aTransaction amount] ifFalse: [0]]! !

!ScwGlobalTransactionHolder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:16'!
openingBalance
	^ profile accounts inject: 0 into: [ :sum :a | sum + a openingBalance ]! !

!ScwGlobalTransactionHolder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 21:14'!
profile: aProfile
	profile := aProfile! !

!ScwGlobalTransactionHolder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 21:12'!
transactions
	^profile transactions! !

SPInternalLoginComponent subclass: #ScwLoginComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwLoginComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/16/2012 18:01'!
renderContentOn: html
	html inlineForm: [
			html textInput on: #username of: self; beSmall; placeholder: 'Email'.
			html passwordInput on: #password of: self; beSmall; placeholder: 'Password'.
			html submitButton callback: [self validateUser ]; bePrimary; beSmall; value: 'Login']! !

!ScNegativeBalanceNotice methodsFor: '*smallchange-web' stamp: 'StuartHerring 5/9/2012 20:02'!
renderOn: html
	html render: self message.! !

WAComponent subclass: #ScwAdminContainerPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Admin'!

!ScwAdminContainerPage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/14/2012 14:49'!
canBeRoot
	^true! !

WAComponent subclass: #ScwComponent
	uses: TScwAnnouncer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

ScwComponent class
	uses: TScwAnnouncer classTrait
	instanceVariableNames: ''!

ScwComponent subclass: #ScwAllocationChart
	instanceVariableNames: 'schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwAllocationChart class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 13:38'!
schedule: aSchedule
	^self new
		initializeWithSchedule: aSchedule;
		yourself.! !

!ScwAllocationChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 13:39'!
initializeWithSchedule: aSchedule
	self initialize.
	schedule := aSchedule! !

!ScwAllocationChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:22'!
nameFor: aTransaction
	^aTransaction pool name ifNil: ['<unnamed>']! !

!ScwAllocationChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/27/2012 14:39'!
renderContentOn: html
 	| id stream c |
	html canvas id: (id := html nextId);width: 600; height: 250; with: 'Canvas Not Supported!!'.
	c := 'c', id.
	stream := WriteStream on: ''.
	stream nextPutAll: '$(window).load(function () { var ', c, ' = new RGraph.Pie(''', id asString, ''',  ['.
	stream	nextPutAll: ((self values collect: [ :t | t amount asFloat printString] ) joinUsing: ',').
	stream nextPutAll: ']); '.
	stream nextPutAll: c, '.Set(''chart.tooltips'', ['''.
	stream nextPutAll: ((self values collect: [ :t | '{1} (${2})' format: {(self nameFor: t). t amount printAsCurrency} ]) joinUsing: ''', ''').
	stream nextPutAll: ''']); '.
	stream nextPutAll: c, '.Set(''chart.tooltips.event'', ''onmousemove'');'.
	stream nextPutAll: c, '.Draw();});'.
	html script: stream contents! !

!ScwAllocationChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:46'!
values
	^(schedule automaticTransactions select: [ :t | t isAllocation ]) asSortedCollection: [ :t1 :t2 | t1 amount > t2 amount ]! !

ScwAllocationChart subclass: #ScwTransferChart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwTransferChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:24'!
nameFor: aTransaction
	^aTransaction account name ifNil: ['<unnamed>']! !

!ScwTransferChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:46'!
values
	^(schedule automaticTransactions select: [ :t | t isTransfer ] ) asSortedCollection: [ :t1 :t2 | t1 amount > t2 amount ]! !

ScwComponent subclass: #ScwAllocationEditor
	instanceVariableNames: 'schedule manualTable accountChart poolChart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwAllocationEditor class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 16:04'!
for: aSchedule
	^self basicNew
		initializeWithSchedule: aSchedule;
		yourself! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:36'!
addManualTransaction
	(self callModal: ((MbForm on: (self profile newTransaction
		sourcePool: schedule transaction pool;
		sourceAccount: schedule transaction account;
		yourself)) title: 'Add Manual Transaction')) ifNotNil: [ :t | self session addManualTransaction: t to:  schedule ]! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:15'!
children
	^{poolChart. accountChart.}! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:44'!
deleteManualTransaction: aTransaction
	self session removeManualTransaction: aTransaction from: schedule! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:42'!
editManualTransaction: aTransaction
	(self callModal: (MbForm on: aTransaction copy)) 
		ifNotNil: [ :t |	self session updateObject: aTransaction with: t ]! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:03'!
initializeWithSchedule: aSchedule
	self initialize.
	schedule := aSchedule.
	accountChart := ScwTransferChart schedule: schedule.
	poolChart := ScwAllocationChart schedule: schedule.
	manualTable := MbTable new
		addColumn: 'Amount' renderedWith: [ :i : h | h render: i amount printAsCurrency ];
		addColumn: 'Destination Account' renderedWith: [ :i : h | h render: i account ];
		addColumn: 'Destination Pool' renderedWith: [ :i : h | h render: i pool ];
		addColumn: '' renderedWith: [:i :h | 
			h anchor callback:  [self editManualTransaction: i]; with: 'Edit'.
			h render: ' | '.
			h anchor callback: [self deleteManualTransaction: i]; with: 'Delete' ]! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:32'!
renderAccountChartOn: html
	html div span: 4; with: accountChart! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 17:06'!
renderBill: aBill on: html
	html listItem: [
		html strong: aBill name.
		html space.
		html render: ('{1} every {2} {3}s.  Allocating: ${4}' format: 
			{ aBill transaction amount printAsCurrency. aBill count asInteger printString. aBill interval asString. (schedule calculatedAmountFor: aBill) printAsCurrency})]! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 16:53'!
renderBillsCoveredOn: html
	html heading level: 2; with: 'Bills covered'.
	html unorderedList: [
		schedule billsCovered do: [ :b |
			self renderBill: b on: html.
		]	
	]! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 13:25'!
renderContentOn: html
	html container: [
		html row: [	html heading level: 1; with: 'Allocations for ', schedule name ].
		html row: [
			self renderPoolChartOn: html.
			self renderTotalAllocationChartOn: html.
			self renderAccountChartOn: html].
		html row: [self renderBillsCoveredOn: html].
		html row: [self renderManualTransactionsOn: html].
		html row: [self renderRemainingOn: html].
		html row: [html anchor class: 'btn btn-primary'; callback: [self answer]; with: 'close'.]]! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 17:39'!
renderManualTransactionsOn: html
	html heading level: 2; with: 'Manual Transactions'.
	html anchor callback: [ self addManualTransaction]; with: [
		html image url: ScwResources addIcon.
		html text: ' New' ].
	manualTable items: schedule manualTransactions.
	html render: manualTable! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:03'!
renderPoolChartOn: html
	html div span: 4; with: poolChart! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:40'!
renderRemainingOn: html
	html heading level: 2;with: 'Remaining'.
	html paragraph: [ html render: $$.
		html render: (
			schedule transaction amount - 
				(schedule billsCovered inject: 0 into: [ :total :bill | total +( schedule calculatedAmountFor: bill) ]) -
				(schedule manualTransactions inject: 0 into: [ :total :t | total + (t amount)])) printAsCurrency ]! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/25/2012 14:41'!
renderTotalAllocationChartOn: html
	html div span: 2; with: ''! !

!ScwAllocationEditor methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 18:42'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	#(RGraphcommoncoreJs RGraphpieJs RGraphcommontooltipsJs) 
		do: [ :script |	anHtmlRoot javascript url: (ScwRGraph urlOf: script )]! !

ScwComponent subclass: #ScwAnalysisWarnings
	instanceVariableNames: 'showNotices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwAnalysisWarnings methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 20:51'!
cssClassFor: aNotice
	aNotice isUrgent ifTrue: [ ^'alert-error' ].
	aNotice isWarning ifTrue: [ ^'alert-block' ].
	^'alert-info'! !

!ScwAnalysisWarnings methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 21:08'!
initialize
	super initialize.
	showNotices := true
	! !

!ScwAnalysisWarnings methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 21:11'!
renderContentOn: html
	showNotices 
		ifFalse: [ html anchor callback: [ showNotices := true]; with: ('Show Notices ({1})' format: { self session notices size printString}) ]
		ifTrue: [	 html anchor class: 'close'; callback: [ showNotices := false ]; with: [ html html: '&times;' ].
			self session notices do: [ :n |
		 	html div class: #alert; class: (self cssClassFor: n); with: n ]]! !

ScwComponent subclass: #ScwChangePasswordForm
	instanceVariableNames: 'user fields message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwChangePasswordForm class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:07'!
on: aUser
	^self basicNew
		initializeWithUser: aUser;
		yourself! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:17'!
children
	^Array with: fields! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 20:09'!
initializeWithUser: aUser
	self initialize.
	user := aUser.
	self resetFields.! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:47'!
passwordsMatch
	"FIXME: This is a very ugly method, I need a much better way of doing cross object validation"
	| f |
	f := fields instVarNamed: #fields.
	^(f at: 2) value = (f at: 3) value
		 ! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 20:04'!
renderContentOn: html
	self renderTitleOn: html.
	self renderMessageOn: html.
	html horizontalForm
		defaultAction: [ self save ];
		with: [ html fieldSet: [
				html render: fields.
				html formActions: [ html submitButton
					class: 'btn';
					bePrimary;
					callback: [ self save ];
					value: 'Save']]]! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 20:06'!
renderMessageOn: html
	message ifNotNil: [ :msg |
 		html div class: 'alert'; class: msg key ; with: msg value].
! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:19'!
renderTitleOn: html
	html heading level: 2; with: 'Change Password'.
	html paragraph: 'Change your password after first verifying your old one'.
	! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 20:09'!
resetFields
	fields := MbFieldGroup on: (ScwChangePasswordObject user: user).! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 20:08'!
save
	self valid ifTrue: [| obj |
		fields save.
		self session transactionProvider commit: [ 
			user password: fields value password1].
			self success]
		ifFalse: [ self setErrorMessage ]! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 20:10'!
setErrorMessage 
	message := nil.
	self passwordsMatch ifFalse: [ message := 'alert-error' -> 'Passwords do not match']! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 20:11'!
success
	message := 'alert-success' -> 'Password successfully changed'.
	self resetFields
	! !

!ScwChangePasswordForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:48'!
valid
	^fields valid and: [self passwordsMatch]! !

!ScwComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 14:48'!
canBeRoot
	^true! !

!ScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 17:53'!
on: anAnnouncement do: aBlock
	self announcer on: anAnnouncement do: aBlock! !

!ScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 14:48'!
profile
	^self session profile! !

!ScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 18:39'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot beHtml5! !

ScwComponent subclass: #ScwContainerPage
	instanceVariableNames: 'content navigationBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwContainerPage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 20:04'!
isLoginComponent
	^true! !

!ScwContainerPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:59'!
children
	^Array with: navigationBar with: content! !

!ScwContainerPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 14:47'!
handleModalAnnouncement: anAnnouncement
	anAnnouncement result: (self call: anAnnouncement component)! !

!ScwContainerPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:59'!
initialize
	super initialize.
	navigationBar := ScwNavBar new.

	content := (	self session isLoggedIn ifTrue: [ScwDashboard new] ifFalse: [ScwLandingPage new]).
	self on: ScwModalAnnouncement do: [ :a | self handleModalAnnouncement: a  ]! !

!ScwContainerPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:59'!
renderContentOn: html
	html render: navigationBar.
	html container: content! !

ScwComponent subclass: #ScwDashboard
	instanceVariableNames: 'history pools accounts schedules expected notices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:44'!
calculateUnallocated
	^self profile unallocated balance
"	^(self session profile transactions inject: (accounts items detectSum: [ :a | a openingBalance])  into: [ :total :each | total + 
		(each isExpense 
			ifTrue: [ each sourcePool isNil ifTrue: [each amount negated] ifFalse: [0] ]
			ifFalse: [
		each isIncome
			ifTrue: [each pool isNil ifTrue: [each amount] ifFalse: [0]]
		ifFalse: [
			each pool isNil 
				ifTrue: [each sourcePool isNil ifTrue: [0] ifFalse: [each amount]]
				ifFalse: [each sourcePool isNil ifTrue: [each amount negated] ifFalse: [0]]]])])"! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 15:39'!
calculateWorth
	^self profile accounts inject: 0 into: [ :total :a | total + a  balance ]! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 20:31'!
calculateWorthAt: aDate
	^(self profile schedules gather: [ :s | s transactionsBetween: Date current and: aDate ])
		inject: self calculateWorth into: [ :total :transaction | self profile accounts inject: total into: [ :subtotal :account | subtotal + (account accumulate: transaction) ]  ]! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2012 19:29'!
children
	^{history. pools. accounts. schedules. expected. notices} asArray! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2012 19:28'!
initialize
	super initialize.
	history := ScwUndoHistory commandProcessor: self session history.
	pools := ScwPoolList new.
	accounts := ScwAccountList new.
	schedules := ScwScheduleList new.
	expected := ScwExpectedTransactions new.
	notices := ScwAnalysisWarnings new.! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:50'!
recordExpense
	(self callModal: ((ScwNewTransactionForm on: self session profile newExpense) title: 'Record an Expense')) ifNotNil: [ :t |
		self session recordTransaction: t ]! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:51'!
recordIncome
	(self callModal: ((ScwNewTransactionForm on: self session profile newIncome) title: 'Record Income')) ifNotNil: [ :t |
		self session recordTransaction: t ]! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/23/2012 22:08'!
renderAccountsOn: html
	html render: accounts! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 13:05'!
renderActionsOn: html
	html unorderedList id: #actions; with: [
			html listItem 
				script: (html jQuery new) button;
				with: [ html anchor callback: [self recordExpense ]; with: [ html image url: ScwResources transactionIcon.
					html span: 'Record an Expense' ]].
			html listItem
				script: (html jQuery new) button;
				with: [ html anchor callback: [self recordIncome ]; with: [ html image url: ScwResources transactionIcon.
					html span: 'Record Income' ]].
			html listItem
				script: (html jQuery new) button;
				with: [ html anchor callback: [self transfer ]; with: [ html image url: ScwResources transferIcon. 
					html span:'Transfer or Allocate' ]]] ! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:04'!
renderContentOn: html
		html div class: 'span12'; with: [
		self renderActionsOn: html.
		self renderNoticesOn: html.
		self renderExpectedTransactionsOn: html.
		self renderUndoHistoryOn: html.
		html paragraph: [html strong: 'Unallocated: '. html anchor 
			callback: [ self callModal: (ScwTransactionList title: 'All' transactions: (self profile unallocated))];			
			with: self calculateUnallocated printAsCurrency].
		html paragraph: [html strong: 'Total Worth: '. html render: self calculateWorth printAsCurrency. 
				html space.
				self session predictionDate ifNotNil: [
				html strong: 'Before Next Pay: '. html render: (self calculateWorthAt: self session predictionDate) printAsCurrency.
				html space].
				html strong: 'By Next Year: '. html render: (self calculateWorthAt: (Date current addMonths: 12)) printAsCurrency ].
		self session predictionDate ifNotNil: [ :date |html paragraph: [ html strong: 'Next Payday: '.  html render: (date next) ]].
		html paragraph: [
			html anchor callback: [ self callModal: (ScwTransactionList title: 'All' transactions: (ScwGlobalTransactionHolder new profile: self profile))]; with: 'All Transactions']].
		html div class: 'span5'; with: [ self renderPoolsOn: html.].
		html div class: 'span1'.
		html div class: 'span5'; with: [ self renderAccountsOn: html].
		html div class: 'span5'; with: [ self renderSchedulesOn: html. ]
! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:35'!
renderExpectedTransactionsOn: html
	html row: [ html div span: 8; with: expected]! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/14/2012 19:29'!
renderNoticesOn: html
	html row: [ html div span: 8; with: notices]! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/23/2012 21:48'!
renderPoolsOn: html
	html render: pools! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:09'!
renderSchedulesOn: html
	html render: schedules! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 18:03'!
renderUndoHistoryOn: html
	html render: history! !

!ScwDashboard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:52'!
transfer
	(self callModal: ((MbForm on: self session profile newTransaction) title: 'Transfer or Allocate Money')) ifNotNil: [ :t |
		self session recordTransaction: t ]! !

ScwComponent subclass: #ScwDeleteAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwDeleteAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:58'!
deleteAccount
	(self confirm: 'Are you sure you want to delete your account? (There''s no going back from here)') ifTrue: [
		self session deleteAccount	]! !

!ScwDeleteAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:57'!
renderContentOn: html
	html heading level: 2; with: 'Delete Account'.
	html div class: 'alert alert-error'; with: [html render: 'This action cannot be undone'].
	html paragraph: 'This will permanently delete your account and all your data from our servers'.
	html div: [html anchor class: 'btn btn-danger'; callback: [self deleteAccount]; with: 'Delete Account']! !

ScwComponent subclass: #ScwExpectedTransactions
	instanceVariableNames: 'hidden table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/12/2012 19:29'!
acceptTransactions: aCollection
	self session acceptPendingTransactions: aCollection! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:27'!
children
	^Array with: table! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/12/2012 19:37'!
delete: aTransaction
	self session deletePendingTransactions: (Array with: aTransaction)! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:06'!
dismiss
	hidden := true.! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:41'!
edit: anItem
	(self callModal: (MbForm on: anItem copy)) 
		ifNotNil: [ :t |	self session updateObject: anItem with: t ]! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:06'!
ifRequired: aBlock
	(hidden not and: [self profile hasPendingTransactions]) ifTrue: [ aBlock value]
! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/12/2012 19:16'!
initialize
	super initialize.
	hidden := false.
	table := MbTable new 
		addColumn: 'Schedule' as: [ :a | a schedule name];
		addColumn: 'Date' as: [ :a | a transaction date ];
		addColumn: 'Transaction' as: [ :a | a transaction ];
		addColumn: '' renderedWith: [ :a :h | h anchor callback: [ self edit: a transaction]; with: 'edit'. h space. 
			h anchor callback: [ self delete: a]; with: 'delete'].! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/12/2012 19:29'!
renderContentOn: html
	| transactions |
	transactions := self transactions.
	self ifRequired: [
		html heading level: 2; with: 'Expected Transactions'.
		html paragraph: 'The following transactions should have happend since the last time you logged in.  Please review'.
			self renderTransactions: transactions on: html.
		html anchor callback: [self acceptTransactions: transactions ]; with: 'Accept All'.
		html space.
		html anchor callback: [self dismiss]; with: 'Dismiss']! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/7/2012 19:48'!
renderTransaction: t on: html
	html listItem: t! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/12/2012 19:21'!
renderTransactions: aCollection on: html
	table items: (aCollection asSortedCollection: [ :a :b | a transaction date <= b transaction date]).
	html render: table.! !

!ScwExpectedTransactions methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/12/2012 19:18'!
transactions
	^self profile pendingTransactions! !

ScwComponent subclass: #ScwLandingPage
	instanceVariableNames: 'navBar signUp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwLandingPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:58'!
children
	^Array with: navBar with: signUp! !

!ScwLandingPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:58'!
initialize
	super initialize.
	navBar := ScwNavBar new.
	signUp := ScwRegistrationComponent new.! !

!ScwLandingPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 14:07'!
renderBenefit: aString with:  aCollection on: html
	html heading level: 2; with: aString.
	html unorderedList: [
		aCollection do: [ :item | html listItem: item ]]! !

!ScwLandingPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 14:45'!
renderBenefitsOn: html
	html div span: 8; with: [
		html heroUnit id: 'Benefits'; with: [
			self renderBenefit: 'Make a Budget' 
				with: #('Easily define your income and expenses') on: html.
			self renderBenefit: 'Keep Track'
				with: #('Receive reminders for upcoming bills' 'Get advanced warning of shortfalls') on: html.
			self renderBenefit: 'Set Goals'
				with: #('Define savings goals, either as one off targets or regular allocations') on: html	]]	! !

!ScwLandingPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 14:49'!
renderContentOn: html
	html container beFluid; with: [
		html row beFluid; with: [
			self renderHeadingOn: html].
		html row beFluid; with: [
			self renderBenefitsOn: html.
			self renderSignupOn: html]]! !

!ScwLandingPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/19/2012 14:02'!
renderHeadingOn: html
	html pageHeader span: 8; with: [
		html heading level: 1; with: 'Smallchange'.
		html paragraph: 'Keeping budgeting personal']! !

!ScwLandingPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:58'!
renderSignupOn: html
	html div span: 4; with: [
		html render: signUp]! !

ScwComponent subclass: #ScwNavBar
	instanceVariableNames: 'login homeCallback title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/20/2012 19:32'!
children
	^Array with: login.! !

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/8/2012 12:42'!
editAccount
	self callModal: ScwUserAccountPage new! !

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:19'!
homeCallback: aBlock
	homeCallback := aBlock! !

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:42'!
initialize
	super initialize.
	login := ScwLoginComponent new.
	homeCallback := [ ].
	title := nil.! !

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:50'!
renderContentOn: html
	html navBar: [
		self session isLoggedIn ifTrue: [
			html anchor class: 'brand'; callback: homeCallback; with: 'Smallchange'].
			title ifNotNil: [html emphasis class: 'brand'; with: title].
		html div pullRight; with: [ 
			self session isLoggedIn 
				ifTrue: [self renderUserMenuOn: html] 
				ifFalse: [self renderLoginBoxOn: html]]]! !

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/24/2012 16:54'!
renderLoginBoxOn: html
	html render: login! !

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 18:27'!
renderUserMenuOn: html
	html div class: 'btn-group'; with: [
		html anchor class: 'btn btn-success'; callback: [self editAccount]; with: self session platformUser name.
		html anchor class: 'btn btn-success';class: 'dropdown-toggle'; attributeAt: #'data-toggle' put: 'dropdown'; url: '#'; with: [
			html span class: 'caret'].
		html unorderedList class: 'dropdown-menu'; with: [
			html listItem: [html anchor callback: [self editAccount]; with: 'Account Profile'].
			html listItem: [ html anchor callback: [self session platformLogout]; with: 'Logout']
		]
	]! !

!ScwNavBar methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:43'!
title: aString
	title := aString! !

ScwComponent subclass: #ScwPoolList
	instanceVariableNames: 'filter pageSize page tableId futureTransactions showAll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

ScwPoolList subclass: #ScwAccountList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwAccountList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:53'!
addItem
	(self callModal: ((MbForm on: self session profile newAccount) title: 'Add Account')) ifNotNil: [ :t |
		self session addAccount: t ]! !

!ScwAccountList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/24/2012 19:31'!
items
	^self session profile accounts! !

!ScwAccountList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/24/2012 19:31'!
title
	^'Accounts'! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:53'!
addItem
	(self callModal: ((MbForm on: self session profile newPool) title: 'Add Pool')) ifNotNil: [ :t |
		self session addPool: t ]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/20/2012 14:18'!
averageSpendFor: item
	| transactions duration |
	transactions := item transactions sorted.
	transactions ifEmpty: [^0].
	duration := transactions last date - transactions first date.
	^((transactions sum: [ :t | t isExpense ifTrue: [t amount ] ifFalse: [0] ]) / duration days) * 14.! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 19:40'!
editItem: anItem
	(self callModal: (MbForm on: anItem copy)) 
		ifNotNil: [ :t |	self session updateObject: anItem with: t ]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 21:59'!
filteredItems
	^filter 
		ifEmpty: [ showAll 
			ifTrue: [ self items]
			ifFalse: [
				self items select: [ :i | self session notices anySatisfy: [ :n | n appliesTo: i ]]]] 
		ifNotEmpty: [ self items select: [ :i | i name includesSubstring:  filter caseSensitive: false]]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 21:55'!
initialize
	super initialize.
	filter := ''.
	pageSize := 10.
	page := 1.
	showAll := true.
	futureTransactions := #()! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/24/2012 19:30'!
items
	^self session profile pools! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 20:10'!
predictedBalanceFor: anItem
	^futureTransactions inject: anItem balance into: [ :balance :transaction | 
		balance + (anItem accumulate: transaction) ]
	! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:19'!
render: className badgeFor: aCollection on: html
	aCollection size > 0
		ifFalse: [ ^ self ].
	html space.
	html span
		class: #badge;
		class: 'badge-' , className;
		with: aCollection size! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 19:15'!
renderActionsOn: html
	html anchor callback: [ self addItem]; with: [
		html image url: ScwResources addIcon.
		html text: ' New' ]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 21:39'!
renderBadgesFor: anItem on: html
	| warnings errors notices info |
	notices := self session notices select: [ :n | n appliesTo: anItem ].
	self render: 'important' badgeFor: (notices select: [ :n | n isUrgent ]) on: html.
	self render: 'warning' badgeFor: (notices select: [ :n | n isWarning ]) on: html.
	self render: 'info' badgeFor: (notices select: [ :n | n isNotice ]) on: html.
	! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 21:41'!
renderContentOn: html
	self resetFutureTransactions.
	html heading level: 2;
"		script: ((html jQuery new) onClick: (html jQuery new next toggle: 'blind')) next hide; 
"		with: self title.
	html div: [
		html div: [ self renderActionsOn: html].
		self renderFilterOn: html.
	self renderTableOn: html]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 22:54'!
renderFilterOn: html
	html form class: 'form-inline'; with: [
		html textInput class: 'input-medium search-query'; placeholder: 'Filter'; 
			value: filter;
			callback: [ :value | filter := value. page := 1];
			onKeyUp: (((html jQuery this parent next) load
				serialize: (html jQuery this)) html: [ :h | self renderTableOn: h ]).
		html space.
		html label class: 'checkbox'; with: [ 
			html render: ' Show All'.
			html checkbox
				value: showAll;
				callback: [ :value | showAll := value. page := 1 ];
				onChange: (html jQuery this) load serializeThisWithHidden;
				onChange: ((html jQuery this parent parent next) load html: [ :h  | self renderTableOn: h])]]
! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/18/2012 23:39'!
renderHeadingsOn: html
	html tableHead: [html tableRow: [
		html tableHeading: 'Name'.
		html tableHeading: 'Balance'.
		html tableHeading: 'Predicted Balance'.
		html tableHeading: 'Average Spend'.
		html tableHeading: 'Actions']]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/18/2012 23:34'!
renderItemsOn: html
	self thisPageItems do: [ :item | html tableRow: [ 
		html tableData: [ html anchor callback: [ self callModal: (ScwTransactionList title: item name transactions: item )]; with: item name. 
			self renderBadgesFor: item on: html].
		html tableData: item balance printAsCurrency.
		html tableData: (self predictedBalanceFor: item) printAsCurrency.
		html tableData: (self averageSpendFor: item) printAsCurrency.
		html tableData: [ html anchor callback: [self editItem: item]; with: 'Edit Details' ]]]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:29'!
renderNavigation: aString condition:  conditionBlock callback:  callback on: html
	| id anchor enabled |
	enabled := conditionBlock value.
	html listItem 
		class: 'disabled' if: enabled not;
		with: [
			anchor := html anchor id: (id := html nextId).
			enabled ifTrue: [
				anchor 	
					callback: callback;
					onClick: ((html jQuery id: tableId) load html: [ :h | callback value. self renderTableOn: h.  ]);
					onClick: 'return false;'].
			anchor with: aString]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/16/2012 12:22'!
renderNavigationOn: html
	| items |
	items := self filteredItems.
	html div class: 'pagination'; with: [ html unorderedList: [
		self renderNavigation: '|<' condition: [ page > 1 ] callback: [ page := 1 ] on: html.
	self renderNavigation: '<' condition: [ page > 1 ] callback: [ page := page - 1 ] on: html.
	html listItem class: 'active'; with: [html anchor: (' {1} - {2} of {3} ' format: {(page - 1) * pageSize + 1. (page * pageSize) min: items size.  items size})].
	self renderNavigation: '>' condition: [ page *  pageSize < items size ] callback: [ page := page + 1 ] on: html.
	self renderNavigation: '>|' condition: [ page * pageSize < items size ] callback: [ page := ((items size / pageSize) + 0.5) rounded] on: html]]
! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:33'!
renderTableOn: html
	html div id: (tableId := html nextId); with: [
 		html table class: 'table-striped table-condensed'; with: [	self renderHeadingsOn: html.
			html tableBody: [
		self  renderItemsOn: html ]].
		html div: [self renderNavigationOn: html]]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:01'!
resetFutureTransactions
	self session predictionDate ifNotNil: [ :d | futureTransactions := self profile schedules gather: [ :s | s transactionsBetween: Date today and: d]]! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/26/2012 12:30'!
thisPageItems
	| items |
	items := self filteredItems.
	^items copyFrom: ((page - 1) * pageSize) + 1to: ((page  * pageSize) min: items size).
	! !

!ScwPoolList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/24/2012 19:29'!
title
	^'Pools'! !

ScwPoolList subclass: #ScwScheduleList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 18:48'!
addItemForTransactionType: aTransactionClass
	| profile |
	profile := self session profile.
	(self callModal: ((MbForm on: (profile newSchedule transaction: (aTransactionClass profile: profile))) title: 'Add Schedule')) ifNotNil: [ :t |
		self session addSchedule: t ]! !

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 10:10'!
deleteSchedule: anItem
	self session deleteSchedule: anItem! !

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 16:03'!
editAllocations: item
	self callModal: (ScwAllocationEditor for: item)! !

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 09:27'!
items
	^self session profile schedules asSortedCollection: [ :a :b | a nextDate <= b nextDate ]! !

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 18:38'!
renderActionsOn: html
	html anchor callback: [ self addItemForTransactionType: ScIncome]; with: [
		html image url: ScwResources addIcon. html text: 'Income' ].
	html space.
		html anchor callback: [ self addItemForTransactionType: ScExpense]; with: [
		html image url: ScwResources addIcon. html text: 'Bill' ].
	html space.
		html anchor callback: [ self addItemForTransactionType: ScTransaction]; with: [
		html image url: ScwResources addIcon. html text: 'Transfer' ]! !

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/5/2012 20:12'!
renderHeadingsOn: html
	html tableHead: [html tableRow: [
		html tableHeading: 'Name'.
		html tableHeading: 'Next Date'.
		html tableHeading: 'Schedule'.
		html tableHeading: 'Amount'.
		html tableHeading: 'Actions']]! !

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 21:40'!
renderItemsOn: html
	self thisPageItems do: [ :item | html tableRow 
		class: #income if: item transaction isIncome;
		class: #expense if: item transaction isExpense;
		class: #transfer if: item transaction isTransfer;
		with: [ 
		html tableData: [ html text: item name. self renderBadgesFor: item on: html ].
		html tableData: item nextDate.
		html tableData: ((item count > 1) ifTrue: [ '{1} {2}s' format:{ item count asInteger asString. item interval}] ifFalse: [item interval, 'ly']).
		html tableData: item transaction amount printAsCurrency.
		html tableData: [ 
			html anchor callback: [self editItem: item]; with: 'Edit Details'. 
			item isIncome ifTrue: [ html render: ' | '. html anchor callback: [self editAllocations: item]; with: 'Allocations'] .
			html render: ' | '. html anchor callback: [ self deleteSchedule: item]; with: 'Delete']]]! !

!ScwScheduleList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:18'!
title
	^'Schedules'! !

ScwComponent subclass: #ScwRegistrationComponent
	instanceVariableNames: 'user fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwRegistrationComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 17:40'!
new
	^self basicNew
		initializeWithUser: ScUser new;
		yourself! !

!ScwRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 18:49'!
initializeWithUser: aUser
	self initialize.
	user := aUser.
	fields := (user mbDefinitions reject: [ :d | d readOnly ])
		collect: [ :def | MbField definition: def model: (user perform: def selector) ]! !

!ScwRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 18:27'!
renderContentOn: html
	html horizontalForm
		defaultAction: [ self save ];
		with: [ html fieldSet: [
				html legend: 'Get Started'.
				self renderFieldsOn: html. 
				html formActions: [ html submitButton
					class: 'btn';
					bePrimary;
					callback: [ self save ];
					value: 'Sign Up']]]! !

!ScwRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 17:41'!
renderFieldsOn: html
	fields do: [:f | html render: f]! !

!ScwRegistrationComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 18:08'!
save
	self callModal: (ScwRegistrationPage user: user fields: fields)! !

ScwComponent subclass: #ScwRegistrationPage
	instanceVariableNames: 'user fields navBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwRegistrationPage class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 18:07'!
user: aUser fields: aCollection 
	^self basicNew
		initializeWithUser: aUser fields: aCollection;
		yourself! !

!ScwRegistrationPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 18:28'!
children 
	^Array with: navBar! !

!ScwRegistrationPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 14:52'!
initializeWithUser: aUser fields: aCollection
	self initialize.
	user := aUser.
	fields := aCollection.
	navBar := ScwNavBar new.! !

!ScwRegistrationPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/20/2012 09:00'!
login
	self session addUser: user.
	self requestContext response addCookie: (self session sessionRegistry sessionForUser: user) cookie.
	self session unregister.
	! !

!ScwRegistrationPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 14:52'!
renderContentOn: html
	html render: navBar.
	html container: [
		html horizontalForm
			defaultAction: [ self save ];
			with: [ html fieldSet: [
					html legend: 'Create an Account' .
					self renderFieldsOn: html. 
					html formActions: [ 
						html paragraph: 'By cliking the button below, you are agreeing to our terms of usage'.
						html submitButton
						class: 'btn';
						bePrimary;
						callback: [ self save ];
						value: 'Sign Up']]]]! !

!ScwRegistrationPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 18:09'!
renderFieldsOn: html
	fields do: [:f | html render: f]! !

!ScwRegistrationPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:19'!
save
	(fields allSatisfy: [ :f | f valid ])
		ifFalse: [ ^ self ].
	fields do: [ :f | f save ].
	self login! !

ScwComponent subclass: #ScwTransactionChart
	instanceVariableNames: 'transactions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwTransactionChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 21:20'!
renderContentOn: html
	| id stream total |
	total := transactions openingBalance.
	html canvas id: (id := html nextId);width: 600; height: 250; with: 'Canvas Not Supported!!'.

	stream := WriteStream on: ''.
	stream nextPutAll: ' window.onload = function () { var line1 = new RGraph.Line(''', id asString, ''',  [';
		nextPutAll: total printAsCurrency.
	stream	nextPutAll: ((self values collect: [ :t | total := total + (transactions accumulate: (t)). ', ', total printAsCurrency] ) joinUsing: '').
	stream nextPutAll: ']); line1.Set(''chart.xaxispos'', ''center'');line1.Draw();}'.
	html script: stream contents! !

!ScwTransactionChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 20:32'!
transactions: aCollection
	transactions := aCollection! !

!ScwTransactionChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 20:55'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	#(RGraphcommoncoreJs RGraphlineJs) 
		do: [ :script |	anHtmlRoot javascript url: (ScwRGraph urlOf: script )]! !

!ScwTransactionChart methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/14/2012 08:26'!
values
	^transactions transactions asSortedCollection! !

ScwComponent subclass: #ScwTransactionList
	instanceVariableNames: 'title table chart transactions balance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwTransactionList class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:09'!
title: aTitle transactions: aCollection
	^self basicNew
		initializeWithTitle: aTitle transactions: aCollection;
		yourself! !

!ScwTransactionList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 20:32'!
children
	^Array with: table with: chart.! !

!ScwTransactionList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 08:01'!
delete: aTransaction
	self session deleteTransaction: aTransaction! !

!ScwTransactionList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 08:01'!
edit: aTransaction
	(self callModal: (MbForm on: aTransaction copy))
		ifNotNil: [ :t |	self session updateObject: aTransaction with: t ]! !

!ScwTransactionList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/14/2012 08:22'!
initializeWithTitle: aString transactions: aTransactionHolder
	self initialize.
	transactions := aTransactionHolder.
	title := aString.
	chart := ScwTransactionChart new transactions: aTransactionHolder.
	table := MbTable new items: (aTransactionHolder transactions asSortedCollection);
		addColumns: ScTransaction;
		addColumn: (MbSimpleValueTableColumn new
			heading: 'Balance';
			valueBlock: [ :a | (balance := balance + (aTransactionHolder accumulate: a)) printAsCurrency ]);
		addColumn: 'Actions' renderedWith: [ :t :h |
			h anchor callback: [ self edit: t ]; with: 'Edit'.
			h text: ' | '.
			h anchor callback: [ self delete: t ]; with: 'Delete']! !

!ScwTransactionList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 12:05'!
renderContentOn: html
	self resetBalance.
	html heading level: 1; with: title.
	html render: chart.
	html paragraph: [
		html strong: 'Opening Balance: '.
		html render: transactions openingBalance printAsCurrency].
	html paragraph: [
		html strong: 'Closing Balance: '.
		html render: transactions balance printAsCurrency].
	html render: table.
	html anchor callback: [self answer]; with: 'Close'! !

!ScwTransactionList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 12:05'!
resetBalance
		balance := transactions openingBalance.
! !

ScwComponent subclass: #ScwUpdateAccountDetails
	instanceVariableNames: 'user fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwUpdateAccountDetails class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 11:22'!
on: aUser
	^self basicNew
		initializeWithUser: aUser;
		yourself! !

!ScwUpdateAccountDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 11:24'!
children
	^fields! !

!ScwUpdateAccountDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 12:50'!
initializeWithUser: aUser
	self initialize.
	user := aUser.
	fields := {
		MbField definition: (aUser mbDefinitionFor: #name) model: aUser name.
		MbField definition: (aUser mbDefinitionFor: #email) model: aUser email}! !

!ScwUpdateAccountDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 12:48'!
renderContentOn: html
	self renderTitleOn: html.
	html horizontalForm
		defaultAction: [ self save ];
		with: [ html fieldSet: [
				self renderFieldsOn: html. 
				html formActions: [ html submitButton
					class: 'btn';
					bePrimary;
					callback: [ self save ];
					value: 'Save']]]! !

!ScwUpdateAccountDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 12:49'!
renderFieldsOn: html
	fields do: [ :f |
		html render: f]! !

!ScwUpdateAccountDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 11:25'!
renderTitleOn: html
	html heading level: 2; with: 'Account Details'.
	html paragraph: 'Review or edit your account details in the form below'.
	! !

!ScwUpdateAccountDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/20/2012 18:34'!
save
	self valid ifTrue: [
		self session transactionProvider commit: [
			self session userRegistry removeUser: user.
			fields do: [ :f | f save ].
			self session userRegistry addUser: user.]]! !

!ScwUpdateAccountDetails methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/13/2012 12:51'!
valid
	^fields allSatisfy: [ :f | f valid]! !

ScwComponent subclass: #ScwUserAccountPage
	instanceVariableNames: 'content current navigationBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:17'!
changePassword
	content := ScwChangePasswordForm on: self session platformUser.
	current := #changePassword! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:59'!
children
	^Array with: navigationBar with:content.! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:40'!
deleteAccount
	content := ScwDeleteAccount new.
	current := #deleteAccount! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:59'!
initialize
	super initialize.
	navigationBar := ScwNavBar new 
		homeCallback: [ self answer ];
		title: 'Account Profile'.
	self updateDetails! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:28'!
renderComponentOn: html
	html render: content.! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:59'!
renderContentOn: html
	html render: navigationBar.
	html container: [ html row: [
		html row: [
			html div span: 2; with: [  self renderMenuOn: html ].
			html div span: 10; with: [self renderComponentOn: html]]]]! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:11'!
renderMenuItem: aSymbol labeled:  aString on: html
	html listItem class: 'active' if: (current = aSymbol); 
		with: [html anchor 
				callback: [self perform: aSymbol];
				with: aString].
! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:26'!
renderMenuOn: html
	html unorderedList class: 'nav nav-pills nav-stacked'; with: [
		self renderMenuItem: #updateDetails labeled: 'Account Details' on: html.
		self renderMenuItem: #changePassword labeled: 'Change Password' on: html.
		html listItem: [html anchor with: 'Export'].	
		self renderMenuItem: #deleteAccount labeled: 'Delete Account' on: html]! !

!ScwUserAccountPage methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/26/2012 19:39'!
updateDetails
	content := ScwUpdateAccountDetails on: self session platformUser.
	current := #updateDetails! !

WAComponent subclass: #ScwUndoHistory
	instanceVariableNames: 'commandProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-Components'!

!ScwUndoHistory class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 16:12'!
commandProcessor: aProcessor
	^self basicNew
		initializeWithCommandProcessor: aProcessor;
		yourself! !

!ScwUndoHistory methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 16:12'!
initializeWithCommandProcessor: aProcessor
	self initialize.
	commandProcessor := aProcessor.! !

!ScwUndoHistory methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 21:46'!
renderContentOn: html
	html div id: #undoHistory; with: [
		html heading level: 2; 
			script: ((html jQuery new) onClick: (html jQuery new next next toggle: 'blind')) next next hide; 		
			with: 'Recent Activity'.
		self renderUndoButtonsOn: html.
		self renderUndoHistoryOn: html]! !

!ScwUndoHistory methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/2/2012 17:54'!
renderUndoButtonsOn: html
	html div class: #undo; with: [
		commandProcessor canUndo 
			ifTrue: [ html anchor callback: [ self undo ]; with: 'Undo']
			ifFalse: [html text: 'Undo']]! !

!ScwUndoHistory methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 21:13'!
renderUndoHistoryOn: html
	html unorderedList: [
		commandProcessor history do: [ :h | html listItem: h ]]! !

!ScwUndoHistory methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/2/2012 17:54'!
undo
	commandProcessor undo! !

SPInternalUser subclass: #ScUser
	uses: TMbObject
	instanceVariableNames: 'email history profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web-User'!

ScUser class
	uses: TMbObject classTrait
	instanceVariableNames: ''!

!ScUser class methodsFor: 'mabinogi-private' stamp: 'StuartHerring 5/21/2012 20:16'!
mbDefinitions
	^ (self mbSelectors collect: [ :s | self mbDefinitionFor: s ]) select: [ :def | def notNil ]! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 15:27'!
email
	<required>
	<email>
	<validateWith: #validateEmailIsUnique:>
	^email! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 16:53'!
email: anEmailAddress
	self set: #email to: anEmailAddress! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 16:52'!
fieldDefinitions
	<mbFields: #(name email password)>! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/8/2012 12:43'!
history
	^history! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/20/2012 17:18'!
id
	<ignore>
	^email! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/8/2012 12:57'!
initialize
	super initialize.
	profile := ScProfile new.
	history := OrderedCollection new.! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 16:52'!
name
	<required>
	^name! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 16:53'!
name: aString
	self set: #name to: aString! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 17:07'!
password
	<required>
	<password>
	^password! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 17:06'!
password: aString
	self set: #password to: aString! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/8/2012 12:43'!
profile
	^profile! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/8/2012 12:44'!
profile: aProfile
	profile := aProfile! !

!ScUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/20/2012 18:29'!
validateEmailIsUnique: anEmailAddress
	WACurrentRequestContext value session ifNotNil: [ :session | 
		(session userRegistry findUserByEmailAddress: anEmailAddress) 
			ifNotNil: [ :user | user = self ifFalse: [MbValidationError signal: 'Email already in use']]]! !

!ScTransaction methodsFor: '*smallchange-web' stamp: 'StuartHerring 3/10/2012 17:38'!
renderOn: html
	html span style: (self isExpense ifTrue: [ 'color: darkred;'] ifFalse: [self isIncome ifTrue: ['color: darkgreen'] ifFalse: ['color: blue']]);
		with: self displayString! !

!ScRecordTransaction methodsFor: '*smallchange-web' stamp: 'StuartHerring 2/15/2012 14:37'!
renderOn: html
	html span style: (transaction isExpense ifTrue: [ 'color: darkred;'] ifFalse: [transaction isIncome ifTrue: ['color: darkgreen'] ifFalse: ['color: blue']]);
		with: self displayString! !

WASystemConfiguration subclass: #ScwConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web'!

!ScwConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 13:40'!
describeOn: config
	(config string: #databaseName) 
		group: 'Persistence'! !

!ScwConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 13:38'!
parents
	^Array with: SPConfiguration instance with: SPInternalConfiguration instance! !

Object subclass: #ScwDeploymentTools
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Web'!

!ScwDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/13/2012 15:38'!
createDatabaseNamed: aName
	MagmaRepositoryController create: aName  root: Dictionary new.! !

!ScwDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/13/2012 15:38'!
createDefaultDatabase
	self createDatabaseNamed: 'smallchange.magma'! !

!ScwDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/13/2012 15:23'!
registerAsDefaultAt: aString
	| application |
	application := self registerAt: aString.	
	WADispatcher default defaultName: aString.
	^application! !

!ScwDeploymentTools class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/13/2012 15:22'!
registerAt: aString
	| application |
	application := WAAdmin register: ScwContainerPage asApplicationAt: aString.
	application configuration
		addParent: ScwConfiguration instance.
	
	application
		preferenceAt: #databaseName put: 'smallchange.magma';
		preferenceAt: #sessionClass put: ScwMagmaSession;
		preferenceAt: #loginComponent put: ScwContainerPage;
		preferenceAt: #sessionRegistry put: SPInternalSessionRegistry;
		preferenceAt: #platforms put: {SPInternalPlatform};
		preferenceAt: #libraries put: {ScwResources. JQBaseTheme. BSBootstrapLibrary}.
	^application! !
